/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var me=["require","exports","vs/base/common/uri","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/base/common/strings","vs/base/common/path","vs/base/common/network","vs/base/common/platform","vs/platform/log/common/log","vs/workbench/api/common/extHostRpcService","vs/base/common/types","vs/base/common/errors","vs/base/common/async","vs/workbench/api/common/extHostTypeConverters","vs/nls","vs/nls!vs/workbench/services/extensions/node/extensionHostProcess","vs/base/common/arrays","vs/base/common/cancellation","vs/base/common/map","vs/base/common/resources","vs/base/common/buffer","vs/base/common/objects","vs/platform/extensions/common/extensions","vs/workbench/api/common/extHostInitDataService","vs/base/node/pfs","vs/base/common/extpath","vs/base/common/glob","vs/workbench/services/search/common/search","vs/base/common/uuid","vs/workbench/api/common/extHostTerminalService","vs/platform/registry/common/platform","vs/workbench/services/extensions/common/extensions","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/base/common/process","child_process","vs/workbench/api/common/extHostExtensionService","vs/editor/common/core/range","vs/platform/files/common/files","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostCommands","vs/workbench/api/common/extHostDocumentsAndEditors","vs/base/common/stopwatch","vs/base/common/codicons","vs/base/common/severity","fs","vs/editor/common/core/position","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostDebugService","vs/base/common/assert","vs/base/common/collections","vs/base/common/decorators","vs/base/common/json","vs/base/common/hash","vs/base/common/marshalling","vs/base/common/errorMessage","vs/platform/contextkey/common/contextkey","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostOutput","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostWebview","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/base/common/performance","vs/workbench/api/common/extHostSearch","vs/base/common/functional","vs/base/common/idGenerator","vs/base/common/iterator","vs/base/common/numbers","vs/base/common/normalization","vs/base/common/labels","os","vs/editor/common/modes/languageSelector","vs/platform/instantiation/common/extensions","vs/editor/common/modes","vs/platform/instantiation/common/serviceCollection","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteHosts","vs/platform/theme/common/themeService","vs/workbench/api/common/cache","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/api/common/shared/webview","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testId","vs/workbench/api/common/exHostSecretState","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostStorage","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/common/linkedList","vs/base/common/stream","vs/base/common/uint","vs/base/common/filters","vs/base/common/htmlContent","vs/base/common/comparers","vs/base/common/fuzzyScorer","vs/base/common/mime","vs/base/common/uriIpc","string_decoder","vs/base/node/extpath","vs/base/parts/ipc/common/ipc","vs/base/parts/ipc/common/ipc.net","vs/editor/common/core/characterClassifier","vs/editor/common/model","vs/editor/common/model/wordHelper","vs/editor/common/services/semanticTokensDto","vs/editor/common/viewModel/prefixSumComputer","vs/base/node/processes","vs/editor/common/config/editorOptions","vs/platform/instantiation/common/descriptors","vs/platform/log/node/spdlogLog","vs/platform/markers/common/markers","vs/platform/progress/common/progress","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configuration","vs/platform/remote/common/remoteAuthorityResolver","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostDocumentData","vs/workbench/contrib/debug/common/abstractDebugAdapter","net","vs/workbench/contrib/testing/common/testCollection","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTextEditor","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostWindow","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/parts/ipc/node/ipc.net","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/lazy","vs/base/common/processes","vs/base/common/iconLabels","vs/base/node/decoder","vs/editor/common/controller/wordCharacterClassifier","vs/editor/common/core/selection","vs/editor/common/model/textModelSearch","vs/editor/common/modes/languageConfiguration","vs/editor/common/modes/linkComputer","vs/editor/common/modes/tokenizationRegistry","vs/editor/common/model/mirrorTextModel","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/node/processes","vs/nls!vs/editor/common/config/editorOptions","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/workspaces/common/workspaces","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/search/common/queryBuilder","vs/nls!vs/workbench/contrib/tasks/common/taskService","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/platform/editor/common/editor","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/editor/common/services/modelService","vs/editor/common/modes/languageFeatureRegistry","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/instantiation/common/instantiationService","vs/platform/notification/common/notification","vs/platform/opener/common/opener","vs/platform/product/common/product","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/tunnel","vs/platform/sign/node/signService","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/theme","vs/platform/theme/common/iconRegistry","vs/platform/workspaces/common/workspaces","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostNotebookConcatDocument","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/common/shared/treeDataTransfer","vs/workbench/api/common/extHostCodeInsets","vs/workbench/common/editor","vs/workbench/common/views","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","vs/workbench/contrib/debug/node/terminals","vs/workbench/contrib/tasks/common/taskService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostTreeViews","vs/workbench/contrib/testing/common/ownedTestCollection","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/node/extHostLogService","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostOutputService","vs/workbench/api/node/extHostStoragePaths","vs/workbench/api/node/extHostTerminalService","vs/workbench/api/node/extHostTunnelService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/contrib/search/common/queryBuilder","vs/workbench/api/common/shared/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/node/extHostDebugService","vs/workbench/api/node/extHostTask","vs/workbench/services/extensions/common/extensionHostMain","vs/workbench/services/search/common/fileSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/services/textfile/common/encoding","vs/workbench/services/extensions/node/proxyResolver","http","vs/workbench/services/search/node/ripgrepFileSearch","vscode-ripgrep","vs/workbench/services/search/node/fileSearch","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/workbench/api/node/extHostCLIServer","vs/workbench/api/node/extHostExtensionService","vs/workbench/api/node/extHost.node.services","vs/workbench/services/extensions/node/extensionHostProcessSetup","util","vs/base/common/marked/marked","path","https","tls","vscode-proxy-agent","events","vscode-regexpp","graceful-fs","crypto","zlib","minimist","vs/workbench/services/extensions/node/extensionHostProcess"],ge=function(J){for(var e=[],g=0,R=J.length;g<R;g++)e[g]=me[J[g]];return e};define(me[54],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function g(R,k){if(!R)throw new Error(k?`Assertion failed (${k})`:"Assertion Failed")}e.ok=g}),define(me[55],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const g=Object.prototype.hasOwnProperty;function R(i){const C=[];for(let u in i)g.call(i,u)&&C.push(i[u]);return C}e.values=R;function k(i,C){for(let u in i)if(g.call(i,u)&&C({key:u,value:i[u]},function(){delete i[u]})===!1)return}e.forEach=k;function S(i,C){const u=Object.create(null);for(const m of i){const l=C(m);let v=u[l];v||(v=u[l]=[]),v.push(m)}return u}e.groupBy=S;function T(i){const C=Object.create(null);return i&&i.forEach((u,m)=>{C[m]=u}),C}e.fromMap=T;function D(i,C){const u=[],m=[];for(let l of i)C.has(l)||u.push(l);for(let l of C)i.has(l)||m.push(l);return{removed:u,added:m}}e.diffSets=D;function y(i,C){const u=[],m=[];for(let[l,v]of i)C.has(l)||u.push(v);for(let[l,v]of C)i.has(l)||m.push(v);return{removed:u,added:m}}e.diffMaps=y;class A{constructor(){this.map=new Map}add(C,u){let m=this.map.get(C);m||(m=new Set,this.map.set(C,m)),m.add(u)}delete(C,u){const m=this.map.get(C);!m||(m.delete(u),m.size===0&&this.map.delete(C))}forEach(C,u){const m=this.map.get(C);!m||m.forEach(u)}}e.SetMap=A}),define(me[56],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function g(T){return(D,y,A)=>{let i=null,C=null;if(typeof A.value=="function"?(i="value",C=A.value):typeof A.get=="function"&&(i="get",C=A.get),!C)throw new Error("not supported");A[i]=T(C,y)}}e.createDecorator=g;function R(T,D,y){let A=null,i=null;if(typeof y.value=="function"?(A="value",i=y.value,i.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof y.get=="function"&&(A="get",i=y.get),!i)throw new Error("not supported");const C=`$memoize$${D}`;y[A]=function(...u){return this.hasOwnProperty(C)||Object.defineProperty(this,C,{configurable:!1,enumerable:!1,writable:!1,value:i.apply(this,u)}),this[C]}}e.memoize=R;function k(T,D,y){return g((A,i)=>{const C=`$debounce$${i}`,u=`$debounce$result$${i}`;return function(...m){this[u]||(this[u]=y?y():void 0),clearTimeout(this[C]),D&&(this[u]=D(this[u],...m),m=[this[u]]),this[C]=setTimeout(()=>{A.apply(this,m),this[u]=y?y():void 0},T)}})}e.debounce=k;function S(T,D,y){return g((A,i)=>{const C=`$throttle$timer$${i}`,u=`$throttle$result$${i}`,m=`$throttle$lastRun$${i}`,l=`$throttle$pending$${i}`;return function(...v){if(this[u]||(this[u]=y?y():void 0),(this[m]===null||this[m]===void 0)&&(this[m]=-Number.MAX_VALUE),D&&(this[u]=D(this[u],...v)),this[l])return;const _=this[m]+T;_<=Date.now()?(this[m]=Date.now(),A.apply(this,[this[u]]),this[u]=y?y():void 0):(this[l]=!0,this[C]=setTimeout(()=>{this[l]=!1,this[m]=Date.now(),A.apply(this,[this[u]]),this[u]=y?y():void 0},_-Date.now()))}})}e.throttle=S}),define(me[15],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class g{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(t){setTimeout(()=>{throw t.stack?new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.listeners.push(t),()=>{this._removeListener(t)}}emit(t){this.listeners.forEach(r=>{r(t)})}_removeListener(t){this.listeners.splice(this.listeners.indexOf(t),1)}setUnexpectedErrorHandler(t){this.unexpectedErrorHandler=t}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(t){this.unexpectedErrorHandler(t),this.emit(t)}onUnexpectedExternalError(t){this.unexpectedErrorHandler(t)}}e.ErrorHandler=g,e.errorHandler=new g;function R(p){e.errorHandler.setUnexpectedErrorHandler(p)}e.setUnexpectedErrorHandler=R;function k(p){y(p)||e.errorHandler.onUnexpectedError(p)}e.onUnexpectedError=k;function S(p){y(p)||e.errorHandler.onUnexpectedExternalError(p)}e.onUnexpectedExternalError=S;function T(p){if(p instanceof Error){let{name:t,message:r}=p;const s=p.stacktrace||p.stack;return{$isError:!0,name:t,message:r,stack:s}}return p}e.transformErrorForSerialization=T;const D="Canceled";function y(p){return p instanceof Error&&p.name===D&&p.message===D}e.isPromiseCanceledError=y;class A extends Error{constructor(){super(D);this.name=this.message}}e.CancellationError=A;function i(){const p=new Error(D);return p.name=p.message,p}e.canceled=i;function C(p){return p?new Error(`Illegal argument: ${p}`):new Error("Illegal argument")}e.illegalArgument=C;function u(p){return p?new Error(`Illegal state: ${p}`):new Error("Illegal state")}e.illegalState=u;function m(p){return p?new Error(`readonly property '${p} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=m;function l(p){const t=new Error(`${p} has been disposed`);return t.name="DISPOSED",t}e.disposed=l;function v(p){return p?p.message?p.message:p.stack?p.stack.split(`
`)[0]:String(p):"Error"}e.getErrorMessage=v;class _ extends Error{constructor(t){super("NotImplemented");t&&(this.message=t)}}e.NotImplementedError=_;class b extends Error{constructor(t){super("NotSupported");t&&(this.message=t)}}e.NotSupportedError=b;class P extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=P;function c(p){const t=p;return t instanceof Error&&Array.isArray(t.actions)}e.isErrorWithActions=c;function h(p,t=Object.create(null)){const r=new Error(p);return t.actions&&(r.actions=t.actions),r}e.createErrorWithActions=h}),define(me[20],ge([0,1,15]),function(J,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ArrayQueue=e.maxIndex=e.minIndex=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.uniqueFilter=e.distinctES6=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function R(B,G=0){return B[B.length-(1+G)]}e.tail=R;function k(B){if(B.length===0)throw new Error("Invalid tail call");return[B.slice(0,B.length-1),B[B.length-1]]}e.tail2=k;function S(B,G,ie=(he,ye)=>he===ye){if(B===G)return!0;if(!B||!G||B.length!==G.length)return!1;for(let he=0,ye=B.length;he<ye;he++)if(!ie(B[he],G[he]))return!1;return!0}e.equals=S;function T(B,G,ie){let he=0,ye=B.length-1;for(;he<=ye;){const Ie=(he+ye)/2|0,Le=ie(B[Ie],G);if(Le<0)he=Ie+1;else if(Le>0)ye=Ie-1;else return Ie}return-(he+1)}e.binarySearch=T;function D(B,G){let ie=0,he=B.length;if(he===0)return 0;for(;ie<he;){const ye=Math.floor((ie+he)/2);G(B[ye])?he=ye:ie=ye+1}return ie}e.findFirstInSorted=D;function y(B,G,ie){if(B=B|0,B>=G.length)throw new TypeError("invalid index");let he=G[Math.floor(G.length*Math.random())],ye=[],Ie=[],Le=[];for(let qe of G){const We=ie(qe,he);We<0?ye.push(qe):We>0?Ie.push(qe):Le.push(qe)}return B<ye.length?y(B,ye,ie):B<ye.length+Le.length?Le[0]:y(B-(ye.length+Le.length),Ie,ie)}e.quickSelect=y;function A(B,G){const ie=[];let he;for(const ye of B.slice(0).sort(G))!he||G(he[0],ye)!==0?(he=[ye],ie.push(he)):he.push(ye);return ie}e.groupBy=A;function i(B,G,ie){const he=[];function ye(qe,We,je){if(We===0&&je.length===0)return;const W=he[he.length-1];W&&W.start+W.deleteCount===qe?(W.deleteCount+=We,W.toInsert.push(...je)):he.push({start:qe,deleteCount:We,toInsert:je})}let Ie=0,Le=0;for(;;){if(Ie===B.length){ye(Ie,0,G.slice(Le));break}if(Le===G.length){ye(Ie,B.length-Ie,[]);break}const qe=B[Ie],We=G[Le],je=ie(qe,We);je===0?(Ie+=1,Le+=1):je<0?(ye(Ie,1,[]),Ie+=1):je>0&&(ye(Ie,0,[We]),Le+=1)}return he}e.sortedDiff=i;function C(B,G,ie){const he=i(B,G,ie),ye=[],Ie=[];for(const Le of he)ye.push(...B.slice(Le.start,Le.start+Le.deleteCount)),Ie.push(...Le.toInsert);return{removed:ye,added:Ie}}e.delta=C;function u(B,G,ie){if(ie===0)return[];const he=B.slice(0,ie).sort(G);return l(B,G,he,ie,B.length),he}e.top=u;function m(B,G,ie,he,ye){return ie===0?Promise.resolve([]):new Promise((Ie,Le)=>{(async()=>{const qe=B.length,We=B.slice(0,ie).sort(G);for(let je=ie,W=Math.min(ie+he,qe);je<qe;je=W,W=Math.min(W+he,qe)){if(je>ie&&await new Promise(Z=>setTimeout(Z)),ye&&ye.isCancellationRequested)throw(0,g.canceled)();l(B,G,We,je,W)}return We})().then(Ie,Le)})}e.topAsync=m;function l(B,G,ie,he,ye){for(const Ie=ie.length;he<ye;he++){const Le=B[he];if(G(Le,ie[Ie-1])<0){ie.pop();const qe=D(ie,We=>G(Le,We)<0);ie.splice(qe,0,Le)}}}function v(B){return B.filter(G=>!!G)}e.coalesce=v;function _(B){let G=0;for(let ie=0;ie<B.length;ie++)B[ie]&&(B[G]=B[ie],G+=1);B.length=G}e.coalesceInPlace=_;function b(B,G,ie){B.splice(ie,0,B.splice(G,1)[0])}e.move=b;function P(B){return!Array.isArray(B)||B.length===0}e.isFalsyOrEmpty=P;function c(B){return Array.isArray(B)&&B.length>0}e.isNonEmptyArray=c;function h(B,G){if(!G)return B.filter((he,ye)=>B.indexOf(he)===ye);const ie=Object.create(null);return B.filter(he=>{const ye=G(he);return ie[ye]?!1:(ie[ye]=!0,!0)})}e.distinct=h;function p(B){const G=new Set;return B.filter(ie=>G.has(ie)?!1:(G.add(ie),!0))}e.distinctES6=p;function t(B){const G=Object.create(null);return ie=>{const he=B(ie);return G[he]?!1:(G[he]=!0,!0)}}e.uniqueFilter=t;function r(B,G){for(let ie=B.length-1;ie>=0;ie--){const he=B[ie];if(G(he))return ie}return-1}e.lastIndex=r;function s(B,G){return B.length>0?B[0]:G}e.firstOrDefault=s;function n(B,G,ie=(he,ye)=>he===ye){let he=0;for(let ye=0,Ie=Math.min(B.length,G.length);ye<Ie&&ie(B[ye],G[ye]);ye++)he++;return he}e.commonPrefixLength=n;function a(B){return[].concat(...B)}e.flatten=a;function d(B,G){let ie=typeof G=="number"?B:0;typeof G=="number"?ie=B:(ie=0,G=B);const he=[];if(ie<=G)for(let ye=ie;ye<G;ye++)he.push(ye);else for(let ye=ie;ye>G;ye--)he.push(ye);return he}e.range=d;function f(B,G,ie){return B.reduce((he,ye)=>(he[G(ye)]=ie?ie(ye):ye,he),Object.create(null))}e.index=f;function w(B,G){return B.push(G),()=>E(B,G)}e.insert=w;function E(B,G){const ie=B.indexOf(G);if(ie>-1)return B.splice(ie,1),G}e.remove=E;function o(B,G,ie){const he=B.slice(0,G),ye=B.slice(G);return he.concat(ie,ye)}e.arrayInsert=o;function I(B,G){let ie;if(typeof G=="number"){let he=G;ie=()=>{const ye=Math.sin(he++)*179426549;return ye-Math.floor(ye)}}else ie=Math.random;for(let he=B.length-1;he>0;he-=1){const ye=Math.floor(ie()*(he+1)),Ie=B[he];B[he]=B[ye],B[ye]=Ie}}e.shuffle=I;function L(B,G){const ie=B.indexOf(G);ie>-1&&(B.splice(ie,1),B.unshift(G))}e.pushToStart=L;function U(B,G){const ie=B.indexOf(G);ie>-1&&(B.splice(ie,1),B.push(G))}e.pushToEnd=U;function V(B,G){return Array.isArray(B)?B.map(G):G(B)}e.mapArrayOrNot=V;function ee(B){return Array.isArray(B)?B:[B]}e.asArray=ee;function K(B){return B[Math.floor(Math.random()*B.length)]}e.getRandomElement=K;function N(B,G){for(const ie of B){const he=G(ie);if(he!==void 0)return he}}e.mapFind=N;function x(B,G,ie){const he=z(B,G),ye=B.length,Ie=ie.length;B.length=ye+Ie;for(let Le=ye-1;Le>=he;Le--)B[Le+Ie]=B[Le];for(let Le=0;Le<Ie;Le++)B[Le+he]=ie[Le]}e.insertInto=x;function F(B,G,ie,he){const ye=z(B,G),Ie=B.splice(ye,ie);return x(B,ye,he),Ie}e.splice=F;function z(B,G){return G<0?Math.max(G+B.length,0):Math.min(G,B.length)}function M(B,G){let ie=Number.MAX_SAFE_INTEGER,he=0;return B.forEach((ye,Ie)=>{const Le=G(ye);Le<ie&&(ie=Le,he=Ie)}),he}e.minIndex=M;function O(B,G){let ie=Number.MIN_SAFE_INTEGER,he=0;return B.forEach((ye,Ie)=>{const Le=G(ye);Le>ie&&(ie=Le,he=Ie)}),he}e.maxIndex=O;class q{constructor(G){this.items=G,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(G){let ie=this.firstIdx;for(;ie<this.items.length&&G(this.items[ie]);)ie++;const he=ie===this.firstIdx?null:this.items.slice(this.firstIdx,ie);return this.firstIdx=ie,he}takeFromEndWhile(G){let ie=this.lastIdx;for(;ie>=0&&G(this.items[ie]);)ie--;const he=ie===this.lastIdx?null:this.items.slice(ie+1,this.lastIdx+1);return this.lastIdx=ie,he}}e.ArrayQueue=q}),define(me[72],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function g(R){const k=this;let S=!1,T;return function(){return S||(S=!0,T=R.apply(k,arguments)),T}}e.once=g}),define(me[73],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class g{constructor(k){this._prefix=k,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=g,e.defaultGenerator=new g("id#")}),define(me[74],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var g;(function(R){function k(p){return p&&typeof p=="object"&&typeof p[Symbol.iterator]=="function"}R.is=k;const S=Object.freeze([]);function T(){return S}R.empty=T;function*D(p){yield p}R.single=D;function y(p){return p||S}R.from=y;function A(p){return!p||p[Symbol.iterator]().next().done===!0}R.isEmpty=A;function i(p){return p[Symbol.iterator]().next().value}R.first=i;function C(p,t){for(const r of p)if(t(r))return!0;return!1}R.some=C;function u(p,t){for(const r of p)if(t(r))return r}R.find=u;function*m(p,t){for(const r of p)t(r)&&(yield r)}R.filter=m;function*l(p,t){let r=0;for(const s of p)yield t(s,r++)}R.map=l;function*v(...p){for(const t of p)for(const r of t)yield r}R.concat=v;function*_(p){for(const t of p)for(const r of t)yield r}R.concatNested=_;function b(p,t,r){let s=r;for(const n of p)s=t(s,n);return s}R.reduce=b;function*P(p,t,r=p.length){for(t<0&&(t+=p.length),r<0?r+=p.length:r>p.length&&(r=p.length);t<r;t++)yield p[t]}R.slice=P;function c(p,t=Number.POSITIVE_INFINITY){const r=[];if(t===0)return[r,p];const s=p[Symbol.iterator]();for(let n=0;n<t;n++){const a=s.next();if(a.done)return[r,R.empty()];r.push(a.value)}return[r,{[Symbol.iterator](){return s}}]}R.consume=c;function h(p,t,r=(s,n)=>s===n){const s=p[Symbol.iterator](),n=t[Symbol.iterator]();for(;;){const a=s.next(),d=n.next();if(a.done!==d.done)return!1;if(a.done)return!0;if(!r(a.value,d.value))return!1}}R.equals=h})(g=e.Iterable||(e.Iterable={}))}),define(me[57],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var g;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(g=e.ScanError||(e.ScanError={}));var R;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(R=e.SyntaxKind||(e.SyntaxKind={}));var k;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(k=e.ParseErrorCode||(e.ParseErrorCode={}));var S;(function(t){t.DEFAULT={allowTrailingComma:!0}})(S=e.ParseOptions||(e.ParseOptions={}));function T(t,r=!1){let s=0,n=t.length,a="",d=0,f=16,w=0;function E(K){let N=0,x=0;for(;N<K;){const F=t.charCodeAt(s);if(F>=48&&F<=57)x=x*16+F-48;else if(F>=65&&F<=70)x=x*16+F-65+10;else if(F>=97&&F<=102)x=x*16+F-97+10;else break;s++,N++}return N<K&&(x=-1),x}function o(K){s=K,a="",d=0,f=16,w=0}function I(){const K=s;if(t.charCodeAt(s)===48)s++;else for(s++;s<t.length&&A(t.charCodeAt(s));)s++;if(s<t.length&&t.charCodeAt(s)===46)if(s++,s<t.length&&A(t.charCodeAt(s)))for(s++;s<t.length&&A(t.charCodeAt(s));)s++;else return w=3,t.substring(K,s);let N=s;if(s<t.length&&(t.charCodeAt(s)===69||t.charCodeAt(s)===101))if(s++,(s<t.length&&t.charCodeAt(s)===43||t.charCodeAt(s)===45)&&s++,s<t.length&&A(t.charCodeAt(s))){for(s++;s<t.length&&A(t.charCodeAt(s));)s++;N=s}else w=3;return t.substring(K,N)}function L(){let K="",N=s;for(;;){if(s>=n){K+=t.substring(N,s),w=2;break}const x=t.charCodeAt(s);if(x===34){K+=t.substring(N,s),s++;break}if(x===92){if(K+=t.substring(N,s),s++,s>=n){w=2;break}switch(t.charCodeAt(s++)){case 34:K+='"';break;case 92:K+="\\";break;case 47:K+="/";break;case 98:K+="\b";break;case 102:K+="\f";break;case 110:K+=`
`;break;case 114:K+="\r";break;case 116:K+="	";break;case 117:const z=E(4);z>=0?K+=String.fromCharCode(z):w=4;break;default:w=5}N=s;continue}if(x>=0&&x<=31)if(y(x)){K+=t.substring(N,s),w=2;break}else w=6;s++}return K}function U(){if(a="",w=0,d=s,s>=n)return d=n,f=17;let K=t.charCodeAt(s);if(D(K)){do s++,a+=String.fromCharCode(K),K=t.charCodeAt(s);while(D(K));return f=15}if(y(K))return s++,a+=String.fromCharCode(K),K===13&&t.charCodeAt(s)===10&&(s++,a+=`
`),f=14;switch(K){case 123:return s++,f=1;case 125:return s++,f=2;case 91:return s++,f=3;case 93:return s++,f=4;case 58:return s++,f=6;case 44:return s++,f=5;case 34:return s++,a=L(),f=10;case 47:const N=s-1;if(t.charCodeAt(s+1)===47){for(s+=2;s<n&&!y(t.charCodeAt(s));)s++;return a=t.substring(N,s),f=12}if(t.charCodeAt(s+1)===42){s+=2;const x=n-1;let F=!1;for(;s<x;){if(t.charCodeAt(s)===42&&t.charCodeAt(s+1)===47){s+=2,F=!0;break}s++}return F||(s++,w=1),a=t.substring(N,s),f=13}return a+=String.fromCharCode(K),s++,f=16;case 45:if(a+=String.fromCharCode(K),s++,s===n||!A(t.charCodeAt(s)))return f=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return a+=I(),f=11;default:for(;s<n&&V(K);)s++,K=t.charCodeAt(s);if(d!==s){switch(a=t.substring(d,s),a){case"true":return f=8;case"false":return f=9;case"null":return f=7}return f=16}return a+=String.fromCharCode(K),s++,f=16}}function V(K){if(D(K)||y(K))return!1;switch(K){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function ee(){let K;do K=U();while(K>=12&&K<=15);return K}return{setPosition:o,getPosition:()=>s,scan:r?ee:U,getToken:()=>f,getTokenValue:()=>a,getTokenOffset:()=>d,getTokenLength:()=>s-d,getTokenError:()=>w}}e.createScanner=T;function D(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function y(t){return t===10||t===13||t===8232||t===8233}function A(t){return t>=48&&t<=57}var i;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(i||(i={}));function C(t,r){const s=[],n=new Object;let a;const d={value:{},offset:0,length:0,type:"object",parent:void 0};let f=!1;function w(E,o,I,L){d.value=E,d.offset=o,d.length=I,d.type=L,d.colonOffset=void 0,a=d}try{c(t,{onObjectBegin:(E,o)=>{if(r<=E)throw n;a=void 0,f=r>E,s.push("")},onObjectProperty:(E,o,I)=>{if(r<o||(w(E,o,I,"property"),s[s.length-1]=E,r<=o+I))throw n},onObjectEnd:(E,o)=>{if(r<=E)throw n;a=void 0,s.pop()},onArrayBegin:(E,o)=>{if(r<=E)throw n;a=void 0,s.push(0)},onArrayEnd:(E,o)=>{if(r<=E)throw n;a=void 0,s.pop()},onLiteralValue:(E,o,I)=>{if(r<o||(w(E,o,I,p(E)),r<=o+I))throw n},onSeparator:(E,o,I)=>{if(r<=o)throw n;if(E===":"&&a&&a.type==="property")a.colonOffset=o,f=!1,a=void 0;else if(E===","){const L=s[s.length-1];typeof L=="number"?s[s.length-1]=L+1:(f=!0,s[s.length-1]=""),a=void 0}}})}catch(E){if(E!==n)throw E}return{path:s,previousNode:a,isAtPropertyKey:f,matches:E=>{let o=0;for(let I=0;o<E.length&&I<s.length;I++)if(E[o]===s[I]||E[o]==="*")o++;else if(E[o]!=="**")return!1;return o===E.length}}}e.getLocation=C;function u(t,r=[],s=S.DEFAULT){let n=null,a=[];const d=[];function f(E){Array.isArray(a)?a.push(E):n!==null&&(a[n]=E)}return c(t,{onObjectBegin:()=>{const E={};f(E),d.push(a),a=E,n=null},onObjectProperty:E=>{n=E},onObjectEnd:()=>{a=d.pop()},onArrayBegin:()=>{const E=[];f(E),d.push(a),a=E,n=null},onArrayEnd:()=>{a=d.pop()},onLiteralValue:f,onError:(E,o,I)=>{r.push({error:E,offset:o,length:I})}},s),a[0]}e.parse=u;function m(t,r=[],s=S.DEFAULT){let n={type:"array",offset:-1,length:-1,children:[],parent:void 0};function a(E){n.type==="property"&&(n.length=E-n.offset,n=n.parent)}function d(E){return n.children.push(E),E}c(t,{onObjectBegin:E=>{n=d({type:"object",offset:E,length:-1,parent:n,children:[]})},onObjectProperty:(E,o,I)=>{n=d({type:"property",offset:o,length:-1,parent:n,children:[]}),n.children.push({type:"string",value:E,offset:o,length:I,parent:n})},onObjectEnd:(E,o)=>{n.length=E+o-n.offset,n=n.parent,a(E+o)},onArrayBegin:(E,o)=>{n=d({type:"array",offset:E,length:-1,parent:n,children:[]})},onArrayEnd:(E,o)=>{n.length=E+o-n.offset,n=n.parent,a(E+o)},onLiteralValue:(E,o,I)=>{d({type:p(E),offset:o,length:I,parent:n,value:E}),a(o+I)},onSeparator:(E,o,I)=>{n.type==="property"&&(E===":"?n.colonOffset=o:E===","&&a(o))},onError:(E,o,I)=>{r.push({error:E,offset:o,length:I})}},s);const w=n.children[0];return w&&delete w.parent,w}e.parseTree=m;function l(t,r){if(!t)return;let s=t;for(let n of r)if(typeof n=="string"){if(s.type!=="object"||!Array.isArray(s.children))return;let a=!1;for(const d of s.children)if(Array.isArray(d.children)&&d.children[0].value===n){s=d.children[1],a=!0;break}if(!a)return}else{const a=n;if(s.type!=="array"||a<0||!Array.isArray(s.children)||a>=s.children.length)return;s=s.children[a]}return s}e.findNodeAtLocation=l;function v(t){if(!t.parent||!t.parent.children)return[];const r=v(t.parent);if(t.parent.type==="property"){const s=t.parent.children[0].value;r.push(s)}else if(t.parent.type==="array"){const s=t.parent.children.indexOf(t);s!==-1&&r.push(s)}return r}e.getNodePath=v;function _(t){switch(t.type){case"array":return t.children.map(_);case"object":const r=Object.create(null);for(let s of t.children){const n=s.children[1];n&&(r[s.children[0].value]=_(n))}return r;case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=_;function b(t,r,s=!1){return r>=t.offset&&r<t.offset+t.length||s&&r===t.offset+t.length}e.contains=b;function P(t,r,s=!1){if(b(t,r,s)){const n=t.children;if(Array.isArray(n))for(let a=0;a<n.length&&n[a].offset<=r;a++){const d=P(n[a],r,s);if(d)return d}return t}}e.findNodeAtOffset=P;function c(t,r,s=S.DEFAULT){const n=T(t,!1);function a(ie){return ie?()=>ie(n.getTokenOffset(),n.getTokenLength()):()=>!0}function d(ie){return ie?he=>ie(he,n.getTokenOffset(),n.getTokenLength()):()=>!0}const f=a(r.onObjectBegin),w=d(r.onObjectProperty),E=a(r.onObjectEnd),o=a(r.onArrayBegin),I=a(r.onArrayEnd),L=d(r.onLiteralValue),U=d(r.onSeparator),V=a(r.onComment),ee=d(r.onError),K=s&&s.disallowComments,N=s&&s.allowTrailingComma;function x(){for(;;){const ie=n.scan();switch(n.getTokenError()){case 4:F(14);break;case 5:F(15);break;case 3:F(13);break;case 1:K||F(11);break;case 2:F(12);break;case 6:F(16);break}switch(ie){case 12:case 13:K?F(10):V();break;case 16:F(1);break;case 15:case 14:break;default:return ie}}}function F(ie,he=[],ye=[]){if(ee(ie),he.length+ye.length>0){let Ie=n.getToken();for(;Ie!==17;){if(he.indexOf(Ie)!==-1){x();break}else if(ye.indexOf(Ie)!==-1)break;Ie=x()}}}function z(ie){const he=n.getTokenValue();return ie?L(he):w(he),x(),!0}function M(){switch(n.getToken()){case 11:let ie=0;try{ie=JSON.parse(n.getTokenValue()),typeof ie!="number"&&(F(2),ie=0)}catch(he){F(2)}L(ie);break;case 7:L(null);break;case 8:L(!0);break;case 9:L(!1);break;default:return!1}return x(),!0}function O(){return n.getToken()!==10?(F(3,[],[2,5]),!1):(z(!1),n.getToken()===6?(U(":"),x(),G()||F(4,[],[2,5])):F(5,[],[2,5]),!0)}function q(){f(),x();let ie=!1;for(;n.getToken()!==2&&n.getToken()!==17;){if(n.getToken()===5){if(ie||F(4,[],[]),U(","),x(),n.getToken()===2&&N)break}else ie&&F(6,[],[]);O()||F(4,[],[2,5]),ie=!0}return E(),n.getToken()!==2?F(7,[2],[]):x(),!0}function B(){o(),x();let ie=!1;for(;n.getToken()!==4&&n.getToken()!==17;){if(n.getToken()===5){if(ie||F(4,[],[]),U(","),x(),n.getToken()===4&&N)break}else ie&&F(6,[],[]);G()||F(4,[],[4,5]),ie=!0}return I(),n.getToken()!==4?F(8,[4],[]):x(),!0}function G(){switch(n.getToken()){case 3:return B();case 1:return q();case 10:return z(!0);default:return M()}}return x(),n.getToken()===17?s.allowEmptyContent?!0:(F(4,[],[]),!1):G()?(n.getToken()!==17&&F(9,[],[]),!0):(F(4,[],[]),!1)}e.visit=c;function h(t,r){let s=T(t),n=[],a,d=0,f;do switch(f=s.getPosition(),a=s.scan(),a){case 12:case 13:case 17:d!==f&&n.push(t.substring(d,f)),r!==void 0&&n.push(s.getTokenValue().replace(/[^\r\n]/g,r)),d=s.getPosition();break}while(a!==17);return n.join("")}e.stripComments=h;function p(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=p}),define(me[137],ge([0,1,57]),function(J,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.format=void 0;function R(y,A,i){let C,u,m,l,v;if(A){for(l=A.offset,v=l+A.length,m=l;m>0&&!D(y,m-1);)m--;let d=v;for(;d<y.length&&!D(y,d);)d++;u=y.substring(m,d),C=S(u,i)}else u=y,C=0,m=0,l=0,v=y.length;const _=T(i,y);let b=!1,P=0,c;i.insertSpaces?c=k(" ",i.tabSize||4):c="	";const h=(0,g.createScanner)(u,!1);let p=!1;function t(){return _+k(c,C+P)}function r(){let d=h.scan();for(b=!1;d===15||d===14;)b=b||d===14,d=h.scan();return p=d===16||h.getTokenError()!==0,d}const s=[];function n(d,f,w){!p&&f<v&&w>l&&y.substring(f,w)!==d&&s.push({offset:f,length:w-f,content:d})}let a=r();if(a!==17){const d=h.getTokenOffset()+m,f=k(c,C);n(f,m,d)}for(;a!==17;){let d=h.getTokenOffset()+h.getTokenLength()+m,f=r(),w="";for(;!b&&(f===12||f===13);){const o=h.getTokenOffset()+m;n(" ",d,o),d=h.getTokenOffset()+h.getTokenLength()+m,w=f===12?t():"",f=r()}if(f===2)a!==1&&(P--,w=t());else if(f===4)a!==3&&(P--,w=t());else{switch(a){case 3:case 1:P++,w=t();break;case 5:case 12:w=t();break;case 13:b?w=t():w=" ";break;case 6:w=" ";break;case 10:if(f===6){w="";break}case 7:case 8:case 9:case 11:case 2:case 4:f===12||f===13?w=" ":f!==5&&f!==17&&(p=!0);break;case 16:p=!0;break}b&&(f===12||f===13)&&(w=t())}const E=h.getTokenOffset()+m;n(w,d,E),a=f}return s}e.format=R;function k(y,A){let i="";for(let C=0;C<A;C++)i+=y;return i}function S(y,A){let i=0,C=0;const u=A.tabSize||4;for(;i<y.length;){const m=y.charAt(i);if(m===" ")C++;else if(m==="	")C+=u;else break;i++}return Math.floor(C/u)}function T(y,A){for(let i=0;i<A.length;i++){const C=A.charAt(i);if(C==="\r")return i+1<A.length&&A.charAt(i+1)===`
`?`\r
`:"\r";if(C===`
`)return`
`}return y&&y.eol||`
`}e.getEOL=T;function D(y,A){return`\r
`.indexOf(y.charAt(A))!==-1}e.isEOL=D}),define(me[138],ge([0,1,57,137]),function(J,e,g,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function k(A,i,C){return S(A,i,void 0,C)}e.removeProperty=k;function S(A,i,C,u,m){const l=i.slice(),v=[],_=(0,g.parseTree)(A,v);let b,P;for(;l.length>0&&(P=l.pop(),b=(0,g.findNodeAtLocation)(_,l),b===void 0&&C!==void 0);)typeof P=="string"?C={[P]:C}:C=[C];if(b)if(b.type==="object"&&typeof P=="string"&&Array.isArray(b.children)){const c=(0,g.findNodeAtLocation)(b,[P]);if(c!==void 0)if(C===void 0){if(!c.parent)throw new Error("Malformed AST");const h=b.children.indexOf(c.parent);let p,t=c.parent.offset+c.parent.length;if(h>0){const r=b.children[h-1];p=r.offset+r.length}else p=b.offset+1,b.children.length>1&&(t=b.children[1].offset);return T(A,{offset:p,length:t-p,content:""},u)}else return T(A,{offset:c.offset,length:c.length,content:JSON.stringify(C)},u);else{if(C===void 0)return[];const h=`${JSON.stringify(P)}: ${JSON.stringify(C)}`,p=m?m(b.children.map(r=>r.children[0].value)):b.children.length;let t;if(p>0){const r=b.children[p-1];t={offset:r.offset+r.length,length:0,content:","+h}}else b.children.length===0?t={offset:b.offset+1,length:0,content:h}:t={offset:b.offset+1,length:0,content:h+","};return T(A,t,u)}}else if(b.type==="array"&&typeof P=="number"&&Array.isArray(b.children))if(C!==void 0){const c=`${JSON.stringify(C)}`;let h;if(b.children.length===0||P===0)h={offset:b.offset+1,length:0,content:b.children.length===0?c:c+","};else{const p=P===-1||P>b.children.length?b.children.length:P,t=b.children[p-1];h={offset:t.offset+t.length,length:0,content:","+c}}return T(A,h,u)}else{const c=P,h=b.children[c];let p;if(b.children.length===1)p={offset:b.offset+1,length:b.length-2,content:""};else if(b.children.length-1===c){const t=b.children[c-1],r=t.offset+t.length,s=b.offset+b.length;p={offset:r,length:s-2-r,content:""}}else p={offset:h.offset,length:b.children[c+1].offset-h.offset,content:""};return T(A,p,u)}else throw new Error(`Can not add ${typeof P!="number"?"index":"property"} to parent of type ${b.type}`);else{if(C===void 0)throw new Error("Can not delete in empty document");return T(A,{offset:_?_.offset:0,length:_?_.length:0,content:JSON.stringify(C)},u)}}e.setProperty=S;function T(A,i,C){let u=D(A,i),m=i.offset,l=i.offset+i.content.length;if(i.length===0||i.content.length===0){for(;m>0&&!(0,R.isEOL)(u,m-1);)m--;for(;l<u.length&&!(0,R.isEOL)(u,l);)l++}const v=(0,R.format)(u,{offset:m,length:l-m},C);for(let b=v.length-1;b>=0;b--){const P=v[b];u=D(u,P),m=Math.min(m,P.offset),l=Math.max(l,P.offset+P.length),l+=P.content.length-P.length}const _=A.length-(u.length-l)-m;return[{offset:m,length:_,content:u.substring(m,l)}]}e.withFormatting=T;function D(A,i){return A.substring(0,i.offset)+i.content+A.substring(i.offset+i.length)}e.applyEdit=D;function y(A,i){let C=i.slice(0).sort((m,l)=>{const v=m.offset-l.offset;return v===0?m.length-l.length:v}),u=A.length;for(let m=C.length-1;m>=0;m--){let l=C[m];if(l.offset+l.length<=u)A=D(A,l);else throw new Error("Overlapping edit");u=l.offset}return A}e.applyEdits=y}),define(me[139],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class g{constructor(k){this.executor=k,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(k){this._error=k}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(k){return new g(()=>k(this.getValue()))}}e.Lazy=g}),define(me[6],ge([0,1,72,74]),function(J,e,g,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.markAsSingleton=e.setDisposableTracker=void 0;const k=!1;let S=null;function T(s){S=s}if(e.setDisposableTracker=T,k){const s="__is_disposable_tracked__";T(new class{trackDisposable(n){const a=new Error("Potentially leaked disposable").stack;setTimeout(()=>{n[s]||console.log(a)},3e3)}setParent(n,a){if(n&&n!==P.None)try{n[s]=!0}catch{}}markAsDisposed(n){if(n&&n!==P.None)try{n[s]=!0}catch{}}markAsSingleton(n){}})}function D(s){return S?.trackDisposable(s),s}function y(s){S?.markAsDisposed(s)}function A(s,n){S?.setParent(s,n)}function i(s,n){if(!!S)for(const a of s)S.setParent(a,n)}function C(s){return S?.markAsSingleton(s),s}e.markAsSingleton=C;class u extends Error{constructor(n){super(`Encountered errors while disposing of store. Errors: [${n.join(", ")}]`);this.errors=n}}e.MultiDisposeError=u;function m(s){return typeof s.dispose=="function"&&s.dispose.length===0}e.isDisposable=m;function l(s){if(R.Iterable.is(s)){let n=[];for(const a of s)if(a)try{a.dispose()}catch(d){n.push(d)}if(n.length===1)throw n[0];if(n.length>1)throw new u(n);return Array.isArray(s)?[]:s}else if(s)return s.dispose(),s}e.dispose=l;function v(...s){const n=_(()=>l(s));return i(s,n),n}e.combinedDisposable=v;function _(s){const n=D({dispose:(0,g.once)(()=>{y(n),s()})});return n}e.toDisposable=_;class b{constructor(){this._toDispose=new Set,this._isDisposed=!1,D(this)}dispose(){this._isDisposed||(y(this),this._isDisposed=!0,this.clear())}clear(){try{l(this._toDispose.values())}finally{this._toDispose.clear()}}add(n){if(!n)return n;if(n===this)throw new Error("Cannot register a disposable on itself!");return A(n,this),this._isDisposed?b.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(n),n}}e.DisposableStore=b,b.DISABLE_DISPOSED_WARNING=!1;class P{constructor(){this._store=new b,D(this),A(this._store,this)}dispose(){y(this),this._store.dispose()}_register(n){if(n===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(n)}}e.Disposable=P,P.None=Object.freeze({dispose(){}});class c{constructor(){this._isDisposed=!1,D(this)}get value(){return this._isDisposed?void 0:this._value}set value(n){this._isDisposed||n===this._value||(this._value?.dispose(),n&&A(n,this),this._value=n)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,y(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const n=this._value;return this._value=void 0,n&&A(n,null),n}}e.MutableDisposable=c;class h{constructor(n){this._disposable=n,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter==0&&this._disposable.dispose(),this}}e.RefCountedDisposable=h;class p{constructor(){this.references=new Map}acquire(n,...a){let d=this.references.get(n);d||(d={counter:0,object:this.createReferencedObject(n,...a)},this.references.set(n,d));const{object:f}=d,w=(0,g.once)(()=>{--d.counter==0&&(this.destroyReferencedObject(n,d.object),this.references.delete(n))});return d.counter++,{object:f,dispose:w}}}e.ReferenceCollection=p;class t{constructor(n){this.referenceCollection=n}async acquire(n,...a){const d=this.referenceCollection.acquire(n,...a);try{return{object:await d.object,dispose:()=>d.dispose()}}catch(f){throw d.dispose(),f}}}e.AsyncReferenceCollection=t;class r{constructor(n){this.object=n}dispose(){}}e.ImmortalReference=r}),define(me[95],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class g{constructor(S){this.element=S,this.next=g.Undefined,this.prev=g.Undefined}}g.Undefined=new g(void 0);class R{constructor(){this._first=g.Undefined,this._last=g.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===g.Undefined}clear(){let S=this._first;for(;S!==g.Undefined;){const T=S.next;S.prev=g.Undefined,S.next=g.Undefined,S=T}this._first=g.Undefined,this._last=g.Undefined,this._size=0}unshift(S){return this._insert(S,!1)}push(S){return this._insert(S,!0)}_insert(S,T){const D=new g(S);if(this._first===g.Undefined)this._first=D,this._last=D;else if(T){const A=this._last;this._last=D,D.prev=A,A.next=D}else{const A=this._first;this._first=D,D.next=A,A.prev=D}this._size+=1;let y=!1;return()=>{y||(y=!0,this._remove(D))}}shift(){if(this._first!==g.Undefined){const S=this._first.element;return this._remove(this._first),S}}pop(){if(this._last!==g.Undefined){const S=this._last.element;return this._remove(this._last),S}}_remove(S){if(S.prev!==g.Undefined&&S.next!==g.Undefined){const T=S.prev;T.next=S.next,S.next.prev=T}else S.prev===g.Undefined&&S.next===g.Undefined?(this._first=g.Undefined,this._last=g.Undefined):S.next===g.Undefined?(this._last=this._last.prev,this._last.next=g.Undefined):S.prev===g.Undefined&&(this._first=this._first.next,this._first.prev=g.Undefined);this._size-=1}*[Symbol.iterator](){let S=this._first;for(;S!==g.Undefined;)yield S.element,S=S.next}}e.LinkedList=R}),function(J,e){typeof exports=="object"&&typeof module!="undefined"?module.exports=e():typeof define=="function"&&define.amd?define("vs/base/common/marked/marked",e):(J=typeof globalThis!="undefined"?globalThis:J||self,J.marked=e())}(this,function(){"use strict";function J(Ce,De){for(var Te=0;Te<De.length;Te++){var ce=De[Te];ce.enumerable=ce.enumerable||!1,ce.configurable=!0,"value"in ce&&(ce.writable=!0),Object.defineProperty(Ce,ce.key,ce)}}function e(Ce,De,Te){return De&&J(Ce.prototype,De),Te&&J(Ce,Te),Ce}function g(Ce,De){if(!!Ce){if(typeof Ce=="string")return R(Ce,De);var Te=Object.prototype.toString.call(Ce).slice(8,-1);if(Te==="Object"&&Ce.constructor&&(Te=Ce.constructor.name),Te==="Map"||Te==="Set")return Array.from(Ce);if(Te==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(Te))return R(Ce,De)}}function R(Ce,De){(De==null||De>Ce.length)&&(De=Ce.length);for(var Te=0,ce=new Array(De);Te<De;Te++)ce[Te]=Ce[Te];return ce}function k(Ce,De){var Te;if(typeof Symbol=="undefined"||Ce[Symbol.iterator]==null){if(Array.isArray(Ce)||(Te=g(Ce))||De&&Ce&&typeof Ce.length=="number"){Te&&(Ce=Te);var ce=0;return function(){return ce>=Ce.length?{done:!0}:{done:!1,value:Ce[ce++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}return Te=Ce[Symbol.iterator](),Te.next.bind(Te)}function S(Ce){var De={exports:{}};return Ce(De,De.exports),De.exports}var T=S(function(Ce){function De(){return{baseUrl:null,breaks:!1,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}function Te(ce){Ce.exports.defaults=ce}Ce.exports={defaults:De(),getDefaults:De,changeDefaults:Te}}),D=/[&<>"']/,y=/[&<>"']/g,A=/[<>"']|&(?!#?\w+;)/,i=/[<>"']|&(?!#?\w+;)/g,C={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},u=function(De){return C[De]};function m(Ce,De){if(De){if(D.test(Ce))return Ce.replace(y,u)}else if(A.test(Ce))return Ce.replace(i,u);return Ce}var l=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function v(Ce){return Ce.replace(l,function(De,Te){return Te=Te.toLowerCase(),Te==="colon"?":":Te.charAt(0)==="#"?Te.charAt(1)==="x"?String.fromCharCode(parseInt(Te.substring(2),16)):String.fromCharCode(+Te.substring(1)):""})}var _=/(^|[^\[])\^/g;function b(Ce,De){Ce=Ce.source||Ce,De=De||"";var Te={replace:function(ue,pe){return pe=pe.source||pe,pe=pe.replace(_,"$1"),Ce=Ce.replace(ue,pe),Te},getRegex:function(){return new RegExp(Ce,De)}};return Te}var P=/[^\w:]/g,c=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function h(Ce,De,Te){if(Ce){var ce;try{ce=decodeURIComponent(v(Te)).replace(P,"").toLowerCase()}catch(ue){return null}if(ce.indexOf("javascript:")===0||ce.indexOf("vbscript:")===0||ce.indexOf("data:")===0)return null}De&&!c.test(Te)&&(Te=n(De,Te));try{Te=encodeURI(Te).replace(/%25/g,"%")}catch(ue){return null}return Te}var p={},t=/^[^:]+:\/*[^/]*$/,r=/^([^:]+:)[\s\S]*$/,s=/^([^:]+:\/*[^/]*)[\s\S]*$/;function n(Ce,De){p[" "+Ce]||(t.test(Ce)?p[" "+Ce]=Ce+"/":p[" "+Ce]=w(Ce,"/",!0)),Ce=p[" "+Ce];var Te=Ce.indexOf(":")===-1;return De.substring(0,2)==="//"?Te?De:Ce.replace(r,"$1")+De:De.charAt(0)==="/"?Te?De:Ce.replace(s,"$1")+De:Ce+De}var a={exec:function(){}};function d(Ce){for(var De=1,Te,ce;De<arguments.length;De++){Te=arguments[De];for(ce in Te)Object.prototype.hasOwnProperty.call(Te,ce)&&(Ce[ce]=Te[ce])}return Ce}function f(Ce,De){var Te=Ce.replace(/\|/g,function(pe,be,j){for(var we=!1,_e=be;--_e>=0&&j[_e]==="\\";)we=!we;return we?"|":" |"}),ce=Te.split(/ \|/),ue=0;if(ce.length>De)ce.splice(De);else for(;ce.length<De;)ce.push("");for(;ue<ce.length;ue++)ce[ue]=ce[ue].trim().replace(/\\\|/g,"|");return ce}function w(Ce,De,Te){var ce=Ce.length;if(ce===0)return"";for(var ue=0;ue<ce;){var pe=Ce.charAt(ce-ue-1);if(pe===De&&!Te)ue++;else if(pe!==De&&Te)ue++;else break}return Ce.substr(0,ce-ue)}function E(Ce,De){if(Ce.indexOf(De[1])===-1)return-1;for(var Te=Ce.length,ce=0,ue=0;ue<Te;ue++)if(Ce[ue]==="\\")ue++;else if(Ce[ue]===De[0])ce++;else if(Ce[ue]===De[1]&&(ce--,ce<0))return ue;return-1}function o(Ce){Ce&&Ce.sanitize&&!Ce.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function I(Ce,De){if(De<1)return"";for(var Te="";De>1;)De&1&&(Te+=Ce),De>>=1,Ce+=Ce;return Te+Ce}var L={escape:m,unescape:v,edit:b,cleanUrl:h,resolveUrl:n,noopTest:a,merge:d,splitCells:f,rtrim:w,findClosingBracket:E,checkSanitizeDeprecation:o,repeatString:I},U=T.defaults,V=L.rtrim,ee=L.splitCells,K=L.escape,N=L.findClosingBracket;function x(Ce,De,Te){var ce=De.href,ue=De.title?K(De.title):null,pe=Ce[1].replace(/\\([\[\]])/g,"$1");return Ce[0].charAt(0)!=="!"?{type:"link",raw:Te,href:ce,title:ue,text:pe}:{type:"image",raw:Te,href:ce,title:ue,text:K(pe)}}function F(Ce,De){var Te=Ce.match(/^(\s+)(?:```)/);if(Te===null)return De;var ce=Te[1];return De.split(`
`).map(function(ue){var pe=ue.match(/^\s+/);if(pe===null)return ue;var be=pe[0];return be.length>=ce.length?ue.slice(ce.length):ue}).join(`
`)}var z=function(){function Ce(Te){this.options=Te||U}var De=Ce.prototype;return De.space=function(ce){var ue=this.rules.block.newline.exec(ce);if(ue)return ue[0].length>1?{type:"space",raw:ue[0]}:{raw:`
`}},De.code=function(ce){var ue=this.rules.block.code.exec(ce);if(ue){var pe=ue[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:ue[0],codeBlockStyle:"indented",text:this.options.pedantic?pe:V(pe,`
`)}}},De.fences=function(ce){var ue=this.rules.block.fences.exec(ce);if(ue){var pe=ue[0],be=F(pe,ue[3]||"");return{type:"code",raw:pe,lang:ue[2]?ue[2].trim():ue[2],text:be}}},De.heading=function(ce){var ue=this.rules.block.heading.exec(ce);if(ue){var pe=ue[2].trim();if(/#$/.test(pe)){var be=V(pe,"#");(this.options.pedantic||!be||/ $/.test(be))&&(pe=be.trim())}return{type:"heading",raw:ue[0],depth:ue[1].length,text:pe}}},De.nptable=function(ce){var ue=this.rules.block.nptable.exec(ce);if(ue){var pe={type:"table",header:ee(ue[1].replace(/^ *| *\| *$/g,"")),align:ue[2].replace(/^ *|\| *$/g,"").split(/ *\| */),cells:ue[3]?ue[3].replace(/\n$/,"").split(`
`):[],raw:ue[0]};if(pe.header.length===pe.align.length){var be=pe.align.length,j;for(j=0;j<be;j++)/^ *-+: *$/.test(pe.align[j])?pe.align[j]="right":/^ *:-+: *$/.test(pe.align[j])?pe.align[j]="center":/^ *:-+ *$/.test(pe.align[j])?pe.align[j]="left":pe.align[j]=null;for(be=pe.cells.length,j=0;j<be;j++)pe.cells[j]=ee(pe.cells[j],pe.header.length);return pe}}},De.hr=function(ce){var ue=this.rules.block.hr.exec(ce);if(ue)return{type:"hr",raw:ue[0]}},De.blockquote=function(ce){var ue=this.rules.block.blockquote.exec(ce);if(ue){var pe=ue[0].replace(/^ *> ?/gm,"");return{type:"blockquote",raw:ue[0],text:pe}}},De.list=function(ce){var ue=this.rules.block.list.exec(ce);if(ue){var pe=ue[0],be=ue[2],j=be.length>1,we={type:"list",raw:pe,ordered:j,start:j?+be.slice(0,-1):"",loose:!1,items:[]},_e=ue[0].match(this.rules.block.item),Ae=!1,Ue,Ge,Ze,Qe,Je,ct,mt,bt,ot=_e.length;Ze=this.rules.block.listItemStart.exec(_e[0]);for(var at=0;at<ot;at++){if(Ue=_e[at],pe=Ue,at!==ot-1){if(Qe=this.rules.block.listItemStart.exec(_e[at+1]),this.options.pedantic?Qe[1].length>Ze[1].length:Qe[1].length>Ze[0].length||Qe[1].length>3){_e.splice(at,2,_e[at]+`
`+_e[at+1]),at--,ot--;continue}else(!this.options.pedantic||this.options.smartLists?Qe[2][Qe[2].length-1]!==be[be.length-1]:j===(Qe[2].length===1))&&(Je=_e.slice(at+1).join(`
`),we.raw=we.raw.substring(0,we.raw.length-Je.length),at=ot-1);Ze=Qe}Ge=Ue.length,Ue=Ue.replace(/^ *([*+-]|\d+[.)]) ?/,""),~Ue.indexOf(`
 `)&&(Ge-=Ue.length,Ue=this.options.pedantic?Ue.replace(/^ {1,4}/gm,""):Ue.replace(new RegExp("^ {1,"+Ge+"}","gm"),"")),ct=Ae||/\n\n(?!\s*$)/.test(Ue),at!==ot-1&&(Ae=Ue.charAt(Ue.length-1)===`
`,ct||(ct=Ae)),ct&&(we.loose=!0),this.options.gfm&&(mt=/^\[[ xX]\] /.test(Ue),bt=void 0,mt&&(bt=Ue[1]!==" ",Ue=Ue.replace(/^\[[ xX]\] +/,""))),we.items.push({type:"list_item",raw:pe,task:mt,checked:bt,loose:ct,text:Ue})}return we}},De.html=function(ce){var ue=this.rules.block.html.exec(ce);if(ue)return{type:this.options.sanitize?"paragraph":"html",raw:ue[0],pre:!this.options.sanitizer&&(ue[1]==="pre"||ue[1]==="script"||ue[1]==="style"),text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ue[0]):K(ue[0]):ue[0]}},De.def=function(ce){var ue=this.rules.block.def.exec(ce);if(ue){ue[3]&&(ue[3]=ue[3].substring(1,ue[3].length-1));var pe=ue[1].toLowerCase().replace(/\s+/g," ");return{tag:pe,raw:ue[0],href:ue[2],title:ue[3]}}},De.table=function(ce){var ue=this.rules.block.table.exec(ce);if(ue){var pe={type:"table",header:ee(ue[1].replace(/^ *| *\| *$/g,"")),align:ue[2].replace(/^ *|\| *$/g,"").split(/ *\| */),cells:ue[3]?ue[3].replace(/\n$/,"").split(`
`):[]};if(pe.header.length===pe.align.length){pe.raw=ue[0];var be=pe.align.length,j;for(j=0;j<be;j++)/^ *-+: *$/.test(pe.align[j])?pe.align[j]="right":/^ *:-+: *$/.test(pe.align[j])?pe.align[j]="center":/^ *:-+ *$/.test(pe.align[j])?pe.align[j]="left":pe.align[j]=null;for(be=pe.cells.length,j=0;j<be;j++)pe.cells[j]=ee(pe.cells[j].replace(/^ *\| *| *\| *$/g,""),pe.header.length);return pe}}},De.lheading=function(ce){var ue=this.rules.block.lheading.exec(ce);if(ue)return{type:"heading",raw:ue[0],depth:ue[2].charAt(0)==="="?1:2,text:ue[1]}},De.paragraph=function(ce){var ue=this.rules.block.paragraph.exec(ce);if(ue)return{type:"paragraph",raw:ue[0],text:ue[1].charAt(ue[1].length-1)===`
`?ue[1].slice(0,-1):ue[1]}},De.text=function(ce){var ue=this.rules.block.text.exec(ce);if(ue)return{type:"text",raw:ue[0],text:ue[0]}},De.escape=function(ce){var ue=this.rules.inline.escape.exec(ce);if(ue)return{type:"escape",raw:ue[0],text:K(ue[1])}},De.tag=function(ce,ue,pe){var be=this.rules.inline.tag.exec(ce);if(be)return!ue&&/^<a /i.test(be[0])?ue=!0:ue&&/^<\/a>/i.test(be[0])&&(ue=!1),!pe&&/^<(pre|code|kbd|script)(\s|>)/i.test(be[0])?pe=!0:pe&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(be[0])&&(pe=!1),{type:this.options.sanitize?"text":"html",raw:be[0],inLink:ue,inRawBlock:pe,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(be[0]):K(be[0]):be[0]}},De.link=function(ce){var ue=this.rules.inline.link.exec(ce);if(ue){var pe=ue[2].trim();if(!this.options.pedantic&&/^</.test(pe)){if(!/>$/.test(pe))return;var be=V(pe.slice(0,-1),"\\");if((pe.length-be.length)%2==0)return}else{var j=N(ue[2],"()");if(j>-1){var we=ue[0].indexOf("!")===0?5:4,_e=we+ue[1].length+j;ue[2]=ue[2].substring(0,j),ue[0]=ue[0].substring(0,_e).trim(),ue[3]=""}}var Ae=ue[2],Ue="";if(this.options.pedantic){var Ge=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Ae);Ge&&(Ae=Ge[1],Ue=Ge[3])}else Ue=ue[3]?ue[3].slice(1,-1):"";return Ae=Ae.trim(),/^</.test(Ae)&&(this.options.pedantic&&!/>$/.test(pe)?Ae=Ae.slice(1):Ae=Ae.slice(1,-1)),x(ue,{href:Ae&&Ae.replace(this.rules.inline._escapes,"$1"),title:Ue&&Ue.replace(this.rules.inline._escapes,"$1")},ue[0])}},De.reflink=function(ce,ue){var pe;if((pe=this.rules.inline.reflink.exec(ce))||(pe=this.rules.inline.nolink.exec(ce))){var be=(pe[2]||pe[1]).replace(/\s+/g," ");if(be=ue[be.toLowerCase()],!be||!be.href){var j=pe[0].charAt(0);return{type:"text",raw:j,text:j}}return x(pe,be,pe[0])}},De.emStrong=function(ce,ue,pe){pe===void 0&&(pe="");var be=this.rules.inline.emStrong.lDelim.exec(ce);if(!!be&&!(be[3]&&pe.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u08A0-\u08B4\u08B6-\u08C7\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u170C\u170E-\u1711\u1720-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4B\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2C2E\u2C30-\u2C5E\u2C60-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\u9FFC\uA000-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7BF\uA7C2-\uA7CA\uA7F5-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEC0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82C[\uDC00-\uDD1E\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDD\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF34\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var j=be[1]||be[2]||"";if(!j||j&&(pe===""||this.rules.inline.punctuation.exec(pe))){var we=be[0].length-1,_e,Ae,Ue=we,Ge=0,Ze=be[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(Ze.lastIndex=0,ue=ue.slice(-1*ce.length+we);(be=Ze.exec(ue))!=null;)if(_e=be[1]||be[2]||be[3]||be[4]||be[5]||be[6],!!_e){if(Ae=_e.length,be[3]||be[4]){Ue+=Ae;continue}else if((be[5]||be[6])&&we%3&&!((we+Ae)%3)){Ge+=Ae;continue}if(Ue-=Ae,!(Ue>0)){if(Ue+Ge-Ae<=0&&!ue.slice(Ze.lastIndex).match(Ze)&&(Ae=Math.min(Ae,Ae+Ue+Ge)),Math.min(we,Ae)%2)return{type:"em",raw:ce.slice(0,we+be.index+Ae+1),text:ce.slice(1,we+be.index+Ae)};if(Math.min(we,Ae)%2==0)return{type:"strong",raw:ce.slice(0,we+be.index+Ae+1),text:ce.slice(2,we+be.index+Ae-1)}}}}}},De.codespan=function(ce){var ue=this.rules.inline.code.exec(ce);if(ue){var pe=ue[2].replace(/\n/g," "),be=/[^ ]/.test(pe),j=/^ /.test(pe)&&/ $/.test(pe);return be&&j&&(pe=pe.substring(1,pe.length-1)),pe=K(pe,!0),{type:"codespan",raw:ue[0],text:pe}}},De.br=function(ce){var ue=this.rules.inline.br.exec(ce);if(ue)return{type:"br",raw:ue[0]}},De.del=function(ce){var ue=this.rules.inline.del.exec(ce);if(ue)return{type:"del",raw:ue[0],text:ue[2]}},De.autolink=function(ce,ue){var pe=this.rules.inline.autolink.exec(ce);if(pe){var be,j;return pe[2]==="@"?(be=K(this.options.mangle?ue(pe[1]):pe[1]),j="mailto:"+be):(be=K(pe[1]),j=be),{type:"link",raw:pe[0],text:be,href:j,tokens:[{type:"text",raw:be,text:be}]}}},De.url=function(ce,ue){var pe;if(pe=this.rules.inline.url.exec(ce)){var be,j;if(pe[2]==="@")be=K(this.options.mangle?ue(pe[0]):pe[0]),j="mailto:"+be;else{var we;do we=pe[0],pe[0]=this.rules.inline._backpedal.exec(pe[0])[0];while(we!==pe[0]);be=K(pe[0]),pe[1]==="www."?j="http://"+be:j=be}return{type:"link",raw:pe[0],text:be,href:j,tokens:[{type:"text",raw:be,text:be}]}}},De.inlineText=function(ce,ue,pe){var be=this.rules.inline.text.exec(ce);if(be){var j;return ue?j=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(be[0]):K(be[0]):be[0]:j=K(this.options.smartypants?pe(be[0]):be[0]),{type:"text",raw:be[0],text:j}}},Ce}(),M=L.noopTest,O=L.edit,q=L.merge,B={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?:\n+|$)|$)/,hr:/^ {0,3}((?:- *){3,}|(?:_ *){3,}|(?:\* *){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3})(bull) [\s\S]+?(?:hr|def|\n{2,}(?! )(?! {0,3}bull )\n*|\s*$)/,html:"^ {0,3}(?:<(script|pre|style)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:\\n{2,}|$)|<(?!script|pre|style)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:\\n{2,}|$)|</(?!script|pre|style)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:\\n{2,}|$))",def:/^ {0,3}\[(label)\]: *\n? *<?([^\s>]+)>?(?:(?: +\n? *| *\n *)(title))? *(?:\n+|$)/,nptable:M,table:M,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html| +\n)[^\n]+)*)/,text:/^[^\n]+/};B._label=/(?!\s*\])(?:\\[\[\]]|[^\[\]])+/,B._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,B.def=O(B.def).replace("label",B._label).replace("title",B._title).getRegex(),B.bullet=/(?:[*+-]|\d{1,9}[.)])/,B.item=/^( *)(bull) ?[^\n]*(?:\n(?! *bull ?)[^\n]*)*/,B.item=O(B.item,"gm").replace(/bull/g,B.bullet).getRegex(),B.listItemStart=O(/^( *)(bull)/).replace("bull",B.bullet).getRegex(),B.list=O(B.list).replace(/bull/g,B.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+B.def.source+")").getRegex(),B._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",B._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,B.html=O(B.html,"i").replace("comment",B._comment).replace("tag",B._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),B.paragraph=O(B._paragraph).replace("hr",B.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",B._tag).getRegex(),B.blockquote=O(B.blockquote).replace("paragraph",B.paragraph).getRegex(),B.normal=q({},B),B.gfm=q({},B.normal,{nptable:"^ *([^|\\n ].*\\|.*)\\n {0,3}([-:]+ *\\|[-| :]*)(?:\\n((?:(?!\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)",table:"^ *\\|(.+)\\n {0,3}\\|?( *[-:]+[-| :]*)(?:\\n *((?:(?!\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),B.gfm.nptable=O(B.gfm.nptable).replace("hr",B.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",B._tag).getRegex(),B.gfm.table=O(B.gfm.table).replace("hr",B.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",B._tag).getRegex(),B.pedantic=q({},B.normal,{html:O(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",B._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:M,paragraph:O(B.normal._paragraph).replace("hr",B.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",B.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var G={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:M,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(?!\s*\])((?:\\[\[\]]?|[^\[\]\\])+)\]/,nolink:/^!?\[(?!\s*\])((?:\[[^\[\]]*\]|\\[\[\]]|[^\[\]])*)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/\_\_[^_]*?\*[^_]*?\_\_|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/\*\*[^*]*?\_[^*]*?\*\*|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:M,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};G._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",G.punctuation=O(G.punctuation).replace(/punctuation/g,G._punctuation).getRegex(),G.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,G.escapedEmSt=/\\\*|\\_/g,G._comment=O(B._comment).replace("(?:-->|$)","-->").getRegex(),G.emStrong.lDelim=O(G.emStrong.lDelim).replace(/punct/g,G._punctuation).getRegex(),G.emStrong.rDelimAst=O(G.emStrong.rDelimAst,"g").replace(/punct/g,G._punctuation).getRegex(),G.emStrong.rDelimUnd=O(G.emStrong.rDelimUnd,"g").replace(/punct/g,G._punctuation).getRegex(),G._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,G._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,G._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,G.autolink=O(G.autolink).replace("scheme",G._scheme).replace("email",G._email).getRegex(),G._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,G.tag=O(G.tag).replace("comment",G._comment).replace("attribute",G._attribute).getRegex(),G._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,G._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,G._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,G.link=O(G.link).replace("label",G._label).replace("href",G._href).replace("title",G._title).getRegex(),G.reflink=O(G.reflink).replace("label",G._label).getRegex(),G.reflinkSearch=O(G.reflinkSearch,"g").replace("reflink",G.reflink).replace("nolink",G.nolink).getRegex(),G.normal=q({},G),G.pedantic=q({},G.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:O(/^!?\[(label)\]\((.*?)\)/).replace("label",G._label).getRegex(),reflink:O(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",G._label).getRegex()}),G.gfm=q({},G.normal,{escape:O(G.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@))|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@))/}),G.gfm.url=O(G.gfm.url,"i").replace("email",G.gfm._extended_email).getRegex(),G.breaks=q({},G.gfm,{br:O(G.br).replace("{2,}","*").getRegex(),text:O(G.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});var ie={block:B,inline:G},he=T.defaults,ye=ie.block,Ie=ie.inline,Le=L.repeatString;function qe(Ce){return Ce.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function We(Ce){var De="",Te,ce,ue=Ce.length;for(Te=0;Te<ue;Te++)ce=Ce.charCodeAt(Te),Math.random()>.5&&(ce="x"+ce.toString(16)),De+="&#"+ce+";";return De}var je=function(){function Ce(Te){this.tokens=[],this.tokens.links=Object.create(null),this.options=Te||he,this.options.tokenizer=this.options.tokenizer||new z,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options;var ce={block:ye.normal,inline:Ie.normal};this.options.pedantic?(ce.block=ye.pedantic,ce.inline=Ie.pedantic):this.options.gfm&&(ce.block=ye.gfm,this.options.breaks?ce.inline=Ie.breaks:ce.inline=Ie.gfm),this.tokenizer.rules=ce}Ce.lex=function(ce,ue){var pe=new Ce(ue);return pe.lex(ce)},Ce.lexInline=function(ce,ue){var pe=new Ce(ue);return pe.inlineTokens(ce)};var De=Ce.prototype;return De.lex=function(ce){return ce=ce.replace(/\r\n|\r/g,`
`).replace(/\t/g,"    "),this.blockTokens(ce,this.tokens,!0),this.inline(this.tokens),this.tokens},De.blockTokens=function(ce,ue,pe){ue===void 0&&(ue=[]),pe===void 0&&(pe=!0),this.options.pedantic&&(ce=ce.replace(/^ +$/gm,""));for(var be,j,we,_e;ce;){if(be=this.tokenizer.space(ce)){ce=ce.substring(be.raw.length),be.type&&ue.push(be);continue}if(be=this.tokenizer.code(ce)){ce=ce.substring(be.raw.length),_e=ue[ue.length-1],_e&&_e.type==="paragraph"?(_e.raw+=`
`+be.raw,_e.text+=`
`+be.text):ue.push(be);continue}if(be=this.tokenizer.fences(ce)){ce=ce.substring(be.raw.length),ue.push(be);continue}if(be=this.tokenizer.heading(ce)){ce=ce.substring(be.raw.length),ue.push(be);continue}if(be=this.tokenizer.nptable(ce)){ce=ce.substring(be.raw.length),ue.push(be);continue}if(be=this.tokenizer.hr(ce)){ce=ce.substring(be.raw.length),ue.push(be);continue}if(be=this.tokenizer.blockquote(ce)){ce=ce.substring(be.raw.length),be.tokens=this.blockTokens(be.text,[],pe),ue.push(be);continue}if(be=this.tokenizer.list(ce)){for(ce=ce.substring(be.raw.length),we=be.items.length,j=0;j<we;j++)be.items[j].tokens=this.blockTokens(be.items[j].text,[],!1);ue.push(be);continue}if(be=this.tokenizer.html(ce)){ce=ce.substring(be.raw.length),ue.push(be);continue}if(pe&&(be=this.tokenizer.def(ce))){ce=ce.substring(be.raw.length),this.tokens.links[be.tag]||(this.tokens.links[be.tag]={href:be.href,title:be.title});continue}if(be=this.tokenizer.table(ce)){ce=ce.substring(be.raw.length),ue.push(be);continue}if(be=this.tokenizer.lheading(ce)){ce=ce.substring(be.raw.length),ue.push(be);continue}if(pe&&(be=this.tokenizer.paragraph(ce))){ce=ce.substring(be.raw.length),ue.push(be);continue}if(be=this.tokenizer.text(ce)){ce=ce.substring(be.raw.length),_e=ue[ue.length-1],_e&&_e.type==="text"?(_e.raw+=`
`+be.raw,_e.text+=`
`+be.text):ue.push(be);continue}if(ce){var Ae="Infinite loop on byte: "+ce.charCodeAt(0);if(this.options.silent){console.error(Ae);break}else throw new Error(Ae)}}return ue},De.inline=function(ce){var ue,pe,be,j,we,_e,Ae=ce.length;for(ue=0;ue<Ae;ue++)switch(_e=ce[ue],_e.type){case"paragraph":case"text":case"heading":{_e.tokens=[],this.inlineTokens(_e.text,_e.tokens);break}case"table":{for(_e.tokens={header:[],cells:[]},j=_e.header.length,pe=0;pe<j;pe++)_e.tokens.header[pe]=[],this.inlineTokens(_e.header[pe],_e.tokens.header[pe]);for(j=_e.cells.length,pe=0;pe<j;pe++)for(we=_e.cells[pe],_e.tokens.cells[pe]=[],be=0;be<we.length;be++)_e.tokens.cells[pe][be]=[],this.inlineTokens(we[be],_e.tokens.cells[pe][be]);break}case"blockquote":{this.inline(_e.tokens);break}case"list":{for(j=_e.items.length,pe=0;pe<j;pe++)this.inline(_e.items[pe].tokens);break}}return ce},De.inlineTokens=function(ce,ue,pe,be){ue===void 0&&(ue=[]),pe===void 0&&(pe=!1),be===void 0&&(be=!1);var j,we,_e=ce,Ae,Ue,Ge;if(this.tokens.links){var Ze=Object.keys(this.tokens.links);if(Ze.length>0)for(;(Ae=this.tokenizer.rules.inline.reflinkSearch.exec(_e))!=null;)Ze.includes(Ae[0].slice(Ae[0].lastIndexOf("[")+1,-1))&&(_e=_e.slice(0,Ae.index)+"["+Le("a",Ae[0].length-2)+"]"+_e.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Ae=this.tokenizer.rules.inline.blockSkip.exec(_e))!=null;)_e=_e.slice(0,Ae.index)+"["+Le("a",Ae[0].length-2)+"]"+_e.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Ae=this.tokenizer.rules.inline.escapedEmSt.exec(_e))!=null;)_e=_e.slice(0,Ae.index)+"++"+_e.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;ce;){if(Ue||(Ge=""),Ue=!1,j=this.tokenizer.escape(ce)){ce=ce.substring(j.raw.length),ue.push(j);continue}if(j=this.tokenizer.tag(ce,pe,be)){ce=ce.substring(j.raw.length),pe=j.inLink,be=j.inRawBlock;var Qe=ue[ue.length-1];Qe&&j.type==="text"&&Qe.type==="text"?(Qe.raw+=j.raw,Qe.text+=j.text):ue.push(j);continue}if(j=this.tokenizer.link(ce)){ce=ce.substring(j.raw.length),j.type==="link"&&(j.tokens=this.inlineTokens(j.text,[],!0,be)),ue.push(j);continue}if(j=this.tokenizer.reflink(ce,this.tokens.links)){ce=ce.substring(j.raw.length);var Je=ue[ue.length-1];j.type==="link"?(j.tokens=this.inlineTokens(j.text,[],!0,be),ue.push(j)):Je&&j.type==="text"&&Je.type==="text"?(Je.raw+=j.raw,Je.text+=j.text):ue.push(j);continue}if(j=this.tokenizer.emStrong(ce,_e,Ge)){ce=ce.substring(j.raw.length),j.tokens=this.inlineTokens(j.text,[],pe,be),ue.push(j);continue}if(j=this.tokenizer.codespan(ce)){ce=ce.substring(j.raw.length),ue.push(j);continue}if(j=this.tokenizer.br(ce)){ce=ce.substring(j.raw.length),ue.push(j);continue}if(j=this.tokenizer.del(ce)){ce=ce.substring(j.raw.length),j.tokens=this.inlineTokens(j.text,[],pe,be),ue.push(j);continue}if(j=this.tokenizer.autolink(ce,We)){ce=ce.substring(j.raw.length),ue.push(j);continue}if(!pe&&(j=this.tokenizer.url(ce,We))){ce=ce.substring(j.raw.length),ue.push(j);continue}if(j=this.tokenizer.inlineText(ce,be,qe)){ce=ce.substring(j.raw.length),j.raw.slice(-1)!=="_"&&(Ge=j.raw.slice(-1)),Ue=!0,we=ue[ue.length-1],we&&we.type==="text"?(we.raw+=j.raw,we.text+=j.text):ue.push(j);continue}if(ce){var ct="Infinite loop on byte: "+ce.charCodeAt(0);if(this.options.silent){console.error(ct);break}else throw new Error(ct)}}return ue},e(Ce,null,[{key:"rules",get:function(){return{block:ye,inline:Ie}}}]),Ce}(),W=T.defaults,Z=L.cleanUrl,ne=L.escape,le=function(){function Ce(Te){this.options=Te||W}var De=Ce.prototype;return De.code=function(ce,ue,pe){var be=(ue||"").match(/\S*/)[0];if(this.options.highlight){var j=this.options.highlight(ce,be);j!=null&&j!==ce&&(pe=!0,ce=j)}return ce=ce.replace(/\n$/,"")+`
`,be?'<pre><code class="'+this.options.langPrefix+ne(be,!0)+'">'+(pe?ce:ne(ce,!0))+`</code></pre>
`:"<pre><code>"+(pe?ce:ne(ce,!0))+`</code></pre>
`},De.blockquote=function(ce){return`<blockquote>
`+ce+`</blockquote>
`},De.html=function(ce){return ce},De.heading=function(ce,ue,pe,be){return this.options.headerIds?"<h"+ue+' id="'+this.options.headerPrefix+be.slug(pe)+'">'+ce+"</h"+ue+`>
`:"<h"+ue+">"+ce+"</h"+ue+`>
`},De.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},De.list=function(ce,ue,pe){var be=ue?"ol":"ul",j=ue&&pe!==1?' start="'+pe+'"':"";return"<"+be+j+`>
`+ce+"</"+be+`>
`},De.listitem=function(ce){return"<li>"+ce+`</li>
`},De.checkbox=function(ce){return"<input "+(ce?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},De.paragraph=function(ce){return"<p>"+ce+`</p>
`},De.table=function(ce,ue){return ue&&(ue="<tbody>"+ue+"</tbody>"),`<table>
<thead>
`+ce+`</thead>
`+ue+`</table>
`},De.tablerow=function(ce){return`<tr>
`+ce+`</tr>
`},De.tablecell=function(ce,ue){var pe=ue.header?"th":"td",be=ue.align?"<"+pe+' align="'+ue.align+'">':"<"+pe+">";return be+ce+"</"+pe+`>
`},De.strong=function(ce){return"<strong>"+ce+"</strong>"},De.em=function(ce){return"<em>"+ce+"</em>"},De.codespan=function(ce){return"<code>"+ce+"</code>"},De.br=function(){return this.options.xhtml?"<br/>":"<br>"},De.del=function(ce){return"<del>"+ce+"</del>"},De.link=function(ce,ue,pe){if(ce=Z(this.options.sanitize,this.options.baseUrl,ce),ce===null)return pe;var be='<a href="'+ne(ce)+'"';return ue&&(be+=' title="'+ue+'"'),be+=">"+pe+"</a>",be},De.image=function(ce,ue,pe){if(ce=Z(this.options.sanitize,this.options.baseUrl,ce),ce===null)return pe;var be='<img src="'+ce+'" alt="'+pe+'"';return ue&&(be+=' title="'+ue+'"'),be+=this.options.xhtml?"/>":">",be},De.text=function(ce){return ce},Ce}(),Y=function(){function Ce(){}var De=Ce.prototype;return De.strong=function(ce){return ce},De.em=function(ce){return ce},De.codespan=function(ce){return ce},De.del=function(ce){return ce},De.html=function(ce){return ce},De.text=function(ce){return ce},De.link=function(ce,ue,pe){return""+pe},De.image=function(ce,ue,pe){return""+pe},De.br=function(){return""},Ce}(),ae=function(){function Ce(){this.seen={}}var De=Ce.prototype;return De.serialize=function(ce){return ce.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},De.getNextSafeSlug=function(ce,ue){var pe=ce,be=0;if(this.seen.hasOwnProperty(pe)){be=this.seen[ce];do be++,pe=ce+"-"+be;while(this.seen.hasOwnProperty(pe))}return ue||(this.seen[ce]=be,this.seen[pe]=0),pe},De.slug=function(ce,ue){ue===void 0&&(ue={});var pe=this.serialize(ce);return this.getNextSafeSlug(pe,ue.dryrun)},Ce}(),ve=T.defaults,Me=L.unescape,ze=function(){function Ce(Te){this.options=Te||ve,this.options.renderer=this.options.renderer||new le,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new Y,this.slugger=new ae}Ce.parse=function(ce,ue){var pe=new Ce(ue);return pe.parse(ce)},Ce.parseInline=function(ce,ue){var pe=new Ce(ue);return pe.parseInline(ce)};var De=Ce.prototype;return De.parse=function(ce,ue){ue===void 0&&(ue=!0);var pe="",be,j,we,_e,Ae,Ue,Ge,Ze,Qe,Je,ct,mt,bt,ot,at,Se,Pe,te,Q=ce.length;for(be=0;be<Q;be++)switch(Je=ce[be],Je.type){case"space":continue;case"hr":{pe+=this.renderer.hr();continue}case"heading":{pe+=this.renderer.heading(this.parseInline(Je.tokens),Je.depth,Me(this.parseInline(Je.tokens,this.textRenderer)),this.slugger);continue}case"code":{pe+=this.renderer.code(Je.text,Je.lang,Je.escaped);continue}case"table":{for(Ze="",Ge="",_e=Je.header.length,j=0;j<_e;j++)Ge+=this.renderer.tablecell(this.parseInline(Je.tokens.header[j]),{header:!0,align:Je.align[j]});for(Ze+=this.renderer.tablerow(Ge),Qe="",_e=Je.cells.length,j=0;j<_e;j++){for(Ue=Je.tokens.cells[j],Ge="",Ae=Ue.length,we=0;we<Ae;we++)Ge+=this.renderer.tablecell(this.parseInline(Ue[we]),{header:!1,align:Je.align[we]});Qe+=this.renderer.tablerow(Ge)}pe+=this.renderer.table(Ze,Qe);continue}case"blockquote":{Qe=this.parse(Je.tokens),pe+=this.renderer.blockquote(Qe);continue}case"list":{for(ct=Je.ordered,mt=Je.start,bt=Je.loose,_e=Je.items.length,Qe="",j=0;j<_e;j++)at=Je.items[j],Se=at.checked,Pe=at.task,ot="",at.task&&(te=this.renderer.checkbox(Se),bt?at.tokens.length>0&&at.tokens[0].type==="text"?(at.tokens[0].text=te+" "+at.tokens[0].text,at.tokens[0].tokens&&at.tokens[0].tokens.length>0&&at.tokens[0].tokens[0].type==="text"&&(at.tokens[0].tokens[0].text=te+" "+at.tokens[0].tokens[0].text)):at.tokens.unshift({type:"text",text:te}):ot+=te),ot+=this.parse(at.tokens,bt),Qe+=this.renderer.listitem(ot,Pe,Se);pe+=this.renderer.list(Qe,ct,mt);continue}case"html":{pe+=this.renderer.html(Je.text);continue}case"paragraph":{pe+=this.renderer.paragraph(this.parseInline(Je.tokens));continue}case"text":{for(Qe=Je.tokens?this.parseInline(Je.tokens):Je.text;be+1<Q&&ce[be+1].type==="text";)Je=ce[++be],Qe+=`
`+(Je.tokens?this.parseInline(Je.tokens):Je.text);pe+=ue?this.renderer.paragraph(Qe):Qe;continue}default:{var Oe='Token with "'+Je.type+'" type was not found.';if(this.options.silent){console.error(Oe);return}else throw new Error(Oe)}}return pe},De.parseInline=function(ce,ue){ue=ue||this.renderer;var pe="",be,j,we=ce.length;for(be=0;be<we;be++)switch(j=ce[be],j.type){case"escape":{pe+=ue.text(j.text);break}case"html":{pe+=ue.html(j.text);break}case"link":{pe+=ue.link(j.href,j.title,this.parseInline(j.tokens,ue));break}case"image":{pe+=ue.image(j.href,j.title,j.text);break}case"strong":{pe+=ue.strong(this.parseInline(j.tokens,ue));break}case"em":{pe+=ue.em(this.parseInline(j.tokens,ue));break}case"codespan":{pe+=ue.codespan(j.text);break}case"br":{pe+=ue.br();break}case"del":{pe+=ue.del(this.parseInline(j.tokens,ue));break}case"text":{pe+=ue.text(j.text);break}default:{var _e='Token with "'+j.type+'" type was not found.';if(this.options.silent){console.error(_e);return}else throw new Error(_e)}}return pe},Ce}(),Ee=L.merge,Ye=L.checkSanitizeDeprecation,X=L.escape,se=T.getDefaults,fe=T.changeDefaults,xe=T.defaults;function Be(Ce,De,Te){if(typeof Ce=="undefined"||Ce===null)throw new Error("marked(): input parameter is undefined or null");if(typeof Ce!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(Ce)+", string expected");if(typeof De=="function"&&(Te=De,De=null),De=Ee({},Be.defaults,De||{}),Ye(De),Te){var ce=De.highlight,ue;try{ue=je.lex(Ce,De)}catch(we){return Te(we)}var pe=function(_e){var Ae;if(!_e)try{Ae=ze.parse(ue,De)}catch(Ue){_e=Ue}return De.highlight=ce,_e?Te(_e):Te(null,Ae)};if(!ce||ce.length<3||(delete De.highlight,!ue.length))return pe();var be=0;Be.walkTokens(ue,function(we){we.type==="code"&&(be++,setTimeout(function(){ce(we.text,we.lang,function(_e,Ae){if(_e)return pe(_e);Ae!=null&&Ae!==we.text&&(we.text=Ae,we.escaped=!0),be--,be===0&&pe()})},0))}),be===0&&pe();return}try{var j=je.lex(Ce,De);return De.walkTokens&&Be.walkTokens(j,De.walkTokens),ze.parse(j,De)}catch(we){if(we.message+=`
Please report this to https://github.com/markedjs/marked.`,De.silent)return"<p>An error occurred:</p><pre>"+X(we.message+"",!0)+"</pre>";throw we}}Be.options=Be.setOptions=function(Ce){return Ee(Be.defaults,Ce),fe(Be.defaults),Be},Be.getDefaults=se,Be.defaults=xe,Be.use=function(Ce){var De=Ee({},Ce);if(Ce.renderer&&function(){var ce=Be.defaults.renderer||new le,ue=function(j){var we=ce[j];ce[j]=function(){for(var _e=arguments.length,Ae=new Array(_e),Ue=0;Ue<_e;Ue++)Ae[Ue]=arguments[Ue];var Ge=Ce.renderer[j].apply(ce,Ae);return Ge===!1&&(Ge=we.apply(ce,Ae)),Ge}};for(var pe in Ce.renderer)ue(pe);De.renderer=ce}(),Ce.tokenizer&&function(){var ce=Be.defaults.tokenizer||new z,ue=function(j){var we=ce[j];ce[j]=function(){for(var _e=arguments.length,Ae=new Array(_e),Ue=0;Ue<_e;Ue++)Ae[Ue]=arguments[Ue];var Ge=Ce.tokenizer[j].apply(ce,Ae);return Ge===!1&&(Ge=we.apply(ce,Ae)),Ge}};for(var pe in Ce.tokenizer)ue(pe);De.tokenizer=ce}(),Ce.walkTokens){var Te=Be.defaults.walkTokens;De.walkTokens=function(ce){Ce.walkTokens(ce),Te&&Te(ce)}}Be.setOptions(De)},Be.walkTokens=function(Ce,De){for(var Te=k(Ce),ce;!(ce=Te()).done;){var ue=ce.value;switch(De(ue),ue.type){case"table":{for(var pe=k(ue.tokens.header),be;!(be=pe()).done;){var j=be.value;Be.walkTokens(j,De)}for(var we=k(ue.tokens.cells),_e;!(_e=we()).done;)for(var Ae=_e.value,Ue=k(Ae),Ge;!(Ge=Ue()).done;){var Ze=Ge.value;Be.walkTokens(Ze,De)}break}case"list":{Be.walkTokens(ue.items,De);break}default:ue.tokens&&Be.walkTokens(ue.tokens,De)}}},Be.parseInline=function(Ce,De){if(typeof Ce=="undefined"||Ce===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof Ce!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(Ce)+", string expected");De=Ee({},Be.defaults,De||{}),Ye(De);try{var Te=je.lexInline(Ce,De);return De.walkTokens&&Be.walkTokens(Te,De.walkTokens),ze.parseInline(Te,De)}catch(ce){if(ce.message+=`
Please report this to https://github.com/markedjs/marked.`,De.silent)return"<p>An error occurred:</p><pre>"+X(ce.message+"",!0)+"</pre>";throw ce}},Be.Parser=ze,Be.parser=ze.parse,Be.Renderer=le,Be.TextRenderer=Y,Be.Lexer=je,Be.lexer=je.lex,Be.Tokenizer=z,Be.Slugger=ae,Be.parse=Be;var et=Be;return et}),define(me[75],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function g(T,D,y){return Math.min(Math.max(T,D),y)}e.clamp=g;function R(T,D){return(D+T%D)%D}e.rot=R;class k{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=k;class S{constructor(){this._n=1,this._val=0}update(D){return this._val=this._val+(D-this._val)/this._n,this._n+=1,this}get value(){return this._val}}e.MovingAverage=S}),function(){function J(k){const S=[];typeof k=="number"&&S.push("code/timeOrigin",k);function T(y){S.push(y,Date.now())}function D(){const y=[];for(let A=0;A<S.length;A+=2)y.push({name:S[A],startTime:S[A+1]});return y}return{mark:T,getMarks:D}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?J():{mark(k){performance.mark(k)},getMarks(){let k=performance.timeOrigin;typeof k!="number"&&(k=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const S=[{name:"code/timeOrigin",startTime:Math.round(k)}];for(const T of performance.getEntriesByType("mark"))S.push({name:T.name,startTime:Math.round(k+T.startTime)});return S}};if(typeof process=="object"){const k=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return J(k)}else return console.trace("perf-util loaded in UNKNOWN environment"),J()}function g(k){return k.MonacoPerformanceMarks||(k.MonacoPerformanceMarks=e()),k.MonacoPerformanceMarks}var R;typeof global=="object"?R=global:typeof self=="object"?R=self:R={},typeof define=="function"?define("vs/base/common/performance",[],function(){return g(R)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=g(R):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),R.perf=g(R))}(),define(me[11],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setImmediate=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isPreferringBrowserCodeLoad=e.browserCodeLoadingCacheStrategy=e.isElectronSandboxed=e.globals=void 0;const g="en";let R=!1,k=!1,S=!1,T=!1,D=!1,y=!1,A=!1,i,C=g,u,m;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let l;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?l=e.globals.vscode.process:typeof process!="undefined"&&(l=process);const v=typeof l?.versions?.electron=="string"&&l.type==="renderer";if(e.isElectronSandboxed=v&&l?.sandboxed,e.browserCodeLoadingCacheStrategy=(()=>{if(e.isElectronSandboxed)return"bypassHeatCheck";const s=l?.env.VSCODE_BROWSER_CODE_LOADING;if(typeof s=="string")return s==="none"||s==="code"||s==="bypassHeatCheck"||s==="bypassHeatCheckAndEagerCompile"?s:"bypassHeatCheck"})(),e.isPreferringBrowserCodeLoad=typeof e.browserCodeLoadingCacheStrategy=="string",typeof navigator=="object"&&!v)m=navigator.userAgent,R=m.indexOf("Windows")>=0,k=m.indexOf("Macintosh")>=0,A=(m.indexOf("Macintosh")>=0||m.indexOf("iPad")>=0||m.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,S=m.indexOf("Linux")>=0,y=!0,i=navigator.language,C=i;else if(typeof l=="object"){R=l.platform==="win32",k=l.platform==="darwin",S=l.platform==="linux",T=S&&!!l.env.SNAP&&!!l.env.SNAP_REVISION,i=g,C=g;const s=l.env.VSCODE_NLS_CONFIG;if(s)try{const n=JSON.parse(s),a=n.availableLanguages["*"];i=n.locale,C=a||g,u=n._translationsConfigFile}catch(n){}D=!0}else console.error("Unable to resolve platform.");var _;(function(s){s[s.Web=0]="Web",s[s.Mac=1]="Mac",s[s.Linux=2]="Linux",s[s.Windows=3]="Windows"})(_=e.Platform||(e.Platform={}));function b(s){switch(s){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=b;let P=0;k?P=1:R?P=3:S&&(P=2),e.isWindows=R,e.isMacintosh=k,e.isLinux=S,e.isLinuxSnap=T,e.isNative=D,e.isWeb=y,e.isIOS=A,e.platform=P,e.userAgent=m,e.language=C;var c;(function(s){function n(){return e.language}s.value=n;function a(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}s.isDefaultVariant=a;function d(){return e.language==="en"}s.isDefault=d})(c=e.Language||(e.Language={})),e.locale=i,e.translationsConfigFile=u,e.setImmediate=function(){if(e.globals.setImmediate)return e.globals.setImmediate.bind(e.globals);if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let a=[];e.globals.addEventListener("message",f=>{if(f.data&&f.data.vscodeSetImmediateId)for(let w=0,E=a.length;w<E;w++){const o=a[w];if(o.id===f.data.vscodeSetImmediateId){a.splice(w,1),o.callback();return}}});let d=0;return f=>{const w=++d;a.push({id:w,callback:f}),e.globals.postMessage({vscodeSetImmediateId:w},"*")}}if(typeof l?.nextTick=="function")return l.nextTick.bind(l);const n=Promise.resolve();return a=>n.then(a)}();var h;(function(s){s[s.Windows=1]="Windows",s[s.Macintosh=2]="Macintosh",s[s.Linux=3]="Linux"})(h=e.OperatingSystem||(e.OperatingSystem={})),e.OS=k||A?2:R?1:3;let p=!0,t=!1;function r(){if(!t){t=!0;const s=new Uint8Array(2);s[0]=1,s[1]=2,p=new Uint16Array(s.buffer)[0]===(2<<8)+1}return p}e.isLittleEndian=r}),define(me[38],ge([0,1,11]),function(J,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nextTick=e.platform=e.env=e.cwd=void 0;let R;if(typeof g.globals.vscode!="undefined"&&typeof g.globals.vscode.process!="undefined"){const k=g.globals.vscode.process;R={get platform(){return k.platform},get env(){return k.env},cwd(){return k.cwd()},nextTick(S){return(0,g.setImmediate)(S)}}}else typeof process!="undefined"?R={get platform(){return process.platform},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()},nextTick(k){return process.nextTick(k)}}:R={get platform(){return g.isWindows?"win32":g.isMacintosh?"darwin":"linux"},nextTick(k){return(0,g.setImmediate)(k)},get env(){return{}},cwd(){return"/"}};e.cwd=R.cwd,e.env=R.env,e.platform=R.platform,e.nextTick=R.nextTick}),define(me[9],ge([0,1,38]),function(J,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const R=65,k=97,S=90,T=122,D=46,y=47,A=92,i=58,C=63;class u extends Error{constructor(h,p,t){let r;typeof p=="string"&&p.indexOf("not ")===0?(r="must not be",p=p.replace(/^not /,"")):r="must be";const s=h.indexOf(".")!==-1?"property":"argument";let n=`The "${h}" ${s} ${r} of type ${p}`;n+=`. Received type ${typeof t}`,super(n),this.code="ERR_INVALID_ARG_TYPE"}}function m(c,h){if(typeof c!="string")throw new u(h,"string",c)}function l(c){return c===y||c===A}function v(c){return c===y}function _(c){return c>=R&&c<=S||c>=k&&c<=T}function b(c,h,p,t){let r="",s=0,n=-1,a=0,d=0;for(let f=0;f<=c.length;++f){if(f<c.length)d=c.charCodeAt(f);else{if(t(d))break;d=y}if(t(d)){if(!(n===f-1||a===1))if(a===2){if(r.length<2||s!==2||r.charCodeAt(r.length-1)!==D||r.charCodeAt(r.length-2)!==D){if(r.length>2){const w=r.lastIndexOf(p);w===-1?(r="",s=0):(r=r.slice(0,w),s=r.length-1-r.lastIndexOf(p)),n=f,a=0;continue}else if(r.length!==0){r="",s=0,n=f,a=0;continue}}h&&(r+=r.length>0?`${p}..`:"..",s=2)}else r.length>0?r+=`${p}${c.slice(n+1,f)}`:r=c.slice(n+1,f),s=f-n-1;n=f,a=0}else d===D&&a!==-1?++a:a=-1}return r}function P(c,h){if(h===null||typeof h!="object")throw new u("pathObject","Object",h);const p=h.dir||h.root,t=h.base||`${h.name||""}${h.ext||""}`;return p?p===h.root?`${p}${t}`:`${p}${c}${t}`:t}e.win32={resolve(...c){let h="",p="",t=!1;for(let r=c.length-1;r>=-1;r--){let s;if(r>=0){if(s=c[r],m(s,"path"),s.length===0)continue}else h.length===0?s=g.cwd():(s=g.env[`=${h}`]||g.cwd(),(s===void 0||s.slice(0,2).toLowerCase()!==h.toLowerCase()&&s.charCodeAt(2)===A)&&(s=`${h}\\`));const n=s.length;let a=0,d="",f=!1;const w=s.charCodeAt(0);if(n===1)l(w)&&(a=1,f=!0);else if(l(w))if(f=!0,l(s.charCodeAt(1))){let E=2,o=E;for(;E<n&&!l(s.charCodeAt(E));)E++;if(E<n&&E!==o){const I=s.slice(o,E);for(o=E;E<n&&l(s.charCodeAt(E));)E++;if(E<n&&E!==o){for(o=E;E<n&&!l(s.charCodeAt(E));)E++;(E===n||E!==o)&&(d=`\\\\${I}\\${s.slice(o,E)}`,a=E)}}}else a=1;else _(w)&&s.charCodeAt(1)===i&&(d=s.slice(0,2),a=2,n>2&&l(s.charCodeAt(2))&&(f=!0,a=3));if(d.length>0)if(h.length>0){if(d.toLowerCase()!==h.toLowerCase())continue}else h=d;if(t){if(h.length>0)break}else if(p=`${s.slice(a)}\\${p}`,t=f,f&&h.length>0)break}return p=b(p,!t,"\\",l),t?`${h}\\${p}`:`${h}${p}`||"."},normalize(c){m(c,"path");const h=c.length;if(h===0)return".";let p=0,t,r=!1;const s=c.charCodeAt(0);if(h===1)return v(s)?"\\":c;if(l(s))if(r=!0,l(c.charCodeAt(1))){let a=2,d=a;for(;a<h&&!l(c.charCodeAt(a));)a++;if(a<h&&a!==d){const f=c.slice(d,a);for(d=a;a<h&&l(c.charCodeAt(a));)a++;if(a<h&&a!==d){for(d=a;a<h&&!l(c.charCodeAt(a));)a++;if(a===h)return`\\\\${f}\\${c.slice(d)}\\`;a!==d&&(t=`\\\\${f}\\${c.slice(d,a)}`,p=a)}}}else p=1;else _(s)&&c.charCodeAt(1)===i&&(t=c.slice(0,2),p=2,h>2&&l(c.charCodeAt(2))&&(r=!0,p=3));let n=p<h?b(c.slice(p),!r,"\\",l):"";return n.length===0&&!r&&(n="."),n.length>0&&l(c.charCodeAt(h-1))&&(n+="\\"),t===void 0?r?`\\${n}`:n:r?`${t}\\${n}`:`${t}${n}`},isAbsolute(c){m(c,"path");const h=c.length;if(h===0)return!1;const p=c.charCodeAt(0);return l(p)||h>2&&_(p)&&c.charCodeAt(1)===i&&l(c.charCodeAt(2))},join(...c){if(c.length===0)return".";let h,p;for(let s=0;s<c.length;++s){const n=c[s];m(n,"path"),n.length>0&&(h===void 0?h=p=n:h+=`\\${n}`)}if(h===void 0)return".";let t=!0,r=0;if(typeof p=="string"&&l(p.charCodeAt(0))){++r;const s=p.length;s>1&&l(p.charCodeAt(1))&&(++r,s>2&&(l(p.charCodeAt(2))?++r:t=!1))}if(t){for(;r<h.length&&l(h.charCodeAt(r));)r++;r>=2&&(h=`\\${h.slice(r)}`)}return e.win32.normalize(h)},relative(c,h){if(m(c,"from"),m(h,"to"),c===h)return"";const p=e.win32.resolve(c),t=e.win32.resolve(h);if(p===t||(c=p.toLowerCase(),h=t.toLowerCase(),c===h))return"";let r=0;for(;r<c.length&&c.charCodeAt(r)===A;)r++;let s=c.length;for(;s-1>r&&c.charCodeAt(s-1)===A;)s--;const n=s-r;let a=0;for(;a<h.length&&h.charCodeAt(a)===A;)a++;let d=h.length;for(;d-1>a&&h.charCodeAt(d-1)===A;)d--;const f=d-a,w=n<f?n:f;let E=-1,o=0;for(;o<w;o++){const L=c.charCodeAt(r+o);if(L!==h.charCodeAt(a+o))break;L===A&&(E=o)}if(o!==w){if(E===-1)return t}else{if(f>w){if(h.charCodeAt(a+o)===A)return t.slice(a+o+1);if(o===2)return t.slice(a+o)}n>w&&(c.charCodeAt(r+o)===A?E=o:o===2&&(E=3)),E===-1&&(E=0)}let I="";for(o=r+E+1;o<=s;++o)(o===s||c.charCodeAt(o)===A)&&(I+=I.length===0?"..":"\\..");return a+=E,I.length>0?`${I}${t.slice(a,d)}`:(t.charCodeAt(a)===A&&++a,t.slice(a,d))},toNamespacedPath(c){if(typeof c!="string")return c;if(c.length===0)return"";const h=e.win32.resolve(c);if(h.length<=2)return c;if(h.charCodeAt(0)===A){if(h.charCodeAt(1)===A){const p=h.charCodeAt(2);if(p!==C&&p!==D)return`\\\\?\\UNC\\${h.slice(2)}`}}else if(_(h.charCodeAt(0))&&h.charCodeAt(1)===i&&h.charCodeAt(2)===A)return`\\\\?\\${h}`;return c},dirname(c){m(c,"path");const h=c.length;if(h===0)return".";let p=-1,t=0;const r=c.charCodeAt(0);if(h===1)return l(r)?c:".";if(l(r)){if(p=t=1,l(c.charCodeAt(1))){let a=2,d=a;for(;a<h&&!l(c.charCodeAt(a));)a++;if(a<h&&a!==d){for(d=a;a<h&&l(c.charCodeAt(a));)a++;if(a<h&&a!==d){for(d=a;a<h&&!l(c.charCodeAt(a));)a++;if(a===h)return c;a!==d&&(p=t=a+1)}}}}else _(r)&&c.charCodeAt(1)===i&&(p=h>2&&l(c.charCodeAt(2))?3:2,t=p);let s=-1,n=!0;for(let a=h-1;a>=t;--a)if(l(c.charCodeAt(a))){if(!n){s=a;break}}else n=!1;if(s===-1){if(p===-1)return".";s=p}return c.slice(0,s)},basename(c,h){h!==void 0&&m(h,"ext"),m(c,"path");let p=0,t=-1,r=!0,s;if(c.length>=2&&_(c.charCodeAt(0))&&c.charCodeAt(1)===i&&(p=2),h!==void 0&&h.length>0&&h.length<=c.length){if(h===c)return"";let n=h.length-1,a=-1;for(s=c.length-1;s>=p;--s){const d=c.charCodeAt(s);if(l(d)){if(!r){p=s+1;break}}else a===-1&&(r=!1,a=s+1),n>=0&&(d===h.charCodeAt(n)?--n==-1&&(t=s):(n=-1,t=a))}return p===t?t=a:t===-1&&(t=c.length),c.slice(p,t)}for(s=c.length-1;s>=p;--s)if(l(c.charCodeAt(s))){if(!r){p=s+1;break}}else t===-1&&(r=!1,t=s+1);return t===-1?"":c.slice(p,t)},extname(c){m(c,"path");let h=0,p=-1,t=0,r=-1,s=!0,n=0;c.length>=2&&c.charCodeAt(1)===i&&_(c.charCodeAt(0))&&(h=t=2);for(let a=c.length-1;a>=h;--a){const d=c.charCodeAt(a);if(l(d)){if(!s){t=a+1;break}continue}r===-1&&(s=!1,r=a+1),d===D?p===-1?p=a:n!==1&&(n=1):p!==-1&&(n=-1)}return p===-1||r===-1||n===0||n===1&&p===r-1&&p===t+1?"":c.slice(p,r)},format:P.bind(null,"\\"),parse(c){m(c,"path");const h={root:"",dir:"",base:"",ext:"",name:""};if(c.length===0)return h;const p=c.length;let t=0,r=c.charCodeAt(0);if(p===1)return l(r)?(h.root=h.dir=c,h):(h.base=h.name=c,h);if(l(r)){if(t=1,l(c.charCodeAt(1))){let E=2,o=E;for(;E<p&&!l(c.charCodeAt(E));)E++;if(E<p&&E!==o){for(o=E;E<p&&l(c.charCodeAt(E));)E++;if(E<p&&E!==o){for(o=E;E<p&&!l(c.charCodeAt(E));)E++;E===p?t=E:E!==o&&(t=E+1)}}}}else if(_(r)&&c.charCodeAt(1)===i){if(p<=2)return h.root=h.dir=c,h;if(t=2,l(c.charCodeAt(2))){if(p===3)return h.root=h.dir=c,h;t=3}}t>0&&(h.root=c.slice(0,t));let s=-1,n=t,a=-1,d=!0,f=c.length-1,w=0;for(;f>=t;--f){if(r=c.charCodeAt(f),l(r)){if(!d){n=f+1;break}continue}a===-1&&(d=!1,a=f+1),r===D?s===-1?s=f:w!==1&&(w=1):s!==-1&&(w=-1)}return a!==-1&&(s===-1||w===0||w===1&&s===a-1&&s===n+1?h.base=h.name=c.slice(n,a):(h.name=c.slice(n,s),h.base=c.slice(n,a),h.ext=c.slice(s,a))),n>0&&n!==t?h.dir=c.slice(0,n-1):h.dir=h.root,h},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...c){let h="",p=!1;for(let t=c.length-1;t>=-1&&!p;t--){const r=t>=0?c[t]:g.cwd();m(r,"path"),r.length!==0&&(h=`${r}/${h}`,p=r.charCodeAt(0)===y)}return h=b(h,!p,"/",v),p?`/${h}`:h.length>0?h:"."},normalize(c){if(m(c,"path"),c.length===0)return".";const h=c.charCodeAt(0)===y,p=c.charCodeAt(c.length-1)===y;return c=b(c,!h,"/",v),c.length===0?h?"/":p?"./":".":(p&&(c+="/"),h?`/${c}`:c)},isAbsolute(c){return m(c,"path"),c.length>0&&c.charCodeAt(0)===y},join(...c){if(c.length===0)return".";let h;for(let p=0;p<c.length;++p){const t=c[p];m(t,"path"),t.length>0&&(h===void 0?h=t:h+=`/${t}`)}return h===void 0?".":e.posix.normalize(h)},relative(c,h){if(m(c,"from"),m(h,"to"),c===h||(c=e.posix.resolve(c),h=e.posix.resolve(h),c===h))return"";const p=1,t=c.length,r=t-p,s=1,n=h.length-s,a=r<n?r:n;let d=-1,f=0;for(;f<a;f++){const E=c.charCodeAt(p+f);if(E!==h.charCodeAt(s+f))break;E===y&&(d=f)}if(f===a)if(n>a){if(h.charCodeAt(s+f)===y)return h.slice(s+f+1);if(f===0)return h.slice(s+f)}else r>a&&(c.charCodeAt(p+f)===y?d=f:f===0&&(d=0));let w="";for(f=p+d+1;f<=t;++f)(f===t||c.charCodeAt(f)===y)&&(w+=w.length===0?"..":"/..");return`${w}${h.slice(s+d)}`},toNamespacedPath(c){return c},dirname(c){if(m(c,"path"),c.length===0)return".";const h=c.charCodeAt(0)===y;let p=-1,t=!0;for(let r=c.length-1;r>=1;--r)if(c.charCodeAt(r)===y){if(!t){p=r;break}}else t=!1;return p===-1?h?"/":".":h&&p===1?"//":c.slice(0,p)},basename(c,h){h!==void 0&&m(h,"ext"),m(c,"path");let p=0,t=-1,r=!0,s;if(h!==void 0&&h.length>0&&h.length<=c.length){if(h===c)return"";let n=h.length-1,a=-1;for(s=c.length-1;s>=0;--s){const d=c.charCodeAt(s);if(d===y){if(!r){p=s+1;break}}else a===-1&&(r=!1,a=s+1),n>=0&&(d===h.charCodeAt(n)?--n==-1&&(t=s):(n=-1,t=a))}return p===t?t=a:t===-1&&(t=c.length),c.slice(p,t)}for(s=c.length-1;s>=0;--s)if(c.charCodeAt(s)===y){if(!r){p=s+1;break}}else t===-1&&(r=!1,t=s+1);return t===-1?"":c.slice(p,t)},extname(c){m(c,"path");let h=-1,p=0,t=-1,r=!0,s=0;for(let n=c.length-1;n>=0;--n){const a=c.charCodeAt(n);if(a===y){if(!r){p=n+1;break}continue}t===-1&&(r=!1,t=n+1),a===D?h===-1?h=n:s!==1&&(s=1):h!==-1&&(s=-1)}return h===-1||t===-1||s===0||s===1&&h===t-1&&h===p+1?"":c.slice(h,t)},format:P.bind(null,"/"),parse(c){m(c,"path");const h={root:"",dir:"",base:"",ext:"",name:""};if(c.length===0)return h;const p=c.charCodeAt(0)===y;let t;p?(h.root="/",t=1):t=0;let r=-1,s=0,n=-1,a=!0,d=c.length-1,f=0;for(;d>=t;--d){const w=c.charCodeAt(d);if(w===y){if(!a){s=d+1;break}continue}n===-1&&(a=!1,n=d+1),w===D?r===-1?r=d:f!==1&&(f=1):r!==-1&&(f=-1)}if(n!==-1){const w=s===0&&p?1:s;r===-1||f===0||f===1&&r===n-1&&r===s+1?h.base=h.name=c.slice(w,n):(h.name=c.slice(w,r),h.base=c.slice(w,n),h.ext=c.slice(r,n))}return s>0?h.dir=c.slice(0,s-1):p&&(h.dir="/"),h},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=g.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=g.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=g.platform==="win32"?e.win32.join:e.posix.join,e.resolve=g.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=g.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=g.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=g.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=g.platform==="win32"?e.win32.extname:e.posix.extname,e.format=g.platform==="win32"?e.win32.format:e.posix.format,e.parse=g.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=g.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=g.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=g.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(me[140],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var g;(function(S){S[S.stdout=0]="stdout",S[S.stderr=1]="stderr"})(g=e.Source||(e.Source={}));var R;(function(S){S[S.Success=0]="Success",S[S.Unknown=1]="Unknown",S[S.AccessDenied=2]="AccessDenied",S[S.ProcessNotFound=3]="ProcessNotFound"})(R=e.TerminateResponseCode||(e.TerminateResponseCode={}));function k(S,...T){const D=T.reduce((i,C)=>(i[C]=!0,i),{}),y=[/^ELECTRON_.+$/,/^VSCODE_.+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(S).filter(i=>!D[i]).forEach(i=>{for(let C=0;C<y.length;C++)if(i.search(y[C])!==-1){delete S[i];break}})}e.sanitizeProcessEnvironment=k}),define(me[46],ge([0,1,11]),function(J,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const R=g.globals.performance&&typeof g.globals.performance.now=="function";class k{constructor(T){this._highResolution=R&&T,this._startTime=this._now(),this._stopTime=-1}static create(T=!0){return new k(T)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?g.globals.performance.now():Date.now()}}e.StopWatch=k}),define(me[3],ge([0,1,15,72,6,95,46]),function(J,e,g,R,k,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var D;(function(c){c.None=()=>k.Disposable.None;function h(K){return(N,x=null,F)=>{let z=!1,M;return M=K(O=>{if(!z)return M?M.dispose():z=!0,N.call(x,O)},null,F),z&&M.dispose(),M}}c.once=h;function p(K,N){return d((x,F=null,z)=>K(M=>x.call(F,N(M)),null,z))}c.map=p;function t(K,N){return d((x,F=null,z)=>K(M=>{N(M),x.call(F,M)},null,z))}c.forEach=t;function r(K,N){return d((x,F=null,z)=>K(M=>N(M)&&x.call(F,M),null,z))}c.filter=r;function s(K){return K}c.signal=s;function n(...K){return(N,x=null,F)=>(0,k.combinedDisposable)(...K.map(z=>z(M=>N.call(x,M),null,F)))}c.any=n;function a(K,N,x){let F=x;return p(K,z=>(F=N(F,z),F))}c.reduce=a;function d(K){let N;const x=new u({onFirstListenerAdd(){N=K(x.fire,x)},onLastListenerRemove(){N.dispose()}});return x.event}function f(K,N,x=100,F=!1,z){let M,O,q,B=0;const G=new u({leakWarningThreshold:z,onFirstListenerAdd(){M=K(ie=>{B++,O=N(O,ie),F&&!q&&(G.fire(O),O=void 0),clearTimeout(q),q=setTimeout(()=>{const he=O;O=void 0,q=void 0,(!F||B>1)&&G.fire(he),B=0},x)})},onLastListenerRemove(){M.dispose()}});return G.event}c.debounce=f;function w(K,N=(x,F)=>x===F){let x=!0,F;return r(K,z=>{const M=x||!N(z,F);return x=!1,F=z,M})}c.latch=w;function E(K,N){return[c.filter(K,N),c.filter(K,x=>!N(x))]}c.split=E;function o(K,N=!1,x=[]){let F=x.slice(),z=K(q=>{F?F.push(q):O.fire(q)});const M=()=>{F&&F.forEach(q=>O.fire(q)),F=null},O=new u({onFirstListenerAdd(){z||(z=K(q=>O.fire(q)))},onFirstListenerDidAdd(){F&&(N?setTimeout(M):M())},onLastListenerRemove(){z&&z.dispose(),z=null}});return O.event}c.buffer=o;class I{constructor(N){this.event=N}map(N){return new I(p(this.event,N))}forEach(N){return new I(t(this.event,N))}filter(N){return new I(r(this.event,N))}reduce(N,x){return new I(a(this.event,N,x))}latch(){return new I(w(this.event))}debounce(N,x=100,F=!1,z){return new I(f(this.event,N,x,F,z))}on(N,x,F){return this.event(N,x,F)}once(N,x,F){return h(this.event)(N,x,F)}}function L(K){return new I(K)}c.chain=L;function U(K,N,x=F=>F){const F=(...q)=>O.fire(x(...q)),z=()=>K.on(N,F),M=()=>K.removeListener(N,F),O=new u({onFirstListenerAdd:z,onLastListenerRemove:M});return O.event}c.fromNodeEventEmitter=U;function V(K,N,x=F=>F){const F=(...q)=>O.fire(x(...q)),z=()=>K.addEventListener(N,F),M=()=>K.removeEventListener(N,F),O=new u({onFirstListenerAdd:z,onLastListenerRemove:M});return O.event}c.fromDOMEventEmitter=V;function ee(K){return new Promise(N=>h(K)(N))}c.toPromise=ee})(D=e.Event||(e.Event={}));class y{constructor(h){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${h}_${y._idPool++}`}start(h){this._stopWatch=new T.StopWatch(!0),this._listenerCount=h}stop(){if(this._stopWatch){const h=this._stopWatch.elapsed();this._elapsedOverall+=h,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${h.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}y._idPool=0;let A=-1;function i(c){const h=A;return A=c,{dispose(){A=h}}}e.setGlobalLeakWarningThreshold=i;class C{constructor(h,p=Math.random().toString(18).slice(2,5)){this.customThreshold=h,this.name=p,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(h){let p=A;if(typeof this.customThreshold=="number"&&(p=this.customThreshold),p<=0||h<p)return;this._stacks||(this._stacks=new Map);const t=new Error().stack.split(`
`).slice(3).join(`
`),r=this._stacks.get(t)||0;if(this._stacks.set(t,r+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=p*.5;let s,n=0;for(const[a,d]of this._stacks)(!s||n<d)&&(s=a,n=d);console.warn(`[${this.name}] potential listener LEAK detected, having ${h} listeners already. MOST frequent listener (${n}):`),console.warn(s)}return()=>{const s=this._stacks.get(t)||0;this._stacks.set(t,s-1)}}}class u{constructor(h){this._disposed=!1,this._options=h,this._leakageMon=A>0?new C(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new y(this._options._profName):void 0}get event(){return this._event||(this._event=(h,p,t)=>{this._listeners||(this._listeners=new S.LinkedList);const r=this._listeners.isEmpty();r&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const s=this._listeners.push(p?[h,p]:h);r&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,h,p);const n=this._leakageMon?.check(this._listeners.size),a=(0,k.toDisposable)(()=>{n&&n(),this._disposed||(s(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return t instanceof k.DisposableStore?t.add(a):Array.isArray(t)&&t.push(a),a}),this._event}fire(h){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new S.LinkedList);for(let p of this._listeners)this._deliveryQueue.push([p,h]);for(this._perfMon?.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[p,t]=this._deliveryQueue.shift();try{typeof p=="function"?p.call(void 0,t):p[0].call(p[1],t)}catch(r){(0,g.onUnexpectedError)(r)}}this._perfMon?.stop()}}dispose(){this._disposed||(this._disposed=!0,this._listeners?.clear(),this._deliveryQueue?.clear(),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose())}}e.Emitter=u;class m extends u{async fireAsync(h,p,t){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new S.LinkedList);for(const r of this._listeners)this._asyncDeliveryQueue.push([r,h]);for(;this._asyncDeliveryQueue.size>0&&!p.isCancellationRequested;){const[r,s]=this._asyncDeliveryQueue.shift(),n=[],a={...s,waitUntil:d=>{if(Object.isFrozen(n))throw new Error("waitUntil can NOT be called asynchronous");t&&(d=t(d,typeof r=="function"?r:r[0])),n.push(d)}};try{typeof r=="function"?r.call(void 0,a):r[0].call(r[1],a)}catch(d){(0,g.onUnexpectedError)(d);continue}Object.freeze(n),await Promise.allSettled(n).then(d=>{for(const f of d)f.status==="rejected"&&(0,g.onUnexpectedError)(f.reason)})}}}}e.AsyncEmitter=m;class l extends u{constructor(h){super(h);this._isPaused=0,this._eventQueue=new S.LinkedList,this._mergeFn=h?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const h=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(h))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(h){this._listeners&&(this._isPaused!==0?this._eventQueue.push(h):super.fire(h))}}e.PauseableEmitter=l;class v extends l{constructor(h){super(h);this._delay=h.delay??100}fire(h){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(h)}}e.DebounceEmitter=v;class _{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new u({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(h){const p={event:h,listener:null};this.events.push(p),this.hasListeners&&this.hook(p);const t=()=>{this.hasListeners&&this.unhook(p);const r=this.events.indexOf(p);this.events.splice(r,1)};return(0,k.toDisposable)((0,R.once)(t))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(h=>this.hook(h))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(h=>this.unhook(h))}hook(h){h.listener=h.event(p=>this.emitter.fire(p))}unhook(h){h.listener&&h.listener.dispose(),h.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=_;class b{constructor(){this.buffers=[]}wrapEvent(h){return(p,t,r)=>h(s=>{const n=this.buffers[this.buffers.length-1];n?n.push(()=>p.call(t,s)):p.call(t,s)},void 0,r)}bufferEvents(h){const p=[];this.buffers.push(p);const t=h();return this.buffers.pop(),p.forEach(r=>r()),t}}e.EventBufferer=b;class P{constructor(){this.listening=!1,this.inputEvent=D.None,this.inputEventListener=k.Disposable.None,this.emitter=new u({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(h){this.inputEvent=h,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=h(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=P}),define(me[21],ge([0,1,3]),function(J,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const R=Object.freeze(function(D,y){const A=setTimeout(D.bind(y),0);return{dispose(){clearTimeout(A)}}});var k;(function(D){function y(A){return A===D.None||A===D.Cancelled||A instanceof S?!0:!A||typeof A!="object"?!1:typeof A.isCancellationRequested=="boolean"&&typeof A.onCancellationRequested=="function"}D.isCancellationToken=y,D.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:g.Event.None}),D.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:R})})(k=e.CancellationToken||(e.CancellationToken={}));class S{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?R:(this._emitter||(this._emitter=new g.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class T{constructor(y){this._token=void 0,this._parentListener=void 0,this._parentListener=y&&y.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new S),this._token}cancel(){this._token?this._token instanceof S&&this._token.cancel():this._token=k.Cancelled}dispose(y=!1){y&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof S&&this._token.dispose():this._token=k.None}}e.CancellationTokenSource=T}),define(me[47],ge([0,1,3]),function(J,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=e.registerCodicon=e.iconRegistry=void 0;class R{constructor(){this._icons=new Map,this._onDidRegister=new g.Emitter}add(C){const u=this._icons.get(C.id);u?C.description?u.description=C.description:console.error(`Duplicate registration of codicon ${C.id}`):(this._icons.set(C.id,C),this._onDidRegister.fire(C))}get(C){return this._icons.get(C)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const k=new R;e.iconRegistry=k;function S(i,C){return new D(i,C)}e.registerCodicon=S;function T(i){return i?i.replace(/\$\((.*?)\)/g,(C,u)=>` ${u} `).trim():""}e.getCodiconAriaLabel=T;class D{constructor(C,u,m){this.id=C,this.definition=u,this.description=m,k.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=D;function y(i,C){const u=["codicon","codicon-"+i];return C&&u.push("codicon-modifier-"+C),u}e.getClassNamesArray=y;var A;(function(i){i.iconNameSegment="[A-Za-z0-9]+",i.iconNameExpression="[A-Za-z0-9\\-]+",i.iconModifierExpression="~[A-Za-z]+";const C=new RegExp(`^(${i.iconNameExpression})(${i.iconModifierExpression})?$`);function u(v){if(v instanceof D)return["codicon","codicon-"+v.id];const _=C.exec(v.id);if(!_)return u(D.error);let[,b,P]=_;const c=["codicon","codicon-"+b];return P&&c.push("codicon-modifier-"+P.substr(1)),c}i.asClassNameArray=u;function m(v){return u(v).join(" ")}i.asClassName=m;function l(v){return"."+u(v).join(".")}i.asCSSSelector=l})(A=e.CSSIcon||(e.CSSIcon={})),function(i){i.add=new i("add",{fontCharacter:"\\ea60"}),i.plus=new i("plus",{fontCharacter:"\\ea60"}),i.gistNew=new i("gist-new",{fontCharacter:"\\ea60"}),i.repoCreate=new i("repo-create",{fontCharacter:"\\ea60"}),i.lightbulb=new i("lightbulb",{fontCharacter:"\\ea61"}),i.lightBulb=new i("light-bulb",{fontCharacter:"\\ea61"}),i.repo=new i("repo",{fontCharacter:"\\ea62"}),i.repoDelete=new i("repo-delete",{fontCharacter:"\\ea62"}),i.gistFork=new i("gist-fork",{fontCharacter:"\\ea63"}),i.repoForked=new i("repo-forked",{fontCharacter:"\\ea63"}),i.gitPullRequest=new i("git-pull-request",{fontCharacter:"\\ea64"}),i.gitPullRequestAbandoned=new i("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),i.recordKeys=new i("record-keys",{fontCharacter:"\\ea65"}),i.keyboard=new i("keyboard",{fontCharacter:"\\ea65"}),i.tag=new i("tag",{fontCharacter:"\\ea66"}),i.tagAdd=new i("tag-add",{fontCharacter:"\\ea66"}),i.tagRemove=new i("tag-remove",{fontCharacter:"\\ea66"}),i.person=new i("person",{fontCharacter:"\\ea67"}),i.personFollow=new i("person-follow",{fontCharacter:"\\ea67"}),i.personOutline=new i("person-outline",{fontCharacter:"\\ea67"}),i.personFilled=new i("person-filled",{fontCharacter:"\\ea67"}),i.gitBranch=new i("git-branch",{fontCharacter:"\\ea68"}),i.gitBranchCreate=new i("git-branch-create",{fontCharacter:"\\ea68"}),i.gitBranchDelete=new i("git-branch-delete",{fontCharacter:"\\ea68"}),i.sourceControl=new i("source-control",{fontCharacter:"\\ea68"}),i.mirror=new i("mirror",{fontCharacter:"\\ea69"}),i.mirrorPublic=new i("mirror-public",{fontCharacter:"\\ea69"}),i.star=new i("star",{fontCharacter:"\\ea6a"}),i.starAdd=new i("star-add",{fontCharacter:"\\ea6a"}),i.starDelete=new i("star-delete",{fontCharacter:"\\ea6a"}),i.starEmpty=new i("star-empty",{fontCharacter:"\\ea6a"}),i.comment=new i("comment",{fontCharacter:"\\ea6b"}),i.commentAdd=new i("comment-add",{fontCharacter:"\\ea6b"}),i.alert=new i("alert",{fontCharacter:"\\ea6c"}),i.warning=new i("warning",{fontCharacter:"\\ea6c"}),i.search=new i("search",{fontCharacter:"\\ea6d"}),i.searchSave=new i("search-save",{fontCharacter:"\\ea6d"}),i.logOut=new i("log-out",{fontCharacter:"\\ea6e"}),i.signOut=new i("sign-out",{fontCharacter:"\\ea6e"}),i.logIn=new i("log-in",{fontCharacter:"\\ea6f"}),i.signIn=new i("sign-in",{fontCharacter:"\\ea6f"}),i.eye=new i("eye",{fontCharacter:"\\ea70"}),i.eyeUnwatch=new i("eye-unwatch",{fontCharacter:"\\ea70"}),i.eyeWatch=new i("eye-watch",{fontCharacter:"\\ea70"}),i.circleFilled=new i("circle-filled",{fontCharacter:"\\ea71"}),i.primitiveDot=new i("primitive-dot",{fontCharacter:"\\ea71"}),i.closeDirty=new i("close-dirty",{fontCharacter:"\\ea71"}),i.debugBreakpoint=new i("debug-breakpoint",{fontCharacter:"\\ea71"}),i.debugBreakpointDisabled=new i("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),i.debugHint=new i("debug-hint",{fontCharacter:"\\ea71"}),i.primitiveSquare=new i("primitive-square",{fontCharacter:"\\ea72"}),i.edit=new i("edit",{fontCharacter:"\\ea73"}),i.pencil=new i("pencil",{fontCharacter:"\\ea73"}),i.info=new i("info",{fontCharacter:"\\ea74"}),i.issueOpened=new i("issue-opened",{fontCharacter:"\\ea74"}),i.gistPrivate=new i("gist-private",{fontCharacter:"\\ea75"}),i.gitForkPrivate=new i("git-fork-private",{fontCharacter:"\\ea75"}),i.lock=new i("lock",{fontCharacter:"\\ea75"}),i.mirrorPrivate=new i("mirror-private",{fontCharacter:"\\ea75"}),i.close=new i("close",{fontCharacter:"\\ea76"}),i.removeClose=new i("remove-close",{fontCharacter:"\\ea76"}),i.x=new i("x",{fontCharacter:"\\ea76"}),i.repoSync=new i("repo-sync",{fontCharacter:"\\ea77"}),i.sync=new i("sync",{fontCharacter:"\\ea77"}),i.clone=new i("clone",{fontCharacter:"\\ea78"}),i.desktopDownload=new i("desktop-download",{fontCharacter:"\\ea78"}),i.beaker=new i("beaker",{fontCharacter:"\\ea79"}),i.microscope=new i("microscope",{fontCharacter:"\\ea79"}),i.vm=new i("vm",{fontCharacter:"\\ea7a"}),i.deviceDesktop=new i("device-desktop",{fontCharacter:"\\ea7a"}),i.file=new i("file",{fontCharacter:"\\ea7b"}),i.fileText=new i("file-text",{fontCharacter:"\\ea7b"}),i.more=new i("more",{fontCharacter:"\\ea7c"}),i.ellipsis=new i("ellipsis",{fontCharacter:"\\ea7c"}),i.kebabHorizontal=new i("kebab-horizontal",{fontCharacter:"\\ea7c"}),i.mailReply=new i("mail-reply",{fontCharacter:"\\ea7d"}),i.reply=new i("reply",{fontCharacter:"\\ea7d"}),i.organization=new i("organization",{fontCharacter:"\\ea7e"}),i.organizationFilled=new i("organization-filled",{fontCharacter:"\\ea7e"}),i.organizationOutline=new i("organization-outline",{fontCharacter:"\\ea7e"}),i.newFile=new i("new-file",{fontCharacter:"\\ea7f"}),i.fileAdd=new i("file-add",{fontCharacter:"\\ea7f"}),i.newFolder=new i("new-folder",{fontCharacter:"\\ea80"}),i.fileDirectoryCreate=new i("file-directory-create",{fontCharacter:"\\ea80"}),i.trash=new i("trash",{fontCharacter:"\\ea81"}),i.trashcan=new i("trashcan",{fontCharacter:"\\ea81"}),i.history=new i("history",{fontCharacter:"\\ea82"}),i.clock=new i("clock",{fontCharacter:"\\ea82"}),i.folder=new i("folder",{fontCharacter:"\\ea83"}),i.fileDirectory=new i("file-directory",{fontCharacter:"\\ea83"}),i.symbolFolder=new i("symbol-folder",{fontCharacter:"\\ea83"}),i.logoGithub=new i("logo-github",{fontCharacter:"\\ea84"}),i.markGithub=new i("mark-github",{fontCharacter:"\\ea84"}),i.github=new i("github",{fontCharacter:"\\ea84"}),i.terminal=new i("terminal",{fontCharacter:"\\ea85"}),i.console=new i("console",{fontCharacter:"\\ea85"}),i.repl=new i("repl",{fontCharacter:"\\ea85"}),i.zap=new i("zap",{fontCharacter:"\\ea86"}),i.symbolEvent=new i("symbol-event",{fontCharacter:"\\ea86"}),i.error=new i("error",{fontCharacter:"\\ea87"}),i.stop=new i("stop",{fontCharacter:"\\ea87"}),i.variable=new i("variable",{fontCharacter:"\\ea88"}),i.symbolVariable=new i("symbol-variable",{fontCharacter:"\\ea88"}),i.array=new i("array",{fontCharacter:"\\ea8a"}),i.symbolArray=new i("symbol-array",{fontCharacter:"\\ea8a"}),i.symbolModule=new i("symbol-module",{fontCharacter:"\\ea8b"}),i.symbolPackage=new i("symbol-package",{fontCharacter:"\\ea8b"}),i.symbolNamespace=new i("symbol-namespace",{fontCharacter:"\\ea8b"}),i.symbolObject=new i("symbol-object",{fontCharacter:"\\ea8b"}),i.symbolMethod=new i("symbol-method",{fontCharacter:"\\ea8c"}),i.symbolFunction=new i("symbol-function",{fontCharacter:"\\ea8c"}),i.symbolConstructor=new i("symbol-constructor",{fontCharacter:"\\ea8c"}),i.symbolBoolean=new i("symbol-boolean",{fontCharacter:"\\ea8f"}),i.symbolNull=new i("symbol-null",{fontCharacter:"\\ea8f"}),i.symbolNumeric=new i("symbol-numeric",{fontCharacter:"\\ea90"}),i.symbolNumber=new i("symbol-number",{fontCharacter:"\\ea90"}),i.symbolStructure=new i("symbol-structure",{fontCharacter:"\\ea91"}),i.symbolStruct=new i("symbol-struct",{fontCharacter:"\\ea91"}),i.symbolParameter=new i("symbol-parameter",{fontCharacter:"\\ea92"}),i.symbolTypeParameter=new i("symbol-type-parameter",{fontCharacter:"\\ea92"}),i.symbolKey=new i("symbol-key",{fontCharacter:"\\ea93"}),i.symbolText=new i("symbol-text",{fontCharacter:"\\ea93"}),i.symbolReference=new i("symbol-reference",{fontCharacter:"\\ea94"}),i.goToFile=new i("go-to-file",{fontCharacter:"\\ea94"}),i.symbolEnum=new i("symbol-enum",{fontCharacter:"\\ea95"}),i.symbolValue=new i("symbol-value",{fontCharacter:"\\ea95"}),i.symbolRuler=new i("symbol-ruler",{fontCharacter:"\\ea96"}),i.symbolUnit=new i("symbol-unit",{fontCharacter:"\\ea96"}),i.activateBreakpoints=new i("activate-breakpoints",{fontCharacter:"\\ea97"}),i.archive=new i("archive",{fontCharacter:"\\ea98"}),i.arrowBoth=new i("arrow-both",{fontCharacter:"\\ea99"}),i.arrowDown=new i("arrow-down",{fontCharacter:"\\ea9a"}),i.arrowLeft=new i("arrow-left",{fontCharacter:"\\ea9b"}),i.arrowRight=new i("arrow-right",{fontCharacter:"\\ea9c"}),i.arrowSmallDown=new i("arrow-small-down",{fontCharacter:"\\ea9d"}),i.arrowSmallLeft=new i("arrow-small-left",{fontCharacter:"\\ea9e"}),i.arrowSmallRight=new i("arrow-small-right",{fontCharacter:"\\ea9f"}),i.arrowSmallUp=new i("arrow-small-up",{fontCharacter:"\\eaa0"}),i.arrowUp=new i("arrow-up",{fontCharacter:"\\eaa1"}),i.bell=new i("bell",{fontCharacter:"\\eaa2"}),i.bold=new i("bold",{fontCharacter:"\\eaa3"}),i.book=new i("book",{fontCharacter:"\\eaa4"}),i.bookmark=new i("bookmark",{fontCharacter:"\\eaa5"}),i.debugBreakpointConditionalUnverified=new i("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),i.debugBreakpointConditional=new i("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),i.debugBreakpointConditionalDisabled=new i("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),i.debugBreakpointDataUnverified=new i("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),i.debugBreakpointData=new i("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),i.debugBreakpointDataDisabled=new i("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),i.debugBreakpointLogUnverified=new i("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),i.debugBreakpointLog=new i("debug-breakpoint-log",{fontCharacter:"\\eaab"}),i.debugBreakpointLogDisabled=new i("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),i.briefcase=new i("briefcase",{fontCharacter:"\\eaac"}),i.broadcast=new i("broadcast",{fontCharacter:"\\eaad"}),i.browser=new i("browser",{fontCharacter:"\\eaae"}),i.bug=new i("bug",{fontCharacter:"\\eaaf"}),i.calendar=new i("calendar",{fontCharacter:"\\eab0"}),i.caseSensitive=new i("case-sensitive",{fontCharacter:"\\eab1"}),i.check=new i("check",{fontCharacter:"\\eab2"}),i.checklist=new i("checklist",{fontCharacter:"\\eab3"}),i.chevronDown=new i("chevron-down",{fontCharacter:"\\eab4"}),i.chevronLeft=new i("chevron-left",{fontCharacter:"\\eab5"}),i.chevronRight=new i("chevron-right",{fontCharacter:"\\eab6"}),i.chevronUp=new i("chevron-up",{fontCharacter:"\\eab7"}),i.chromeClose=new i("chrome-close",{fontCharacter:"\\eab8"}),i.chromeMaximize=new i("chrome-maximize",{fontCharacter:"\\eab9"}),i.chromeMinimize=new i("chrome-minimize",{fontCharacter:"\\eaba"}),i.chromeRestore=new i("chrome-restore",{fontCharacter:"\\eabb"}),i.circleOutline=new i("circle-outline",{fontCharacter:"\\eabc"}),i.debugBreakpointUnverified=new i("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),i.circleSlash=new i("circle-slash",{fontCharacter:"\\eabd"}),i.circuitBoard=new i("circuit-board",{fontCharacter:"\\eabe"}),i.clearAll=new i("clear-all",{fontCharacter:"\\eabf"}),i.clippy=new i("clippy",{fontCharacter:"\\eac0"}),i.closeAll=new i("close-all",{fontCharacter:"\\eac1"}),i.cloudDownload=new i("cloud-download",{fontCharacter:"\\eac2"}),i.cloudUpload=new i("cloud-upload",{fontCharacter:"\\eac3"}),i.code=new i("code",{fontCharacter:"\\eac4"}),i.collapseAll=new i("collapse-all",{fontCharacter:"\\eac5"}),i.colorMode=new i("color-mode",{fontCharacter:"\\eac6"}),i.commentDiscussion=new i("comment-discussion",{fontCharacter:"\\eac7"}),i.compareChanges=new i("compare-changes",{fontCharacter:"\\eafd"}),i.creditCard=new i("credit-card",{fontCharacter:"\\eac9"}),i.dash=new i("dash",{fontCharacter:"\\eacc"}),i.dashboard=new i("dashboard",{fontCharacter:"\\eacd"}),i.database=new i("database",{fontCharacter:"\\eace"}),i.debugContinue=new i("debug-continue",{fontCharacter:"\\eacf"}),i.debugDisconnect=new i("debug-disconnect",{fontCharacter:"\\ead0"}),i.debugPause=new i("debug-pause",{fontCharacter:"\\ead1"}),i.debugRestart=new i("debug-restart",{fontCharacter:"\\ead2"}),i.debugStart=new i("debug-start",{fontCharacter:"\\ead3"}),i.debugStepInto=new i("debug-step-into",{fontCharacter:"\\ead4"}),i.debugStepOut=new i("debug-step-out",{fontCharacter:"\\ead5"}),i.debugStepOver=new i("debug-step-over",{fontCharacter:"\\ead6"}),i.debugStop=new i("debug-stop",{fontCharacter:"\\ead7"}),i.debug=new i("debug",{fontCharacter:"\\ead8"}),i.deviceCameraVideo=new i("device-camera-video",{fontCharacter:"\\ead9"}),i.deviceCamera=new i("device-camera",{fontCharacter:"\\eada"}),i.deviceMobile=new i("device-mobile",{fontCharacter:"\\eadb"}),i.diffAdded=new i("diff-added",{fontCharacter:"\\eadc"}),i.diffIgnored=new i("diff-ignored",{fontCharacter:"\\eadd"}),i.diffModified=new i("diff-modified",{fontCharacter:"\\eade"}),i.diffRemoved=new i("diff-removed",{fontCharacter:"\\eadf"}),i.diffRenamed=new i("diff-renamed",{fontCharacter:"\\eae0"}),i.diff=new i("diff",{fontCharacter:"\\eae1"}),i.discard=new i("discard",{fontCharacter:"\\eae2"}),i.editorLayout=new i("editor-layout",{fontCharacter:"\\eae3"}),i.emptyWindow=new i("empty-window",{fontCharacter:"\\eae4"}),i.exclude=new i("exclude",{fontCharacter:"\\eae5"}),i.extensions=new i("extensions",{fontCharacter:"\\eae6"}),i.eyeClosed=new i("eye-closed",{fontCharacter:"\\eae7"}),i.fileBinary=new i("file-binary",{fontCharacter:"\\eae8"}),i.fileCode=new i("file-code",{fontCharacter:"\\eae9"}),i.fileMedia=new i("file-media",{fontCharacter:"\\eaea"}),i.filePdf=new i("file-pdf",{fontCharacter:"\\eaeb"}),i.fileSubmodule=new i("file-submodule",{fontCharacter:"\\eaec"}),i.fileSymlinkDirectory=new i("file-symlink-directory",{fontCharacter:"\\eaed"}),i.fileSymlinkFile=new i("file-symlink-file",{fontCharacter:"\\eaee"}),i.fileZip=new i("file-zip",{fontCharacter:"\\eaef"}),i.files=new i("files",{fontCharacter:"\\eaf0"}),i.filter=new i("filter",{fontCharacter:"\\eaf1"}),i.flame=new i("flame",{fontCharacter:"\\eaf2"}),i.foldDown=new i("fold-down",{fontCharacter:"\\eaf3"}),i.foldUp=new i("fold-up",{fontCharacter:"\\eaf4"}),i.fold=new i("fold",{fontCharacter:"\\eaf5"}),i.folderActive=new i("folder-active",{fontCharacter:"\\eaf6"}),i.folderOpened=new i("folder-opened",{fontCharacter:"\\eaf7"}),i.gear=new i("gear",{fontCharacter:"\\eaf8"}),i.gift=new i("gift",{fontCharacter:"\\eaf9"}),i.gistSecret=new i("gist-secret",{fontCharacter:"\\eafa"}),i.gist=new i("gist",{fontCharacter:"\\eafb"}),i.gitCommit=new i("git-commit",{fontCharacter:"\\eafc"}),i.gitCompare=new i("git-compare",{fontCharacter:"\\eafd"}),i.gitMerge=new i("git-merge",{fontCharacter:"\\eafe"}),i.githubAction=new i("github-action",{fontCharacter:"\\eaff"}),i.githubAlt=new i("github-alt",{fontCharacter:"\\eb00"}),i.globe=new i("globe",{fontCharacter:"\\eb01"}),i.grabber=new i("grabber",{fontCharacter:"\\eb02"}),i.graph=new i("graph",{fontCharacter:"\\eb03"}),i.gripper=new i("gripper",{fontCharacter:"\\eb04"}),i.heart=new i("heart",{fontCharacter:"\\eb05"}),i.home=new i("home",{fontCharacter:"\\eb06"}),i.horizontalRule=new i("horizontal-rule",{fontCharacter:"\\eb07"}),i.hubot=new i("hubot",{fontCharacter:"\\eb08"}),i.inbox=new i("inbox",{fontCharacter:"\\eb09"}),i.issueClosed=new i("issue-closed",{fontCharacter:"\\eba4"}),i.issueReopened=new i("issue-reopened",{fontCharacter:"\\eb0b"}),i.issues=new i("issues",{fontCharacter:"\\eb0c"}),i.italic=new i("italic",{fontCharacter:"\\eb0d"}),i.jersey=new i("jersey",{fontCharacter:"\\eb0e"}),i.json=new i("json",{fontCharacter:"\\eb0f"}),i.kebabVertical=new i("kebab-vertical",{fontCharacter:"\\eb10"}),i.key=new i("key",{fontCharacter:"\\eb11"}),i.law=new i("law",{fontCharacter:"\\eb12"}),i.lightbulbAutofix=new i("lightbulb-autofix",{fontCharacter:"\\eb13"}),i.linkExternal=new i("link-external",{fontCharacter:"\\eb14"}),i.link=new i("link",{fontCharacter:"\\eb15"}),i.listOrdered=new i("list-ordered",{fontCharacter:"\\eb16"}),i.listUnordered=new i("list-unordered",{fontCharacter:"\\eb17"}),i.liveShare=new i("live-share",{fontCharacter:"\\eb18"}),i.loading=new i("loading",{fontCharacter:"\\eb19"}),i.location=new i("location",{fontCharacter:"\\eb1a"}),i.mailRead=new i("mail-read",{fontCharacter:"\\eb1b"}),i.mail=new i("mail",{fontCharacter:"\\eb1c"}),i.markdown=new i("markdown",{fontCharacter:"\\eb1d"}),i.megaphone=new i("megaphone",{fontCharacter:"\\eb1e"}),i.mention=new i("mention",{fontCharacter:"\\eb1f"}),i.milestone=new i("milestone",{fontCharacter:"\\eb20"}),i.mortarBoard=new i("mortar-board",{fontCharacter:"\\eb21"}),i.move=new i("move",{fontCharacter:"\\eb22"}),i.multipleWindows=new i("multiple-windows",{fontCharacter:"\\eb23"}),i.mute=new i("mute",{fontCharacter:"\\eb24"}),i.noNewline=new i("no-newline",{fontCharacter:"\\eb25"}),i.note=new i("note",{fontCharacter:"\\eb26"}),i.octoface=new i("octoface",{fontCharacter:"\\eb27"}),i.openPreview=new i("open-preview",{fontCharacter:"\\eb28"}),i.package_=new i("package",{fontCharacter:"\\eb29"}),i.paintcan=new i("paintcan",{fontCharacter:"\\eb2a"}),i.pin=new i("pin",{fontCharacter:"\\eb2b"}),i.play=new i("play",{fontCharacter:"\\eb2c"}),i.run=new i("run",{fontCharacter:"\\eb2c"}),i.plug=new i("plug",{fontCharacter:"\\eb2d"}),i.preserveCase=new i("preserve-case",{fontCharacter:"\\eb2e"}),i.preview=new i("preview",{fontCharacter:"\\eb2f"}),i.project=new i("project",{fontCharacter:"\\eb30"}),i.pulse=new i("pulse",{fontCharacter:"\\eb31"}),i.question=new i("question",{fontCharacter:"\\eb32"}),i.quote=new i("quote",{fontCharacter:"\\eb33"}),i.radioTower=new i("radio-tower",{fontCharacter:"\\eb34"}),i.reactions=new i("reactions",{fontCharacter:"\\eb35"}),i.references=new i("references",{fontCharacter:"\\eb36"}),i.refresh=new i("refresh",{fontCharacter:"\\eb37"}),i.regex=new i("regex",{fontCharacter:"\\eb38"}),i.remoteExplorer=new i("remote-explorer",{fontCharacter:"\\eb39"}),i.remote=new i("remote",{fontCharacter:"\\eb3a"}),i.remove=new i("remove",{fontCharacter:"\\eb3b"}),i.replaceAll=new i("replace-all",{fontCharacter:"\\eb3c"}),i.replace=new i("replace",{fontCharacter:"\\eb3d"}),i.repoClone=new i("repo-clone",{fontCharacter:"\\eb3e"}),i.repoForcePush=new i("repo-force-push",{fontCharacter:"\\eb3f"}),i.repoPull=new i("repo-pull",{fontCharacter:"\\eb40"}),i.repoPush=new i("repo-push",{fontCharacter:"\\eb41"}),i.report=new i("report",{fontCharacter:"\\eb42"}),i.requestChanges=new i("request-changes",{fontCharacter:"\\eb43"}),i.rocket=new i("rocket",{fontCharacter:"\\eb44"}),i.rootFolderOpened=new i("root-folder-opened",{fontCharacter:"\\eb45"}),i.rootFolder=new i("root-folder",{fontCharacter:"\\eb46"}),i.rss=new i("rss",{fontCharacter:"\\eb47"}),i.ruby=new i("ruby",{fontCharacter:"\\eb48"}),i.saveAll=new i("save-all",{fontCharacter:"\\eb49"}),i.saveAs=new i("save-as",{fontCharacter:"\\eb4a"}),i.save=new i("save",{fontCharacter:"\\eb4b"}),i.screenFull=new i("screen-full",{fontCharacter:"\\eb4c"}),i.screenNormal=new i("screen-normal",{fontCharacter:"\\eb4d"}),i.searchStop=new i("search-stop",{fontCharacter:"\\eb4e"}),i.server=new i("server",{fontCharacter:"\\eb50"}),i.settingsGear=new i("settings-gear",{fontCharacter:"\\eb51"}),i.settings=new i("settings",{fontCharacter:"\\eb52"}),i.shield=new i("shield",{fontCharacter:"\\eb53"}),i.smiley=new i("smiley",{fontCharacter:"\\eb54"}),i.sortPrecedence=new i("sort-precedence",{fontCharacter:"\\eb55"}),i.splitHorizontal=new i("split-horizontal",{fontCharacter:"\\eb56"}),i.splitVertical=new i("split-vertical",{fontCharacter:"\\eb57"}),i.squirrel=new i("squirrel",{fontCharacter:"\\eb58"}),i.starFull=new i("star-full",{fontCharacter:"\\eb59"}),i.starHalf=new i("star-half",{fontCharacter:"\\eb5a"}),i.symbolClass=new i("symbol-class",{fontCharacter:"\\eb5b"}),i.symbolColor=new i("symbol-color",{fontCharacter:"\\eb5c"}),i.symbolConstant=new i("symbol-constant",{fontCharacter:"\\eb5d"}),i.symbolEnumMember=new i("symbol-enum-member",{fontCharacter:"\\eb5e"}),i.symbolField=new i("symbol-field",{fontCharacter:"\\eb5f"}),i.symbolFile=new i("symbol-file",{fontCharacter:"\\eb60"}),i.symbolInterface=new i("symbol-interface",{fontCharacter:"\\eb61"}),i.symbolKeyword=new i("symbol-keyword",{fontCharacter:"\\eb62"}),i.symbolMisc=new i("symbol-misc",{fontCharacter:"\\eb63"}),i.symbolOperator=new i("symbol-operator",{fontCharacter:"\\eb64"}),i.symbolProperty=new i("symbol-property",{fontCharacter:"\\eb65"}),i.wrench=new i("wrench",{fontCharacter:"\\eb65"}),i.wrenchSubaction=new i("wrench-subaction",{fontCharacter:"\\eb65"}),i.symbolSnippet=new i("symbol-snippet",{fontCharacter:"\\eb66"}),i.tasklist=new i("tasklist",{fontCharacter:"\\eb67"}),i.telescope=new i("telescope",{fontCharacter:"\\eb68"}),i.textSize=new i("text-size",{fontCharacter:"\\eb69"}),i.threeBars=new i("three-bars",{fontCharacter:"\\eb6a"}),i.thumbsdown=new i("thumbsdown",{fontCharacter:"\\eb6b"}),i.thumbsup=new i("thumbsup",{fontCharacter:"\\eb6c"}),i.tools=new i("tools",{fontCharacter:"\\eb6d"}),i.triangleDown=new i("triangle-down",{fontCharacter:"\\eb6e"}),i.triangleLeft=new i("triangle-left",{fontCharacter:"\\eb6f"}),i.triangleRight=new i("triangle-right",{fontCharacter:"\\eb70"}),i.triangleUp=new i("triangle-up",{fontCharacter:"\\eb71"}),i.twitter=new i("twitter",{fontCharacter:"\\eb72"}),i.unfold=new i("unfold",{fontCharacter:"\\eb73"}),i.unlock=new i("unlock",{fontCharacter:"\\eb74"}),i.unmute=new i("unmute",{fontCharacter:"\\eb75"}),i.unverified=new i("unverified",{fontCharacter:"\\eb76"}),i.verified=new i("verified",{fontCharacter:"\\eb77"}),i.versions=new i("versions",{fontCharacter:"\\eb78"}),i.vmActive=new i("vm-active",{fontCharacter:"\\eb79"}),i.vmOutline=new i("vm-outline",{fontCharacter:"\\eb7a"}),i.vmRunning=new i("vm-running",{fontCharacter:"\\eb7b"}),i.watch=new i("watch",{fontCharacter:"\\eb7c"}),i.whitespace=new i("whitespace",{fontCharacter:"\\eb7d"}),i.wholeWord=new i("whole-word",{fontCharacter:"\\eb7e"}),i.window=new i("window",{fontCharacter:"\\eb7f"}),i.wordWrap=new i("word-wrap",{fontCharacter:"\\eb80"}),i.zoomIn=new i("zoom-in",{fontCharacter:"\\eb81"}),i.zoomOut=new i("zoom-out",{fontCharacter:"\\eb82"}),i.listFilter=new i("list-filter",{fontCharacter:"\\eb83"}),i.listFlat=new i("list-flat",{fontCharacter:"\\eb84"}),i.listSelection=new i("list-selection",{fontCharacter:"\\eb85"}),i.selection=new i("selection",{fontCharacter:"\\eb85"}),i.listTree=new i("list-tree",{fontCharacter:"\\eb86"}),i.debugBreakpointFunctionUnverified=new i("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),i.debugBreakpointFunction=new i("debug-breakpoint-function",{fontCharacter:"\\eb88"}),i.debugBreakpointFunctionDisabled=new i("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),i.debugStackframeActive=new i("debug-stackframe-active",{fontCharacter:"\\eb89"}),i.debugStackframeDot=new i("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),i.debugStackframe=new i("debug-stackframe",{fontCharacter:"\\eb8b"}),i.debugStackframeFocused=new i("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),i.debugBreakpointUnsupported=new i("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),i.symbolString=new i("symbol-string",{fontCharacter:"\\eb8d"}),i.debugReverseContinue=new i("debug-reverse-continue",{fontCharacter:"\\eb8e"}),i.debugStepBack=new i("debug-step-back",{fontCharacter:"\\eb8f"}),i.debugRestartFrame=new i("debug-restart-frame",{fontCharacter:"\\eb90"}),i.callIncoming=new i("call-incoming",{fontCharacter:"\\eb92"}),i.callOutgoing=new i("call-outgoing",{fontCharacter:"\\eb93"}),i.menu=new i("menu",{fontCharacter:"\\eb94"}),i.expandAll=new i("expand-all",{fontCharacter:"\\eb95"}),i.feedback=new i("feedback",{fontCharacter:"\\eb96"}),i.groupByRefType=new i("group-by-ref-type",{fontCharacter:"\\eb97"}),i.ungroupByRefType=new i("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),i.account=new i("account",{fontCharacter:"\\eb99"}),i.bellDot=new i("bell-dot",{fontCharacter:"\\eb9a"}),i.debugConsole=new i("debug-console",{fontCharacter:"\\eb9b"}),i.library=new i("library",{fontCharacter:"\\eb9c"}),i.output=new i("output",{fontCharacter:"\\eb9d"}),i.runAll=new i("run-all",{fontCharacter:"\\eb9e"}),i.syncIgnored=new i("sync-ignored",{fontCharacter:"\\eb9f"}),i.pinned=new i("pinned",{fontCharacter:"\\eba0"}),i.githubInverted=new i("github-inverted",{fontCharacter:"\\eba1"}),i.debugAlt=new i("debug-alt",{fontCharacter:"\\eb91"}),i.serverProcess=new i("server-process",{fontCharacter:"\\eba2"}),i.serverEnvironment=new i("server-environment",{fontCharacter:"\\eba3"}),i.pass=new i("pass",{fontCharacter:"\\eba4"}),i.stopCircle=new i("stop-circle",{fontCharacter:"\\eba5"}),i.playCircle=new i("play-circle",{fontCharacter:"\\eba6"}),i.record=new i("record",{fontCharacter:"\\eba7"}),i.debugAltSmall=new i("debug-alt-small",{fontCharacter:"\\eba8"}),i.vmConnect=new i("vm-connect",{fontCharacter:"\\eba9"}),i.cloud=new i("cloud",{fontCharacter:"\\ebaa"}),i.merge=new i("merge",{fontCharacter:"\\ebab"}),i.exportIcon=new i("export",{fontCharacter:"\\ebac"}),i.graphLeft=new i("graph-left",{fontCharacter:"\\ebad"}),i.magnet=new i("magnet",{fontCharacter:"\\ebae"}),i.notebook=new i("notebook",{fontCharacter:"\\ebaf"}),i.redo=new i("redo",{fontCharacter:"\\ebb0"}),i.checkAll=new i("check-all",{fontCharacter:"\\ebb1"}),i.pinnedDirty=new i("pinned-dirty",{fontCharacter:"\\ebb2"}),i.passFilled=new i("pass-filled",{fontCharacter:"\\ebb3"}),i.circleLargeFilled=new i("circle-large-filled",{fontCharacter:"\\ebb4"}),i.circleLargeOutline=new i("circle-large-outline",{fontCharacter:"\\ebb5"}),i.combine=new i("combine",{fontCharacter:"\\ebb6"}),i.gather=new i("gather",{fontCharacter:"\\ebb6"}),i.table=new i("table",{fontCharacter:"\\ebb7"}),i.variableGroup=new i("variable-group",{fontCharacter:"\\ebb8"}),i.typeHierarchy=new i("type-hierarchy",{fontCharacter:"\\ebb9"}),i.typeHierarchySub=new i("type-hierarchy-sub",{fontCharacter:"\\ebba"}),i.typeHierarchySuper=new i("type-hierarchy-super",{fontCharacter:"\\ebbb"}),i.gitPullRequestCreate=new i("git-pull-request-create",{fontCharacter:"\\ebbc"}),i.runAbove=new i("run-above",{fontCharacter:"\\ebbd"}),i.runBelow=new i("run-below",{fontCharacter:"\\ebbe"}),i.notebookTemplate=new i("notebook-template",{fontCharacter:"\\ebbf"}),i.debugRerun=new i("debug-rerun",{fontCharacter:"\\ebc0"}),i.workspaceTrusted=new i("workspace-trusted",{fontCharacter:"\\ebc1"}),i.workspaceUntrusted=new i("workspace-untrusted",{fontCharacter:"\\ebc2"}),i.workspaceUnspecified=new i("workspace-unspecified",{fontCharacter:"\\ebc3"}),i.terminalCmd=new i("terminal-cmd",{fontCharacter:"\\ebc4"}),i.terminalDebian=new i("terminal-debian",{fontCharacter:"\\ebc5"}),i.terminalLinux=new i("terminal-linux",{fontCharacter:"\\ebc6"}),i.terminalPowershell=new i("terminal-powershell",{fontCharacter:"\\ebc7"}),i.terminalTmux=new i("terminal-tmux",{fontCharacter:"\\ebc8"}),i.terminalUbuntu=new i("terminal-ubuntu",{fontCharacter:"\\ebc9"}),i.terminalBash=new i("terminal-bash",{fontCharacter:"\\ebca"}),i.arrowSwap=new i("arrow-swap",{fontCharacter:"\\ebcb"}),i.copy=new i("copy",{fontCharacter:"\\ebcc"}),i.personAdd=new i("person-add",{fontCharacter:"\\ebcd"}),i.filterFilled=new i("filter-filled",{fontCharacter:"\\ebce"}),i.wand=new i("wand",{fontCharacter:"\\ebcf"}),i.debugLineByLine=new i("debug-line-by-line",{fontCharacter:"\\ebd0"}),i.inspect=new i("inspect",{fontCharacter:"\\ebd1"}),i.layers=new i("layers",{fontCharacter:"\\ebd2"}),i.layersDot=new i("layers-dot",{fontCharacter:"\\ebd3"}),i.layersActive=new i("layers-active",{fontCharacter:"\\ebd4"}),i.compass=new i("compass",{fontCharacter:"\\ebd5"}),i.compassDot=new i("compass-dot",{fontCharacter:"\\ebd6"}),i.compassActive=new i("compass-active",{fontCharacter:"\\ebd7"}),i.azure=new i("azure",{fontCharacter:"\\ebd8"}),i.issueDraft=new i("issue-draft",{fontCharacter:"\\ebd9"}),i.gitPullRequestClosed=new i("git-pull-request-closed",{fontCharacter:"\\ebda"}),i.gitPullRequestDraft=new i("git-pull-request-draft",{fontCharacter:"\\ebdb"}),i.debugAll=new i("debug-all",{fontCharacter:"\\ebdc"}),i.debugCoverage=new i("debug-coverage",{fontCharacter:"\\ebdd"}),i.dropDownButton=new i("drop-down-button",i.chevronDown.definition)}(D=e.Codicon||(e.Codicon={}))}),define(me[96],ge([0,1,15,6]),function(J,e,g,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function k(c){const h=c;return h?[h.on,h.pause,h.resume,h.destroy].every(p=>typeof p=="function"):!1}e.isReadableStream=k;function S(c){const h=c;return h?k(h.stream)&&Array.isArray(h.buffer)&&typeof h.ended=="boolean":!1}e.isReadableBufferedStream=S;function T(c,h){return new D(c,h)}e.newWriteableStream=T;class D{constructor(h,p){this.reducer=h,this.options=p,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(h){if(!this.state.destroyed){if(this.state.flowing)this.emitData(h);else if(this.buffer.data.push(h),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(p=>this.pendingWritePromises.push(p))}}error(h){this.state.destroyed||(this.state.flowing?this.emitError(h):this.buffer.error.push(h))}end(h){this.state.destroyed||(typeof h!="undefined"&&this.write(h),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(h){this.listeners.data.slice(0).forEach(p=>p(h))}emitError(h){this.listeners.error.length===0?(0,g.onUnexpectedError)(h):this.listeners.error.slice(0).forEach(p=>p(h))}emitEnd(){this.listeners.end.slice(0).forEach(h=>h())}on(h,p){if(!this.state.destroyed)switch(h){case"data":this.listeners.data.push(p),this.resume();break;case"end":this.listeners.end.push(p),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(p),this.state.flowing&&this.flowErrors();break}}removeListener(h,p){if(this.state.destroyed)return;let t;switch(h){case"data":t=this.listeners.data;break;case"end":t=this.listeners.end;break;case"error":t=this.listeners.error;break}if(t){const r=t.indexOf(p);r>=0&&t.splice(r,1)}}flowData(){if(this.buffer.data.length>0){const h=this.reducer(this.buffer.data);this.emitData(h),this.buffer.data.length=0;const p=[...this.pendingWritePromises];this.pendingWritePromises.length=0,p.forEach(t=>t())}}flowErrors(){if(this.listeners.error.length>0){for(const h of this.buffer.error)this.emitError(h);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function y(c,h){const p=[];let t;for(;(t=c.read())!==null;)p.push(t);return h(p)}e.consumeReadable=y;function A(c,h,p){const t=[];let r;for(;(r=c.read())!==null&&t.length<p;)t.push(r);return r===null&&t.length>0?h(t):{read:()=>{if(t.length>0)return t.shift();if(typeof r!="undefined"){const s=r;return r=void 0,s}return c.read()}}}e.peekReadable=A;function i(c,h){return new Promise((p,t)=>{const r=[];C(c,{onData:s=>{h&&r.push(s)},onError:s=>{h?t(s):p(void 0)},onEnd:()=>{p(h?h(r):void 0)}})})}e.consumeStream=i;function C(c,h){c.on("error",p=>h.onError(p)),c.on("end",()=>h.onEnd()),c.on("data",p=>h.onData(p))}e.listenStream=C;function u(c,h){return new Promise((p,t)=>{const r=new R.DisposableStore,s=[],n=f=>{if(s.push(f),s.length>h)return r.dispose(),c.pause(),p({stream:c,buffer:s,ended:!1})},a=f=>t(f),d=()=>p({stream:c,buffer:s,ended:!0});r.add((0,R.toDisposable)(()=>c.removeListener("error",a))),c.on("error",a),r.add((0,R.toDisposable)(()=>c.removeListener("end",d))),c.on("end",d),r.add((0,R.toDisposable)(()=>c.removeListener("data",n))),c.on("data",n)})}e.peekStream=u;function m(c,h){const p=T(h);return p.end(c),p}e.toStream=m;function l(){const c=T(()=>{throw new Error("not supported")});return c.end(),c}e.emptyStream=l;function v(c){let h=!1;return{read:()=>h?null:(h=!0,c)}}e.toReadable=v;function _(c,h,p){const t=T(p);return C(c,{onData:r=>t.write(h.data(r)),onError:r=>t.error(h.error?h.error(r):r),onEnd:()=>t.end()}),t}e.transform=_;function b(c,h,p){let t=!1;return{read:()=>{const r=h.read();return t?r:(t=!0,r!==null?p([c,r]):c)}}}e.prefixedReadable=b;function P(c,h,p){let t=!1;const r=T(p);return C(h,{onData:s=>t?r.write(s):(t=!0,r.write(p([c,s]))),onError:s=>r.error(s),onEnd:()=>{t||(t=!0,r.write(c)),r.end()}}),r}e.prefixedStream=P}),define(me[8],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLeftDeleteOffset=e.GraphemeBreakType=e.breakBetweenGraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsEmoji=e.containsRTL=e.decodeUTF8=e.encodeUTF8=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function g(j){return!j||typeof j!="string"?!0:j.trim().length===0}e.isFalsyOrWhitespace=g;const R=/{(\d+)}/g;function k(j,...we){return we.length===0?j:j.replace(R,function(_e,Ae){const Ue=parseInt(Ae,10);return isNaN(Ue)||Ue<0||Ue>=we.length?_e:we[Ue]})}e.format=k;const S=/{([^}]+)}/g;function T(j,we){return j.replace(S,(_e,Ae)=>we[Ae]??_e)}e.format2=T;function D(j){return j.replace(/[<>&]/g,function(we){switch(we){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return we}})}e.escape=D;function y(j){return j.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=y;function A(j,we){let _e=0;const Ae=we.charCodeAt(0);for(let Ue=j.length-1;Ue>=0;Ue--)j.charCodeAt(Ue)===Ae&&_e++;return _e}e.count=A;function i(j,we,_e="\u2026"){return j.length<=we?j:`${j.substr(0,we)}${_e}`}e.truncate=i;function C(j,we=" "){const _e=u(j,we);return m(_e,we)}e.trim=C;function u(j,we){if(!j||!we)return j;const _e=we.length;if(_e===0||j.length===0)return j;let Ae=0;for(;j.indexOf(we,Ae)===Ae;)Ae=Ae+_e;return j.substring(Ae)}e.ltrim=u;function m(j,we){if(!j||!we)return j;const _e=we.length,Ae=j.length;if(_e===0||Ae===0)return j;let Ue=Ae,Ge=-1;for(;Ge=j.lastIndexOf(we,Ue-1),!(Ge===-1||Ge+_e!==Ue);){if(Ge===0)return"";Ue=Ge}return j.substring(0,Ue)}e.rtrim=m;function l(j){return j.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=l;function v(j){return j.replace(/\*/g,"")}e.stripWildcards=v;function _(j,we,_e={}){if(!j)throw new Error("Cannot create regex from empty string");we||(j=y(j)),_e.wholeWord&&(/\B/.test(j.charAt(0))||(j="\\b"+j),/\B/.test(j.charAt(j.length-1))||(j=j+"\\b"));let Ae="";return _e.global&&(Ae+="g"),_e.matchCase||(Ae+="i"),_e.multiline&&(Ae+="m"),_e.unicode&&(Ae+="u"),new RegExp(j,Ae)}e.createRegExp=_;function b(j){return j.source==="^"||j.source==="^$"||j.source==="$"||j.source==="^\\s*$"?!1:!!(j.exec("")&&j.lastIndex===0)}e.regExpLeadsToEndlessLoop=b;function P(j){return!!j.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=P;function c(j){return(j.global?"g":"")+(j.ignoreCase?"i":"")+(j.multiline?"m":"")+(j.unicode?"u":"")}e.regExpFlags=c;function h(j){return j.split(/\r\n|\r|\n/)}e.splitLines=h;function p(j){for(let we=0,_e=j.length;we<_e;we++){const Ae=j.charCodeAt(we);if(Ae!==32&&Ae!==9)return we}return-1}e.firstNonWhitespaceIndex=p;function t(j,we=0,_e=j.length){for(let Ae=we;Ae<_e;Ae++){const Ue=j.charCodeAt(Ae);if(Ue!==32&&Ue!==9)return j.substring(we,Ae)}return j.substring(we,_e)}e.getLeadingWhitespace=t;function r(j,we=j.length-1){for(let _e=we;_e>=0;_e--){const Ae=j.charCodeAt(_e);if(Ae!==32&&Ae!==9)return _e}return-1}e.lastNonWhitespaceIndex=r;function s(j,we){return j<we?-1:j>we?1:0}e.compare=s;function n(j,we,_e=0,Ae=j.length,Ue=0,Ge=we.length){for(;_e<Ae&&Ue<Ge;_e++,Ue++){let Je=j.charCodeAt(_e),ct=we.charCodeAt(Ue);if(Je<ct)return-1;if(Je>ct)return 1}const Ze=Ae-_e,Qe=Ge-Ue;return Ze<Qe?-1:Ze>Qe?1:0}e.compareSubstring=n;function a(j,we){return d(j,we,0,j.length,0,we.length)}e.compareIgnoreCase=a;function d(j,we,_e=0,Ae=j.length,Ue=0,Ge=we.length){for(;_e<Ae&&Ue<Ge;_e++,Ue++){let Je=j.charCodeAt(_e),ct=we.charCodeAt(Ue);if(Je===ct)continue;const mt=Je-ct;if(!(mt===32&&w(ct))&&!(mt===-32&&w(Je)))return f(Je)&&f(ct)?mt:n(j.toLowerCase(),we.toLowerCase(),_e,Ae,Ue,Ge)}const Ze=Ae-_e,Qe=Ge-Ue;return Ze<Qe?-1:Ze>Qe?1:0}e.compareSubstringIgnoreCase=d;function f(j){return j>=97&&j<=122}e.isLowerAsciiLetter=f;function w(j){return j>=65&&j<=90}e.isUpperAsciiLetter=w;function E(j){return f(j)||w(j)}function o(j,we){return j.length===we.length&&I(j,we)}e.equalsIgnoreCase=o;function I(j,we,_e=j.length){for(let Ae=0;Ae<_e;Ae++){const Ue=j.charCodeAt(Ae),Ge=we.charCodeAt(Ae);if(Ue!==Ge){if(E(Ue)&&E(Ge)){const Ze=Math.abs(Ue-Ge);if(Ze!==0&&Ze!==32)return!1}else if(String.fromCharCode(Ue).toLowerCase()!==String.fromCharCode(Ge).toLowerCase())return!1}}return!0}function L(j,we){const _e=we.length;return we.length>j.length?!1:I(j,we,_e)}e.startsWithIgnoreCase=L;function U(j,we){let _e,Ae=Math.min(j.length,we.length);for(_e=0;_e<Ae;_e++)if(j.charCodeAt(_e)!==we.charCodeAt(_e))return _e;return Ae}e.commonPrefixLength=U;function V(j,we){let _e,Ae=Math.min(j.length,we.length);const Ue=j.length-1,Ge=we.length-1;for(_e=0;_e<Ae;_e++)if(j.charCodeAt(Ue-_e)!==we.charCodeAt(Ge-_e))return _e;return Ae}e.commonSuffixLength=V;function ee(j){return 55296<=j&&j<=56319}e.isHighSurrogate=ee;function K(j){return 56320<=j&&j<=57343}e.isLowSurrogate=K;function N(j,we){return(j-55296<<10)+(we-56320)+65536}e.computeCodePoint=N;function x(j,we,_e){const Ae=j.charCodeAt(_e);if(ee(Ae)&&_e+1<we){const Ue=j.charCodeAt(_e+1);if(K(Ue))return N(Ae,Ue)}return Ae}e.getNextCodePoint=x;function F(j,we){const _e=j.charCodeAt(we-1);if(K(_e)&&we>1){const Ae=j.charCodeAt(we-2);if(ee(Ae))return N(Ae,_e)}return _e}function z(j,we){const _e=Ce.getInstance(),Ae=we,Ue=j.length,Ge=x(j,Ue,we);we+=Ge>=65536?2:1;let Ze=_e.getGraphemeBreakType(Ge);for(;we<Ue;){const Qe=x(j,Ue,we),Je=_e.getGraphemeBreakType(Qe);if(Be(Ze,Je))break;we+=Qe>=65536?2:1,Ze=Je}return we-Ae}e.nextCharLength=z;function M(j,we){const _e=Ce.getInstance(),Ae=we,Ue=F(j,we);we-=Ue>=65536?2:1;let Ge=_e.getGraphemeBreakType(Ue);for(;we>0;){const Ze=F(j,we),Qe=_e.getGraphemeBreakType(Ze);if(Be(Qe,Ge))break;we-=Ze>=65536?2:1,Ge=Qe}return Ae-we}e.prevCharLength=M;function O(j,we){const _e=Ce.getInstance(),Ae=j.length,Ue=we,Ge=x(j,Ae,we),Ze=_e.getGraphemeBreakType(Ge);we+=Ge>=65536?2:1;let Qe=Ze;for(;we<Ae;){const ct=x(j,Ae,we),mt=_e.getGraphemeBreakType(ct);if(Be(Qe,mt))break;we+=ct>=65536?2:1,Qe=mt}const Je=we;for(we=Ue,Qe=Ze;we>0;){const ct=F(j,we),mt=_e.getGraphemeBreakType(ct);if(Be(mt,Qe))break;we-=ct>=65536?2:1,Qe=mt}return[we,Je]}function q(j,we){return we>0&&K(j.charCodeAt(we))?O(j,we-1):O(j,we)}e.getCharContainingOffset=q;function B(j){const we=j.length;let _e=0,Ae=0;for(;Ae<we;){const Ze=x(j,we,Ae);Ae+=Ze>=65536?2:1,Ze<128?_e+=1:Ze<2048?_e+=2:Ze<65536?_e+=3:_e+=4}const Ue=new Uint8Array(_e);Ae=0;let Ge=0;for(;Ae<we;){const Ze=x(j,we,Ae);Ae+=Ze>=65536?2:1,Ze<128?Ue[Ge++]=Ze:Ze<2048?(Ue[Ge++]=192|(Ze&1984)>>>6,Ue[Ge++]=128|(Ze&63)>>>0):Ze<65536?(Ue[Ge++]=224|(Ze&61440)>>>12,Ue[Ge++]=128|(Ze&4032)>>>6,Ue[Ge++]=128|(Ze&63)>>>0):(Ue[Ge++]=240|(Ze&1835008)>>>18,Ue[Ge++]=128|(Ze&258048)>>>12,Ue[Ge++]=128|(Ze&4032)>>>6,Ue[Ge++]=128|(Ze&63)>>>0)}return Ue}e.encodeUTF8=B;function G(j){const we=j.byteLength,_e=[];let Ae=0;for(;Ae<we;){const Ue=j[Ae];let Ge;if(Ue>=240&&Ae+3<we?Ge=(j[Ae++]&7)<<18>>>0|(j[Ae++]&63)<<12>>>0|(j[Ae++]&63)<<6>>>0|(j[Ae++]&63)<<0>>>0:Ue>=224&&Ae+2<we?Ge=(j[Ae++]&15)<<12>>>0|(j[Ae++]&63)<<6>>>0|(j[Ae++]&63)<<0>>>0:Ue>=192&&Ae+1<we?Ge=(j[Ae++]&31)<<6>>>0|(j[Ae++]&63)<<0>>>0:Ge=j[Ae++],Ge>=0&&Ge<=55295||Ge>=57344&&Ge<=65535)_e.push(String.fromCharCode(Ge));else if(Ge>=65536&&Ge<=1114111){const Ze=Ge-65536,Qe=55296+((Ze&1047552)>>>10),Je=56320+((Ze&1023)>>>0);_e.push(String.fromCharCode(Qe)),_e.push(String.fromCharCode(Je))}else _e.push(String.fromCharCode(65533))}return _e.join("")}e.decodeUTF8=G;const ie=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function he(j){return ie.test(j)}e.containsRTL=he;const ye=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD00-\uDDFF\uDE70-\uDED6])/;function Ie(j){return ye.test(j)}e.containsEmoji=Ie;const Le=/^[\t\n\r\x20-\x7E]*$/;function qe(j){return Le.test(j)}e.isBasicASCII=qe,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function We(j){return e.UNUSUAL_LINE_TERMINATORS.test(j)}e.containsUnusualLineTerminators=We;function je(j){for(let we=0,_e=j.length;we<_e;we++)if(W(j.charCodeAt(we)))return!0;return!1}e.containsFullWidthCharacter=je;function W(j){return j=+j,j>=11904&&j<=55215||j>=63744&&j<=64255||j>=65281&&j<=65374}e.isFullWidthCharacter=W;function Z(j){return j>=127462&&j<=127487||j===8986||j===8987||j===9200||j===9203||j>=9728&&j<=10175||j===11088||j===11093||j>=127744&&j<=128591||j>=128640&&j<=128764||j>=128992&&j<=129003||j>=129280&&j<=129535||j>=129648&&j<=129750}e.isEmojiImprecise=Z;function ne(j,we){if(j.length<we)return j;const _e=/\b/g;let Ae=0;for(;_e.test(j)&&!(j.length-_e.lastIndex<we);)Ae=_e.lastIndex,_e.lastIndex+=1;return j.substring(Ae).replace(/^\s/,"")}e.lcut=ne;const le=/\x1B\x5B[12]?K/g,Y=/\x1b\[\d+m/g,ae=/\x1b\[0?m/g;function ve(j){return j&&(j=j.replace(le,""),j=j.replace(Y,""),j=j.replace(ae,"")),j}e.removeAnsiEscapeCodes=ve,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function Me(j){return!!(j&&j.length>0&&j.charCodeAt(0)===65279)}e.startsWithUTF8BOM=Me;function ze(j){return Me(j)?j.substr(1):j}e.stripUTF8BOM=ze;function Ee(j,we){if(!j||!we||j.length<we.length)return!1;const _e=we.length,Ae=j.toLowerCase();let Ue=0,Ge=-1;for(;Ue<_e;){const Ze=Ae.indexOf(we[Ue],Ge+1);if(Ze<0)return!1;Ge=Ze,Ue++}return!0}e.fuzzyContains=Ee;function Ye(j,we=!1){return j?(we&&(j=j.replace(/\\./g,"")),j.toLowerCase()!==j):!1}e.containsUppercaseCharacter=Ye;function X(j){return j.charAt(0).toUpperCase()+j.slice(1)}e.uppercaseFirstLetter=X;function se(j,we=1){if(we===0)return"";let _e=-1;do _e=j.indexOf(`
`,_e+1),we--;while(we>0&&_e>=0);return _e===-1?j:(j[_e-1]==="\r"&&_e--,j.substr(0,_e))}e.getNLines=se;function fe(j){const we=90-65+1;return j=j%(2*we),j<we?String.fromCharCode(97+j):String.fromCharCode(65+j-we)}e.singleLetterHash=fe;function xe(j){return Ce.getInstance().getGraphemeBreakType(j)}e.getGraphemeBreakType=xe;function Be(j,we){return j===0?we!==5&&we!==7:j===2&&we===3?!1:j===4||j===2||j===3||we===4||we===2||we===3?!0:!(j===8&&(we===8||we===9||we===11||we===12)||(j===11||j===9)&&(we===9||we===10)||(j===12||j===10)&&we===10||we===5||we===13||we===7||j===1||j===13&&we===14||j===6&&we===6)}e.breakBetweenGraphemeBreakType=Be;var et;(function(j){j[j.Other=0]="Other",j[j.Prepend=1]="Prepend",j[j.CR=2]="CR",j[j.LF=3]="LF",j[j.Control=4]="Control",j[j.Extend=5]="Extend",j[j.Regional_Indicator=6]="Regional_Indicator",j[j.SpacingMark=7]="SpacingMark",j[j.L=8]="L",j[j.V=9]="V",j[j.T=10]="T",j[j.LV=11]="LV",j[j.LVT=12]="LVT",j[j.ZWJ=13]="ZWJ",j[j.Extended_Pictographic=14]="Extended_Pictographic"})(et=e.GraphemeBreakType||(e.GraphemeBreakType={}));class Ce{constructor(){this._data=De()}static getInstance(){return Ce._INSTANCE||(Ce._INSTANCE=new Ce),Ce._INSTANCE}getGraphemeBreakType(we){if(we<32)return we===10?3:we===13?2:4;if(we<127)return 0;const _e=this._data,Ae=_e.length/3;let Ue=1;for(;Ue<=Ae;)if(we<_e[3*Ue])Ue=2*Ue;else if(we>_e[3*Ue+1])Ue=2*Ue+1;else return _e[3*Ue+2];return 0}}Ce._INSTANCE=null;function De(){return JSON.parse("[0,0,0,51592,51592,11,44424,44424,11,72251,72254,5,7150,7150,7,48008,48008,11,55176,55176,11,128420,128420,14,3276,3277,5,9979,9980,14,46216,46216,11,49800,49800,11,53384,53384,11,70726,70726,5,122915,122916,5,129320,129327,14,2558,2558,5,5906,5908,5,9762,9763,14,43360,43388,8,45320,45320,11,47112,47112,11,48904,48904,11,50696,50696,11,52488,52488,11,54280,54280,11,70082,70083,1,71350,71350,7,73111,73111,5,127892,127893,14,128726,128727,14,129473,129474,14,2027,2035,5,2901,2902,5,3784,3789,5,6754,6754,5,8418,8420,5,9877,9877,14,11088,11088,14,44008,44008,5,44872,44872,11,45768,45768,11,46664,46664,11,47560,47560,11,48456,48456,11,49352,49352,11,50248,50248,11,51144,51144,11,52040,52040,11,52936,52936,11,53832,53832,11,54728,54728,11,69811,69814,5,70459,70460,5,71096,71099,7,71998,71998,5,72874,72880,5,119149,119149,7,127374,127374,14,128335,128335,14,128482,128482,14,128765,128767,14,129399,129400,14,129680,129685,14,1476,1477,5,2377,2380,7,2759,2760,5,3137,3140,7,3458,3459,7,4153,4154,5,6432,6434,5,6978,6978,5,7675,7679,5,9723,9726,14,9823,9823,14,9919,9923,14,10035,10036,14,42736,42737,5,43596,43596,5,44200,44200,11,44648,44648,11,45096,45096,11,45544,45544,11,45992,45992,11,46440,46440,11,46888,46888,11,47336,47336,11,47784,47784,11,48232,48232,11,48680,48680,11,49128,49128,11,49576,49576,11,50024,50024,11,50472,50472,11,50920,50920,11,51368,51368,11,51816,51816,11,52264,52264,11,52712,52712,11,53160,53160,11,53608,53608,11,54056,54056,11,54504,54504,11,54952,54952,11,68108,68111,5,69933,69940,5,70197,70197,7,70498,70499,7,70845,70845,5,71229,71229,5,71727,71735,5,72154,72155,5,72344,72345,5,73023,73029,5,94095,94098,5,121403,121452,5,126981,127182,14,127538,127546,14,127990,127990,14,128391,128391,14,128445,128449,14,128500,128505,14,128752,128752,14,129160,129167,14,129356,129356,14,129432,129442,14,129648,129651,14,129751,131069,14,173,173,4,1757,1757,1,2274,2274,1,2494,2494,5,2641,2641,5,2876,2876,5,3014,3016,7,3262,3262,7,3393,3396,5,3570,3571,7,3968,3972,5,4228,4228,7,6086,6086,5,6679,6680,5,6912,6915,5,7080,7081,5,7380,7392,5,8252,8252,14,9096,9096,14,9748,9749,14,9784,9786,14,9833,9850,14,9890,9894,14,9938,9938,14,9999,9999,14,10085,10087,14,12349,12349,14,43136,43137,7,43454,43456,7,43755,43755,7,44088,44088,11,44312,44312,11,44536,44536,11,44760,44760,11,44984,44984,11,45208,45208,11,45432,45432,11,45656,45656,11,45880,45880,11,46104,46104,11,46328,46328,11,46552,46552,11,46776,46776,11,47000,47000,11,47224,47224,11,47448,47448,11,47672,47672,11,47896,47896,11,48120,48120,11,48344,48344,11,48568,48568,11,48792,48792,11,49016,49016,11,49240,49240,11,49464,49464,11,49688,49688,11,49912,49912,11,50136,50136,11,50360,50360,11,50584,50584,11,50808,50808,11,51032,51032,11,51256,51256,11,51480,51480,11,51704,51704,11,51928,51928,11,52152,52152,11,52376,52376,11,52600,52600,11,52824,52824,11,53048,53048,11,53272,53272,11,53496,53496,11,53720,53720,11,53944,53944,11,54168,54168,11,54392,54392,11,54616,54616,11,54840,54840,11,55064,55064,11,65438,65439,5,69633,69633,5,69837,69837,1,70018,70018,7,70188,70190,7,70368,70370,7,70465,70468,7,70712,70719,5,70835,70840,5,70850,70851,5,71132,71133,5,71340,71340,7,71458,71461,5,71985,71989,7,72002,72002,7,72193,72202,5,72281,72283,5,72766,72766,7,72885,72886,5,73104,73105,5,92912,92916,5,113824,113827,4,119173,119179,5,121505,121519,5,125136,125142,5,127279,127279,14,127489,127490,14,127570,127743,14,127900,127901,14,128254,128254,14,128369,128370,14,128400,128400,14,128425,128432,14,128468,128475,14,128489,128494,14,128715,128720,14,128745,128745,14,128759,128760,14,129004,129023,14,129296,129304,14,129340,129342,14,129388,129392,14,129404,129407,14,129454,129455,14,129485,129487,14,129659,129663,14,129719,129727,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2363,2363,7,2402,2403,5,2507,2508,7,2622,2624,7,2691,2691,7,2786,2787,5,2881,2884,5,3006,3006,5,3072,3072,5,3170,3171,5,3267,3268,7,3330,3331,7,3406,3406,1,3538,3540,5,3655,3662,5,3897,3897,5,4038,4038,5,4184,4185,5,4352,4447,8,6068,6069,5,6155,6157,5,6448,6449,7,6742,6742,5,6783,6783,5,6966,6970,5,7042,7042,7,7143,7143,7,7212,7219,5,7412,7412,5,8206,8207,4,8294,8303,4,8596,8601,14,9410,9410,14,9742,9742,14,9757,9757,14,9770,9770,14,9794,9794,14,9828,9828,14,9855,9855,14,9882,9882,14,9900,9903,14,9929,9933,14,9963,9967,14,9987,9988,14,10006,10006,14,10062,10062,14,10175,10175,14,11744,11775,5,42607,42607,5,43043,43044,7,43263,43263,5,43444,43445,7,43569,43570,5,43698,43700,5,43766,43766,5,44032,44032,11,44144,44144,11,44256,44256,11,44368,44368,11,44480,44480,11,44592,44592,11,44704,44704,11,44816,44816,11,44928,44928,11,45040,45040,11,45152,45152,11,45264,45264,11,45376,45376,11,45488,45488,11,45600,45600,11,45712,45712,11,45824,45824,11,45936,45936,11,46048,46048,11,46160,46160,11,46272,46272,11,46384,46384,11,46496,46496,11,46608,46608,11,46720,46720,11,46832,46832,11,46944,46944,11,47056,47056,11,47168,47168,11,47280,47280,11,47392,47392,11,47504,47504,11,47616,47616,11,47728,47728,11,47840,47840,11,47952,47952,11,48064,48064,11,48176,48176,11,48288,48288,11,48400,48400,11,48512,48512,11,48624,48624,11,48736,48736,11,48848,48848,11,48960,48960,11,49072,49072,11,49184,49184,11,49296,49296,11,49408,49408,11,49520,49520,11,49632,49632,11,49744,49744,11,49856,49856,11,49968,49968,11,50080,50080,11,50192,50192,11,50304,50304,11,50416,50416,11,50528,50528,11,50640,50640,11,50752,50752,11,50864,50864,11,50976,50976,11,51088,51088,11,51200,51200,11,51312,51312,11,51424,51424,11,51536,51536,11,51648,51648,11,51760,51760,11,51872,51872,11,51984,51984,11,52096,52096,11,52208,52208,11,52320,52320,11,52432,52432,11,52544,52544,11,52656,52656,11,52768,52768,11,52880,52880,11,52992,52992,11,53104,53104,11,53216,53216,11,53328,53328,11,53440,53440,11,53552,53552,11,53664,53664,11,53776,53776,11,53888,53888,11,54000,54000,11,54112,54112,11,54224,54224,11,54336,54336,11,54448,54448,11,54560,54560,11,54672,54672,11,54784,54784,11,54896,54896,11,55008,55008,11,55120,55120,11,64286,64286,5,66272,66272,5,68900,68903,5,69762,69762,7,69817,69818,5,69927,69931,5,70003,70003,5,70070,70078,5,70094,70094,7,70194,70195,7,70206,70206,5,70400,70401,5,70463,70463,7,70475,70477,7,70512,70516,5,70722,70724,5,70832,70832,5,70842,70842,5,70847,70848,5,71088,71089,7,71102,71102,7,71219,71226,5,71231,71232,5,71342,71343,7,71453,71455,5,71463,71467,5,71737,71738,5,71995,71996,5,72000,72000,7,72145,72147,7,72160,72160,5,72249,72249,7,72273,72278,5,72330,72342,5,72752,72758,5,72850,72871,5,72882,72883,5,73018,73018,5,73031,73031,5,73109,73109,5,73461,73462,7,94031,94031,5,94192,94193,7,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,126976,126979,14,127184,127231,14,127344,127345,14,127405,127461,14,127514,127514,14,127561,127567,14,127778,127779,14,127896,127896,14,127985,127986,14,127995,127999,5,128326,128328,14,128360,128366,14,128378,128378,14,128394,128397,14,128405,128406,14,128422,128423,14,128435,128443,14,128453,128464,14,128479,128480,14,128484,128487,14,128496,128498,14,128640,128709,14,128723,128724,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129096,129103,14,129292,129292,14,129311,129311,14,129329,129330,14,129344,129349,14,129360,129374,14,129394,129394,14,129402,129402,14,129413,129425,14,129445,129450,14,129466,129471,14,129483,129483,14,129511,129535,14,129653,129655,14,129667,129670,14,129705,129711,14,129731,129743,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2307,2307,7,2366,2368,7,2382,2383,7,2434,2435,7,2497,2500,5,2519,2519,5,2563,2563,7,2631,2632,5,2677,2677,5,2750,2752,7,2763,2764,7,2817,2817,5,2879,2879,5,2891,2892,7,2914,2915,5,3008,3008,5,3021,3021,5,3076,3076,5,3146,3149,5,3202,3203,7,3264,3265,7,3271,3272,7,3298,3299,5,3390,3390,5,3402,3404,7,3426,3427,5,3535,3535,5,3544,3550,7,3635,3635,7,3763,3763,7,3893,3893,5,3953,3966,5,3981,3991,5,4145,4145,7,4157,4158,5,4209,4212,5,4237,4237,5,4520,4607,10,5970,5971,5,6071,6077,5,6089,6099,5,6277,6278,5,6439,6440,5,6451,6456,7,6683,6683,5,6744,6750,5,6765,6770,7,6846,6846,5,6964,6964,5,6972,6972,5,7019,7027,5,7074,7077,5,7083,7085,5,7146,7148,7,7154,7155,7,7222,7223,5,7394,7400,5,7416,7417,5,8204,8204,5,8233,8233,4,8288,8292,4,8413,8416,5,8482,8482,14,8986,8987,14,9193,9203,14,9654,9654,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9775,14,9792,9792,14,9800,9811,14,9825,9826,14,9831,9831,14,9852,9853,14,9872,9873,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9936,9936,14,9941,9960,14,9974,9974,14,9982,9985,14,9992,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10145,10145,14,11013,11015,14,11503,11505,5,12334,12335,5,12951,12951,14,42612,42621,5,43014,43014,5,43047,43047,7,43204,43205,5,43335,43345,5,43395,43395,7,43450,43451,7,43561,43566,5,43573,43574,5,43644,43644,5,43710,43711,5,43758,43759,7,44005,44005,5,44012,44012,7,44060,44060,11,44116,44116,11,44172,44172,11,44228,44228,11,44284,44284,11,44340,44340,11,44396,44396,11,44452,44452,11,44508,44508,11,44564,44564,11,44620,44620,11,44676,44676,11,44732,44732,11,44788,44788,11,44844,44844,11,44900,44900,11,44956,44956,11,45012,45012,11,45068,45068,11,45124,45124,11,45180,45180,11,45236,45236,11,45292,45292,11,45348,45348,11,45404,45404,11,45460,45460,11,45516,45516,11,45572,45572,11,45628,45628,11,45684,45684,11,45740,45740,11,45796,45796,11,45852,45852,11,45908,45908,11,45964,45964,11,46020,46020,11,46076,46076,11,46132,46132,11,46188,46188,11,46244,46244,11,46300,46300,11,46356,46356,11,46412,46412,11,46468,46468,11,46524,46524,11,46580,46580,11,46636,46636,11,46692,46692,11,46748,46748,11,46804,46804,11,46860,46860,11,46916,46916,11,46972,46972,11,47028,47028,11,47084,47084,11,47140,47140,11,47196,47196,11,47252,47252,11,47308,47308,11,47364,47364,11,47420,47420,11,47476,47476,11,47532,47532,11,47588,47588,11,47644,47644,11,47700,47700,11,47756,47756,11,47812,47812,11,47868,47868,11,47924,47924,11,47980,47980,11,48036,48036,11,48092,48092,11,48148,48148,11,48204,48204,11,48260,48260,11,48316,48316,11,48372,48372,11,48428,48428,11,48484,48484,11,48540,48540,11,48596,48596,11,48652,48652,11,48708,48708,11,48764,48764,11,48820,48820,11,48876,48876,11,48932,48932,11,48988,48988,11,49044,49044,11,49100,49100,11,49156,49156,11,49212,49212,11,49268,49268,11,49324,49324,11,49380,49380,11,49436,49436,11,49492,49492,11,49548,49548,11,49604,49604,11,49660,49660,11,49716,49716,11,49772,49772,11,49828,49828,11,49884,49884,11,49940,49940,11,49996,49996,11,50052,50052,11,50108,50108,11,50164,50164,11,50220,50220,11,50276,50276,11,50332,50332,11,50388,50388,11,50444,50444,11,50500,50500,11,50556,50556,11,50612,50612,11,50668,50668,11,50724,50724,11,50780,50780,11,50836,50836,11,50892,50892,11,50948,50948,11,51004,51004,11,51060,51060,11,51116,51116,11,51172,51172,11,51228,51228,11,51284,51284,11,51340,51340,11,51396,51396,11,51452,51452,11,51508,51508,11,51564,51564,11,51620,51620,11,51676,51676,11,51732,51732,11,51788,51788,11,51844,51844,11,51900,51900,11,51956,51956,11,52012,52012,11,52068,52068,11,52124,52124,11,52180,52180,11,52236,52236,11,52292,52292,11,52348,52348,11,52404,52404,11,52460,52460,11,52516,52516,11,52572,52572,11,52628,52628,11,52684,52684,11,52740,52740,11,52796,52796,11,52852,52852,11,52908,52908,11,52964,52964,11,53020,53020,11,53076,53076,11,53132,53132,11,53188,53188,11,53244,53244,11,53300,53300,11,53356,53356,11,53412,53412,11,53468,53468,11,53524,53524,11,53580,53580,11,53636,53636,11,53692,53692,11,53748,53748,11,53804,53804,11,53860,53860,11,53916,53916,11,53972,53972,11,54028,54028,11,54084,54084,11,54140,54140,11,54196,54196,11,54252,54252,11,54308,54308,11,54364,54364,11,54420,54420,11,54476,54476,11,54532,54532,11,54588,54588,11,54644,54644,11,54700,54700,11,54756,54756,11,54812,54812,11,54868,54868,11,54924,54924,11,54980,54980,11,55036,55036,11,55092,55092,11,55148,55148,11,55216,55238,9,65056,65071,5,65529,65531,4,68097,68099,5,68159,68159,5,69446,69456,5,69688,69702,5,69808,69810,7,69815,69816,7,69821,69821,1,69888,69890,5,69932,69932,7,69957,69958,7,70016,70017,5,70067,70069,7,70079,70080,7,70089,70092,5,70095,70095,5,70191,70193,5,70196,70196,5,70198,70199,5,70367,70367,5,70371,70378,5,70402,70403,7,70462,70462,5,70464,70464,5,70471,70472,7,70487,70487,5,70502,70508,5,70709,70711,7,70720,70721,7,70725,70725,7,70750,70750,5,70833,70834,7,70841,70841,7,70843,70844,7,70846,70846,7,70849,70849,7,71087,71087,5,71090,71093,5,71100,71101,5,71103,71104,5,71216,71218,7,71227,71228,7,71230,71230,7,71339,71339,5,71341,71341,5,71344,71349,5,71351,71351,5,71456,71457,7,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123628,123631,5,125252,125258,5,126980,126980,14,127183,127183,14,127245,127247,14,127340,127343,14,127358,127359,14,127377,127386,14,127462,127487,6,127491,127503,14,127535,127535,14,127548,127551,14,127568,127569,14,127744,127777,14,127780,127891,14,127894,127895,14,127897,127899,14,127902,127984,14,127987,127989,14,127991,127994,14,128000,128253,14,128255,128317,14,128329,128334,14,128336,128359,14,128367,128368,14,128371,128377,14,128379,128390,14,128392,128393,14,128398,128399,14,128401,128404,14,128407,128419,14,128421,128421,14,128424,128424,14,128433,128434,14,128444,128444,14,128450,128452,14,128465,128467,14,128476,128478,14,128481,128481,14,128483,128483,14,128488,128488,14,128495,128495,14,128499,128499,14,128506,128591,14,128710,128714,14,128721,128722,14,128725,128725,14,128728,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129664,129666,14,129671,129679,14,129686,129704,14,129712,129718,14,129728,129730,14,129744,129750,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2259,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3134,3136,5,3142,3144,5,3157,3158,5,3201,3201,5,3260,3260,5,3263,3263,5,3266,3266,5,3270,3270,5,3274,3275,7,3285,3286,5,3328,3329,5,3387,3388,5,3391,3392,7,3398,3400,7,3405,3405,5,3415,3415,5,3457,3457,5,3530,3530,5,3536,3537,7,3542,3542,5,3551,3551,5,3633,3633,5,3636,3642,5,3761,3761,5,3764,3772,5,3864,3865,5,3895,3895,5,3902,3903,7,3967,3967,7,3974,3975,5,3993,4028,5,4141,4144,5,4146,4151,5,4155,4156,7,4182,4183,7,4190,4192,5,4226,4226,5,4229,4230,5,4253,4253,5,4448,4519,9,4957,4959,5,5938,5940,5,6002,6003,5,6070,6070,7,6078,6085,7,6087,6088,7,6109,6109,5,6158,6158,4,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6848,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7673,5,8203,8203,4,8205,8205,13,8232,8232,4,8234,8238,4,8265,8265,14,8293,8293,4,8400,8412,5,8417,8417,5,8421,8432,5,8505,8505,14,8617,8618,14,9000,9000,14,9167,9167,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9776,9783,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9935,14,9937,9937,14,9939,9940,14,9961,9962,14,9968,9973,14,9975,9978,14,9981,9981,14,9986,9986,14,9989,9989,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10084,14,10133,10135,14,10160,10160,14,10548,10549,14,11035,11036,14,11093,11093,14,11647,11647,5,12330,12333,5,12336,12336,14,12441,12442,5,12953,12953,14,42608,42610,5,42654,42655,5,43010,43010,5,43019,43019,5,43045,43046,5,43052,43052,5,43188,43203,7,43232,43249,5,43302,43309,5,43346,43347,7,43392,43394,5,43443,43443,5,43446,43449,5,43452,43453,5,43493,43493,5,43567,43568,7,43571,43572,7,43587,43587,5,43597,43597,7,43696,43696,5,43703,43704,5,43713,43713,5,43756,43757,5,43765,43765,7,44003,44004,7,44006,44007,7,44009,44010,7,44013,44013,5,44033,44059,12,44061,44087,12,44089,44115,12,44117,44143,12,44145,44171,12,44173,44199,12,44201,44227,12,44229,44255,12,44257,44283,12,44285,44311,12,44313,44339,12,44341,44367,12,44369,44395,12,44397,44423,12,44425,44451,12,44453,44479,12,44481,44507,12,44509,44535,12,44537,44563,12,44565,44591,12,44593,44619,12,44621,44647,12,44649,44675,12,44677,44703,12,44705,44731,12,44733,44759,12,44761,44787,12,44789,44815,12,44817,44843,12,44845,44871,12,44873,44899,12,44901,44927,12,44929,44955,12,44957,44983,12,44985,45011,12,45013,45039,12,45041,45067,12,45069,45095,12,45097,45123,12,45125,45151,12,45153,45179,12,45181,45207,12,45209,45235,12,45237,45263,12,45265,45291,12,45293,45319,12,45321,45347,12,45349,45375,12,45377,45403,12,45405,45431,12,45433,45459,12,45461,45487,12,45489,45515,12,45517,45543,12,45545,45571,12,45573,45599,12,45601,45627,12,45629,45655,12,45657,45683,12,45685,45711,12,45713,45739,12,45741,45767,12,45769,45795,12,45797,45823,12,45825,45851,12,45853,45879,12,45881,45907,12,45909,45935,12,45937,45963,12,45965,45991,12,45993,46019,12,46021,46047,12,46049,46075,12,46077,46103,12,46105,46131,12,46133,46159,12,46161,46187,12,46189,46215,12,46217,46243,12,46245,46271,12,46273,46299,12,46301,46327,12,46329,46355,12,46357,46383,12,46385,46411,12,46413,46439,12,46441,46467,12,46469,46495,12,46497,46523,12,46525,46551,12,46553,46579,12,46581,46607,12,46609,46635,12,46637,46663,12,46665,46691,12,46693,46719,12,46721,46747,12,46749,46775,12,46777,46803,12,46805,46831,12,46833,46859,12,46861,46887,12,46889,46915,12,46917,46943,12,46945,46971,12,46973,46999,12,47001,47027,12,47029,47055,12,47057,47083,12,47085,47111,12,47113,47139,12,47141,47167,12,47169,47195,12,47197,47223,12,47225,47251,12,47253,47279,12,47281,47307,12,47309,47335,12,47337,47363,12,47365,47391,12,47393,47419,12,47421,47447,12,47449,47475,12,47477,47503,12,47505,47531,12,47533,47559,12,47561,47587,12,47589,47615,12,47617,47643,12,47645,47671,12,47673,47699,12,47701,47727,12,47729,47755,12,47757,47783,12,47785,47811,12,47813,47839,12,47841,47867,12,47869,47895,12,47897,47923,12,47925,47951,12,47953,47979,12,47981,48007,12,48009,48035,12,48037,48063,12,48065,48091,12,48093,48119,12,48121,48147,12,48149,48175,12,48177,48203,12,48205,48231,12,48233,48259,12,48261,48287,12,48289,48315,12,48317,48343,12,48345,48371,12,48373,48399,12,48401,48427,12,48429,48455,12,48457,48483,12,48485,48511,12,48513,48539,12,48541,48567,12,48569,48595,12,48597,48623,12,48625,48651,12,48653,48679,12,48681,48707,12,48709,48735,12,48737,48763,12,48765,48791,12,48793,48819,12,48821,48847,12,48849,48875,12,48877,48903,12,48905,48931,12,48933,48959,12,48961,48987,12,48989,49015,12,49017,49043,12,49045,49071,12,49073,49099,12,49101,49127,12,49129,49155,12,49157,49183,12,49185,49211,12,49213,49239,12,49241,49267,12,49269,49295,12,49297,49323,12,49325,49351,12,49353,49379,12,49381,49407,12,49409,49435,12,49437,49463,12,49465,49491,12,49493,49519,12,49521,49547,12,49549,49575,12,49577,49603,12,49605,49631,12,49633,49659,12,49661,49687,12,49689,49715,12,49717,49743,12,49745,49771,12,49773,49799,12,49801,49827,12,49829,49855,12,49857,49883,12,49885,49911,12,49913,49939,12,49941,49967,12,49969,49995,12,49997,50023,12,50025,50051,12,50053,50079,12,50081,50107,12,50109,50135,12,50137,50163,12,50165,50191,12,50193,50219,12,50221,50247,12,50249,50275,12,50277,50303,12,50305,50331,12,50333,50359,12,50361,50387,12,50389,50415,12,50417,50443,12,50445,50471,12,50473,50499,12,50501,50527,12,50529,50555,12,50557,50583,12,50585,50611,12,50613,50639,12,50641,50667,12,50669,50695,12,50697,50723,12,50725,50751,12,50753,50779,12,50781,50807,12,50809,50835,12,50837,50863,12,50865,50891,12,50893,50919,12,50921,50947,12,50949,50975,12,50977,51003,12,51005,51031,12,51033,51059,12,51061,51087,12,51089,51115,12,51117,51143,12,51145,51171,12,51173,51199,12,51201,51227,12,51229,51255,12,51257,51283,12,51285,51311,12,51313,51339,12,51341,51367,12,51369,51395,12,51397,51423,12,51425,51451,12,51453,51479,12,51481,51507,12,51509,51535,12,51537,51563,12,51565,51591,12,51593,51619,12,51621,51647,12,51649,51675,12,51677,51703,12,51705,51731,12,51733,51759,12,51761,51787,12,51789,51815,12,51817,51843,12,51845,51871,12,51873,51899,12,51901,51927,12,51929,51955,12,51957,51983,12,51985,52011,12,52013,52039,12,52041,52067,12,52069,52095,12,52097,52123,12,52125,52151,12,52153,52179,12,52181,52207,12,52209,52235,12,52237,52263,12,52265,52291,12,52293,52319,12,52321,52347,12,52349,52375,12,52377,52403,12,52405,52431,12,52433,52459,12,52461,52487,12,52489,52515,12,52517,52543,12,52545,52571,12,52573,52599,12,52601,52627,12,52629,52655,12,52657,52683,12,52685,52711,12,52713,52739,12,52741,52767,12,52769,52795,12,52797,52823,12,52825,52851,12,52853,52879,12,52881,52907,12,52909,52935,12,52937,52963,12,52965,52991,12,52993,53019,12,53021,53047,12,53049,53075,12,53077,53103,12,53105,53131,12,53133,53159,12,53161,53187,12,53189,53215,12,53217,53243,12,53245,53271,12,53273,53299,12,53301,53327,12,53329,53355,12,53357,53383,12,53385,53411,12,53413,53439,12,53441,53467,12,53469,53495,12,53497,53523,12,53525,53551,12,53553,53579,12,53581,53607,12,53609,53635,12,53637,53663,12,53665,53691,12,53693,53719,12,53721,53747,12,53749,53775,12,53777,53803,12,53805,53831,12,53833,53859,12,53861,53887,12,53889,53915,12,53917,53943,12,53945,53971,12,53973,53999,12,54001,54027,12,54029,54055,12,54057,54083,12,54085,54111,12,54113,54139,12,54141,54167,12,54169,54195,12,54197,54223,12,54225,54251,12,54253,54279,12,54281,54307,12,54309,54335,12,54337,54363,12,54365,54391,12,54393,54419,12,54421,54447,12,54449,54475,12,54477,54503,12,54505,54531,12,54533,54559,12,54561,54587,12,54589,54615,12,54617,54643,12,54645,54671,12,54673,54699,12,54701,54727,12,54729,54755,12,54757,54783,12,54785,54811,12,54813,54839,12,54841,54867,12,54869,54895,12,54897,54923,12,54925,54951,12,54953,54979,12,54981,55007,12,55009,55035,12,55037,55063,12,55065,55091,12,55093,55119,12,55121,55147,12,55149,55175,12,55177,55203,12,55243,55291,10,65024,65039,5,65279,65279,4,65520,65528,4,66045,66045,5,66422,66426,5,68101,68102,5,68152,68154,5,68325,68326,5,69291,69292,5,69632,69632,7,69634,69634,7,69759,69761,5]")}function Te(j,we){if(j===0)return 0;const _e=ce(j,we);if(_e!==void 0)return _e;const Ae=F(we,j);return j-=ue(Ae),j}e.getLeftDeleteOffset=Te;function ce(j,we){let _e=F(we,j);for(j-=ue(_e);pe(_e)||_e===65039||_e===8419;){if(j===0)return;_e=F(we,j),j-=ue(_e)}if(!!Z(_e)){if(j>=0){const Ae=F(we,j);Ae===8205&&(j-=ue(Ae))}return j}}function ue(j){return j>=65536?2:1}function pe(j){return 127995<=j&&j<=127999}var be;(function(j){j[j.zwj=8205]="zwj",j[j.emojiVariantSelector=65039]="emojiVariantSelector",j[j.enclosingKeyCap=8419]="enclosingKeyCap"})(be||(be={}))}),define(me[24],ge([0,1,8,96]),function(J,e,g,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const k=typeof Buffer!="undefined",S=typeof TextEncoder!="undefined",T=typeof TextDecoder!="undefined";let D,y;class A{constructor(f){this.buffer=f,this.byteLength=this.buffer.byteLength}static alloc(f){return k?new A(Buffer.allocUnsafe(f)):new A(new Uint8Array(f))}static wrap(f){return k&&!Buffer.isBuffer(f)&&(f=Buffer.from(f.buffer,f.byteOffset,f.byteLength)),new A(f)}static fromString(f,w){return!(w?.dontUseNodeBuffer||!1)&&k?new A(Buffer.from(f)):S?(D||(D=new TextEncoder),new A(D.encode(f))):new A(g.encodeUTF8(f))}static concat(f,w){if(typeof w=="undefined"){w=0;for(let I=0,L=f.length;I<L;I++)w+=f[I].byteLength}const E=A.alloc(w);let o=0;for(let I=0,L=f.length;I<L;I++){const U=f[I];E.set(U,o),o+=U.byteLength}return E}toString(){return k?this.buffer.toString():T?(y||(y=new TextDecoder),y.decode(this.buffer)):g.decodeUTF8(this.buffer)}slice(f,w){return new A(this.buffer.subarray(f,w))}set(f,w){f instanceof A?this.buffer.set(f.buffer,w):this.buffer.set(f,w)}readUInt32BE(f){return u(this.buffer,f)}writeUInt32BE(f,w){m(this.buffer,f,w)}readUInt32LE(f){return l(this.buffer,f)}writeUInt32LE(f,w){v(this.buffer,f,w)}readUInt8(f){return _(this.buffer,f)}writeUInt8(f,w){b(this.buffer,f,w)}}e.VSBuffer=A;function i(d,f){return d[f+0]<<0>>>0|d[f+1]<<8>>>0}e.readUInt16LE=i;function C(d,f,w){d[w+0]=f&255,f=f>>>8,d[w+1]=f&255}e.writeUInt16LE=C;function u(d,f){return d[f]*2**24+d[f+1]*2**16+d[f+2]*2**8+d[f+3]}e.readUInt32BE=u;function m(d,f,w){d[w+3]=f,f=f>>>8,d[w+2]=f,f=f>>>8,d[w+1]=f,f=f>>>8,d[w]=f}e.writeUInt32BE=m;function l(d,f){return d[f+0]<<0>>>0|d[f+1]<<8>>>0|d[f+2]<<16>>>0|d[f+3]<<24>>>0}e.readUInt32LE=l;function v(d,f,w){d[w+0]=f&255,f=f>>>8,d[w+1]=f&255,f=f>>>8,d[w+2]=f&255,f=f>>>8,d[w+3]=f&255}e.writeUInt32LE=v;function _(d,f){return d[f]}e.readUInt8=_;function b(d,f,w){d[w]=f}e.writeUInt8=b;function P(d){return R.consumeReadable(d,f=>A.concat(f))}e.readableToBuffer=P;function c(d){return R.toReadable(d)}e.bufferToReadable=c;function h(d){return R.consumeStream(d,f=>A.concat(f))}e.streamToBuffer=h;async function p(d){return d.ended?A.concat(d.buffer):A.concat([...d.buffer,await h(d.stream)])}e.bufferedStreamToBuffer=p;function t(d){return R.toStream(d,f=>A.concat(f))}e.bufferToStream=t;function r(d){return R.transform(d,{data:f=>typeof f=="string"?A.fromString(f):A.wrap(f)},f=>A.concat(f))}e.streamToBufferReadableStream=r;function s(d){return R.newWriteableStream(f=>A.concat(f),d)}e.newWriteableBufferStream=s;function n(d,f){return R.prefixedReadable(d,f,w=>A.concat(w))}e.prefixedBufferReadable=n;function a(d,f){return R.prefixedStream(d,f,w=>A.concat(w))}e.prefixedBufferStream=a}),define(me[58],ge([0,1,8]),function(J,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.doHash=e.hash=void 0;function R(b){return k(b,0)}e.hash=R;function k(b,P){switch(typeof b){case"object":return b===null?S(349,P):Array.isArray(b)?y(b,P):A(b,P);case"string":return D(b,P);case"boolean":return T(b,P);case"number":return S(b,P);case"undefined":return S(937,P);default:return S(617,P)}}e.doHash=k;function S(b,P){return(P<<5)-P+b|0}function T(b,P){return S(b?433:863,P)}function D(b,P){P=S(149417,P);for(let c=0,h=b.length;c<h;c++)P=S(b.charCodeAt(c),P);return P}e.stringHash=D;function y(b,P){return P=S(104579,P),b.reduce((c,h)=>k(h,c),P)}function A(b,P){return P=S(181387,P),Object.keys(b).sort().reduce((c,h)=>(c=D(h,c),k(b[h],c)),P)}class i{constructor(){this._value=0}get value(){return this._value}hash(P){return this._value=k(P,this._value),this._value}}e.Hasher=i;var C;(function(b){b[b.BLOCK_SIZE=64]="BLOCK_SIZE",b[b.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(C||(C={}));function u(b,P,c=32){const h=c-P,p=~((1<<h)-1);return(b<<P|(p&b)>>>h)>>>0}function m(b,P=0,c=b.byteLength,h=0){for(let p=0;p<c;p++)b[P+p]=h}function l(b,P,c="0"){for(;b.length<P;)b=c+b;return b}function v(b,P=32){return b instanceof ArrayBuffer?Array.from(new Uint8Array(b)).map(c=>c.toString(16).padStart(2,"0")).join(""):l((b>>>0).toString(16),P/4)}e.toHexString=v;class _{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(P){const c=P.length;if(c===0)return;const h=this._buff;let p=this._buffLen,t=this._leftoverHighSurrogate,r,s;for(t!==0?(r=t,s=-1,t=0):(r=P.charCodeAt(0),s=0);;){let n=r;if(g.isHighSurrogate(r))if(s+1<c){const a=P.charCodeAt(s+1);g.isLowSurrogate(a)?(s++,n=g.computeCodePoint(r,a)):n=65533}else{t=r;break}else g.isLowSurrogate(r)&&(n=65533);if(p=this._push(h,p,n),s++,s<c)r=P.charCodeAt(s);else break}this._buffLen=p,this._leftoverHighSurrogate=t}_push(P,c,h){return h<128?P[c++]=h:h<2048?(P[c++]=192|(h&1984)>>>6,P[c++]=128|(h&63)>>>0):h<65536?(P[c++]=224|(h&61440)>>>12,P[c++]=128|(h&4032)>>>6,P[c++]=128|(h&63)>>>0):(P[c++]=240|(h&1835008)>>>18,P[c++]=128|(h&258048)>>>12,P[c++]=128|(h&4032)>>>6,P[c++]=128|(h&63)>>>0),c>=64&&(this._step(),c-=64,this._totalLen+=64,P[0]=P[64+0],P[1]=P[64+1],P[2]=P[64+2]),c}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),v(this._h0)+v(this._h1)+v(this._h2)+v(this._h3)+v(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,m(this._buff,this._buffLen),this._buffLen>56&&(this._step(),m(this._buff));const P=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(P/4294967296),!1),this._buffDV.setUint32(60,P%4294967296,!1),this._step()}_step(){const P=_._bigBlock32,c=this._buffDV;for(let f=0;f<64;f+=4)P.setUint32(f,c.getUint32(f,!1),!1);for(let f=64;f<320;f+=4)P.setUint32(f,u(P.getUint32(f-12,!1)^P.getUint32(f-32,!1)^P.getUint32(f-56,!1)^P.getUint32(f-64,!1),1),!1);let h=this._h0,p=this._h1,t=this._h2,r=this._h3,s=this._h4,n,a,d;for(let f=0;f<80;f++)f<20?(n=p&t|~p&r,a=1518500249):f<40?(n=p^t^r,a=1859775393):f<60?(n=p&t|p&r|t&r,a=2400959708):(n=p^t^r,a=3395469782),d=u(h,5)+n+s+a+P.getUint32(f*4,!1)&4294967295,s=r,r=t,t=u(p,30),p=h,h=d;this._h0=this._h0+h&4294967295,this._h1=this._h1+p&4294967295,this._h2=this._h2+t&4294967295,this._h3=this._h3+r&4294967295,this._h4=this._h4+s&4294967295}}e.StringSHA1=_,_._bigBlock32=new DataView(new ArrayBuffer(320))}),define(me[48],ge([0,1,8]),function(J,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var R;(function(k){k[k.Ignore=0]="Ignore",k[k.Info=1]="Info",k[k.Warning=2]="Warning",k[k.Error=3]="Error"})(R||(R={})),function(k){const S="error",T="warning",D="warn",y="info",A="ignore";function i(u){return u?g.equalsIgnoreCase(S,u)?k.Error:g.equalsIgnoreCase(T,u)||g.equalsIgnoreCase(D,u)?k.Warning:g.equalsIgnoreCase(y,u)?k.Info:k.Ignore:k.Ignore}k.fromValue=i;function C(u){switch(u){case k.Error:return S;case k.Warning:return T;case k.Info:return y;default:return A}}k.toString=C}(R||(R={})),e.default=R}),define(me[14],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.assertNever=e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function g(f){return Array.isArray(f)}e.isArray=g;function R(f){return typeof f=="string"}e.isString=R;function k(f){return Array.isArray(f)&&f.every(w=>R(w))}e.isStringArray=k;function S(f){return typeof f=="object"&&f!==null&&!Array.isArray(f)&&!(f instanceof RegExp)&&!(f instanceof Date)}e.isObject=S;function T(f){return typeof f=="number"&&!isNaN(f)}e.isNumber=T;function D(f){return!!f&&typeof f[Symbol.iterator]=="function"}e.isIterable=D;function y(f){return f===!0||f===!1}e.isBoolean=y;function A(f){return typeof f=="undefined"}e.isUndefined=A;function i(f){return!C(f)}e.isDefined=i;function C(f){return A(f)||f===null}e.isUndefinedOrNull=C;function u(f,w){if(!f)throw new Error(w?`Unexpected type, expected '${w}'`:"Unexpected type")}e.assertType=u;function m(f){if(C(f))throw new Error("Assertion Failed: argument is undefined or null");return f}e.assertIsDefined=m;function l(...f){const w=[];for(let E=0;E<f.length;E++){const o=f[E];if(C(o))throw new Error(`Assertion Failed: argument at index ${E} is undefined or null`);w.push(o)}return w}e.assertAllDefined=l;const v=Object.prototype.hasOwnProperty;function _(f){if(!S(f))return!1;for(let w in f)if(v.call(f,w))return!1;return!0}e.isEmptyObject=_;function b(f){return typeof f=="function"}e.isFunction=b;function P(...f){return f.length>0&&f.every(b)}e.areFunctions=P;function c(f,w){const E=Math.min(f.length,w.length);for(let o=0;o<E;o++)h(f[o],w[o])}e.validateConstraints=c;function h(f,w){if(R(w)){if(typeof f!==w)throw new Error(`argument does not match constraint: typeof ${w}`)}else if(b(w)){try{if(f instanceof w)return}catch{}if(!C(f)&&f.constructor===w||w.length===1&&w.call(void 0,f)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=h;function p(f){let w=[],E=Object.getPrototypeOf(f);for(;Object.prototype!==E;)w=w.concat(Object.getOwnPropertyNames(E)),E=Object.getPrototypeOf(E);return w}e.getAllPropertyNames=p;function t(f){const w=[];for(const E of p(f))typeof f[E]=="function"&&w.push(E);return w}e.getAllMethodNames=t;function r(f,w){const E=I=>function(){const L=Array.prototype.slice.call(arguments,0);return w(I,L)};let o={};for(const I of f)o[I]=E(I);return o}e.createProxyObject=r;function s(f){return f===null?void 0:f}e.withNullAsUndefined=s;function n(f){return typeof f=="undefined"?null:f}e.withUndefinedAsNull=n;function a(f){return class{constructor(){return new Proxy({},{get(w,E){if(w[E])return w[E];throw new Error(`Not Implemented: ${f}->${String(E)}`)}})}}}e.NotImplementedProxy=a;function d(f,w="Unreachable"){throw new Error(w)}e.assertNever=d}),define(me[29],ge([0,1,11,8,9,14]),function(J,e,g,R,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function T(s){return s===47||s===92}e.isPathSeparator=T;function D(s){return s.replace(/[\\/]/g,k.posix.sep)}e.toSlashes=D;function y(s){return s.indexOf("/")===-1&&(s=D(s)),/^[a-zA-Z]:(\/|$)/.test(s)&&(s="/"+s),s}e.toPosixPath=y;function A(s,n=k.posix.sep){if(!s)return"";const a=s.length,d=s.charCodeAt(0);if(T(d)){if(T(s.charCodeAt(1))&&!T(s.charCodeAt(2))){let w=3;const E=w;for(;w<a&&!T(s.charCodeAt(w));w++);if(E!==w&&!T(s.charCodeAt(w+1))){for(w+=1;w<a;w++)if(T(s.charCodeAt(w)))return s.slice(0,w+1).replace(/[\\/]/g,n)}}return n}else if(b(d)&&s.charCodeAt(1)===58)return T(s.charCodeAt(2))?s.slice(0,2)+n:s.slice(0,2);let f=s.indexOf("://");if(f!==-1){for(f+=3;f<a;f++)if(T(s.charCodeAt(f)))return s.slice(0,f+1)}return""}e.getRoot=A;function i(s){if(!g.isWindows||!s||s.length<5)return!1;let n=s.charCodeAt(0);if(n!==92||(n=s.charCodeAt(1),n!==92))return!1;let a=2;const d=a;for(;a<s.length&&(n=s.charCodeAt(a),n!==92);a++);return!(d===a||(n=s.charCodeAt(a+1),isNaN(n)||n===92))}e.isUNC=i;const C=/[\\/:\*\?"<>\|]/g,u=/[\\/]/g,m=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function l(s,n=g.isWindows){const a=n?C:u;return!(!s||s.length===0||/^\s+$/.test(s)||(a.lastIndex=0,a.test(s))||n&&m.test(s)||s==="."||s===".."||n&&s[s.length-1]==="."||n&&s.length!==s.trim().length||s.length>255)}e.isValidBasename=l;function v(s,n,a){const d=s===n;return!a||d?d:!s||!n?!1:(0,R.equalsIgnoreCase)(s,n)}e.isEqual=v;function _(s,n,a,d=k.sep){if(s===n)return!0;if(!s||!n||n.length>s.length)return!1;if(a){if(!(0,R.startsWithIgnoreCase)(s,n))return!1;if(n.length===s.length)return!0;let w=n.length;return n.charAt(n.length-1)===d&&w--,s.charAt(w)===d}return n.charAt(n.length-1)!==d&&(n+=d),s.indexOf(n)===0}e.isEqualOrParent=_;function b(s){return s>=65&&s<=90||s>=97&&s<=122}e.isWindowsDriveLetter=b;function P(s,n){return g.isWindows&&s.endsWith(":")&&(s+=k.sep),(0,k.isAbsolute)(s)||(s=(0,k.join)(n,s)),s=(0,k.normalize)(s),g.isWindows?(s=(0,R.rtrim)(s,k.sep),s.endsWith(":")&&(s+=k.sep)):(s=(0,R.rtrim)(s,k.sep),s||(s=k.sep)),s}e.sanitizeFilePath=P;function c(s){const n=(0,k.normalize)(s);return g.isWindows?s.length>3?!1:h(n)&&(s.length===2||n.charCodeAt(2)===92):n===k.posix.sep}e.isRootOrDriveLetter=c;function h(s){return g.isWindows?b(s.charCodeAt(0))&&s.charCodeAt(1)===58:!1}e.hasDriveLetter=h;function p(s){return h(s)?s[0]:void 0}e.getDriveLetter=p;function t(s,n,a){return n.length>s.length?-1:s===n?0:(a&&(s=s.toLowerCase(),n=n.toLowerCase()),s.indexOf(n))}e.indexOfPath=t;function r(s){const n=s.split(":");let a,d,f;if(n.forEach(w=>{const E=Number(w);(0,S.isNumber)(E)?d===void 0?d=E:f===void 0&&(f=E):a=a?[a,w].join(":"):w}),!a)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:a,line:d!==void 0?d:void 0,column:f!==void 0?f:d!==void 0?1:void 0}}e.parseLineAndColumnAware=r}),define(me[25],ge([0,1,14]),function(J,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function R(v){if(!v||typeof v!="object"||v instanceof RegExp)return v;const _=Array.isArray(v)?[]:{};return Object.keys(v).forEach(b=>{v[b]&&typeof v[b]=="object"?_[b]=R(v[b]):_[b]=v[b]}),_}e.deepClone=R;function k(v){if(!v||typeof v!="object")return v;const _=[v];for(;_.length>0;){const b=_.shift();Object.freeze(b);for(const P in b)if(S.call(b,P)){const c=b[P];typeof c=="object"&&!Object.isFrozen(c)&&_.push(c)}}return v}e.deepFreeze=k;const S=Object.prototype.hasOwnProperty;function T(v,_){return D(v,_,new Set)}e.cloneAndChange=T;function D(v,_,b){if((0,g.isUndefinedOrNull)(v))return v;const P=_(v);if(typeof P!="undefined")return P;if((0,g.isArray)(v)){const c=[];for(const h of v)c.push(D(h,_,b));return c}if((0,g.isObject)(v)){if(b.has(v))throw new Error("Cannot clone recursive data-structure");b.add(v);const c={};for(let h in v)S.call(v,h)&&(c[h]=D(v[h],_,b));return b.delete(v),c}return v}function y(v,_,b=!0){return(0,g.isObject)(v)?((0,g.isObject)(_)&&Object.keys(_).forEach(P=>{P in v?b&&((0,g.isObject)(v[P])&&(0,g.isObject)(_[P])?y(v[P],_[P],b):v[P]=_[P]):v[P]=_[P]}),v):_}e.mixin=y;function A(v,_){if(v===_)return!0;if(v==null||_===null||_===void 0||typeof v!=typeof _||typeof v!="object"||Array.isArray(v)!==Array.isArray(_))return!1;let b,P;if(Array.isArray(v)){if(v.length!==_.length)return!1;for(b=0;b<v.length;b++)if(!A(v[b],_[b]))return!1}else{const c=[];for(P in v)c.push(P);c.sort();const h=[];for(P in _)h.push(P);if(h.sort(),!A(c,h))return!1;for(b=0;b<c.length;b++)if(!A(v[c[b]],_[c[b]]))return!1}return!0}e.equals=A;function i(v){const _=new Set;return JSON.stringify(v,(b,P)=>{if((0,g.isObject)(P)||Array.isArray(P)){if(_.has(P))return"[Circular]";_.add(P)}return P})}e.safeStringify=i;function C(v,_,b){const P=_(v);return typeof P=="undefined"?b:P}e.getOrDefault=C;function u(v,_){const b=Object.create(null);return!v||!_||Object.keys(_).forEach(c=>{const h=v[c],p=_[c];A(h,p)||(b[c]=p)}),b}e.distinct=u;function m(v,_){const b=_.toLowerCase(),P=Object.keys(v).find(c=>c.toLowerCase()===b);return P?v[P]:v[_]}e.getCaseInsensitive=m;function l(v,_){const b=Object.create(null);for(const P of Object.keys(v))_(P,v[P])&&(b[P]=v[P]);return b}e.filter=l}),define(me[97],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toUint32=e.toUint8=e.Constants=void 0;var g;(function(S){S[S.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",S[S.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",S[S.MAX_UINT_8=255]="MAX_UINT_8",S[S.MAX_UINT_16=65535]="MAX_UINT_16",S[S.MAX_UINT_32=4294967295]="MAX_UINT_32",S[S.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(g=e.Constants||(e.Constants={}));function R(S){return S<0?0:S>255?255:S|0}e.toUint8=R;function k(S){return S<0?0:S>4294967295?4294967295:S|0}e.toUint32=k}),define(me[2],ge([0,1,11,9]),function(J,e,g,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const k=/^\w[\w\d+.-]*$/,S=/^\//,T=/^\/\//;function D(s,n){if(!s.scheme&&n)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${s.authority}", path: "${s.path}", query: "${s.query}", fragment: "${s.fragment}"}`);if(s.scheme&&!k.test(s.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(s.path){if(s.authority){if(!S.test(s.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(T.test(s.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function y(s,n){return!s&&!n?"file":s}function A(s,n){switch(s){case"https":case"http":case"file":n?n[0]!==C&&(n=C+n):n=C;break}return n}const i="",C="/",u=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class m{constructor(n,a,d,f,w,E=!1){typeof n=="object"?(this.scheme=n.scheme||i,this.authority=n.authority||i,this.path=n.path||i,this.query=n.query||i,this.fragment=n.fragment||i):(this.scheme=y(n,E),this.authority=a||i,this.path=A(this.scheme,d||i),this.query=f||i,this.fragment=w||i,D(this,E))}static isUri(n){return n instanceof m?!0:n?typeof n.authority=="string"&&typeof n.fragment=="string"&&typeof n.path=="string"&&typeof n.query=="string"&&typeof n.scheme=="string"&&typeof n.fsPath=="string"&&typeof n.with=="function"&&typeof n.toString=="function":!1}get fsPath(){return c(this,!1)}with(n){if(!n)return this;let{scheme:a,authority:d,path:f,query:w,fragment:E}=n;return a===void 0?a=this.scheme:a===null&&(a=i),d===void 0?d=this.authority:d===null&&(d=i),f===void 0?f=this.path:f===null&&(f=i),w===void 0?w=this.query:w===null&&(w=i),E===void 0?E=this.fragment:E===null&&(E=i),a===this.scheme&&d===this.authority&&f===this.path&&w===this.query&&E===this.fragment?this:new v(a,d,f,w,E)}static parse(n,a=!1){const d=u.exec(n);return d?new v(d[2]||i,r(d[4]||i),r(d[5]||i),r(d[7]||i),r(d[9]||i),a):new v(i,i,i,i,i)}static file(n){let a=i;if(g.isWindows&&(n=n.replace(/\\/g,C)),n[0]===C&&n[1]===C){const d=n.indexOf(C,2);d===-1?(a=n.substring(2),n=C):(a=n.substring(2,d),n=n.substring(d)||C)}return new v("file",a,n,i,i)}static from(n){const a=new v(n.scheme,n.authority,n.path,n.query,n.fragment);return D(a,!0),a}static joinPath(n,...a){if(!n.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let d;return g.isWindows&&n.scheme==="file"?d=m.file(R.win32.join(c(n,!0),...a)).path:d=R.posix.join(n.path,...a),n.with({path:d})}toString(n=!1){return h(this,n)}toJSON(){return this}static revive(n){if(n){if(n instanceof m)return n;{const a=new v(n);return a._formatted=n.external,a._fsPath=n._sep===l?n.fsPath:null,a}}else return n}}e.URI=m;const l=g.isWindows?1:void 0;class v extends m{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=c(this,!1)),this._fsPath}toString(n=!1){return n?h(this,!0):(this._formatted||(this._formatted=h(this,!1)),this._formatted)}toJSON(){const n={$mid:1};return this._fsPath&&(n.fsPath=this._fsPath,n._sep=l),this._formatted&&(n.external=this._formatted),this.path&&(n.path=this.path),this.scheme&&(n.scheme=this.scheme),this.authority&&(n.authority=this.authority),this.query&&(n.query=this.query),this.fragment&&(n.fragment=this.fragment),n}}const _={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function b(s,n){let a,d=-1;for(let f=0;f<s.length;f++){const w=s.charCodeAt(f);if(w>=97&&w<=122||w>=65&&w<=90||w>=48&&w<=57||w===45||w===46||w===95||w===126||n&&w===47)d!==-1&&(a+=encodeURIComponent(s.substring(d,f)),d=-1),a!==void 0&&(a+=s.charAt(f));else{a===void 0&&(a=s.substr(0,f));const E=_[w];E!==void 0?(d!==-1&&(a+=encodeURIComponent(s.substring(d,f)),d=-1),a+=E):d===-1&&(d=f)}}return d!==-1&&(a+=encodeURIComponent(s.substring(d))),a!==void 0?a:s}function P(s){let n;for(let a=0;a<s.length;a++){const d=s.charCodeAt(a);d===35||d===63?(n===void 0&&(n=s.substr(0,a)),n+=_[d]):n!==void 0&&(n+=s[a])}return n!==void 0?n:s}function c(s,n){let a;return s.authority&&s.path.length>1&&s.scheme==="file"?a=`//${s.authority}${s.path}`:s.path.charCodeAt(0)===47&&(s.path.charCodeAt(1)>=65&&s.path.charCodeAt(1)<=90||s.path.charCodeAt(1)>=97&&s.path.charCodeAt(1)<=122)&&s.path.charCodeAt(2)===58?n?a=s.path.substr(1):a=s.path[1].toLowerCase()+s.path.substr(2):a=s.path,g.isWindows&&(a=a.replace(/\//g,"\\")),a}e.uriToFsPath=c;function h(s,n){const a=n?P:b;let d="",{scheme:f,authority:w,path:E,query:o,fragment:I}=s;if(f&&(d+=f,d+=":"),(w||f==="file")&&(d+=C,d+=C),w){let L=w.indexOf("@");if(L!==-1){const U=w.substr(0,L);w=w.substr(L+1),L=U.indexOf(":"),L===-1?d+=a(U,!1):(d+=a(U.substr(0,L),!1),d+=":",d+=a(U.substr(L+1),!1)),d+="@"}w=w.toLowerCase(),L=w.indexOf(":"),L===-1?d+=a(w,!1):(d+=a(w.substr(0,L),!1),d+=w.substr(L))}if(E){if(E.length>=3&&E.charCodeAt(0)===47&&E.charCodeAt(2)===58){const L=E.charCodeAt(1);L>=65&&L<=90&&(E=`/${String.fromCharCode(L+32)}:${E.substr(3)}`)}else if(E.length>=2&&E.charCodeAt(1)===58){const L=E.charCodeAt(0);L>=65&&L<=90&&(E=`${String.fromCharCode(L+32)}:${E.substr(2)}`)}d+=a(E,!0)}return o&&(d+="?",d+=a(o,!1)),I&&(d+="#",d+=n?I:b(I,!1)),d}function p(s){try{return decodeURIComponent(s)}catch{return s.length>3?s.substr(0,3)+p(s.substr(3)):s}}const t=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function r(s){return s.match(t)?s.replace(t,n=>p(n)):s}});var it=this&&this.__classPrivateFieldSet||function(J,e,g,R,k){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!k:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?k.call(J,g):k?k.value=g:e.set(J,g),g},He=this&&this.__classPrivateFieldGet||function(J,e,g,R){if(g==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!R:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?R:g==="a"?R.call(J):R?R.value:e.get(J)};define(me[22],ge([0,1,2,8]),function(J,e,g,R){"use strict";var k,S,T;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function D(t,r,s){let n=t.get(r);return n===void 0&&(n=s,t.set(r,n)),n}e.getOrSet=D;function y(t){const r=[];return t.forEach((s,n)=>{r.push(`${n} => ${s}`)}),`Map(${t.size}) {${r.join(", ")}}`}e.mapToString=y;function A(t){const r=[];return t.forEach(s=>{r.push(s)}),`Set(${t.size}) {${r.join(", ")}}`}e.setToString=A;class i{constructor(){this._value="",this._pos=0}reset(r){return this._value=r,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(r){const s=r.charCodeAt(0),n=this._value.charCodeAt(this._pos);return s-n}value(){return this._value[this._pos]}}e.StringIterator=i;class C{constructor(r=!0){this._caseSensitive=r}reset(r){return this._value=r,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let r=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(r)this._from++;else break;else r=!1;return this}cmp(r){return this._caseSensitive?(0,R.compareSubstring)(r,this._value,0,r.length,this._from,this._to):(0,R.compareSubstringIgnoreCase)(r,this._value,0,r.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=C;class u{constructor(r=!0,s=!0){this._splitOnBackslash=r,this._caseSensitive=s}reset(r){return this._value=r.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let r=!0;for(;this._to<this._value.length;this._to++){const s=this._value.charCodeAt(this._to);if(s===47||this._splitOnBackslash&&s===92)if(r)this._from++;else break;else r=!1}return this}cmp(r){return this._caseSensitive?(0,R.compareSubstring)(r,this._value,0,r.length,this._from,this._to):(0,R.compareSubstringIgnoreCase)(r,this._value,0,r.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=u;var m;(function(t){t[t.Scheme=1]="Scheme",t[t.Authority=2]="Authority",t[t.Path=3]="Path",t[t.Query=4]="Query",t[t.Fragment=5]="Fragment"})(m||(m={}));class l{constructor(r){this._ignorePathCasing=r,this._states=[],this._stateIdx=0}reset(r){return this._value=r,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new u(!1,!this._ignorePathCasing(r)),this._pathIterator.reset(r.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(r){if(this._states[this._stateIdx]===1)return(0,R.compareIgnoreCase)(r,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,R.compareIgnoreCase)(r,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(r);if(this._states[this._stateIdx]===4)return(0,R.compare)(r,this._value.query);if(this._states[this._stateIdx]===5)return(0,R.compare)(r,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=l;class v{isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}}class _{constructor(r){this._iter=r}static forUris(r=()=>!1){return new _(new l(r))}static forPaths(){return new _(new u)}static forStrings(){return new _(new i)}static forConfigKeys(){return new _(new C)}clear(){this._root=void 0}set(r,s){const n=this._iter.reset(r);let a;for(this._root||(this._root=new v,this._root.segment=n.value()),a=this._root;;){const f=n.cmp(a.segment);if(f>0)a.left||(a.left=new v,a.left.segment=n.value()),a=a.left;else if(f<0)a.right||(a.right=new v,a.right.segment=n.value()),a=a.right;else if(n.hasNext())n.next(),a.mid||(a.mid=new v,a.mid.segment=n.value()),a=a.mid;else break}const d=a.value;return a.value=s,a.key=r,d}get(r){return this._getNode(r)?.value}_getNode(r){const s=this._iter.reset(r);let n=this._root;for(;n;){const a=s.cmp(n.segment);if(a>0)n=n.left;else if(a<0)n=n.right;else if(s.hasNext())s.next(),n=n.mid;else break}return n}has(r){const s=this._getNode(r);return!(s?.value===void 0&&s?.mid===void 0)}delete(r){return this._delete(r,!1)}deleteSuperstr(r){return this._delete(r,!0)}_delete(r,s){const n=this._iter.reset(r),a=[];let d=this._root;for(;d;){const f=n.cmp(d.segment);if(f>0)a.push([1,d]),d=d.left;else if(f<0)a.push([-1,d]),d=d.right;else if(n.hasNext())n.next(),a.push([0,d]),d=d.mid;else{for(s?(d.left=void 0,d.mid=void 0,d.right=void 0):d.value=void 0;a.length>0&&d.isEmpty();){let[w,E]=a.pop();switch(w){case 1:E.left=void 0;break;case 0:E.mid=void 0;break;case-1:E.right=void 0;break}d=E}break}}}findSubstr(r){const s=this._iter.reset(r);let n=this._root,a;for(;n;){const d=s.cmp(n.segment);if(d>0)n=n.left;else if(d<0)n=n.right;else if(s.hasNext())s.next(),a=n.value||a,n=n.mid;else break}return n&&n.value||a}findSuperstr(r){const s=this._iter.reset(r);let n=this._root;for(;n;){const a=s.cmp(n.segment);if(a>0)n=n.left;else if(a<0)n=n.right;else if(s.hasNext())s.next(),n=n.mid;else return n.mid?this._entries(n.mid):void 0}}forEach(r){for(const[s,n]of this)r(n,s)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(r){if(!r)return;const s=[r];for(;s.length>0;){const n=s.pop();n&&(n.value&&(yield[n.key,n.value]),n.left&&s.push(n.left),n.mid&&s.push(n.mid),n.right&&s.push(n.right))}}}e.TernarySearchTree=_;class b{constructor(r,s){this[k]="ResourceMap",r instanceof b?(this.map=new Map(r.map),this.toKey=s??b.defaultToKey):(this.map=new Map,this.toKey=r??b.defaultToKey)}set(r,s){return this.map.set(this.toKey(r),s),this}get(r){return this.map.get(this.toKey(r))}has(r){return this.map.has(this.toKey(r))}get size(){return this.map.size}clear(){this.map.clear()}delete(r){return this.map.delete(this.toKey(r))}forEach(r,s){typeof s!="undefined"&&(r=r.bind(s));for(let[n,a]of this.map)r(a,g.URI.parse(n),this)}values(){return this.map.values()}*keys(){for(let r of this.map.keys())yield g.URI.parse(r)}*entries(){for(let r of this.map.entries())yield[g.URI.parse(r[0]),r[1]]}*[(k=Symbol.toStringTag,Symbol.iterator)](){for(let r of this.map)yield[g.URI.parse(r[0]),r[1]]}}e.ResourceMap=b,b.defaultToKey=t=>t.toString();var P;(function(t){t[t.None=0]="None",t[t.AsOld=1]="AsOld",t[t.AsNew=2]="AsNew"})(P=e.Touch||(e.Touch={}));class c{constructor(){this[S]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(r){return this._map.has(r)}get(r,s=0){const n=this._map.get(r);if(!!n)return s!==0&&this.touch(n,s),n.value}set(r,s,n=0){let a=this._map.get(r);if(a)a.value=s,n!==0&&this.touch(a,n);else{switch(a={key:r,value:s,next:void 0,previous:void 0},n){case 0:this.addItemLast(a);break;case 1:this.addItemFirst(a);break;case 2:this.addItemLast(a);break;default:this.addItemLast(a);break}this._map.set(r,a),this._size++}return this}delete(r){return!!this.remove(r)}remove(r){const s=this._map.get(r);if(!!s)return this._map.delete(r),this.removeItem(s),this._size--,s.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const r=this._head;return this._map.delete(r.key),this.removeItem(r),this._size--,r.value}forEach(r,s){const n=this._state;let a=this._head;for(;a;){if(s?r.bind(s)(a.value,a.key,this):r(a.value,a.key,this),this._state!==n)throw new Error("LinkedMap got modified during iteration.");a=a.next}}keys(){const r=this,s=this._state;let n=this._head;const a={[Symbol.iterator](){return a},next(){if(r._state!==s)throw new Error("LinkedMap got modified during iteration.");if(n){const d={value:n.key,done:!1};return n=n.next,d}else return{value:void 0,done:!0}}};return a}values(){const r=this,s=this._state;let n=this._head;const a={[Symbol.iterator](){return a},next(){if(r._state!==s)throw new Error("LinkedMap got modified during iteration.");if(n){const d={value:n.value,done:!1};return n=n.next,d}else return{value:void 0,done:!0}}};return a}entries(){const r=this,s=this._state;let n=this._head;const a={[Symbol.iterator](){return a},next(){if(r._state!==s)throw new Error("LinkedMap got modified during iteration.");if(n){const d={value:[n.key,n.value],done:!1};return n=n.next,d}else return{value:void 0,done:!0}}};return a}[(S=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(r){if(r>=this.size)return;if(r===0){this.clear();return}let s=this._head,n=this.size;for(;s&&n>r;)this._map.delete(s.key),s=s.next,n--;this._head=s,this._size=n,s&&(s.previous=void 0),this._state++}addItemFirst(r){if(!this._head&&!this._tail)this._tail=r;else if(this._head)r.next=this._head,this._head.previous=r;else throw new Error("Invalid list");this._head=r,this._state++}addItemLast(r){if(!this._head&&!this._tail)this._head=r;else if(this._tail)r.previous=this._tail,this._tail.next=r;else throw new Error("Invalid list");this._tail=r,this._state++}removeItem(r){if(r===this._head&&r===this._tail)this._head=void 0,this._tail=void 0;else if(r===this._head){if(!r.next)throw new Error("Invalid list");r.next.previous=void 0,this._head=r.next}else if(r===this._tail){if(!r.previous)throw new Error("Invalid list");r.previous.next=void 0,this._tail=r.previous}else{const s=r.next,n=r.previous;if(!s||!n)throw new Error("Invalid list");s.previous=n,n.next=s}r.next=void 0,r.previous=void 0,this._state++}touch(r,s){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(s!==1&&s!==2)){if(s===1){if(r===this._head)return;const n=r.next,a=r.previous;r===this._tail?(a.next=void 0,this._tail=a):(n.previous=a,a.next=n),r.previous=void 0,r.next=this._head,this._head.previous=r,this._head=r,this._state++}else if(s===2){if(r===this._tail)return;const n=r.next,a=r.previous;r===this._head?(n.previous=void 0,this._head=n):(n.previous=a,a.next=n),r.next=void 0,r.previous=this._tail,this._tail.next=r,this._tail=r,this._state++}}}toJSON(){const r=[];return this.forEach((s,n)=>{r.push([n,s])}),r}fromJSON(r){this.clear();for(const[s,n]of r)this.set(s,n)}}e.LinkedMap=c;class h extends c{constructor(r,s=1){super();this._limit=r,this._ratio=Math.min(Math.max(0,s),1)}get limit(){return this._limit}set limit(r){this._limit=r,this.checkTrim()}get ratio(){return this._ratio}set ratio(r){this._ratio=Math.min(Math.max(0,r),1),this.checkTrim()}get(r,s=2){return super.get(r,s)}peek(r){return super.get(r,0)}set(r,s){return super.set(r,s,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=h;class p{constructor(r){T.set(this,void 0),it(this,T,r,"f")}get size(){return He(this,T,"f").size}forEach(r,s){He(this,T,"f").forEach(r,s)}get(r){return He(this,T,"f").get(r)}has(r){return He(this,T,"f").has(r)}entries(){return He(this,T,"f").entries()}keys(){return He(this,T,"f").keys()}values(){return He(this,T,"f").values()}[(T=new WeakMap,Symbol.iterator)](){return He(this,T,"f").entries()}}e.ReadonlyMapView=p}),define(me[98],ge([0,1,22,8]),function(J,e,g,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function k(...Y){return function(ae,ve){for(let Me=0,ze=Y.length;Me<ze;Me++){const Ee=Y[Me](ae,ve);if(Ee)return Ee}return null}}e.or=k,e.matchesStrictPrefix=S.bind(void 0,!1),e.matchesPrefix=S.bind(void 0,!0);function S(Y,ae,ve){if(!ve||ve.length<ae.length)return null;let Me;return Y?Me=R.startsWithIgnoreCase(ve,ae):Me=ve.indexOf(ae)===0,Me?ae.length>0?[{start:0,end:ae.length}]:[]:null}function T(Y,ae){const ve=ae.toLowerCase().indexOf(Y.toLowerCase());return ve===-1?null:[{start:ve,end:ve+Y.length}]}e.matchesContiguousSubString=T;function D(Y,ae){return y(Y.toLowerCase(),ae.toLowerCase(),0,0)}e.matchesSubString=D;function y(Y,ae,ve,Me){if(ve===Y.length)return[];if(Me===ae.length)return null;if(Y[ve]===ae[Me]){let ze=null;return(ze=y(Y,ae,ve+1,Me+1))?b({start:Me,end:Me+1},ze):null}return y(Y,ae,ve,Me+1)}function A(Y){return 97<=Y&&Y<=122}function i(Y){return 65<=Y&&Y<=90}e.isUpper=i;function C(Y){return 48<=Y&&Y<=57}function u(Y){return Y===32||Y===9||Y===10||Y===13}const m=new Set;"`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?".split("").forEach(Y=>m.add(Y.charCodeAt(0)));function l(Y){return u(Y)||m.has(Y)}function v(Y,ae){return Y===ae||l(Y)&&l(ae)}function _(Y){return A(Y)||i(Y)||C(Y)}function b(Y,ae){return ae.length===0?ae=[Y]:Y.end===ae[0].start?ae[0].start=Y.start:ae.unshift(Y),ae}function P(Y,ae){for(let ve=ae;ve<Y.length;ve++){const Me=Y.charCodeAt(ve);if(i(Me)||C(Me)||ve>0&&!_(Y.charCodeAt(ve-1)))return ve}return Y.length}function c(Y,ae,ve,Me){if(ve===Y.length)return[];if(Me===ae.length)return null;if(Y[ve]!==ae[Me].toLowerCase())return null;{let ze=null,Ee=Me+1;for(ze=c(Y,ae,ve+1,Me+1);!ze&&(Ee=P(ae,Ee))<ae.length;)ze=c(Y,ae,ve+1,Ee),Ee++;return ze===null?null:b({start:Me,end:Me+1},ze)}}function h(Y){let ae=0,ve=0,Me=0,ze=0,Ee=0;for(let xe=0;xe<Y.length;xe++)Ee=Y.charCodeAt(xe),i(Ee)&&ae++,A(Ee)&&ve++,_(Ee)&&Me++,C(Ee)&&ze++;const Ye=ae/Y.length,X=ve/Y.length,se=Me/Y.length,fe=ze/Y.length;return{upperPercent:Ye,lowerPercent:X,alphaPercent:se,numericPercent:fe}}function p(Y){const{upperPercent:ae,lowerPercent:ve}=Y;return ve===0&&ae>.6}function t(Y){const{upperPercent:ae,lowerPercent:ve,alphaPercent:Me,numericPercent:ze}=Y;return ve>.2&&ae<.8&&Me>.6&&ze<.2}function r(Y){let ae=0,ve=0,Me=0,ze=0;for(let Ee=0;Ee<Y.length;Ee++)Me=Y.charCodeAt(Ee),i(Me)&&ae++,A(Me)&&ve++,u(Me)&&ze++;return(ae===0||ve===0)&&ze===0?Y.length<=30:ae<=5}function s(Y,ae){if(!ae||(ae=ae.trim(),ae.length===0)||!r(Y)||ae.length>60)return null;const ve=h(ae);if(!t(ve)){if(!p(ve))return null;ae=ae.toLowerCase()}let Me=null,ze=0;for(Y=Y.toLowerCase();ze<ae.length&&(Me=c(Y,ae,0,ze))===null;)ze=P(ae,ze+1);return Me}e.matchesCamelCase=s;function n(Y,ae,ve=!1){if(!ae||ae.length===0)return null;let Me=null,ze=0;for(Y=Y.toLowerCase(),ae=ae.toLowerCase();ze<ae.length&&(Me=a(Y,ae,0,ze,ve))===null;)ze=d(ae,ze+1);return Me}e.matchesWords=n;function a(Y,ae,ve,Me,ze){if(ve===Y.length)return[];if(Me===ae.length)return null;if(v(Y.charCodeAt(ve),ae.charCodeAt(Me))){let Ee=null,Ye=Me+1;if(Ee=a(Y,ae,ve+1,Me+1,ze),!ze)for(;!Ee&&(Ye=d(ae,Ye))<ae.length;)Ee=a(Y,ae,ve+1,Ye,ze),Ye++;return Ee===null?null:b({start:Me,end:Me+1},Ee)}else return null}function d(Y,ae){for(let ve=ae;ve<Y.length;ve++)if(l(Y.charCodeAt(ve))||ve>0&&l(Y.charCodeAt(ve-1)))return ve;return Y.length}const f=k(e.matchesPrefix,s,T),w=k(e.matchesPrefix,s,D),E=new g.LRUCache(1e4);function o(Y,ae,ve=!1){if(typeof Y!="string"||typeof ae!="string")return null;let Me=E.get(Y);Me||(Me=new RegExp(R.convertSimple2RegExpPattern(Y),"i"),E.set(Y,Me));const ze=Me.exec(ae);return ze?[{start:ze.index,end:ze.index+ze[0].length}]:ve?w(Y,ae):f(Y,ae)}e.matchesFuzzy=o;function I(Y,ae){const ve=qe(Y,Y.toLowerCase(),0,ae,ae.toLowerCase(),0,!0);return ve?U(ve):null}e.matchesFuzzy2=I;function L(Y,ae,ve,Me,ze,Ee){const Ye=Math.min(13,Y.length);for(;ve<Ye;ve++){const X=qe(Y,ae,ve,Me,ze,Ee,!1);if(X)return X}return[0,Ee]}e.anyScore=L;function U(Y){if(typeof Y=="undefined")return[];const ae=[],ve=Y[1];for(let Me=Y.length-1;Me>1;Me--){const ze=Y[Me]+ve,Ee=ae[ae.length-1];Ee&&Ee.end===ze?Ee.end=ze+1:ae.push({start:ze,end:ze+1})}return ae}e.createMatches=U;const V=128;function ee(){const Y=[],ae=[];for(let ve=0;ve<=V;ve++)ae[ve]=0;for(let ve=0;ve<=V;ve++)Y.push(ae.slice(0));return Y}function K(Y){const ae=[];for(let ve=0;ve<=Y;ve++)ae[ve]=0;return ae}const N=K(2*V),x=K(2*V),F=ee(),z=ee(),M=ee(),O=!1;function q(Y,ae,ve,Me,ze){function Ee(X,se,fe=" "){for(;X.length<se;)X=fe+X;return X}let Ye=` |   |${Me.split("").map(X=>Ee(X,3)).join("|")}
`;for(let X=0;X<=ve;X++)X===0?Ye+=" |":Ye+=`${ae[X-1]}|`,Ye+=Y[X].slice(0,ze+1).map(se=>Ee(se.toString(),3)).join("|")+`
`;return Ye}function B(Y,ae,ve,Me){Y=Y.substr(ae),ve=ve.substr(Me),console.log(q(z,Y,Y.length,ve,ve.length)),console.log(q(M,Y,Y.length,ve,ve.length)),console.log(q(F,Y,Y.length,ve,ve.length))}function G(Y,ae){if(ae<0||ae>=Y.length)return!1;const ve=Y.codePointAt(ae);switch(ve){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 40:case 91:return!0;case void 0:return!1;default:return!!R.isEmojiImprecise(ve)}}function ie(Y,ae){if(ae<0||ae>=Y.length)return!1;switch(Y.charCodeAt(ae)){case 32:case 9:return!0;default:return!1}}function he(Y,ae,ve){return ae[Y]!==ve[Y]}function ye(Y,ae,ve,Me,ze,Ee,Ye=!1){for(;ae<ve&&ze<Ee;)Y[ae]===Me[ze]&&(Ye&&(N[ae]=ze),ae+=1),ze+=1;return ae===ve}e.isPatternInWord=ye;var Ie;(function(Y){Y[Y.Diag=1]="Diag",Y[Y.Left=2]="Left",Y[Y.LeftLeft=3]="LeftLeft"})(Ie||(Ie={}));var Le;(function(Y){Y.Default=[-100,0];function ae(ve){return!ve||ve.length===2&&ve[0]===-100&&ve[1]===0}Y.isDefault=ae})(Le=e.FuzzyScore||(e.FuzzyScore={}));function qe(Y,ae,ve,Me,ze,Ee,Ye){const X=Y.length>V?V:Y.length,se=Me.length>V?V:Me.length;if(ve>=X||Ee>=se||X-ve>se-Ee||!ye(ae,ve,X,ze,Ee,se,!0))return;We(X,se,ve,Ee,ae,ze);let fe=1,xe=1,Be=ve,et=Ee;const Ce=[!1];for(fe=1,Be=ve;Be<X;fe++,Be++){const pe=N[Be],be=x[Be],j=Be+1<X?x[Be+1]:se;for(xe=pe-Ee+1,et=pe;et<j;xe++,et++){let we=Number.MIN_SAFE_INTEGER,_e=!1;et<=be&&(we=je(Y,ae,Be,ve,Me,ze,et,se,Ee,F[fe-1][xe-1]===0,Ce));let Ae=0;we!==Number.MAX_SAFE_INTEGER&&(_e=!0,Ae=we+z[fe-1][xe-1]);const Ue=et>pe,Ge=Ue?z[fe][xe-1]+(F[fe][xe-1]>0?-5:0):0,Ze=et>pe+1&&F[fe][xe-1]>0,Qe=Ze?z[fe][xe-2]+(F[fe][xe-2]>0?-5:0):0;if(Ze&&(!Ue||Qe>=Ge)&&(!_e||Qe>=Ae))z[fe][xe]=Qe,M[fe][xe]=3,F[fe][xe]=0;else if(Ue&&(!_e||Ge>=Ae))z[fe][xe]=Ge,M[fe][xe]=2,F[fe][xe]=0;else if(_e)z[fe][xe]=Ae,M[fe][xe]=1,F[fe][xe]=F[fe-1][xe-1]+1;else throw new Error("not possible")}}if(O&&B(Y,ve,Me,Ee),!Ce[0]&&!Ye)return;fe--,xe--;const De=[z[fe][xe],Ee];let Te=0,ce=0;for(;fe>=1;){let pe=xe;do{const be=M[fe][pe];if(be===3)pe=pe-2;else if(be===2)pe=pe-1;else break}while(pe>=1);Te>1&&ae[ve+fe-1]===ze[Ee+xe-1]&&!he(pe+Ee-1,Me,ze)&&Te+1>F[fe][pe]&&(pe=xe),pe===xe?Te++:Te=1,ce||(ce=pe),fe--,xe=pe-1,De.push(xe)}se===X&&(De[0]+=2);const ue=ce-X;return De[0]-=ue,De}e.fuzzyScore=qe;function We(Y,ae,ve,Me,ze,Ee){let Ye=Y-1,X=ae-1;for(;Ye>=ve&&X>=Me;)ze[Ye]===Ee[X]&&(x[Ye]=X,Ye--),X--}function je(Y,ae,ve,Me,ze,Ee,Ye,X,se,fe,xe){if(ae[ve]!==Ee[Ye])return Number.MIN_SAFE_INTEGER;let Be=1,et=!1;return Ye===ve-Me?Be=Y[ve]===ze[Ye]?7:5:he(Ye,ze,Ee)&&(Ye===0||!he(Ye-1,ze,Ee))?(Be=Y[ve]===ze[Ye]?7:5,et=!0):G(Ee,Ye)&&(Ye===0||!G(Ee,Ye-1))?Be=5:(G(Ee,Ye-1)||ie(Ee,Ye-1))&&(Be=5,et=!0),Be>1&&ve===Me&&(xe[0]=!0),et||(et=he(Ye,ze,Ee)||G(Ee,Ye-1)||ie(Ee,Ye-1)),ve===Me?Ye>se&&(Be-=et?3:5):fe?Be+=et?2:0:Be+=et?0:1,Ye+1===X&&(Be-=et?3:5),Be}function W(Y,ae,ve,Me,ze,Ee,Ye){return ne(Y,ae,ve,Me,ze,Ee,!0,Ye)}e.fuzzyScoreGracefulAggressive=W;function Z(Y,ae,ve,Me,ze,Ee,Ye){return ne(Y,ae,ve,Me,ze,Ee,!1,Ye)}e.fuzzyScoreGraceful=Z;function ne(Y,ae,ve,Me,ze,Ee,Ye,X){let se=qe(Y,ae,ve,Me,ze,Ee,X);if(se&&!Ye)return se;if(Y.length>=3){const fe=Math.min(7,Y.length-1);for(let xe=ve+1;xe<fe;xe++){const Be=le(Y,xe);if(Be){const et=qe(Be,Be.toLowerCase(),ve,Me,ze,Ee,X);et&&(et[0]-=3,(!se||et[0]>se[0])&&(se=et))}}}return se}function le(Y,ae){if(ae+1>=Y.length)return;const ve=Y[ae],Me=Y[ae+1];if(ve!==Me)return Y.slice(0,ae)+Me+ve+Y.slice(ae+2)}}),define(me[141],ge([0,1,47,98,8]),function(J,e,g,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const S=new RegExp(`\\$\\(${g.CSSIcon.iconNameExpression}(?:${g.CSSIcon.iconModifierExpression})?\\)`,"g"),T=new RegExp(`(\\\\)?${S.source}`,"g");function D(v){return v.replace(T,(_,b)=>b?_:`\\${_}`)}e.escapeIcons=D;const y=new RegExp(`\\\\${S.source}`,"g");function A(v){return v.replace(y,_=>`\\${_}`)}e.markdownEscapeEscapedIcons=A;const i=new RegExp(`(\\s)?(\\\\)?${S.source}(\\s)?`,"g");function C(v){return v.indexOf(e.iconStartMarker)===-1?v:v.replace(i,(_,b,P,c)=>P?_:b||c||"")}e.stripIcons=C;function u(v){const _=v.indexOf(e.iconStartMarker);return _===-1?{text:v}:m(v,_)}e.parseLabelWithIcons=u;function m(v,_){const b=[];let P="";function c(d){if(d){P+=d;for(const f of d)b.push(t)}}let h=-1,p="",t=0,r,s,n=_;const a=v.length;for(c(v.substr(0,_));n<a;)r=v[n],s=v[n+1],r===e.iconStartMarker[0]&&s===e.iconStartMarker[1]?(h=n,c(p),p=e.iconStartMarker,n++):r===")"&&h!==-1?(t+=n-h+1,h=-1,p=""):h!==-1?/^[a-z0-9\-]$/i.test(r)?p+=r:(c(p),h=-1,p=""):c(r),n++;return c(p),{text:P,iconOffsets:b}}function l(v,_,b=!1){const{text:P,iconOffsets:c}=_;if(!c||c.length===0)return(0,R.matchesFuzzy)(v,P,b);const h=(0,k.ltrim)(P," "),p=P.length-h.length,t=(0,R.matchesFuzzy)(v,h,b);if(t)for(const r of t){const s=c[r.start+p]+p;r.start+=s,r.end+=s}return t}e.matchesFuzzyIconAware=l}),define(me[99],ge([0,1,141,15]),function(J,e,g,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var k;(function(u){u[u.Paragraph=0]="Paragraph",u[u.Break=1]="Break"})(k=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class S{constructor(m="",l=!1){if(this.value=m,typeof this.value!="string")throw(0,R.illegalArgument)("value");typeof l=="boolean"?(this.isTrusted=l,this.supportThemeIcons=!1):(this.isTrusted=l.isTrusted??void 0,this.supportThemeIcons=l.supportThemeIcons??!1)}appendText(m,l=0){return this.value+=A(this.supportThemeIcons?(0,g.escapeIcons)(m):m).replace(/([ \t]+)/g,(v,_)=>"&nbsp;".repeat(_.length)).replace(/^>/gm,"\\>").replace(/\n/g,l===1?`\\
`:`

`),this}appendMarkdown(m){return this.value+=m,this}appendCodeblock(m,l){return this.value+="\n```",this.value+=m,this.value+=`
`,this.value+=l,this.value+="\n```\n",this}}e.MarkdownString=S;function T(u){return D(u)?!u.value:Array.isArray(u)?u.every(T):!0}e.isEmptyMarkdownString=T;function D(u){return u instanceof S?!0:u&&typeof u=="object"?typeof u.value=="string"&&(typeof u.isTrusted=="boolean"||u.isTrusted===void 0)&&(typeof u.supportThemeIcons=="boolean"||u.supportThemeIcons===void 0):!1}e.isMarkdownString=D;function y(u,m){return u===m?!0:!u||!m?!1:u.value===m.value&&u.isTrusted===m.isTrusted&&u.supportThemeIcons===m.supportThemeIcons}e.markdownStringEqual=y;function A(u){return u.replace(/[\\`*_{}[\]()#+\-.!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=A;function i(u){return u&&u.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=i;function C(u){const m=[],l=u.split("|").map(_=>_.trim());u=l[0];const v=l[1];if(v){const _=/height=(\d+)/.exec(v),b=/width=(\d+)/.exec(v),P=_?_[1]:"",c=b?b[1]:"",h=isFinite(parseInt(c)),p=isFinite(parseInt(P));h&&m.push(`width="${c}"`),p&&m.push(`height="${P}"`)}return{href:u,dimensions:m}}e.parseHrefAndDimensions=C}),define(me[59],ge([0,1,24,8,2]),function(J,e,g,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.MarshalledId=e.parse=e.stringify=void 0;function S(i){return JSON.stringify(i,y)}e.stringify=S;function T(i){let C=JSON.parse(i);return C=A(C),C}e.parse=T;var D;(function(i){i[i.Uri=1]="Uri",i[i.Regexp=2]="Regexp",i[i.ScmResource=3]="ScmResource",i[i.ScmResourceGroup=4]="ScmResourceGroup",i[i.ScmProvider=5]="ScmProvider",i[i.CommentController=6]="CommentController",i[i.CommentThread=7]="CommentThread",i[i.CommentThreadReply=8]="CommentThreadReply",i[i.CommentNode=9]="CommentNode",i[i.CommentThreadNode=10]="CommentThreadNode",i[i.TimelineActionContext=11]="TimelineActionContext",i[i.NotebookCellActionContext=12]="NotebookCellActionContext",i[i.TestItemContext=13]="TestItemContext"})(D=e.MarshalledId||(e.MarshalledId={}));function y(i,C){return C instanceof RegExp?{$mid:2,source:C.source,flags:(0,R.regExpFlags)(C)}:C}function A(i,C=0){if(!i||C>200)return i;if(typeof i=="object"){switch(i.$mid){case 1:return k.URI.revive(i);case 2:return new RegExp(i.source,i.flags)}if(i instanceof g.VSBuffer||i instanceof Uint8Array)return i;if(Array.isArray(i))for(let u=0;u<i.length;++u)i[u]=A(i[u],C+1);else for(const u in i)Object.hasOwnProperty.call(i,u)&&(i[u]=A(i[u],C+1))}return i}e.revive=A}),define(me[10],ge([0,1,2,11]),function(J,e,g,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var k;(function(D){D.inMemory="inmemory",D.vscode="vscode",D.internal="private",D.walkThrough="walkThrough",D.walkThroughSnippet="walkThroughSnippet",D.http="http",D.https="https",D.file="file",D.mailto="mailto",D.untitled="untitled",D.data="data",D.command="command",D.vscodeRemote="vscode-remote",D.vscodeRemoteResource="vscode-remote-resource",D.userData="vscode-userdata",D.vscodeCustomEditor="vscode-custom-editor",D.vscodeNotebook="vscode-notebook",D.vscodeNotebookCell="vscode-notebook-cell",D.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",D.vscodeNotebookCellOutput="vscode-notebook-cell-output",D.vscodeInteractive="vscode-interactive",D.vscodeInteractiveInput="vscode-interactive-input",D.vscodeSettings="vscode-settings",D.vscodeWorkspaceTrust="vscode-workspace-trust",D.vscodeTerminal="vscode-terminal",D.webviewPanel="webview-panel",D.vscodeWebview="vscode-webview",D.extension="extension",D.vscodeFileResource="vscode-file",D.tmp="tmp"})(k=e.Schemas||(e.Schemas={}));class S{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(y){this._preferredWebSchema=y}setDelegate(y){this._delegate=y}set(y,A,i){this._hosts[y]=A,this._ports[y]=i}setConnectionToken(y,A){this._connectionTokens[y]=A}rewrite(y){if(this._delegate)return this._delegate(y);const A=y.authority;let i=this._hosts[A];i&&i.indexOf(":")!==-1&&(i=`[${i}]`);const C=this._ports[A],u=this._connectionTokens[A];let m=`path=${encodeURIComponent(y.path)}`;return typeof u=="string"&&(m+=`&tkn=${encodeURIComponent(u)}`),g.URI.from({scheme:R.isWeb?this._preferredWebSchema:k.vscodeRemoteResource,authority:`${i}:${C}`,path:"/vscode-remote-resource",query:m})}}e.RemoteAuthorities=new S;class T{constructor(){this.FALLBACK_AUTHORITY="vscode-app"}asBrowserUri(y,A,i){const C=this.toUri(y,A);if(C.scheme===k.vscodeRemote)return e.RemoteAuthorities.rewrite(C);let u=!1;return R.isNative&&(i||R.isPreferringBrowserCodeLoad)&&C.scheme===k.file&&(u=!0),C.scheme===k.file&&typeof R.globals.importScripts=="function"&&R.globals.origin==="vscode-file://vscode-app"&&(u=!0),u?C.with({scheme:k.vscodeFileResource,authority:C.authority||this.FALLBACK_AUTHORITY,query:null,fragment:null}):C}asFileUri(y,A){const i=this.toUri(y,A);return i.scheme===k.vscodeFileResource?i.with({scheme:k.file,authority:i.authority!==this.FALLBACK_AUTHORITY?i.authority:null,query:null,fragment:null}):i}toUri(y,A){return g.URI.isUri(y)?y:g.URI.parse(A.toUrl(y))}}e.FileAccess=new T}),define(me[76],ge([0,1,22]),function(J,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const R=new g.LRUCache(1e4);function k(A){return y(A,"NFC",R)}e.normalizeNFC=k;const S=new g.LRUCache(1e4);function T(A){return y(A,"NFD",S)}e.normalizeNFD=T;const D=/[^\u0000-\u0080]/;function y(A,i,C){if(!A)return A;const u=C.get(A);if(u)return u;let m;return D.test(A)?m=A.normalize(i):m=A,C.set(A,m),m}e.removeAccents=function(){const A=/[\u0300-\u036f]/g;return function(i){return T(i).replace(A,"")}}()}),define(me[23],ge([0,1,29,9,2,8,10,11]),function(J,e,g,R,k,S,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function y(m){return(0,k.uriToFsPath)(m,!0)}e.originalFSPath=y;class A{constructor(l){this._ignorePathCasing=l}compare(l,v,_=!1){return l===v?0:(0,S.compare)(this.getComparisonKey(l,_),this.getComparisonKey(v,_))}isEqual(l,v,_=!1){return l===v?!0:!l||!v?!1:this.getComparisonKey(l,_)===this.getComparisonKey(v,_)}getComparisonKey(l,v=!1){return l.with({path:this._ignorePathCasing(l)?l.path.toLowerCase():void 0,fragment:v?null:void 0}).toString()}ignorePathCasing(l){return this._ignorePathCasing(l)}isEqualOrParent(l,v,_=!1){if(l.scheme===v.scheme){if(l.scheme===T.Schemas.file)return g.isEqualOrParent(y(l),y(v),this._ignorePathCasing(l))&&l.query===v.query&&(_||l.fragment===v.fragment);if((0,e.isEqualAuthority)(l.authority,v.authority))return g.isEqualOrParent(l.path,v.path,this._ignorePathCasing(l),"/")&&l.query===v.query&&(_||l.fragment===v.fragment)}return!1}joinPath(l,...v){return k.URI.joinPath(l,...v)}basenameOrAuthority(l){return(0,e.basename)(l)||l.authority}basename(l){return R.posix.basename(l.path)}extname(l){return R.posix.extname(l.path)}dirname(l){if(l.path.length===0)return l;let v;return l.scheme===T.Schemas.file?v=k.URI.file(R.dirname(y(l))).path:(v=R.posix.dirname(l.path),l.authority&&v.length&&v.charCodeAt(0)!==47&&(console.error(`dirname("${l.toString})) resulted in a relative path`),v="/")),l.with({path:v})}normalizePath(l){if(!l.path.length)return l;let v;return l.scheme===T.Schemas.file?v=k.URI.file(R.normalize(y(l))).path:v=R.posix.normalize(l.path),l.with({path:v})}relativePath(l,v){if(l.scheme!==v.scheme||!(0,e.isEqualAuthority)(l.authority,v.authority))return;if(l.scheme===T.Schemas.file){const P=R.relative(y(l),y(v));return D.isWindows?g.toSlashes(P):P}let _=l.path||"/",b=v.path||"/";if(this._ignorePathCasing(l)){let P=0;for(const c=Math.min(_.length,b.length);P<c&&!(_.charCodeAt(P)!==b.charCodeAt(P)&&_.charAt(P).toLowerCase()!==b.charAt(P).toLowerCase());P++);_=b.substr(0,P)+_.substr(P)}return R.posix.relative(_,b)}resolvePath(l,v){if(l.scheme===T.Schemas.file){const _=k.URI.file(R.resolve(y(l),v));return l.with({authority:_.authority,path:_.path})}return v=g.toPosixPath(v),l.with({path:R.posix.resolve(l.path,v)})}isAbsolutePath(l){return!!l.path&&l.path[0]==="/"}isEqualAuthority(l,v){return l===v||(0,S.equalsIgnoreCase)(l,v)}hasTrailingPathSeparator(l,v=R.sep){if(l.scheme===T.Schemas.file){const _=y(l);return _.length>g.getRoot(_).length&&_[_.length-1]===v}else{const _=l.path;return _.length>1&&_.charCodeAt(_.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(l.fsPath)}}removeTrailingPathSeparator(l,v=R.sep){return(0,e.hasTrailingPathSeparator)(l,v)?l.with({path:l.path.substr(0,l.path.length-1)}):l}addTrailingPathSeparator(l,v=R.sep){let _=!1;if(l.scheme===T.Schemas.file){const b=y(l);_=b!==void 0&&b.length===g.getRoot(b).length&&b[b.length-1]===v}else{v="/";const b=l.path;_=b.length===1&&b.charCodeAt(b.length-1)===47}return!_&&!(0,e.hasTrailingPathSeparator)(l,v)?l.with({path:l.path+"/"}):l}}e.ExtUri=A,e.extUri=new A(()=>!1),e.extUriBiasedIgnorePathCase=new A(m=>m.scheme===T.Schemas.file?!D.isLinux:!0),e.extUriIgnorePathCase=new A(m=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function i(m,l){const v=[];for(let _=0;_<m.length;_++){const b=l(m[_]);m.some((P,c)=>c===_?!1:(0,e.isEqualOrParent)(b,l(P)))||v.push(m[_])}return v}e.distinctParents=i;var C;(function(m){m.META_DATA_LABEL="label",m.META_DATA_DESCRIPTION="description",m.META_DATA_SIZE="size",m.META_DATA_MIME="mime";function l(v){const _=new Map;v.path.substring(v.path.indexOf(";")+1,v.path.lastIndexOf(";")).split(";").forEach(c=>{const[h,p]=c.split(":");h&&p&&_.set(h,p)});const P=v.path.substring(0,v.path.indexOf(";"));return P&&_.set(m.META_DATA_MIME,P),_}m.parseMetaData=l})(C=e.DataUri||(e.DataUri={}));function u(m,l,v){if(l){let _=m.path;return _&&_[0]!==R.posix.sep&&(_=R.posix.sep+_),m.with({scheme:v,authority:l,path:_})}return m.with({scheme:v})}e.toLocalResource=u}),define(me[16],ge([0,1,21,15,3,6,23]),function(J,e,g,R,k,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function D(x){return!!x&&typeof x.then=="function"}e.isThenable=D;function y(x){const F=new g.CancellationTokenSource,z=x(F.token),M=new Promise((O,q)=>{const B=F.token.onCancellationRequested(()=>{B.dispose(),F.dispose(),q((0,R.canceled)())});Promise.resolve(z).then(G=>{B.dispose(),F.dispose(),O(G)},G=>{B.dispose(),F.dispose(),q(G)})});return new class{cancel(){F.cancel()}then(O,q){return M.then(O,q)}catch(O){return this.then(void 0,O)}finally(O){return M.finally(O)}}}e.createCancelablePromise=y;function A(x,F,z){return Promise.race([x,new Promise(M=>F.onCancellationRequested(()=>M(z)))])}e.raceCancellation=A;async function i(x){let F=-1;const z=x.map((O,q)=>O.then(B=>(F=q,B))),M=await Promise.race(z);return x.forEach((O,q)=>{q!==F&&O.cancel()}),M}e.raceCancellablePromises=i;function C(x,F,z){let M;const O=setTimeout(()=>{M?.(void 0),z?.()},F);return Promise.race([x.finally(()=>clearTimeout(O)),new Promise(q=>M=q)])}e.raceTimeout=C;function u(x){return new Promise((F,z)=>{const M=x();D(M)?M.then(F,z):F(M)})}e.asPromise=u;class m{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(F){if(this.activePromise){if(this.queuedPromiseFactory=F,!this.queuedPromise){const z=()=>{this.queuedPromise=null;const M=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,M};this.queuedPromise=new Promise(M=>{this.activePromise.then(z,z).then(M)})}return new Promise((z,M)=>{this.queuedPromise.then(z,M)})}return this.activePromise=F(),new Promise((z,M)=>{this.activePromise.then(O=>{this.activePromise=null,z(O)},O=>{this.activePromise=null,M(O)})})}}e.Throttler=m;class l{constructor(){this.current=Promise.resolve(null)}queue(F){return this.current=this.current.then(()=>F(),()=>F())}}e.Sequencer=l;class v{constructor(){this.promiseMap=new Map}queue(F,z){const O=(this.promiseMap.get(F)??Promise.resolve()).catch(()=>{}).then(z).finally(()=>{this.promiseMap.get(F)===O&&this.promiseMap.delete(F)});return this.promiseMap.set(F,O),O}}e.SequencerByKey=v;class _{constructor(F){this.defaultDelay=F,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(F,z=this.defaultDelay){return this.task=F,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((M,O)=>{this.doResolve=M,this.doReject=O}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const M=this.task;return this.task=null,M()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},z),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,R.canceled)()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancel()}}e.Delayer=_;class b{constructor(F){this.delayer=new _(F),this.throttler=new m}trigger(F,z){return this.delayer.trigger(()=>this.throttler.queue(F),z)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=b;class P{constructor(){this._isOpen=!1,this._promise=new Promise((F,z)=>{this._completePromise=F})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=P;class c extends P{constructor(F){super();this._timeout=setTimeout(()=>this.open(),F)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=c;function h(x,F){return F?new Promise((z,M)=>{const O=setTimeout(()=>{q.dispose(),z()},x),q=F.onCancellationRequested(()=>{clearTimeout(O),q.dispose(),M((0,R.canceled)())})}):y(z=>h(x,z))}e.timeout=h;function p(x,F=0){const z=setTimeout(x,F);return(0,S.toDisposable)(()=>clearTimeout(z))}e.disposableTimeout=p;function t(x){const F=[];let z=0;const M=x.length;function O(){return z<M?x[z++]():null}function q(B){B!=null&&F.push(B);const G=O();return G?G.then(q):Promise.resolve(F)}return Promise.resolve(null).then(q)}e.sequence=t;function r(x,F=M=>!!M,z=null){let M=0;const O=x.length,q=()=>{if(M>=O)return Promise.resolve(z);const B=x[M++];return Promise.resolve(B()).then(ie=>F(ie)?Promise.resolve(ie):q())};return q()}e.first=r;function s(x,F=M=>!!M,z=null){if(x.length===0)return Promise.resolve(z);let M=x.length;const O=()=>{M=-1;for(const q of x)q.cancel?.()};return new Promise((q,B)=>{for(const G of x)G.then(ie=>{--M>=0&&F(ie)?(O(),q(ie)):M===0&&q(z)}).catch(ie=>{--M>=0&&(O(),B(ie))})})}e.firstParallel=s;class n{constructor(F){this._size=0,this.maxDegreeOfParalellism=F,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new k.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(F){return this._size++,new Promise((z,M)=>{this.outstandingPromises.push({factory:F,c:z,e:M}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const F=this.outstandingPromises.shift();this.runningPromises++;const z=F.factory();z.then(F.c,F.e),z.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=n;class a extends n{constructor(){super(1)}}e.Queue=a;class d{constructor(){this.queues=new Map}queueFor(F,z=T.extUri){const M=z.getComparisonKey(F);let O=this.queues.get(M);return O||(O=new a,k.Event.once(O.onFinished)(()=>{O?.dispose(),this.queues.delete(M)}),this.queues.set(M,O)),O}dispose(){this.queues.forEach(F=>F.dispose()),this.queues.clear()}}e.ResourceQueue=d;class f{constructor(F,z){this._token=-1,typeof F=="function"&&typeof z=="number"&&this.setIfNotSet(F,z)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(F,z){this.cancel(),this._token=setTimeout(()=>{this._token=-1,F()},z)}setIfNotSet(F,z){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,F()},z))}}e.TimeoutTimer=f;class w{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(F,z){this.cancel(),this._token=setInterval(()=>{F()},z)}}e.IntervalTimer=w;class E{constructor(F,z){this.timeoutToken=-1,this.runner=F,this.timeout=z,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(F=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,F)}get delay(){return this.timeout}set delay(F){this.timeout=F}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=E;class o extends E{constructor(F,z){super(F,z);this.units=[]}work(F){this.units.push(F),this.isScheduled()||this.schedule()}doRun(){const F=this.units;this.units=[],this.runner&&this.runner(F)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=o;class I extends S.Disposable{constructor(F,z,M,O){super();this.maxWorkChunkSize=F,this.maxPendingWork=z,this.throttleDelay=M,this.handler=O,this.pendingWork=[],this.throttler=this._register(new S.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(F){if(this.disposed)return!1;if(typeof this.maxPendingWork=="number"){if(this.throttler.value){if(this.pending+F.length>this.maxPendingWork)return!1}else if(this.pending+F.length-this.maxWorkChunkSize>this.maxPendingWork)return!1}return this.pendingWork.push(...F),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new E(()=>{this.throttler.clear(),this.doWork()},this.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=I,function(){if(typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"){const x=Object.freeze({didTimeout:!0,timeRemaining(){return 15}});e.runWhenIdle=F=>{const z=setTimeout(()=>F(x));let M=!1;return{dispose(){M||(M=!0,clearTimeout(z))}}}}else e.runWhenIdle=(x,F)=>{const z=requestIdleCallback(x,typeof F=="number"?{timeout:F}:void 0);let M=!1;return{dispose(){M||(M=!0,cancelIdleCallback(z))}}}}();class L{constructor(F){this._didRun=!1,this._executor=()=>{try{this._value=F()}catch(z){this._error=z}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}}e.IdleValue=L;async function U(x,F,z){let M;for(let O=0;O<z;O++)try{return await x()}catch(q){M=q,await h(F)}throw M}e.retry=U;class V{hasPending(F){return this._pending?typeof F=="number"?this._pending.taskId===F:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(F,z,M){return this._pending={taskId:F,cancel:()=>M?.(),promise:z},z.then(()=>this.donePending(F),()=>this.donePending(F)),z}donePending(F){this._pending&&F===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const F=this._next;this._next=void 0,F.run().then(F.promiseResolve,F.promiseReject)}}setNext(F){if(this._next)this._next.run=F;else{let z,M;const O=new Promise((q,B)=>{z=q,M=B});this._next={run:F,promise:O,promiseResolve:z,promiseReject:M}}return this._next.promise}}e.TaskSequentializer=V;class ee{constructor(F){this.interval=F,this.lastIncrementTime=0,this.value=0}increment(){const F=Date.now();return F-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=F,this.value=0),this.value++,this.value}}e.IntervalCounter=ee;class K{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((F,z)=>{this.completeCallback=F,this.errorCallback=z})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(F){return new Promise(z=>{this.completeCallback(F),this.resolved=!0,z()})}error(F){return new Promise(z=>{this.errorCallback(F),this.rejected=!0,z()})}cancel(){new Promise(F=>{this.errorCallback((0,R.canceled)()),this.rejected=!0,F()})}}e.DeferredPromise=K;var N;(function(x){async function F(z){let M;const O=await Promise.all(z.map(q=>q.then(B=>B,B=>{M||(M=B)})));if(typeof M!="undefined")throw M;return O}x.settled=F})(N=e.Promises||(e.Promises={}))}),define(me[100],ge([0,1,9,16]),function(J,e,g,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.noIntlCompareFileNames=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const k=new R.IdleValue(()=>{const E=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:E,collatorIsNumeric:E.resolvedOptions().numeric}}),S=new R.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),T=new R.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function D(E,o,I=!1){const L=E||"",U=o||"",V=k.value.collator.compare(L,U);return k.value.collatorIsNumeric&&V===0&&L!==U?L<U?-1:1:V}e.compareFileNames=D;function y(E,o){const I=S.value.collator;return E=E||"",o=o||"",p(I,E,o)}e.compareFileNamesDefault=y;function A(E,o){const I=S.value.collator;return E=E||"",o=o||"",n(E,o)||p(I,E,o)}e.compareFileNamesUpper=A;function i(E,o){const I=S.value.collator;return E=E||"",o=o||"",s(E,o)||p(I,E,o)}e.compareFileNamesLower=i;function C(E,o){return E=E||"",o=o||"",E===o?0:E<o?-1:1}e.compareFileNamesUnicode=C;function u(E,o,I=!1){I||(E=E&&E.toLowerCase(),o=o&&o.toLowerCase());const[L,U]=c(E),[V,ee]=c(o);return L!==V?L<V?-1:1:U===ee?0:U<ee?-1:1}e.noIntlCompareFileNames=u;function m(E,o){const[I,L]=c(E),[U,V]=c(o);let ee=k.value.collator.compare(L,V);if(ee===0){if(k.value.collatorIsNumeric&&L!==V)return L<V?-1:1;if(ee=k.value.collator.compare(I,U),k.value.collatorIsNumeric&&ee===0&&I!==U)return I<U?-1:1}return ee}e.compareFileExtensions=m;function l(E,o){E=E||"",o=o||"";const I=h(E),L=h(o),U=S.value.collator,V=T.value.collator;return p(V,I,L)||p(U,E,o)}e.compareFileExtensionsDefault=l;function v(E,o){E=E||"",o=o||"";const I=h(E),L=h(o),U=S.value.collator,V=T.value.collator;return p(V,I,L)||n(E,o)||p(U,E,o)}e.compareFileExtensionsUpper=v;function _(E,o){E=E||"",o=o||"";const I=h(E),L=h(o),U=S.value.collator,V=T.value.collator;return p(V,I,L)||s(E,o)||p(U,E,o)}e.compareFileExtensionsLower=_;function b(E,o){E=E||"",o=o||"";const I=h(E).toLowerCase(),L=h(o).toLowerCase();return I!==L?I<L?-1:1:E!==o?E<o?-1:1:0}e.compareFileExtensionsUnicode=b;const P=/^(.*?)(\.([^.]*))?$/;function c(E,o=!1){const I=E?P.exec(E):[];let L=[I&&I[1]||"",I&&I[3]||""];return o&&(!L[0]&&L[1]||L[0]&&L[0].charAt(0)===".")&&(L=[L[0]+"."+L[1],""]),L}function h(E){const o=E?P.exec(E):[];return o&&o[1]&&o[1].charAt(0)!=="."&&o[3]||""}function p(E,o,I){let L=E.compare(o,I);return L!==0?L:o.length!==I.length?o.length<I.length?-1:1:0}function t(E){const o=E.charAt(0);return o.toLocaleUpperCase()!==o}function r(E){const o=E.charAt(0);return o.toLocaleLowerCase()!==o}function s(E,o){return t(E)&&r(o)?-1:r(E)&&t(o)?1:0}function n(E,o){return r(E)&&t(o)?-1:t(E)&&r(o)?1:0}function a(E,o,I=!1){return I||(E=E&&E.toLowerCase(),o=o&&o.toLowerCase()),E===o?0:E<o?-1:1}function d(E,o,I=!1){const L=E.split(g.sep),U=o.split(g.sep),V=L.length-1,ee=U.length-1;let K,N;for(let x=0;;x++){if(K=V===x,N=ee===x,K&&N)return D(L[x],U[x],I);if(K)return-1;if(N)return 1;const F=a(L[x],U[x],I);if(F!==0)return F}}e.comparePaths=d;function f(E,o,I){const L=E.toLowerCase(),U=o.toLowerCase(),V=w(E,o,I);if(V)return V;const ee=L.endsWith(I),K=U.endsWith(I);if(ee!==K)return ee?-1:1;const N=D(L,U);return N!==0?N:L.localeCompare(U)}e.compareAnything=f;function w(E,o,I){const L=E.toLowerCase(),U=o.toLowerCase(),V=L.startsWith(I),ee=U.startsWith(I);if(V!==ee)return V?-1:1;if(V&&ee){if(L.length<U.length)return-1;if(L.length>U.length)return 1}return 0}e.compareByPrefix=w}),define(me[101],ge([0,1,100,98,9,11,8]),function(J,e,g,R,k,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.pieceToQuery=e.prepareQuery=e.compareItemsByFuzzyScore=e.scoreItemFuzzy=e.scoreFuzzy2=e.scoreFuzzy=void 0;const D=0,y=[D,[]];function A(K,N,x,F){if(!K||!N)return y;const z=K.length,M=N.length;if(z<M)return y;const O=K.toLowerCase();return!F&&!O.includes(x)?y:i(N,x,M,K,O,z)}e.scoreFuzzy=A;function i(K,N,x,F,z,M){const O=[],q=[];for(let he=0;he<x;he++){const ye=he*M,Ie=ye-M,Le=he>0,qe=K[he],We=N[he];for(let je=0;je<M;je++){const W=je>0,Z=ye+je,ne=Z-1,le=Ie+je-1,Y=W?O[ne]:0,ae=Le&&W?O[le]:0,ve=Le&&W?q[le]:0;let Me;!ae&&Le?Me=0:Me=C(qe,We,F,z,je,ve),Me&&ae+Me>=Y?(q[Z]=ve+1,O[Z]=ae+Me):(q[Z]=D,O[Z]=Y)}}const B=[];let G=x-1,ie=M-1;for(;G>=0&&ie>=0;){const he=G*M+ie;q[he]===D||(B.push(ie),G--),ie--}return[O[x*M-1],B.reverse()]}function C(K,N,x,F,z,M){let O=0;if(!u(N,F[z]))return O;if(O+=1,M>0&&(O+=M*5),K===x[z]&&(O+=1),z===0)O+=8;else{const q=m(x.charCodeAt(z-1));q?O+=q:(0,R.isUpper)(x.charCodeAt(z))&&(O+=2)}return O}function u(K,N){return K===N?!0:K==="/"||K==="\\"?N==="/"||N==="\\":!1}function m(K){switch(K){case 47:case 92:return 5;case 95:case 45:case 46:case 32:case 39:case 34:case 58:return 4;default:return 0}}const l=[void 0,[]];function v(K,N,x=0,F=0){const z=N;return z.values&&z.values.length>1?_(K,z.values,x,F):b(K,N,x,F)}e.scoreFuzzy2=v;function _(K,N,x,F){let z=0;const M=[];for(const O of N){const[q,B]=b(K,O,x,F);if(typeof q!="number")return l;z+=q,M.push(...B)}return[z,d(M)]}function b(K,N,x,F){const z=(0,R.fuzzyScore)(N.original,N.originalLowercase,x,K,K.toLowerCase(),F,!0);return z?[z[0],(0,R.createMatches)(z)]:l}const P=Object.freeze({score:0}),c=1<<18,h=1<<17,p=1<<16;function t(K,N,x,F,z){if(!K||!N.normalized)return P;const M=F.getItemLabel(K);if(!M)return P;const O=F.getItemDescription(K);let q;O?q=`${M}${O}${N.normalized}${Array.isArray(N.values)?N.values.length:""}${x}`:q=`${M}${N.normalized}${Array.isArray(N.values)?N.values.length:""}${x}`;const B=z[q];if(B)return B;const G=r(M,O,F.getItemPath(K),N,x);return z[q]=G,G}e.scoreItemFuzzy=t;function r(K,N,x,F,z){const M=!x||!F.containsPathSeparator;return x&&(S.isLinux?F.pathNormalized===x:(0,T.equalsIgnoreCase)(F.pathNormalized,x))?{score:c,labelMatch:[{start:0,end:K.length}],descriptionMatch:N?[{start:0,end:N.length}]:void 0}:F.values&&F.values.length>1?s(K,N,x,F.values,M,z):n(K,N,x,F,M,z)}function s(K,N,x,F,z,M){let O=0;const q=[],B=[];for(const G of F){const{score:ie,labelMatch:he,descriptionMatch:ye}=n(K,N,x,G,z,M);if(ie===D)return P;O+=ie,he&&q.push(...he),ye&&B.push(...ye)}return{score:O,labelMatch:d(q),descriptionMatch:d(B)}}function n(K,N,x,F,z,M){if(z||!N){const[O,q]=A(K,F.normalized,F.normalizedLowercase,M);if(O){const B=(0,R.matchesPrefix)(F.normalized,K);let G;return B?(G=h,G+=Math.round(F.normalized.length/K.length*100)):G=p,{score:G+O,labelMatch:B||a(q)}}}if(N){let O=N;x&&(O=`${N}${k.sep}`);const q=O.length,B=`${O}${K}`,[G,ie]=A(B,F.normalized,F.normalizedLowercase,M);if(G){const he=a(ie),ye=[],Ie=[];return he.forEach(Le=>{Le.start<q&&Le.end>q?(ye.push({start:0,end:Le.end-q}),Ie.push({start:Le.start,end:q})):Le.start>=q?ye.push({start:Le.start-q,end:Le.end-q}):Ie.push(Le)}),{score:G,labelMatch:ye,descriptionMatch:Ie}}}return P}function a(K){const N=[];if(!K)return N;let x;for(const F of K)x&&x.end===F?x.end+=1:(x={start:F,end:F+1},N.push(x));return N}function d(K){const N=K.sort((z,M)=>z.start-M.start),x=[];let F;for(const z of N)!F||!f(F,z)?(F=z,x.push(z)):(F.start=Math.min(F.start,z.start),F.end=Math.max(F.end,z.end));return x}function f(K,N){return!(K.end<N.start||N.end<K.start)}function w(K,N,x,F,z,M){const O=t(K,x,F,z,M),q=t(N,x,F,z,M),B=O.score,G=q.score;if((B===c||G===c)&&B!==G)return B===c?-1:1;if(B>p||G>p){if(B!==G)return B>G?-1:1;if(B<h&&G<h){const We=o(O.labelMatch,q.labelMatch);if(We!==0)return We}const Le=z.getItemLabel(K)||"",qe=z.getItemLabel(N)||"";if(Le.length!==qe.length)return Le.length-qe.length}if(B!==G)return B>G?-1:1;const ie=Array.isArray(O.labelMatch)&&O.labelMatch.length>0,he=Array.isArray(q.labelMatch)&&q.labelMatch.length>0;if(ie&&!he)return-1;if(he&&!ie)return 1;const ye=E(K,O,z),Ie=E(N,q,z);return ye&&Ie&&ye!==Ie?Ie>ye?-1:1:I(K,N,x,z)}e.compareItemsByFuzzyScore=w;function E(K,N,x){let F=-1,z=-1;if(N.descriptionMatch&&N.descriptionMatch.length?F=N.descriptionMatch[0].start:N.labelMatch&&N.labelMatch.length&&(F=N.labelMatch[0].start),N.labelMatch&&N.labelMatch.length){if(z=N.labelMatch[N.labelMatch.length-1].end,N.descriptionMatch&&N.descriptionMatch.length){const M=x.getItemDescription(K);M&&(z+=M.length)}}else N.descriptionMatch&&N.descriptionMatch.length&&(z=N.descriptionMatch[N.descriptionMatch.length-1].end);return z-F}function o(K,N){if(!K&&!N||(!K||!K.length)&&(!N||!N.length))return 0;if(!N||!N.length)return-1;if(!K||!K.length)return 1;const x=K[0].start,z=K[K.length-1].end-x,M=N[0].start,q=N[N.length-1].end-M;return z===q?0:q<z?1:-1}function I(K,N,x,F){const z=F.getItemLabel(K)||"",M=F.getItemLabel(N)||"",O=F.getItemDescription(K),q=F.getItemDescription(N),B=z.length+(O?O.length:0),G=M.length+(q?q.length:0);if(B!==G)return B-G;const ie=F.getItemPath(K),he=F.getItemPath(N);return ie&&he&&ie.length!==he.length?ie.length-he.length:z!==M?(0,g.compareAnything)(z,M,x.normalized):O&&q&&O!==q?(0,g.compareAnything)(O,q,x.normalized):ie&&he&&ie!==he?(0,g.compareAnything)(ie,he,x.normalized):0}const L=" ";function U(K){typeof K!="string"&&(K="");const N=K.toLowerCase(),{pathNormalized:x,normalized:F,normalizedLowercase:z}=V(K),M=x.indexOf(k.sep)>=0;let O;const q=K.split(L);if(q.length>1)for(const B of q){const{pathNormalized:G,normalized:ie,normalizedLowercase:he}=V(B);ie&&(O||(O=[]),O.push({original:B,originalLowercase:B.toLowerCase(),pathNormalized:G,normalized:ie,normalizedLowercase:he}))}return{original:K,originalLowercase:N,pathNormalized:x,normalized:F,normalizedLowercase:z,values:O,containsPathSeparator:M}}e.prepareQuery=U;function V(K){let N;S.isWindows?N=K.replace(/\//g,k.sep):N=K.replace(/\\/g,k.sep);const x=(0,T.stripWildcards)(N).replace(/\s/g,"");return{pathNormalized:N,normalized:x,normalizedLowercase:x.toLowerCase()}}function ee(K){return Array.isArray(K)?U(K.map(N=>N.original).join(L)):U(K.original)}e.pieceToQuery=ee}),define(me[30],ge([0,1,8,29,9,22,16]),function(J,e,g,R,k,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function D(){return Object.create(null)}e.getEmptyExpression=D;const y="**",A="/",i="[/\\\\]",C="[^/\\\\]",u=/\//g;function m(O){switch(O){case 0:return"";case 1:return`${C}*?`;default:return`(?:${i}|${C}+${i}|${i}${C}+)*?`}}function l(O,q){if(!O)return[];const B=[];let G=!1,ie=!1,he="";for(const ye of O){switch(ye){case q:if(!G&&!ie){B.push(he),he="";continue}break;case"{":G=!0;break;case"}":G=!1;break;case"[":ie=!0;break;case"]":ie=!1;break}he+=ye}return he&&B.push(he),B}e.splitGlobAware=l;function v(O){if(!O)return"";let q="";const B=l(O,A);if(B.every(G=>G===y))q=".*";else{let G=!1;B.forEach((ie,he)=>{if(ie===y){G||(q+=m(2),G=!0);return}let ye=!1,Ie="",Le=!1,qe="";for(const We of ie){if(We!=="}"&&ye){Ie+=We;continue}if(Le&&(We!=="]"||!qe)){let je;We==="-"?je=We:(We==="^"||We==="!")&&!qe?je="^":We===A?je="":je=g.escapeRegExpCharacters(We),qe+=je;continue}switch(We){case"{":ye=!0;continue;case"[":Le=!0;continue;case"}":q+=`(?:${l(Ie,",").map(Z=>v(Z)).join("|")})`,ye=!1,Ie="";break;case"]":q+="["+qe+"]",Le=!1,qe="";break;case"?":q+=C;continue;case"*":q+=m(1);continue;default:q+=g.escapeRegExpCharacters(We)}}he<B.length-1&&(B[he+1]!==y||he+2<B.length)&&(q+=i),G=!1})}return q}const _=/^\*\*\/\*\.[\w\.-]+$/,b=/^\*\*\/([\w\.-]+)\/?$/,P=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,c=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,h=/^\*\*((\/[\w\.-]+)+)\/?$/,p=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new S.LRUCache(1e4),r=function(){return!1},s=function(){return null};function n(O,q){if(!O)return s;let B;typeof O!="string"?B=O.pattern:B=O,B=B.trim();const G=`${B}_${!!q.trimForExclusions}`;let ie=t.get(G);if(ie)return a(ie,O);let he;if(_.test(B)){const ye=B.substr(4);ie=function(Ie,Le){return typeof Ie=="string"&&Ie.endsWith(ye)?B:null}}else(he=b.exec(d(B,q)))?ie=f(he[1],B):(q.trimForExclusions?c:P).test(B)?ie=w(B,q):(he=h.exec(d(B,q)))?ie=E(he[1].substr(1),B,!0):(he=p.exec(d(B,q)))?ie=E(he[1],B,!1):ie=o(B);return t.set(G,ie),a(ie,O)}function a(O,q){return typeof q=="string"?O:function(B,G){return R.isEqualOrParent(B,q.base)?O(k.relative(q.base,B),G):null}}function d(O,q){return q.trimForExclusions&&O.endsWith("/**")?O.substr(0,O.length-2):O}function f(O,q){const B=`/${O}`,G=`\\${O}`,ie=function(ye,Ie){return typeof ye!="string"?null:Ie?Ie===O?q:null:ye===O||ye.endsWith(B)||ye.endsWith(G)?q:null},he=[O];return ie.basenames=he,ie.patterns=[q],ie.allBasenames=he,ie}function w(O,q){const B=M(O.slice(1,-1).split(",").map(Ie=>n(Ie,q)).filter(Ie=>Ie!==s),O),G=B.length;if(!G)return s;if(G===1)return B[0];const ie=function(Ie,Le){for(let qe=0,We=B.length;qe<We;qe++)if(B[qe](Ie,Le))return O;return null},he=B.find(Ie=>!!Ie.allBasenames);he&&(ie.allBasenames=he.allBasenames);const ye=B.reduce((Ie,Le)=>Le.allPaths?Ie.concat(Le.allPaths):Ie,[]);return ye.length&&(ie.allPaths=ye),ie}function E(O,q,B){const G=k.sep===k.posix.sep,ie=G?O:O.replace(u,k.sep),he=k.sep+ie,ye=k.posix.sep+O,Ie=B?function(Le,qe){return typeof Le=="string"&&(Le===ie||Le.endsWith(he)||!G&&(Le===O||Le.endsWith(ye)))?q:null}:function(Le,qe){return typeof Le=="string"&&(Le===ie||!G&&Le===O)?q:null};return Ie.allPaths=[(B?"*/":"./")+O],Ie}function o(O){try{const q=new RegExp(`^${v(O)}$`);return function(B){return q.lastIndex=0,typeof B=="string"&&q.test(B)?O:null}}catch(q){return s}}function I(O,q,B){return!O||typeof q!="string"?!1:L(O)(q,void 0,B)}e.match=I;function L(O,q={}){if(!O)return r;if(typeof O=="string"||K(O)){const B=n(O,q);if(B===s)return r;const G=function(ie,he){return!!B(ie,he)};return B.allBasenames&&(G.allBasenames=B.allBasenames),B.allPaths&&(G.allPaths=B.allPaths),G}return F(O,q)}e.parse=L;function U(O){if(!O)return;let q;return B=>(q||(q=(O()||Promise.resolve([])).then(G=>G?ee(G):{})),q.then(G=>!!G[B]))}e.hasSiblingPromiseFn=U;function V(O){if(!O)return;let q;return B=>{if(!q){const G=O();q=G?ee(G):{}}return!!q[B]}}e.hasSiblingFn=V;function ee(O){const q={};for(const B of O)q[B]=!0;return q}function K(O){const q=O;return q&&typeof q.base=="string"&&typeof q.pattern=="string"}e.isRelativePattern=K;function N(O){return O.allBasenames||[]}e.getBasenameTerms=N;function x(O){return O.allPaths||[]}e.getPathTerms=x;function F(O,q){const B=M(Object.getOwnPropertyNames(O).map(Ie=>z(Ie,O[Ie],q)).filter(Ie=>Ie!==s)),G=B.length;if(!G)return s;if(!B.some(Ie=>!!Ie.requiresSiblings)){if(G===1)return B[0];const Ie=function(We,je){for(let W=0,Z=B.length;W<Z;W++){const ne=B[W](We,je);if(ne)return ne}return null},Le=B.find(We=>!!We.allBasenames);Le&&(Ie.allBasenames=Le.allBasenames);const qe=B.reduce((We,je)=>je.allPaths?We.concat(je.allPaths):We,[]);return qe.length&&(Ie.allPaths=qe),Ie}const ie=function(Ie,Le,qe){let We;for(let je=0,W=B.length;je<W;je++){const Z=B[je];Z.requiresSiblings&&qe&&(Le||(Le=k.basename(Ie)),We||(We=Le.substr(0,Le.length-k.extname(Ie).length)));const ne=Z(Ie,Le,We,qe);if(ne)return ne}return null},he=B.find(Ie=>!!Ie.allBasenames);he&&(ie.allBasenames=he.allBasenames);const ye=B.reduce((Ie,Le)=>Le.allPaths?Ie.concat(Le.allPaths):Ie,[]);return ye.length&&(ie.allPaths=ye),ie}function z(O,q,B){if(q===!1)return s;const G=n(O,B);if(G===s)return s;if(typeof q=="boolean")return G;if(q){const ie=q.when;if(typeof ie=="string"){const he=(ye,Ie,Le,qe)=>{if(!qe||!G(ye,Ie))return null;const We=ie.replace("$(basename)",Le),je=qe(We);return(0,T.isThenable)(je)?je.then(W=>W?O:null):je?O:null};return he.requiresSiblings=!0,he}}return G}function M(O,q){const B=O.filter(Ie=>!!Ie.basenames);if(B.length<2)return O;const G=B.reduce((Ie,Le)=>{const qe=Le.basenames;return qe?Ie.concat(qe):Ie},[]);let ie;if(q){ie=[];for(let Ie=0,Le=G.length;Ie<Le;Ie++)ie.push(q)}else ie=B.reduce((Ie,Le)=>{const qe=Le.patterns;return qe?Ie.concat(qe):Ie},[]);const he=function(Ie,Le){if(typeof Ie!="string")return null;if(!Le){let We;for(We=Ie.length;We>0;We--){const je=Ie.charCodeAt(We-1);if(je===47||je===92)break}Le=Ie.substr(We)}const qe=G.indexOf(Le);return qe!==-1?ie[qe]:null};he.basenames=G,he.patterns=ie,he.allBasenames=G;const ye=O.filter(Ie=>!Ie.basenames);return ye.push(he),ye}}),define(me[77],ge([0,1,2,9,8,10,11,23,29]),function(J,e,g,R,k,S,T,D,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function A(n,a,d){if(typeof n=="string"&&(n=g.URI.file(n)),d){const w=d.getWorkspaceFolder(n);if(w){const E=d.getWorkspace().folders.length>1;let o;if((0,D.isEqual)(w.uri,n)?o="":o=(0,D.relativePath)(w.uri,n),E){const I=w.name?w.name:(0,D.basename)(w.uri);o=o?I+" \u2022 "+o:I}return o}}if(n.scheme!==S.Schemas.file&&n.scheme!==S.Schemas.untitled)return n.with({query:null,fragment:null}).toString(!0);if((0,y.hasDriveLetter)(n.fsPath))return(0,R.normalize)(C(n.fsPath));let f=(0,R.normalize)(n.fsPath);return!T.isWindows&&a?.userHome&&(f=m(f,a.userHome.fsPath)),f}e.getPathLabel=A;function i(n){if(!n)return;typeof n=="string"&&(n=g.URI.file(n));const a=(0,D.basename)(n)||(n.scheme===S.Schemas.file?n.fsPath:n.path);return T.isWindows&&(0,y.isRootOrDriveLetter)(a)?C(a):a}e.getBaseLabel=i;function C(n){return(0,y.hasDriveLetter)(n)?n.charAt(0).toUpperCase()+n.slice(1):n}e.normalizeDriveLetter=C;let u=Object.create(null);function m(n,a){if(T.isWindows||!n||!a)return n;let d=u.original===a?u.normalized:void 0;return d||(d=`${(0,k.rtrim)(a,R.posix.sep)}${R.posix.sep}`,u={original:a,normalized:d}),(T.isLinux?n.startsWith(d):(0,k.startsWithIgnoreCase)(n,d))&&(n=`~/${n.substr(d.length)}`),n}e.tildify=m;function l(n,a){return n.replace(/^~($|\/|\\)/,`${a}$1`)}e.untildify=l;const v="\u2026",_="\\\\",b="~";function P(n,a=R.sep){const d=new Array(n.length);let f=!1;for(let w=0;w<n.length;w++){let E=n[w];if(E===""){d[w]=`.${a}`;continue}if(!E){d[w]=E;continue}f=!0;let o="";E.indexOf(_)===0?(o=E.substr(0,E.indexOf(_)+_.length),E=E.substr(E.indexOf(_)+_.length)):E.indexOf(a)===0?(o=E.substr(0,E.indexOf(a)+a.length),E=E.substr(E.indexOf(a)+a.length)):E.indexOf(b)===0&&(o=E.substr(0,E.indexOf(b)+b.length),E=E.substr(E.indexOf(b)+b.length));const I=E.split(a);for(let L=1;f&&L<=I.length;L++)for(let U=I.length-L;f&&U>=0;U--){f=!1;let V=I.slice(U,U+L).join(a);for(let ee=0;!f&&ee<n.length;ee++)if(ee!==w&&n[ee]&&n[ee].indexOf(V)>-1){const K=U+L===I.length,N=U>0&&n[ee].indexOf(a)>-1?a+V:V,x=n[ee].endsWith(N);f=!K||x}if(!f){let ee="";(I[0].endsWith(":")||o!=="")&&(U===1&&(U=0,L++,V=I[0]+a+V),U>0&&(ee=I[0]+a),ee=o+ee),U>0&&(ee=ee+v+a),ee=ee+V,U+L<I.length&&(ee=ee+a+v),d[w]=ee}}f&&(d[w]=E)}return d}e.shorten=P;var c;(function(n){n[n.TEXT=0]="TEXT",n[n.VARIABLE=1]="VARIABLE",n[n.SEPARATOR=2]="SEPARATOR"})(c||(c={}));function h(n,a=Object.create(null)){const d=[];let f=!1,w="";for(const E of n)if(E==="$"||f&&E==="{")w&&d.push({value:w,type:c.TEXT}),w="",f=!0;else if(E==="}"&&f){const o=a[w];if(typeof o=="string")o.length&&d.push({value:o,type:c.VARIABLE});else if(o){const I=d[d.length-1];(!I||I.type!==c.SEPARATOR)&&d.push({value:o.label,type:c.SEPARATOR})}w="",f=!1}else w+=E;return w&&!f&&d.push({value:w,type:c.TEXT}),d.filter((E,o)=>{if(E.type===c.SEPARATOR){const I=d[o-1],L=d[o+1];return[I,L].every(U=>U&&(U.type===c.VARIABLE||U.type===c.TEXT)&&U.value.length>0)}return!0}).map(E=>E.value).join("")}e.template=h;function p(n,a){return T.isMacintosh||a?n.replace(/\(&&\w\)|&&/g,"").replace(/&/g,T.isMacintosh?"&":"&&"):n.replace(/&&|&/g,d=>d==="&"?"&&":"&")}e.mnemonicMenuLabel=p;function t(n,a){return T.isMacintosh||a?n.replace(/\(&&\w\)|&&/g,""):T.isWindows?n.replace(/&&|&/g,d=>d==="&"?"&&":"&"):n.replace(/&&/g,"_")}e.mnemonicButtonLabel=t;function r(n){return n.replace(/&/g,"&&")}e.unmnemonicLabel=r;function s(n){const a=n.indexOf("/")!==-1?R.posix:R.win32,d=a.basename(n),f=a.dirname(n);return d.length?{name:d,parentPath:f}:{name:f,parentPath:""}}e.splitName=s}),define(me[102],ge([0,1,9,8,30,10,23]),function(J,e,g,R,k,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.isUnspecific=e.guessMimeTypes=e.clearTextMimes=e.registerTextMime=e.Mimes=void 0;var D;(function(r){r.text="text/plain",r.binary="application/octet-stream",r.unknown="application/unknown",r.markdown="text/markdown"})(D=e.Mimes||(e.Mimes={}));let y=[],A=[],i=[];function C(r,s=!1){const n=u(r);y.push(n),n.userConfigured?i.push(n):A.push(n),s&&!n.userConfigured&&y.forEach(a=>{a.mime===n.mime||a.userConfigured||(n.extension&&a.extension===n.extension&&console.warn(`Overwriting extension <<${n.extension}>> to now point to mime <<${n.mime}>>`),n.filename&&a.filename===n.filename&&console.warn(`Overwriting filename <<${n.filename}>> to now point to mime <<${n.mime}>>`),n.filepattern&&a.filepattern===n.filepattern&&console.warn(`Overwriting filepattern <<${n.filepattern}>> to now point to mime <<${n.mime}>>`),n.firstline&&a.firstline===n.firstline&&console.warn(`Overwriting firstline <<${n.firstline}>> to now point to mime <<${n.mime}>>`))})}e.registerTextMime=C;function u(r){return{id:r.id,mime:r.mime,filename:r.filename,extension:r.extension,filepattern:r.filepattern,firstline:r.firstline,userConfigured:r.userConfigured,filenameLowercase:r.filename?r.filename.toLowerCase():void 0,extensionLowercase:r.extension?r.extension.toLowerCase():void 0,filepatternLowercase:r.filepattern?r.filepattern.toLowerCase():void 0,filepatternOnPath:r.filepattern?r.filepattern.indexOf(g.posix.sep)>=0:!1}}function m(r){r?(y=y.filter(s=>!s.userConfigured),i=[]):(y=[],A=[],i=[])}e.clearTextMimes=m;function l(r,s){let n;if(r)switch(r.scheme){case S.Schemas.file:n=r.fsPath;break;case S.Schemas.data:n=T.DataUri.parseMetaData(r).get(T.DataUri.META_DATA_LABEL);break;default:n=r.path}if(!n)return[D.unknown];n=n.toLowerCase();const a=(0,g.basename)(n),d=v(n,a,i);if(d)return[d,D.text];const f=v(n,a,A);if(f)return[f,D.text];if(s){const w=_(s);if(w)return[w,D.text]}return[D.unknown]}e.guessMimeTypes=l;function v(r,s,n){let a=null,d=null,f=null;for(let w=n.length-1;w>=0;w--){const E=n[w];if(s===E.filenameLowercase){a=E;break}if(E.filepattern&&(!d||E.filepattern.length>d.filepattern.length)){const o=E.filepatternOnPath?r:s;(0,k.match)(E.filepatternLowercase,o)&&(d=E)}E.extension&&(!f||E.extension.length>f.extension.length)&&s.endsWith(E.extensionLowercase)&&(f=E)}return a?a.mime:d?d.mime:f?f.mime:null}function _(r){if((0,R.startsWithUTF8BOM)(r)&&(r=r.substr(1)),r.length>0)for(let s=y.length-1;s>=0;s--){const n=y[s];if(!n.firstline)continue;const a=r.match(n.firstline);if(a&&a.length>0)return n.mime}return null}function b(r){return r?typeof r=="string"?r===D.binary||r===D.text||r===D.unknown:r.length===1&&b(r[0]):!0}e.isUnspecific=b;const P={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function c(r){const s=(0,g.extname)(r);return P[s.toLowerCase()]}e.getMediaMime=c;function h(r){for(const s in P)if(P[s]===r)return s}e.getExtensionForMimeType=h;const p=/^(.+)\/(.+?)(;.+)?$/;function t(r,s){const n=p.exec(r);return n?`${n[1].toLowerCase()}/${n[2].toLowerCase()}${n[3]??""}`:s?void 0:r}e.normalizeMimeType=t}),define(me[103],ge([0,1,2]),function(J,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function R(i){return i.toJSON()}class k{constructor(C){this._uriTransformer=C}transformIncoming(C){const u=this._uriTransformer.transformIncoming(C);return u===C?C:R(g.URI.from(u))}transformOutgoing(C){const u=this._uriTransformer.transformOutgoing(C);return u===C?C:R(g.URI.from(u))}transformOutgoingURI(C){const u=this._uriTransformer.transformOutgoing(C);return u===C?C:g.URI.from(u)}transformOutgoingScheme(C){return this._uriTransformer.transformOutgoingScheme(C)}}e.URITransformer=k,e.DefaultURITransformer=new class{transformIncoming(i){return i}transformOutgoing(i){return i}transformOutgoingURI(i){return i}transformOutgoingScheme(i){return i}};function S(i,C,u){if(!i||u>200)return null;if(typeof i=="object"){if(i instanceof g.URI)return C.transformOutgoing(i);for(let m in i)if(Object.hasOwnProperty.call(i,m)){const l=S(i[m],C,u+1);l!==null&&(i[m]=l)}}return null}function T(i,C){const u=S(i,C,0);return u===null?i:u}e.transformOutgoingURIs=T;function D(i,C,u,m){if(!i||m>200)return null;if(typeof i=="object"){if(i.$mid===1)return u?g.URI.revive(C.transformIncoming(i)):C.transformIncoming(i);for(let l in i)if(Object.hasOwnProperty.call(i,l)){const v=D(i[l],C,u,m+1);v!==null&&(i[l]=v)}}return null}function y(i,C){const u=D(i,C,!1,0);return u===null?i:u}e.transformIncomingURIs=y;function A(i,C){const u=D(i,C,!0,0);return u===null?i:u}e.transformAndReviveIncomingURIs=A}),define(me[32],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const g=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function R(y){return g.test(y)}e.isUUID=R;const k=new Uint8Array(16),S=[];for(let y=0;y<256;y++)S.push(y.toString(16).padStart(2,"0"));let T;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?T=crypto.getRandomValues.bind(crypto):T=function(y){for(let A=0;A<y.length;A++)y[A]=Math.floor(Math.random()*256);return y};function D(){T(k),k[6]=k[6]&15|64,k[8]=k[8]&63|128;let y=0,A="";return A+=S[k[y++]],A+=S[k[y++]],A+=S[k[y++]],A+=S[k[y++]],A+="-",A+=S[k[y++]],A+=S[k[y++]],A+="-",A+=S[k[y++]],A+=S[k[y++]],A+="-",A+=S[k[y++]],A+=S[k[y++]],A+="-",A+=S[k[y++]],A+=S[k[y++]],A+=S[k[y++]],A+=S[k[y++]],A+=S[k[y++]],A+=S[k[y++]],A}e.generateUuid=D}),define(me[142],ge([0,1,104]),function(J,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class R{constructor(S="utf8"){this.stringDecoder=new g.StringDecoder(S),this.remaining=null}write(S){const T=[],D=this.remaining?this.remaining+this.stringDecoder.write(S):this.stringDecoder.write(S);if(D.length<1)return T;let y=0,A,i=y;for(;i<D.length;)if(A=D.charCodeAt(i),A===13||A===10){if(T.push(D.substring(y,i)),i++,i<D.length){const C=A;A=D.charCodeAt(i),(C===13&&A===10||C===10&&A===13)&&i++}y=i}else i++;return this.remaining=y<D.length?D.substr(y):null,T}end(){return this.remaining}}e.LineDecoder=R}),define(me[28],ge([0,1,49,78,289,9,16,11,29,32,76,23,2]),function(J,e,g,R,k,S,T,D,y,A,i,C,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var m;(function(N){N[N.UNLINK=0]="UNLINK",N[N.MOVE=1]="MOVE"})(m=e.RimRafMode||(e.RimRafMode={}));async function l(N,x=m.UNLINK){if((0,y.isRootOrDriveLetter)(N))throw new Error("rimraf - will refuse to recursively delete root");return x===m.UNLINK?_(N):v(N)}async function v(N){try{const x=(0,S.join)((0,R.tmpdir)(),(0,A.generateUuid)());try{await e.Promises.rename(N,x)}catch(F){return _(N)}_(x).catch(F=>{})}catch(x){if(x.code!=="ENOENT")throw x}}async function _(N){return e.Promises.rmdir(N,{recursive:!0,maxRetries:3})}function b(N){if((0,y.isRootOrDriveLetter)(N))throw new Error("rimraf - will refuse to recursively delete root");g.rmdirSync(N,{recursive:!0})}e.rimrafSync=b;async function P(N,x){return p(await(x?c(N):(0,k.promisify)(g.readdir)(N)))}async function c(N){try{return await(0,k.promisify)(g.readdir)(N,{withFileTypes:!0})}catch(z){console.warn("[node.js fs] readdir with filetypes failed with error: ",z)}const x=[],F=await P(N);for(const z of F){let M=!1,O=!1,q=!1;try{const B=await e.Promises.lstat((0,S.join)(N,z));M=B.isFile(),O=B.isDirectory(),q=B.isSymbolicLink()}catch(B){console.warn("[node.js fs] unexpected error from lstat after readdir: ",B)}x.push({name:z,isFile:()=>M,isDirectory:()=>O,isSymbolicLink:()=>q})}return x}function h(N){return p(g.readdirSync(N))}e.readdirSync=h;function p(N){return N.map(x=>typeof x=="string"?D.isMacintosh?(0,i.normalizeNFC)(x):x:(x.name=D.isMacintosh?(0,i.normalizeNFC)(x.name):x.name,x))}async function t(N){const x=await P(N),F=[];for(const z of x)await s.existsDirectory((0,S.join)(N,z))&&F.push(z);return F}function r(N,x=1e3){return new Promise(F=>{let z=!1;const M=setInterval(()=>{z||(z=!0,g.access(N,O=>{z=!1,O&&(clearInterval(M),F(void 0))}))},x)})}e.whenDeleted=r;var s;(function(N){async function x(M){let O;try{if(O=await e.Promises.lstat(M),!O.isSymbolicLink())return{stat:O}}catch(q){}try{return{stat:await e.Promises.stat(M),symbolicLink:O?.isSymbolicLink()?{dangling:!1}:void 0}}catch(q){if(q.code==="ENOENT"&&O)return{stat:O,symbolicLink:{dangling:!0}};if(D.isWindows&&q.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(M)),symbolicLink:{dangling:!1}}}catch(B){if(B.code==="ENOENT"&&O)return{stat:O,symbolicLink:{dangling:!0}};throw B}throw q}}N.stat=x;async function F(M){try{const{stat:O,symbolicLink:q}=await N.stat(M);return O.isFile()&&q?.dangling!==!0}catch(O){}return!1}N.existsFile=F;async function z(M){try{const{stat:O,symbolicLink:q}=await N.stat(M);return O.isDirectory()&&q?.dangling!==!0}catch(O){}return!1}N.existsDirectory=z})(s=e.SymlinkSupport||(e.SymlinkSupport={}));const n=new T.ResourceQueue;function a(N,x,F){return n.queueFor(u.URI.file(N),C.extUriBiasedIgnorePathCase).queue(()=>{const z=E(F);return new Promise((M,O)=>f(N,x,z,q=>q?O(q):M()))})}let d=!0;function f(N,x,F,z){if(!d)return g.writeFile(N,x,{mode:F.mode,flag:F.flag},z);g.open(N,F.flag,F.mode,(M,O)=>{if(M)return z(M);g.writeFile(O,x,q=>{if(q)return g.close(O,()=>z(q));g.fdatasync(O,B=>(B&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",B),d=!1),g.close(O,G=>z(G))))})})}function w(N,x,F){const z=E(F);if(!d)return g.writeFileSync(N,x,{mode:z.mode,flag:z.flag});const M=g.openSync(N,z.flag,z.mode);try{g.writeFileSync(M,x);try{g.fdatasyncSync(M)}catch(O){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",O),d=!1}}finally{g.closeSync(M)}}e.writeFileSync=w;function E(N){return N?{mode:typeof N.mode=="number"?N.mode:438,flag:typeof N.flag=="string"?N.flag:"w"}:{mode:438,flag:"w"}}async function o(N,x){if(N===x)return;async function F(z){try{const M=await e.Promises.lstat(z);if(M.isDirectory()||M.isSymbolicLink())return;await e.Promises.utimes(z,M.atime,new Date)}catch(M){}}try{await e.Promises.rename(N,x),await F(x)}catch(z){if(N.toLowerCase()!==x.toLowerCase()&&z.code==="EXDEV"||N.endsWith("."))await I(N,x,{preserveSymlinks:!1}),await l(N,m.MOVE),await F(x);else throw z}}async function I(N,x,F){return U(N,x,{root:{source:N,target:x},options:F,handledSourcePaths:new Set})}const L=511;async function U(N,x,F){if(F.handledSourcePaths.has(N))return;F.handledSourcePaths.add(N);const{stat:z,symbolicLink:M}=await s.stat(N);if(M){if(F.options.preserveSymlinks)try{return await K(N,x,F)}catch(O){console.warn("[node.js fs] copy of symlink failed: ",O)}if(M.dangling)return}return z.isDirectory()?V(N,x,z.mode&L,F):ee(N,x,z.mode&L)}async function V(N,x,F,z){await e.Promises.mkdir(x,{recursive:!0,mode:F});const M=await P(N);for(const O of M)await U((0,S.join)(N,O),(0,S.join)(x,O),z)}async function ee(N,x,F){await e.Promises.copyFile(N,x),await e.Promises.chmod(x,F)}async function K(N,x,F){let z=await e.Promises.readlink(N);(0,y.isEqualOrParent)(z,F.root.source,!D.isLinux)&&(z=(0,S.join)(F.root.target,z.substr(F.root.source.length+1))),await e.Promises.symlink(z,x)}e.Promises=new class{get access(){return(0,k.promisify)(g.access)}get stat(){return(0,k.promisify)(g.stat)}get lstat(){return(0,k.promisify)(g.lstat)}get utimes(){return(0,k.promisify)(g.utimes)}get read(){return(0,k.promisify)(g.read)}get readFile(){return(0,k.promisify)(g.readFile)}get write(){return(0,k.promisify)(g.write)}get appendFile(){return(0,k.promisify)(g.appendFile)}get fdatasync(){return(0,k.promisify)(g.fdatasync)}get truncate(){return(0,k.promisify)(g.truncate)}get rename(){return(0,k.promisify)(g.rename)}get copyFile(){return(0,k.promisify)(g.copyFile)}get open(){return(0,k.promisify)(g.open)}get close(){return(0,k.promisify)(g.close)}get symlink(){return(0,k.promisify)(g.symlink)}get readlink(){return(0,k.promisify)(g.readlink)}get chmod(){return(0,k.promisify)(g.chmod)}get mkdir(){return(0,k.promisify)(g.mkdir)}get unlink(){return(0,k.promisify)(g.unlink)}get rmdir(){return(0,k.promisify)(g.rmdir)}get realpath(){return(0,k.promisify)(g.realpath)}async exists(N){try{return await e.Promises.access(N),!0}catch{return!1}}get readdir(){return P}get readDirsInDir(){return t}get writeFile(){return a}get rm(){return l}get move(){return o}get copy(){return I}}}),define(me[105],ge([0,1,49,8,9,28]),function(J,e,g,R,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcaseSync=void 0;function T(i){const C=(0,k.dirname)(i);if(i===C)return i;const u=((0,k.basename)(i)||i).toLowerCase();try{const l=(0,S.readdirSync)(C).filter(v=>v.toLowerCase()===u);if(l.length===1){const v=T(C);if(v)return(0,k.join)(v,l[0])}else if(l.length>1){const v=l.indexOf(u);if(v>=0){const _=T(C);if(_)return(0,k.join)(_,l[v])}}}catch(m){}return null}e.realcaseSync=T;async function D(i){try{return await S.Promises.realpath(i)}catch(C){const u=A(i);return await S.Promises.access(u,g.constants.R_OK),u}}e.realpath=D;function y(i){try{return g.realpathSync(i)}catch(C){const u=A(i);return g.accessSync(u,g.constants.R_OK),u}}e.realpathSync=y;function A(i){return(0,R.rtrim)((0,k.normalize)(i),k.sep)}});var Ve=this&&this.__decorate||function(J,e,g,R){var k=arguments.length,S=k<3?e:R===null?R=Object.getOwnPropertyDescriptor(e,g):R,T;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")S=Reflect.decorate(J,e,g,R);else for(var D=J.length-1;D>=0;D--)(T=J[D])&&(S=(k<3?T(S):k>3?T(e,g,S):T(e,g))||S);return k>3&&S&&Object.defineProperty(e,g,S),S};define(me[106],ge([0,1,3,6,16,21,15,24,20,14,59,8,56]),function(J,e,g,R,k,S,T,D,y,A,i,C,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var m;(function(M){M[M.Promise=100]="Promise",M[M.PromiseCancel=101]="PromiseCancel",M[M.EventListen=102]="EventListen",M[M.EventDispose=103]="EventDispose"})(m=e.RequestType||(e.RequestType={}));function l(M){switch(M){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var v;(function(M){M[M.Initialize=200]="Initialize",M[M.PromiseSuccess=201]="PromiseSuccess",M[M.PromiseError=202]="PromiseError",M[M.PromiseErrorObj=203]="PromiseErrorObj",M[M.EventFire=204]="EventFire"})(v=e.ResponseType||(e.ResponseType={}));function _(M){switch(M){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var b;(function(M){M[M.Uninitialized=0]="Uninitialized",M[M.Idle=1]="Idle"})(b||(b={}));class P{constructor(O){this.buffer=O,this.pos=0}read(O){const q=this.buffer.slice(this.pos,this.pos+O);return this.pos+=q.byteLength,q}}class c{constructor(){this.buffers=[]}get buffer(){return D.VSBuffer.concat(this.buffers)}write(O){this.buffers.push(O)}}var h;(function(M){M[M.Undefined=0]="Undefined",M[M.String=1]="String",M[M.Buffer=2]="Buffer",M[M.VSBuffer=3]="VSBuffer",M[M.Array=4]="Array",M[M.Object=5]="Object"})(h||(h={}));function p(M){const O=D.VSBuffer.alloc(4);return O.writeUInt32BE(M,0),O}function t(M){return M.read(4).readUInt32BE(0)}function r(M){const O=D.VSBuffer.alloc(1);return O.writeUInt8(M,0),O}const s={Undefined:r(h.Undefined),String:r(h.String),Buffer:r(h.Buffer),VSBuffer:r(h.VSBuffer),Array:r(h.Array),Object:r(h.Object)},n=typeof Buffer!="undefined";function a(M,O){if(typeof O=="undefined")M.write(s.Undefined);else if(typeof O=="string"){const q=D.VSBuffer.fromString(O);M.write(s.String),M.write(p(q.byteLength)),M.write(q)}else if(n&&Buffer.isBuffer(O)){const q=D.VSBuffer.wrap(O);M.write(s.Buffer),M.write(p(q.byteLength)),M.write(q)}else if(O instanceof D.VSBuffer)M.write(s.VSBuffer),M.write(p(O.byteLength)),M.write(O);else if(Array.isArray(O)){M.write(s.Array),M.write(p(O.length));for(const q of O)a(M,q)}else{const q=D.VSBuffer.fromString(JSON.stringify(O));M.write(s.Object),M.write(p(q.byteLength)),M.write(q)}}function d(M){switch(M.read(1).readUInt8(0)){case h.Undefined:return;case h.String:return M.read(t(M)).toString();case h.Buffer:return M.read(t(M)).buffer;case h.VSBuffer:return M.read(t(M));case h.Array:{const q=t(M),B=[];for(let G=0;G<q;G++)B.push(d(M));return B}case h.Object:return JSON.parse(M.read(t(M)).toString())}}class f{constructor(O,q,B=null,G=1e3){this.protocol=O,this.ctx=q,this.logger=B,this.timeoutDelay=G,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(ie=>this.onRawMessage(ie)),this.sendResponse({type:200})}registerChannel(O,q){this.channels.set(O,q),setTimeout(()=>this.flushPendingRequests(O),0)}sendResponse(O){switch(O.type){case 200:{const q=this.send([O.type]);this.logger&&this.logger.logOutgoing(q,0,1,_(O.type));return}case 201:case 202:case 204:case 203:{const q=this.send([O.type,O.id],O.data);this.logger&&this.logger.logOutgoing(q,O.id,1,_(O.type),O.data);return}}}send(O,q=void 0){const B=new c;return a(B,O),a(B,q),this.sendBuffer(B.buffer)}sendBuffer(O){try{return this.protocol.send(O),O.byteLength}catch(q){return 0}}onRawMessage(O){const q=new P(O),B=d(q),G=d(q),ie=B[0];switch(ie){case 100:return this.logger&&this.logger.logIncoming(O.byteLength,B[1],1,`${l(ie)}: ${B[2]}.${B[3]}`,G),this.onPromise({type:ie,id:B[1],channelName:B[2],name:B[3],arg:G});case 102:return this.logger&&this.logger.logIncoming(O.byteLength,B[1],1,`${l(ie)}: ${B[2]}.${B[3]}`,G),this.onEventListen({type:ie,id:B[1],channelName:B[2],name:B[3],arg:G});case 101:return this.logger&&this.logger.logIncoming(O.byteLength,B[1],1,`${l(ie)}`),this.disposeActiveRequest({type:ie,id:B[1]});case 103:return this.logger&&this.logger.logIncoming(O.byteLength,B[1],1,`${l(ie)}`),this.disposeActiveRequest({type:ie,id:B[1]})}}onPromise(O){const q=this.channels.get(O.channelName);if(!q){this.collectPendingRequest(O);return}const B=new S.CancellationTokenSource;let G;try{G=q.call(this.ctx,O.name,O.arg,B.token)}catch(ye){G=Promise.reject(ye)}const ie=O.id;G.then(ye=>{this.sendResponse({id:ie,data:ye,type:201}),this.activeRequests.delete(O.id)},ye=>{ye instanceof Error?this.sendResponse({id:ie,data:{message:ye.message,name:ye.name,stack:ye.stack?ye.stack.split?ye.stack.split(`
`):ye.stack:void 0},type:202}):this.sendResponse({id:ie,data:ye,type:203}),this.activeRequests.delete(O.id)});const he=(0,R.toDisposable)(()=>B.cancel());this.activeRequests.set(O.id,he)}onEventListen(O){const q=this.channels.get(O.channelName);if(!q){this.collectPendingRequest(O);return}const B=O.id,ie=q.listen(this.ctx,O.name,O.arg)(he=>this.sendResponse({id:B,data:he,type:204}));this.activeRequests.set(O.id,ie)}disposeActiveRequest(O){const q=this.activeRequests.get(O.id);q&&(q.dispose(),this.activeRequests.delete(O.id))}collectPendingRequest(O){let q=this.pendingRequests.get(O.channelName);q||(q=[],this.pendingRequests.set(O.channelName,q));const B=setTimeout(()=>{console.error(`Unknown channel: ${O.channelName}`),O.type===100&&this.sendResponse({id:O.id,data:{name:"Unknown channel",message:`Channel name '${O.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);q.push({request:O,timeoutTimer:B})}flushPendingRequests(O){const q=this.pendingRequests.get(O);if(q){for(const B of q)switch(clearTimeout(B.timeoutTimer),B.request.type){case 100:this.onPromise(B.request);break;case 102:this.onEventListen(B.request);break}this.pendingRequests.delete(O)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(O=>O.dispose()),this.activeRequests.clear()}}e.ChannelServer=f;var w;(function(M){M[M.LocalSide=0]="LocalSide",M[M.OtherSide=1]="OtherSide"})(w=e.RequestInitiator||(e.RequestInitiator={}));class E{constructor(O,q=null){this.protocol=O,this.isDisposed=!1,this.state=b.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new g.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(B=>this.onBuffer(B)),this.logger=q}getChannel(O){const q=this;return{call(B,G,ie){return q.isDisposed?Promise.reject(T.canceled()):q.requestPromise(O,B,G,ie)},listen(B,G){return q.isDisposed?Promise.reject(T.canceled()):q.requestEvent(O,B,G)}}}requestPromise(O,q,B,G=S.CancellationToken.None){const ie=this.lastRequestId++,ye={id:ie,type:100,channelName:O,name:q,arg:B};if(G.isCancellationRequested)return Promise.reject(T.canceled());let Ie;return new Promise((qe,We)=>{if(G.isCancellationRequested)return We(T.canceled());const je=()=>{const le=Y=>{switch(Y.type){case 201:this.handlers.delete(ie),qe(Y.data);break;case 202:this.handlers.delete(ie);const ae=new Error(Y.data.message);ae.stack=Y.data.stack,ae.name=Y.data.name,We(ae);break;case 203:this.handlers.delete(ie),We(Y.data);break}};this.handlers.set(ie,le),this.sendRequest(ye)};let W=null;this.state===b.Idle?je():(W=(0,k.createCancelablePromise)(le=>this.whenInitialized()),W.then(()=>{W=null,je()}));const Z=()=>{W?(W.cancel(),W=null):this.sendRequest({id:ie,type:101}),We(T.canceled())},ne=G.onCancellationRequested(Z);Ie=(0,R.combinedDisposable)((0,R.toDisposable)(Z),ne),this.activeRequests.add(Ie)}).finally(()=>{this.activeRequests.delete(Ie)})}requestEvent(O,q,B){const G=this.lastRequestId++,he={id:G,type:102,channelName:O,name:q,arg:B};let ye=null;const Ie=new g.Emitter({onFirstListenerAdd:()=>{ye=(0,k.createCancelablePromise)(qe=>this.whenInitialized()),ye.then(()=>{ye=null,this.activeRequests.add(Ie),this.sendRequest(he)})},onLastListenerRemove:()=>{ye?(ye.cancel(),ye=null):(this.activeRequests.delete(Ie),this.sendRequest({id:G,type:103}))}}),Le=qe=>Ie.fire(qe.data);return this.handlers.set(G,Le),Ie.event}sendRequest(O){switch(O.type){case 100:case 102:{const q=this.send([O.type,O.id,O.channelName,O.name],O.arg);this.logger&&this.logger.logOutgoing(q,O.id,0,`${l(O.type)}: ${O.channelName}.${O.name}`,O.arg);return}case 101:case 103:{const q=this.send([O.type,O.id]);this.logger&&this.logger.logOutgoing(q,O.id,0,l(O.type));return}}}send(O,q=void 0){const B=new c;return a(B,O),a(B,q),this.sendBuffer(B.buffer)}sendBuffer(O){try{return this.protocol.send(O),O.byteLength}catch(q){return 0}}onBuffer(O){const q=new P(O),B=d(q),G=d(q),ie=B[0];switch(ie){case 200:return this.logger&&this.logger.logIncoming(O.byteLength,0,0,_(ie)),this.onResponse({type:B[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(O.byteLength,B[1],0,_(ie),G),this.onResponse({type:B[0],id:B[1],data:G})}}onResponse(O){if(O.type===200){this.state=b.Idle,this._onDidInitialize.fire();return}const q=this.handlers.get(O.id);q&&q(O)}get onDidInitializePromise(){return g.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===b.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(O=>O.dispose()),this.activeRequests.clear()}}Ve([u.memoize],E.prototype,"onDidInitializePromise",null),e.ChannelClient=E;class o{constructor(O){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new g.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new g.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,O(({protocol:q,onDidClientDisconnect:B})=>{g.Event.once(q.onMessage)(ie=>{const he=new P(ie),ye=d(he),Ie=new f(q,ye),Le=new E(q);this.channels.forEach((We,je)=>Ie.registerChannel(je,We));const qe={channelServer:Ie,channelClient:Le,ctx:ye};this._connections.add(qe),this._onDidAddConnection.fire(qe),B(()=>{Ie.dispose(),Le.dispose(),this._connections.delete(qe),this._onDidRemoveConnection.fire(qe)})})})}get connections(){const O=[];return this._connections.forEach(q=>O.push(q)),O}getChannel(O,q){const B=this;return{call(G,ie,he){let ye;if((0,A.isFunction)(q)){let Le=(0,y.getRandomElement)(B.connections.filter(q));ye=Le?Promise.resolve(Le):g.Event.toPromise(g.Event.filter(B.onDidAddConnection,q))}else ye=q.routeCall(B,G,ie);const Ie=ye.then(Le=>Le.channelClient.getChannel(O));return L(Ie).call(G,ie,he)},listen(G,ie){if((0,A.isFunction)(q))return B.getMulticastEvent(O,q,G,ie);const he=q.routeEvent(B,G,ie).then(ye=>ye.channelClient.getChannel(O));return L(he).listen(G,ie)}}}getMulticastEvent(O,q,B,G){const ie=this;let he=new R.DisposableStore;const ye=new g.Emitter({onFirstListenerAdd:()=>{he=new R.DisposableStore;const Ie=new g.EventMultiplexer,Le=new Map,qe=je=>{const Z=je.channelClient.getChannel(O).listen(B,G),ne=Ie.add(Z);Le.set(je,ne)},We=je=>{const W=Le.get(je);!W||(W.dispose(),Le.delete(je))};ie.connections.filter(q).forEach(qe),g.Event.filter(ie.onDidAddConnection,q)(qe,void 0,he),ie.onDidRemoveConnection(We,void 0,he),Ie.event(ye.fire,ye,he),he.add(Ie)},onLastListenerRemove:()=>{he.dispose()}});return ye.event}registerChannel(O,q){this.channels.set(O,q),this._connections.forEach(B=>{B.channelServer.registerChannel(O,q)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=o;class I{constructor(O,q,B=null){const G=new c;a(G,q),O.send(G.buffer),this.channelClient=new E(O,B),this.channelServer=new f(O,q,B)}getChannel(O){return this.channelClient.getChannel(O)}registerChannel(O,q){this.channelServer.registerChannel(O,q)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=I;function L(M){return{call(O,q,B){return M.then(G=>G.call(O,q,B))},listen(O,q){const B=new g.Relay;return M.then(G=>B.input=G.listen(O,q)),B.event}}}e.getDelayedChannel=L;function U(M){let O=!1;return{call(q,B,G){return O?M.call(q,B,G):(0,k.timeout)(0).then(()=>O=!0).then(()=>M.call(q,B,G))},listen(q,B){if(O)return M.listen(q,B);const G=new g.Relay;return(0,k.timeout)(0).then(()=>O=!0).then(()=>G.input=M.listen(q,B)),G.event}}}e.getNextTickChannel=U;class V{constructor(O){this.fn=O}routeCall(O){return this.route(O)}routeEvent(O){return this.route(O)}async route(O){for(const q of O.connections)if(await Promise.resolve(this.fn(q.ctx)))return Promise.resolve(q);return await g.Event.toPromise(O.onDidAddConnection),await this.route(O)}}e.StaticRouter=V;var ee;(function(M){function O(G,ie){const he=G,ye=ie&&ie.disableMarshalling,Ie=new Map;for(const Le in he)B(Le)&&Ie.set(Le,g.Event.buffer(he[Le],!0));return new class{listen(Le,qe){const We=Ie.get(qe);if(We)return We;throw new Error(`Event not found: ${qe}`)}call(Le,qe,We){const je=he[qe];if(typeof je=="function"){if(!ye&&Array.isArray(We))for(let W=0;W<We.length;W++)We[W]=(0,i.revive)(We[W]);return je.apply(he,We)}throw new Error(`Method not found: ${qe}`)}}}M.fromService=O;function q(G,ie){const he=ie&&ie.disableMarshalling;return new Proxy({},{get(ye,Ie){if(typeof Ie=="string")return ie?.properties?.has(Ie)?ie.properties.get(Ie):B(Ie)?G.listen(Ie):async function(...Le){let qe;ie&&!(0,A.isUndefinedOrNull)(ie.context)?qe=[ie.context,...Le]:qe=Le;const We=await G.call(Ie,qe);return he?We:(0,i.revive)(We)};throw new Error(`Property not found: ${String(Ie)}`)}})}M.toService=q;function B(G){return G[0]==="o"&&G[1]==="n"&&C.isUpperAsciiLetter(G.charCodeAt(2))}})(ee=e.ProxyChannel||(e.ProxyChannel={}));const K=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function N(M){if(Array.isArray(M))return M;if(M&&typeof M=="object"&&typeof M.toString=="function"){let O=M.toString();if(O!=="[object Object]")return O}return M}function x(M){return Array.isArray(M)?M.map(N):N(M)}function F(M,O,q,B,G,ie,he){he=x(he);const ye=K[G],Ie=ye[B%ye.length];let Le=[`%c[${M}]%c[${String(O).padStart(7," ")}]%c[len: ${String(q).padStart(5," ")}]%c${String(B).padStart(5," ")} - ${ie}`,"color: darkgreen","color: grey","color: grey",`color: ${Ie}`];/\($/.test(ie)?(Le=Le.concat(he),Le.push(")")):Le.push(he),console.log.apply(console,Le)}e.logWithColors=F;class z{constructor(O,q){this._outgoingPrefix=O,this._incomingPrefix=q,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(O,q,B,G,ie){this._totalOutgoing+=O,F(this._outgoingPrefix,this._totalOutgoing,O,q,B,G,ie)}logIncoming(O,q,B,G,ie){this._totalIncoming+=O,F(this._incomingPrefix,this._totalIncoming,O,q,B,G,ie)}}e.IPCLogger=z}),define(me[107],ge([0,1,3,106,6,24,11,38]),function(J,e,g,R,k,S,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=void 0;var y;(function(s){s[s.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",s[s.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(y=e.SocketCloseEventType||(e.SocketCloseEventType={}));let A=null;function i(){return A||(A=S.VSBuffer.alloc(0)),A}class C{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(n){this._chunks.push(n),this._totalLength+=n.byteLength}read(n){return this._read(n,!0)}peek(n){return this._read(n,!1)}_read(n,a){if(n===0)return i();if(n>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===n){const E=this._chunks[0];return a&&(this._chunks.shift(),this._totalLength-=n),E}if(this._chunks[0].byteLength>n){const E=this._chunks[0].slice(0,n);return a&&(this._chunks[0]=this._chunks[0].slice(n),this._totalLength-=n),E}let d=S.VSBuffer.alloc(n),f=0,w=0;for(;n>0;){const E=this._chunks[w];if(E.byteLength>n){const o=E.slice(0,n);d.set(o,f),f+=n,a&&(this._chunks[w]=E.slice(n),this._totalLength-=n),n-=n}else d.set(E,f),f+=E.byteLength,a?(this._chunks.shift(),this._totalLength-=E.byteLength):w++,n-=E.byteLength}return d}}e.ChunkStream=C;var u;(function(s){s[s.None=0]="None",s[s.Regular=1]="Regular",s[s.Control=2]="Control",s[s.Ack=3]="Ack",s[s.KeepAlive=4]="KeepAlive",s[s.Disconnect=5]="Disconnect",s[s.ReplayRequest=6]="ReplayRequest"})(u||(u={}));var m;(function(s){s[s.HeaderLength=13]="HeaderLength",s[s.AcknowledgeTime=2e3]="AcknowledgeTime",s[s.AcknowledgeTimeoutTime=2e4]="AcknowledgeTimeoutTime",s[s.KeepAliveTime=5e3]="KeepAliveTime",s[s.KeepAliveTimeoutTime=2e4]="KeepAliveTimeoutTime",s[s.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",s[s.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(m=e.ProtocolConstants||(e.ProtocolConstants={}));class l{constructor(n,a,d,f){this.type=n,this.id=a,this.ack=d,this.data=f,this.writtenTime=0}get size(){return this.data.byteLength}}class v extends k.Disposable{constructor(n){super();this._onMessage=this._register(new g.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=n,this._isDisposed=!1,this._incomingData=new C,this._register(this._socket.onData(a=>this.acceptChunk(a))),this.lastReadTime=Date.now()}acceptChunk(n){if(!(!n||n.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(n);this._incomingData.byteLength>=this._state.readLen;){const a=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=a.readUInt32BE(9),this._state.messageType=a.readUInt8(0),this._state.id=a.readUInt32BE(1),this._state.ack=a.readUInt32BE(5);else{const d=this._state.messageType,f=this._state.id,w=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._onMessage.fire(new l(d,f,w,a)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class _{constructor(n){this._isDisposed=!1,this._socket=n,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch(n){}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}write(n){if(this._isDisposed)return;n.writtenTime=Date.now(),this.lastWriteTime=Date.now();const a=S.VSBuffer.alloc(13);a.writeUInt8(n.type,0),a.writeUInt32BE(n.id,1),a.writeUInt32BE(n.ack,5),a.writeUInt32BE(n.data.byteLength,9),this._writeSoon(a,n.data)}_bufferAdd(n,a){const d=this._totalLength===0;return this._data.push(n,a),this._totalLength+=n.byteLength+a.byteLength,d}_bufferTake(){const n=S.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,n}_writeSoon(n,a){this._bufferAdd(n,a)&&T.setImmediate(()=>{this._writeNow()})}_writeNow(){this._totalLength!==0&&this._socket.write(this._bufferTake())}}class b extends k.Disposable{constructor(n){super();this._onMessage=new g.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new g.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=n,this._socketWriter=this._register(new _(this._socket)),this._socketReader=this._register(new v(this._socket)),this._register(this._socketReader.onMessage(a=>{a.type===1&&this._onMessage.fire(a.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(n){this._socketWriter.write(new l(1,0,0,n))}}e.Protocol=b;class P extends R.IPCClient{constructor(n,a,d=null){super(n,a,d);this.protocol=n}static fromSocket(n,a){return new P(new b(n),a)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const n=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),n.end()}}e.Client=P;class c{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new g.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,D.nextTick(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(n){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(n):this._emitter.fire(n):this._bufferedMessages.push(n)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=c;class h{constructor(n){this.data=n,this.next=null}}class p{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){let n=[],a=0,d=this._first;for(;d;)n[a++]=d.data,d=d.next;return n}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(n){const a=new h(n);if(!this._first){this._first=a,this._last=a;return}this._last.next=a,this._last=a}}class t{constructor(){this.lastRuns=[];const n=Date.now();for(let a=0;a<t._HISTORY_LENGTH;a++)this.lastRuns[a]=n-1e3*a;setInterval(()=>{for(let a=t._HISTORY_LENGTH;a>=1;a--)this.lastRuns[a]=this.lastRuns[a-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return t._INSTANCE||(t._INSTANCE=new t),t._INSTANCE}load(){const n=Date.now(),a=(1+t._HISTORY_LENGTH)*1e3;let d=0;for(let f=0;f<t._HISTORY_LENGTH;f++)n-this.lastRuns[f]<=a&&d++;return 1-d/t._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}t._HISTORY_LENGTH=10,t._INSTANCE=null;class r{constructor(n,a=null){this._loadEstimator=t.getInstance(),this._onControlMessage=new c,this.onControlMessage=this._onControlMessage.event,this._onMessage=new c,this.onMessage=this._onMessage.event,this._onDidDispose=new c,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new c,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new c,this.onSocketTimeout=this._onSocketTimeout.event,this._isReconnecting=!1,this._outgoingUnackMsg=new p,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._outgoingKeepAliveTimeout=null,this._incomingKeepAliveTimeout=null,this._lastReplayRequestTime=0,this._socketDisposables=[],this._socket=n,this._socketWriter=new _(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new v(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(d=>this._receiveMessage(d))),this._socketDisposables.push(this._socket.onClose(d=>this._onSocketClose.fire(d))),a&&this._socketReader.acceptChunk(a),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._outgoingKeepAliveTimeout&&(clearTimeout(this._outgoingKeepAliveTimeout),this._outgoingKeepAliveTimeout=null),this._incomingKeepAliveTimeout&&(clearTimeout(this._incomingKeepAliveTimeout),this._incomingKeepAliveTimeout=null),this._socketDisposables=(0,k.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const n=new l(5,0,0,i());this._socketWriter.write(n),this._socketWriter.flush()}_sendKeepAliveCheck(){if(this._outgoingKeepAliveTimeout)return;const n=Date.now()-this._socketWriter.lastWriteTime;if(n>=5e3){const a=new l(4,0,0,i());this._socketWriter.write(a),this._sendKeepAliveCheck();return}this._outgoingKeepAliveTimeout=setTimeout(()=>{this._outgoingKeepAliveTimeout=null,this._sendKeepAliveCheck()},5e3-n+5)}_recvKeepAliveCheck(){if(this._incomingKeepAliveTimeout)return;const n=Date.now()-this._socketReader.lastReadTime;if(n>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._incomingKeepAliveTimeout=setTimeout(()=>{this._incomingKeepAliveTimeout=null,this._recvKeepAliveCheck()},Math.max(2e4-n,0)+5)}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(n,a){this._isReconnecting=!0,this._socketDisposables=(0,k.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._socket=n,this._socketWriter=new _(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new v(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(d=>this._receiveMessage(d))),this._socketDisposables.push(this._socket.onClose(d=>this._onSocketClose.fire(d))),this._socketReader.acceptChunk(a)}endAcceptReconnection(){this._isReconnecting=!1;const n=this._outgoingUnackMsg.toArray();for(let a=0,d=n.length;a<d;a++)this._socketWriter.write(n[a]);this._recvAckCheck(),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(n){if(n.ack>this._outgoingAckId){this._outgoingAckId=n.ack;do{const a=this._outgoingUnackMsg.peek();if(a&&a.id<=n.ack)this._outgoingUnackMsg.pop();else break}while(!0)}if(n.type===1){if(n.id>this._incomingMsgId)if(n.id!==this._incomingMsgId+1){const a=Date.now();a-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=a,this._socketWriter.write(new l(6,0,0,i())))}else this._incomingMsgId=n.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(n.data)}else if(n.type===2)this._onControlMessage.fire(n.data);else if(n.type===5)this._onDidDispose.fire();else if(n.type===6){const a=this._outgoingUnackMsg.toArray();for(let d=0,f=a.length;d<f;d++)this._socketWriter.write(a[d]);this._recvAckCheck()}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(n){const a=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const d=new l(1,a,this._incomingAckId,n);this._outgoingUnackMsg.push(d),this._isReconnecting||(this._socketWriter.write(d),this._recvAckCheck())}sendControl(n){const a=new l(2,0,0,n);this._socketWriter.write(a)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const n=Date.now()-this._incomingMsgLastTime;if(n>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-n+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout)return;const n=this._outgoingUnackMsg.peek(),a=Date.now()-n.writtenTime;if(a>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},Math.max(2e4-a,0)+5)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const n=new l(3,0,this._incomingAckId,i());this._socketWriter.write(n)}}e.PersistentProtocol=r}),define(me[108],ge([0,1,97]),function(J,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharacterSet=e.CharacterClassifier=void 0;class R{constructor(D){let y=(0,g.toUint8)(D);this._defaultValue=y,this._asciiMap=R._createAsciiMap(y),this._map=new Map}static _createAsciiMap(D){let y=new Uint8Array(256);for(let A=0;A<256;A++)y[A]=D;return y}set(D,y){let A=(0,g.toUint8)(y);D>=0&&D<256?this._asciiMap[D]=A:this._map.set(D,A)}get(D){return D>=0&&D<256?this._asciiMap[D]:this._map.get(D)||this._defaultValue}}e.CharacterClassifier=R;var k;(function(T){T[T.False=0]="False",T[T.True=1]="True"})(k||(k={}));class S{constructor(){this._actual=new R(0)}add(D){this._actual.set(D,1)}has(D){return this._actual.get(D)===1}}e.CharacterSet=S}),define(me[143],ge([0,1,108]),function(J,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMapForWordSeparators=e.WordCharacterClassifier=e.WordCharacterClass=void 0;var R;(function(T){T[T.Regular=0]="Regular",T[T.Whitespace=1]="Whitespace",T[T.WordSeparator=2]="WordSeparator"})(R=e.WordCharacterClass||(e.WordCharacterClass={}));class k extends g.CharacterClassifier{constructor(D){super(0);for(let y=0,A=D.length;y<A;y++)this.set(D.charCodeAt(y),2);this.set(32,1),this.set(9,1)}}e.WordCharacterClassifier=k;function S(T){let D={};return y=>(D.hasOwnProperty(y)||(D[y]=T(y)),D[y])}e.getMapForWordSeparators=S(T=>new k(T))}),define(me[50],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Position=void 0;class g{constructor(k,S){this.lineNumber=k,this.column=S}with(k=this.lineNumber,S=this.column){return k===this.lineNumber&&S===this.column?this:new g(k,S)}delta(k=0,S=0){return this.with(this.lineNumber+k,this.column+S)}equals(k){return g.equals(this,k)}static equals(k,S){return!k&&!S?!0:!!k&&!!S&&k.lineNumber===S.lineNumber&&k.column===S.column}isBefore(k){return g.isBefore(this,k)}static isBefore(k,S){return k.lineNumber<S.lineNumber?!0:S.lineNumber<k.lineNumber?!1:k.column<S.column}isBeforeOrEqual(k){return g.isBeforeOrEqual(this,k)}static isBeforeOrEqual(k,S){return k.lineNumber<S.lineNumber?!0:S.lineNumber<k.lineNumber?!1:k.column<=S.column}static compare(k,S){let T=k.lineNumber|0,D=S.lineNumber|0;if(T===D){let y=k.column|0,A=S.column|0;return y-A}return T-D}clone(){return new g(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(k){return new g(k.lineNumber,k.column)}static isIPosition(k){return k&&typeof k.lineNumber=="number"&&typeof k.column=="number"}}e.Position=g}),define(me[41],ge([0,1,50]),function(J,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;class R{constructor(S,T,D,y){S>D||S===D&&T>y?(this.startLineNumber=D,this.startColumn=y,this.endLineNumber=S,this.endColumn=T):(this.startLineNumber=S,this.startColumn=T,this.endLineNumber=D,this.endColumn=y)}isEmpty(){return R.isEmpty(this)}static isEmpty(S){return S.startLineNumber===S.endLineNumber&&S.startColumn===S.endColumn}containsPosition(S){return R.containsPosition(this,S)}static containsPosition(S,T){return!(T.lineNumber<S.startLineNumber||T.lineNumber>S.endLineNumber||T.lineNumber===S.startLineNumber&&T.column<S.startColumn||T.lineNumber===S.endLineNumber&&T.column>S.endColumn)}containsRange(S){return R.containsRange(this,S)}static containsRange(S,T){return!(T.startLineNumber<S.startLineNumber||T.endLineNumber<S.startLineNumber||T.startLineNumber>S.endLineNumber||T.endLineNumber>S.endLineNumber||T.startLineNumber===S.startLineNumber&&T.startColumn<S.startColumn||T.endLineNumber===S.endLineNumber&&T.endColumn>S.endColumn)}strictContainsRange(S){return R.strictContainsRange(this,S)}static strictContainsRange(S,T){return!(T.startLineNumber<S.startLineNumber||T.endLineNumber<S.startLineNumber||T.startLineNumber>S.endLineNumber||T.endLineNumber>S.endLineNumber||T.startLineNumber===S.startLineNumber&&T.startColumn<=S.startColumn||T.endLineNumber===S.endLineNumber&&T.endColumn>=S.endColumn)}plusRange(S){return R.plusRange(this,S)}static plusRange(S,T){let D,y,A,i;return T.startLineNumber<S.startLineNumber?(D=T.startLineNumber,y=T.startColumn):T.startLineNumber===S.startLineNumber?(D=T.startLineNumber,y=Math.min(T.startColumn,S.startColumn)):(D=S.startLineNumber,y=S.startColumn),T.endLineNumber>S.endLineNumber?(A=T.endLineNumber,i=T.endColumn):T.endLineNumber===S.endLineNumber?(A=T.endLineNumber,i=Math.max(T.endColumn,S.endColumn)):(A=S.endLineNumber,i=S.endColumn),new R(D,y,A,i)}intersectRanges(S){return R.intersectRanges(this,S)}static intersectRanges(S,T){let D=S.startLineNumber,y=S.startColumn,A=S.endLineNumber,i=S.endColumn,C=T.startLineNumber,u=T.startColumn,m=T.endLineNumber,l=T.endColumn;return D<C?(D=C,y=u):D===C&&(y=Math.max(y,u)),A>m?(A=m,i=l):A===m&&(i=Math.min(i,l)),D>A||D===A&&y>i?null:new R(D,y,A,i)}equalsRange(S){return R.equalsRange(this,S)}static equalsRange(S,T){return!!S&&!!T&&S.startLineNumber===T.startLineNumber&&S.startColumn===T.startColumn&&S.endLineNumber===T.endLineNumber&&S.endColumn===T.endColumn}getEndPosition(){return R.getEndPosition(this)}static getEndPosition(S){return new g.Position(S.endLineNumber,S.endColumn)}getStartPosition(){return R.getStartPosition(this)}static getStartPosition(S){return new g.Position(S.startLineNumber,S.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(S,T){return new R(this.startLineNumber,this.startColumn,S,T)}setStartPosition(S,T){return new R(S,T,this.endLineNumber,this.endColumn)}collapseToStart(){return R.collapseToStart(this)}static collapseToStart(S){return new R(S.startLineNumber,S.startColumn,S.startLineNumber,S.startColumn)}static fromPositions(S,T=S){return new R(S.lineNumber,S.column,T.lineNumber,T.column)}static lift(S){return S?new R(S.startLineNumber,S.startColumn,S.endLineNumber,S.endColumn):null}static isIRange(S){return S&&typeof S.startLineNumber=="number"&&typeof S.startColumn=="number"&&typeof S.endLineNumber=="number"&&typeof S.endColumn=="number"}static areIntersectingOrTouching(S,T){return!(S.endLineNumber<T.startLineNumber||S.endLineNumber===T.startLineNumber&&S.endColumn<T.startColumn||T.endLineNumber<S.startLineNumber||T.endLineNumber===S.startLineNumber&&T.endColumn<S.startColumn)}static areIntersecting(S,T){return!(S.endLineNumber<T.startLineNumber||S.endLineNumber===T.startLineNumber&&S.endColumn<=T.startColumn||T.endLineNumber<S.startLineNumber||T.endLineNumber===S.startLineNumber&&T.endColumn<=S.startColumn)}static compareRangesUsingStarts(S,T){if(S&&T){const A=S.startLineNumber|0,i=T.startLineNumber|0;if(A===i){const C=S.startColumn|0,u=T.startColumn|0;if(C===u){const m=S.endLineNumber|0,l=T.endLineNumber|0;if(m===l){const v=S.endColumn|0,_=T.endColumn|0;return v-_}return m-l}return C-u}return A-i}return(S?1:0)-(T?1:0)}static compareRangesUsingEnds(S,T){return S.endLineNumber===T.endLineNumber?S.endColumn===T.endColumn?S.startLineNumber===T.startLineNumber?S.startColumn-T.startColumn:S.startLineNumber-T.startLineNumber:S.endColumn-T.endColumn:S.endLineNumber-T.endLineNumber}static spansMultipleLines(S){return S.endLineNumber>S.startLineNumber}}e.Range=R}),define(me[144],ge([0,1,50,41]),function(J,e,g,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Selection=e.SelectionDirection=void 0;var k;(function(T){T[T.LTR=0]="LTR",T[T.RTL=1]="RTL"})(k=e.SelectionDirection||(e.SelectionDirection={}));class S extends R.Range{constructor(D,y,A,i){super(D,y,A,i);this.selectionStartLineNumber=D,this.selectionStartColumn=y,this.positionLineNumber=A,this.positionColumn=i}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(D){return S.selectionsEqual(this,D)}static selectionsEqual(D,y){return D.selectionStartLineNumber===y.selectionStartLineNumber&&D.selectionStartColumn===y.selectionStartColumn&&D.positionLineNumber===y.positionLineNumber&&D.positionColumn===y.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(D,y){return this.getDirection()===0?new S(this.startLineNumber,this.startColumn,D,y):new S(D,y,this.startLineNumber,this.startColumn)}getPosition(){return new g.Position(this.positionLineNumber,this.positionColumn)}setStartPosition(D,y){return this.getDirection()===0?new S(D,y,this.endLineNumber,this.endColumn):new S(this.endLineNumber,this.endColumn,D,y)}static fromPositions(D,y=D){return new S(D.lineNumber,D.column,y.lineNumber,y.column)}static liftSelection(D){return new S(D.selectionStartLineNumber,D.selectionStartColumn,D.positionLineNumber,D.positionColumn)}static selectionsArrEqual(D,y){if(D&&!y||!D&&y)return!1;if(!D&&!y)return!0;if(D.length!==y.length)return!1;for(let A=0,i=D.length;A<i;A++)if(!this.selectionsEqual(D[A],y[A]))return!1;return!0}static isISelection(D){return D&&typeof D.selectionStartLineNumber=="number"&&typeof D.selectionStartColumn=="number"&&typeof D.positionLineNumber=="number"&&typeof D.positionColumn=="number"}static createWithDirection(D,y,A,i,C){return C===0?new S(D,y,A,i):new S(A,i,D,y)}}e.Selection=S}),define(me[109],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApplyEditsResult=e.ValidAnnotatedEditOperation=e.ModelConstants=e.PositionAffinity=e.TrackedRangeStickiness=e.FindMatch=e.TextModelResolvedOptions=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.MinimapPosition=e.OverviewRulerLane=void 0;var g;(function(l){l[l.Left=1]="Left",l[l.Center=2]="Center",l[l.Right=4]="Right",l[l.Full=7]="Full"})(g=e.OverviewRulerLane||(e.OverviewRulerLane={}));var R;(function(l){l[l.Inline=1]="Inline",l[l.Gutter=2]="Gutter"})(R=e.MinimapPosition||(e.MinimapPosition={}));var k;(function(l){l[l.TextDefined=0]="TextDefined",l[l.LF=1]="LF",l[l.CRLF=2]="CRLF"})(k=e.EndOfLinePreference||(e.EndOfLinePreference={}));var S;(function(l){l[l.LF=1]="LF",l[l.CRLF=2]="CRLF"})(S=e.DefaultEndOfLine||(e.DefaultEndOfLine={}));var T;(function(l){l[l.LF=0]="LF",l[l.CRLF=1]="CRLF"})(T=e.EndOfLineSequence||(e.EndOfLineSequence={}));class D{constructor(v){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,v.tabSize|0),this.indentSize=v.tabSize|0,this.insertSpaces=Boolean(v.insertSpaces),this.defaultEOL=v.defaultEOL|0,this.trimAutoWhitespace=Boolean(v.trimAutoWhitespace)}equals(v){return this.tabSize===v.tabSize&&this.indentSize===v.indentSize&&this.insertSpaces===v.insertSpaces&&this.defaultEOL===v.defaultEOL&&this.trimAutoWhitespace===v.trimAutoWhitespace}createChangeEvent(v){return{tabSize:this.tabSize!==v.tabSize,indentSize:this.indentSize!==v.indentSize,insertSpaces:this.insertSpaces!==v.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==v.trimAutoWhitespace}}}e.TextModelResolvedOptions=D;class y{constructor(v,_){this._findMatchBrand=void 0,this.range=v,this.matches=_}}e.FindMatch=y;var A;(function(l){l[l.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",l[l.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",l[l.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",l[l.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(A=e.TrackedRangeStickiness||(e.TrackedRangeStickiness={}));var i;(function(l){l[l.Left=0]="Left",l[l.Right=1]="Right",l[l.None=2]="None"})(i=e.PositionAffinity||(e.PositionAffinity={}));var C;(function(l){l[l.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(C=e.ModelConstants||(e.ModelConstants={}));class u{constructor(v,_,b,P,c,h){this.identifier=v,this.range=_,this.text=b,this.forceMoveMarkers=P,this.isAutoWhitespaceEdit=c,this._isTracked=h}}e.ValidAnnotatedEditOperation=u;class m{constructor(v,_,b){this.reverseEdits=v,this.changes=_,this.trimAutoWhitespaceLineNumbers=b}}e.ApplyEditsResult=m}),define(me[145],ge([0,1,8,143,50,41,109]),function(J,e,g,R,k,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Searcher=e.isValidMatch=e.TextModelSearch=e.createFindMatch=e.SearchData=e.isMultilineRegexSource=e.SearchParams=void 0;const D=999;class y{constructor(c,h,p,t){this.searchString=c,this.isRegex=h,this.matchCase=p,this.wordSeparators=t}parseSearchRequest(){if(this.searchString==="")return null;let c;this.isRegex?c=A(this.searchString):c=this.searchString.indexOf(`
`)>=0;let h=null;try{h=g.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:c,global:!0,unicode:!0})}catch(t){return null}if(!h)return null;let p=!this.isRegex&&!c;return p&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(p=this.matchCase),new i(h,this.wordSeparators?(0,R.getMapForWordSeparators)(this.wordSeparators):null,p?this.searchString:null)}}e.SearchParams=y;function A(P){if(!P||P.length===0)return!1;for(let c=0,h=P.length;c<h;c++)if(P.charCodeAt(c)===92){if(c++,c>=h)break;const t=P.charCodeAt(c);if(t===110||t===114||t===87||t===119)return!0}return!1}e.isMultilineRegexSource=A;class i{constructor(c,h,p){this.regex=c,this.wordSeparators=h,this.simpleSearch=p}}e.SearchData=i;function C(P,c,h){if(!h)return new T.FindMatch(P,null);let p=[];for(let t=0,r=c.length;t<r;t++)p[t]=c[t];return new T.FindMatch(P,p)}e.createFindMatch=C;class u{constructor(c){let h=[],p=0;for(let t=0,r=c.length;t<r;t++)c.charCodeAt(t)===10&&(h[p++]=t);this._lineFeedsOffsets=h}findLineFeedCountBeforeOffset(c){const h=this._lineFeedsOffsets;let p=0,t=h.length-1;if(t===-1||c<=h[0])return 0;for(;p<t;){const r=p+((t-p)/2>>0);h[r]>=c?t=r-1:h[r+1]>=c?(p=r,t=r):p=r+1}return p+1}}class m{static findMatches(c,h,p,t,r){const s=h.parseSearchRequest();return s?s.regex.multiline?this._doFindMatchesMultiline(c,p,new b(s.wordSeparators,s.regex),t,r):this._doFindMatchesLineByLine(c,p,s,t,r):[]}static _getMultilineMatchRange(c,h,p,t,r,s){let n,a=0;t?(a=t.findLineFeedCountBeforeOffset(r),n=h+r+a):n=h+r;let d;if(t){let o=t.findLineFeedCountBeforeOffset(r+s.length)-a;d=n+s.length+o}else d=n+s.length;const f=c.getPositionAt(n),w=c.getPositionAt(d);return new S.Range(f.lineNumber,f.column,w.lineNumber,w.column)}static _doFindMatchesMultiline(c,h,p,t,r){const s=c.getOffsetAt(h.getStartPosition()),n=c.getValueInRange(h,1),a=c.getEOL()===`\r
`?new u(n):null,d=[];let f=0,w;for(p.reset(0);w=p.next(n);)if(d[f++]=C(this._getMultilineMatchRange(c,s,n,a,w.index,w[0]),w,t),f>=r)return d;return d}static _doFindMatchesLineByLine(c,h,p,t,r){const s=[];let n=0;if(h.startLineNumber===h.endLineNumber){const d=c.getLineContent(h.startLineNumber).substring(h.startColumn-1,h.endColumn-1);return n=this._findMatchesInLine(p,d,h.startLineNumber,h.startColumn-1,n,s,t,r),s}const a=c.getLineContent(h.startLineNumber).substring(h.startColumn-1);n=this._findMatchesInLine(p,a,h.startLineNumber,h.startColumn-1,n,s,t,r);for(let d=h.startLineNumber+1;d<h.endLineNumber&&n<r;d++)n=this._findMatchesInLine(p,c.getLineContent(d),d,0,n,s,t,r);if(n<r){const d=c.getLineContent(h.endLineNumber).substring(0,h.endColumn-1);n=this._findMatchesInLine(p,d,h.endLineNumber,0,n,s,t,r)}return s}static _findMatchesInLine(c,h,p,t,r,s,n,a){const d=c.wordSeparators;if(!n&&c.simpleSearch){const E=c.simpleSearch,o=E.length,I=h.length;let L=-o;for(;(L=h.indexOf(E,L+o))!==-1;)if((!d||_(d,h,I,L,o))&&(s[r++]=new T.FindMatch(new S.Range(p,L+1+t,p,L+1+o+t),null),r>=a))return r;return r}const f=new b(c.wordSeparators,c.regex);let w;f.reset(0);do if(w=f.next(h),w&&(s[r++]=C(new S.Range(p,w.index+1+t,p,w.index+1+w[0].length+t),w,n),r>=a))return r;while(w);return r}static findNextMatch(c,h,p,t){const r=h.parseSearchRequest();if(!r)return null;const s=new b(r.wordSeparators,r.regex);return r.regex.multiline?this._doFindNextMatchMultiline(c,p,s,t):this._doFindNextMatchLineByLine(c,p,s,t)}static _doFindNextMatchMultiline(c,h,p,t){const r=new k.Position(h.lineNumber,1),s=c.getOffsetAt(r),n=c.getLineCount(),a=c.getValueInRange(new S.Range(r.lineNumber,r.column,n,c.getLineMaxColumn(n)),1),d=c.getEOL()===`\r
`?new u(a):null;p.reset(h.column-1);let f=p.next(a);return f?C(this._getMultilineMatchRange(c,s,a,d,f.index,f[0]),f,t):h.lineNumber!==1||h.column!==1?this._doFindNextMatchMultiline(c,new k.Position(1,1),p,t):null}static _doFindNextMatchLineByLine(c,h,p,t){const r=c.getLineCount(),s=h.lineNumber,n=c.getLineContent(s),a=this._findFirstMatchInLine(p,n,s,h.column,t);if(a)return a;for(let d=1;d<=r;d++){const f=(s+d-1)%r,w=c.getLineContent(f+1),E=this._findFirstMatchInLine(p,w,f+1,1,t);if(E)return E}return null}static _findFirstMatchInLine(c,h,p,t,r){c.reset(t-1);const s=c.next(h);return s?C(new S.Range(p,s.index+1,p,s.index+1+s[0].length),s,r):null}static findPreviousMatch(c,h,p,t){const r=h.parseSearchRequest();if(!r)return null;const s=new b(r.wordSeparators,r.regex);return r.regex.multiline?this._doFindPreviousMatchMultiline(c,p,s,t):this._doFindPreviousMatchLineByLine(c,p,s,t)}static _doFindPreviousMatchMultiline(c,h,p,t){const r=this._doFindMatchesMultiline(c,new S.Range(1,1,h.lineNumber,h.column),p,t,10*D);if(r.length>0)return r[r.length-1];const s=c.getLineCount();return h.lineNumber!==s||h.column!==c.getLineMaxColumn(s)?this._doFindPreviousMatchMultiline(c,new k.Position(s,c.getLineMaxColumn(s)),p,t):null}static _doFindPreviousMatchLineByLine(c,h,p,t){const r=c.getLineCount(),s=h.lineNumber,n=c.getLineContent(s).substring(0,h.column-1),a=this._findLastMatchInLine(p,n,s,t);if(a)return a;for(let d=1;d<=r;d++){const f=(r+s-d-1)%r,w=c.getLineContent(f+1),E=this._findLastMatchInLine(p,w,f+1,t);if(E)return E}return null}static _findLastMatchInLine(c,h,p,t){let r=null,s;for(c.reset(0);s=c.next(h);)r=C(new S.Range(p,s.index+1,p,s.index+1+s[0].length),s,t);return r}}e.TextModelSearch=m;function l(P,c,h,p,t){if(p===0)return!0;const r=c.charCodeAt(p-1);if(P.get(r)!==0||r===13||r===10)return!0;if(t>0){const s=c.charCodeAt(p);if(P.get(s)!==0)return!0}return!1}function v(P,c,h,p,t){if(p+t===h)return!0;const r=c.charCodeAt(p+t);if(P.get(r)!==0||r===13||r===10)return!0;if(t>0){const s=c.charCodeAt(p+t-1);if(P.get(s)!==0)return!0}return!1}function _(P,c,h,p,t){return l(P,c,h,p,t)&&v(P,c,h,p,t)}e.isValidMatch=_;class b{constructor(c,h){this._wordSeparators=c,this._searchRegex=h,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(c){this._searchRegex.lastIndex=c,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(c){const h=c.length;let p;do{if(this._prevMatchStartIndex+this._prevMatchLength===h||(p=this._searchRegex.exec(c),!p))return null;const t=p.index,r=p[0].length;if(t===this._prevMatchStartIndex&&r===this._prevMatchLength){if(r===0){g.getNextCodePoint(c,h,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=t,this._prevMatchLength=r,!this._wordSeparators||_(this._wordSeparators,c,h,t,r))return p}while(p);return null}}e.Searcher=b}),define(me[110],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWordAtText=e.ensureValidWordDefinition=e.DEFAULT_WORD_REGEXP=e.USUAL_WORD_SEPARATORS=void 0,e.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function g(D=""){let y="(-?\\d*\\.\\d\\w*)|([^";for(const A of e.USUAL_WORD_SEPARATORS)D.indexOf(A)>=0||(y+="\\"+A);return y+="\\s]+)",new RegExp(y,"g")}e.DEFAULT_WORD_REGEXP=g();function R(D){let y=e.DEFAULT_WORD_REGEXP;if(D&&D instanceof RegExp)if(D.global)y=D;else{let A="g";D.ignoreCase&&(A+="i"),D.multiline&&(A+="m"),D.unicode&&(A+="u"),y=new RegExp(D.source,A)}return y.lastIndex=0,y}e.ensureValidWordDefinition=R;const k={maxLen:1e3,windowSize:15,timeBudget:150};function S(D,y,A,i,C=k){if(A.length>C.maxLen){let _=D-C.maxLen/2;return _<0?_=0:i+=_,A=A.substring(_,D+C.maxLen/2),S(D,y,A,i,C)}const u=Date.now(),m=D-1-i;let l=-1,v=null;for(let _=1;!(Date.now()-u>=C.timeBudget);_++){const b=m-C.windowSize*_;y.lastIndex=Math.max(0,b);const P=T(y,A,m,l);if(!P&&v||(v=P,b<=0))break;l=b}if(v){let _={word:v[0],startColumn:i+1+v.index,endColumn:i+1+v.index+v[0].length};return y.lastIndex=0,_}return null}e.getWordAtText=S;function T(D,y,A,i){let C;for(;C=D.exec(y);){const u=C.index||0;if(u<=A&&D.lastIndex>=A)return C;if(i>0&&u>i)return null}return null}}),define(me[146],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var g;(function(T){T[T.None=0]="None",T[T.Indent=1]="Indent",T[T.IndentOutdent=2]="IndentOutdent",T[T.Outdent=3]="Outdent"})(g=e.IndentAction||(e.IndentAction={}));class R{constructor(D){if(this._standardAutoClosingPairConditionalBrand=void 0,this.open=D.open,this.close=D.close,this._standardTokenMask=0,Array.isArray(D.notIn))for(let y=0,A=D.notIn.length;y<A;y++)switch(D.notIn[y]){case"string":this._standardTokenMask|=2;break;case"comment":this._standardTokenMask|=1;break;case"regex":this._standardTokenMask|=4;break}}isOK(D){return(this._standardTokenMask&D)==0}}e.StandardAutoClosingPairConditional=R;class k{constructor(D){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const y of D)S(this.autoClosingPairsOpenByStart,y.open.charAt(0),y),S(this.autoClosingPairsOpenByEnd,y.open.charAt(y.open.length-1),y),S(this.autoClosingPairsCloseByStart,y.close.charAt(0),y),S(this.autoClosingPairsCloseByEnd,y.close.charAt(y.close.length-1),y),y.close.length===1&&y.open.length===1&&S(this.autoClosingPairsCloseSingleChar,y.close,y)}}e.AutoClosingPairs=k;function S(T,D,y){T.has(D)?T.get(D).push(y):T.set(D,[y])}}),define(me[79],ge([0,1,30,9]),function(J,e,g,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function k(S,T,D,y){if(Array.isArray(S)){let A=0;for(const i of S){const C=k(i,T,D,y);if(C===10)return C;C>A&&(A=C)}return A}else{if(typeof S=="string")return y?S==="*"?5:S===D?10:0:0;if(S){const{language:A,pattern:i,scheme:C,hasAccessToAllModels:u}=S;if(!y&&!u)return 0;let m=0;if(C)if(C===T.scheme)m=10;else if(C==="*")m=5;else return 0;if(A)if(A===D)m=10;else if(A==="*")m=Math.max(m,5);else return 0;if(i){let l;if(typeof i=="string"?l=i:l={...i,base:(0,R.normalize)(i.base)},l===T.fsPath||(0,g.match)(l,T.fsPath))m=10;else return 0}return m}else return 0}}e.score=k}),define(me[147],ge([0,1,108]),function(J,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeLinks=e.LinkComputer=e.StateMachine=e.Uint8Matrix=e.State=void 0;var R;(function(m){m[m.Invalid=0]="Invalid",m[m.Start=1]="Start",m[m.H=2]="H",m[m.HT=3]="HT",m[m.HTT=4]="HTT",m[m.HTTP=5]="HTTP",m[m.F=6]="F",m[m.FI=7]="FI",m[m.FIL=8]="FIL",m[m.BeforeColon=9]="BeforeColon",m[m.AfterColon=10]="AfterColon",m[m.AlmostThere=11]="AlmostThere",m[m.End=12]="End",m[m.Accept=13]="Accept",m[m.LastKnownState=14]="LastKnownState"})(R=e.State||(e.State={}));class k{constructor(l,v,_){const b=new Uint8Array(l*v);for(let P=0,c=l*v;P<c;P++)b[P]=_;this._data=b,this.rows=l,this.cols=v}get(l,v){return this._data[l*this.cols+v]}set(l,v,_){this._data[l*this.cols+v]=_}}e.Uint8Matrix=k;class S{constructor(l){let v=0,_=0;for(let P=0,c=l.length;P<c;P++){let[h,p,t]=l[P];p>v&&(v=p),h>_&&(_=h),t>_&&(_=t)}v++,_++;let b=new k(_,v,0);for(let P=0,c=l.length;P<c;P++){let[h,p,t]=l[P];b.set(h,p,t)}this._states=b,this._maxCharCode=v}nextState(l,v){return v<0||v>=this._maxCharCode?0:this._states.get(l,v)}}e.StateMachine=S;let T=null;function D(){return T===null&&(T=new S([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),T}var y;(function(m){m[m.None=0]="None",m[m.ForceTermination=1]="ForceTermination",m[m.CannotEndIn=2]="CannotEndIn"})(y||(y={}));let A=null;function i(){if(A===null){A=new g.CharacterClassifier(0);const m=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let v=0;v<m.length;v++)A.set(m.charCodeAt(v),1);const l=".,;";for(let v=0;v<l.length;v++)A.set(l.charCodeAt(v),2)}return A}class C{static _createLink(l,v,_,b,P){let c=P-1;do{const h=v.charCodeAt(c);if(l.get(h)!==2)break;c--}while(c>b);if(b>0){const h=v.charCodeAt(b-1),p=v.charCodeAt(c);(h===40&&p===41||h===91&&p===93||h===123&&p===125)&&c--}return{range:{startLineNumber:_,startColumn:b+1,endLineNumber:_,endColumn:c+2},url:v.substring(b,c+1)}}static computeLinks(l,v=D()){const _=i();let b=[];for(let P=1,c=l.getLineCount();P<=c;P++){const h=l.getLineContent(P),p=h.length;let t=0,r=0,s=0,n=1,a=!1,d=!1,f=!1,w=!1;for(;t<p;){let E=!1;const o=h.charCodeAt(t);if(n===13){let I;switch(o){case 40:a=!0,I=0;break;case 41:I=a?0:1;break;case 91:f=!0,d=!0,I=0;break;case 93:f=!1,I=d?0:1;break;case 123:w=!0,I=0;break;case 125:I=w?0:1;break;case 39:I=s===34||s===96?0:1;break;case 34:I=s===39||s===96?0:1;break;case 96:I=s===39||s===34?0:1;break;case 42:I=s===42?1:0;break;case 124:I=s===124?1:0;break;case 32:I=f?0:1;break;default:I=_.get(o)}I===1&&(b.push(C._createLink(_,h,P,r,t)),E=!0)}else if(n===12){let I;o===91?(d=!0,I=0):I=_.get(o),I===1?E=!0:n=13}else n=v.nextState(n,o),n===0&&(E=!0);E&&(n=1,a=!1,d=!1,w=!1,r=t+1,s=o),t++}n===13&&b.push(C._createLink(_,h,P,r,p))}return b}}e.LinkComputer=C;function u(m){return!m||typeof m.getLineCount!="function"||typeof m.getLineContent!="function"?[]:C.computeLinks(m)}e.computeLinks=u}),define(me[148],ge([0,1,3,6]),function(J,e,g,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistryImpl=void 0;class k{constructor(){this._map=new Map,this._promises=new Map,this._onDidChange=new g.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}fire(T){this._onDidChange.fire({changedLanguages:T,changedColorMap:!1})}register(T,D){return this._map.set(T,D),this.fire([T]),(0,R.toDisposable)(()=>{this._map.get(T)===D&&(this._map.delete(T),this.fire([T]))})}registerPromise(T,D){let y=null,A=!1;return this._promises.set(T,D.then(i=>{this._promises.delete(T),!(A||!i)&&(y=this.register(T,i))})),(0,R.toDisposable)(()=>{A=!0,y&&y.dispose()})}getPromise(T){const D=this.get(T);if(D)return Promise.resolve(D);const y=this._promises.get(T);return y?y.then(A=>this.get(T)):null}get(T){return this._map.get(T)||null}setColorMap(T){this._colorMap=T,this._onDidChange.fire({changedLanguages:Array.from(this._map.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}e.TokenizationRegistryImpl=k}),define(me[111],ge([0,1,24,11]),function(J,e,g,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var k;(function(C){C[C.Full=1]="Full",C[C.Delta=2]="Delta"})(k||(k={}));function S(C){for(let u=0,m=C.length;u<m;u+=4){const l=C[u+0],v=C[u+1],_=C[u+2],b=C[u+3];C[u+0]=b,C[u+1]=_,C[u+2]=v,C[u+3]=l}}function T(C){const u=new Uint8Array(C.buffer,C.byteOffset,C.length*4);return R.isLittleEndian()||S(u),g.VSBuffer.wrap(u)}function D(C){const u=C.buffer;if(R.isLittleEndian()||S(u),u.byteOffset%4==0)return new Uint32Array(u.buffer,u.byteOffset,u.length/4);{const m=new Uint8Array(u.byteLength);return m.set(u),new Uint32Array(m.buffer,m.byteOffset,m.length/4)}}function y(C){const u=new Uint32Array(A(C));let m=0;if(u[m++]=C.id,C.type==="full")u[m++]=1,u[m++]=C.data.length,u.set(C.data,m),m+=C.data.length;else{u[m++]=2,u[m++]=C.deltas.length;for(const l of C.deltas)u[m++]=l.start,u[m++]=l.deleteCount,l.data?(u[m++]=l.data.length,u.set(l.data,m),m+=l.data.length):u[m++]=0}return T(u)}e.encodeSemanticTokensDto=y;function A(C){let u=0;if(u+=1+1,C.type==="full")u+=1+C.data.length;else{u+=1,u+=(1+1+1)*C.deltas.length;for(const m of C.deltas)m.data&&(u+=m.data.length)}return u}function i(C){const u=D(C);let m=0;const l=u[m++];if(u[m++]===1){const P=u[m++],c=u.subarray(m,m+P);return m+=P,{id:l,type:"full",data:c}}const _=u[m++];let b=[];for(let P=0;P<_;P++){const c=u[m++],h=u[m++],p=u[m++];let t;p>0&&(t=u.subarray(m,m+p),m+=p),b[P]={start:c,deleteCount:h,data:t}}return{id:l,type:"delta",deltas:b}}e.decodeSemanticTokensDto=i}),define(me[112],ge([0,1,97]),function(J,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PrefixSumComputer=e.PrefixSumIndexOfResult=void 0;class R{constructor(T,D){this._prefixSumIndexOfResultBrand=void 0,this.index=T,this.remainder=D}}e.PrefixSumIndexOfResult=R;class k{constructor(T){this.values=T,this.prefixSum=new Uint32Array(T.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}getCount(){return this.values.length}insertValues(T,D){T=(0,g.toUint32)(T);const y=this.values,A=this.prefixSum,i=D.length;return i===0?!1:(this.values=new Uint32Array(y.length+i),this.values.set(y.subarray(0,T),0),this.values.set(y.subarray(T),T+i),this.values.set(D,T),T-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=T-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(A.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}changeValue(T,D){return T=(0,g.toUint32)(T),D=(0,g.toUint32)(D),this.values[T]===D?!1:(this.values[T]=D,T-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=T-1),!0)}removeValues(T,D){T=(0,g.toUint32)(T),D=(0,g.toUint32)(D);const y=this.values,A=this.prefixSum;if(T>=y.length)return!1;let i=y.length-T;return D>=i&&(D=i),D===0?!1:(this.values=new Uint32Array(y.length-D),this.values.set(y.subarray(0,T),0),this.values.set(y.subarray(T+D),T),this.prefixSum=new Uint32Array(this.values.length),T-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=T-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(A.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}getTotalSum(){return this.values.length===0?0:this._getPrefixSum(this.values.length-1)}getPrefixSum(T){return T<0?0:(T=(0,g.toUint32)(T),this._getPrefixSum(T))}_getPrefixSum(T){if(T<=this.prefixSumValidIndex[0])return this.prefixSum[T];let D=this.prefixSumValidIndex[0]+1;D===0&&(this.prefixSum[0]=this.values[0],D++),T>=this.values.length&&(T=this.values.length-1);for(let y=D;y<=T;y++)this.prefixSum[y]=this.prefixSum[y-1]+this.values[y];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],T),this.prefixSum[T]}getIndexOf(T){T=Math.floor(T),this.getTotalSum();let D=0,y=this.values.length-1,A=0,i=0,C=0;for(;D<=y;)if(A=D+(y-D)/2|0,i=this.prefixSum[A],C=i-this.values[A],T<C)y=A-1;else if(T>=i)D=A+1;else break;return new R(A,T-C)}}e.PrefixSumComputer=k}),define(me[149],ge([0,1,8,50,112]),function(J,e,g,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MirrorTextModel=void 0;class S{constructor(D,y,A,i){this._uri=D,this._lines=y,this._eol=A,this._versionId=i,this._lineStarts=null,this._cachedTextValue=null}dispose(){this._lines.length=0}get version(){return this._versionId}getText(){return this._cachedTextValue===null&&(this._cachedTextValue=this._lines.join(this._eol)),this._cachedTextValue}onEvents(D){D.eol&&D.eol!==this._eol&&(this._eol=D.eol,this._lineStarts=null);const y=D.changes;for(const A of y)this._acceptDeleteRange(A.range),this._acceptInsertText(new R.Position(A.range.startLineNumber,A.range.startColumn),A.text);this._versionId=D.versionId,this._cachedTextValue=null}_ensureLineStarts(){if(!this._lineStarts){const D=this._eol.length,y=this._lines.length,A=new Uint32Array(y);for(let i=0;i<y;i++)A[i]=this._lines[i].length+D;this._lineStarts=new k.PrefixSumComputer(A)}}_setLineText(D,y){this._lines[D]=y,this._lineStarts&&this._lineStarts.changeValue(D,this._lines[D].length+this._eol.length)}_acceptDeleteRange(D){if(D.startLineNumber===D.endLineNumber){if(D.startColumn===D.endColumn)return;this._setLineText(D.startLineNumber-1,this._lines[D.startLineNumber-1].substring(0,D.startColumn-1)+this._lines[D.startLineNumber-1].substring(D.endColumn-1));return}this._setLineText(D.startLineNumber-1,this._lines[D.startLineNumber-1].substring(0,D.startColumn-1)+this._lines[D.endLineNumber-1].substring(D.endColumn-1)),this._lines.splice(D.startLineNumber,D.endLineNumber-D.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(D.startLineNumber,D.endLineNumber-D.startLineNumber)}_acceptInsertText(D,y){if(y.length===0)return;let A=(0,g.splitLines)(y);if(A.length===1){this._setLineText(D.lineNumber-1,this._lines[D.lineNumber-1].substring(0,D.column-1)+A[0]+this._lines[D.lineNumber-1].substring(D.column-1));return}A[A.length-1]+=this._lines[D.lineNumber-1].substring(D.column-1),this._setLineText(D.lineNumber-1,this._lines[D.lineNumber-1].substring(0,D.column-1)+A[0]);let i=new Uint32Array(A.length-1);for(let C=1;C<A.length;C++)this._lines.splice(D.lineNumber+C-1,0,A[C]),i[C-1]=A[C].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(D.lineNumber,i)}}e.MirrorTextModel=S}),define(me[150],ge([18,19]),function(J,e){return J.create("vs/base/common/date",e)}),define(me[151],ge([0,1,150]),function(J,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const R=60,k=R*60,S=k*24,T=S*7,D=S*30,y=S*365;function A(C,u){typeof C!="number"&&(C=C.getTime());const m=Math.round((new Date().getTime()-C)/1e3);if(m<-30)return(0,g.localize)(0,null,A(new Date().getTime()+m*1e3,!1));if(m<30)return(0,g.localize)(1,null);let l;return m<R?(l=m,u?l===1?(0,g.localize)(2,null,l):(0,g.localize)(3,null,l):l===1?(0,g.localize)(4,null,l):(0,g.localize)(5,null,l)):m<k?(l=Math.floor(m/R),u?l===1?(0,g.localize)(6,null,l):(0,g.localize)(7,null,l):l===1?(0,g.localize)(8,null,l):(0,g.localize)(9,null,l)):m<S?(l=Math.floor(m/k),u?l===1?(0,g.localize)(10,null,l):(0,g.localize)(11,null,l):l===1?(0,g.localize)(12,null,l):(0,g.localize)(13,null,l)):m<T?(l=Math.floor(m/S),u?l===1?(0,g.localize)(14,null,l):(0,g.localize)(15,null,l):l===1?(0,g.localize)(16,null,l):(0,g.localize)(17,null,l)):m<D?(l=Math.floor(m/T),u?l===1?(0,g.localize)(18,null,l):(0,g.localize)(19,null,l):l===1?(0,g.localize)(20,null,l):(0,g.localize)(21,null,l)):m<y?(l=Math.floor(m/D),u?l===1?(0,g.localize)(22,null,l):(0,g.localize)(23,null,l):l===1?(0,g.localize)(24,null,l):(0,g.localize)(25,null,l)):(l=Math.floor(m/y),u?l===1?(0,g.localize)(26,null,l):(0,g.localize)(27,null,l):l===1?(0,g.localize)(28,null,l):(0,g.localize)(29,null,l))}e.fromNow=A;function i(C){return C.getFullYear()+"-"+String(C.getMonth()+1).padStart(2,"0")+"-"+String(C.getDate()).padStart(2,"0")+"T"+String(C.getHours()).padStart(2,"0")+":"+String(C.getMinutes()).padStart(2,"0")+":"+String(C.getSeconds()).padStart(2,"0")+"."+(C.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=i}),define(me[152],ge([18,19]),function(J,e){return J.create("vs/base/common/errorMessage",e)}),define(me[60],ge([0,1,152,14,20]),function(J,e,g,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function S(A,i){return i&&(A.stack||A.stacktrace)?g.localize(0,null,D(A),T(A.stack)||T(A.stacktrace)):D(A)}function T(A){return Array.isArray(A)?A.join(`
`):A}function D(A){return typeof A.code=="string"&&typeof A.errno=="number"&&typeof A.syscall=="string"?g.localize(1,null,A.message):A.message||g.localize(2,null)}function y(A=null,i=!1){if(!A)return g.localize(3,null);if(Array.isArray(A)){const C=k.coalesce(A),u=y(C[0],i);return C.length>1?g.localize(4,null,u,C.length):u}if(R.isString(A))return A;if(A.detail){const C=A.detail;if(C.error)return S(C.error,i);if(C.exception)return S(C.exception,i)}return A.stack?S(A,i):A.message?A.message:g.localize(5,null)}e.toErrorMessage=y}),define(me[153],ge([18,19]),function(J,e){return J.create("vs/base/node/processes",e)}),define(me[113],ge([0,1,9,28,39,153,38,14,25,29,11,142,10]),function(J,e,g,R,k,S,T,D,y,A,i,C,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0;function m(h){switch(h){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function l(h,p){if(i.isWindows)try{const t={stdio:["pipe","pipe","ignore"]};p&&(t.cwd=p);const r=k.execFile("taskkill",["/T","/F","/PID",h.pid.toString()],t);return new Promise(s=>{r.once("error",n=>{s({success:!1,error:n})}),r.once("exit",(n,a)=>{s(n===0?{success:!0}:{success:!1,code:n!==null?n:1})})})}catch(t){return Promise.resolve({success:!1,error:t,code:t.status?m(t.status):1})}else if(i.isLinux||i.isMacintosh)try{const t=u.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",J).fsPath;return new Promise(r=>{k.execFile(t,[h.pid.toString()],{encoding:"utf8",shell:!0},(s,n,a)=>{r(s?{success:!1,error:s}:{success:!0})})})}catch(t){return Promise.resolve({success:!1,error:t})}else h.kill("SIGKILL");return Promise.resolve({success:!0})}function v(h=T.env){return h.comspec||"cmd.exe"}e.getWindowsShell=v;class _{constructor(p,t,r,s){if(t!==void 0&&r!==void 0&&s!==void 0)this.cmd=p,this.args=t,this.shell=r,this.options=s;else{const n=p;this.cmd=n.command,this.shell=n.isShellCommand,this.args=n.args.slice(0),this.options=n.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const n=Object.create(null);Object.keys(T.env).forEach(a=>{n[a]=T.env[a]}),Object.keys(this.options.env).forEach(a=>{n[a]=this.options.env[a]}),this.options.env=n}}getSanitizedCommand(){let p=this.cmd.toLowerCase();const t=p.lastIndexOf(g.sep);return t!==-1&&(p=p.substring(t+1)),_.WellKnowCommands[p]?p:"other"}start(p){return i.isWindows&&(this.options&&this.options.cwd&&A.isUNC(this.options.cwd)||!this.options&&A.isUNC(T.cwd()))?Promise.reject(new Error(S.localize(0,null))):this.useExec().then(t=>{let r,s;const n=new Promise((a,d)=>{r=a,s=d});if(t){let a=this.cmd;this.args&&(a=a+" "+this.args.join(" ")),this.childProcess=k.exec(a,this.options,(d,f,w)=>{this.childProcess=null;const E=d;E&&E.killed?s({killed:this.terminateRequested,stdout:f.toString(),stderr:w.toString()}):this.handleExec(r,p,d,f,w)})}else{let a=null;const d=f=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(f,r,p,s);const w={terminated:this.terminateRequested};D.isNumber(f)&&(w.cmdCode=f),r(w)};if(this.shell&&i.isWindows){const f=y.deepClone(this.options);f.windowsVerbatimArguments=!0,f.detached=!1;let w=!1,E=!1;const o=[];let I=this.ensureQuotes(this.cmd);o.push(I.value),w=I.quoted,this.args&&this.args.forEach(U=>{I=this.ensureQuotes(U),o.push(I.value),E=E&&I.quoted});const L=["/s","/c"];w?E?L.push('"'+o.join(" ")+'"'):o.length>1?L.push('"'+o[0]+'" '+o.slice(1).join(" ")):L.push('"'+o[0]+'"'):L.push(o.join(" ")),a=k.spawn(v(),L,f)}else this.cmd&&(a=k.spawn(this.cmd,this.args,this.options));a&&(this.childProcess=a,this.childProcessPromise=Promise.resolve(a),this.pidResolve&&(this.pidResolve(D.isNumber(a.pid)?a.pid:-1),this.pidResolve=void 0),a.on("error",f=>{this.childProcess=null,s({terminated:this.terminateRequested,error:f})}),a.pid&&(this.childProcess.on("close",d),this.handleSpawn(a,r,p,s,!0)))}return n})}handleClose(p,t,r,s){}ensureQuotes(p){return _.regexp.test(p)?{value:'"'+p+'"',quoted:!0}:{value:p,quoted:p.length>0&&p[0]==='"'&&p[p.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(p=>p.pid,p=>-1):new Promise(p=>{this.pidResolve=p})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(p=>(this.terminateRequested=!0,l(p,this.options.cwd).then(t=>(t.success&&(this.childProcess=null),t))),p=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(p=>{if(!this.shell||!i.isWindows)return p(!1);const t=k.spawn(v(),["/s","/c"]);t.on("error",r=>p(!0)),t.on("exit",r=>p(!1))})}}e.AbstractProcess=_,_.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},_.regexp=/^[^"].* .*[^"]/;class b extends _{constructor(p,t,r,s){super(p,t,r,s);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(p,t,r,s,n){[s,n].forEach((a,d)=>{const f=new C.LineDecoder;f.write(a).forEach(o=>{t({line:o,source:d===0?0:1})});const E=f.end();E&&t({line:E,source:d===0?0:1})}),p({terminated:this.terminateRequested,error:r})}handleSpawn(p,t,r,s,n){const a=new C.LineDecoder,d=new C.LineDecoder;p.stdout.on("data",f=>{a.write(f).forEach(E=>r({line:E,source:0}))}),p.stderr.on("data",f=>{d.write(f).forEach(E=>r({line:E,source:1}))}),this.stdoutLineDecoder=a,this.stderrLineDecoder=d}handleClose(p,t,r,s){const n=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;n&&r({line:n,source:0});const a=this.stderrLineDecoder?this.stderrLineDecoder.end():null;a&&r({line:a,source:1})}}e.LineProcess=b;function P(h){let p=[],t=!1;const r=function(s){if(t){p.push(s);return}(!h.send(s,a=>{if(a&&console.error(a),t=!1,p.length>0){const d=p.slice(0);p=[],d.forEach(f=>r(f))}})||i.isWindows)&&(t=!0)};return{send:r}}e.createQueuedSender=P;var c;(function(h){async function p(t,r,s){if(g.isAbsolute(t))return t;if(r===void 0&&(r=T.cwd()),g.dirname(t)!=="."||(s===void 0&&D.isString(T.env.PATH)&&(s=T.env.PATH.split(g.delimiter)),s===void 0||s.length===0))return g.join(r,t);async function a(d){return await R.Promises.exists(d)?!(await R.Promises.stat(d)).isDirectory():!1}for(let d of s){let f;if(g.isAbsolute(d)?f=g.join(d,t):f=g.join(r,d,t),await a(f))return f;let w=f+".com";if(await a(w)||(w=f+".exe",await a(w)))return w}return g.join(r,t)}h.findExecutable=p})(c=e.win32||(e.win32={}))}),define(me[154],ge([18,19]),function(J,e){return J.create("vs/editor/common/config/editorOptions",e)}),define(me[114],ge([0,1,154,11,110]),function(J,e,g,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_MODEL_DEFAULTS=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.boolean=e.ComputeOptionsMemory=e.ValidatedEditorOptions=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var S;(function(X){X[X.None=0]="None",X[X.Keep=1]="Keep",X[X.Brackets=2]="Brackets",X[X.Advanced=3]="Advanced",X[X.Full=4]="Full"})(S=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class T{constructor(se){this._values=se}hasChanged(se){return this._values[se]}}e.ConfigurationChangedEvent=T;class D{constructor(){this._values=[]}_read(se){return this._values[se]}get(se){return this._values[se]}_write(se,fe){this._values[se]=fe}}e.ValidatedEditorOptions=D;class y{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=y;class A{constructor(se,fe,xe,Be){this.id=se,this.name=fe,this.defaultValue=xe,this.schema=Be}compute(se,fe,xe){return xe}}class i{constructor(se,fe=null){this.schema=void 0,this.id=se,this.name="_never_",this.defaultValue=void 0,this.deps=fe}validate(se){return this.defaultValue}}class C{constructor(se,fe,xe,Be){this.id=se,this.name=fe,this.defaultValue=xe,this.schema=Be}validate(se){return typeof se=="undefined"?this.defaultValue:se}compute(se,fe,xe){return xe}}function u(X,se){return typeof X=="undefined"?se:X==="false"?!1:Boolean(X)}e.boolean=u;class m extends C{constructor(se,fe,xe,Be=void 0){typeof Be!="undefined"&&(Be.type="boolean",Be.default=xe),super(se,fe,xe,Be)}validate(se){return u(se,this.defaultValue)}}class l extends C{constructor(se,fe,xe,Be,et,Ce=void 0){typeof Ce!="undefined"&&(Ce.type="integer",Ce.default=xe,Ce.minimum=Be,Ce.maximum=et),super(se,fe,xe,Ce),this.minimum=Be,this.maximum=et}static clampedInt(se,fe,xe,Be){if(typeof se=="undefined")return fe;let et=parseInt(se,10);return isNaN(et)?fe:(et=Math.max(xe,et),et=Math.min(Be,et),et|0)}validate(se){return l.clampedInt(se,this.defaultValue,this.minimum,this.maximum)}}class v extends C{constructor(se,fe,xe,Be,et){typeof et!="undefined"&&(et.type="number",et.default=xe),super(se,fe,xe,et),this.validationFn=Be}static clamp(se,fe,xe){return se<fe?fe:se>xe?xe:se}static float(se,fe){if(typeof se=="number")return se;if(typeof se=="undefined")return fe;const xe=parseFloat(se);return isNaN(xe)?fe:xe}validate(se){return this.validationFn(v.float(se,this.defaultValue))}}class _ extends C{static string(se,fe){return typeof se!="string"?fe:se}constructor(se,fe,xe,Be=void 0){typeof Be!="undefined"&&(Be.type="string",Be.default=xe),super(se,fe,xe,Be)}validate(se){return _.string(se,this.defaultValue)}}function b(X,se,fe){return typeof X!="string"||fe.indexOf(X)===-1?se:X}e.stringSet=b;class P extends C{constructor(se,fe,xe,Be,et=void 0){typeof et!="undefined"&&(et.type="string",et.enum=Be,et.default=xe),super(se,fe,xe,et),this._allowedValues=Be}validate(se){return b(se,this.defaultValue,this._allowedValues)}}class c extends A{constructor(se,fe,xe,Be,et,Ce,De=void 0){typeof De!="undefined"&&(De.type="string",De.enum=et,De.default=Be),super(se,fe,xe,De),this._allowedValues=et,this._convert=Ce}validate(se){return typeof se!="string"?this.defaultValue:this._allowedValues.indexOf(se)===-1?this.defaultValue:this._convert(se)}}function h(X){switch(X){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class p extends A{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[g.localize(0,null),g.localize(1,null),g.localize(2,null)],default:"auto",description:g.localize(3,null)})}validate(se){switch(se){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(se,fe,xe){return xe===0?se.accessibilitySupport:xe}}class t extends A{constructor(){const se={insertSpace:!0,ignoreEmptyLines:!0};super(17,"comments",se,{"editor.comments.insertSpace":{type:"boolean",default:se.insertSpace,description:g.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:se.ignoreEmptyLines,description:g.localize(5,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const fe=se;return{insertSpace:u(fe.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:u(fe.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var r;(function(X){X[X.Hidden=0]="Hidden",X[X.Blink=1]="Blink",X[X.Smooth=2]="Smooth",X[X.Phase=3]="Phase",X[X.Expand=4]="Expand",X[X.Solid=5]="Solid"})(r=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function s(X){switch(X){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var n;(function(X){X[X.Line=1]="Line",X[X.Block=2]="Block",X[X.Underline=3]="Underline",X[X.LineThin=4]="LineThin",X[X.BlockOutline=5]="BlockOutline",X[X.UnderlineThin=6]="UnderlineThin"})(n=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function a(X){switch(X){case n.Line:return"line";case n.Block:return"block";case n.Underline:return"underline";case n.LineThin:return"line-thin";case n.BlockOutline:return"block-outline";case n.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=a;function d(X){switch(X){case"line":return n.Line;case"block":return n.Block;case"underline":return n.Underline;case"line-thin":return n.LineThin;case"block-outline":return n.BlockOutline;case"underline-thin":return n.UnderlineThin}}class f extends i{constructor(){super(126,[64,31])}compute(se,fe,xe){const Be=["monaco-editor"];return fe.get(31)&&Be.push(fe.get(31)),se.extraEditorClassName&&Be.push(se.extraEditorClassName),fe.get(64)==="default"?Be.push("mouse-default"):fe.get(64)==="copy"&&Be.push("mouse-copy"),fe.get(99)&&Be.push("showUnused"),fe.get(124)&&Be.push("showDeprecated"),Be.join(" ")}}class w extends m{constructor(){super(30,"emptySelectionClipboard",!0,{description:g.localize(6,null)})}compute(se,fe,xe){return xe&&se.emptySelectionClipboard}}class E extends A{constructor(){const se={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(33,"find",se,{"editor.find.cursorMoveOnType":{type:"boolean",default:se.cursorMoveOnType,description:g.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:se.seedSearchStringFromSelection,enumDescriptions:[g.localize(8,null),g.localize(9,null),g.localize(10,null)],description:g.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:se.autoFindInSelection,enumDescriptions:[g.localize(12,null),g.localize(13,null),g.localize(14,null)],description:g.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:se.globalFindClipboard,description:g.localize(16,null),included:R.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:se.addExtraSpaceOnTop,description:g.localize(17,null)},"editor.find.loop":{type:"boolean",default:se.loop,description:g.localize(18,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const fe=se;return{cursorMoveOnType:u(fe.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof se.seedSearchStringFromSelection=="boolean"?se.seedSearchStringFromSelection?"always":"never":b(fe.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof se.autoFindInSelection=="boolean"?se.autoFindInSelection?"always":"never":b(fe.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:u(fe.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:u(fe.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:u(fe.loop,this.defaultValue.loop)}}}class o extends A{constructor(){super(42,"fontLigatures",o.OFF,{anyOf:[{type:"boolean",description:g.localize(19,null)},{type:"string",description:g.localize(20,null)}],description:g.localize(21,null),default:!1})}validate(se){return typeof se=="undefined"?this.defaultValue:typeof se=="string"?se==="false"?o.OFF:se==="true"?o.ON:se:Boolean(se)?o.ON:o.OFF}}e.EditorFontLigatures=o,o.OFF='"liga" off, "calt" off',o.ON='"liga" on, "calt" on';class I extends i{constructor(){super(41)}compute(se,fe,xe){return se.fontInfo}}class L extends C{constructor(){super(43,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:g.localize(22,null)})}validate(se){let fe=v.float(se,this.defaultValue);return fe===0?e.EDITOR_FONT_DEFAULTS.fontSize:v.clamp(fe,6,100)}compute(se,fe,xe){return se.fontInfo.fontSize}}class U extends A{constructor(){super(44,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:U.MINIMUM_VALUE,maximum:U.MAXIMUM_VALUE,errorMessage:g.localize(23,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:U.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:g.localize(24,null)})}validate(se){return se==="normal"||se==="bold"?se:String(l.clampedInt(se,e.EDITOR_FONT_DEFAULTS.fontWeight,U.MINIMUM_VALUE,U.MAXIMUM_VALUE))}}U.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],U.MINIMUM_VALUE=1,U.MAXIMUM_VALUE=1e3;class V extends A{constructor(){const se={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},fe={type:"string",enum:["peek","gotoAndPeek","goto"],default:se.multiple,enumDescriptions:[g.localize(25,null),g.localize(26,null),g.localize(27,null)]},xe=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(48,"gotoLocation",se,{"editor.gotoLocation.multiple":{deprecationMessage:g.localize(28,null)},"editor.gotoLocation.multipleDefinitions":{description:g.localize(29,null),...fe},"editor.gotoLocation.multipleTypeDefinitions":{description:g.localize(30,null),...fe},"editor.gotoLocation.multipleDeclarations":{description:g.localize(31,null),...fe},"editor.gotoLocation.multipleImplementations":{description:g.localize(32,null),...fe},"editor.gotoLocation.multipleReferences":{description:g.localize(33,null),...fe},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:se.alternativeDefinitionCommand,enum:xe,description:g.localize(34,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:se.alternativeTypeDefinitionCommand,enum:xe,description:g.localize(35,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:se.alternativeDeclarationCommand,enum:xe,description:g.localize(36,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:se.alternativeImplementationCommand,enum:xe,description:g.localize(37,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:se.alternativeReferenceCommand,enum:xe,description:g.localize(38,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const fe=se;return{multiple:b(fe.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:fe.multipleDefinitions??b(fe.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:fe.multipleTypeDefinitions??b(fe.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:fe.multipleDeclarations??b(fe.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:fe.multipleImplementations??b(fe.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:fe.multipleReferences??b(fe.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:_.string(fe.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:_.string(fe.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:_.string(fe.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:_.string(fe.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:_.string(fe.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class ee extends A{constructor(){const se={enabled:!0,delay:300,sticky:!0};super(51,"hover",se,{"editor.hover.enabled":{type:"boolean",default:se.enabled,description:g.localize(39,null)},"editor.hover.delay":{type:"number",default:se.delay,description:g.localize(40,null)},"editor.hover.sticky":{type:"boolean",default:se.sticky,description:g.localize(41,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const fe=se;return{enabled:u(fe.enabled,this.defaultValue.enabled),delay:l.clampedInt(fe.delay,this.defaultValue.delay,0,1e4),sticky:u(fe.sticky,this.defaultValue.sticky)}}}var K;(function(X){X[X.None=0]="None",X[X.Text=1]="Text",X[X.Blocks=2]="Blocks"})(K=e.RenderMinimap||(e.RenderMinimap={}));class N extends i{constructor(){super(129,[47,56,35,63,91,58,59,93,116,119,120,121,2])}compute(se,fe,xe){return N.computeLayout(fe,{memory:se.memory,outerWidth:se.outerWidth,outerHeight:se.outerHeight,isDominatedByLongLines:se.isDominatedByLongLines,lineHeight:se.fontInfo.lineHeight,viewLineCount:se.viewLineCount,lineNumbersDigitCount:se.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:se.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:se.fontInfo.maxDigitWidth,pixelRatio:se.pixelRatio})}static computeContainedMinimapLineCount(se){const fe=se.height/se.lineHeight,xe=se.scrollBeyondLastLine?fe-1:0,Be=(se.viewLineCount+xe)/(se.pixelRatio*se.height),et=Math.floor(se.viewLineCount/Be);return{typicalViewportLineCount:fe,extraLinesBeyondLastLine:xe,desiredRatio:Be,minimapLineCount:et}}static _computeMinimapLayout(se,fe){const xe=se.outerWidth,Be=se.outerHeight,et=se.pixelRatio;if(!se.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(et*Be),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Be};const Ce=fe.stableMinimapLayoutInput,De=Ce&&se.outerHeight===Ce.outerHeight&&se.lineHeight===Ce.lineHeight&&se.typicalHalfwidthCharacterWidth===Ce.typicalHalfwidthCharacterWidth&&se.pixelRatio===Ce.pixelRatio&&se.scrollBeyondLastLine===Ce.scrollBeyondLastLine&&se.minimap.enabled===Ce.minimap.enabled&&se.minimap.side===Ce.minimap.side&&se.minimap.size===Ce.minimap.size&&se.minimap.showSlider===Ce.minimap.showSlider&&se.minimap.renderCharacters===Ce.minimap.renderCharacters&&se.minimap.maxColumn===Ce.minimap.maxColumn&&se.minimap.scale===Ce.minimap.scale&&se.verticalScrollbarWidth===Ce.verticalScrollbarWidth&&se.isViewportWrapping===Ce.isViewportWrapping,Te=se.lineHeight,ce=se.typicalHalfwidthCharacterWidth,ue=se.scrollBeyondLastLine,pe=se.minimap.renderCharacters;let be=et>=2?Math.round(se.minimap.scale*2):se.minimap.scale;const j=se.minimap.maxColumn,we=se.minimap.size,_e=se.minimap.side,Ae=se.verticalScrollbarWidth,Ue=se.viewLineCount,Ge=se.remainingWidth,Ze=se.isViewportWrapping,Qe=pe?2:3;let Je=Math.floor(et*Be);const ct=Je/et;let mt=!1,bt=!1,ot=Qe*be,at=be/et,Se=1;if(we==="fill"||we==="fit"){const{typicalViewportLineCount:Ke,extraLinesBeyondLastLine:ut,desiredRatio:St,minimapLineCount:kt}=N.computeContainedMinimapLineCount({viewLineCount:Ue,scrollBeyondLastLine:ue,height:Be,lineHeight:Te,pixelRatio:et});if(Ue/kt>1)mt=!0,bt=!0,be=1,ot=1,at=be/et;else{let ft=!1,dt=be+1;if(we==="fit"){const vt=Math.ceil((Ue+ut)*ot);Ze&&De&&Ge<=fe.stableFitRemainingWidth?(ft=!0,dt=fe.stableFitMaxMinimapScale):ft=vt>Je}if(we==="fill"||ft){mt=!0;const vt=be;ot=Math.min(Te*et,Math.max(1,Math.floor(1/St))),Ze&&De&&Ge<=fe.stableFitRemainingWidth&&(dt=fe.stableFitMaxMinimapScale),be=Math.min(dt,Math.max(1,Math.floor(ot/Qe))),be>vt&&(Se=Math.min(2,be/vt)),at=be/et/Se,Je=Math.ceil(Math.max(Ke,Ue+ut)*ot),Ze?(fe.stableMinimapLayoutInput=se,fe.stableFitRemainingWidth=Ge,fe.stableFitMaxMinimapScale=be):(fe.stableMinimapLayoutInput=null,fe.stableFitRemainingWidth=0)}}}const Pe=Math.floor(j*at),te=Math.min(Pe,Math.max(0,Math.floor((Ge-Ae-2)*at/(ce+at)))+e.MINIMAP_GUTTER_WIDTH);let Q=Math.floor(et*te);const Oe=Q/et;Q=Math.floor(Q*Se);const Fe=pe?1:2,tt=_e==="left"?0:xe-te-Ae;return{renderMinimap:Fe,minimapLeft:tt,minimapWidth:te,minimapHeightIsEditorHeight:mt,minimapIsSampling:bt,minimapScale:be,minimapLineHeight:ot,minimapCanvasInnerWidth:Q,minimapCanvasInnerHeight:Je,minimapCanvasOuterWidth:Oe,minimapCanvasOuterHeight:ct}}static computeLayout(se,fe){const xe=fe.outerWidth|0,Be=fe.outerHeight|0,et=fe.lineHeight|0,Ce=fe.lineNumbersDigitCount|0,De=fe.typicalHalfwidthCharacterWidth,Te=fe.maxDigitWidth,ce=fe.pixelRatio,ue=fe.viewLineCount,pe=se.get(121),be=pe==="inherit"?se.get(120):pe,j=be==="inherit"?se.get(116):be,we=se.get(119),_e=se.get(2),Ae=fe.isDominatedByLongLines,Ue=se.get(47),Ge=se.get(58).renderType!==0,Ze=se.get(59),Qe=se.get(93),Je=se.get(63),ct=se.get(91),mt=ct.verticalScrollbarSize,bt=ct.verticalHasArrows,ot=ct.arrowSize,at=ct.horizontalScrollbarSize,Se=se.get(56),Pe=se.get(35);let te;if(typeof Se=="string"&&/^\d+(\.\d+)?ch$/.test(Se)){const It=parseFloat(Se.substr(0,Se.length-2));te=l.clampedInt(It*De,0,0,1e3)}else te=l.clampedInt(Se,0,0,1e3);Pe&&(te+=16);let Q=0;if(Ge){const It=Math.max(Ce,Ze);Q=Math.round(It*Te)}let Oe=0;Ue&&(Oe=et);let Fe=0,tt=Fe+Oe,Ke=tt+Q,ut=Ke+te;const St=xe-Oe-Q-te;let kt=!1,Dt=!1,ft=-1;_e!==2&&(be==="inherit"&&Ae?(kt=!0,Dt=!0):j==="on"||j==="bounded"?Dt=!0:j==="wordWrapColumn"&&(ft=we));const dt=N._computeMinimapLayout({outerWidth:xe,outerHeight:Be,lineHeight:et,typicalHalfwidthCharacterWidth:De,pixelRatio:ce,scrollBeyondLastLine:Qe,minimap:Je,verticalScrollbarWidth:mt,viewLineCount:ue,remainingWidth:St,isViewportWrapping:Dt},fe.memory||new y);dt.renderMinimap!==0&&dt.minimapLeft===0&&(Fe+=dt.minimapWidth,tt+=dt.minimapWidth,Ke+=dt.minimapWidth,ut+=dt.minimapWidth);const vt=St-dt.minimapWidth,Et=Math.max(1,Math.floor((vt-mt-2)/De)),Tt=bt?ot:0;return Dt&&(ft=Math.max(1,Et),j==="bounded"&&(ft=Math.min(ft,we))),{width:xe,height:Be,glyphMarginLeft:Fe,glyphMarginWidth:Oe,lineNumbersLeft:tt,lineNumbersWidth:Q,decorationsLeft:Ke,decorationsWidth:te,contentLeft:ut,contentWidth:vt,minimap:dt,viewportColumn:Et,isWordWrapMinified:kt,isViewportWrapping:Dt,wrappingColumn:ft,verticalScrollbarWidth:mt,horizontalScrollbarHeight:at,overviewRuler:{top:Tt,width:mt,height:Be-2*Tt,right:0}}}}e.EditorLayoutInfoComputer=N;class x extends A{constructor(){const se={enabled:!0};super(55,"lightbulb",se,{"editor.lightbulb.enabled":{type:"boolean",default:se.enabled,description:g.localize(42,null)}})}validate(se){return!se||typeof se!="object"?this.defaultValue:{enabled:u(se.enabled,this.defaultValue.enabled)}}}class F extends A{constructor(){const se={enabled:!0,fontSize:0,fontFamily:""};super(125,"inlayHints",se,{"editor.inlayHints.enabled":{type:"boolean",default:se.enabled,description:g.localize(43,null)},"editor.inlayHints.fontSize":{type:"number",default:se.fontSize,markdownDescription:g.localize(44,null)},"editor.inlayHints.fontFamily":{type:"string",default:se.fontFamily,description:g.localize(45,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const fe=se;return{enabled:u(fe.enabled,this.defaultValue.enabled),fontSize:l.clampedInt(fe.fontSize,this.defaultValue.fontSize,0,100),fontFamily:_.string(fe.fontFamily,this.defaultValue.fontFamily)}}}class z extends v{constructor(){super(57,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,se=>v.clamp(se,0,150),{markdownDescription:g.localize(46,null)})}compute(se,fe,xe){return se.fontInfo.lineHeight}}class M extends A{constructor(){const se={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",renderCharacters:!0,maxColumn:120,scale:1};super(63,"minimap",se,{"editor.minimap.enabled":{type:"boolean",default:se.enabled,description:g.localize(47,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[g.localize(48,null),g.localize(49,null),g.localize(50,null)],default:se.size,description:g.localize(51,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:se.side,description:g.localize(52,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:se.showSlider,description:g.localize(53,null)},"editor.minimap.scale":{type:"number",default:se.scale,minimum:1,maximum:3,enum:[1,2,3],description:g.localize(54,null)},"editor.minimap.renderCharacters":{type:"boolean",default:se.renderCharacters,description:g.localize(55,null)},"editor.minimap.maxColumn":{type:"number",default:se.maxColumn,description:g.localize(56,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const fe=se;return{enabled:u(fe.enabled,this.defaultValue.enabled),size:b(fe.size,this.defaultValue.size,["proportional","fill","fit"]),side:b(fe.side,this.defaultValue.side,["right","left"]),showSlider:b(fe.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:u(fe.renderCharacters,this.defaultValue.renderCharacters),scale:l.clampedInt(fe.scale,1,1,3),maxColumn:l.clampedInt(fe.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function O(X){return X==="ctrlCmd"?R.isMacintosh?"metaKey":"ctrlKey":"altKey"}class q extends A{constructor(){super(73,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:g.localize(57,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:g.localize(58,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const fe=se;return{top:l.clampedInt(fe.top,0,0,1e3),bottom:l.clampedInt(fe.bottom,0,0,1e3)}}}class B extends A{constructor(){const se={enabled:!0,cycle:!1};super(74,"parameterHints",se,{"editor.parameterHints.enabled":{type:"boolean",default:se.enabled,description:g.localize(59,null)},"editor.parameterHints.cycle":{type:"boolean",default:se.cycle,description:g.localize(60,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const fe=se;return{enabled:u(fe.enabled,this.defaultValue.enabled),cycle:u(fe.cycle,this.defaultValue.cycle)}}}class G extends i{constructor(){super(127)}compute(se,fe,xe){return se.pixelRatio}}class ie extends A{constructor(){const se={other:!0,comments:!1,strings:!1};super(77,"quickSuggestions",se,{anyOf:[{type:"boolean"},{type:"object",properties:{strings:{type:"boolean",default:se.strings,description:g.localize(61,null)},comments:{type:"boolean",default:se.comments,description:g.localize(62,null)},other:{type:"boolean",default:se.other,description:g.localize(63,null)}}}],default:se,description:g.localize(64,null)});this.defaultValue=se}validate(se){if(typeof se=="boolean")return se;if(se&&typeof se=="object"){const fe=se,xe={other:u(fe.other,this.defaultValue.other),comments:u(fe.comments,this.defaultValue.comments),strings:u(fe.strings,this.defaultValue.strings)};return xe.other&&xe.comments&&xe.strings?!0:!xe.other&&!xe.comments&&!xe.strings?!1:xe}return this.defaultValue}}var he;(function(X){X[X.Off=0]="Off",X[X.On=1]="On",X[X.Relative=2]="Relative",X[X.Interval=3]="Interval",X[X.Custom=4]="Custom"})(he=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class ye extends A{constructor(){super(58,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[g.localize(65,null),g.localize(66,null),g.localize(67,null),g.localize(68,null)],default:"on",description:g.localize(69,null)})}validate(se){let fe=this.defaultValue.renderType,xe=this.defaultValue.renderFn;return typeof se!="undefined"&&(typeof se=="function"?(fe=4,xe=se):se==="interval"?fe=3:se==="relative"?fe=2:se==="on"?fe=1:fe=0),{renderType:fe,renderFn:xe}}}function Ie(X){const se=X.get(86);return se==="editable"?X.get(79):se!=="on"}e.filterValidationDecorations=Ie;class Le extends A{constructor(){const se=[],fe={type:"number",description:g.localize(70,null)};super(90,"rulers",se,{type:"array",items:{anyOf:[fe,{type:["object"],properties:{column:fe,color:{type:"string",description:g.localize(71,null),format:"color-hex"}}}]},default:se,description:g.localize(72,null)})}validate(se){if(Array.isArray(se)){let fe=[];for(let xe of se)if(typeof xe=="number")fe.push({column:l.clampedInt(xe,0,0,1e4),color:null});else if(xe&&typeof xe=="object"){const Be=xe;fe.push({column:l.clampedInt(Be.column,0,0,1e4),color:Be.color})}return fe.sort((xe,Be)=>xe.column-Be.column),fe}return this.defaultValue}}function qe(X,se){if(typeof X!="string")return se;switch(X){case"hidden":return 2;case"visible":return 3;default:return 1}}class We extends A{constructor(){const se={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(91,"scrollbar",se,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[g.localize(73,null),g.localize(74,null),g.localize(75,null)],default:"auto",description:g.localize(76,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[g.localize(77,null),g.localize(78,null),g.localize(79,null)],default:"auto",description:g.localize(80,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:se.verticalScrollbarSize,description:g.localize(81,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:se.horizontalScrollbarSize,description:g.localize(82,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:se.scrollByPage,description:g.localize(83,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const fe=se,xe=l.clampedInt(fe.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Be=l.clampedInt(fe.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:l.clampedInt(fe.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:qe(fe.vertical,this.defaultValue.vertical),horizontal:qe(fe.horizontal,this.defaultValue.horizontal),useShadows:u(fe.useShadows,this.defaultValue.useShadows),verticalHasArrows:u(fe.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:u(fe.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:u(fe.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:u(fe.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:xe,horizontalSliderSize:l.clampedInt(fe.horizontalSliderSize,xe,0,1e3),verticalScrollbarSize:Be,verticalSliderSize:l.clampedInt(fe.verticalSliderSize,Be,0,1e3),scrollByPage:u(fe.scrollByPage,this.defaultValue.scrollByPage)}}}class je extends A{constructor(){const se={enabled:!1,mode:"subwordSmart"};super(53,"inlineSuggest",se,{"editor.inlineSuggest.enabled":{type:"boolean",default:se.enabled,description:g.localize(84,null)},"editor.inlineSuggest.mode":{type:"string",enum:["prefix","subword","subwordSmart"],enumDescriptions:[g.localize(85,null),g.localize(86,null),g.localize(87,null)],default:se.mode,description:g.localize(88,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const fe=se;return{enabled:u(fe.enabled,this.defaultValue.enabled),mode:b(fe.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"])}}}class W extends A{constructor(){const se={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(105,"suggest",se,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[g.localize(89,null),g.localize(90,null)],default:se.insertMode,description:g.localize(91,null)},"editor.suggest.filterGraceful":{type:"boolean",default:se.filterGraceful,description:g.localize(92,null)},"editor.suggest.localityBonus":{type:"boolean",default:se.localityBonus,description:g.localize(93,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:se.shareSuggestSelections,markdownDescription:g.localize(94,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:se.snippetsPreventQuickSuggestions,description:g.localize(95,null)},"editor.suggest.showIcons":{type:"boolean",default:se.showIcons,description:g.localize(96,null)},"editor.suggest.showStatusBar":{type:"boolean",default:se.showStatusBar,description:g.localize(97,null)},"editor.suggest.preview":{type:"boolean",default:se.preview,description:g.localize(98,null)},"editor.suggest.previewMode":{type:"string",enum:["prefix","subword","subwordSmart"],enumDescriptions:[g.localize(99,null),g.localize(100,null),g.localize(101,null)],default:se.previewMode,description:g.localize(102,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:se.showInlineDetails,description:g.localize(103,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:g.localize(104,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:g.localize(105,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:g.localize(106,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:g.localize(107,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:g.localize(108,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:g.localize(109,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:g.localize(110,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:g.localize(111,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:g.localize(112,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:g.localize(113,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:g.localize(114,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:g.localize(115,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:g.localize(116,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:g.localize(117,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:g.localize(118,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:g.localize(119,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:g.localize(120,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:g.localize(121,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:g.localize(122,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:g.localize(123,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:g.localize(124,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:g.localize(125,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:g.localize(126,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:g.localize(127,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:g.localize(128,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:g.localize(129,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:g.localize(130,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:g.localize(131,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:g.localize(132,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:g.localize(133,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:g.localize(134,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const fe=se;return{insertMode:b(fe.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:u(fe.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:u(fe.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:u(fe.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:u(fe.shareSuggestSelections,this.defaultValue.shareSuggestSelections),showIcons:u(fe.showIcons,this.defaultValue.showIcons),showStatusBar:u(fe.showStatusBar,this.defaultValue.showStatusBar),preview:u(fe.preview,this.defaultValue.preview),previewMode:b(fe.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:u(fe.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:u(fe.showMethods,this.defaultValue.showMethods),showFunctions:u(fe.showFunctions,this.defaultValue.showFunctions),showConstructors:u(fe.showConstructors,this.defaultValue.showConstructors),showDeprecated:u(fe.showDeprecated,this.defaultValue.showDeprecated),showFields:u(fe.showFields,this.defaultValue.showFields),showVariables:u(fe.showVariables,this.defaultValue.showVariables),showClasses:u(fe.showClasses,this.defaultValue.showClasses),showStructs:u(fe.showStructs,this.defaultValue.showStructs),showInterfaces:u(fe.showInterfaces,this.defaultValue.showInterfaces),showModules:u(fe.showModules,this.defaultValue.showModules),showProperties:u(fe.showProperties,this.defaultValue.showProperties),showEvents:u(fe.showEvents,this.defaultValue.showEvents),showOperators:u(fe.showOperators,this.defaultValue.showOperators),showUnits:u(fe.showUnits,this.defaultValue.showUnits),showValues:u(fe.showValues,this.defaultValue.showValues),showConstants:u(fe.showConstants,this.defaultValue.showConstants),showEnums:u(fe.showEnums,this.defaultValue.showEnums),showEnumMembers:u(fe.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:u(fe.showKeywords,this.defaultValue.showKeywords),showWords:u(fe.showWords,this.defaultValue.showWords),showColors:u(fe.showColors,this.defaultValue.showColors),showFiles:u(fe.showFiles,this.defaultValue.showFiles),showReferences:u(fe.showReferences,this.defaultValue.showReferences),showFolders:u(fe.showFolders,this.defaultValue.showFolders),showTypeParameters:u(fe.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:u(fe.showSnippets,this.defaultValue.showSnippets),showUsers:u(fe.showUsers,this.defaultValue.showUsers),showIssues:u(fe.showIssues,this.defaultValue.showIssues)}}}class Z extends A{constructor(){super(101,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:g.localize(135,null),default:!0,type:"boolean"}})}validate(se){return!se||typeof se!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:u(se.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class ne extends i{constructor(){super(128,[79])}compute(se,fe,xe){return fe.get(79)?!0:se.tabFocusMode}}var le;(function(X){X[X.None=0]="None",X[X.Same=1]="Same",X[X.Indent=2]="Indent",X[X.DeepIndent=3]="DeepIndent"})(le=e.WrappingIndent||(e.WrappingIndent={}));function Y(X){switch(X){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}}class ae extends i{constructor(){super(130,[129])}compute(se,fe,xe){const Be=fe.get(129);return{isDominatedByLongLines:se.isDominatedByLongLines,isWordWrapMinified:Be.isWordWrapMinified,isViewportWrapping:Be.isViewportWrapping,wrappingColumn:Be.wrappingColumn}}}const ve="Consolas, 'Courier New', monospace",Me="Menlo, Monaco, 'Courier New', monospace",ze="'Droid Sans Mono', 'monospace', monospace, 'Droid Sans Fallback'";e.EDITOR_FONT_DEFAULTS={fontFamily:R.isMacintosh?Me:R.isLinux?ze:ve,fontWeight:"normal",fontSize:R.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0},e.editorOptionsRegistry=[];function Ee(X){return e.editorOptionsRegistry[X.id]=X,X}var Ye;(function(X){X[X.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",X[X.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",X[X.accessibilitySupport=2]="accessibilitySupport",X[X.accessibilityPageSize=3]="accessibilityPageSize",X[X.ariaLabel=4]="ariaLabel",X[X.autoClosingBrackets=5]="autoClosingBrackets",X[X.autoClosingDelete=6]="autoClosingDelete",X[X.autoClosingOvertype=7]="autoClosingOvertype",X[X.autoClosingQuotes=8]="autoClosingQuotes",X[X.autoIndent=9]="autoIndent",X[X.automaticLayout=10]="automaticLayout",X[X.autoSurround=11]="autoSurround",X[X.codeLens=12]="codeLens",X[X.codeLensFontFamily=13]="codeLensFontFamily",X[X.codeLensFontSize=14]="codeLensFontSize",X[X.colorDecorators=15]="colorDecorators",X[X.columnSelection=16]="columnSelection",X[X.comments=17]="comments",X[X.contextmenu=18]="contextmenu",X[X.copyWithSyntaxHighlighting=19]="copyWithSyntaxHighlighting",X[X.cursorBlinking=20]="cursorBlinking",X[X.cursorSmoothCaretAnimation=21]="cursorSmoothCaretAnimation",X[X.cursorStyle=22]="cursorStyle",X[X.cursorSurroundingLines=23]="cursorSurroundingLines",X[X.cursorSurroundingLinesStyle=24]="cursorSurroundingLinesStyle",X[X.cursorWidth=25]="cursorWidth",X[X.disableLayerHinting=26]="disableLayerHinting",X[X.disableMonospaceOptimizations=27]="disableMonospaceOptimizations",X[X.domReadOnly=28]="domReadOnly",X[X.dragAndDrop=29]="dragAndDrop",X[X.emptySelectionClipboard=30]="emptySelectionClipboard",X[X.extraEditorClassName=31]="extraEditorClassName",X[X.fastScrollSensitivity=32]="fastScrollSensitivity",X[X.find=33]="find",X[X.fixedOverflowWidgets=34]="fixedOverflowWidgets",X[X.folding=35]="folding",X[X.foldingStrategy=36]="foldingStrategy",X[X.foldingHighlight=37]="foldingHighlight",X[X.foldingImportsByDefault=38]="foldingImportsByDefault",X[X.unfoldOnClickAfterEndOfLine=39]="unfoldOnClickAfterEndOfLine",X[X.fontFamily=40]="fontFamily",X[X.fontInfo=41]="fontInfo",X[X.fontLigatures=42]="fontLigatures",X[X.fontSize=43]="fontSize",X[X.fontWeight=44]="fontWeight",X[X.formatOnPaste=45]="formatOnPaste",X[X.formatOnType=46]="formatOnType",X[X.glyphMargin=47]="glyphMargin",X[X.gotoLocation=48]="gotoLocation",X[X.hideCursorInOverviewRuler=49]="hideCursorInOverviewRuler",X[X.highlightActiveIndentGuide=50]="highlightActiveIndentGuide",X[X.hover=51]="hover",X[X.inDiffEditor=52]="inDiffEditor",X[X.inlineSuggest=53]="inlineSuggest",X[X.letterSpacing=54]="letterSpacing",X[X.lightbulb=55]="lightbulb",X[X.lineDecorationsWidth=56]="lineDecorationsWidth",X[X.lineHeight=57]="lineHeight",X[X.lineNumbers=58]="lineNumbers",X[X.lineNumbersMinChars=59]="lineNumbersMinChars",X[X.linkedEditing=60]="linkedEditing",X[X.links=61]="links",X[X.matchBrackets=62]="matchBrackets",X[X.minimap=63]="minimap",X[X.mouseStyle=64]="mouseStyle",X[X.mouseWheelScrollSensitivity=65]="mouseWheelScrollSensitivity",X[X.mouseWheelZoom=66]="mouseWheelZoom",X[X.multiCursorMergeOverlapping=67]="multiCursorMergeOverlapping",X[X.multiCursorModifier=68]="multiCursorModifier",X[X.multiCursorPaste=69]="multiCursorPaste",X[X.occurrencesHighlight=70]="occurrencesHighlight",X[X.overviewRulerBorder=71]="overviewRulerBorder",X[X.overviewRulerLanes=72]="overviewRulerLanes",X[X.padding=73]="padding",X[X.parameterHints=74]="parameterHints",X[X.peekWidgetDefaultFocus=75]="peekWidgetDefaultFocus",X[X.definitionLinkOpensInPeek=76]="definitionLinkOpensInPeek",X[X.quickSuggestions=77]="quickSuggestions",X[X.quickSuggestionsDelay=78]="quickSuggestionsDelay",X[X.readOnly=79]="readOnly",X[X.renameOnType=80]="renameOnType",X[X.renderControlCharacters=81]="renderControlCharacters",X[X.renderIndentGuides=82]="renderIndentGuides",X[X.renderFinalNewline=83]="renderFinalNewline",X[X.renderLineHighlight=84]="renderLineHighlight",X[X.renderLineHighlightOnlyWhenFocus=85]="renderLineHighlightOnlyWhenFocus",X[X.renderValidationDecorations=86]="renderValidationDecorations",X[X.renderWhitespace=87]="renderWhitespace",X[X.revealHorizontalRightPadding=88]="revealHorizontalRightPadding",X[X.roundedSelection=89]="roundedSelection",X[X.rulers=90]="rulers",X[X.scrollbar=91]="scrollbar",X[X.scrollBeyondLastColumn=92]="scrollBeyondLastColumn",X[X.scrollBeyondLastLine=93]="scrollBeyondLastLine",X[X.scrollPredominantAxis=94]="scrollPredominantAxis",X[X.selectionClipboard=95]="selectionClipboard",X[X.selectionHighlight=96]="selectionHighlight",X[X.selectOnLineNumbers=97]="selectOnLineNumbers",X[X.showFoldingControls=98]="showFoldingControls",X[X.showUnused=99]="showUnused",X[X.snippetSuggestions=100]="snippetSuggestions",X[X.smartSelect=101]="smartSelect",X[X.smoothScrolling=102]="smoothScrolling",X[X.stickyTabStops=103]="stickyTabStops",X[X.stopRenderingLineAfter=104]="stopRenderingLineAfter",X[X.suggest=105]="suggest",X[X.suggestFontSize=106]="suggestFontSize",X[X.suggestLineHeight=107]="suggestLineHeight",X[X.suggestOnTriggerCharacters=108]="suggestOnTriggerCharacters",X[X.suggestSelection=109]="suggestSelection",X[X.tabCompletion=110]="tabCompletion",X[X.tabIndex=111]="tabIndex",X[X.unusualLineTerminators=112]="unusualLineTerminators",X[X.useShadowDOM=113]="useShadowDOM",X[X.useTabStops=114]="useTabStops",X[X.wordSeparators=115]="wordSeparators",X[X.wordWrap=116]="wordWrap",X[X.wordWrapBreakAfterCharacters=117]="wordWrapBreakAfterCharacters",X[X.wordWrapBreakBeforeCharacters=118]="wordWrapBreakBeforeCharacters",X[X.wordWrapColumn=119]="wordWrapColumn",X[X.wordWrapOverride1=120]="wordWrapOverride1",X[X.wordWrapOverride2=121]="wordWrapOverride2",X[X.wrappingIndent=122]="wrappingIndent",X[X.wrappingStrategy=123]="wrappingStrategy",X[X.showDeprecated=124]="showDeprecated",X[X.inlayHints=125]="inlayHints",X[X.editorClassName=126]="editorClassName",X[X.pixelRatio=127]="pixelRatio",X[X.tabFocusMode=128]="tabFocusMode",X[X.layoutInfo=129]="layoutInfo",X[X.wrappingInfo=130]="wrappingInfo"})(Ye=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Ee(new m(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:g.localize(136,null)})),acceptSuggestionOnEnter:Ee(new P(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",g.localize(137,null),""],markdownDescription:g.localize(138,null)})),accessibilitySupport:Ee(new p),accessibilityPageSize:Ee(new l(3,"accessibilityPageSize",10,1,1073741824,{description:g.localize(139,null)})),ariaLabel:Ee(new _(4,"ariaLabel",g.localize(140,null))),autoClosingBrackets:Ee(new P(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",g.localize(141,null),g.localize(142,null),""],description:g.localize(143,null)})),autoClosingDelete:Ee(new P(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",g.localize(144,null),""],description:g.localize(145,null)})),autoClosingOvertype:Ee(new P(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",g.localize(146,null),""],description:g.localize(147,null)})),autoClosingQuotes:Ee(new P(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",g.localize(148,null),g.localize(149,null),""],description:g.localize(150,null)})),autoIndent:Ee(new c(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],h,{enumDescriptions:[g.localize(151,null),g.localize(152,null),g.localize(153,null),g.localize(154,null),g.localize(155,null)],description:g.localize(156,null)})),automaticLayout:Ee(new m(10,"automaticLayout",!1)),autoSurround:Ee(new P(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[g.localize(157,null),g.localize(158,null),g.localize(159,null),""],description:g.localize(160,null)})),stickyTabStops:Ee(new m(103,"stickyTabStops",!1,{description:g.localize(161,null)})),codeLens:Ee(new m(12,"codeLens",!0,{description:g.localize(162,null)})),codeLensFontFamily:Ee(new _(13,"codeLensFontFamily","",{description:g.localize(163,null)})),codeLensFontSize:Ee(new l(14,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:g.localize(164,null)})),colorDecorators:Ee(new m(15,"colorDecorators",!0,{description:g.localize(165,null)})),columnSelection:Ee(new m(16,"columnSelection",!1,{description:g.localize(166,null)})),comments:Ee(new t),contextmenu:Ee(new m(18,"contextmenu",!0)),copyWithSyntaxHighlighting:Ee(new m(19,"copyWithSyntaxHighlighting",!0,{description:g.localize(167,null)})),cursorBlinking:Ee(new c(20,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],s,{description:g.localize(168,null)})),cursorSmoothCaretAnimation:Ee(new m(21,"cursorSmoothCaretAnimation",!1,{description:g.localize(169,null)})),cursorStyle:Ee(new c(22,"cursorStyle",n.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],d,{description:g.localize(170,null)})),cursorSurroundingLines:Ee(new l(23,"cursorSurroundingLines",0,0,1073741824,{description:g.localize(171,null)})),cursorSurroundingLinesStyle:Ee(new P(24,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[g.localize(172,null),g.localize(173,null)],description:g.localize(174,null)})),cursorWidth:Ee(new l(25,"cursorWidth",0,0,1073741824,{markdownDescription:g.localize(175,null)})),disableLayerHinting:Ee(new m(26,"disableLayerHinting",!1)),disableMonospaceOptimizations:Ee(new m(27,"disableMonospaceOptimizations",!1)),domReadOnly:Ee(new m(28,"domReadOnly",!1)),dragAndDrop:Ee(new m(29,"dragAndDrop",!0,{description:g.localize(176,null)})),emptySelectionClipboard:Ee(new w),extraEditorClassName:Ee(new _(31,"extraEditorClassName","")),fastScrollSensitivity:Ee(new v(32,"fastScrollSensitivity",5,X=>X<=0?5:X,{markdownDescription:g.localize(177,null)})),find:Ee(new E),fixedOverflowWidgets:Ee(new m(34,"fixedOverflowWidgets",!1)),folding:Ee(new m(35,"folding",!0,{description:g.localize(178,null)})),foldingStrategy:Ee(new P(36,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[g.localize(179,null),g.localize(180,null)],description:g.localize(181,null)})),foldingHighlight:Ee(new m(37,"foldingHighlight",!0,{description:g.localize(182,null)})),foldingImportsByDefault:Ee(new m(38,"foldingImportsByDefault",!1,{description:g.localize(183,null)})),unfoldOnClickAfterEndOfLine:Ee(new m(39,"unfoldOnClickAfterEndOfLine",!1,{description:g.localize(184,null)})),fontFamily:Ee(new _(40,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:g.localize(185,null)})),fontInfo:Ee(new I),fontLigatures2:Ee(new o),fontSize:Ee(new L),fontWeight:Ee(new U),formatOnPaste:Ee(new m(45,"formatOnPaste",!1,{description:g.localize(186,null)})),formatOnType:Ee(new m(46,"formatOnType",!1,{description:g.localize(187,null)})),glyphMargin:Ee(new m(47,"glyphMargin",!0,{description:g.localize(188,null)})),gotoLocation:Ee(new V),hideCursorInOverviewRuler:Ee(new m(49,"hideCursorInOverviewRuler",!1,{description:g.localize(189,null)})),highlightActiveIndentGuide:Ee(new m(50,"highlightActiveIndentGuide",!0,{description:g.localize(190,null)})),hover:Ee(new ee),inDiffEditor:Ee(new m(52,"inDiffEditor",!1)),letterSpacing:Ee(new v(54,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,X=>v.clamp(X,-5,20),{description:g.localize(191,null)})),lightbulb:Ee(new x),lineDecorationsWidth:Ee(new C(56,"lineDecorationsWidth",10)),lineHeight:Ee(new z),lineNumbers:Ee(new ye),lineNumbersMinChars:Ee(new l(59,"lineNumbersMinChars",5,1,300)),linkedEditing:Ee(new m(60,"linkedEditing",!1,{description:g.localize(192,null)})),links:Ee(new m(61,"links",!0,{description:g.localize(193,null)})),matchBrackets:Ee(new P(62,"matchBrackets","always",["always","near","never"],{description:g.localize(194,null)})),minimap:Ee(new M),mouseStyle:Ee(new P(64,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Ee(new v(65,"mouseWheelScrollSensitivity",1,X=>X===0?1:X,{markdownDescription:g.localize(195,null)})),mouseWheelZoom:Ee(new m(66,"mouseWheelZoom",!1,{markdownDescription:g.localize(196,null)})),multiCursorMergeOverlapping:Ee(new m(67,"multiCursorMergeOverlapping",!0,{description:g.localize(197,null)})),multiCursorModifier:Ee(new c(68,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],O,{markdownEnumDescriptions:[g.localize(198,null),g.localize(199,null)],markdownDescription:g.localize(200,null)})),multiCursorPaste:Ee(new P(69,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[g.localize(201,null),g.localize(202,null)],markdownDescription:g.localize(203,null)})),occurrencesHighlight:Ee(new m(70,"occurrencesHighlight",!0,{description:g.localize(204,null)})),overviewRulerBorder:Ee(new m(71,"overviewRulerBorder",!0,{description:g.localize(205,null)})),overviewRulerLanes:Ee(new l(72,"overviewRulerLanes",3,0,3)),padding:Ee(new q),parameterHints:Ee(new B),peekWidgetDefaultFocus:Ee(new P(75,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[g.localize(206,null),g.localize(207,null)],description:g.localize(208,null)})),definitionLinkOpensInPeek:Ee(new m(76,"definitionLinkOpensInPeek",!1,{description:g.localize(209,null)})),quickSuggestions:Ee(new ie),quickSuggestionsDelay:Ee(new l(78,"quickSuggestionsDelay",10,0,1073741824,{description:g.localize(210,null)})),readOnly:Ee(new m(79,"readOnly",!1)),renameOnType:Ee(new m(80,"renameOnType",!1,{description:g.localize(211,null),markdownDeprecationMessage:g.localize(212,null)})),renderControlCharacters:Ee(new m(81,"renderControlCharacters",!1,{description:g.localize(213,null)})),renderIndentGuides:Ee(new m(82,"renderIndentGuides",!0,{description:g.localize(214,null)})),renderFinalNewline:Ee(new m(83,"renderFinalNewline",!0,{description:g.localize(215,null)})),renderLineHighlight:Ee(new P(84,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",g.localize(216,null)],description:g.localize(217,null)})),renderLineHighlightOnlyWhenFocus:Ee(new m(85,"renderLineHighlightOnlyWhenFocus",!1,{description:g.localize(218,null)})),renderValidationDecorations:Ee(new P(86,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Ee(new P(87,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",g.localize(219,null),g.localize(220,null),g.localize(221,null),""],description:g.localize(222,null)})),revealHorizontalRightPadding:Ee(new l(88,"revealHorizontalRightPadding",30,0,1e3)),roundedSelection:Ee(new m(89,"roundedSelection",!0,{description:g.localize(223,null)})),rulers:Ee(new Le),scrollbar:Ee(new We),scrollBeyondLastColumn:Ee(new l(92,"scrollBeyondLastColumn",5,0,1073741824,{description:g.localize(224,null)})),scrollBeyondLastLine:Ee(new m(93,"scrollBeyondLastLine",!0,{description:g.localize(225,null)})),scrollPredominantAxis:Ee(new m(94,"scrollPredominantAxis",!0,{description:g.localize(226,null)})),selectionClipboard:Ee(new m(95,"selectionClipboard",!0,{description:g.localize(227,null),included:R.isLinux})),selectionHighlight:Ee(new m(96,"selectionHighlight",!0,{description:g.localize(228,null)})),selectOnLineNumbers:Ee(new m(97,"selectOnLineNumbers",!0)),showFoldingControls:Ee(new P(98,"showFoldingControls","mouseover",["always","mouseover"],{enumDescriptions:[g.localize(229,null),g.localize(230,null)],description:g.localize(231,null)})),showUnused:Ee(new m(99,"showUnused",!0,{description:g.localize(232,null)})),showDeprecated:Ee(new m(124,"showDeprecated",!0,{description:g.localize(233,null)})),inlayHints:Ee(new F),snippetSuggestions:Ee(new P(100,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[g.localize(234,null),g.localize(235,null),g.localize(236,null),g.localize(237,null)],description:g.localize(238,null)})),smartSelect:Ee(new Z),smoothScrolling:Ee(new m(102,"smoothScrolling",!1,{description:g.localize(239,null)})),stopRenderingLineAfter:Ee(new l(104,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Ee(new W),inlineSuggest:Ee(new je),suggestFontSize:Ee(new l(106,"suggestFontSize",0,0,1e3,{markdownDescription:g.localize(240,null)})),suggestLineHeight:Ee(new l(107,"suggestLineHeight",0,0,1e3,{markdownDescription:g.localize(241,null)})),suggestOnTriggerCharacters:Ee(new m(108,"suggestOnTriggerCharacters",!0,{description:g.localize(242,null)})),suggestSelection:Ee(new P(109,"suggestSelection","recentlyUsed",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[g.localize(243,null),g.localize(244,null),g.localize(245,null)],description:g.localize(246,null)})),tabCompletion:Ee(new P(110,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[g.localize(247,null),g.localize(248,null),g.localize(249,null)],description:g.localize(250,null)})),tabIndex:Ee(new l(111,"tabIndex",0,-1,1073741824)),unusualLineTerminators:Ee(new P(112,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[g.localize(251,null),g.localize(252,null),g.localize(253,null)],description:g.localize(254,null)})),useShadowDOM:Ee(new m(113,"useShadowDOM",!0)),useTabStops:Ee(new m(114,"useTabStops",!0,{description:g.localize(255,null)})),wordSeparators:Ee(new _(115,"wordSeparators",k.USUAL_WORD_SEPARATORS,{description:g.localize(256,null)})),wordWrap:Ee(new P(116,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[g.localize(257,null),g.localize(258,null),g.localize(259,null),g.localize(260,null)],description:g.localize(261,null)})),wordWrapBreakAfterCharacters:Ee(new _(117,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Ee(new _(118,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Ee(new l(119,"wordWrapColumn",80,1,1073741824,{markdownDescription:g.localize(262,null)})),wordWrapOverride1:Ee(new P(120,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Ee(new P(121,"wordWrapOverride2","inherit",["off","on","inherit"])),wrappingIndent:Ee(new c(122,"wrappingIndent",1,"same",["none","same","indent","deepIndent"],Y,{enumDescriptions:[g.localize(263,null),g.localize(264,null),g.localize(265,null),g.localize(266,null)],description:g.localize(267,null)})),wrappingStrategy:Ee(new P(123,"wrappingStrategy","simple",["simple","advanced"],{enumDescriptions:[g.localize(268,null),g.localize(269,null)],description:g.localize(270,null)})),editorClassName:Ee(new f),pixelRatio:Ee(new G),tabFocusMode:Ee(new ne),layoutInfo:Ee(new N),wrappingInfo:Ee(new ae)}}),define(me[155],ge([18,19]),function(J,e){return J.create("vs/platform/configuration/common/configurationRegistry",e)}),define(me[156],ge([18,19]),function(J,e){return J.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(me[157],ge([18,19]),function(J,e){return J.create("vs/platform/extensions/common/extensionValidator",e)}),define(me[158],ge([18,19]),function(J,e){return J.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(me[159],ge([18,19]),function(J,e){return J.create("vs/platform/files/common/files",e)}),define(me[160],ge([18,19]),function(J,e){return J.create("vs/platform/markers/common/markers",e)}),define(me[161],ge([18,19]),function(J,e){return J.create("vs/platform/theme/common/iconRegistry",e)}),define(me[162],ge([18,19]),function(J,e){return J.create("vs/platform/workspaces/common/workspaces",e)}),define(me[163],ge([18,19]),function(J,e){return J.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(me[164],ge([18,19]),function(J,e){return J.create("vs/workbench/api/common/extHostExtensionService",e)}),define(me[165],ge([18,19]),function(J,e){return J.create("vs/workbench/api/common/extHostProgress",e)}),define(me[166],ge([18,19]),function(J,e){return J.create("vs/workbench/api/common/extHostStatusBar",e)}),define(me[167],ge([18,19]),function(J,e){return J.create("vs/workbench/api/common/extHostTerminalService",e)}),define(me[168],ge([18,19]),function(J,e){return J.create("vs/workbench/api/common/extHostTreeViews",e)}),define(me[169],ge([18,19]),function(J,e){return J.create("vs/workbench/api/common/extHostWorkspace",e)}),define(me[170],ge([18,19]),function(J,e){return J.create("vs/workbench/api/node/extHostDebugService",e)}),define(me[171],ge([18,19]),function(J,e){return J.create("vs/workbench/common/editor",e)}),define(me[172],ge([18,19]),function(J,e){return J.create("vs/workbench/common/views",e)}),define(me[173],ge([18,19]),function(J,e){return J.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(me[174],ge([18,19]),function(J,e){return J.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(me[175],ge([18,19]),function(J,e){return J.create("vs/workbench/contrib/search/common/queryBuilder",e)}),define(me[176],ge([18,19]),function(J,e){return J.create("vs/workbench/contrib/tasks/common/taskService",e)}),define(me[177],ge([18,19]),function(J,e){return J.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(me[178],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextEditorSelectionRevealType=e.EditorOpenContext=e.EditorResolution=e.EditorActivation=void 0;var g;(function(T){T[T.ACTIVATE=1]="ACTIVATE",T[T.RESTORE=2]="RESTORE",T[T.PRESERVE=3]="PRESERVE"})(g=e.EditorActivation||(e.EditorActivation={}));var R;(function(T){T[T.PICK=0]="PICK",T[T.DISABLED=1]="DISABLED",T[T.EXCLUSIVE_ONLY=2]="EXCLUSIVE_ONLY"})(R=e.EditorResolution||(e.EditorResolution={}));var k;(function(T){T[T.API=0]="API",T[T.USER=1]="USER"})(k=e.EditorOpenContext||(e.EditorOpenContext={}));var S;(function(T){T[T.Center=0]="Center",T[T.CenterIfOutsideViewport=1]="CenterIfOutsideViewport",T[T.NearTop=2]="NearTop",T[T.NearTopIfOutsideViewport=3]="NearTopIfOutsideViewport"})(S=e.TextEditorSelectionRevealType||(e.TextEditorSelectionRevealType={}))}),define(me[179],ge([0,1,157]),function(J,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const R=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,k=/^-(\d{4})(\d{2})(\d{2})$/;function S(u){return u=u.trim(),u==="*"||R.test(u)}e.isValidVersionStr=S;function T(u){if(!S(u))return null;if(u=u.trim(),u==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let m=u.match(R);return m?{hasCaret:m[1]==="^",hasGreaterEquals:m[1]===">=",majorBase:m[2]==="x"?0:parseInt(m[2],10),majorMustEqual:m[2]!=="x",minorBase:m[4]==="x"?0:parseInt(m[4],10),minorMustEqual:m[4]!=="x",patchBase:m[6]==="x"?0:parseInt(m[6],10),patchMustEqual:m[6]!=="x",preRelease:m[8]||null}:null}e.parseVersion=T;function D(u){if(!u)return null;let m=u.majorBase,l=u.majorMustEqual,v=u.minorBase,_=u.minorMustEqual,b=u.patchBase,P=u.patchMustEqual;u.hasCaret&&(m===0||(_=!1),P=!1);let c=0;if(u.preRelease){const h=k.exec(u.preRelease);if(h){const[,p,t,r]=h;c=Date.UTC(Number(p),Number(t)-1,Number(r))}}return{majorBase:m,majorMustEqual:l,minorBase:v,minorMustEqual:_,patchBase:b,patchMustEqual:P,isMinimum:u.hasGreaterEquals,notBefore:c}}e.normalizeVersion=D;function y(u,m,l){let v;typeof u=="string"?v=D(T(u)):v=u;let _;m instanceof Date?_=m.getTime():typeof m=="string"&&(_=new Date(m).getTime());let b;if(typeof l=="string"?b=D(T(l)):b=l,!v||!b)return!1;let P=v.majorBase,c=v.minorBase,h=v.patchBase,p=b.majorBase,t=b.minorBase,r=b.patchBase,s=b.notBefore,n=b.majorMustEqual,a=b.minorMustEqual,d=b.patchMustEqual;return b.isMinimum?P>p?!0:P<p?!1:c>t?!0:c<t||_&&_<s?!1:h>=r:(P===1&&p===0&&(!n||!a||!d)&&(p=1,t=0,r=0,n=!0,a=!1,d=!1),P<p?!1:P>p?!n:c<t?!1:c>t?!a:h<r?!1:h>r?!d:!(_&&_<s))}e.isValidVersion=y;function A(u,m,l,v){return l.isBuiltin||typeof l.main=="undefined"?!0:C(u,m,l.engines.vscode,v)}e.isValidExtensionVersion=A;function i(u,m,l){return u==="*"||C(m,l,u)}e.isEngineValid=i;function C(u,m,l,v=[]){let _=D(T(l));if(!_)return v.push(g.localize(0,null,l)),!1;if(_.majorBase===0){if(!_.majorMustEqual||!_.minorMustEqual)return v.push(g.localize(1,null,l)),!1}else if(!_.majorMustEqual)return v.push(g.localize(2,null,l)),!1;return y(u,m,_)?!0:(v.push(g.localize(3,null,u,l)),!1)}}),define(me[115],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class g{constructor(k,S=[],T=!1){this.ctor=k,this.staticArguments=S,this.supportsDelayedInstantiation=T}}e.SyncDescriptor=g}),define(me[80],ge([0,1,115]),function(J,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const R=[];function k(T,D,y){D instanceof g.SyncDescriptor||(D=new g.SyncDescriptor(D,[],y)),R.push([T,D])}e.registerSingleton=k;function S(){return R}e.getSingletonServiceDescriptors=S}),define(me[180],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class g{constructor(S){this.incoming=new Map,this.outgoing=new Map,this.data=S}}e.Node=g;class R{constructor(S){this._hashFn=S,this._nodes=new Map}roots(){const S=[];for(let T of this._nodes.values())T.outgoing.size===0&&S.push(T);return S}insertEdge(S,T){const D=this.lookupOrInsertNode(S),y=this.lookupOrInsertNode(T);D.outgoing.set(this._hashFn(T),y),y.incoming.set(this._hashFn(S),D)}removeNode(S){const T=this._hashFn(S);this._nodes.delete(T);for(let D of this._nodes.values())D.outgoing.delete(T),D.incoming.delete(T)}lookupOrInsertNode(S){const T=this._hashFn(S);let D=this._nodes.get(T);return D||(D=new g(S),this._nodes.set(T,D)),D}lookup(S){return this._nodes.get(this._hashFn(S))}isEmpty(){return this._nodes.size===0}toString(){let S=[];for(let[T,D]of this._nodes)S.push(`${T}, (incoming)[${[...D.incoming.keys()].join(", ")}], (outgoing)[${[...D.outgoing.keys()].join(",")}]`);return S.join(`
`)}findCycleSlow(){for(let[S,T]of this._nodes){const D=new Set([S]),y=this._findCycle(T,D);if(y)return y}}_findCycle(S,T){for(let[D,y]of S.outgoing){if(T.has(D))return[...T,D].join(" -> ");T.add(D);const A=this._findCycle(y,T);if(A)return A;T.delete(D)}}}e.Graph=R}),define(me[4],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.optional=e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var g;(function(D){D.serviceIds=new Map,D.DI_TARGET="$di$target",D.DI_DEPENDENCIES="$di$dependencies";function y(A){return A[D.DI_DEPENDENCIES]||[]}D.getServiceDependencies=y})(g=e._util||(e._util={})),e.IInstantiationService=k("instantiationService");function R(D,y,A,i){y[g.DI_TARGET]===y?y[g.DI_DEPENDENCIES].push({id:D,index:A,optional:i}):(y[g.DI_DEPENDENCIES]=[{id:D,index:A,optional:i}],y[g.DI_TARGET]=y)}function k(D){if(g.serviceIds.has(D))return g.serviceIds.get(D);const y=function(A,i,C){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");R(y,A,C,!1)};return y.toString=()=>D,g.serviceIds.set(D,y),y}e.createDecorator=k;function S(D){return D}e.refineServiceDecorator=S;function T(D){return function(y,A,i){if(arguments.length!==3)throw new Error("@optional-decorator can only be used to decorate a parameter");R(D,y,i,!0)}}e.optional=T}),define(me[181],ge([0,1,4]),function(J,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.IModelService=void 0,e.IModelService=(0,g.createDecorator)("modelService");function R(k){return!k.isTooLargeForSyncing()&&!k.isForSimpleWidget}e.shouldSynchronizeModel=R}),define(me[182],ge([0,1,3,58,6,22,75,79,181]),function(J,e,g,R,k,S,T,D,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguageFeatureRequestDelays=e.LanguageFeatureRegistry=void 0;function A(u){return typeof u=="string"?!1:Array.isArray(u)?u.every(A):!!u.exclusive}class i{constructor(){this._clock=0,this._entries=[],this._onDidChange=new g.Emitter}get onDidChange(){return this._onDidChange.event}register(m,l){let v={selector:m,provider:l,_score:-1,_time:this._clock++};return this._entries.push(v),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),(0,k.toDisposable)(()=>{if(v){let _=this._entries.indexOf(v);_>=0&&(this._entries.splice(_,1),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),v=void 0)}})}has(m){return this.all(m).length>0}all(m){if(!m)return[];this._updateScores(m);const l=[];for(let v of this._entries)v._score>0&&l.push(v.provider);return l}ordered(m){const l=[];return this._orderedForEach(m,v=>l.push(v.provider)),l}orderedGroups(m){const l=[];let v,_;return this._orderedForEach(m,b=>{v&&_===b._score?v.push(b.provider):(_=b._score,v=[b.provider],l.push(v))}),l}_orderedForEach(m,l){if(!!m){this._updateScores(m);for(const v of this._entries)v._score>0&&l(v)}}_updateScores(m){let l={uri:m.uri.toString(),language:m.getLanguageIdentifier().language};if(!(this._lastCandidate&&this._lastCandidate.language===l.language&&this._lastCandidate.uri===l.uri)){this._lastCandidate=l;for(let v of this._entries)if(v._score=(0,D.score)(v.selector,m.uri,m.getLanguageIdentifier().language,(0,y.shouldSynchronizeModel)(m)),A(v.selector)&&v._score>0){for(let _ of this._entries)_._score=0;v._score=1e3;break}this._entries.sort(i._compareByScoreAndTime)}}static _compareByScoreAndTime(m,l){return m._score<l._score?1:m._score>l._score?-1:m._time<l._time?1:m._time>l._time?-1:0}}e.LanguageFeatureRegistry=i;class C{constructor(m,l,v=Number.MAX_SAFE_INTEGER){this._registry=m,this.min=l,this.max=v,this._cache=new S.LRUCache(50,.7)}_key(m){return m.id+(0,R.hash)(this._registry.all(m))}_clamp(m){return m===void 0?this.min:Math.min(this.max,Math.max(this.min,Math.floor(m*1.3)))}get(m){const l=this._key(m),v=this._cache.get(l);return this._clamp(v?.value)}update(m,l){const v=this._key(m);let _=this._cache.get(v);return _||(_=new T.MovingAverage,this._cache.set(v,_)),_.update(l),this.get(m)}}e.LanguageFeatureRequestDelays=C}),define(me[81],ge([0,1,2,41,182,148,47]),function(J,e,g,R,k,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.DocumentRangeSemanticTokensProviderRegistry=e.DocumentSemanticTokensProviderRegistry=e.FoldingRangeProviderRegistry=e.SelectionRangeRegistry=e.ColorProviderRegistry=e.LinkProviderRegistry=e.OnTypeFormattingEditProviderRegistry=e.DocumentRangeFormattingEditProviderRegistry=e.DocumentFormattingEditProviderRegistry=e.CodeActionProviderRegistry=e.InlayHintsProviderRegistry=e.CodeLensProviderRegistry=e.TypeDefinitionProviderRegistry=e.ImplementationProviderRegistry=e.DeclarationProviderRegistry=e.DefinitionProviderRegistry=e.LinkedEditingRangeProviderRegistry=e.DocumentHighlightProviderRegistry=e.DocumentSymbolProviderRegistry=e.InlineValuesProviderRegistry=e.EvaluatableExpressionProviderRegistry=e.HoverProviderRegistry=e.SignatureHelpProviderRegistry=e.InlineCompletionsProviderRegistry=e.CompletionProviderRegistry=e.RenameProviderRegistry=e.ReferenceProviderRegistry=e.InlayHintKind=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.completionKindFromString=e.completionKindToCssClass=e.CompletionItemKind=e.TokenMetadata=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageIdentifier=e.LanguageId=void 0;var D;(function(o){o[o.Null=0]="Null",o[o.PlainText=1]="PlainText"})(D=e.LanguageId||(e.LanguageId={}));class y{constructor(I,L){this.language=I,this.id=L}}e.LanguageIdentifier=y;var A;(function(o){o[o.NotSet=-1]="NotSet",o[o.None=0]="None",o[o.Italic=1]="Italic",o[o.Bold=2]="Bold",o[o.Underline=4]="Underline"})(A=e.FontStyle||(e.FontStyle={}));var i;(function(o){o[o.None=0]="None",o[o.DefaultForeground=1]="DefaultForeground",o[o.DefaultBackground=2]="DefaultBackground"})(i=e.ColorId||(e.ColorId={}));var C;(function(o){o[o.Other=0]="Other",o[o.Comment=1]="Comment",o[o.String=2]="String",o[o.RegEx=4]="RegEx"})(C=e.StandardTokenType||(e.StandardTokenType={}));var u;(function(o){o[o.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",o[o.TOKEN_TYPE_MASK=1792]="TOKEN_TYPE_MASK",o[o.FONT_STYLE_MASK=14336]="FONT_STYLE_MASK",o[o.FOREGROUND_MASK=8372224]="FOREGROUND_MASK",o[o.BACKGROUND_MASK=4286578688]="BACKGROUND_MASK",o[o.ITALIC_MASK=2048]="ITALIC_MASK",o[o.BOLD_MASK=4096]="BOLD_MASK",o[o.UNDERLINE_MASK=8192]="UNDERLINE_MASK",o[o.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",o[o.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",o[o.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",o[o.SEMANTIC_USE_FOREGROUND=8]="SEMANTIC_USE_FOREGROUND",o[o.SEMANTIC_USE_BACKGROUND=16]="SEMANTIC_USE_BACKGROUND",o[o.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",o[o.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",o[o.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",o[o.FOREGROUND_OFFSET=14]="FOREGROUND_OFFSET",o[o.BACKGROUND_OFFSET=23]="BACKGROUND_OFFSET"})(u=e.MetadataConsts||(e.MetadataConsts={}));class m{static getLanguageId(I){return(I&255)>>>0}static getTokenType(I){return(I&1792)>>>8}static getFontStyle(I){return(I&14336)>>>11}static getForeground(I){return(I&8372224)>>>14}static getBackground(I){return(I&4286578688)>>>23}static getClassNameFromMetadata(I){let L=this.getForeground(I),U="mtk"+L,V=this.getFontStyle(I);return V&1&&(U+=" mtki"),V&2&&(U+=" mtkb"),V&4&&(U+=" mtku"),U}static getInlineStyleFromMetadata(I,L){const U=this.getForeground(I),V=this.getFontStyle(I);let ee=`color: ${L[U]};`;return V&1&&(ee+="font-style: italic;"),V&2&&(ee+="font-weight: bold;"),V&4&&(ee+="text-decoration: underline;"),ee}}e.TokenMetadata=m;var l;(function(o){o[o.Method=0]="Method",o[o.Function=1]="Function",o[o.Constructor=2]="Constructor",o[o.Field=3]="Field",o[o.Variable=4]="Variable",o[o.Class=5]="Class",o[o.Struct=6]="Struct",o[o.Interface=7]="Interface",o[o.Module=8]="Module",o[o.Property=9]="Property",o[o.Event=10]="Event",o[o.Operator=11]="Operator",o[o.Unit=12]="Unit",o[o.Value=13]="Value",o[o.Constant=14]="Constant",o[o.Enum=15]="Enum",o[o.EnumMember=16]="EnumMember",o[o.Keyword=17]="Keyword",o[o.Text=18]="Text",o[o.Color=19]="Color",o[o.File=20]="File",o[o.Reference=21]="Reference",o[o.Customcolor=22]="Customcolor",o[o.Folder=23]="Folder",o[o.TypeParameter=24]="TypeParameter",o[o.User=25]="User",o[o.Issue=26]="Issue",o[o.Snippet=27]="Snippet"})(l=e.CompletionItemKind||(e.CompletionItemKind={})),e.completionKindToCssClass=function(){let o=Object.create(null);return o[0]="symbol-method",o[1]="symbol-function",o[2]="symbol-constructor",o[3]="symbol-field",o[4]="symbol-variable",o[5]="symbol-class",o[6]="symbol-struct",o[7]="symbol-interface",o[8]="symbol-module",o[9]="symbol-property",o[10]="symbol-event",o[11]="symbol-operator",o[12]="symbol-unit",o[13]="symbol-value",o[14]="symbol-constant",o[15]="symbol-enum",o[16]="symbol-enum-member",o[17]="symbol-keyword",o[27]="symbol-snippet",o[18]="symbol-text",o[19]="symbol-color",o[20]="symbol-file",o[21]="symbol-reference",o[22]="symbol-customcolor",o[23]="symbol-folder",o[24]="symbol-type-parameter",o[25]="account",o[26]="issues",function(I){const L=o[I];let U=L&&T.iconRegistry.get(L);return U||(console.info("No codicon found for CompletionItemKind "+I),U=T.Codicon.symbolProperty),U.classNames}}(),e.completionKindFromString=function(){let o=Object.create(null);return o.method=0,o.function=1,o.constructor=2,o.field=3,o.variable=4,o.class=5,o.struct=6,o.interface=7,o.module=8,o.property=9,o.event=10,o.operator=11,o.unit=12,o.value=13,o.constant=14,o.enum=15,o["enum-member"]=16,o.enumMember=16,o.keyword=17,o.snippet=27,o.text=18,o.color=19,o.file=20,o.reference=21,o.customcolor=22,o.folder=23,o["type-parameter"]=24,o.typeParameter=24,o.account=25,o.issue=26,function(I,L){let U=o[I];return typeof U=="undefined"&&!L&&(U=9),U}}();var v;(function(o){o[o.Deprecated=1]="Deprecated"})(v=e.CompletionItemTag||(e.CompletionItemTag={}));var _;(function(o){o[o.KeepWhitespace=1]="KeepWhitespace",o[o.InsertAsSnippet=4]="InsertAsSnippet"})(_=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var b;(function(o){o[o.Invoke=0]="Invoke",o[o.TriggerCharacter=1]="TriggerCharacter",o[o.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(b=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var P;(function(o){o[o.Automatic=0]="Automatic",o[o.Explicit=1]="Explicit"})(P=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var c;(function(o){o[o.Invoke=1]="Invoke",o[o.Auto=2]="Auto"})(c=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var h;(function(o){o[o.Invoke=1]="Invoke",o[o.TriggerCharacter=2]="TriggerCharacter",o[o.ContentChange=3]="ContentChange"})(h=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var p;(function(o){o[o.Text=0]="Text",o[o.Read=1]="Read",o[o.Write=2]="Write"})(p=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function t(o){return o&&g.URI.isUri(o.uri)&&R.Range.isIRange(o.range)&&(R.Range.isIRange(o.originSelectionRange)||R.Range.isIRange(o.targetSelectionRange))}e.isLocationLink=t;var r;(function(o){o[o.File=0]="File",o[o.Module=1]="Module",o[o.Namespace=2]="Namespace",o[o.Package=3]="Package",o[o.Class=4]="Class",o[o.Method=5]="Method",o[o.Property=6]="Property",o[o.Field=7]="Field",o[o.Constructor=8]="Constructor",o[o.Enum=9]="Enum",o[o.Interface=10]="Interface",o[o.Function=11]="Function",o[o.Variable=12]="Variable",o[o.Constant=13]="Constant",o[o.String=14]="String",o[o.Number=15]="Number",o[o.Boolean=16]="Boolean",o[o.Array=17]="Array",o[o.Object=18]="Object",o[o.Key=19]="Key",o[o.Null=20]="Null",o[o.EnumMember=21]="EnumMember",o[o.Struct=22]="Struct",o[o.Event=23]="Event",o[o.Operator=24]="Operator",o[o.TypeParameter=25]="TypeParameter"})(r=e.SymbolKind||(e.SymbolKind={}));var s;(function(o){o[o.Deprecated=1]="Deprecated"})(s=e.SymbolTag||(e.SymbolTag={}));var n;(function(o){const I=new Map;I.set("file",0),I.set("module",1),I.set("namespace",2),I.set("package",3),I.set("class",4),I.set("method",5),I.set("property",6),I.set("field",7),I.set("constructor",8),I.set("enum",9),I.set("interface",10),I.set("function",11),I.set("variable",12),I.set("constant",13),I.set("string",14),I.set("number",15),I.set("boolean",16),I.set("array",17),I.set("object",18),I.set("key",19),I.set("null",20),I.set("enum-member",21),I.set("struct",22),I.set("event",23),I.set("operator",24),I.set("type-parameter",25);const L=new Map;L.set(0,"file"),L.set(1,"module"),L.set(2,"namespace"),L.set(3,"package"),L.set(4,"class"),L.set(5,"method"),L.set(6,"property"),L.set(7,"field"),L.set(8,"constructor"),L.set(9,"enum"),L.set(10,"interface"),L.set(11,"function"),L.set(12,"variable"),L.set(13,"constant"),L.set(14,"string"),L.set(15,"number"),L.set(16,"boolean"),L.set(17,"array"),L.set(18,"object"),L.set(19,"key"),L.set(20,"null"),L.set(21,"enum-member"),L.set(22,"struct"),L.set(23,"event"),L.set(24,"operator"),L.set(25,"type-parameter");function U(K){return I.get(K)}o.fromString=U;function V(K){return L.get(K)}o.toString=V;function ee(K,N){const x=L.get(K);let F=x&&T.iconRegistry.get("symbol-"+x);return F||(console.info("No codicon found for SymbolKind "+K),F=T.Codicon.symbolProperty),`${N?"inline":"block"} ${F.classNames}`}o.toCssClassName=ee})(n=e.SymbolKinds||(e.SymbolKinds={}));class a{constructor(I){this.value=I}}e.FoldingRangeKind=a,a.Comment=new a("comment"),a.Imports=new a("imports"),a.Region=new a("region");var d;(function(o){o[o.Collapsed=0]="Collapsed",o[o.Expanded=1]="Expanded"})(d=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var f;(function(o){o[o.Editing=0]="Editing",o[o.Preview=1]="Preview"})(f=e.CommentMode||(e.CommentMode={}));var w;(function(o){o[o.Other=0]="Other",o[o.Type=1]="Type",o[o.Parameter=2]="Parameter"})(w=e.InlayHintKind||(e.InlayHintKind={})),e.ReferenceProviderRegistry=new k.LanguageFeatureRegistry,e.RenameProviderRegistry=new k.LanguageFeatureRegistry,e.CompletionProviderRegistry=new k.LanguageFeatureRegistry,e.InlineCompletionsProviderRegistry=new k.LanguageFeatureRegistry,e.SignatureHelpProviderRegistry=new k.LanguageFeatureRegistry,e.HoverProviderRegistry=new k.LanguageFeatureRegistry,e.EvaluatableExpressionProviderRegistry=new k.LanguageFeatureRegistry,e.InlineValuesProviderRegistry=new k.LanguageFeatureRegistry,e.DocumentSymbolProviderRegistry=new k.LanguageFeatureRegistry,e.DocumentHighlightProviderRegistry=new k.LanguageFeatureRegistry,e.LinkedEditingRangeProviderRegistry=new k.LanguageFeatureRegistry,e.DefinitionProviderRegistry=new k.LanguageFeatureRegistry,e.DeclarationProviderRegistry=new k.LanguageFeatureRegistry,e.ImplementationProviderRegistry=new k.LanguageFeatureRegistry,e.TypeDefinitionProviderRegistry=new k.LanguageFeatureRegistry,e.CodeLensProviderRegistry=new k.LanguageFeatureRegistry,e.InlayHintsProviderRegistry=new k.LanguageFeatureRegistry,e.CodeActionProviderRegistry=new k.LanguageFeatureRegistry,e.DocumentFormattingEditProviderRegistry=new k.LanguageFeatureRegistry,e.DocumentRangeFormattingEditProviderRegistry=new k.LanguageFeatureRegistry,e.OnTypeFormattingEditProviderRegistry=new k.LanguageFeatureRegistry,e.LinkProviderRegistry=new k.LanguageFeatureRegistry,e.ColorProviderRegistry=new k.LanguageFeatureRegistry,e.SelectionRangeRegistry=new k.LanguageFeatureRegistry,e.FoldingRangeProviderRegistry=new k.LanguageFeatureRegistry,e.DocumentSemanticTokensProviderRegistry=new k.LanguageFeatureRegistry,e.DocumentRangeSemanticTokensProviderRegistry=new k.LanguageFeatureRegistry,e.TokenizationRegistry=new S.TokenizationRegistryImpl;var E;(function(o){o[o.None=0]="None",o[o.Option=1]="Option",o[o.Default=2]="Default",o[o.Preferred=3]="Preferred"})(E=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(me[61],ge([0,1,8,4,11]),function(J,e,g,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.ContextKeyExpr=e.ContextKeyExprType=void 0;let S=k.userAgent||"";const T=new Map;T.set("false",!1),T.set("true",!0),T.set("isMac",k.isMacintosh),T.set("isLinux",k.isLinux),T.set("isWindows",k.isWindows),T.set("isWeb",k.isWeb),T.set("isMacNative",k.isMacintosh&&!k.isWeb),T.set("isEdge",S.indexOf("Edg/")>=0),T.set("isFirefox",S.indexOf("Firefox")>=0),T.set("isChrome",S.indexOf("Chrome")>=0),T.set("isSafari",S.indexOf("Safari")>=0);const D=Object.prototype.hasOwnProperty;var y;(function(E){E[E.False=0]="False",E[E.True=1]="True",E[E.Defined=2]="Defined",E[E.Not=3]="Not",E[E.Equals=4]="Equals",E[E.NotEquals=5]="NotEquals",E[E.And=6]="And",E[E.Regex=7]="Regex",E[E.NotRegex=8]="NotRegex",E[E.Or=9]="Or",E[E.In=10]="In",E[E.NotIn=11]="NotIn",E[E.Greater=12]="Greater",E[E.GreaterEquals=13]="GreaterEquals",E[E.Smaller=14]="Smaller",E[E.SmallerEquals=15]="SmallerEquals"})(y=e.ContextKeyExprType||(e.ContextKeyExprType={}));class A{static false(){return C.INSTANCE}static true(){return u.INSTANCE}static has(o){return m.create(o)}static equals(o,I){return l.create(o,I)}static notEquals(o,I){return b.create(o,I)}static regex(o,I){return r.create(o,I)}static in(o,I){return v.create(o,I)}static not(o){return P.create(o)}static and(...o){return n.create(o)}static or(...o){return a.create(o)}static greater(o,I){return c.create(o,I)}static less(o,I){return p.create(o,I)}static deserialize(o,I=!1){if(!!o)return this._deserializeOrExpression(o,I)}static _deserializeOrExpression(o,I){let L=o.split("||");return a.create(L.map(U=>this._deserializeAndExpression(U,I)))}static _deserializeAndExpression(o,I){let L=o.split("&&");return n.create(L.map(U=>this._deserializeOne(U,I)))}static _deserializeOne(o,I){if(o=o.trim(),o.indexOf("!=")>=0){let L=o.split("!=");return b.create(L[0].trim(),this._deserializeValue(L[1],I))}if(o.indexOf("==")>=0){let L=o.split("==");return l.create(L[0].trim(),this._deserializeValue(L[1],I))}if(o.indexOf("=~")>=0){let L=o.split("=~");return r.create(L[0].trim(),this._deserializeRegexValue(L[1],I))}if(o.indexOf(" in ")>=0){let L=o.split(" in ");return v.create(L[0].trim(),L[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(o)){const L=o.split(">=");return h.create(L[0].trim(),L[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(o)){const L=o.split(">");return c.create(L[0].trim(),L[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(o)){const L=o.split("<=");return t.create(L[0].trim(),L[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(o)){const L=o.split("<");return p.create(L[0].trim(),L[1].trim())}return/^\!\s*/.test(o)?P.create(o.substr(1).trim()):m.create(o)}static _deserializeValue(o,I){if(o=o.trim(),o==="true")return!0;if(o==="false")return!1;let L=/^'([^']*)'$/.exec(o);return L?L[1].trim():o}static _deserializeRegexValue(o,I){if((0,g.isFalsyOrWhitespace)(o)){if(I)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let L=o.indexOf("/"),U=o.lastIndexOf("/");if(L===U||L<0){if(I)throw new Error(`bad regexp-value '${o}', missing /-enclosure`);return console.warn(`bad regexp-value '${o}', missing /-enclosure`),null}let V=o.slice(L+1,U),ee=o[U+1]==="i"?"i":"";try{return new RegExp(V,ee)}catch(K){if(I)throw new Error(`bad regexp-value '${o}', parse error: ${K}`);return console.warn(`bad regexp-value '${o}', parse error: ${K}`),null}}}e.ContextKeyExpr=A;function i(E,o){return E.cmp(o)}class C{constructor(){this.type=0}cmp(o){return this.type-o.type}equals(o){return o.type===this.type}evaluate(o){return!1}serialize(){return"false"}keys(){return[]}map(o){return this}negate(){return u.INSTANCE}}e.ContextKeyFalseExpr=C,C.INSTANCE=new C;class u{constructor(){this.type=1}cmp(o){return this.type-o.type}equals(o){return o.type===this.type}evaluate(o){return!0}serialize(){return"true"}keys(){return[]}map(o){return this}negate(){return C.INSTANCE}}e.ContextKeyTrueExpr=u,u.INSTANCE=new u;class m{constructor(o){this.key=o,this.type=2}static create(o){const I=T.get(o);return typeof I=="boolean"?I?u.INSTANCE:C.INSTANCE:new m(o)}cmp(o){return o.type!==this.type?this.type-o.type:f(this.key,o.key)}equals(o){return o.type===this.type?this.key===o.key:!1}evaluate(o){return!!o.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(o){return o.mapDefined(this.key)}negate(){return P.create(this.key)}}e.ContextKeyDefinedExpr=m;class l{constructor(o,I){this.key=o,this.value=I,this.type=4}static create(o,I){if(typeof I=="boolean")return I?m.create(o):P.create(o);const L=T.get(o);return typeof L=="boolean"?I===(L?"true":"false")?u.INSTANCE:C.INSTANCE:new l(o,I)}cmp(o){return o.type!==this.type?this.type-o.type:w(this.key,this.value,o.key,o.value)}equals(o){return o.type===this.type?this.key===o.key&&this.value===o.value:!1}evaluate(o){return o.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(o){return o.mapEquals(this.key,this.value)}negate(){return b.create(this.key,this.value)}}e.ContextKeyEqualsExpr=l;class v{constructor(o,I){this.key=o,this.valueKey=I,this.type=10}static create(o,I){return new v(o,I)}cmp(o){return o.type!==this.type?this.type-o.type:w(this.key,this.valueKey,o.key,o.valueKey)}equals(o){return o.type===this.type?this.key===o.key&&this.valueKey===o.valueKey:!1}evaluate(o){const I=o.getValue(this.valueKey),L=o.getValue(this.key);return Array.isArray(I)?I.indexOf(L)>=0:typeof L=="string"&&typeof I=="object"&&I!==null?D.call(I,L):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(o){return o.mapIn(this.key,this.valueKey)}negate(){return _.create(this)}}e.ContextKeyInExpr=v;class _{constructor(o){this._actual=o,this.type=11}static create(o){return new _(o)}cmp(o){return o.type!==this.type?this.type-o.type:this._actual.cmp(o._actual)}equals(o){return o.type===this.type?this._actual.equals(o._actual):!1}evaluate(o){return!this._actual.evaluate(o)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(o){return new _(this._actual.map(o))}negate(){return this._actual}}e.ContextKeyNotInExpr=_;class b{constructor(o,I){this.key=o,this.value=I,this.type=5}static create(o,I){if(typeof I=="boolean")return I?P.create(o):m.create(o);const L=T.get(o);return typeof L=="boolean"?I===(L?"true":"false")?C.INSTANCE:u.INSTANCE:new b(o,I)}cmp(o){return o.type!==this.type?this.type-o.type:w(this.key,this.value,o.key,o.value)}equals(o){return o.type===this.type?this.key===o.key&&this.value===o.value:!1}evaluate(o){return o.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(o){return o.mapNotEquals(this.key,this.value)}negate(){return l.create(this.key,this.value)}}e.ContextKeyNotEqualsExpr=b;class P{constructor(o){this.key=o,this.type=3}static create(o){const I=T.get(o);return typeof I=="boolean"?I?C.INSTANCE:u.INSTANCE:new P(o)}cmp(o){return o.type!==this.type?this.type-o.type:f(this.key,o.key)}equals(o){return o.type===this.type?this.key===o.key:!1}evaluate(o){return!o.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(o){return o.mapNot(this.key)}negate(){return m.create(this.key)}}e.ContextKeyNotExpr=P;class c{constructor(o,I){this.key=o,this.value=I,this.type=12}static create(o,I){return new c(o,I)}cmp(o){return o.type!==this.type?this.type-o.type:w(this.key,this.value,o.key,o.value)}equals(o){return o.type===this.type?this.key===o.key&&this.value===o.value:!1}evaluate(o){return parseFloat(o.getValue(this.key))>parseFloat(this.value)}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(o){return o.mapGreater(this.key,this.value)}negate(){return t.create(this.key,this.value)}}e.ContextKeyGreaterExpr=c;class h{constructor(o,I){this.key=o,this.value=I,this.type=13}static create(o,I){return new h(o,I)}cmp(o){return o.type!==this.type?this.type-o.type:w(this.key,this.value,o.key,o.value)}equals(o){return o.type===this.type?this.key===o.key&&this.value===o.value:!1}evaluate(o){return parseFloat(o.getValue(this.key))>=parseFloat(this.value)}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(o){return o.mapGreaterEquals(this.key,this.value)}negate(){return p.create(this.key,this.value)}}e.ContextKeyGreaterEqualsExpr=h;class p{constructor(o,I){this.key=o,this.value=I,this.type=14}static create(o,I){return new p(o,I)}cmp(o){return o.type!==this.type?this.type-o.type:w(this.key,this.value,o.key,o.value)}equals(o){return o.type===this.type?this.key===o.key&&this.value===o.value:!1}evaluate(o){return parseFloat(o.getValue(this.key))<parseFloat(this.value)}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(o){return o.mapSmaller(this.key,this.value)}negate(){return h.create(this.key,this.value)}}e.ContextKeySmallerExpr=p;class t{constructor(o,I){this.key=o,this.value=I,this.type=15}static create(o,I){return new t(o,I)}cmp(o){return o.type!==this.type?this.type-o.type:w(this.key,this.value,o.key,o.value)}equals(o){return o.type===this.type?this.key===o.key&&this.value===o.value:!1}evaluate(o){return parseFloat(o.getValue(this.key))<=parseFloat(this.value)}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(o){return o.mapSmallerEquals(this.key,this.value)}negate(){return c.create(this.key,this.value)}}e.ContextKeySmallerEqualsExpr=t;class r{constructor(o,I){this.key=o,this.regexp=I,this.type=7}static create(o,I){return new r(o,I)}cmp(o){if(o.type!==this.type)return this.type-o.type;if(this.key<o.key)return-1;if(this.key>o.key)return 1;const I=this.regexp?this.regexp.source:"",L=o.regexp?o.regexp.source:"";return I<L?-1:I>L?1:0}equals(o){if(o.type===this.type){const I=this.regexp?this.regexp.source:"",L=o.regexp?o.regexp.source:"";return this.key===o.key&&I===L}return!1}evaluate(o){let I=o.getValue(this.key);return this.regexp?this.regexp.test(I):!1}serialize(){const o=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${o}`}keys(){return[this.key]}map(o){return o.mapRegex(this.key,this.regexp)}negate(){return s.create(this)}}e.ContextKeyRegexExpr=r;class s{constructor(o){this._actual=o,this.type=8}static create(o){return new s(o)}cmp(o){return o.type!==this.type?this.type-o.type:this._actual.cmp(o._actual)}equals(o){return o.type===this.type?this._actual.equals(o._actual):!1}evaluate(o){return!this._actual.evaluate(o)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(o){return new s(this._actual.map(o))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=s;class n{constructor(o){this.expr=o,this.type=6}static create(o){return n._normalizeArr(o)}cmp(o){if(o.type!==this.type)return this.type-o.type;if(this.expr.length<o.expr.length)return-1;if(this.expr.length>o.expr.length)return 1;for(let I=0,L=this.expr.length;I<L;I++){const U=i(this.expr[I],o.expr[I]);if(U!==0)return U}return 0}equals(o){if(o.type===this.type){if(this.expr.length!==o.expr.length)return!1;for(let I=0,L=this.expr.length;I<L;I++)if(!this.expr[I].equals(o.expr[I]))return!1;return!0}return!1}evaluate(o){for(let I=0,L=this.expr.length;I<L;I++)if(!this.expr[I].evaluate(o))return!1;return!0}static _normalizeArr(o){const I=[];let L=!1;for(const U of o)if(!!U){if(U.type===1){L=!0;continue}if(U.type===0)return C.INSTANCE;if(U.type===6){I.push(...U.expr);continue}I.push(U)}if(I.length===0&&L)return u.INSTANCE;if(I.length!==0){if(I.length===1)return I[0];for(I.sort(i);I.length>1;){const U=I[I.length-1];if(U.type!==9)break;I.pop();const V=I.pop(),ee=a.create(U.expr.map(K=>n.create([K,V])));ee&&(I.push(ee),I.sort(i))}return I.length===1?I[0]:new n(I)}}serialize(){return this.expr.map(o=>o.serialize()).join(" && ")}keys(){const o=[];for(let I of this.expr)o.push(...I.keys());return o}map(o){return new n(this.expr.map(I=>I.map(o)))}negate(){let o=[];for(let I of this.expr)o.push(I.negate());return a.create(o)}}e.ContextKeyAndExpr=n;class a{constructor(o){this.expr=o,this.type=9}static create(o){const I=a._normalizeArr(o);if(I.length!==0)return I.length===1?I[0]:new a(I)}cmp(o){if(o.type!==this.type)return this.type-o.type;if(this.expr.length<o.expr.length)return-1;if(this.expr.length>o.expr.length)return 1;for(let I=0,L=this.expr.length;I<L;I++){const U=i(this.expr[I],o.expr[I]);if(U!==0)return U}return 0}equals(o){if(o.type===this.type){if(this.expr.length!==o.expr.length)return!1;for(let I=0,L=this.expr.length;I<L;I++)if(!this.expr[I].equals(o.expr[I]))return!1;return!0}return!1}evaluate(o){for(let I=0,L=this.expr.length;I<L;I++)if(this.expr[I].evaluate(o))return!0;return!1}static _normalizeArr(o){let I=[],L=!1;if(o){for(let U=0,V=o.length;U<V;U++){const ee=o[U];if(!!ee){if(ee.type===0){L=!0;continue}if(ee.type===1)return[u.INSTANCE];if(ee.type===9){I=I.concat(ee.expr);continue}I.push(ee)}}if(I.length===0&&L)return[C.INSTANCE];I.sort(i)}return I}serialize(){return this.expr.map(o=>o.serialize()).join(" || ")}keys(){const o=[];for(let I of this.expr)o.push(...I.keys());return o}map(o){return new a(this.expr.map(I=>I.map(o)))}negate(){let o=[];for(let L of this.expr)o.push(L.negate());const I=L=>L.type===9?L.expr:[L];for(;o.length>1;){const L=o.shift(),U=o.shift(),V=[];for(const ee of I(L))for(const K of I(U))V.push(A.and(ee,K));o.unshift(A.or(...V))}return o[0]}}e.ContextKeyOrExpr=a;class d extends m{constructor(o,I,L){super(o);this._defaultValue=I,typeof L=="object"?d._info.push({...L,key:o}):L!==!0&&d._info.push({key:o,description:L,type:I!=null?typeof I:void 0})}static all(){return d._info.values()}bindTo(o){return o.createKey(this.key,this._defaultValue)}getValue(o){return o.getContextKeyValue(this.key)}toNegated(){return A.not(this.key)}isEqualTo(o){return A.equals(this.key,o)}notEqualsTo(o){return A.notEquals(this.key,o)}}e.RawContextKey=d,d._info=[],e.IContextKeyService=(0,R.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function f(E,o){return E<o?-1:E>o?1:0}function w(E,o,I,L){return E<I?-1:E>I?1:o<L?-1:o>L?1:0}}),define(me[183],ge([0,1,4]),function(J,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,g.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,g.refineServiceDecorator)(e.IEnvironmentService)}),define(me[184],ge([0,1,156,4,10]),function(J,e,g,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.DefaultIconPath=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.INSTALL_ERROR_INCOMPATIBLE=e.INSTALL_ERROR_MALICIOUS=e.INSTALL_ERROR_NOT_SUPPORTED=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";function S(C){return C&&typeof C=="object"&&typeof C.id=="string"&&(!C.uuid||typeof C.uuid=="string")}e.isIExtensionIdentifier=S;var T;(function(C){C[C.NoneOrRelevance=0]="NoneOrRelevance",C[C.LastUpdatedDate=1]="LastUpdatedDate",C[C.Title=2]="Title",C[C.PublisherName=3]="PublisherName",C[C.InstallCount=4]="InstallCount",C[C.PublishedDate=5]="PublishedDate",C[C.AverageRating=6]="AverageRating",C[C.WeightedRating=12]="WeightedRating"})(T=e.SortBy||(e.SortBy={}));var D;(function(C){C[C.Default=0]="Default",C[C.Ascending=1]="Ascending",C[C.Descending=2]="Descending"})(D=e.SortOrder||(e.SortOrder={}));var y;(function(C){C.Install="install",C.Uninstall="uninstall"})(y=e.StatisticType||(e.StatisticType={}));var A;(function(C){C[C.None=0]="None",C[C.Install=1]="Install",C[C.Update=2]="Update"})(A=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,R.createDecorator)("extensionGalleryService"),e.INSTALL_ERROR_NOT_SUPPORTED="notsupported",e.INSTALL_ERROR_MALICIOUS="malicious",e.INSTALL_ERROR_INCOMPATIBLE="incompatible";class i extends Error{constructor(u,m){super(u);this.code=m,this.name=m}}e.ExtensionManagementError=i,e.IExtensionManagementService=(0,R.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,R.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,R.createDecorator)("IExtensionTipsService"),e.DefaultIconPath=k.FileAccess.asBrowserUri("./media/defaultIcon.png",J).toString(!0),e.ExtensionsLabel=(0,g.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,g.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,R.createDecorator)("IExtensionManagementCLIService")}),define(me[26],ge([0,1,8,4]),function(J,e,g,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isAuthenticaionProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function k(i){if(typeof i=="object"&&i!==null&&i.supported!==!0)return i.description}e.getWorkspaceSupportTypeMessage=k;function S(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(!i.uuid||typeof i.uuid=="string")}e.isIExtensionIdentifier=S,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var T;(function(i){i[i.System=0]="System",i[i.User=1]="User"})(T=e.ExtensionType||(e.ExtensionType={}));class D{constructor(C){this.value=C,this._lower=C.toLowerCase()}static equals(C,u){if(typeof C=="undefined"||C===null)return typeof u=="undefined"||u===null;if(typeof u=="undefined"||u===null)return!1;if(typeof C=="string"||typeof u=="string"){let m=typeof C=="string"?C:C.value,l=typeof u=="string"?u:u.value;return g.equalsIgnoreCase(m,l)}return C._lower===u._lower}static toKey(C){return typeof C=="string"?C.toLowerCase():C._lower}}e.ExtensionIdentifier=D;function y(i){return i.contributes&&i.contributes.localizations?i.contributes.localizations.length>0:!1}e.isLanguagePackExtension=y;function A(i){return i.contributes&&i.contributes.authentication?i.contributes.authentication.length>0:!1}e.isAuthenticaionProviderExtension=A,e.IBuiltinExtensionsScannerService=(0,R.createDecorator)("IBuiltinExtensionsScannerService")}),define(me[185],ge([0,1,8,26]),function(J,e,g,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getExtensionDependencies=e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function k(l,v){return l.uuid&&v.uuid?l.uuid===v.uuid:l.id===v.id?!0:(0,g.compareIgnoreCase)(l.id,v.id)===0}e.areSameExtensions=k;class S{constructor(v,_){this.version=_,this.id=v.id,this.uuid=v.uuid}key(){return`${this.id}-${this.version}`}equals(v){return v instanceof S?k(this,v)&&this.version===v.version:!1}}e.ExtensionIdentifierWithVersion=S;function T(l,v){return`${l}.${v}`}e.getExtensionId=T;function D(l){return l.toLocaleLowerCase()}e.adoptToGalleryExtensionId=D;function y(l,v){return D(T(l,v))}e.getGalleryExtensionId=y;function A(l,v){const _=[],b=P=>{for(const c of _)if(c.some(h=>k(v(h),v(P))))return c;return null};for(const P of l){const c=b(P);c?c.push(P):_.push([P])}return _}e.groupByExtension=A;function i(l){return{id:l.identifier.id,name:l.manifest.name,galleryId:null,publisherId:l.publisherId,publisherName:l.manifest.publisher,publisherDisplayName:l.publisherDisplayName,dependencies:l.manifest.extensionDependencies&&l.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=i;function C(l){return{id:l.identifier.id,name:l.name,galleryId:l.identifier.uuid,publisherId:l.publisherId,publisherName:l.publisher,publisherDisplayName:l.publisherDisplayName,dependencies:!!(l.properties.dependencies&&l.properties.dependencies.length>0),...l.telemetryData}}e.getGalleryExtensionTelemetryData=C,e.BetterMergeId=new R.ExtensionIdentifier("pprice.better-merge");function u(l){const v=new Set;for(const _ of l)_.malicious&&v.add(_.id.id);return v}e.getMaliciousExtensionsSet=u;function m(l,v){const _=[],b=v.manifest.extensionDependencies?.slice(0)??[];for(;b.length;){const P=b.shift();if(P&&_.every(c=>!k(c.identifier,{id:P}))){const c=l.filter(h=>k(h.identifier,{id:P}));c.length===1&&(_.push(c[0]),b.push(...c[0].manifest.extensionDependencies?.slice(0)??[]))}}return _}e.getExtensionDependencies=m}),define(me[186],ge([0,1,4]),function(J,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,g.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=(0,g.createDecorator)("externalTerminal")}),define(me[187],ge([0,1,39,9,113,158,28,11,186,10,140]),function(J,e,g,R,k,S,T,D,y,A,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const C=S.localize(0,null);class u{async getDefaultTerminalForPlatforms(){return{windows:m.getDefaultTerminalWindows(),linux:await v.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class m extends u{openTerminal(h,p){return this.spawnTerminal(g,h,k.getWindowsShell(),p)}spawnTerminal(h,p,t,r){const s=p.windowsExec||m.getDefaultTerminalWindows();r&&r[1]===":"&&(r=r[0].toUpperCase()+r.substr(1));const n=R.basename(s).toLowerCase();if(n==="cmder"||n==="cmder.exe")return h.spawn(s,r?[r]:void 0),Promise.resolve(void 0);const a=["/c","start","/wait"];return s.indexOf(" ")>=0&&a.push('""'),a.push(s),(n==="wt"||n==="wt.exe")&&a.push("-d ."),new Promise((d,f)=>{const w=_(process),E=h.spawn(t,a,{cwd:r,env:w});E.on("error",f),E.on("exit",()=>d())})}runInTerminal(h,p,t,r,s){const n="windowsExec"in s&&s.windowsExec?s.windowsExec:m.getDefaultTerminalWindows();return new Promise((a,d)=>{const f=`"${p} - ${C}"`,w=`""${t.join('" "')}" & pause"`,E=["/c","start",f,"/wait",n,"/c",w],o=Object.assign({},_(process),r);Object.keys(o).filter(U=>o[U]===null).forEach(U=>delete o[U]);const I={cwd:p,env:o,windowsVerbatimArguments:!0};g.spawn(m.CMD,E,I).on("error",U=>{d(b(U))}),a(void 0)})}static getDefaultTerminalWindows(){if(!m._DEFAULT_TERMINAL_WINDOWS){const h=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");m._DEFAULT_TERMINAL_WINDOWS=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${h?"Sysnative":"System32"}\\cmd.exe`}return m._DEFAULT_TERMINAL_WINDOWS}}e.WindowsExternalTerminalService=m,m.CMD="cmd.exe";class l extends u{openTerminal(h,p){return this.spawnTerminal(g,h,p)}runInTerminal(h,p,t,r,s){const n=s.osxExec||y.DEFAULT_TERMINAL_OSX;return new Promise((a,d)=>{if(n===y.DEFAULT_TERMINAL_OSX||n==="iTerm.app"){const f=n===y.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",E=[A.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${f}.scpt`,J).fsPath,"-t",h||C,"-w",p];for(let L of t)E.push("-a"),E.push(L);if(r){const L=Object.assign({},_(process),r);for(let U in L){const V=L[U];V===null?(E.push("-u"),E.push(U)):(E.push("-e"),E.push(`${U}=${V}`))}}let o="";const I=g.spawn(l.OSASCRIPT,E);I.on("error",L=>{d(b(L))}),I.stderr.on("data",L=>{o+=L.toString()}),I.on("exit",L=>{if(L===0)a(void 0);else if(o){const U=o.split(`
`,1);d(new Error(U[0]))}else d(new Error(S.localize(1,null,f,L)))})}else d(new Error(S.localize(2,null,n)))})}spawnTerminal(h,p,t){const r=p.osxExec||y.DEFAULT_TERMINAL_OSX;return new Promise((s,n)=>{const a=["-a",r];t&&a.push(t);const d=_(process),f=h.spawn("/usr/bin/open",a,{cwd:t,env:d});f.on("error",n),f.on("exit",()=>s())})}}e.MacExternalTerminalService=l,l.OSASCRIPT="/usr/bin/osascript";class v extends u{openTerminal(h,p){return this.spawnTerminal(g,h,p)}runInTerminal(h,p,t,r,s){const n=s.linuxExec?Promise.resolve(s.linuxExec):v.getDefaultTerminalLinuxReady();return new Promise((a,d)=>{let f=[];n.then(w=>{w.indexOf("gnome-terminal")>=0?f.push("-x"):f.push("-e"),f.push("bash"),f.push("-c");const E=`${P(t)}; echo; read -p "${v.WAIT_MESSAGE}" -n1;`;f.push(`''${E}''`);const o=Object.assign({},_(process),r);Object.keys(o).filter(V=>o[V]===null).forEach(V=>delete o[V]);const I={cwd:p,env:o};let L="";const U=g.spawn(w,f,I);U.on("error",V=>{d(b(V))}),U.stderr.on("data",V=>{L+=V.toString()}),U.on("exit",V=>{if(V===0)a(void 0);else if(L){const ee=L.split(`
`,1);d(new Error(ee[0]))}else d(new Error(S.localize(4,null,w,V)))})})})}static async getDefaultTerminalLinuxReady(){return v._DEFAULT_TERMINAL_LINUX_READY||(v._DEFAULT_TERMINAL_LINUX_READY=new Promise(async h=>{D.isLinux?await T.Promises.exists("/etc/debian_version")?h("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?h("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?h("konsole"):process.env.COLORTERM?h(process.env.COLORTERM):process.env.TERM?h(process.env.TERM):h("xterm"):h("xterm")})),v._DEFAULT_TERMINAL_LINUX_READY}spawnTerminal(h,p,t){const r=p.linuxExec?Promise.resolve(p.linuxExec):v.getDefaultTerminalLinuxReady();return new Promise((s,n)=>{r.then(a=>{const d=_(process),f=h.spawn(a,[],{cwd:t,env:d});f.on("error",n),f.on("exit",()=>s())})})}}e.LinuxExternalTerminalService=v,v.WAIT_MESSAGE=S.localize(3,null);function _(c){const h={...c.env};return(0,i.sanitizeProcessEnvironment)(h),h}function b(c){return"errno"in c&&c.errno==="ENOENT"&&"path"in c&&typeof c.path=="string"?new Error(S.localize(5,null,c.path)):c}function P(c){let h="";for(let p of c)p.indexOf(" ")>=0?h+='"'+p+'"':h+=p,h+=" ";return h}}),define(me[42],ge([0,1,159,9,2,4,8,14,22]),function(J,e,g,R,k,S,T,D,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,S.createDecorator)("fileService");function A(N){return N.create===!0}e.isFileOpenForWriteOptions=A;var i;(function(N){N[N.Unknown=0]="Unknown",N[N.File=1]="File",N[N.Directory=2]="Directory",N[N.SymbolicLink=64]="SymbolicLink"})(i=e.FileType||(e.FileType={}));var C;(function(N){N[N.Readonly=1]="Readonly"})(C=e.FilePermission||(e.FilePermission={}));var u;(function(N){N[N.FileReadWrite=2]="FileReadWrite",N[N.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",N[N.FileReadStream=16]="FileReadStream",N[N.FileFolderCopy=8]="FileFolderCopy",N[N.PathCaseSensitive=1024]="PathCaseSensitive",N[N.Readonly=2048]="Readonly",N[N.Trash=4096]="Trash",N[N.FileWriteUnlock=8192]="FileWriteUnlock"})(u=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function m(N){return!!(N.capabilities&2)}e.hasReadWriteCapability=m;function l(N){return!!(N.capabilities&8)}e.hasFileFolderCopyCapability=l;function v(N){return!!(N.capabilities&4)}e.hasOpenReadWriteCloseCapability=v;function _(N){return!!(N.capabilities&16)}e.hasFileReadStreamCapability=_;var b;(function(N){N.FileExists="EntryExists",N.FileNotFound="EntryNotFound",N.FileNotADirectory="EntryNotADirectory",N.FileIsADirectory="EntryIsADirectory",N.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",N.FileTooLarge="EntryTooLarge",N.FileWriteLocked="EntryWriteLocked",N.NoPermissions="NoPermissions",N.Unavailable="Unavailable",N.Unknown="Unknown"})(b=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class P extends Error{constructor(x,F){super(x);this.code=F}}e.FileSystemProviderError=P;function c(N,x){const F=new P(N.toString(),x);return p(F,x),F}e.createFileSystemProviderError=c;function h(N){return N||c((0,g.localize)(0,null),b.Unknown)}e.ensureFileSystemProviderError=h;function p(N,x){return N.name=x?`${x} (FileSystemError)`:"FileSystemError",N}e.markAsFileSystemProviderError=p;function t(N){if(!N)return b.Unknown;if(N instanceof P)return N.code;const x=/^(.+) \(FileSystemError\)$/.exec(N.name);if(!x)return b.Unknown;switch(x[1]){case b.FileExists:return b.FileExists;case b.FileIsADirectory:return b.FileIsADirectory;case b.FileNotADirectory:return b.FileNotADirectory;case b.FileNotFound:return b.FileNotFound;case b.FileExceedsMemoryLimit:return b.FileExceedsMemoryLimit;case b.FileTooLarge:return b.FileTooLarge;case b.FileWriteLocked:return b.FileWriteLocked;case b.NoPermissions:return b.NoPermissions;case b.Unavailable:return b.Unavailable}return b.Unknown}e.toFileSystemProviderErrorCode=t;function r(N){if(N instanceof w)return N.fileOperationResult;switch(t(N)){case b.FileNotFound:return 1;case b.FileIsADirectory:return 0;case b.FileNotADirectory:return 10;case b.FileWriteLocked:return 5;case b.NoPermissions:return 6;case b.FileExists:return 4;case b.FileExceedsMemoryLimit:return 9;case b.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=r;var s;(function(N){N[N.CREATE=0]="CREATE",N[N.DELETE=1]="DELETE",N[N.MOVE=2]="MOVE",N[N.COPY=3]="COPY"})(s=e.FileOperation||(e.FileOperation={}));class n{constructor(x,F,z){this.resource=x,this.operation=F,this.target=z}isOperation(x){return this.operation===x}}e.FileOperationEvent=n;var a;(function(N){N[N.UPDATED=0]="UPDATED",N[N.ADDED=1]="ADDED",N[N.DELETED=2]="DELETED"})(a=e.FileChangeType||(e.FileChangeType={}));class d{constructor(x,F){this.added=void 0,this.updated=void 0,this.deleted=void 0;for(const z of x)switch(z.type){case 1:this.added||(this.added=y.TernarySearchTree.forUris(()=>F)),this.added.set(z.resource,z);break;case 0:this.updated||(this.updated=y.TernarySearchTree.forUris(()=>F)),this.updated.set(z.resource,z);break;case 2:this.deleted||(this.deleted=y.TernarySearchTree.forUris(()=>F)),this.deleted.set(z.resource,z);break}}contains(x,...F){return this.doContains(x,{includeChildren:!1},...F)}affects(x,...F){return this.doContains(x,{includeChildren:!0},...F)}doContains(x,F,...z){if(!x)return!1;const M=z.length>0;return!!((!M||z.includes(1))&&(this.added?.get(x)||F.includeChildren&&this.added?.findSuperstr(x))||(!M||z.includes(0))&&(this.updated?.get(x)||F.includeChildren&&this.updated?.findSuperstr(x))||(!M||z.includes(2))&&(this.deleted?.findSubstr(x)||F.includeChildren&&this.deleted?.findSuperstr(x)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}get rawAdded(){return this.added}get rawDeleted(){return this.deleted}}e.FileChangesEvent=d;function f(N,x,F){return!N||!x||N===x||x.length>N.length?!1:(x.charAt(x.length-1)!==R.sep&&(x+=R.sep),F?(0,T.startsWithIgnoreCase)(N,x):N.indexOf(x)===0)}e.isParent=f;class w extends Error{constructor(x,F,z){super(x);this.fileOperationResult=F,this.options=z}}e.FileOperationError=w;class E extends w{constructor(x,F,z){super(x,2,z);this.stat=F}}e.NotModifiedSinceFileOperationError=E;var o;(function(N){N[N.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",N[N.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",N[N.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",N[N.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",N[N.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",N[N.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",N[N.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",N[N.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",N[N.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",N[N.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",N[N.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",N[N.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(o=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var I;(function(N){N[N.FILE=0]="FILE",N[N.FOLDER=1]="FOLDER",N[N.ROOT_FOLDER=2]="ROOT_FOLDER"})(I=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function L(N){if(!(typeof N.size!="number"||typeof N.mtime!="number"))return N.mtime.toString(29)+N.size.toString(31)}e.etag=L;async function U(N,x){if(!x.canHandleResource(k.URI.from({scheme:N.scheme})))return new Promise(F=>{const z=x.onDidChangeFileSystemProviderRegistrations(M=>{M.scheme===N.scheme&&M.added&&(z.dispose(),F())})})}e.whenProviderRegistered=U,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class V{static formatSize(x){return(0,D.isNumber)(x)||(x=0),x<V.KB?(0,g.localize)(1,null,x.toFixed(0)):x<V.MB?(0,g.localize)(2,null,(x/V.KB).toFixed(2)):x<V.GB?(0,g.localize)(3,null,(x/V.MB).toFixed(2)):x<V.TB?(0,g.localize)(4,null,(x/V.GB).toFixed(2)):(0,g.localize)(5,null,(x/V.TB).toFixed(2))}}e.ByteSize=V,V.KB=1024,V.MB=V.KB*V.KB,V.GB=V.MB*V.KB,V.TB=V.GB*V.KB;var ee;(function(N){N[N.IA32=0]="IA32",N[N.OTHER=1]="OTHER"})(ee=e.Arch||(e.Arch={}));function K(N){return{maxFileSize:N===0?300*V.MB:16*V.GB,maxHeapSize:N===0?700*V.MB:2*700*V.MB}}e.getPlatformLimits=K}),define(me[82],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class g{constructor(...k){this._entries=new Map;for(let[S,T]of k)this.set(S,T)}set(k,S){const T=this._entries.get(k);return this._entries.set(k,S),T}has(k){return this._entries.has(k)}get(k){return this._entries.get(k)}}e.ServiceCollection=g}),define(me[188],ge([0,1,15,180,115,4,82,16]),function(J,e,g,R,k,S,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const y=!1;class A extends Error{constructor(l){super("cyclic dependency between services");this.message=l.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${l.toString()}`}}class i{constructor(l=new T.ServiceCollection,v=!1,_){this._activeInstantiations=new Set,this._services=l,this._strict=v,this._parent=_,this._services.set(S.IInstantiationService,this)}createChild(l){return new i(l,this._strict,this)}invokeFunction(l,...v){let _=u.traceInvocation(l),b=!1;try{return l({get:(c,h)=>{if(b)throw(0,g.illegalState)("service accessor is only valid during the invocation of its target method");const p=this._getOrCreateServiceInstance(c,_);if(!p&&h!==S.optional)throw new Error(`[invokeFunction] unknown service '${c}'`);return p}},...v)}finally{b=!0,_.stop()}}createInstance(l,...v){let _,b;return l instanceof k.SyncDescriptor?(_=u.traceCreation(l.ctor),b=this._createInstance(l.ctor,l.staticArguments.concat(v),_)):(_=u.traceCreation(l),b=this._createInstance(l,v,_)),_.stop(),b}_createInstance(l,v=[],_){let b=S._util.getServiceDependencies(l).sort((h,p)=>h.index-p.index),P=[];for(const h of b){let p=this._getOrCreateServiceInstance(h.id,_);if(!p&&this._strict&&!h.optional)throw new Error(`[createInstance] ${l.name} depends on UNKNOWN service ${h.id}.`);P.push(p)}let c=b.length>0?b[0].index:v.length;if(v.length!==c){console.warn(`[createInstance] First service dependency of ${l.name} at position ${c+1} conflicts with ${v.length} static arguments`);let h=c-v.length;h>0?v=v.concat(new Array(h)):v=v.slice(0,c)}return new l(...[...v,...P])}_setServiceInstance(l,v){if(this._services.get(l)instanceof k.SyncDescriptor)this._services.set(l,v);else if(this._parent)this._parent._setServiceInstance(l,v);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(l){let v=this._services.get(l);return!v&&this._parent?this._parent._getServiceInstanceOrDescriptor(l):v}_getOrCreateServiceInstance(l,v){let _=this._getServiceInstanceOrDescriptor(l);return _ instanceof k.SyncDescriptor?this._safeCreateAndCacheServiceInstance(l,_,v.branch(l,!0)):(v.branch(l,!1),_)}_safeCreateAndCacheServiceInstance(l,v,_){if(this._activeInstantiations.has(l))throw new Error(`illegal state - RECURSIVELY instantiating service '${l}'`);this._activeInstantiations.add(l);try{return this._createAndCacheServiceInstance(l,v,_)}finally{this._activeInstantiations.delete(l)}}_createAndCacheServiceInstance(l,v,_){const b=new R.Graph(h=>h.id.toString());let P=0;const c=[{id:l,desc:v,_trace:_}];for(;c.length;){const h=c.pop();if(b.lookupOrInsertNode(h),P++>1e3)throw new A(b);for(let p of S._util.getServiceDependencies(h.desc.ctor)){let t=this._getServiceInstanceOrDescriptor(p.id);if(!t&&!p.optional&&console.warn(`[createInstance] ${l} depends on ${p.id} which is NOT registered.`),t instanceof k.SyncDescriptor){const r={id:p.id,desc:t,_trace:h._trace.branch(p.id,!0)};b.insertEdge(h,r),c.push(r)}}}for(;;){const h=b.roots();if(h.length===0){if(!b.isEmpty())throw new A(b);break}for(const{data:p}of h){if(this._getServiceInstanceOrDescriptor(p.id)instanceof k.SyncDescriptor){const r=this._createServiceInstanceWithOwner(p.id,p.desc.ctor,p.desc.staticArguments,p.desc.supportsDelayedInstantiation,p._trace);this._setServiceInstance(p.id,r)}b.removeNode(p)}}return this._getServiceInstanceOrDescriptor(l)}_createServiceInstanceWithOwner(l,v,_=[],b,P){if(this._services.get(l)instanceof k.SyncDescriptor)return this._createServiceInstance(v,_,b,P);if(this._parent)return this._parent._createServiceInstanceWithOwner(l,v,_,b,P);throw new Error(`illegalState - creating UNKNOWN service instance ${v.name}`)}_createServiceInstance(l,v=[],_,b){if(_){const P=new D.IdleValue(()=>this._createInstance(l,v,b));return new Proxy(Object.create(null),{get(c,h){if(h in c)return c[h];let p=P.value,t=p[h];return typeof t!="function"||(t=t.bind(p),c[h]=t),t},set(c,h,p){return P.value[h]=p,!0}})}else return this._createInstance(l,v,b)}}e.InstantiationService=i;var C;(function(m){m[m.Creation=0]="Creation",m[m.Invocation=1]="Invocation",m[m.Branch=2]="Branch"})(C||(C={}));class u{constructor(l,v){this.type=l,this.name=v,this._start=Date.now(),this._dep=[]}static traceInvocation(l){return y?new u(1,l.name||l.toString().substring(0,42).replace(/\n/g,"")):u._None}static traceCreation(l){return y?new u(0,l.name):u._None}branch(l,v){let _=new u(2,l.toString());return this._dep.push([l,v,_]),_}stop(){let l=Date.now()-this._start;u._totals+=l;let v=!1;function _(P,c){let h=[],p=new Array(P+1).join("	");for(const[t,r,s]of c._dep)if(r&&s){v=!0,h.push(`${p}CREATES -> ${t}`);let n=_(P+1,s);n&&h.push(n)}else h.push(`${p}uses -> ${t}`);return h.join(`
`)}let b=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${_(1,this)}`,`DONE, took ${l.toFixed(2)}ms (grand total ${u._totals.toFixed(2)}ms)`];(l>2||v)&&console.log(b.join(`
`))}}u._None=new class extends u{constructor(){super(-1,null)}stop(){}branch(){return this}},u._totals=0}),define(me[12],ge([0,1,4,6,11,3,60]),function(J,e,g,R,k,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,g.createDecorator)("logService"),e.ILoggerService=(0,g.createDecorator)("loggerService");function D(){return new Date().toISOString()}var y;(function(p){p[p.Trace=0]="Trace",p[p.Debug=1]="Debug",p[p.Info=2]="Info",p[p.Warning=3]="Warning",p[p.Error=4]="Error",p[p.Critical=5]="Critical",p[p.Off=6]="Off"})(y=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=y.Info;class A extends R.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new S.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(t){this.level!==t&&(this.level=t,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=A;class i extends A{constructor(t){super();this.logAlways=t}checkLogLevel(t){return this.logAlways||this.getLevel()<=t}trace(t,...r){this.checkLogLevel(y.Trace)&&this.log(y.Trace,this.format([t,...r]))}debug(t,...r){this.checkLogLevel(y.Debug)&&this.log(y.Debug,this.format([t,...r]))}info(t,...r){this.checkLogLevel(y.Info)&&this.log(y.Info,this.format([t,...r]))}warn(t,...r){this.checkLogLevel(y.Warning)&&this.log(y.Warning,this.format([t,...r]))}error(t,...r){if(this.checkLogLevel(y.Error))if(t instanceof Error){const s=Array.prototype.slice.call(arguments);s[0]=t.stack,this.log(y.Error,this.format(s))}else this.log(y.Error,this.format([t,...r]))}critical(t,...r){this.checkLogLevel(y.Critical)&&this.log(y.Critical,this.format([t,...r]))}flush(){}format(t){let r="";for(let s=0;s<t.length;s++){let n=t[s];if(typeof n=="object")try{n=JSON.stringify(n)}catch(a){}r+=(s>0?" ":"")+n}return r}}e.AbstractMessageLogger=i;class C extends A{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t),this.useColors=!k.isWindows}trace(t,...r){this.getLevel()<=y.Trace&&(this.useColors?console.log(`[90m[main ${D()}][0m`,t,...r):console.log(`[main ${D()}]`,t,...r))}debug(t,...r){this.getLevel()<=y.Debug&&(this.useColors?console.log(`[90m[main ${D()}][0m`,t,...r):console.log(`[main ${D()}]`,t,...r))}info(t,...r){this.getLevel()<=y.Info&&(this.useColors?console.log(`[90m[main ${D()}][0m`,t,...r):console.log(`[main ${D()}]`,t,...r))}warn(t,...r){this.getLevel()<=y.Warning&&(this.useColors?console.warn(`[93m[main ${D()}][0m`,t,...r):console.warn(`[main ${D()}]`,t,...r))}error(t,...r){this.getLevel()<=y.Error&&(this.useColors?console.error(`[91m[main ${D()}][0m`,t,...r):console.error(`[main ${D()}]`,t,...r))}critical(t,...r){this.getLevel()<=y.Critical&&(this.useColors?console.error(`[90m[main ${D()}][0m`,t,...r):console.error(`[main ${D()}]`,t,...r))}dispose(){}flush(){}}e.ConsoleMainLogger=C;class u extends A{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t)}trace(t,...r){this.getLevel()<=y.Trace&&console.log("%cTRACE","color: #888",t,...r)}debug(t,...r){this.getLevel()<=y.Debug&&console.log("%cDEBUG","background: #eee; color: #888",t,...r)}info(t,...r){this.getLevel()<=y.Info&&console.log("%c INFO","color: #33f",t,...r)}warn(t,...r){this.getLevel()<=y.Warning&&console.log("%c WARN","color: #993",t,...r)}error(t,...r){this.getLevel()<=y.Error&&console.log("%c  ERR","color: #f33",t,...r)}critical(t,...r){this.getLevel()<=y.Critical&&console.log("%cCRITI","background: #f33; color: white",t,...r)}dispose(){}flush(){}}e.ConsoleLogger=u;class m extends A{constructor(t,r=e.DEFAULT_LOG_LEVEL){super();this.adapter=t,this.setLevel(r)}trace(t,...r){this.getLevel()<=y.Trace&&this.adapter.log(y.Trace,[this.extractMessage(t),...r])}debug(t,...r){this.getLevel()<=y.Debug&&this.adapter.log(y.Debug,[this.extractMessage(t),...r])}info(t,...r){this.getLevel()<=y.Info&&this.adapter.log(y.Info,[this.extractMessage(t),...r])}warn(t,...r){this.getLevel()<=y.Warning&&this.adapter.log(y.Warning,[this.extractMessage(t),...r])}error(t,...r){this.getLevel()<=y.Error&&this.adapter.log(y.Error,[this.extractMessage(t),...r])}critical(t,...r){this.getLevel()<=y.Critical&&this.adapter.log(y.Critical,[this.extractMessage(t),...r])}extractMessage(t){return typeof t=="string"?t:(0,T.toErrorMessage)(t,this.getLevel()<=y.Trace)}dispose(){}flush(){}}e.AdapterLogger=m;class l extends A{constructor(t){super();this.logServices=t,t.length&&this.setLevel(t[0].getLevel())}setLevel(t){for(const r of this.logServices)r.setLevel(t);super.setLevel(t)}trace(t,...r){for(const s of this.logServices)s.trace(t,...r)}debug(t,...r){for(const s of this.logServices)s.debug(t,...r)}info(t,...r){for(const s of this.logServices)s.info(t,...r)}warn(t,...r){for(const s of this.logServices)s.warn(t,...r)}error(t,...r){for(const s of this.logServices)s.error(t,...r)}critical(t,...r){for(const s of this.logServices)s.critical(t,...r)}flush(){for(const t of this.logServices)t.flush()}dispose(){for(const t of this.logServices)t.dispose()}}e.MultiplexLogService=l;class v extends R.Disposable{constructor(t){super();this.logger=t,this._register(t)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(t){this.logger.setLevel(t)}getLevel(){return this.logger.getLevel()}trace(t,...r){this.logger.trace(t,...r)}debug(t,...r){this.logger.debug(t,...r)}info(t,...r){this.logger.info(t,...r)}warn(t,...r){this.logger.warn(t,...r)}error(t,...r){this.logger.error(t,...r)}critical(t,...r){this.logger.critical(t,...r)}flush(){this.logger.flush()}}e.LogService=v;class _ extends R.Disposable{constructor(t,r){super();this.logLevel=t,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(r(s=>{this.logLevel=s,this.logLevelChangeableLoggers.forEach(n=>n.setLevel(s))}))}getLogger(t){return this.loggers.get(t.toString())}createLogger(t,r){let s=this.loggers.get(t.toString());return s||(s=this.doCreateLogger(t,r?.always?y.Trace:this.logLevel,r),this.loggers.set(t.toString(),s),r?.always||this.logLevelChangeableLoggers.push(s)),s}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(t=>t.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=_;class b{constructor(){this.onDidChangeLogLevel=new S.Emitter().event}setLevel(t){}getLevel(){return y.Info}trace(t,...r){}debug(t,...r){}info(t,...r){}warn(t,...r){}error(t,...r){}critical(t,...r){}dispose(){}flush(){}}e.NullLogService=b;function P(p){if(p.verbose)return y.Trace;if(typeof p.logLevel=="string"){const t=c(p.logLevel.toLowerCase());if(t!==void 0)return t}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=P;function c(p){switch(p){case"trace":return y.Trace;case"debug":return y.Debug;case"info":return y.Info;case"warn":return y.Warning;case"error":return y.Error;case"critical":return y.Critical;case"off":return y.Off}}e.parseLogLevel=c;function h(p){switch(p){case y.Trace:return"trace";case y.Debug:return"debug";case y.Info:return"info";case y.Warning:return"warn";case y.Error:return"error";case y.Critical:return"critical";case y.Off:return"off"}}e.LogLevelToString=h}),define(me[116],ge([0,1,12,42]),function(J,e,g,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=e.createRotatingLogger=void 0;async function k(y,A,i,C){try{const u=await new Promise((m,l)=>{J(["spdlog"],m,l)});return u.setFlushOn(g.LogLevel.Trace),u.createAsyncRotatingLogger(y,A,i,C)}catch(u){console.error(u)}return null}function S(y,A,i,C){const u=J.__$__nodeRequire("spdlog");return u.setFlushOn(g.LogLevel.Trace),u.createRotatingLogger(y,A,i,C)}e.createRotatingLogger=S;function T(y,A,i){switch(A){case g.LogLevel.Trace:y.trace(i);break;case g.LogLevel.Debug:y.debug(i);break;case g.LogLevel.Info:y.info(i);break;case g.LogLevel.Warning:y.warn(i);break;case g.LogLevel.Error:y.error(i);break;case g.LogLevel.Critical:y.critical(i);break;default:throw new Error("Invalid log level")}}class D extends g.AbstractMessageLogger{constructor(A,i,C,u){super();this.name=A,this.filepath=i,this.rotating=C,this.buffer=[],this.setLevel(u),this._loggerCreationPromise=this._createSpdLogLogger(),this._register(this.onDidChangeLogLevel(m=>{this._logger&&this._logger.setLevel(m)}))}_createSpdLogLogger(){const A=this.rotating?6:1,i=30/A*R.ByteSize.MB;return k(this.name,this.filepath,i,A).then(C=>{if(C){this._logger=C,this._logger.setLevel(this.getLevel());for(const{level:u,message:m}of this.buffer)T(this._logger,u,m);this.buffer=[]}})}log(A,i){this._logger?T(this._logger,A,i):this.getLevel()<=A&&this.buffer.push({level:A,message:i})}clearFormatters(){this._logger?this._logger.clearFormatters():this._loggerCreationPromise.then(()=>this.clearFormatters())}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=D}),define(me[117],ge([0,1,4,160,48]),function(J,e,g,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var S;(function(y){y[y.Unnecessary=1]="Unnecessary",y[y.Deprecated=2]="Deprecated"})(S=e.MarkerTag||(e.MarkerTag={}));var T;(function(y){y[y.Hint=1]="Hint",y[y.Info=2]="Info",y[y.Warning=4]="Warning",y[y.Error=8]="Error"})(T=e.MarkerSeverity||(e.MarkerSeverity={})),function(y){function A(l,v){return v-l}y.compare=A;const i=Object.create(null);i[y.Error]=(0,R.localize)(0,null),i[y.Warning]=(0,R.localize)(1,null),i[y.Info]=(0,R.localize)(2,null);function C(l){return i[l]||""}y.toString=C;function u(l){switch(l){case k.default.Error:return y.Error;case k.default.Warning:return y.Warning;case k.default.Info:return y.Info;case k.default.Ignore:return y.Hint}}y.fromSeverity=u;function m(l){switch(l){case y.Error:return k.default.Error;case y.Warning:return k.default.Warning;case y.Info:return k.default.Info;case y.Hint:return k.default.Ignore}}y.toSeverity=m}(T=e.MarkerSeverity||(e.MarkerSeverity={}));var D;(function(y){const A="";function i(u){return C(u,!0)}y.makeKey=i;function C(u,m){let l=[A];return u.source?l.push(u.source.replace("\xA6","\\\xA6")):l.push(A),u.code?typeof u.code=="string"?l.push(u.code.replace("\xA6","\\\xA6")):l.push(u.code.value.replace("\xA6","\\\xA6")):l.push(A),u.severity!==void 0&&u.severity!==null?l.push(T.toString(u.severity)):l.push(A),u.message&&m?l.push(u.message.replace("\xA6","\\\xA6")):l.push(A),u.startLineNumber!==void 0&&u.startLineNumber!==null?l.push(u.startLineNumber.toString()):l.push(A),u.startColumn!==void 0&&u.startColumn!==null?l.push(u.startColumn.toString()):l.push(A),u.endLineNumber!==void 0&&u.endLineNumber!==null?l.push(u.endLineNumber.toString()):l.push(A),u.endColumn!==void 0&&u.endColumn!==null?l.push(u.endColumn.toString()):l.push(A),l.push(A),l.join("\xA6")}y.makeKeyOptionalMessage=C})(D=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,g.createDecorator)("markerService")}),define(me[189],ge([0,1,48,4,3]),function(J,e,g,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=g.default,e.INotificationService=(0,R.createDecorator)("notificationService");var S;(function(A){A[A.WORKSPACE=0]="WORKSPACE",A[A.GLOBAL=1]="GLOBAL"})(S=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var T;(function(A){A[A.OFF=0]="OFF",A[A.SILENT=1]="SILENT",A[A.ERROR=2]="ERROR"})(T=e.NotificationsFilter||(e.NotificationsFilter={}));class D{constructor(){this.progress=new y,this.onDidClose=k.Event.None,this.onDidChangeVisibility=k.Event.None}updateSeverity(i){}updateMessage(i){}updateActions(i){}close(){}}e.NoOpNotification=D;class y{infinite(){}done(){}total(i){}worked(i){}}e.NoOpProgress=y}),define(me[190],ge([0,1,6,8,2,4]),function(J,e,g,R,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesScheme=e.NullOpenerService=e.IOpenerService=void 0,e.IOpenerService=(0,S.createDecorator)("openerService"),e.NullOpenerService=Object.freeze({_serviceBrand:void 0,registerOpener(){return g.Disposable.None},registerValidator(){return g.Disposable.None},registerExternalUriResolver(){return g.Disposable.None},setDefaultExternalOpener(){},registerExternalOpener(){return g.Disposable.None},async open(){return!1},async resolveExternalUri(D){return{resolved:D,dispose(){}}}});function T(D,y){return k.URI.isUri(D)?(0,R.equalsIgnoreCase)(D.scheme,y):(0,R.startsWithIgnoreCase)(D,y+":")}e.matchesScheme=T}),define(me[191],ge([0,1,10,11,38,23]),function(J,e,g,R,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let T;if(typeof R.globals.vscode!="undefined"&&typeof R.globals.vscode.context!="undefined"){const D=R.globals.vscode.context.configuration();if(D)T=D.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof J?.__$__nodeRequire=="function"){const D=(0,S.dirname)(g.FileAccess.asFileUri("",J));T=J.__$__nodeRequire((0,S.joinPath)(D,"product.json").fsPath);const y=J.__$__nodeRequire((0,S.joinPath)(D,"package.json").fsPath);k.env.VSCODE_DEV&&Object.assign(T,{nameShort:`${T.nameShort} Dev`,nameLong:`${T.nameLong} Dev`,dataFolderName:`${T.dataFolderName}-dev`}),Object.assign(T,{version:y.version})}else T={},Object.keys(T).length===0&&Object.assign(T,{version:"1.59.0-dev",nameShort:R.isWeb?"Code Web - OSS Dev":"Code - OSS Dev",nameLong:R.isWeb?"Code Web - OSS Dev":"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",extensionAllowedProposedApi:["ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","ms-vscode.remotehub","ms-vscode.remotehub-insiders","GitHub.remotehub","GitHub.remotehub-insiders"]});e.default=T});var $e=this&&this.__param||function(J,e){return function(g,R){e(g,R,J)}};define(me[118],ge([0,1,4,21,6,16]),function(J,e,g,R,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,g.createDecorator)("progressService");var T;(function(i){i[i.Explorer=1]="Explorer",i[i.Scm=3]="Scm",i[i.Extensions=5]="Extensions",i[i.Window=10]="Window",i[i.Notification=15]="Notification",i[i.Dialog=20]="Dialog"})(T=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class D{constructor(C){this.callback=C}get value(){return this._value}report(C){this._value=C,this.callback(this._value)}}e.Progress=D,D.None=Object.freeze({report(){}});let y=class extends k.Disposable{constructor(C,u){super();this.deferred=new S.DeferredPromise,u.withProgress(C,m=>(this.reporter=m,this.lastStep&&m.report(this.lastStep),this.deferred.p)),this._register((0,k.toDisposable)(()=>this.deferred.complete()))}report(C){this.reporter?this.reporter.report(C):this.lastStep=C}};y=Ve([$e(1,e.IProgressService)],y),e.UnmanagedProgress=y;class A extends k.Disposable{constructor(C){super();this.progressIndicator=C,this.currentOperationId=0,this.currentOperationDisposables=this._register(new k.DisposableStore)}start(C){this.stop();const u=++this.currentOperationId,m=new R.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{u===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},C),this.currentOperationDisposables.add((0,k.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,k.toDisposable)(()=>m.cancel())),this.currentOperationDisposables.add((0,k.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:u,token:m.token,stop:()=>this.doStop(u),isCurrent:()=>this.currentOperationId===u}}stop(){this.doStop(this.currentOperationId)}doStop(C){this.currentOperationId===C&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=A,e.IEditorProgressService=(0,g.createDecorator)("editorProgressService")}),define(me[34],ge([0,1,14,54]),function(J,e,g,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class k{constructor(){this.data=new Map}add(T,D){R.ok(g.isString(T)),R.ok(g.isObject(D)),R.ok(!this.data.has(T),"There is already an extension with this id"),this.data.set(T,D)}knows(T){return this.data.has(T)}as(T){return this.data.get(T)||null}}e.Registry=new k}),define(me[119],ge([0,1,34,3]),function(J,e,g,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function k(D){return D.length>0&&D.charAt(D.length-1)==="#"?D.substring(0,D.length-1):D}class S{constructor(){this._onDidChangeSchema=new R.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(y,A){this.schemasById[k(y)]=A,this._onDidChangeSchema.fire(y)}notifySchemaChanged(y){this._onDidChangeSchema.fire(y)}getSchemaContributions(){return{schemas:this.schemasById}}}const T=new S;g.Registry.add(e.Extensions.JSONContribution,T)}),define(me[83],ge([0,1,155,3,34,14,119]),function(J,e,g,R,k,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.overrideIdentifierFromKey=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var D;(function(b){b.Multiline="multilineText",b.Singleline="singlelineText"})(D=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var y;(function(b){b[b.APPLICATION=1]="APPLICATION",b[b.MACHINE=2]="MACHINE",b[b.WINDOW=3]="WINDOW",b[b.RESOURCE=4]="RESOURCE",b[b.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",b[b.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(y=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const A=k.Registry.as(T.Extensions.JSONContribution);class i{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new R.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new R.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:g.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},A.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(P,c=!0){this.registerConfigurations([P],c)}registerConfigurations(P,c=!0){const h=[];P.forEach(p=>{h.push(...this.validateAndRegisterProperties(p,c,p.extensionInfo)),this.configurationContributors.push(p),this.registerJSONConfiguration(p)}),A.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(h)}deregisterConfigurations(P){const c=[],h=p=>{if(p.properties)for(const t in p.properties)c.push(t),delete this.configurationProperties[t],this.removeFromSchema(t,p.properties[t]);p.allOf&&p.allOf.forEach(t=>h(t))};for(const p of P){h(p);const t=this.configurationContributors.indexOf(p);t!==-1&&this.configurationContributors.splice(t,1)}A.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(c)}registerDefaultConfigurations(P){const c=[],h=[];for(const p of P)for(const t in p)if(c.push(t),e.OVERRIDE_PROPERTY_PATTERN.test(t)){this.defaultValues[t]={...this.defaultValues[t]||{},...p[t]};const r={type:"object",default:this.defaultValues[t],description:g.localize(1,null,t),$ref:e.resourceLanguageSettingsSchemaId};h.push(u(t)),this.configurationProperties[t]=r,this.defaultLanguageConfigurationOverridesNode.properties[t]=r}else{this.defaultValues[t]=p[t];const r=this.configurationProperties[t];r&&(this.updatePropertyDefaultValue(t,r),this.updateSchema(t,r))}this.registerOverrideIdentifiers(h),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(c)}deregisterDefaultConfigurations(P){const c=[];for(const h of P)for(const p in h)if(c.push(p),delete this.defaultValues[p],e.OVERRIDE_PROPERTY_PATTERN.test(p))delete this.configurationProperties[p],delete this.defaultLanguageConfigurationOverridesNode.properties[p];else{const t=this.configurationProperties[p];t&&(this.updatePropertyDefaultValue(p,t),this.updateSchema(p,t))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(c)}notifyConfigurationSchemaUpdated(...P){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(P){for(const c of P)this.overrideIdentifiers.add(c);this.updateOverridePropertyPatternKey()}validateAndRegisterProperties(P,c=!0,h,p=3){p=S.isUndefinedOrNull(P.scope)?p:P.scope;let t=[],r=P.properties;if(r)for(let n in r){if(c&&v(n)){delete r[n];continue}const a=r[n];if(this.updatePropertyDefaultValue(n,a),e.OVERRIDE_PROPERTY_PATTERN.test(n)?a.scope=void 0:(a.scope=S.isUndefinedOrNull(a.scope)?p:a.scope,a.restricted=S.isUndefinedOrNull(a.restricted)?!!h?.restrictedConfigurations?.includes(n):a.restricted),r[n].hasOwnProperty("included")&&!r[n].included){this.excludedConfigurationProperties[n]=r[n],delete r[n];continue}else this.configurationProperties[n]=r[n];!r[n].deprecationMessage&&r[n].markdownDeprecationMessage&&(r[n].deprecationMessage=r[n].markdownDeprecationMessage),t.push(n)}let s=P.allOf;if(s)for(let n of s)t.push(...this.validateAndRegisterProperties(n,c,h,p));return t}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(P){const c=h=>{let p=h.properties;if(p)for(const r in p)this.updateSchema(r,p[r]);let t=h.allOf;t&&t.forEach(c)};c(P)}updateSchema(P,c){switch(e.allSettings.properties[P]=c,c.scope){case 1:e.applicationSettings.properties[P]=c;break;case 2:e.machineSettings.properties[P]=c;break;case 6:e.machineOverridableSettings.properties[P]=c;break;case 3:e.windowSettings.properties[P]=c;break;case 4:e.resourceSettings.properties[P]=c;break;case 5:e.resourceSettings.properties[P]=c,this.resourceLanguageSettingsSchema.properties[P]=c;break}}removeFromSchema(P,c){switch(delete e.allSettings.properties[P],c.scope){case 1:delete e.applicationSettings.properties[P];break;case 2:delete e.machineSettings.properties[P];break;case 6:delete e.machineOverridableSettings.properties[P];break;case 3:delete e.windowSettings.properties[P];break;case 4:case 5:delete e.resourceSettings.properties[P];break}}updateOverridePropertyPatternKey(){for(const P of this.overrideIdentifiers.values()){const c=`[${P}]`,h={type:"object",description:g.localize(2,null),errorMessage:g.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(c,h),e.allSettings.properties[c]=h,e.applicationSettings.properties[c]=h,e.machineSettings.properties[c]=h,e.machineOverridableSettings.properties[c]=h,e.windowSettings.properties[c]=h,e.resourceSettings.properties[c]=h}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(P,c){let h=this.defaultValues[P];S.isUndefined(h)&&(h=c.default),S.isUndefined(h)&&(h=m(c.type)),c.default=h}}const C="\\[.*\\]$";e.OVERRIDE_PROPERTY_PATTERN=new RegExp(C);function u(b){return b.substring(1,b.length-1)}e.overrideIdentifierFromKey=u;function m(b){switch(Array.isArray(b)?b[0]:b){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=m;const l=new i;k.Registry.add(e.Extensions.Configuration,l);function v(b){return b.trim()?e.OVERRIDE_PROPERTY_PATTERN.test(b)?g.localize(5,null,b):l.getConfigurationProperties()[b]!==void 0?g.localize(6,null,b):null:g.localize(4,null)}e.validateProperty=v;function _(){const b=[],P=l.getConfigurationProperties();for(const c of Object.keys(P))b.push([c,P[c].scope]);return b.push(["launch",4]),b.push(["task",4]),b}e.getScopes=_}),define(me[120],ge([0,1,25,14,2,34,4,83]),function(J,e,g,R,k,S,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.keyFromOverrideIdentifier=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.toOverrides=e.compare=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,T.createDecorator)("configurationService");function y(r){return r&&typeof r=="object"&&(!r.overrideIdentifier||typeof r.overrideIdentifier=="string")&&(!r.resource||r.resource instanceof k.URI)}e.isConfigurationOverrides=y;var A;(function(r){r[r.USER=1]="USER",r[r.USER_LOCAL=2]="USER_LOCAL",r[r.USER_REMOTE=3]="USER_REMOTE",r[r.WORKSPACE=4]="WORKSPACE",r[r.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",r[r.DEFAULT=6]="DEFAULT",r[r.MEMORY=7]="MEMORY"})(A=e.ConfigurationTarget||(e.ConfigurationTarget={}));function i(r){switch(r){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=i;function C(r,s){const n=s?r?s.keys.filter(I=>r.keys.indexOf(I)===-1):[...s.keys]:[],a=r?s?r.keys.filter(I=>s.keys.indexOf(I)===-1):[...r.keys]:[],d=[];if(s&&r){for(const I of r.keys)if(s.keys.indexOf(I)!==-1){const L=b(r.contents,I),U=b(s.contents,I);g.equals(L,U)||d.push(I)}}const f=[],w=I=>{const L={};for(const U of I)for(const V of U.identifiers)L[p(V)]=U;return L},E=s?w(s.overrides):{},o=r?w(r.overrides):{};if(Object.keys(E).length)for(const I of n){const L=E[I];L&&f.push([(0,D.overrideIdentifierFromKey)(I),L.keys])}if(Object.keys(o).length)for(const I of a){const L=o[I];L&&f.push([(0,D.overrideIdentifierFromKey)(I),L.keys])}if(Object.keys(E).length&&Object.keys(o).length)for(const I of d){const L=o[I],U=E[I];if(L&&U){const V=C({contents:L.contents,keys:L.keys,overrides:[]},{contents:U.contents,keys:U.keys,overrides:[]});f.push([(0,D.overrideIdentifierFromKey)(I),[...V.added,...V.removed,...V.updated]])}}return{added:n,removed:a,updated:d,overrides:f}}e.compare=C;function u(r,s){const n=[];for(const a of Object.keys(r))if(D.OVERRIDE_PROPERTY_PATTERN.test(a)){const d={};for(const f in r[a])d[f]=r[a][f];n.push({identifiers:[(0,D.overrideIdentifierFromKey)(a).trim()],keys:Object.keys(d),contents:m(d,s)})}return n}e.toOverrides=u;function m(r,s){const n=Object.create(null);for(let a in r)l(n,a,r[a],s);return n}e.toValuesTree=m;function l(r,s,n,a){const d=s.split("."),f=d.pop();let w=r;for(let E=0;E<d.length;E++){let o=d[E],I=w[o];switch(typeof I){case"undefined":I=w[o]=Object.create(null);break;case"object":break;default:a(`Ignoring ${s} as ${d.slice(0,E+1).join(".")} is ${JSON.stringify(I)}`);return}w=I}if(typeof w=="object"&&w!==null)try{w[f]=n}catch(E){a(`Ignoring ${s} as ${d.join(".")} is ${JSON.stringify(w)}`)}else a(`Ignoring ${s} as ${d.join(".")} is ${JSON.stringify(w)}`)}e.addToValueTree=l;function v(r,s){const n=s.split(".");_(r,n)}e.removeFromValueTree=v;function _(r,s){const n=s.shift();if(s.length===0){delete r[n];return}if(Object.keys(r).indexOf(n)!==-1){const a=r[n];typeof a=="object"&&!Array.isArray(a)&&(_(a,s),Object.keys(a).length===0&&delete r[n])}}function b(r,s,n){function a(w,E){let o=w;for(const I of E){if(typeof o!="object"||o===null)return;o=o[I]}return o}const d=s.split("."),f=a(r,d);return typeof f=="undefined"?n:f}e.getConfigurationValue=b;function P(r,s,n){Object.keys(s).forEach(a=>{a!=="__proto__"&&(a in r?R.isObject(r[a])&&R.isObject(s[a])?P(r[a],s[a],n):n&&(r[a]=s[a]):r[a]=s[a])})}e.merge=P;function c(){const r=S.Registry.as(D.Extensions.Configuration).getConfigurationProperties();return Object.keys(r)}e.getConfigurationKeys=c;function h(){const r=Object.create(null),s=S.Registry.as(D.Extensions.Configuration).getConfigurationProperties();for(let n in s){let a=s[n].default;l(r,n,a,d=>console.error(`Conflict in default settings: ${d}`))}return r}e.getDefaultValues=h;function p(r){return`[${r}]`}e.keyFromOverrideIdentifier=p;function t(r,s,n){const a=r.inspect(s),d=r.inspect(n);return typeof a.userValue!="undefined"||typeof a.workspaceValue!="undefined"||typeof a.workspaceFolderValue!="undefined"?a.value:typeof d.userValue!="undefined"||typeof d.workspaceValue!="undefined"||typeof d.workspaceFolderValue!="undefined"?d.value:a.defaultValue}e.getMigratedSettingValue=t}),define(me[192],ge([0,1,57,22,20,14,25,2,83,120,34,6,3]),function(J,e,g,R,k,S,T,D,y,A,i,C,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class m{constructor(t={},r=[],s=[]){this._contents=t,this._keys=r,this._overrides=s,this.isFrozen=!1}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(t){return t?(0,A.getConfigurationValue)(this.contents,t):this.contents}getOverrideValue(t,r){const s=this.getContentsForOverrideIdentifer(r);return s?t?(0,A.getConfigurationValue)(s,t):s:void 0}getKeysForOverrideIdentifier(t){for(const r of this.overrides)if(r.identifiers.indexOf(t)!==-1)return r.keys;return[]}override(t){const r=this.getContentsForOverrideIdentifer(t);if(!r||typeof r!="object"||!Object.keys(r).length)return this;let s={};for(const n of k.distinct([...Object.keys(this.contents),...Object.keys(r)])){let a=this.contents[n],d=r[n];d&&(typeof a=="object"&&typeof d=="object"?(a=T.deepClone(a),this.mergeContents(a,d)):a=d),s[n]=a}return new m(s,this.keys,this.overrides)}merge(...t){const r=T.deepClone(this.contents),s=T.deepClone(this.overrides),n=[...this.keys];for(const a of t){this.mergeContents(r,a.contents);for(const d of a.overrides){const[f]=s.filter(w=>k.equals(w.identifiers,d.identifiers));f?this.mergeContents(f.contents,d.contents):s.push(T.deepClone(d))}for(const d of a.keys)n.indexOf(d)===-1&&n.push(d)}return new m(r,n,s)}freeze(){return this.isFrozen=!0,this}mergeContents(t,r){for(const s of Object.keys(r)){if(s in t&&S.isObject(t[s])&&S.isObject(r[s])){this.mergeContents(t[s],r[s]);continue}t[s]=T.deepClone(r[s])}}checkAndFreeze(t){return this.isFrozen&&!Object.isFrozen(t)?T.deepFreeze(t):t}getContentsForOverrideIdentifer(t){for(const r of this.overrides)if(r.identifiers.indexOf(t)!==-1)return r.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(t,r){this.addKey(t),(0,A.addToValueTree)(this.contents,t,r,s=>{throw new Error(s)})}removeValue(t){this.removeKey(t)&&(0,A.removeFromValueTree)(this.contents,t)}addKey(t){let r=this.keys.length;for(let s=0;s<r;s++)t.indexOf(this.keys[s])===0&&(r=s);this.keys.splice(r,1,t)}removeKey(t){let r=this.keys.indexOf(t);return r!==-1?(this.keys.splice(r,1),!0):!1}}e.ConfigurationModel=m;class l extends m{constructor(){const t=(0,A.getDefaultValues)(),r=(0,A.getConfigurationKeys)(),s=[];for(const n of Object.keys(t))y.OVERRIDE_PROPERTY_PATTERN.test(n)&&s.push({identifiers:[(0,y.overrideIdentifierFromKey)(n).trim()],keys:Object.keys(t[n]),contents:(0,A.toValuesTree)(t[n],a=>console.error(`Conflict in default settings file: ${a}`))});super(t,r,s)}}e.DefaultConfigurationModel=l;class v{constructor(t){this._name=t,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new m}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(t,r){if(!S.isUndefinedOrNull(t)){const s=this.doParseContent(t);this.parseRaw(s,r)}}reparse(t){this._raw&&this.parseRaw(this._raw,t)}parseRaw(t,r){this._raw=t;const{contents:s,keys:n,overrides:a,restricted:d}=this.doParseRaw(t,r);this._configurationModel=new m(s,n,a),this._restrictedConfigurations=d||[]}doParseContent(t){let r={},s=null,n=[],a=[],d=[];function f(E){Array.isArray(n)?n.push(E):s!==null&&(n[s]=E)}let w={onObjectBegin:()=>{let E={};f(E),a.push(n),n=E,s=null},onObjectProperty:E=>{s=E},onObjectEnd:()=>{n=a.pop()},onArrayBegin:()=>{let E=[];f(E),a.push(n),n=E,s=null},onArrayEnd:()=>{n=a.pop()},onLiteralValue:f,onError:(E,o,I)=>{d.push({error:E,offset:o,length:I})}};if(t)try{g.visit(t,w),r=n[0]||{}}catch(E){console.error(`Error while parsing settings file ${this._name}: ${E}`),this._parseErrors=[E]}return r}doParseRaw(t,r){const s=i.Registry.as(y.Extensions.Configuration).getConfigurationProperties(),n=this.filter(t,s,!0,r);t=n.raw;const a=(0,A.toValuesTree)(t,w=>console.error(`Conflict in settings file ${this._name}: ${w}`)),d=Object.keys(t),f=(0,A.toOverrides)(t,w=>console.error(`Conflict in settings file ${this._name}: ${w}`));return{contents:a,keys:d,overrides:f,restricted:n.restricted}}filter(t,r,s,n){if(!n?.scopes&&!n?.skipRestricted)return{raw:t,restricted:[]};const a={},d=[];for(let f in t)if(y.OVERRIDE_PROPERTY_PATTERN.test(f)&&s){const w=this.filter(t[f],r,!1,n);a[f]=w.raw,d.push(...w.restricted)}else{const w=r[f],E=w?typeof w.scope!="undefined"?w.scope:3:void 0;w?.restricted&&d.push(f),(E===void 0||n.scopes===void 0||n.scopes.includes(E))&&(n.skipRestricted&&w?.restricted||(a[f]=t[f]))}return{raw:a,restricted:d}}}e.ConfigurationModelParser=v;class _ extends C.Disposable{constructor(t,r,s,n){super();this.userSettingsResource=t,this.scopes=r,this.fileService=n,this._onDidChange=this._register(new u.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new v(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(s.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(u.Event.filter(this.fileService.onDidFilesChange,a=>a.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const t=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(t.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(t){return new m}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=_;class b{constructor(t,r,s=new m,n=new m,a=new R.ResourceMap,d=new m,f=new R.ResourceMap,w=!0){this._defaultConfiguration=t,this._localUserConfiguration=r,this._remoteUserConfiguration=s,this._workspaceConfiguration=n,this._folderConfigurations=a,this._memoryConfiguration=d,this._memoryConfigurationByResource=f,this._freeze=w,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new R.ResourceMap,this._userConfiguration=null}getValue(t,r,s){return this.getConsolidateConfigurationModel(r,s).getValue(t)}updateValue(t,r,s={}){let n;s.resource?(n=this._memoryConfigurationByResource.get(s.resource),n||(n=new m,this._memoryConfigurationByResource.set(s.resource,n))):n=this._memoryConfiguration,r===void 0?n.removeValue(t):n.setValue(t,r),s.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(t,r,s){const n=this.getConsolidateConfigurationModel(r,s),a=this.getFolderConfigurationModelForResource(r.resource,s),d=r.resource?this._memoryConfigurationByResource.get(r.resource)||this._memoryConfiguration:this._memoryConfiguration,f=r.overrideIdentifier?this._defaultConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this._defaultConfiguration.freeze().getValue(t),w=r.overrideIdentifier?this.userConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this.userConfiguration.freeze().getValue(t),E=r.overrideIdentifier?this.localUserConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this.localUserConfiguration.freeze().getValue(t),o=r.overrideIdentifier?this.remoteUserConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this.remoteUserConfiguration.freeze().getValue(t),I=s?r.overrideIdentifier?this._workspaceConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this._workspaceConfiguration.freeze().getValue(t):void 0,L=a?r.overrideIdentifier?a.freeze().override(r.overrideIdentifier).getValue(t):a.freeze().getValue(t):void 0,U=r.overrideIdentifier?d.override(r.overrideIdentifier).getValue(t):d.getValue(t),V=n.getValue(t),ee=k.distinct(k.flatten(n.overrides.map(K=>K.identifiers))).filter(K=>n.getOverrideValue(t,K)!==void 0);return{defaultValue:f,userValue:w,userLocalValue:E,userRemoteValue:o,workspaceValue:I,workspaceFolderValue:L,memoryValue:U,value:V,default:f!==void 0?{value:this._defaultConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,user:w!==void 0?{value:this.userConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,userLocal:E!==void 0?{value:this.localUserConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,userRemote:o!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,workspace:I!==void 0?{value:this._workspaceConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,workspaceFolder:L!==void 0?{value:a?.freeze().getValue(t),override:r.overrideIdentifier?a?.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,memory:U!==void 0?{value:d.getValue(t),override:r.overrideIdentifier?d.getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,overrideIdentifiers:ee.length?ee:void 0}}keys(t){const r=this.getFolderConfigurationModelForResource(void 0,t);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:r?r.freeze().keys:[]}}updateDefaultConfiguration(t){this._defaultConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(t){this._localUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(t){this._remoteUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(t){this._workspaceConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(t,r){this._folderConfigurations.set(t,r),this._foldersConsolidatedConfigurations.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this._foldersConsolidatedConfigurations.delete(t)}compareAndUpdateDefaultConfiguration(t,r){const s=r.filter(n=>y.OVERRIDE_PROPERTY_PATTERN.test(n)).map(n=>{const a=(0,y.overrideIdentifierFromKey)(n),d=this._defaultConfiguration.getKeysForOverrideIdentifier(a),f=t.getKeysForOverrideIdentifier(a),w=[...f.filter(E=>d.indexOf(E)===-1),...d.filter(E=>f.indexOf(E)===-1),...d.filter(E=>!T.equals(this._defaultConfiguration.override(a).getValue(E),t.override(a).getValue(E)))];return[a,w]});return this.updateDefaultConfiguration(t),{keys:r,overrides:s}}compareAndUpdateLocalUserConfiguration(t){const{added:r,updated:s,removed:n,overrides:a}=(0,A.compare)(this.localUserConfiguration,t),d=[...r,...s,...n];return d.length&&this.updateLocalUserConfiguration(t),{keys:d,overrides:a}}compareAndUpdateRemoteUserConfiguration(t){const{added:r,updated:s,removed:n,overrides:a}=(0,A.compare)(this.remoteUserConfiguration,t);let d=[...r,...s,...n];return d.length&&this.updateRemoteUserConfiguration(t),{keys:d,overrides:a}}compareAndUpdateWorkspaceConfiguration(t){const{added:r,updated:s,removed:n,overrides:a}=(0,A.compare)(this.workspaceConfiguration,t);let d=[...r,...s,...n];return d.length&&this.updateWorkspaceConfiguration(t),{keys:d,overrides:a}}compareAndUpdateFolderConfiguration(t,r){const s=this.folderConfigurations.get(t),{added:n,updated:a,removed:d,overrides:f}=(0,A.compare)(s,r);let w=[...n,...a,...d];return(w.length||!s)&&this.updateFolderConfiguration(t,r),{keys:w,overrides:f}}compareAndDeleteFolderConfiguration(t){const r=this.folderConfigurations.get(t);if(!r)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:s,updated:n,removed:a,overrides:d}=(0,A.compare)(r,void 0);return{keys:[...s,...n,...a],overrides:d}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(t,r){let s=this.getConsolidatedConfigurationModelForResource(t,r);return t.overrideIdentifier?s.override(t.overrideIdentifier):s}getConsolidatedConfigurationModelForResource({resource:t},r){let s=this.getWorkspaceConsolidatedConfiguration();if(r&&t){const n=r.getFolder(t);n&&(s=this.getFolderConsolidatedConfiguration(n.uri)||s);const a=this._memoryConfigurationByResource.get(t);a&&(s=s.merge(a))}return s}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(t){let r=this._foldersConsolidatedConfigurations.get(t);if(!r){const s=this.getWorkspaceConsolidatedConfiguration(),n=this._folderConfigurations.get(t);n?(r=s.merge(n),this._freeze&&(r=r.freeze()),this._foldersConsolidatedConfigurations.set(t,r)):r=s}return r}getFolderConfigurationModelForResource(t,r){if(r&&t){const s=r.getFolder(t);if(s)return this._folderConfigurations.get(s.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((t,r)=>{const{contents:s,overrides:n,keys:a}=this._folderConfigurations.get(r);return t.push([r,{contents:s,overrides:n,keys:a}]),t},[])}}allKeys(){const t=new Set;return this._defaultConfiguration.freeze().keys.forEach(r=>t.add(r)),this.userConfiguration.freeze().keys.forEach(r=>t.add(r)),this._workspaceConfiguration.freeze().keys.forEach(r=>t.add(r)),this._folderConfigurations.forEach(r=>r.freeze().keys.forEach(s=>t.add(s))),[...t.values()]}getAllKeysForOverrideIdentifier(t){const r=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(t).forEach(s=>r.add(s)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(s=>r.add(s)),this._workspaceConfiguration.getKeysForOverrideIdentifier(t).forEach(s=>r.add(s)),this._folderConfigurations.forEach(s=>s.getKeysForOverrideIdentifier(t).forEach(n=>r.add(n))),[...r.values()]}static parse(t){const r=this.parseConfigurationModel(t.defaults),s=this.parseConfigurationModel(t.user),n=this.parseConfigurationModel(t.workspace),a=t.folders.reduce((d,f)=>(d.set(D.URI.revive(f[0]),this.parseConfigurationModel(f[1])),d),new R.ResourceMap);return new b(r,s,new m,n,a,new m,new R.ResourceMap,!1)}static parseConfigurationModel(t){return new m(t.contents,t.keys,t.overrides).freeze()}}e.Configuration=b;function P(...p){if(p.length===0)return{keys:[],overrides:[]};if(p.length===1)return p[0];const t=new Set,r=new Map;for(const n of p)n.keys.forEach(a=>t.add(a)),n.overrides.forEach(([a,d])=>{const f=(0,R.getOrSet)(r,a,new Set);d.forEach(w=>f.add(w))});const s=[];return r.forEach((n,a)=>s.push([a,[...n.values()]])),{keys:[...t.values()],overrides:s}}e.mergeChanges=P;class c{constructor(t,r,s,n){this.change=t,this.previous=r,this.currentConfiguraiton=s,this.currentWorkspace=n,this._previousConfiguration=void 0;const a=new Set;t.keys.forEach(f=>a.add(f)),t.overrides.forEach(([,f])=>f.forEach(w=>a.add(w))),this.affectedKeys=[...a.values()];const d=new m;this.affectedKeys.forEach(f=>d.setValue(f,{})),this.affectedKeysTree=d.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=b.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(t,r){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,t)){if(r){const s=this.previousConfiguration?this.previousConfiguration.getValue(t,r,this.previous?.workspace):void 0,n=this.currentConfiguraiton.getValue(t,r,this.currentWorkspace);return!T.equals(s,n)}return!0}return!1}doesAffectedKeysTreeContains(t,r){let s=(0,A.toValuesTree)({[r]:!0},()=>{}),n;for(;typeof s=="object"&&(n=Object.keys(s)[0]);){if(t=t[n],!t)return!1;s=s[n]}return!0}}e.ConfigurationChangeEvent=c;class h extends c{constructor(t,r,s,n){super({keys:t.allKeys(),overrides:[]},void 0,t,r);this.source=s,this.sourceConfig=n}}e.AllKeysConfigurationChangeEvent=h}),define(me[121],ge([0,1,4]),function(J,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,g.createDecorator)("remoteAuthorityResolverService");var R;(function(S){S.Unknown="Unknown",S.NotAvailable="NotAvailable",S.TemporarilyNotAvailable="TemporarilyNotAvailable",S.NoResolverFound="NoResolverFound"})(R=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class k extends Error{constructor(T,D=R.Unknown,y){super(T);this._message=T,this._code=D,this._detail=y,this.isHandled=D===R.NotAvailable&&y===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,k.prototype)}static isTemporarilyNotAvailable(T){return T instanceof k&&T._code===R.TemporarilyNotAvailable}static isNoResolverFound(T){return T instanceof k&&T._code===R.NoResolverFound}static isHandled(T){return T instanceof k&&T.isHandled}}e.RemoteAuthorityResolverError=k}),define(me[84],ge([0,1,10]),function(J,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=e.getRemoteName=e.getRemoteAuthority=void 0;function R(A){return A.scheme===g.Schemas.vscodeRemote?A.authority:void 0}e.getRemoteAuthority=R;function k(A){if(!A)return;const i=A.indexOf("+");return i<0?A:A.substr(0,i)}e.getRemoteName=k;function S(A){return A.scheme!==g.Schemas.file&&A.scheme!==g.Schemas.vscodeRemote}e.isVirtualResource=S;function T(A){if(A.folders.length)return A.folders.every(i=>S(i.uri))?A.folders[0].uri:void 0;if(A.configuration&&S(A.configuration))return A.configuration}e.getVirtualWorkspaceLocation=T;function D(A){return T(A)?.scheme}e.getVirtualWorkspaceScheme=D;function y(A){return T(A)!==void 0}e.isVirtualWorkspace=y}),define(me[193],ge([0,1,3,11,4,12]),function(J,e,g,R,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelProtocol=e.ITunnelService=void 0,e.ITunnelService=(0,k.createDecorator)("tunnelService");var T;(function(m){m.Http="http",m.Https="https"})(T=e.TunnelProtocol||(e.TunnelProtocol={}));var D;(function(m){m[m.Notify=1]="Notify",m[m.OpenBrowser=2]="OpenBrowser",m[m.OpenPreview=3]="OpenPreview",m[m.Silent=4]="Silent",m[m.Ignore=5]="Ignore",m[m.OpenBrowserOnce=6]="OpenBrowserOnce"})(D=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function y(m){if(m.scheme!=="http"&&m.scheme!=="https")return;const l=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(m.authority);if(!!l)return{address:l[1],port:+l[2]}}e.extractLocalHostUriMetaDataForPortMapping=y,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function A(m){return e.LOCALHOST_ADDRESSES.indexOf(m)>=0}e.isLocalhost=A,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function i(m){return e.ALL_INTERFACES_ADDRESSES.indexOf(m)>=0}e.isAllInterfaces=i;function C(m,l){return l?l!==1&&m<1024:!R.isWindows&&m<1024}e.isPortPrivileged=C;let u=class{constructor(l){this.logService=l,this._onTunnelOpened=new g.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new g.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new g.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._canMakePublic=!1}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(l,v){return this._tunnelProvider=l,l?(this._canElevate=v.elevation,this._canMakePublic=v.public,this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._canMakePublic=!1}}):(this._canElevate=!1,this._canMakePublic=!1,this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}get canElevate(){return this._canElevate}get canMakePublic(){return this._canMakePublic}get tunnels(){return new Promise(async l=>{const v=[],_=Array.from(this._tunnels.values());for(let b of _){const P=Array.from(b.values());for(let c of P){const h=await c.value;h&&v.push(h)}}l(v)})}async dispose(){for(const l of this._tunnels.values()){for(const{value:v}of l.values())await v.then(_=>_?.dispose());l.clear()}this._tunnels.clear()}openTunnel(l,v,_,b,P=!1,c=!1,h){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${v}:${_} on local port ${b}.`),!l)return;v||(v="localhost");const p=this.retainOrCreateTunnel(l,v,_,b,P,c,h);return p?p.then(t=>{if(!t){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(v,_);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const r=this.makeTunnel(t);return(t.tunnelRemoteHost!==v||t.tunnelRemotePort!==_)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(r),r}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),p)}makeTunnel(l){return{tunnelRemotePort:l.tunnelRemotePort,tunnelRemoteHost:l.tunnelRemoteHost,tunnelLocalPort:l.tunnelLocalPort,localAddress:l.localAddress,public:l.public,protocol:l.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${l.tunnelRemoteHost}:${l.tunnelRemotePort} `);const v=this._tunnels.get(l.tunnelRemoteHost);if(v){const _=v.get(l.tunnelRemotePort);_&&(_.refcount--,await this.tryDisposeTunnel(l.tunnelRemoteHost,l.tunnelRemotePort,_))}}}}async tryDisposeTunnel(l,v,_){if(_.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${l}:${v}.`);const b=_.value.then(async P=>{P&&(await P.dispose(!0),this._onTunnelClosed.fire({host:P.tunnelRemoteHost,port:P.tunnelRemotePort}))});return this._tunnels.has(l)&&this._tunnels.get(l).delete(v),b}}async closeTunnel(l,v){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${l}:${v} `);const _=this._tunnels.get(l);if(_&&_.has(v)){const b=_.get(v);b.refcount=0,await this.tryDisposeTunnel(l,v,b)}}addTunnelToMap(l,v,_){this._tunnels.has(l)||this._tunnels.set(l,new Map),this._tunnels.get(l).set(v,{refcount:1,value:_})}async removeEmptyTunnelFromMap(l,v){const _=this._tunnels.get(l);_&&(await _.get(v)||_.delete(v),_.size===0&&this._tunnels.delete(l))}getTunnelFromMap(l,v){let _=[l];A(l)?(_.push(...e.LOCALHOST_ADDRESSES),_.push(...e.ALL_INTERFACES_ADDRESSES)):i(l)&&_.push(...e.ALL_INTERFACES_ADDRESSES);const b=_.map(P=>this._tunnels.get(P));for(const P of b){const c=P?.get(v);if(c)return c}}canTunnel(l){return!!y(l)}createWithProvider(l,v,_,b,P,c,h){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${v}:${_} on local port ${b}.`);const t={elevationRequired:P?C(b===void 0?_:b):!1},r={remoteAddress:{host:v,port:_},localAddressPort:b,public:c,protocol:h},s=l.forwardPort(r,t);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),s&&this.addTunnelToMap(v,_,s),s}};u=Ve([$e(0,S.ILogService)],u),e.AbstractTunnelService=u}),define(me[194],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class g{vsda(){return new Promise((k,S)=>J(["vsda"],k,S))}async sign(k){try{const S=await this.vsda(),T=new S.signer;if(T)return T.sign(k)}catch(S){}return k}}e.SignService=g}),define(me[195],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class g{constructor(k){this._callback=k,this._terminalBufferMap=new Map}dispose(){for(const k of this._terminalBufferMap.values())k.dispose()}startBuffering(k,S,T=5){let D;return D=S(y=>{const A=typeof y=="string"?y:y.data;let i=this._terminalBufferMap.get(k);if(i){i.data.push(A);return}const C=setTimeout(()=>this.flushBuffer(k),T);i={data:[A],timeoutId:C,dispose:()=>{clearTimeout(C),this.flushBuffer(k),D.dispose()}},this._terminalBufferMap.set(k,i)}),D}stopBuffering(k){const S=this._terminalBufferMap.get(k);S&&S.dispose()}flushBuffer(k){const S=this._terminalBufferMap.get(k);S&&(this._terminalBufferMap.delete(k),this._callback(k,S.data.join("")))}}e.TerminalDataBufferer=g}),define(me[196],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var g;(function(R){R.DARK="dark",R.LIGHT="light",R.HIGH_CONTRAST="hc"})(g=e.ColorScheme||(e.ColorScheme={}))}),define(me[85],ge([0,1,4,6,34,3,196,47]),function(J,e,g,R,k,S,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,g.createDecorator)("themeService");var y;(function(_){function b(P){return P&&typeof P=="object"&&typeof P.id=="string"}_.isThemeColor=b})(y=e.ThemeColor||(e.ThemeColor={}));function A(_){return{id:_}}e.themeColorFromId=A;var i;(function(_){function b(r){return r&&typeof r=="object"&&typeof r.id=="string"&&(typeof r.color=="undefined"||y.isThemeColor(r.color))}_.isThemeIcon=b;const P=new RegExp(`^\\$\\((${D.CSSIcon.iconNameExpression}(?:${D.CSSIcon.iconModifierExpression})?)\\)$`);function c(r){const s=P.exec(r);if(!s)return;let[,n]=s;return{id:n}}_.fromString=c;function h(r,s){let n=r.id;const a=n.lastIndexOf("~");return a!==-1&&(n=n.substring(0,a)),s&&(n=`${n}~${s}`),{id:n}}_.modify=h;function p(r,s){return r.id===s.id&&r.color?.id===s.color?.id}_.isEqual=p;function t(r,s){return{id:r.id,color:s?A(s):void 0}}_.asThemeIcon=t,_.asClassNameArray=D.CSSIcon.asClassNameArray,_.asClassName=D.CSSIcon.asClassName,_.asCSSSelector=D.CSSIcon.asCSSSelector})(i=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=D.Codicon.file,e.FolderThemeIcon=D.Codicon.folder;function C(_){switch(_){case T.ColorScheme.DARK:return"vs-dark";case T.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=C,e.Extensions={ThemingContribution:"base.contributions.theming"};class u{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new S.Emitter}onColorThemeChange(b){return this.themingParticipants.push(b),this.onThemingParticipantAddedEmitter.fire(b),(0,R.toDisposable)(()=>{const P=this.themingParticipants.indexOf(b);this.themingParticipants.splice(P,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let m=new u;k.Registry.add(e.Extensions.ThemingContribution,m);function l(_){return m.onColorThemeChange(_)}e.registerThemingParticipant=l;class v extends R.Disposable{constructor(b){super();this.themeService=b,this.theme=b.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(P=>this.onThemeChange(P)))}onThemeChange(b){this.theme=b,this.updateStyles()}updateStyles(){}getColor(b,P){let c=this.theme.getColor(b);return c&&P&&(c=P(c,this.theme)),c?c.toString():null}}e.Themable=v}),define(me[197],ge([0,1,34,85,3,161,119,16,47]),function(J,e,g,R,k,S,T,D,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.syncing=e.gotoNextLocation=e.gotoPreviousLocation=e.widgetClose=e.iconsSchemaId=e.getIconRegistry=e.registerIcon=e.Extensions=void 0,e.Extensions={IconContribution:"base.contributions.icons"};class A{constructor(){this._onDidChange=new k.Emitter,this.onDidChange=this._onDidChange.event,this.iconSchema={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,S.localize)(0,null)},fontCharacter:{type:"string",description:(0,S.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.iconReferenceSchema={type:"string",pattern:`^${y.CSSIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.iconsById={},this.iconFontsById={}}registerIcon(b,P,c,h){const p=this.iconsById[b];if(p){if(c&&!p.description){p.description=c,this.iconSchema.properties[b].markdownDescription=`${c} $(${b})`;const s=this.iconReferenceSchema.enum.indexOf(b);s!==-1&&(this.iconReferenceSchema.enumDescriptions[s]=c),this._onDidChange.fire()}return p}let t={id:b,description:c,defaults:P,deprecationMessage:h};this.iconsById[b]=t;let r={$ref:"#/definitions/icons"};return h&&(r.deprecationMessage=h),c&&(r.markdownDescription=`${c}: $(${b})`),this.iconSchema.properties[b]=r,this.iconReferenceSchema.enum.push(b),this.iconReferenceSchema.enumDescriptions.push(c||""),this._onDidChange.fire(),{id:b}}deregisterIcon(b){delete this.iconsById[b],delete this.iconSchema.properties[b];const P=this.iconReferenceSchema.enum.indexOf(b);P!==-1&&(this.iconReferenceSchema.enum.splice(P,1),this.iconReferenceSchema.enumDescriptions.splice(P,1)),this._onDidChange.fire()}getIcons(){return Object.keys(this.iconsById).map(b=>this.iconsById[b])}getIcon(b){return this.iconsById[b]}getIconSchema(){return this.iconSchema}getIconReferenceSchema(){return this.iconReferenceSchema}registerIconFont(b,P){const c=this.iconFontsById[b];if(c)return c;let h={id:b,definition:P};return this.iconFontsById[b]=h,this._onDidChange.fire(),h}deregisterIconFont(b){delete this.iconFontsById[b]}getIconFonts(){return Object.keys(this.iconFontsById).map(b=>this.iconFontsById[b])}getIconFont(b){return this.iconFontsById[b]}toString(){const b=(p,t)=>p.id.localeCompare(t.id),P=p=>{for(;R.ThemeIcon.isThemeIcon(p.defaults);)p=this.iconsById[p.defaults.id];return`codicon codicon-${p?p.id:""}`};let c=[];c.push("| preview     | identifier                        | default codicon ID                | description"),c.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const h=Object.keys(this.iconsById).map(p=>this.iconsById[p]);for(const p of h.filter(t=>!!t.description).sort(b))c.push(`|<i class="${P(p)}"></i>|${p.id}|${R.ThemeIcon.isThemeIcon(p.defaults)?p.defaults.id:p.id}|${p.description||""}|`);c.push("| preview     | identifier                        "),c.push("| ----------- | --------------------------------- |");for(const p of h.filter(t=>!R.ThemeIcon.isThemeIcon(t.defaults)).sort(b))c.push(`|<i class="${P(p)}"></i>|${p.id}|`);return c.join(`
`)}}const i=new A;g.Registry.add(e.Extensions.IconContribution,i);function C(_,b,P,c){return i.registerIcon(_,b,P,c)}e.registerIcon=C;function u(){return i}e.getIconRegistry=u;function m(){for(const _ of y.iconRegistry.all)i.registerIcon(_.id,_.definition,_.description);y.iconRegistry.onDidRegister(_=>i.registerIcon(_.id,_.definition,_.description))}m(),e.iconsSchemaId="vscode://schemas/icons";let l=g.Registry.as(T.Extensions.JSONContribution);l.registerSchema(e.iconsSchemaId,i.getIconSchema());const v=new D.RunOnceScheduler(()=>l.notifySchemaChanged(e.iconsSchemaId),200);i.onDidChange(()=>{v.isScheduled()||v.schedule()}),e.widgetClose=C("widget-close",y.Codicon.close,(0,S.localize)(2,null)),e.gotoPreviousLocation=C("goto-previous-location",y.Codicon.arrowUp,(0,S.localize)(3,null)),e.gotoNextLocation=C("goto-next-location",y.Codicon.arrowDown,(0,S.localize)(4,null)),e.syncing=R.ThemeIcon.modify(y.Codicon.sync,"spin")}),define(me[43],ge([0,1,2,23,4,22]),function(J,e,g,R,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,k.createDecorator)("contextService");var T;(function(u){u[u.EMPTY=1]="EMPTY",u[u.FOLDER=2]="FOLDER",u[u.WORKSPACE=3]="WORKSPACE"})(T=e.WorkbenchState||(e.WorkbenchState={}));function D(u){const m=u;return!!(m&&typeof m=="object"&&typeof m.id=="string"&&Array.isArray(m.folders))}e.isWorkspace=D;function y(u){const m=u;return!!(m&&typeof m=="object"&&g.URI.isUri(m.uri)&&typeof m.name=="string"&&typeof m.toResource=="function")}e.isWorkspaceFolder=y;class A{constructor(m,l,v,_){this._id=m,this._configuration=v,this._ignorePathCasing=_,this._foldersMap=S.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=l}update(m){this._id=m.id,this._configuration=m.configuration,this._ignorePathCasing=m._ignorePathCasing,this.folders=m.folders}get folders(){return this._folders}set folders(m){this._folders=m,this.updateFoldersMap()}get id(){return this._id}get configuration(){return this._configuration}set configuration(m){this._configuration=m}getFolder(m){return m&&this._foldersMap.findSubstr(m.with({scheme:m.scheme,authority:m.authority,path:m.path}))||null}updateFoldersMap(){this._foldersMap=S.TernarySearchTree.forUris(this._ignorePathCasing);for(const m of this.folders)this._foldersMap.set(m.uri,m)}toJSON(){return{id:this.id,folders:this.folders,configuration:this.configuration}}}e.Workspace=A;class i{constructor(m,l){this.raw=l,this.uri=m.uri,this.index=m.index,this.name=m.name}toResource(m){return(0,R.joinPath)(this.uri,m)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=i;function C(u){return new i({uri:u,index:0,name:(0,R.basenameOrAuthority)(u)},{uri:u.toString()})}e.toWorkspaceFolder=C}),define(me[198],ge([0,1,4,162,43,2,11,9,23,138,57,10,77,29,84]),function(J,e,g,R,k,S,T,D,y,A,i,C,u,m,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.useSlashForPath=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isRawUriWorkspaceFolder=e.isRawFileWorkspaceFolder=e.isStoredWorkspaceFolder=e.isUntitledWorkspace=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=e.hasWorkspaceFileExtension=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=void 0,e.WORKSPACE_EXTENSION="code-workspace";const v=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:(0,R.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function _(N){return(typeof N=="string"?(0,D.extname)(N):(0,y.extname)(N))===v}e.hasWorkspaceFileExtension=_,e.IWorkspacesService=(0,g.createDecorator)("workspacesService");function b(N){return N.hasOwnProperty("workspace")}e.isRecentWorkspace=b;function P(N){return N.hasOwnProperty("folderUri")}e.isRecentFolder=P;function c(N){return N.hasOwnProperty("fileUri")}e.isRecentFile=c;function h(N){const x=N;return typeof x?.id=="string"&&S.URI.isUri(x.uri)}e.isSingleFolderWorkspaceIdentifier=h;function p(N){if(N.configuration)return{id:N.id,configPath:N.configuration};if(N.folders.length===1)return{id:N.id,uri:N.folders[0].uri}}e.toWorkspaceIdentifier=p;function t(N){const x=N;return typeof x?.id=="string"&&S.URI.isUri(x.configPath)}e.isWorkspaceIdentifier=t;function r(N){const x=N;if(x?.uri)return{id:x.id,uri:S.URI.revive(x.uri)};const F=N;if(F?.configPath)return{id:F.id,configPath:S.URI.revive(F.configPath)};if(N?.id)return{id:N.id}}e.reviveIdentifier=r;function s(N,x){return y.extUriBiasedIgnorePathCase.isEqualOrParent(N,x.untitledWorkspacesHome)}e.isUntitledWorkspace=s;function n(N){return a(N)||d(N)}e.isStoredWorkspaceFolder=n;function a(N){const x=N;return typeof x?.path=="string"&&(!x.name||typeof x.name=="string")}e.isRawFileWorkspaceFolder=a;function d(N){const x=N;return typeof x?.uri=="string"&&(!x.name||typeof x.name=="string")}e.isRawUriWorkspaceFolder=d;function f(N,x,F,z,M=!T.isWindows,O){if(N.scheme!==z.scheme)return{name:F,uri:N.toString(!0)};let q=x?void 0:O.relativePath(z,N);if(q!==void 0)q.length===0?q=".":T.isWindows&&N.scheme===C.Schemas.file&&!M&&(q=q.replace(/\//g,"\\"));else if(N.scheme===C.Schemas.file)q=N.fsPath,T.isWindows&&(q=(0,u.normalizeDriveLetter)(q),M&&(q=(0,m.toSlashes)(q)));else{if(!O.isEqualAuthority(N.authority,z.authority))return{name:F,uri:N.toString(!0)};q=N.path}return{name:F,path:q}}e.getStoredWorkspaceFolder=f;function w(N,x,F){let z=[],M=new Set;const O=F.dirname(x);for(let q of N){let B;if(a(q))q.path&&(B=F.resolvePath(O,q.path));else if(d(q))try{B=S.URI.parse(q.uri),B.path[0]!=="/"&&(B=B.with({path:"/"+B.path}))}catch(G){console.warn(G)}if(B){let G=F.getComparisonKey(B);if(!M.has(G)){M.add(G);const ie=q.name||F.basenameOrAuthority(B);z.push(new k.WorkspaceFolder({uri:B,name:ie,index:z.length},q))}}}return z}e.toWorkspaceFolders=w;function E(N,x,F,z,M){let O=o(x,N);const q=M.dirname(x),B=M.dirname(z),G=[],ie=I(O.folders);for(const Le of O.folders){const qe=a(Le)?M.resolvePath(q,Le.path):S.URI.parse(Le.uri);let We;F?We=!1:We=!a(Le)||(0,D.isAbsolute)(Le.path),G.push(f(qe,We,Le.name,B,ie,M))}const he={insertSpaces:!1,tabSize:4,eol:T.isLinux||T.isMacintosh?`
`:`\r
`},ye=A.setProperty(N,["folders"],G,he);let Ie=A.applyEdits(N,ye);return O.remoteAuthority===(0,l.getRemoteAuthority)(z)&&(Ie=A.applyEdits(Ie,A.removeProperty(Ie,["remoteAuthority"],he))),Ie}e.rewriteWorkspaceFileForNewLocation=E;function o(N,x){let F=i.parse(x);if(F&&Array.isArray(F.folders))F.folders=F.folders.filter(z=>n(z));else throw new Error(`${N} looks like an invalid workspace file.`);return F}function I(N){return T.isWindows?N.some(x=>a(x)&&x.path.indexOf("/")>=0):!0}e.useSlashForPath=I;function L(N){return N.workspace&&typeof N.workspace=="object"&&typeof N.workspace.id=="string"&&typeof N.workspace.configPath=="string"}function U(N){return typeof N.folderUri=="string"}function V(N){return typeof N.fileUri=="string"}function ee(N,x){const F={workspaces:[],files:[]};if(N){const z=function(O,q){for(let B=0;B<O.length;B++)try{q(O[B],B)}catch(G){x.warn(`Error restoring recent entry ${JSON.stringify(O[B])}: ${G.toString()}. Skip entry.`)}},M=N;if(Array.isArray(M.entries))z(M.entries,O=>{const q=O.label,B=O.remoteAuthority;L(O)?F.workspaces.push({label:q,remoteAuthority:B,workspace:{id:O.workspace.id,configPath:S.URI.parse(O.workspace.configPath)}}):U(O)?F.workspaces.push({label:q,remoteAuthority:B,folderUri:S.URI.parse(O.folderUri)}):V(O)&&F.files.push({label:q,remoteAuthority:B,fileUri:S.URI.parse(O.fileUri)})});else{const O=N;Array.isArray(O.workspaces3)&&z(O.workspaces3,(q,B)=>{const G=Array.isArray(O.workspaceLabels)&&O.workspaceLabels[B]||void 0;typeof q=="object"&&typeof q.id=="string"&&typeof q.configURIPath=="string"?F.workspaces.push({label:G,workspace:{id:q.id,configPath:S.URI.parse(q.configURIPath)}}):typeof q=="string"&&F.workspaces.push({label:G,folderUri:S.URI.parse(q)})}),Array.isArray(O.files2)&&z(O.files2,(q,B)=>{const G=Array.isArray(O.fileLabels)&&O.fileLabels[B]||void 0;typeof q=="string"&&F.files.push({label:G,fileUri:S.URI.parse(q)})})}}return F}e.restoreRecentlyOpened=ee;function K(N){const x={entries:[]};for(const F of N.workspaces)P(F)?x.entries.push({folderUri:F.folderUri.toString(),label:F.label,remoteAuthority:F.remoteAuthority}):x.entries.push({workspace:{id:F.workspace.id,configPath:F.workspace.configPath.toString()},label:F.label,remoteAuthority:F.remoteAuthority});for(const F of N.files)x.entries.push({fileUri:F.fileUri.toString(),label:F.label,remoteAuthority:F.remoteAuthority});return x}e.toStoreData=K}),define(me[86],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class g{constructor(k){this.id=k,this._data=new Map,this._idPool=1}add(k){const S=this._idPool++;return this._data.set(S,k),this.logDebugInfo(),S}get(k,S){return this._data.has(k)?this._data.get(k)[S]:void 0}delete(k){this._data.delete(k),this.logDebugInfo()}logDebugInfo(){!g.enableDebugLogging||console.log(`${this.id} cache size \u2014 ${this._data.size}`)}}e.Cache=g,g.enableDebugLogging=!1}),define(me[51],ge([0,1,2,3,4]),function(J,e,g,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,k.createDecorator)("IExtHostEditorTabs");class S{constructor(){this._onDidChangeTabs=new R.Emitter,this.onDidChangeTabs=this._onDidChangeTabs.event,this._tabs=[]}get tabs(){return this._tabs}$acceptEditorTabs(D){this._tabs=D.map(y=>({name:y.name,group:y.group,resource:g.URI.revive(y.resource),isActive:y.isActive})),this._onDidChangeTabs.fire()}}e.ExtHostEditorTabs=S}),define(me[62],ge([0,1,10,4]),function(J,e,g,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class k{constructor(){this._systemSchemes=new Set(Object.keys(g.Schemas)),this._providerInfo=new Map}$acceptProviderInfos(T,D){D===null?this._providerInfo.delete(T):this._providerInfo.set(T,D)}isFreeScheme(T){return!this._providerInfo.has(T)&&!this._systemSchemes.has(T)}getCapabilities(T){return this._providerInfo.get(T)}}e.ExtHostFileSystemInfo=k,e.IExtHostFileSystemInfo=(0,R.createDecorator)("IExtHostFileSystemInfo")}),define(me[27],ge([0,1,4]),function(J,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,g.createDecorator)("IExtHostInitDataService")}),define(me[199],ge([0,1,16]),function(J,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class R{constructor(T,D,y){this._deferredPromises=new Map,this._id=T,this._shared=D,this._storage=y,this._init=this._storage.getValue(this._shared,this._id,Object.create(null)).then(A=>(this._value=A,this)),this._storageListener=this._storage.onDidChangeStorage(A=>{A.shared===this._shared&&A.key===this._id&&(this._value=A.value)}),this._scheduler=new g.RunOnceScheduler(()=>{const A=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const i of A.values())i.complete()}catch(i){for(const C of A.values())C.error(i)}})()},0)}keys(){return Object.entries(this._value??{}).filter(([,T])=>T!==void 0).map(([T])=>T)}get whenReady(){return this._init}get(T,D){let y=this._value[T];return typeof y=="undefined"&&(y=D),y}update(T,D){this._value[T]=D;let y=this._deferredPromises.get(T);if(y!==void 0)return y.p;const A=new g.DeferredPromise;return this._deferredPromises.set(T,A),this._scheduler.isScheduled()||this._scheduler.schedule(),A.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=R;class k extends R{constructor(T,D){super(T.identifier.value,!0,D);this._extension=T}setKeysForSync(T){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},T)}}e.ExtensionGlobalMemento=k}),define(me[200],ge([0,1,3,2,12]),function(J,e,g,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;let S=class{constructor(D,y){this._logService=D,this._notebooksAndEditors=y,this._onDidChangeNotebookDocumentMetadata=new g.Emitter,this.onDidChangeNotebookDocumentMetadata=this._onDidChangeNotebookDocumentMetadata.event,this._onDidSaveNotebookDocument=new g.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event}$acceptModelChanged(D,y,A){this._notebooksAndEditors.getNotebookDocument(R.URI.revive(D)).acceptModelChanged(y,A)}$acceptDirtyStateChanged(D,y){this._notebooksAndEditors.getNotebookDocument(R.URI.revive(D)).acceptDirty(y)}$acceptModelSaved(D){const y=this._notebooksAndEditors.getNotebookDocument(R.URI.revive(D));this._onDidSaveNotebookDocument.fire(y.apiNotebook)}$acceptDocumentPropertiesChanged(D,y){this._logService.debug("ExtHostNotebook#$acceptDocumentPropertiesChanged",D.path,y);const A=this._notebooksAndEditors.getNotebookDocument(R.URI.revive(D));A.acceptDocumentPropertiesChanged(y),y.metadata&&this._onDidChangeNotebookDocumentMetadata.fire({document:A.apiNotebook})}};S=Ve([$e(0,k.ILogService)],S),e.ExtHostNotebookDocuments=S}),define(me[13],ge([0,1,4]),function(J,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,g.createDecorator)("IExtHostRpcService");class R{constructor(S){this.getProxy=S.getProxy.bind(S),this.set=S.set.bind(S),this.assertRegistered=S.assertRegistered.bind(S),this.drain=S.drain.bind(S)}}e.ExtHostRpcService=R});var it=this&&this.__classPrivateFieldSet||function(J,e,g,R,k){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!k:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?k.call(J,g):k?k.value=g:e.set(J,g),g},He=this&&this.__classPrivateFieldGet||function(J,e,g,R){if(g==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!R:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?R:g==="a"?R.call(J):R?R.value:e.get(J)};define(me[201],ge([0,1,26,3]),function(J,e,g,R){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class S{constructor(D,y){k.set(this,void 0),this._onDidChange=new R.Emitter,this.onDidChange=this._onDidChange.event,this._id=g.ExtensionIdentifier.toKey(D.identifier),it(this,k,y,"f"),He(this,k,"f").onDidChangePassword(A=>{A.extensionId===this._id&&this._onDidChange.fire({key:A.key})})}get(D){return He(this,k,"f").get(this._id,D)}store(D,y){return He(this,k,"f").store(this._id,D,y)}delete(D){return He(this,k,"f").delete(this._id,D)}}e.ExtensionSecrets=S,k=new WeakMap}),define(me[122],ge([0,1,4,3]),function(J,e,g,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.ExtHostTelemetry=void 0;class k{constructor(){this._onDidChangeTelemetryEnabled=new R.Emitter,this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._enabled=!1}getTelemetryEnabled(){return this._enabled}$initializeTelemetryEnabled(T){this._enabled=T}$onDidChangeTelemetryEnabled(T){this._enabled=T,this._onDidChangeTelemetryEnabled.fire(T)}}e.ExtHostTelemetry=k,e.IExtHostTelemetry=(0,g.createDecorator)("IExtHostTelemetry")}),define(me[87],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestItemRootImpl=e.TestItemImpl=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.diffTestItems=e.getPrivateApiFor=e.createPrivateApiFor=e.ExtHostTestItemEventOp=void 0;var g;(function(P){P[P.Upsert=0]="Upsert",P[P.RemoveChild=1]="RemoveChild",P[P.Invalidated=2]="Invalidated",P[P.SetProp=3]="SetProp",P[P.Bulk=4]="Bulk"})(g=e.ExtHostTestItemEventOp||(e.ExtHostTestItemEventOp={}));const R=new WeakMap,k=(P,c)=>{const h={controllerId:c};return R.set(P,h),h};e.createPrivateApiFor=k;const S=P=>R.get(P);e.getPrivateApiFor=S;const T=(P,c,h,p)=>{let t=h;return{enumerable:!0,configurable:!1,get(){return t},set(r){p(t,r)||(t=r,P.listener?.({op:3,key:c,value:r}))}}},D=(P,c)=>P===c,y={range:(P,c)=>P===c?!0:!P||!c?!1:P.isEqual(c),label:D,description:D,busy:D,error:D,canResolveChildren:D},A=Object.keys(y),i=(P,c)=>({range:T(P,"range",void 0,y.range),label:T(P,"label",c,y.label),description:T(P,"description",void 0,y.description),canResolveChildren:T(P,"canResolveChildren",!1,y.canResolveChildren),busy:T(P,"busy",!1,y.busy),error:T(P,"error",void 0,y.error)}),C=(P,c)=>{const h=new Map;for(const p of A)y[p](P[p],c[p])||h.set(p,c[p]);return h};e.diffTestItems=C;class u extends Error{constructor(c){super(`Attempted to insert a duplicate test item ID ${c}`)}}e.DuplicateTestItemError=u;class m extends Error{constructor(c){super(`TestItem with ID "${c}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=m;class l extends Error{constructor(c,h,p){super(`TestItem with ID "${c}" is from controller "${h}" and cannot be added as a child of an item from controller "${p}".`)}}e.MixedTestItemController=l;const v=P=>{const c=(0,e.getPrivateApiFor)(P);let h=new Map;return{get size(){return h.size},forEach(p,t){for(const r of h.values())p.call(t,r,this)},replace(p){const t=new Map,r=new Set(h.keys()),s={op:4,ops:[]};for(const n of p){if(!(n instanceof _))throw new m(n.id);const a=(0,e.getPrivateApiFor)(n).controllerId;if(a!==c.controllerId)throw new l(n.id,a,c.controllerId);if(t.has(n.id))throw new u(n.id);t.set(n.id,n),r.delete(n.id),s.ops.push({op:0,item:n})}for(const n of r.keys())s.ops.push({op:1,id:n});c.listener?.(s),h=t},add(p){if(!(p instanceof _))throw new m(p.id);h.set(p.id,p),c.listener?.({op:0,item:p})},delete(p){h.delete(p)&&c.listener?.({op:1,id:p})},get(p){return h.get(p)},toJSON(){return Array.from(h.values())},[Symbol.iterator](){return h.values()}}};class _{constructor(c,h,p,t){if(h.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(h)} symbol`);const r=(0,e.createPrivateApiFor)(this,c);Object.defineProperties(this,{id:{value:h,enumerable:!0,writable:!1},uri:{value:t,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return r.parent instanceof b?void 0:r.parent}},children:{value:v(this),enumerable:!0,writable:!1},...i(r,p)})}invalidateResults(){(0,e.getPrivateApiFor)(this).listener?.({op:2})}}e.TestItemImpl=_;class b extends _{constructor(c,h){super(c,c,h,void 0)}}e.TestItemRootImpl=b}),define(me[52],ge([0,1,4,3,13]),function(J,e,g,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDto=void 0;var S;(function(D){function y(i){return{remoteAddress:i.remoteAddress,localAddress:i.localAddress,public:!!i.public,protocol:i.protocol}}D.fromApiTunnel=y;function A(i){return{remoteAddress:{host:i.tunnelRemoteHost,port:i.tunnelRemotePort},localAddress:i.localAddress,public:i.public,protocol:i.protocol}}D.fromServiceTunnel=A})(S=e.TunnelDto||(e.TunnelDto={})),e.IExtHostTunnelService=(0,g.createDecorator)("IExtHostTunnelService");let T=class{constructor(y){this.onDidChangeTunnels=new R.Emitter().event}async $applyCandidateFilter(y){return y}async openTunnel(y,A){}async getTunnels(){return[]}async setTunnelExtensionFunctions(y){return{dispose:()=>{}}}registerPortsAttributesProvider(y,A){return{dispose:()=>{}}}async $providePortAttributes(y,A,i,C,u){return[]}async $forwardPort(y,A){}async $closeTunnel(y){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};T=Ve([$e(0,k.IExtHostRpcService)],T),e.ExtHostTunnelService=T});var it=this&&this.__classPrivateFieldSet||function(J,e,g,R,k){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!k:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?k.call(J,g):k?k.value=g:e.set(J,g),g},He=this&&this.__classPrivateFieldGet||function(J,e,g,R){if(g==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!R:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?R:g==="a"?R.call(J):R?R.value:e.get(J)};define(me[7],ge([0,1,20,15,99,22,102,14,2,32,42,121]),function(J,e,g,R,k,S,T,D,y,A,i,C){"use strict";var u,m,l,v,_,b,P,c,h,p,t,r,s,n,a,d,f,w,E,o;Object.defineProperty(e,"__esModule",{value:!0}),e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestMessage=e.TestRunRequest=e.TestRunProfileKind=e.TestMessageSeverity=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookRendererScript=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.QuickInputButtons=e.DebugConfigurationProviderTriggerKind=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.TreeItemCollapsibleState=e.TreeItem=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLink=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestions=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function I(H){function $(){return Reflect.construct(H,arguments,this.constructor)}return Object.defineProperty($,"name",Object.getOwnPropertyDescriptor(H,"name")),Object.setPrototypeOf($,H),Object.setPrototypeOf($.prototype,H.prototype),$}let L=_=class{constructor($){u.set(this,void 0),it(this,u,$,"f")}static from(...$){let oe=$;return new _(function(){if(oe){for(const ke of oe)ke&&typeof ke.dispose=="function"&&ke.dispose();oe=void 0}})}dispose(){typeof He(this,u,"f")=="function"&&(He(this,u,"f").call(this),it(this,u,void 0,"f"))}};u=new WeakMap,L=_=Ve([I],L),e.Disposable=L;let U=b=class{constructor($,oe){if($<0)throw(0,R.illegalArgument)("line must be non-negative");if(oe<0)throw(0,R.illegalArgument)("character must be non-negative");this._line=$,this._character=oe}static Min(...$){if($.length===0)throw new TypeError;let oe=$[0];for(let ke=1;ke<$.length;ke++){const Xe=$[ke];Xe.isBefore(oe)&&(oe=Xe)}return oe}static Max(...$){if($.length===0)throw new TypeError;let oe=$[0];for(let ke=1;ke<$.length;ke++){const Xe=$[ke];Xe.isAfter(oe)&&(oe=Xe)}return oe}static isPosition($){if(!$)return!1;if($ instanceof b)return!0;let{line:oe,character:ke}=$;return typeof oe=="number"&&typeof ke=="number"}get line(){return this._line}get character(){return this._character}isBefore($){return this._line<$._line?!0:$._line<this._line?!1:this._character<$._character}isBeforeOrEqual($){return this._line<$._line?!0:$._line<this._line?!1:this._character<=$._character}isAfter($){return!this.isBeforeOrEqual($)}isAfterOrEqual($){return!this.isBefore($)}isEqual($){return this._line===$._line&&this._character===$._character}compareTo($){return this._line<$._line?-1:this._line>$.line?1:this._character<$._character?-1:this._character>$._character?1:0}translate($,oe=0){if($===null||oe===null)throw(0,R.illegalArgument)();let ke;return typeof $=="undefined"?ke=0:typeof $=="number"?ke=$:(ke=typeof $.lineDelta=="number"?$.lineDelta:0,oe=typeof $.characterDelta=="number"?$.characterDelta:0),ke===0&&oe===0?this:new b(this.line+ke,this.character+oe)}with($,oe=this.character){if($===null||oe===null)throw(0,R.illegalArgument)();let ke;return typeof $=="undefined"?ke=this.line:typeof $=="number"?ke=$:(ke=typeof $.line=="number"?$.line:this.line,oe=typeof $.character=="number"?$.character:this.character),ke===this.line&&oe===this.character?this:new b(ke,oe)}toJSON(){return{line:this.line,character:this.character}}};U=b=Ve([I],U),e.Position=U;let V=P=class{constructor($,oe,ke,Xe){let nt,rt;if(typeof $=="number"&&typeof oe=="number"&&typeof ke=="number"&&typeof Xe=="number"?(nt=new U($,oe),rt=new U(ke,Xe)):$ instanceof U&&oe instanceof U&&(nt=$,rt=oe),!nt||!rt)throw new Error("Invalid arguments");nt.isBefore(rt)?(this._start=nt,this._end=rt):(this._start=rt,this._end=nt)}static isRange($){return $ instanceof P?!0:$?U.isPosition($.start)&&U.isPosition($.end):!1}get start(){return this._start}get end(){return this._end}contains($){return $ instanceof P?this.contains($._start)&&this.contains($._end):$ instanceof U?!($.isBefore(this._start)||this._end.isBefore($)):!1}isEqual($){return this._start.isEqual($._start)&&this._end.isEqual($._end)}intersection($){const oe=U.Max($.start,this._start),ke=U.Min($.end,this._end);if(!oe.isAfter(ke))return new P(oe,ke)}union($){if(this.contains($))return this;if($.contains(this))return $;const oe=U.Min($.start,this._start),ke=U.Max($.end,this.end);return new P(oe,ke)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with($,oe=this.end){if($===null||oe===null)throw(0,R.illegalArgument)();let ke;return $?U.isPosition($)?ke=$:(ke=$.start||this.start,oe=$.end||this.end):ke=this.start,ke.isEqual(this._start)&&oe.isEqual(this.end)?this:new P(ke,oe)}toJSON(){return[this.start,this.end]}};V=P=Ve([I],V),e.Range=V;let ee=c=class extends V{constructor($,oe,ke,Xe){let nt,rt;if(typeof $=="number"&&typeof oe=="number"&&typeof ke=="number"&&typeof Xe=="number"?(nt=new U($,oe),rt=new U(ke,Xe)):$ instanceof U&&oe instanceof U&&(nt=$,rt=oe),!nt||!rt)throw new Error("Invalid arguments");super(nt,rt);this._anchor=nt,this._active=rt}static isSelection($){return $ instanceof c?!0:$?V.isRange($)&&U.isPosition($.anchor)&&U.isPosition($.active)&&typeof $.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};ee=c=Ve([I],ee),e.Selection=ee;class K{constructor($,oe,ke){if(typeof $!="string"||$.length===0)throw(0,R.illegalArgument)("host");if(typeof oe!="number"||oe===0||Math.round(oe)!==oe)throw(0,R.illegalArgument)("port");if(typeof ke!="undefined"&&(typeof ke!="string"||ke.length===0||!/^[0-9A-Za-z\-]+$/.test(ke)))throw(0,R.illegalArgument)("connectionToken");this.host=$,this.port=Math.round(oe),this.connectionToken=ke}}e.ResolvedAuthority=K;class N extends Error{constructor($,oe=C.RemoteAuthorityResolverErrorCode.Unknown,ke){super($);this._message=$,this._code=oe,this._detail=ke,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,N.prototype)}static NotAvailable($,oe){return new N($,C.RemoteAuthorityResolverErrorCode.NotAvailable,oe)}static TemporarilyNotAvailable($){return new N($,C.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}}e.RemoteAuthorityResolverError=N;var x;(function(H){H[H.LF=1]="LF",H[H.CRLF=2]="CRLF"})(x=e.EndOfLine||(e.EndOfLine={}));var F;(function(H){H[H.Replace=1]="Replace",H[H.Append=2]="Append",H[H.Prepend=3]="Prepend"})(F=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let z=h=class{constructor($,oe){this._range=$,this._newText=oe}static isTextEdit($){return $ instanceof h?!0:$?V.isRange($)&&typeof $.newText=="string":!1}static replace($,oe){return new h($,oe)}static insert($,oe){return h.replace(new V($,$),oe)}static delete($){return h.replace($,"")}static setEndOfLine($){const oe=new h(new V(new U(0,0),new U(0,0)),"");return oe.newEol=$,oe}get range(){return this._range}set range($){if($&&!V.isRange($))throw(0,R.illegalArgument)("range");this._range=$}get newText(){return this._newText||""}set newText($){if($&&typeof $!="string")throw(0,R.illegalArgument)("newText");this._newText=$}get newEol(){return this._newEol}set newEol($){if($&&typeof $!="number")throw(0,R.illegalArgument)("newEol");this._newEol=$}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};z=h=Ve([I],z),e.TextEdit=z;var M;(function(H){H[H.File=1]="File",H[H.Text=2]="Text",H[H.Cell=3]="Cell",H[H.CellReplace=5]="CellReplace"})(M=e.FileEditType||(e.FileEditType={}));let O=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile($,oe,ke,Xe){this._edits.push({_type:1,from:$,to:oe,options:ke,metadata:Xe})}createFile($,oe,ke){this._edits.push({_type:1,from:void 0,to:$,options:oe,metadata:ke})}deleteFile($,oe,ke){this._edits.push({_type:1,from:$,to:void 0,options:oe,metadata:ke})}replaceNotebookMetadata($,oe,ke){this._edits.push({_type:3,metadata:ke,uri:$,edit:{editType:5,metadata:oe},notebookMetadata:oe})}replaceNotebookCells($,oe,ke,Xe,nt){let rt,lt,yt=[],At;if(Bt.isNotebookRange(oe)&&Lt.isNotebookCellDataArray(ke)&&!Lt.isNotebookCellDataArray(Xe)?(rt=oe.start,lt=oe.end,yt=ke,At=Xe):typeof oe=="number"&&typeof ke=="number"&&Lt.isNotebookCellDataArray(Xe)&&(rt=oe,lt=ke,yt=Xe,At=nt),rt===void 0||lt===void 0)throw new Error("Invalid arguments");(rt!==lt||yt.length>0)&&this._edits.push({_type:5,uri:$,index:rt,count:lt-rt,cells:yt,metadata:At})}replaceNotebookCellMetadata($,oe,ke,Xe){this._edits.push({_type:3,metadata:Xe,uri:$,edit:{editType:8,index:oe,metadata:ke}})}replace($,oe,ke,Xe){this._edits.push({_type:2,uri:$,edit:new z(oe,ke),metadata:Xe})}insert($,oe,ke,Xe){this.replace($,new V(oe,oe),ke,Xe)}delete($,oe,ke){this.replace($,oe,"",ke)}has($){return this._edits.some(oe=>oe._type===2&&oe.uri.toString()===$.toString())}set($,oe){if(oe)for(const ke of oe)ke&&this._edits.push({_type:2,uri:$,edit:ke});else{for(let ke=0;ke<this._edits.length;ke++){const Xe=this._edits[ke];Xe._type===2&&Xe.uri.toString()===$.toString()&&(this._edits[ke]=void 0)}(0,g.coalesceInPlace)(this._edits)}}get($){const oe=[];for(let ke of this._edits)ke._type===2&&ke.uri.toString()===$.toString()&&oe.push(ke.edit);return oe}entries(){const $=new S.ResourceMap;for(let oe of this._edits)if(oe._type===2){let ke=$.get(oe.uri);ke||(ke=[oe.uri,[]],$.set(oe.uri,ke)),ke[1].push(oe.edit)}return[...$.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};O=Ve([I],O),e.WorkspaceEdit=O;let q=p=class{constructor($){this._tabstop=1,this.value=$||""}static isSnippetString($){return $ instanceof p?!0:$?typeof $.value=="string":!1}static _escape($){return $.replace(/\$|}|\\/g,"\\$&")}appendText($){return this.value+=p._escape($),this}appendTabstop($=this._tabstop++){return this.value+="$",this.value+=$,this}appendPlaceholder($,oe=this._tabstop++){if(typeof $=="function"){const ke=new p;ke._tabstop=this._tabstop,$(ke),this._tabstop=ke._tabstop,$=ke.value}else $=p._escape($);return this.value+="${",this.value+=oe,this.value+=":",this.value+=$,this.value+="}",this}appendChoice($,oe=this._tabstop++){const ke=$.map(Xe=>Xe.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=oe,this.value+="|",this.value+=ke,this.value+="|}",this}appendVariable($,oe){if(typeof oe=="function"){const ke=new p;ke._tabstop=this._tabstop,oe(ke),this._tabstop=ke._tabstop,oe=ke.value}else typeof oe=="string"&&(oe=oe.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=$,oe&&(this.value+=":",this.value+=oe),this.value+="}",this}};q=p=Ve([I],q),e.SnippetString=q;var B;(function(H){H[H.Unnecessary=1]="Unnecessary",H[H.Deprecated=2]="Deprecated"})(B=e.DiagnosticTag||(e.DiagnosticTag={}));var G;(function(H){H[H.Hint=3]="Hint",H[H.Information=2]="Information",H[H.Warning=1]="Warning",H[H.Error=0]="Error"})(G=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let ie=t=class{constructor($,oe){if(this.uri=$,oe)if(oe instanceof V)this.range=oe;else if(oe instanceof U)this.range=new V(oe,oe);else throw new Error("Illegal argument")}static isLocation($){return $ instanceof t?!0:$?V.isRange($.range)&&y.URI.isUri($.uri):!1}toJSON(){return{uri:this.uri,range:this.range}}};ie=t=Ve([I],ie),e.Location=ie;let he=class{constructor($,oe){this.location=$,this.message=oe}static is($){return $?typeof $.message=="string"&&$.location&&V.isRange($.location.range)&&y.URI.isUri($.location.uri):!1}static isEqual($,oe){return $===oe?!0:!$||!oe?!1:$.message===oe.message&&$.location.range.isEqual(oe.location.range)&&$.location.uri.toString()===oe.location.uri.toString()}};he=Ve([I],he),e.DiagnosticRelatedInformation=he;let ye=class{constructor($,oe,ke=G.Error){if(!V.isRange($))throw new TypeError("range must be set");if(!oe)throw new TypeError("message must be set");this.range=$,this.message=oe,this.severity=ke}toJSON(){return{severity:G[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual($,oe){return $===oe?!0:!$||!oe?!1:$.message===oe.message&&$.severity===oe.severity&&$.code===oe.code&&$.severity===oe.severity&&$.source===oe.source&&$.range.isEqual(oe.range)&&(0,g.equals)($.tags,oe.tags)&&(0,g.equals)($.relatedInformation,oe.relatedInformation,he.isEqual)}};ye=Ve([I],ye),e.Diagnostic=ye;let Ie=class{constructor($,oe){if(!$)throw new Error("Illegal argument, contents must be defined");Array.isArray($)?this.contents=$:this.contents=[$],this.range=oe}};Ie=Ve([I],Ie),e.Hover=Ie;var Le;(function(H){H[H.Text=0]="Text",H[H.Read=1]="Read",H[H.Write=2]="Write"})(Le=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let qe=class{constructor($,oe=Le.Text){this.range=$,this.kind=oe}toJSON(){return{range:this.range,kind:Le[this.kind]}}};qe=Ve([I],qe),e.DocumentHighlight=qe;var We;(function(H){H[H.File=0]="File",H[H.Module=1]="Module",H[H.Namespace=2]="Namespace",H[H.Package=3]="Package",H[H.Class=4]="Class",H[H.Method=5]="Method",H[H.Property=6]="Property",H[H.Field=7]="Field",H[H.Constructor=8]="Constructor",H[H.Enum=9]="Enum",H[H.Interface=10]="Interface",H[H.Function=11]="Function",H[H.Variable=12]="Variable",H[H.Constant=13]="Constant",H[H.String=14]="String",H[H.Number=15]="Number",H[H.Boolean=16]="Boolean",H[H.Array=17]="Array",H[H.Object=18]="Object",H[H.Key=19]="Key",H[H.Null=20]="Null",H[H.EnumMember=21]="EnumMember",H[H.Struct=22]="Struct",H[H.Event=23]="Event",H[H.Operator=24]="Operator",H[H.TypeParameter=25]="TypeParameter"})(We=e.SymbolKind||(e.SymbolKind={}));var je;(function(H){H[H.Deprecated=1]="Deprecated"})(je=e.SymbolTag||(e.SymbolTag={}));let W=r=class{constructor($,oe,ke,Xe,nt){this.name=$,this.kind=oe,this.containerName=nt,typeof ke=="string"&&(this.containerName=ke),Xe instanceof ie?this.location=Xe:ke instanceof V&&(this.location=new ie(Xe,ke)),r.validate(this)}static validate($){if(!$.name)throw new Error("name must not be falsy")}toJSON(){return{name:this.name,kind:We[this.kind],location:this.location,containerName:this.containerName}}};W=r=Ve([I],W),e.SymbolInformation=W;let Z=s=class{constructor($,oe,ke,Xe,nt){this.name=$,this.detail=oe,this.kind=ke,this.range=Xe,this.selectionRange=nt,this.children=[],s.validate(this)}static validate($){if(!$.name)throw new Error("name must not be falsy");if(!$.range.contains($.selectionRange))throw new Error("selectionRange must be contained in fullRange");$.children&&$.children.forEach(s.validate)}};Z=s=Ve([I],Z),e.DocumentSymbol=Z;var ne;(function(H){H[H.Invoke=1]="Invoke",H[H.Automatic=2]="Automatic"})(ne=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let le=class{constructor($,oe){this.title=$,this.kind=oe}};le=Ve([I],le),e.CodeAction=le;let Y=n=class{constructor($){this.value=$}append($){return new n(this.value?this.value+n.sep+$:$)}intersects($){return this.contains($)||$.contains(this)}contains($){return this.value===$.value||$.value.startsWith(this.value+n.sep)}};Y.sep=".",Y=n=Ve([I],Y),e.CodeActionKind=Y,Y.Empty=new Y(""),Y.QuickFix=Y.Empty.append("quickfix"),Y.Refactor=Y.Empty.append("refactor"),Y.RefactorExtract=Y.Refactor.append("extract"),Y.RefactorInline=Y.Refactor.append("inline"),Y.RefactorRewrite=Y.Refactor.append("rewrite"),Y.Source=Y.Empty.append("source"),Y.SourceOrganizeImports=Y.Source.append("organizeImports"),Y.SourceFixAll=Y.Source.append("fixAll");let ae=class{constructor($,oe){if(this.range=$,this.parent=oe,oe&&!oe.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};ae=Ve([I],ae),e.SelectionRange=ae;class ve{constructor($,oe,ke,Xe,nt,rt){this.kind=$,this.name=oe,this.detail=ke,this.uri=Xe,this.range=nt,this.selectionRange=rt}}e.CallHierarchyItem=ve;class Me{constructor($,oe){this.fromRanges=oe,this.from=$}}e.CallHierarchyIncomingCall=Me;class ze{constructor($,oe){this.fromRanges=oe,this.to=$}}e.CallHierarchyOutgoingCall=ze;var Ee;(function(H){H[H.Information=0]="Information",H[H.Warning=1]="Warning",H[H.Error=2]="Error"})(Ee=e.LanguageStatusSeverity||(e.LanguageStatusSeverity={}));let Ye=class{constructor($,oe){this.range=$,this.command=oe}get isResolved(){return!!this.command}};Ye=Ve([I],Ye),e.CodeLens=Ye;let X=a=class{constructor($,oe=!1){m.set(this,void 0),it(this,m,new k.MarkdownString($,{supportThemeIcons:oe}),"f")}static isMarkdownString($){return $ instanceof a?!0:$&&$.appendCodeblock&&$.appendMarkdown&&$.appendText&&$.value!==void 0}get value(){return He(this,m,"f").value}set value($){He(this,m,"f").value=$}get isTrusted(){return He(this,m,"f").isTrusted}set isTrusted($){He(this,m,"f").isTrusted=$}get supportThemeIcons(){return He(this,m,"f").supportThemeIcons}set supportThemeIcons($){He(this,m,"f").supportThemeIcons=$}appendText($){return He(this,m,"f").appendText($),this}appendMarkdown($){return He(this,m,"f").appendMarkdown($),this}appendCodeblock($,oe){return He(this,m,"f").appendCodeblock(oe??"",$),this}};m=new WeakMap,X=a=Ve([I],X),e.MarkdownString=X;let se=class{constructor($,oe){this.label=$,this.documentation=oe}};se=Ve([I],se),e.ParameterInformation=se;let fe=class{constructor($,oe){this.label=$,this.documentation=oe,this.parameters=[]}};fe=Ve([I],fe),e.SignatureInformation=fe;let xe=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};xe=Ve([I],xe),e.SignatureHelp=xe;var Be;(function(H){H[H.Invoke=1]="Invoke",H[H.TriggerCharacter=2]="TriggerCharacter",H[H.ContentChange=3]="ContentChange"})(Be=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var et;(function(H){H[H.Other=0]="Other",H[H.Type=1]="Type",H[H.Parameter=2]="Parameter"})(et=e.InlayHintKind||(e.InlayHintKind={}));let Ce=class{constructor($,oe,ke){this.text=$,this.position=oe,this.kind=ke}};Ce=Ve([I],Ce),e.InlayHint=Ce;var De;(function(H){H[H.Invoke=0]="Invoke",H[H.TriggerCharacter=1]="TriggerCharacter",H[H.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(De=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Te;(function(H){H[H.Text=0]="Text",H[H.Method=1]="Method",H[H.Function=2]="Function",H[H.Constructor=3]="Constructor",H[H.Field=4]="Field",H[H.Variable=5]="Variable",H[H.Class=6]="Class",H[H.Interface=7]="Interface",H[H.Module=8]="Module",H[H.Property=9]="Property",H[H.Unit=10]="Unit",H[H.Value=11]="Value",H[H.Enum=12]="Enum",H[H.Keyword=13]="Keyword",H[H.Snippet=14]="Snippet",H[H.Color=15]="Color",H[H.File=16]="File",H[H.Reference=17]="Reference",H[H.Folder=18]="Folder",H[H.EnumMember=19]="EnumMember",H[H.Constant=20]="Constant",H[H.Struct=21]="Struct",H[H.Event=22]="Event",H[H.Operator=23]="Operator",H[H.TypeParameter=24]="TypeParameter",H[H.User=25]="User",H[H.Issue=26]="Issue"})(Te=e.CompletionItemKind||(e.CompletionItemKind={}));var ce;(function(H){H[H.Deprecated=1]="Deprecated"})(ce=e.CompletionItemTag||(e.CompletionItemTag={}));let ue=class{constructor($,oe){this.label=$,this.kind=oe}toJSON(){return{label:this.label,kind:this.kind&&Te[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};ue=Ve([I],ue),e.CompletionItem=ue;let pe=class{constructor($=[],oe=!1){this.items=$,this.isIncomplete=oe}};pe=Ve([I],pe),e.CompletionList=pe;let be=class{constructor($,oe,ke){this.text=$,this.range=oe,this.command=ke}};be=Ve([I],be),e.InlineSuggestion=be;let j=class{constructor($){this.items=$}};j=Ve([I],j),e.InlineSuggestions=j;var we;(function(H){H[H.Active=-1]="Active",H[H.Beside=-2]="Beside",H[H.One=1]="One",H[H.Two=2]="Two",H[H.Three=3]="Three",H[H.Four=4]="Four",H[H.Five=5]="Five",H[H.Six=6]="Six",H[H.Seven=7]="Seven",H[H.Eight=8]="Eight",H[H.Nine=9]="Nine"})(we=e.ViewColumn||(e.ViewColumn={}));var _e;(function(H){H[H.Left=1]="Left",H[H.Right=2]="Right"})(_e=e.StatusBarAlignment||(e.StatusBarAlignment={}));var Ae;(function(H){H[H.Off=0]="Off",H[H.On=1]="On",H[H.Relative=2]="Relative"})(Ae=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var Ue;(function(H){H[H.Manual=1]="Manual",H[H.AfterDelay=2]="AfterDelay",H[H.FocusOut=3]="FocusOut"})(Ue=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Ge;(function(H){H[H.Default=0]="Default",H[H.InCenter=1]="InCenter",H[H.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",H[H.AtTop=3]="AtTop"})(Ge=e.TextEditorRevealType||(e.TextEditorRevealType={}));var Ze;(function(H){H[H.Keyboard=1]="Keyboard",H[H.Mouse=2]="Mouse",H[H.Command=3]="Command"})(Ze=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var Qe;(function(H){H[H.Undo=1]="Undo",H[H.Redo=2]="Redo"})(Qe=e.TextDocumentChangeReason||(e.TextDocumentChangeReason={}));var Je;(function(H){H[H.OpenOpen=0]="OpenOpen",H[H.ClosedClosed=1]="ClosedClosed",H[H.OpenClosed=2]="OpenClosed",H[H.ClosedOpen=3]="ClosedOpen"})(Je=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(H){function $(oe){switch(oe){case"keyboard":return H.Keyboard;case"mouse":return H.Mouse;case"api":return H.Command}}H.fromValue=$}(Ze=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let ct=class{constructor($,oe){if(oe&&!y.URI.isUri(oe))throw(0,R.illegalArgument)("target");if(!V.isRange($)||$.isEmpty)throw(0,R.illegalArgument)("range");this.range=$,this.target=oe}};ct=Ve([I],ct),e.DocumentLink=ct;let mt=class{constructor($,oe,ke,Xe){this.red=$,this.green=oe,this.blue=ke,this.alpha=Xe}};mt=Ve([I],mt),e.Color=mt;let bt=class{constructor($,oe){if(oe&&!(oe instanceof mt))throw(0,R.illegalArgument)("color");if(!V.isRange($)||$.isEmpty)throw(0,R.illegalArgument)("range");this.range=$,this.color=oe}};bt=Ve([I],bt),e.ColorInformation=bt;let ot=class{constructor($){if(!$||typeof $!="string")throw(0,R.illegalArgument)("label");this.label=$}};ot=Ve([I],ot),e.ColorPresentation=ot;var at;(function(H){H[H.RGB=0]="RGB",H[H.HEX=1]="HEX",H[H.HSL=2]="HSL"})(at=e.ColorFormat||(e.ColorFormat={}));var Se;(function(H){H[H.Error=0]="Error",H[H.Warning=1]="Warning",H[H.Information=2]="Information"})(Se=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));class Pe{constructor($,oe,ke){if(this.startIndex=$,this.length=oe,this.tooltip=ke,typeof $!="number"||$<0)throw(0,R.illegalArgument)("startIndex");if(typeof oe!="number"||oe<1)throw(0,R.illegalArgument)("length");if(ke!==void 0&&typeof ke!="string")throw(0,R.illegalArgument)("tooltip")}}e.TerminalLink=Pe;class te{constructor($){this.options=$,typeof $!="object"&&(0,R.illegalArgument)("options")}}e.TerminalProfile=te;var Q;(function(H){H[H.Always=1]="Always",H[H.Silent=2]="Silent",H[H.Never=3]="Never"})(Q=e.TaskRevealKind||(e.TaskRevealKind={}));var Oe;(function(H){H[H.Shared=1]="Shared",H[H.Dedicated=2]="Dedicated",H[H.New=3]="New"})(Oe=e.TaskPanelKind||(e.TaskPanelKind={}));let Fe=d=class{constructor($,oe){if(typeof $!="string"||typeof oe!="string")throw(0,R.illegalArgument)("name");this._id=$}static from($){switch($){case"clean":return d.Clean;case"build":return d.Build;case"rebuild":return d.Rebuild;case"test":return d.Test;default:return}}get id(){return this._id}};Fe.Clean=new d("clean","Clean"),Fe.Build=new d("build","Build"),Fe.Rebuild=new d("rebuild","Rebuild"),Fe.Test=new d("test","Test"),Fe=d=Ve([I],Fe),e.TaskGroup=Fe;function tt(H){let $="";for(let oe=0;oe<H.length;oe++)$+=H[oe].replace(/,/g,",,")+",";return $}let Ke=class{constructor($,oe,ke){if(typeof $!="string")throw(0,R.illegalArgument)("process");this._args=[],this._process=$,oe!==void 0&&(Array.isArray(oe)?(this._args=oe,this._options=ke):this._options=oe)}get process(){return this._process}set process($){if(typeof $!="string")throw(0,R.illegalArgument)("process");this._process=$}get args(){return this._args}set args($){Array.isArray($)||($=[]),this._args=$}get options(){return this._options}set options($){this._options=$}computeId(){const $=[];if($.push("process"),this._process!==void 0&&$.push(this._process),this._args&&this._args.length>0)for(let oe of this._args)$.push(oe);return tt($)}};Ke=Ve([I],Ke),e.ProcessExecution=Ke;let ut=class{constructor($,oe,ke){if(this._args=[],Array.isArray(oe)){if(!$)throw(0,R.illegalArgument)("command can't be undefined or null");if(typeof $!="string"&&typeof $.value!="string")throw(0,R.illegalArgument)("command");this._command=$,this._args=oe,this._options=ke}else{if(typeof $!="string")throw(0,R.illegalArgument)("commandLine");this._commandLine=$,this._options=oe}}get commandLine(){return this._commandLine}set commandLine($){if(typeof $!="string")throw(0,R.illegalArgument)("commandLine");this._commandLine=$}get command(){return this._command?this._command:""}set command($){if(typeof $!="string"&&typeof $.value!="string")throw(0,R.illegalArgument)("command");this._command=$}get args(){return this._args}set args($){this._args=$||[]}get options(){return this._options}set options($){this._options=$}computeId(){const $=[];if($.push("shell"),this._commandLine!==void 0&&$.push(this._commandLine),this._command!==void 0&&$.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(let oe of this._args)$.push(typeof oe=="string"?oe:oe.value);return tt($)}};ut=Ve([I],ut),e.ShellExecution=ut;var St;(function(H){H[H.Escape=1]="Escape",H[H.Strong=2]="Strong",H[H.Weak=3]="Weak"})(St=e.ShellQuoting||(e.ShellQuoting={}));var kt;(function(H){H[H.Global=1]="Global",H[H.Workspace=2]="Workspace"})(kt=e.TaskScope||(e.TaskScope={}));class Dt{constructor($){this._callback=$}computeId(){return"customExecution"+(0,A.generateUuid)()}set callback($){this._callback=$}get callback(){return this._callback}}e.CustomExecution=Dt;let ft=f=class{constructor($,oe,ke,Xe,nt,rt){this.__deprecated=!1,this._definition=this.definition=$;let lt;typeof oe=="string"?(this._name=this.name=oe,this._source=this.source=ke,this.execution=Xe,lt=nt,this.__deprecated=!0):oe===kt.Global||oe===kt.Workspace?(this.target=oe,this._name=this.name=ke,this._source=this.source=Xe,this.execution=nt,lt=rt):(this.target=oe,this._name=this.name=ke,this._source=this.source=Xe,this.execution=nt,lt=rt),typeof lt=="string"?(this._problemMatchers=[lt],this._hasDefinedMatchers=!0):Array.isArray(lt)?(this._problemMatchers=lt,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id($){this.__id=$}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof Ke?this._definition={type:f.ProcessType,id:this._execution.computeId()}:this._execution instanceof ut?this._definition={type:f.ShellType,id:this._execution.computeId()}:this._execution instanceof Dt?this._definition={type:f.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:f.EmptyType,id:(0,A.generateUuid)()}}get definition(){return this._definition}set definition($){if($==null)throw(0,R.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=$}get scope(){return this._scope}set target($){this.clear(),this._scope=$}get name(){return this._name}set name($){if(typeof $!="string")throw(0,R.illegalArgument)("name");this.clear(),this._name=$}get execution(){return this._execution}set execution($){$===null&&($=void 0),this.clear(),this._execution=$;const oe=this._definition.type;(f.EmptyType===oe||f.ProcessType===oe||f.ShellType===oe||f.ExtensionCallbackType===oe)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers($){if(Array.isArray($))this.clear(),this._problemMatchers=$,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground($){$!==!0&&$!==!1&&($=!1),this.clear(),this._isBackground=$}get source(){return this._source}set source($){if(typeof $!="string"||$.length===0)throw(0,R.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=$}get group(){return this._group}set group($){$===null&&($=void 0),this.clear(),this._group=$}get detail(){return this._detail}set detail($){$===null&&($=void 0),this._detail=$}get presentationOptions(){return this._presentationOptions}set presentationOptions($){$==null&&($=Object.create(null)),this.clear(),this._presentationOptions=$}get runOptions(){return this._runOptions}set runOptions($){$==null&&($=Object.create(null)),this.clear(),this._runOptions=$}};ft.ExtensionCallbackType="customExecution",ft.ProcessType="process",ft.ShellType="shell",ft.EmptyType="$empty",ft=f=Ve([I],ft),e.Task=ft;var dt;(function(H){H[H.SourceControl=1]="SourceControl",H[H.Window=10]="Window",H[H.Notification=15]="Notification"})(dt=e.ProgressLocation||(e.ProgressLocation={}));let vt=class{constructor($,oe=Et.None){this.collapsibleState=oe,y.URI.isUri($)?this.resourceUri=$:this.label=$}};vt=Ve([I],vt),e.TreeItem=vt;var Et;(function(H){H[H.None=0]="None",H[H.Collapsed=1]="Collapsed",H[H.Expanded=2]="Expanded"})(Et=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));let Tt=class{constructor($,oe){this.id=$,this.color=oe}};Tt=Ve([I],Tt),e.ThemeIcon=Tt,Tt.File=new Tt("file"),Tt.Folder=new Tt("folder");let It=class{constructor($){this.id=$}};It=Ve([I],It),e.ThemeColor=It;var bn;(function(H){H[H.Global=1]="Global",H[H.Workspace=2]="Workspace",H[H.WorkspaceFolder=3]="WorkspaceFolder"})(bn=e.ConfigurationTarget||(e.ConfigurationTarget={}));let Vt=class{constructor($,oe){if(typeof $!="string"&&(!$||!y.URI.isUri($)&&!y.URI.isUri($.uri)))throw(0,R.illegalArgument)("base");if(typeof oe!="string")throw(0,R.illegalArgument)("pattern");typeof $=="string"?(this.baseFolder=y.URI.file($),this.base=$):y.URI.isUri($)?(this.baseFolder=$,this.base=$.fsPath):(this.baseFolder=$.uri,this.base=$.uri.fsPath),this.pattern=oe}};Vt=Ve([I],Vt),e.RelativePattern=Vt;let _t=class{constructor($,oe,ke,Xe){this.enabled=typeof $=="boolean"?$:!0,typeof oe=="string"&&(this.condition=oe),typeof ke=="string"&&(this.hitCondition=ke),typeof Xe=="string"&&(this.logMessage=Xe)}get id(){return this._id||(this._id=(0,A.generateUuid)()),this._id}};_t=Ve([I],_t),e.Breakpoint=_t;let Xt=class extends _t{constructor($,oe,ke,Xe,nt){super(oe,ke,Xe,nt);if($===null)throw(0,R.illegalArgument)("location");this.location=$}};Xt=Ve([I],Xt),e.SourceBreakpoint=Xt;let Yt=class extends _t{constructor($,oe,ke,Xe,nt){super(oe,ke,Xe,nt);this.functionName=$}};Yt=Ve([I],Yt),e.FunctionBreakpoint=Yt;let gt=class extends _t{constructor($,oe,ke,Xe,nt,rt,lt){super(Xe,nt,rt,lt);if(!oe)throw(0,R.illegalArgument)("dataId");this.label=$,this.dataId=oe,this.canPersist=ke}};gt=Ve([I],gt),e.DataBreakpoint=gt;let jt=class{constructor($,oe,ke){this.command=$,this.args=oe||[],this.options=ke}};jt=Ve([I],jt),e.DebugAdapterExecutable=jt;let Wt=class{constructor($,oe){this.port=$,this.host=oe}};Wt=Ve([I],Wt),e.DebugAdapterServer=Wt;let Jt=class{constructor($){this.path=$}};Jt=Ve([I],Jt),e.DebugAdapterNamedPipeServer=Jt;let Zt=class{constructor($){this.implementation=$}};Zt=Ve([I],Zt),e.DebugAdapterInlineImplementation=Zt;let Pt=class{constructor($,oe){this.range=$,this.expression=oe}};Pt=Ve([I],Pt),e.EvaluatableExpression=Pt;var dn;(function(H){H[H.Automatic=0]="Automatic",H[H.Explicit=1]="Explicit"})(dn=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));let en=class{constructor($,oe){this.range=$,this.text=oe}};en=Ve([I],en),e.InlineValueText=en;let xt=class{constructor($,oe,ke=!0){this.range=$,this.variableName=oe,this.caseSensitiveLookup=ke}};xt=Ve([I],xt),e.InlineValueVariableLookup=xt;let ht=class{constructor($,oe){this.range=$,this.expression=oe}};ht=Ve([I],ht),e.InlineValueEvaluatableExpression=ht;let tn=class{constructor($,oe){this.frameId=$,this.stoppedLocation=oe}};tn=Ve([I],tn),e.InlineValueContext=tn;var Mt;(function(H){H[H.Changed=1]="Changed",H[H.Created=2]="Created",H[H.Deleted=3]="Deleted"})(Mt=e.FileChangeType||(e.FileChangeType={}));let Ot=w=class extends Error{constructor($,oe=i.FileSystemProviderErrorCode.Unknown,ke){super(y.URI.isUri($)?$.toString(!0):$);this.code=ke?.name??"Unknown",(0,i.markAsFileSystemProviderError)(this,oe),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,w.prototype),typeof Error.captureStackTrace=="function"&&typeof ke=="function"&&Error.captureStackTrace(this,ke)}static FileExists($){return new w($,i.FileSystemProviderErrorCode.FileExists,w.FileExists)}static FileNotFound($){return new w($,i.FileSystemProviderErrorCode.FileNotFound,w.FileNotFound)}static FileNotADirectory($){return new w($,i.FileSystemProviderErrorCode.FileNotADirectory,w.FileNotADirectory)}static FileIsADirectory($){return new w($,i.FileSystemProviderErrorCode.FileIsADirectory,w.FileIsADirectory)}static NoPermissions($){return new w($,i.FileSystemProviderErrorCode.NoPermissions,w.NoPermissions)}static Unavailable($){return new w($,i.FileSystemProviderErrorCode.Unavailable,w.Unavailable)}};Ot=w=Ve([I],Ot),e.FileSystemError=Ot;let qt=class{constructor($,oe,ke){this.start=$,this.end=oe,this.kind=ke}};qt=Ve([I],qt),e.FoldingRange=qt;var En;(function(H){H[H.Comment=1]="Comment",H[H.Imports=2]="Imports",H[H.Region=3]="Region"})(En=e.FoldingRangeKind||(e.FoldingRangeKind={}));var hn;(function(H){H[H.Collapsed=0]="Collapsed",H[H.Expanded=1]="Expanded"})(hn=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var _n;(function(H){H[H.Editing=0]="Editing",H[H.Preview=1]="Preview"})(_n=e.CommentMode||(e.CommentMode={}));class fn{constructor($,oe=[]){this.tokenTypes=$,this.tokenModifiers=oe}}e.SemanticTokensLegend=fn;function nn(H){return typeof H=="undefined"||(0,D.isStringArray)(H)}class rn{constructor($){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,$){this._hasLegend=!0;for(let oe=0,ke=$.tokenTypes.length;oe<ke;oe++)this._tokenTypeStrToInt.set($.tokenTypes[oe],oe);for(let oe=0,ke=$.tokenModifiers.length;oe<ke;oe++)this._tokenModifierStrToInt.set($.tokenModifiers[oe],oe)}}push($,oe,ke,Xe,nt){if(typeof $=="number"&&typeof oe=="number"&&typeof ke=="number"&&typeof Xe=="number"&&(typeof nt=="number"||typeof nt=="undefined"))return typeof nt=="undefined"&&(nt=0),this._pushEncoded($,oe,ke,Xe,nt);if(V.isRange($)&&typeof oe=="string"&&nn(ke))return this._push($,oe,ke);throw(0,R.illegalArgument)()}_push($,oe,ke){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if($.start.line!==$.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(oe))throw new Error("`tokenType` is not in the provided legend");const Xe=$.start.line,nt=$.start.character,rt=$.end.character-$.start.character,lt=this._tokenTypeStrToInt.get(oe);let yt=0;if(ke)for(const At of ke){if(!this._tokenModifierStrToInt.has(At))throw new Error("`tokenModifier` is not in the provided legend");const Rt=this._tokenModifierStrToInt.get(At);yt|=1<<Rt>>>0}this._pushEncoded(Xe,nt,rt,lt,yt)}_pushEncoded($,oe,ke,Xe,nt){if(this._dataIsSortedAndDeltaEncoded&&($<this._prevLine||$===this._prevLine&&oe<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const yt=this._data.length/5|0;let At=0,Rt=0;for(let Ft=0;Ft<yt;Ft++){let Nt=this._data[5*Ft],cn=this._data[5*Ft+1];Nt===0?(Nt=At,cn+=Rt):Nt+=At,this._data[5*Ft]=Nt,this._data[5*Ft+1]=cn,At=Nt,Rt=cn}}let rt=$,lt=oe;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(rt-=this._prevLine,rt===0&&(lt-=this._prevChar)),this._data[this._dataLen++]=rt,this._data[this._dataLen++]=lt,this._data[this._dataLen++]=ke,this._data[this._dataLen++]=Xe,this._data[this._dataLen++]=nt,this._prevLine=$,this._prevChar=oe}static _sortAndDeltaEncode($){let oe=[];const ke=$.length/5|0;for(let lt=0;lt<ke;lt++)oe[lt]=lt;oe.sort((lt,yt)=>{const At=$[5*lt],Rt=$[5*yt];if(At===Rt){const Ft=$[5*lt+1],Nt=$[5*yt+1];return Ft-Nt}return At-Rt});const Xe=new Uint32Array($.length);let nt=0,rt=0;for(let lt=0;lt<ke;lt++){const yt=5*oe[lt],At=$[yt+0],Rt=$[yt+1],Ft=$[yt+2],Nt=$[yt+3],cn=$[yt+4],Un=At-nt,qn=Un===0?Rt-rt:Rt,un=5*lt;Xe[un+0]=Un,Xe[un+1]=qn,Xe[un+2]=Ft,Xe[un+3]=Nt,Xe[un+4]=cn,nt=At,rt=Rt}return Xe}build($){return this._dataIsSortedAndDeltaEncoded?new Ht(new Uint32Array(this._data),$):new Ht(rn._sortAndDeltaEncode(this._data),$)}}e.SemanticTokensBuilder=rn;class Ht{constructor($,oe){this.resultId=oe,this.data=$}}e.SemanticTokens=Ht;class sn{constructor($,oe,ke){this.start=$,this.deleteCount=oe,this.data=ke}}e.SemanticTokensEdit=sn;class Sn{constructor($,oe){this.resultId=oe,this.edits=$}}e.SemanticTokensEdits=Sn;var yn;(function(H){H[H.Separate=0]="Separate",H[H.MergeWithParent=1]="MergeWithParent"})(yn=e.DebugConsoleMode||(e.DebugConsoleMode={}));var zt;(function(H){H[H.Initial=1]="Initial",H[H.Dynamic=2]="Dynamic"})(zt=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));let Gt=class{constructor(){}};Gt.Back={iconPath:new Tt("arrow-left")},Gt=Ve([I],Gt),e.QuickInputButtons=Gt;var Dn;(function(H){H[H.UI=1]="UI",H[H.Workspace=2]="Workspace"})(Dn=e.ExtensionKind||(e.ExtensionKind={}));class Cn{constructor($,oe,ke){this.badge=$,this.tooltip=oe,this.color=ke}static validate($){if($.badge&&$.badge.length!==1&&$.badge.length!==2)throw new Error("The 'badge'-property must be undefined or a short character");if(!$.color&&!$.badge&&!$.tooltip)throw new Error("The decoration is empty")}}e.FileDecoration=Cn;let on=class{constructor($){this.kind=$}};on=Ve([I],on),e.ColorTheme=on;var an;(function(H){H[H.Light=1]="Light",H[H.Dark=2]="Dark",H[H.HighContrast=3]="HighContrast"})(an=e.ColorThemeKind||(e.ColorThemeKind={}));class Bt{constructor($,oe){if($<0)throw(0,R.illegalArgument)("start must be positive");if(oe<0)throw(0,R.illegalArgument)("end must be positive");$<=oe?(this._start=$,this._end=oe):(this._start=oe,this._end=$)}static isNotebookRange($){return $ instanceof Bt?!0:$?typeof $.start=="number"&&typeof $.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}with($){let oe=this._start,ke=this._end;return $.start!==void 0&&(oe=$.start),$.end!==void 0&&(ke=$.end),oe===this._start&&ke===this._end?this:new Bt(oe,ke)}}e.NotebookRange=Bt;class Lt{constructor($,oe,ke,Xe,nt,rt,lt){this.kind=$,this.value=oe,this.languageId=ke,this.mime=Xe,this.outputs=nt??[],this.metadata=rt,this.executionSummary=lt,Lt.validate(this)}static validate($){if(typeof $.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof $.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof $.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray($){return Array.isArray($)&&$.every(oe=>Lt.isNotebookCellData(oe))}static isNotebookCellData($){return!0}}e.NotebookCellData=Lt;class Kt{constructor($){this.cells=$}}e.NotebookData=Kt;class Ne{constructor($,oe){this.data=$,this.mime=oe;const ke=(0,T.normalizeMimeType)(oe,!0);if(!ke)throw new Error("INVALID mime type, must not be empty or falsy: "+oe);this.mime=ke}static isNotebookCellOutputItem($){return $ instanceof Ne?!0:$?typeof $.mime=="string"&&$.data instanceof Uint8Array:!1}static error($){const oe={name:$.name,message:$.message,stack:$.stack};return Ne.json(oe,"application/vnd.code.notebook.error")}static stdout($){return Ne.text($,"application/vnd.code.notebook.stdout")}static stderr($){return Ne.text($,"application/vnd.code.notebook.stderr")}static bytes($,oe="application/octet-stream"){return new Ne($,oe)}static text($,oe=T.Mimes.text){const ke=He(Ne,l,"f",v).encode(String($));return new Ne(ke,oe)}static json($,oe="application/json"){const ke=JSON.stringify($,void 0,"	");return Ne.text(ke,oe)}}e.NotebookCellOutputItem=Ne,l=Ne,v={value:new TextEncoder};class $t{constructor($,oe,ke){this.items=$t.ensureUniqueMimeTypes($,!0),typeof oe=="string"?(this.id=oe,this.metadata=ke):(this.id=(0,A.generateUuid)(),this.metadata=oe??ke)}static isNotebookCellOutput($){return $ instanceof $t?!0:!$||typeof $!="object"?!1:typeof $.id=="string"&&(0,D.isArray)($.items)}static ensureUniqueMimeTypes($,oe=!1){const ke=new Set,Xe=new Set;for(let nt=0;nt<$.length;nt++){const rt=$[nt],lt=(0,T.normalizeMimeType)(rt.mime);if(!ke.has(lt)){ke.add(lt);continue}Xe.add(nt),oe&&console.warn(`DUPLICATED mime type '${rt.mime}' will be dropped`)}return Xe.size===0?$:$.filter((nt,rt)=>!Xe.has(rt))}}e.NotebookCellOutput=$t;var mn;(function(H){H[H.Markup=1]="Markup",H[H.Code=2]="Code"})(mn=e.NotebookCellKind||(e.NotebookCellKind={}));var pt;(function(H){H[H.Idle=1]="Idle",H[H.Pending=2]="Pending",H[H.Executing=3]="Executing"})(pt=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var kn;(function(H){H[H.Left=1]="Left",H[H.Right=2]="Right"})(kn=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var In;(function(H){H[H.Default=0]="Default",H[H.InCenter=1]="InCenter",H[H.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",H[H.AtTop=3]="AtTop"})(In=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class gn{constructor($,oe){this.text=$,this.alignment=oe}}e.NotebookCellStatusBarItem=gn;var pn;(function(H){H[H.Default=1]="Default",H[H.Preferred=2]="Preferred"})(pn=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));class Pn{constructor($,oe=[]){this.uri=$,this.provides=(0,g.asArray)(oe)}}e.NotebookRendererScript=Pn;let ln=class{constructor($,oe){this.label=$,this.timestamp=oe}};ln=Ve([I],ln),e.TimelineItem=ln;var An;(function(H){H[H.Production=1]="Production",H[H.Development=2]="Development",H[H.Test=3]="Test"})(An=e.ExtensionMode||(e.ExtensionMode={}));var Tn;(function(H){H[H.Node=1]="Node",H[H.Webworker=2]="Webworker"})(Tn=e.ExtensionRuntime||(e.ExtensionRuntime={}));var vn;(function(H){H[H.Other=0]="Other",H[H.Comment=1]="Comment",H[H.String=2]="String",H[H.RegEx=4]="RegEx"})(vn=e.StandardTokenType||(e.StandardTokenType={}));class Rn{constructor($,oe){this.ranges=$,this.wordPattern=oe}}e.LinkedEditingRanges=Rn;class Ln{constructor($,oe){this._port=$,this._autoForwardAction=oe}get port(){return this._port}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=Ln;var Fn;(function(H){H[H.Queued=1]="Queued",H[H.Running=2]="Running",H[H.Passed=3]="Passed",H[H.Failed=4]="Failed",H[H.Skipped=5]="Skipped",H[H.Errored=6]="Errored"})(Fn=e.TestResultState||(e.TestResultState={}));var Mn;(function(H){H[H.Error=0]="Error",H[H.Warning=1]="Warning",H[H.Information=2]="Information",H[H.Hint=3]="Hint"})(Mn=e.TestMessageSeverity||(e.TestMessageSeverity={}));var On;(function(H){H[H.Run=1]="Run",H[H.Debug=2]="Debug",H[H.Coverage=3]="Coverage"})(On=e.TestRunProfileKind||(e.TestRunProfileKind={}));let re=class{constructor($,oe,ke){this.include=$,this.exclude=oe,this.profile=ke}};re=Ve([I],re),e.TestRunRequest=re;let de=E=class{constructor($){this.message=$}static diff($,oe,ke){const Xe=new E($);return Xe.expectedOutput=oe,Xe.actualOutput=ke,Xe}};de=E=Ve([I],de),e.TestMessage=de;let Re=class{constructor($,oe){this.covered=$,this.total=oe}};Re=Ve([I],Re),e.CoveredCount=Re;let st=o=class{constructor($,oe,ke,Xe){this.uri=$,this.statementCoverage=oe,this.branchCoverage=ke,this.functionCoverage=Xe}static fromDetails($,oe){const ke=new Re(0,0),Xe=new Re(0,0),nt=new Re(0,0);for(const lt of oe)if("branches"in lt){ke.total+=1,ke.covered+=lt.executionCount>0?1:0;for(const yt of lt.branches)Xe.total+=1,Xe.covered+=yt.executionCount>0?1:0}else nt.total+=1,nt.covered+=lt.executionCount>0?1:0;const rt=new o($,ke,Xe.total>0?Xe:void 0,nt.total>0?nt:void 0);return rt.detailedCoverage=oe,rt}};st=o=Ve([I],st),e.FileCoverage=st;let wt=class{constructor($,oe,ke=[]){this.executionCount=$,this.location=oe,this.branches=ke}};wt=Ve([I],wt),e.StatementCoverage=wt;let Ct=class{constructor($,oe){this.executionCount=$,this.location=oe}};Ct=Ve([I],Ct),e.BranchCoverage=Ct;let Nn=class{constructor($,oe){this.executionCount=$,this.location=oe}};Nn=Ve([I],Nn),e.FunctionCoverage=Nn;var Hn;(function(H){H[H.None=0]="None",H[H.Option=1]="Option",H[H.Default=2]="Default",H[H.Preferred=3]="Preferred"})(Hn=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var zn;(function(H){H[H.Untrusted=0]="Untrusted",H[H.Trusted=1]="Trusted",H[H.Unspecified=2]="Unspecified"})(zn=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var Vn;(function(H){H[H.Notify=1]="Notify",H[H.OpenBrowser=2]="OpenBrowser",H[H.OpenPreview=3]="OpenPreview",H[H.Silent=4]="Silent",H[H.Ignore=5]="Ignore",H[H.OpenBrowserOnce=6]="OpenBrowserOnce"})(Vn=e.PortAutoForwardAction||(e.PortAutoForwardAction={}));class jn{constructor($,oe,ke,Xe,nt,rt){this.kind=$,this.name=oe,this.detail=ke,this.uri=Xe,this.range=nt,this.selectionRange=rt}}e.TypeHierarchyItem=jn}),define(me[123],ge([0,1,54,10,8,149,110,7,20]),function(J,e,g,R,k,S,T,D,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.getWordDefinitionFor=e.setWordDefinitionFor=void 0;const A=new Map;function i(l,v){v?A.set(l,v):A.delete(l)}e.setWordDefinitionFor=i;function C(l){return A.get(l)}e.getWordDefinitionFor=C;class u extends S.MirrorTextModel{constructor(v,_,b,P,c,h,p,t){super(_,b,P,c);this._proxy=v,this._languageId=h,this._isDirty=p,this._notebook=t,this._isDisposed=!1}dispose(){(0,g.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(v){return(0,y.equals)(this._lines,v)}get document(){if(!this._document){const v=this;this._document={get uri(){return v._uri},get fileName(){return v._uri.fsPath},get isUntitled(){return v._uri.scheme===R.Schemas.untitled},get languageId(){return v._languageId},get version(){return v._versionId},get isClosed(){return v._isDisposed},get isDirty(){return v._isDirty},get notebook(){return v._notebook},save(){return v._save()},getText(_){return _?v._getTextInRange(_):v.getText()},get eol(){return v._eol===`
`?D.EndOfLine.LF:D.EndOfLine.CRLF},get lineCount(){return v._lines.length},lineAt(_){return v._lineAt(_)},offsetAt(_){return v._offsetAt(_)},positionAt(_){return v._positionAt(_)},validateRange(_){return v._validateRange(_)},validatePosition(_){return v._validatePosition(_)},getWordRangeAtPosition(_,b){return v._getWordRangeAtPosition(_,b)}}}return Object.freeze(this._document)}_acceptLanguageId(v){(0,g.ok)(!this._isDisposed),this._languageId=v}_acceptIsDirty(v){(0,g.ok)(!this._isDisposed),this._isDirty=v}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(v){const _=this._validateRange(v);if(_.isEmpty)return"";if(_.isSingleLine)return this._lines[_.start.line].substring(_.start.character,_.end.character);const b=this._eol,P=_.start.line,c=_.end.line,h=[];h.push(this._lines[P].substring(_.start.character));for(let p=P+1;p<c;p++)h.push(this._lines[p]);return h.push(this._lines[c].substring(0,_.end.character)),h.join(b)}_lineAt(v){let _;if(v instanceof D.Position?_=v.line:typeof v=="number"&&(_=v),typeof _!="number"||_<0||_>=this._lines.length||Math.floor(_)!==_)throw new Error("Illegal value for `line`");return new m(_,this._lines[_],_===this._lines.length-1)}_offsetAt(v){return v=this._validatePosition(v),this._ensureLineStarts(),this._lineStarts.getPrefixSum(v.line-1)+v.character}_positionAt(v){v=Math.floor(v),v=Math.max(0,v),this._ensureLineStarts();const _=this._lineStarts.getIndexOf(v),b=this._lines[_.index].length;return new D.Position(_.index,Math.min(_.remainder,b))}_validateRange(v){if(!(v instanceof D.Range))throw new Error("Invalid argument");const _=this._validatePosition(v.start),b=this._validatePosition(v.end);return _===v.start&&b===v.end?v:new D.Range(_.line,_.character,b.line,b.character)}_validatePosition(v){if(!(v instanceof D.Position))throw new Error("Invalid argument");if(this._lines.length===0)return v.with(0,0);let{line:_,character:b}=v,P=!1;if(_<0)_=0,b=0,P=!0;else if(_>=this._lines.length)_=this._lines.length-1,b=this._lines[_].length,P=!0;else{const c=this._lines[_].length;b<0?(b=0,P=!0):b>c&&(b=c,P=!0)}return P?new D.Position(_,b):v}_getWordRangeAtPosition(v,_){const b=this._validatePosition(v);if(!_)_=C(this._languageId);else if((0,k.regExpLeadsToEndlessLoop)(_))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${_.source}' because it matches the empty string.`);const P=(0,T.getWordAtText)(b.character+1,(0,T.ensureValidWordDefinition)(_),this._lines[b.line],0);if(P)return new D.Range(b.line,P.startColumn-1,b.line,P.endColumn-1)}}e.ExtHostDocumentData=u;class m{constructor(v,_,b){this._line=v,this._text=_,this._isLastLine=b}get lineNumber(){return this._line}get text(){return this._text}get range(){return new D.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new D.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=m}),define(me[202],ge([0,1,7,3,112,6,79,22,2,32]),function(J,e,g,R,k,S,T,D,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookConcatDocument=void 0;class i{constructor(u,m,l,v){this._notebook=l,this._selector=v,this._disposables=new S.DisposableStore,this._isClosed=!1,this._versionId=0,this._onDidChange=new R.Emitter,this.onDidChange=this._onDidChange.event,this.uri=y.URI.from({scheme:"vscode-concat-doc",path:(0,A.generateUuid)()}),this._init(),this._disposables.add(m.onDidChangeDocument(b=>{const P=this._cellUris.get(b.document.uri);P!==void 0&&(this._cellLengths.changeValue(P,this._cells[P].document.getText().length+1),this._cellLines.changeValue(P,this._cells[P].document.lineCount),this._versionId+=1,this._onDidChange.fire(void 0))}));const _=b=>{b===this._notebook&&(this._init(),this._versionId+=1,this._onDidChange.fire(void 0))};this._disposables.add(u.onDidChangeNotebookCells(b=>_(b.document)))}dispose(){this._disposables.dispose(),this._isClosed=!0}get isClosed(){return this._isClosed}_init(){this._cells=[],this._cellUris=new D.ResourceMap;const u=[],m=[];for(const l of this._notebook.getCells())l.kind===g.NotebookCellKind.Code&&(!this._selector||(0,T.score)(this._selector,l.document.uri,l.document.languageId,!0))&&(this._cellUris.set(l.document.uri,this._cells.length),this._cells.push(l),u.push(l.document.getText().length+1),m.push(l.document.lineCount));this._cellLengths=new k.PrefixSumComputer(new Uint32Array(u)),this._cellLines=new k.PrefixSumComputer(new Uint32Array(m))}get version(){return this._versionId}getText(u){if(!u){let P="";for(const c of this._cells)P+=c.document.getText()+`
`;return P=P.slice(0,-1),P}if(u.isEmpty)return"";const m=this.locationAt(u.start),l=this.locationAt(u.end),v=this._cellUris.get(m.uri),_=this._cellUris.get(l.uri);if(v===void 0||_===void 0)return"";if(v===_)return this._cells[v].document.getText(new g.Range(m.range.start,l.range.end));const b=[this._cells[v].document.getText(new g.Range(m.range.start,new g.Position(this._cells[v].document.lineCount,0)))];for(let P=v+1;P<_;P++)b.push(this._cells[P].document.getText());return b.push(this._cells[_].document.getText(new g.Range(new g.Position(0,0),l.range.end))),b.join(`
`)}offsetAt(u){const m=this._cellLines.getIndexOf(u.line),l=this._cellLengths.getPrefixSum(m.index-1),v=this._cells[m.index].document.offsetAt(u.with(m.remainder));return l+v}positionAt(u){if(typeof u=="number"){const l=this._cellLengths.getIndexOf(u),v=this._cellLines.getPrefixSum(l.index-1);return this._cells[l.index].document.positionAt(l.remainder).translate(v)}const m=this._cellUris.get(u.uri);if(m!==void 0){const l=this._cellLines.getPrefixSum(m-1);return new g.Position(l+u.range.start.line,u.range.start.character)}return new g.Position(0,0)}locationAt(u){g.Range.isRange(u)||(u=new g.Range(u,u));const m=this._cellLines.getIndexOf(u.start.line);let l=m;u.isEmpty||(l=this._cellLines.getIndexOf(u.end.line));const v=new g.Position(m.remainder,u.start.character),_=new g.Position(l.remainder,u.end.character),b=new g.Range(v,_),P=this._cells[m.index];return new g.Location(P.document.uri,P.document.validateRange(b))}contains(u){return this._cellUris.has(u)}validateRange(u){const m=this.validatePosition(u.start),l=this.validatePosition(u.end);return u.with(m,l)}validatePosition(u){const m=this._cellLines.getIndexOf(u.line),l=new g.Position(m.remainder,u.character),v=this._cells[m.index].document.validatePosition(l),_=this._cellLines.getPrefixSum(m.index-1);return new g.Position(_+v.line,v.character)}}e.ExtHostNotebookConcatDocument=i}),define(me[203],ge([0,1,7,13,3]),function(J,e,g,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let S=class{constructor(D){this._actual=new g.ColorTheme(g.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new k.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(D){let y=D==="light"?g.ColorThemeKind.Light:D==="dark"?g.ColorThemeKind.Dark:g.ColorThemeKind.HighContrast;this._actual=new g.ColorTheme(y),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};S=Ve([$e(0,R.IExtHostRpcService)],S),e.ExtHostTheming=S}),define(me[63],ge([0,1,4]),function(J,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,g.createDecorator)("IURITransformerService");class R{constructor(S){S?(this.transformIncoming=S.transformIncoming.bind(S),this.transformOutgoing=S.transformOutgoing.bind(S),this.transformOutgoingURI=S.transformOutgoingURI.bind(S),this.transformOutgoingScheme=S.transformOutgoingScheme.bind(S)):(this.transformIncoming=T=>T,this.transformOutgoing=T=>T,this.transformOutgoingURI=T=>T,this.transformOutgoingScheme=T=>T)}}e.URITransformerService=R}),define(me[204],ge([0,1,24]),function(J,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class R{constructor(){this.buffers=[]}add(y){let A=this.buffers.indexOf(y);return A<0&&(A=this.buffers.length,this.buffers.push(y)),A}}function k(D,y){if(y.serializeBuffersForPostMessage){const A=new R,i=(m,l)=>{if(l instanceof ArrayBuffer){const v=A.add(l);return{$$vscode_array_buffer_reference$$:!0,index:v}}else if(ArrayBuffer.isView(l)){const v=S(l);if(v){const _=A.add(l.buffer);return{$$vscode_array_buffer_reference$$:!0,index:_,view:{type:v,byteLength:l.byteLength,byteOffset:l.byteOffset}}}}return l},C=JSON.stringify(D,i),u=A.buffers.map(m=>{const l=new Uint8Array(m);return g.VSBuffer.wrap(l)});return{message:C,buffers:u}}else return{message:JSON.stringify(D),buffers:[]}}e.serializeWebviewMessage=k;function S(D){switch(D.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function T(D,y){const A=y.map(u=>{const m=new ArrayBuffer(u.byteLength);return new Uint8Array(m).set(u.buffer),m}),i=y.length?(u,m)=>{if(typeof m=="object"&&m.$$vscode_array_buffer_reference$$){const l=m,{index:v}=l,_=A[v];if(l.view)switch(l.view.type){case 1:return new Int8Array(_,l.view.byteOffset,l.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(_,l.view.byteOffset,l.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(_,l.view.byteOffset,l.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(_,l.view.byteOffset,l.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(_,l.view.byteOffset,l.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(_,l.view.byteOffset,l.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(_,l.view.byteOffset,l.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(_,l.view.byteOffset,l.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(_,l.view.byteOffset,l.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(_,l.view.byteOffset,l.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(_,l.view.byteOffset,l.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return _}return m}:void 0;return{message:JSON.parse(D,i),arrayBuffers:A}}e.deserializeWebviewMessage=T}),define(me[205],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeDataTransferConverter=void 0;var g;(function(R){function k(T){const D={items:new Map};return T.types.forEach((y,A)=>{D.items.set(y,{asString:async()=>T.items[A].asString})}),D}R.toITreeDataTransfer=k;async function S(T){const D={types:[],items:[]},y=Array.from(T.items.entries());for(const A of y)D.types.push(A[0]),D.items.push({asString:await A[1].asString()});return D}R.toTreeDataTransferDTO=S})(g=e.TreeDataTransferConverter||(e.TreeDataTransferConverter={}))}),define(me[88],ge([0,1,10,2]),function(J,e,g,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-webview.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`https://*.${e.webviewResourceBaseHost}`;function k(S,T){return S.scheme===g.Schemas.http||S.scheme===g.Schemas.https?S:(T&&T.authority&&T.isRemote&&S.scheme===g.Schemas.file&&(S=R.URI.from({scheme:g.Schemas.vscodeRemote,authority:T.authority,path:S.path})),R.URI.from({scheme:g.Schemas.https,authority:`${S.scheme}+${S.authority}.${e.webviewRootResourceAuthority}`,path:S.path,fragment:S.fragment,query:S.query}))}e.asWebviewUri=k}),define(me[206],ge([0,1,3,6,88]),function(J,e,g,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class S{constructor(D,y,A){this._proxy=D,this._editors=y,this._initData=A,this._handlePool=0,this._disposables=new R.DisposableStore,this._insets=new Map,this._disposables.add(y.onDidChangeVisibleTextEditors(()=>{const i=y.getVisibleTextEditors();for(const C of this._insets.values())i.indexOf(C.editor)<0&&C.inset.dispose()}))}dispose(){this._insets.forEach(D=>D.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(D,y,A,i,C){let u;for(const c of this._editors.getVisibleTextEditors(!0))if(c.value===D){u=c;break}if(!u)throw new Error("not a visible editor");const m=this,l=this._handlePool++,v=new g.Emitter,_=new g.Emitter,b=new class{constructor(){this._html="",this._options=Object.create(null)}asWebviewUri(c){return(0,k.asWebviewUri)(c,m._initData.remote)}get cspSource(){return k.webviewGenericCspSource}set options(c){this._options=c,m._proxy.$setOptions(l,c)}get options(){return this._options}set html(c){this._html=c,m._proxy.$setHtml(l,c)}get html(){return this._html}get onDidReceiveMessage(){return v.event}postMessage(c){return m._proxy.$postMessage(l,c)}},P=new class{constructor(){this.editor=D,this.line=y,this.height=A,this.webview=b,this.onDidDispose=_.event}dispose(){m._insets.has(l)&&(m._insets.delete(l),m._proxy.$disposeEditorInset(l),_.fire(),_.dispose(),v.dispose())}};return this._proxy.$createEditorInset(l,u.id,u.value.document.uri,y+1,A,i||{},C.identifier,C.extensionLocation),this._insets.set(l,{editor:D,inset:P,onDidReceiveMessage:v}),P}$onDidDispose(D){const y=this._insets.get(D);y&&y.inset.dispose()}$onDidReceiveMessage(D,y){const A=this._insets.get(D);A&&A.onDidReceiveMessage.fire(y)}}e.ExtHostEditorInsets=S}),define(me[207],ge([0,1,171,14,2,6,4,61,34,20,10]),function(J,e,g,R,k,S,T,D,y,A,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveReason=e.Verbosity=e.isUntitledResourceEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.isTextEditorPane=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.EditorAreaVisibleContext=e.SplitEditorsVertically=e.IsCenteredLayoutContext=e.InEditorZenModeContext=e.EditorsVisibleContext=e.SingleEditorGroupsContext=e.MultipleEditorGroupsContext=e.ActiveEditorGroupLastContext=e.ActiveEditorGroupIndexContext=e.ActiveEditorGroupEmptyContext=e.EditorGroupEditorsCountContext=e.TextCompareEditorActiveContext=e.TextCompareEditorVisibleContext=e.ActiveEditorAvailableEditorIdsContext=e.ActiveEditorContext=e.ActiveEditorCanRevertContext=e.ActiveEditorReadonlyContext=e.ActiveEditorStickyContext=e.ActiveEditorPinnedContext=e.ActiveEditorDirtyContext=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,g.localize)(0,null),providerDisplayName:(0,g.localize)(1,null)},e.ActiveEditorDirtyContext=new D.RawContextKey("activeEditorIsDirty",!1,(0,g.localize)(2,null)),e.ActiveEditorPinnedContext=new D.RawContextKey("activeEditorIsNotPreview",!1,(0,g.localize)(3,null)),e.ActiveEditorStickyContext=new D.RawContextKey("activeEditorIsPinned",!1,(0,g.localize)(4,null)),e.ActiveEditorReadonlyContext=new D.RawContextKey("activeEditorIsReadonly",!1,(0,g.localize)(5,null)),e.ActiveEditorCanRevertContext=new D.RawContextKey("activeEditorCanRevert",!1,(0,g.localize)(6,null)),e.ActiveEditorContext=new D.RawContextKey("activeEditor",null,{type:"string",description:(0,g.localize)(7,null)}),e.ActiveEditorAvailableEditorIdsContext=new D.RawContextKey("activeEditorAvailableEditorIds","",(0,g.localize)(8,null)),e.TextCompareEditorVisibleContext=new D.RawContextKey("textCompareEditorVisible",!1,(0,g.localize)(9,null)),e.TextCompareEditorActiveContext=new D.RawContextKey("textCompareEditorActive",!1,(0,g.localize)(10,null)),e.EditorGroupEditorsCountContext=new D.RawContextKey("groupEditorsCount",0,(0,g.localize)(11,null)),e.ActiveEditorGroupEmptyContext=new D.RawContextKey("activeEditorGroupEmpty",!1,(0,g.localize)(12,null)),e.ActiveEditorGroupIndexContext=new D.RawContextKey("activeEditorGroupIndex",0,(0,g.localize)(13,null)),e.ActiveEditorGroupLastContext=new D.RawContextKey("activeEditorGroupLast",!1,(0,g.localize)(14,null)),e.MultipleEditorGroupsContext=new D.RawContextKey("multipleEditorGroups",!1,(0,g.localize)(15,null)),e.SingleEditorGroupsContext=e.MultipleEditorGroupsContext.toNegated(),e.EditorsVisibleContext=new D.RawContextKey("editorIsOpen",!1,(0,g.localize)(16,null)),e.InEditorZenModeContext=new D.RawContextKey("inZenMode",!1,(0,g.localize)(17,null)),e.IsCenteredLayoutContext=new D.RawContextKey("isCenteredLayout",!1,(0,g.localize)(18,null)),e.SplitEditorsVertically=new D.RawContextKey("splitEditorsVertically",!1,(0,g.localize)(19,null)),e.EditorAreaVisibleContext=new D.RawContextKey("editorAreaVisible",!0,(0,g.localize)(20,null)),e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";function C(o){return typeof o?.getViewState=="function"}e.isTextEditorPane=C;function u(o){if(c(o))return!1;const I=o;return k.URI.isUri(I?.resource)}e.isResourceEditorInput=u;function m(o){if(c(o))return!1;const I=o;return I?.original!==void 0&&I.modified!==void 0}e.isResourceDiffEditorInput=m;function l(o){if(c(o))return!1;const I=o;return I?I?.resource===void 0||I.resource.scheme===i.Schemas.untitled||I.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=l;var v;(function(o){o[o.SHORT=0]="SHORT",o[o.MEDIUM=1]="MEDIUM",o[o.LONG=2]="LONG"})(v=e.Verbosity||(e.Verbosity={}));var _;(function(o){o[o.EXPLICIT=1]="EXPLICIT",o[o.AUTO=2]="AUTO",o[o.FOCUS_CHANGE=3]="FOCUS_CHANGE",o[o.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(_=e.SaveReason||(e.SaveReason={}));var b;(function(o){o[o.None=0]="None",o[o.Readonly=2]="Readonly",o[o.Untitled=4]="Untitled",o[o.Singleton=8]="Singleton",o[o.RequiresTrust=16]="RequiresTrust"})(b=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));class P extends S.Disposable{}e.AbstractEditorInput=P;function c(o){return o instanceof P}e.isEditorInput=c;function h(o){const I=o;return k.URI.isUri(I?.preferredResource)}function p(o){const I=o;return c(I?.primary)&&c(I?.secondary)}e.isSideBySideEditorInput=p;function t(o){return c(o?.editor)}e.isEditorInputWithOptions=t;function r(o){const I=o;return t(o)&&I?.group!==void 0}e.isEditorInputWithOptionsAndGroup=r;function s(o){const I=o;return typeof I?.groupId=="number"&&c(I.editor)}e.isEditorIdentifier=s;var n;(function(o){o[o.PRIMARY=1]="PRIMARY",o[o.SECONDARY=2]="SECONDARY",o[o.BOTH=3]="BOTH"})(n=e.SideBySideEditor||(e.SideBySideEditor={}));class a{getOriginalUri(I,L){if(!I)return;const U=p(I)?I.primary:m(I)?I.modified:void 0,V=p(I)?I.secondary:m(I)?I.original:void 0;if(L?.supportSideBySide&&U&&V){if(L?.supportSideBySide===n.BOTH)return{primary:this.getOriginalUri(U,{filterByScheme:L.filterByScheme}),secondary:this.getOriginalUri(V,{filterByScheme:L.filterByScheme})};I=L.supportSideBySide===n.PRIMARY?U:V}if(m(I))return;const ee=h(I)?I.preferredResource:I.resource;return!ee||!L||!L.filterByScheme?ee:this.filterUri(ee,L.filterByScheme)}getCanonicalUri(I,L){if(!I)return;const U=p(I)?I.primary:m(I)?I.modified:void 0,V=p(I)?I.secondary:m(I)?I.original:void 0;if(L?.supportSideBySide&&U&&V){if(L?.supportSideBySide===n.BOTH)return{primary:this.getCanonicalUri(U,{filterByScheme:L.filterByScheme}),secondary:this.getCanonicalUri(V,{filterByScheme:L.filterByScheme})};I=L.supportSideBySide===n.PRIMARY?U:V}if(m(I))return;const ee=I.resource;return!ee||!L||!L.filterByScheme?ee:this.filterUri(ee,L.filterByScheme)}filterUri(I,L){if(Array.isArray(L)){if(L.some(U=>I.scheme===U))return I}else if(L===I.scheme)return I}}e.EditorResourceAccessor=new a;var d;(function(o){o[o.LEFT=0]="LEFT",o[o.RIGHT=1]="RIGHT"})(d=e.CloseDirection||(e.CloseDirection={}));class f{constructor(){this.editorSerializerConstructors=new Map,this.editorSerializerInstances=new Map}start(I){const L=this.instantiationService=I.get(T.IInstantiationService);for(const[U,V]of this.editorSerializerConstructors)this.createEditorSerializer(U,V,L);this.editorSerializerConstructors.clear()}createEditorSerializer(I,L,U){const V=U.createInstance(L);this.editorSerializerInstances.set(I,V)}registerFileEditorFactory(I){if(this.fileEditorFactory)throw new Error("Can only register one file editor factory.");this.fileEditorFactory=I}getFileEditorFactory(){return(0,R.assertIsDefined)(this.fileEditorFactory)}registerEditorSerializer(I,L){if(this.editorSerializerConstructors.has(I)||this.editorSerializerInstances.has(I))throw new Error(`A editor serializer with type ID '${I}' was already registered.`);return this.instantiationService?this.createEditorSerializer(I,L,this.instantiationService):this.editorSerializerConstructors.set(I,L),(0,S.toDisposable)(()=>{this.editorSerializerConstructors.delete(I),this.editorSerializerInstances.delete(I)})}getEditorSerializer(I){return this.editorSerializerInstances.get(typeof I=="string"?I:I.typeId)}}y.Registry.add(e.EditorExtensions.EditorFactory,new f);async function w(o,I){if(!o||!o.length)return[];const L=await Promise.all(o.map(async U=>{const V=k.URI.revive(U.fileUri);if(!V||(await I.activateProvider(V.scheme),!I.canHandleResource(V)))return;const ee=typeof U.exists=="boolean"?U.exists:await I.exists(V);if(!ee&&U.openOnlyIfExists)return;const K=ee&&!(0,R.isUndefined)(U.selection)?{selection:U.selection,pinned:!0,override:U.editorOverrideId}:{pinned:!0,override:U.editorOverrideId};let N;return ee?N={resource:V,options:K,forceFile:!0}:N={resource:V,options:K,forceUntitled:!0},N}));return(0,A.coalesce)(L)}e.pathsToEditors=w;var E;(function(o){o[o.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",o[o.SEQUENTIAL=1]="SEQUENTIAL"})(E=e.EditorsOrder||(e.EditorsOrder={}))}),define(me[208],ge([0,1,3,61,172,4,6,22,34,20,55,25,47,197]),function(J,e,g,R,k,S,T,D,y,A,i,C,u,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TREE_ITEM_DATA_TRANSFER_TYPE=e.ResolvableTreeItem=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.IViewDescriptorService=e.getVisbileViewContextKey=e.FocusedViewContext=e.IViewsService=e.ViewContentGroups=e.getEnabledViewContainerContextKey=e.ViewContainerLocationToString=e.ViewContainerLocation=e.Extensions=e.defaultViewIcon=void 0,e.defaultViewIcon=(0,m.registerIcon)("default-view-icon",u.Codicon.window,(0,k.localize)(0,null));var l;(function(a){a.ViewContainersRegistry="workbench.registry.view.containers",a.ViewsRegistry="workbench.registry.view"})(l=e.Extensions||(e.Extensions={}));var v;(function(a){a[a.Sidebar=0]="Sidebar",a[a.Panel=1]="Panel"})(v=e.ViewContainerLocation||(e.ViewContainerLocation={}));function _(a){switch(a){case 0:return"sidebar";case 1:return"panel"}}e.ViewContainerLocationToString=_;function b(a){return`viewContainer.${a}.enabled`}e.getEnabledViewContainerContextKey=b;class P extends T.Disposable{constructor(){super(...arguments);this._onDidRegister=this._register(new g.Emitter),this.onDidRegister=this._onDidRegister.event,this._onDidDeregister=this._register(new g.Emitter),this.onDidDeregister=this._onDidDeregister.event,this.viewContainers=new Map,this.defaultViewContainers=[]}get all(){return(0,A.flatten)([...this.viewContainers.values()])}registerViewContainer(d,f,w){const E=this.get(d.id);if(E)return E;const o=d;return o.openCommandActionDescriptor=w?.donotRegisterOpenCommand?void 0:o.openCommandActionDescriptor??{id:o.id},(0,D.getOrSet)(this.viewContainers,f,[]).push(o),w?.isDefault&&this.defaultViewContainers.push(o),this._onDidRegister.fire({viewContainer:o,viewContainerLocation:f}),o}deregisterViewContainer(d){for(const f of this.viewContainers.keys()){const w=this.viewContainers.get(f),E=w?.indexOf(d);if(E!==-1){w?.splice(E,1),w.length===0&&this.viewContainers.delete(f),this._onDidDeregister.fire({viewContainer:d,viewContainerLocation:f});return}}}get(d){return this.all.filter(f=>f.id===d)[0]}getViewContainers(d){return[...this.viewContainers.get(d)||[]]}getViewContainerLocation(d){return[...this.viewContainers.keys()].filter(f=>this.getViewContainers(f).filter(w=>w?.id===d.id).length>0)[0]}getDefaultViewContainer(d){return this.defaultViewContainers.find(f=>this.getViewContainerLocation(f)===d)}}y.Registry.add(l.ViewContainersRegistry,new P);var c;(function(a){a.Open="2_open",a.Debug="4_debug",a.SCM="5_scm",a.More="9_more"})(c=e.ViewContentGroups||(e.ViewContentGroups={}));function h(a,d){const f=a.group??c.More,w=d.group??c.More;return f!==w?f.localeCompare(w):(a.order??5)-(d.order??5)}class p extends T.Disposable{constructor(){super(...arguments);this._onViewsRegistered=this._register(new g.Emitter),this.onViewsRegistered=this._onViewsRegistered.event,this._onViewsDeregistered=this._register(new g.Emitter),this.onViewsDeregistered=this._onViewsDeregistered.event,this._onDidChangeContainer=this._register(new g.Emitter),this.onDidChangeContainer=this._onDidChangeContainer.event,this._onDidChangeViewWelcomeContent=this._register(new g.Emitter),this.onDidChangeViewWelcomeContent=this._onDidChangeViewWelcomeContent.event,this._viewContainers=[],this._views=new Map,this._viewWelcomeContents=new i.SetMap}registerViews(d,f){this.registerViews2([{views:d,viewContainer:f}])}registerViews2(d){d.forEach(({views:f,viewContainer:w})=>this.addViews(f,w)),this._onViewsRegistered.fire(d)}deregisterViews(d,f){const w=this.removeViews(d,f);w.length&&this._onViewsDeregistered.fire({views:w,viewContainer:f})}moveViews(d,f){for(const w of this._views.keys())if(w!==f){const E=this.removeViews(d,w);E.length&&(this.addViews(E,f),this._onDidChangeContainer.fire({views:E,from:w,to:f}))}}getViews(d){return this._views.get(d)||[]}getView(d){for(const f of this._viewContainers){const w=(this._views.get(f)||[]).filter(E=>E.id===d)[0];if(w)return w}return null}getViewContainer(d){for(const f of this._viewContainers)if((this._views.get(f)||[]).filter(E=>E.id===d)[0])return f;return null}registerViewWelcomeContent(d,f){return this._viewWelcomeContents.add(d,f),this._onDidChangeViewWelcomeContent.fire(d),(0,T.toDisposable)(()=>{this._viewWelcomeContents.delete(d,f),this._onDidChangeViewWelcomeContent.fire(d)})}registerViewWelcomeContent2(d,f){const w=new Map;for(const[E,o]of f)this._viewWelcomeContents.add(d,o),w.set(E,(0,T.toDisposable)(()=>{this._viewWelcomeContents.delete(d,o),this._onDidChangeViewWelcomeContent.fire(d)}));return this._onDidChangeViewWelcomeContent.fire(d),w}getViewWelcomeContent(d){const f=[];return this._viewWelcomeContents.forEach(d,w=>f.push(w)),f.sort(h)}addViews(d,f){let w=this._views.get(f);w||(w=[],this._views.set(f,w),this._viewContainers.push(f));for(const E of d){if(this.getView(E.id)!==null)throw new Error((0,k.localize)(1,null,E.id));w.push(E)}}removeViews(d,f){const w=this._views.get(f);if(!w)return[];const E=[],o=[];for(const I of w)d.includes(I)?E.push(I):o.push(I);return E.length&&(o.length?this._views.set(f,o):(this._views.delete(f),this._viewContainers.splice(this._viewContainers.indexOf(f),1))),E}}y.Registry.add(l.ViewsRegistry,new p),e.IViewsService=(0,S.createDecorator)("viewsService"),e.FocusedViewContext=new R.RawContextKey("focusedView","",(0,k.localize)(2,null));function t(a){return`view.${a}.visible`}e.getVisbileViewContextKey=t,e.IViewDescriptorService=(0,S.createDecorator)("viewDescriptorService");var r;(function(a){a[a.Default=0]="Default",a[a.Expand=1]="Expand"})(r=e.ViewVisibilityState||(e.ViewVisibilityState={}));var s;(function(a){a[a.None=0]="None",a[a.Collapsed=1]="Collapsed",a[a.Expanded=2]="Expanded"})(s=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));class n{constructor(d,f){this.resolved=!1,this._hasResolve=!1,(0,C.mixin)(this,d),this._hasResolve=!!f,this.resolve=async w=>{if(f&&!this.resolved){const E=await f(w);E&&(this.tooltip=this.tooltip??E.tooltip,this.command=this.command??E.command)}w.isCancellationRequested||(this.resolved=!0)}}get hasResolve(){return this._hasResolve}resetResolve(){this.resolved=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.ResolvableTreeItem=n,e.TREE_ITEM_DATA_TRANSFER_TYPE="text/treeitems"}),define(me[124],ge([0,1,3,16,173]),function(J,e,g,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class S{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new g.Emitter,this._onExit=new g.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(D){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=D}onEvent(D){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=D}onRequest(D){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=D}sendResponse(D){D.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${D.command}`)):this.internalSend("response",D)}sendRequest(D,y,A,i){const C={command:D};if(y&&Object.keys(y).length>0&&(C.arguments=y),this.internalSend("request",C),typeof i=="number"){const u=setTimeout(()=>{clearTimeout(u);const m=this.pendingRequests.get(C.seq);if(m){this.pendingRequests.delete(C.seq);const l={type:"response",seq:0,request_seq:C.seq,success:!1,command:D,message:(0,k.localize)(0,null,i,D)};m(l)}},i)}return A&&this.pendingRequests.set(C.seq,A),C.seq}acceptMessage(D){this.messageCallback?this.messageCallback(D):(this.queue.push(D),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(D,y){return D.type!=="event"||y.type!=="event"}async processQueue(){let D;for(;this.queue.length;){if((!D||this.needsTaskBoundaryBetween(this.queue[0],D))&&await(0,R.timeout)(0),D=this.queue.shift(),!D)return;switch(D.type){case"event":this.eventCallback&&this.eventCallback(D);break;case"request":this.requestCallback&&this.requestCallback(D);break;case"response":const y=D,A=this.pendingRequests.get(y.request_seq);A&&(this.pendingRequests.delete(y.request_seq),A(y));break}}}internalSend(D,y){y.type=D,y.seq=this.sequence++,this.sendMessage(y)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const D=new Map;this.pendingRequests.forEach((y,A)=>D.set(A,y)),await(0,R.timeout)(500),D.forEach((y,A)=>{y({type:"response",seq:0,request_seq:A,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(A)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=S}),define(me[209],ge([0,1,8,2,9,25,10]),function(J,e,g,R,k,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const D=/{([^}]+)}/g;function y(r,s,n){return r.replace(D,function(a,d){return s&&d.length>0&&d[0]!=="_"?a:n&&n.hasOwnProperty(d)?n[d]:a})}e.formatPII=y;function A(r){const s={};for(const n of Object.keys(r))n.startsWith("!")||(s[n]=r[n]);return s}e.filterExceptionsFromTelemetry=A;function i(r){return r.configuration.request==="attach"&&!C(r)&&(!r.parentSession||i(r.parentSession))}e.isSessionAttach=i;function C(r){let s=r.configuration.type;if(!!s)return s==="vslsShare"&&(s=r.configuration.adapterProxy.configuration.type),(0,g.equalsIgnoreCase)(s,"extensionhost")||(0,g.equalsIgnoreCase)(s,"pwa-extensionhost")?r:r.parentSession?C(r.parentSession):void 0}e.getExtensionHostDebugSession=C;function u(r){return r.type&&(r.label||r.program||r.runtime)}e.isDebuggerMainContribution=u;function m(r,s,n){let a,d=0,f=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g,w=null;for(;w=f.exec(r);){let E=w.index+1,o=E+w[0].length;if(E<=s&&o>=n){a=w[0],d=E;break}}if(a){let E=/\w+/g,o=null;for(;(o=E.exec(a))&&!(o.index+1+d+o[0].length>=n););o&&(a=a.substring(0,E.lastIndex))}return a?{start:d,end:d+a.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=m;const l=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function v(r){return!!(r&&r.match(l))}e.isUri=v;function _(r){if(typeof r.path=="string"&&!(typeof r.sourceReference=="number"&&r.sourceReference>0)){if(v(r.path))return R.URI.parse(r.path);if((0,k.isAbsolute)(r.path))return R.URI.file(r.path)}return r.path}function b(r){if(typeof r.path=="object"){const s=R.URI.revive(r.path);if(s)return s.scheme===T.Schemas.file?s.fsPath:s.toString()}return r.path}function P(r,s){const n=s?_:b,a=(0,S.deepClone)(r);return h(a,(d,f)=>{d&&f&&(f.path=n(f))}),a}e.convertToDAPaths=P;function c(r,s){const n=s?_:b,a=(0,S.deepClone)(r);return h(a,(d,f)=>{!d&&f&&(f.path=n(f))}),a}e.convertToVSCPaths=c;function h(r,s){switch(r.type){case"event":const n=r;switch(n.event){case"output":s(!1,n.body.source);break;case"loadedSource":s(!1,n.body.source);break;case"breakpoint":s(!1,n.body.breakpoint.source);break;default:break}break;case"request":const a=r;switch(a.command){case"setBreakpoints":s(!0,a.arguments.source);break;case"breakpointLocations":s(!0,a.arguments.source);break;case"source":s(!0,a.arguments.source);break;case"gotoTargets":s(!0,a.arguments.source);break;case"launchVSCode":a.arguments.args.forEach(f=>s(!1,f));break;default:break}break;case"response":const d=r;if(d.success&&d.body)switch(d.command){case"stackTrace":d.body.stackFrames.forEach(f=>s(!1,f.source));break;case"loadedSources":d.body.sources.forEach(f=>s(!1,f));break;case"scopes":d.body.scopes.forEach(f=>s(!1,f.source));break;case"setFunctionBreakpoints":d.body.breakpoints.forEach(f=>s(!1,f.source));break;case"setBreakpoints":d.body.breakpoints.forEach(f=>s(!1,f.source));break;default:break}break}}function p(r){return r.filter(s=>!s.presentation?.hidden).sort((s,n)=>s.presentation?n.presentation?s.presentation.group?n.presentation.group?s.presentation.group!==n.presentation.group?s.presentation.group.localeCompare(n.presentation.group):t(s.presentation.order,n.presentation.order):-1:n.presentation.group?1:t(s.presentation.order,n.presentation.order):-1:n.presentation?1:0)}e.getVisibleAndSorted=p;function t(r,s){return typeof r!="number"?typeof s!="number"?0:1:typeof s!="number"?-1:r-s}}),define(me[210],ge([0,1,28,39,174,125,9,8,25,11,184,124]),function(J,e,g,R,k,S,T,D,y,A,i,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExecutableDebugAdapter=e.NamedPipeDebugAdapter=e.SocketDebugAdapter=e.NetworkDebugAdapter=e.StreamDebugAdapter=void 0;class u extends C.AbstractDebugAdapter{constructor(){super();this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1}connect(P,c){this.outputStream=c,this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1,P.on("data",h=>this.handleData(h))}sendMessage(P){if(this.outputStream){const c=JSON.stringify(P);this.outputStream.write(`Content-Length: ${Buffer.byteLength(c,"utf8")}${u.TWO_CRLF}${c}`,"utf8")}}handleData(P){for(this.rawData=Buffer.concat([this.rawData,P]);;){if(this.contentLength>=0){if(this.rawData.length>=this.contentLength){const c=this.rawData.toString("utf8",0,this.contentLength);if(this.rawData=this.rawData.slice(this.contentLength),this.contentLength=-1,c.length>0)try{this.acceptMessage(JSON.parse(c))}catch(h){this._onError.fire(new Error((h.message||h)+`
`+c))}continue}}else{const c=this.rawData.indexOf(u.TWO_CRLF);if(c!==-1){const p=this.rawData.toString("utf8",0,c).split(u.HEADER_LINESEPARATOR);for(const t of p){const r=t.split(u.HEADER_FIELDSEPARATOR);r[0]==="Content-Length"&&(this.contentLength=Number(r[1]))}this.rawData=this.rawData.slice(c+u.TWO_CRLF.length);continue}}break}}}e.StreamDebugAdapter=u,u.TWO_CRLF=`\r
\r
`,u.HEADER_LINESEPARATOR=/\r?\n/,u.HEADER_FIELDSEPARATOR=/: */;class m extends u{startSession(){return new Promise((P,c)=>{let h=!1;this.socket=this.createConnection(()=>{this.connect(this.socket,this.socket),P(),h=!0}),this.socket.on("close",()=>{h?this._onError.fire(new Error("connection closed")):c(new Error("connection closed"))}),this.socket.on("error",p=>{h?this._onError.fire(p):c(p)})})}async stopSession(){await this.cancelPendingRequests(),this.socket&&(this.socket.end(),this.socket=void 0)}}e.NetworkDebugAdapter=m;class l extends m{constructor(P){super();this.adapterServer=P}createConnection(P){return S.createConnection(this.adapterServer.port,this.adapterServer.host||"127.0.0.1",P)}}e.SocketDebugAdapter=l;class v extends m{constructor(P){super();this.adapterServer=P}createConnection(P){return S.createConnection(this.adapterServer.path,P)}}e.NamedPipeDebugAdapter=v;class _ extends u{constructor(P,c,h){super();this.adapterExecutable=P,this.debugType=c,this.outputService=h}async startSession(){const P=this.adapterExecutable.command,c=this.adapterExecutable.args,h=this.adapterExecutable.options||{};try{if(P)if(T.isAbsolute(P)){if(!await g.Promises.exists(P))throw new Error(k.localize(0,null,P))}else P.indexOf("/")<0&&P.indexOf("\\")<0;else throw new Error(k.localize(1,null,this.debugType));let p=process.env;if(h.env&&Object.keys(h.env).length>0&&(p=y.mixin(y.deepClone(process.env),h.env)),P==="node")if(Array.isArray(c)&&c.length>0){const r=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,s={env:p,execArgv:r?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};h.cwd&&(s.cwd=h.cwd);const n=R.fork(c[0],c.slice(1),s);if(!n.pid)throw new Error(k.localize(2,null,c[0]));this.serverProcess=n}else throw new Error(k.localize(3,null));else{const r={env:p};h.cwd&&(r.cwd=h.cwd),this.serverProcess=R.spawn(P,c,r)}this.serverProcess.on("error",r=>{this._onError.fire(r)}),this.serverProcess.on("exit",(r,s)=>{this._onExit.fire(r)}),this.serverProcess.stdout.on("close",()=>{this._onError.fire(new Error("read error"))}),this.serverProcess.stdout.on("error",r=>{this._onError.fire(r)}),this.serverProcess.stdin.on("error",r=>{this._onError.fire(r)});const t=this.outputService;if(t){const r=s=>s.toString().replace(/\r?\n$/mg,"");this.serverProcess.stderr.on("data",s=>{const n=t.getChannel(i.ExtensionsChannelId);n&&n.append(r(s))})}else this.serverProcess.stderr.resume();this.connect(this.serverProcess.stdout,this.serverProcess.stdin)}catch(p){this._onError.fire(p)}}async stopSession(){return this.serverProcess?(await this.cancelPendingRequests(),A.isWindows?new Promise((P,c)=>{const h=R.exec(`taskkill /F /T /PID ${this.serverProcess.pid}`,function(p,t,r){if(p)return c(p)});h.on("exit",P),h.on("error",c)}):(this.serverProcess.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static extract(P,c){if(!P)return;const h=Object.create(null);P.runtime&&(P.runtime.indexOf("./")===0?h.runtime=T.join(c,P.runtime):h.runtime=P.runtime),P.runtimeArgs&&(h.runtimeArgs=P.runtimeArgs),P.program&&(T.isAbsolute(P.program)?h.program=P.program:h.program=T.join(c,P.program)),P.args&&(h.args=P.args);const p=P;return p.win&&(h.win=_.extract(p.win,c)),p.winx86&&(h.winx86=_.extract(p.winx86,c)),p.windows&&(h.windows=_.extract(p.windows,c)),p.osx&&(h.osx=_.extract(p.osx,c)),p.linux&&(h.linux=_.extract(p.linux,c)),h}static platformAdapterExecutable(P,c){let h=Object.create(null);c=c.toLowerCase();for(const a of P)if(a.contributes){const d=a.contributes.debuggers;d&&d.length>0&&d.filter(f=>typeof f.type=="string"&&D.equalsIgnoreCase(f.type,c)).forEach(f=>{const w=_.extract(f,a.extensionLocation.fsPath);h=y.mixin(h,w,a.isBuiltin)})}let p;A.isWindows&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?p=h.winx86||h.win||h.windows:A.isWindows?p=h.win||h.windows:A.isMacintosh?p=h.osx:A.isLinux&&(p=h.linux),p=p||h;let t=p.program||h.program;const r=p.args||h.args;let s=p.runtime||h.runtime;const n=p.runtimeArgs||h.runtimeArgs;if(s)return{type:"executable",command:s,args:(n||[]).concat(typeof t=="string"?[t]:[]).concat(r||[])};if(t)return{type:"executable",command:t,args:r||[]}}}e.ExecutableDebugAdapter=_}),define(me[211],ge([0,1,39,11,29,187]),function(J,e,g,R,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prepareCommand=e.hasChildProcesses=e.runInExternalTerminal=void 0;function T(u,m){return new Promise((l,v)=>{let _="";const b=g.spawn(u,m);b.pid&&b.stdout.on("data",P=>{_+=P.toString()}),b.on("error",P=>{v(P)}),b.on("close",P=>{l(_)})})}let D;function y(u,m){if(!D)if(R.isWindows)D=new S.WindowsExternalTerminalService;else if(R.isMacintosh)D=new S.MacExternalTerminalService;else if(R.isLinux)D=new S.LinuxExternalTerminalService;else throw new Error("external terminals not supported on this platform");const l=m.getConfiguration("terminal");return D.runInTerminal(u.title,u.cwd,u.args,u.env||{},l.external||{})}e.runInExternalTerminal=y;function A(u){return u?R.isWindows?new Promise(async m=>{(await new Promise((v,_)=>{J(["windows-process-tree"],v,_)})).getProcessTree(u,v=>{m(v.children.length>0)})}):T("/usr/bin/pgrep",["-lP",String(u)]).then(m=>{const l=m.trim();return!(l.length===0||l.indexOf(" tmux")>=0)},m=>!0):Promise.resolve(!0)}e.hasChildProcesses=A;var i;(function(u){u[u.cmd=0]="cmd",u[u.powershell=1]="powershell",u[u.bash=2]="bash"})(i||(i={}));function C(u,m,l,v){u=u.trim().toLowerCase();let _;u.indexOf("powershell")>=0||u.indexOf("pwsh")>=0?_=1:u.indexOf("cmd.exe")>=0?_=0:u.indexOf("bash")>=0?_=2:R.isWindows?_=0:_=2;let b,P=" ";switch(_){case 1:if(b=h=>(h=h.replace(/\'/g,"''"),h.length>0&&h.charAt(h.length-1)==="\\"?`'${h}\\'`:`'${h}'`),l){const h=(0,k.getDriveLetter)(l);h&&(P+=`${h}:; `),P+=`cd ${b(l)}; `}if(v)for(let h in v){const p=v[h];p===null?P+=`Remove-Item env:${h}; `:P+=`\${env:${h}}='${p}'; `}if(m.length>0){const h=b(m.shift());P+=h[0]==="'"?`& ${h} `:`${h} `;for(let p of m)P+=`${b(p)} `}break;case 0:if(b=h=>(h=h.replace(/\"/g,'""'),h.indexOf(" ")>=0||h.indexOf('"')>=0||h.length===0?`"${h}"`:h),l){const h=(0,k.getDriveLetter)(l);h&&(P+=`${h}: && `),P+=`cd ${b(l)} && `}if(v){P+='cmd /C "';for(let h in v){let p=v[h];p===null?P+=`set "${h}=" && `:(p=p.replace(/[\^\&\|\<\>]/g,t=>`^${t}`),P+=`set "${h}=${p}" && `)}}for(let h of m)P+=`${b(h)} `;v&&(P+='"');break;case 2:b=h=>(h=h.replace(/(["'\\\$])/g,"\\$1"),h.indexOf(" ")>=0||h.indexOf(";")>=0||h.length===0?`"${h}"`:h);const c=h=>/[^\w@%\/+=,.:^-]/.test(h)?`'${h.replace(/'/g,"'\\''")}'`:h;if(l&&(P+=`cd ${b(l)} ; `),v){P+="/usr/bin/env";for(let h in v){const p=v[h];p===null?P+=` -u ${c(h)}`:P+=` ${c(`${h}=${p}`)}`}P+=" "}for(let h of m)P+=`${b(h)} `;break}return P}e.prepareCommand=C}),define(me[89],ge([0,1,30,102,10,9,11,61]),function(J,e,g,R,k,S,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.GlobalToolbarShowLabel=e.TextOutputLineLimit=e.OpenGettingStarted=e.ConsolidatedRunButton=e.NotebookCellEditorOptionsCustomizations=e.DragAndDropEnabled=e.ShowFoldingControls=e.ConsolidatedOutputButton=e.UndoRedoPerCell=e.GlobalToolbar=e.InsertToolbarLocation=e.FocusIndicator=e.CompactView=e.ExperimentalInsertToolbarAlignment=e.NotebookTextDiffEditorPreview=e.ShowCellStatusBar=e.CellToolbarVisibility=e.CellToolbarLocation=e.DisplayOrderKey=e.CellSequence=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.sortMimeTypes=e.mimeTypeIsMergeable=e.mimeTypeSupportedByCore=e.mimeTypeIsAlwaysSecure=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.BUILTIN_RENDERER_ID=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=void 0;var y;(function(o){o[o.Markup=1]="Markup",o[o.Code=2]="Code"})(y=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",R.Mimes.markdown,"image/png","image/jpeg",R.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[R.Mimes.markdown,"application/json",R.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.BUILTIN_RENDERER_ID="_builtin",e.RENDERER_NOT_AVAILABLE="_notAvailable";var A;(function(o){o[o.Running=1]="Running",o[o.Idle=2]="Idle"})(A=e.NotebookRunState||(e.NotebookRunState={}));var i;(function(o){o[o.Pending=2]="Pending",o[o.Executing=3]="Executing"})(i=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var C;(function(o){o[o.WithHardKernelDependency=0]="WithHardKernelDependency",o[o.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",o[o.Pure=2]="Pure",o[o.Never=3]="Never"})(C=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var u;(function(o){o.Always="always",o.Never="never",o.Optional="optional"})(u=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var m;(function(o){o[o.ModelChange=1]="ModelChange",o[o.Move=2]="Move",o[o.ChangeLanguage=5]="ChangeLanguage",o[o.Initialize=6]="Initialize",o[o.ChangeCellMetadata=7]="ChangeCellMetadata",o[o.Output=8]="Output",o[o.OutputItem=9]="OutputItem",o[o.ChangeCellContent=10]="ChangeCellContent",o[o.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",o[o.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",o[o.ChangeCellMime=13]="ChangeCellMime",o[o.Unknown=100]="Unknown"})(m=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var l;(function(o){o[o.Handle=0]="Handle",o[o.Index=1]="Index"})(l=e.SelectionStateType||(e.SelectionStateType={}));var v;(function(o){o[o.Replace=1]="Replace",o[o.Output=2]="Output",o[o.Metadata=3]="Metadata",o[o.CellLanguage=4]="CellLanguage",o[o.DocumentMetadata=5]="DocumentMetadata",o[o.Move=6]="Move",o[o.OutputItems=7]="OutputItems",o[o.PartialMetadata=8]="PartialMetadata",o[o.PartialInternalMetadata=9]="PartialInternalMetadata"})(v=e.CellEditType||(e.CellEditType={}));var _;(function(o){o.scheme=k.Schemas.vscodeNotebookCell;const I=/^ch(\d{7,})/;function L(N,x){return N.with({scheme:o.scheme,fragment:`ch${x.toString().padStart(7,"0")}${N.scheme!==k.Schemas.file?N.scheme:""}`})}o.generate=L;function U(N){if(N.scheme!==o.scheme)return;const x=I.exec(N.fragment);return x?{handle:Number(x[1]),notebook:N.with({scheme:N.fragment.substr(x[0].length)||k.Schemas.file,fragment:null})}:void 0}o.parse=U;function V(N){if(N.scheme!==k.Schemas.vscodeNotebookCellMetadata)return;const x=I.exec(N.fragment);return x?{handle:Number(x[1]),notebook:N.with({scheme:N.fragment.substr(x[0].length)||k.Schemas.file,fragment:null})}:void 0}o.parseCellMetadataUri=V;function ee(N,x,F){return N.with({scheme:F,fragment:`ch${x.toString().padStart(7,"0")}${N.scheme!==k.Schemas.file?N.scheme:""}`})}o.generateCellUri=ee;function K(N,x){if(N.scheme!==x)return;const F=I.exec(N.fragment);return F?{handle:Number(F[1]),notebook:N.with({scheme:N.fragment.substr(F[0].length)||k.Schemas.file,fragment:null})}:void 0}o.parseCellUri=K})(_=e.CellUri||(e.CellUri={}));const b=new Map([["application/javascript",{supportedByCore:!0}],["image/png",{alwaysSecure:!0,supportedByCore:!0}],["image/jpeg",{alwaysSecure:!0,supportedByCore:!0}],["image/git",{alwaysSecure:!0,supportedByCore:!0}],["image/svg+xml",{supportedByCore:!0}],["application/json",{alwaysSecure:!0,supportedByCore:!0}],[R.Mimes.markdown,{alwaysSecure:!0,supportedByCore:!0}],[R.Mimes.text,{alwaysSecure:!0,supportedByCore:!0}],["text/html",{supportedByCore:!0}],["text/x-javascript",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.error",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.stdout",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/vnd.code.notebook.stderr",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}]]);function P(o){return b.get(o)?.alwaysSecure??!1}e.mimeTypeIsAlwaysSecure=P;function c(o){return b.get(o)?.supportedByCore??!1}e.mimeTypeSupportedByCore=c;function h(o){return b.get(o)?.mergeable??!1}e.mimeTypeIsMergeable=h;function p(o,I){return T.isWindows&&(o=o.replace(/\//g,"\\"),I=I.replace(/\//g,"\\")),g.match(o,I)}function t(o,I,L){let U=0;for(let V=0;V<I.length;V++){if(p(I[V],o))return U;U++}for(let V=0;V<L.length;V++){if(p(L[V],o))return U;U++}return U}function r(o,I,L){return o.sort((U,V)=>t(U,I,L)-t(V,I,L))}e.sortMimeTypes=r;function s(o,I,L,U=(V,ee)=>V===ee){const V=[];function ee(x,F,z){if(F===0&&z.length===0)return;const M=V[V.length-1];M&&M.start+M.deleteCount===x?(M.deleteCount+=F,M.toInsert.push(...z)):V.push({start:x,deleteCount:F,toInsert:z})}let K=0,N=0;for(;;){if(K===o.length){ee(K,0,I.slice(N));break}if(N===I.length){ee(K,o.length-K,[]);break}const x=o[K],F=I[N];if(U(x,F)){K+=1,N+=1;continue}L(F)?(ee(K,1,[]),K+=1):(ee(K,0,[F]),N+=1)}return V}e.diff=s,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new D.RawContextKey("notebookEditorCursorAtBoundary","none");var n;(function(o){o.default="default",o.option="option"})(n=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function a(o){const I=o;return!!((typeof I.include=="string"||g.isRelativePattern(I.include))&&(typeof I.exclude=="string"||g.isRelativePattern(I.exclude)))}e.isDocumentExcludePattern=a;function d(o,I,L){if(Array.isArray(o.viewType)&&o.viewType.indexOf(I)>=0||o.viewType===I)return!0;if(o.filenamePattern){let U=a(o.filenamePattern)?o.filenamePattern.include:o.filenamePattern,V=a(o.filenamePattern)?o.filenamePattern.exclude:void 0;if(g.match(U,(0,S.basename)(L.fsPath).toLowerCase()))return!(V&&g.match(V,(0,S.basename)(L.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=d;class f{constructor(I){this.textModel=I}getElements(){const I=new Int32Array(this.textModel.cells.length);for(let L=0;L<this.textModel.cells.length;L++)I[L]=this.textModel.cells[L].getHashValue();return I}}e.CellSequence=f,e.DisplayOrderKey="notebook.displayOrder",e.CellToolbarLocation="notebook.cellToolbarLocation",e.CellToolbarVisibility="notebook.cellToolbarVisibility",e.ShowCellStatusBar="notebook.showCellStatusBar",e.NotebookTextDiffEditorPreview="notebook.diff.enablePreview",e.ExperimentalInsertToolbarAlignment="notebook.experimental.insertToolbarAlignment",e.CompactView="notebook.compactView",e.FocusIndicator="notebook.cellFocusIndicator",e.InsertToolbarLocation="notebook.insertToolbarLocation",e.GlobalToolbar="notebook.globalToolbar",e.UndoRedoPerCell="notebook.undoRedoPerCell",e.ConsolidatedOutputButton="notebook.consolidatedOutputButton",e.ShowFoldingControls="notebook.showFoldingControls",e.DragAndDropEnabled="notebook.dragAndDropEnabled",e.NotebookCellEditorOptionsCustomizations="notebook.editorOptionsCustomizations",e.ConsolidatedRunButton="notebook.consolidatedRunButton",e.OpenGettingStarted="notebook.experimental.openGettingStarted",e.TextOutputLineLimit="notebook.output.textLineLimit",e.GlobalToolbarShowLabel="notebook.globalToolbarShowLabel";var w;(function(o){o[o.Left=1]="Left",o[o.Right=2]="Right"})(w=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class E{static create(I){return`${E._prefix}${I}`}static parse(I){if(I.startsWith(E._prefix))return I.substr(E._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=E,E._prefix="notebook/"}),define(me[212],ge([0,1,176,4,61]),function(J,e,g,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USER_TASKS_GROUP_KEY=e.ITaskService=e.ProcessExecutionSupportedContext=e.ShellExecutionSupportedContext=e.CustomExecutionSupportedContext=void 0,e.CustomExecutionSupportedContext=new k.RawContextKey("customExecutionSupported",!0,g.localize(0,null)),e.ShellExecutionSupportedContext=new k.RawContextKey("shellExecutionSupported",!1,g.localize(1,null)),e.ProcessExecutionSupportedContext=new k.RawContextKey("processExecutionSupported",!1,g.localize(2,null)),e.ITaskService=(0,R.createDecorator)("taskService"),e.USER_TASKS_GROUP_KEY="settings"}),define(me[213],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function g(k){return[...k.entries()]}e.serializeEnvironmentVariableCollection=g;function R(k){return new Map(k)}e.deserializeEnvironmentVariableCollection=R}),define(me[126],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.TestDiffOpType=e.DetailType=e.applyTestItemUpdate=e.TestItemExpandState=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.identifyTest=e.TestResultState=void 0;var g;(function(C){C[C.Unset=0]="Unset",C[C.Queued=1]="Queued",C[C.Running=2]="Running",C[C.Passed=3]="Passed",C[C.Failed=4]="Failed",C[C.Skipped=5]="Skipped",C[C.Errored=6]="Errored"})(g=e.TestResultState||(e.TestResultState={}));const R=C=>({testId:C.item.extId,controllerId:C.controllerId});e.identifyTest=R;var k;(function(C){C[C.Run=2]="Run",C[C.Debug=4]="Debug",C[C.Coverage=8]="Coverage",C[C.HasNonDefaultProfile=16]="HasNonDefaultProfile",C[C.HasConfigurable=32]="HasConfigurable"})(k=e.TestRunProfileBitset||(e.TestRunProfileBitset={})),e.testRunProfileBitsetList=[2,4,8,16];var S;(function(C){C[C.NotExpandable=0]="NotExpandable",C[C.Expandable=1]="Expandable",C[C.BusyExpanding=2]="BusyExpanding",C[C.Expanded=3]="Expanded"})(S=e.TestItemExpandState||(e.TestItemExpandState={}));const T=(C,u)=>{u.expand!==void 0&&(C.expand=u.expand),u.item!==void 0&&(C.item=C.item?Object.assign(C.item,u.item):u.item)};e.applyTestItemUpdate=T;var D;(function(C){C[C.Function=0]="Function",C[C.Statement=1]="Statement"})(D=e.DetailType||(e.DetailType={}));var y;(function(C){C[C.Add=0]="Add",C[C.Update=1]="Update",C[C.Remove=2]="Remove",C[C.IncrementPendingExtHosts=3]="IncrementPendingExtHosts",C[C.Retire=4]="Retire"})(y=e.TestDiffOpType||(e.TestDiffOpType={}));class A{add(u){}update(u){}remove(u,m){}complete(){}}e.IncrementalChangeCollector=A;class i{constructor(){this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0}apply(u){const m=this.createChangeCollector();for(const l of u)switch(l[0]){case 0:{const v=l[1];if(v.parent){if(this.items.has(v.parent)){const _=this.items.get(v.parent);_.children.add(v.item.extId);const b=this.createItem(v,_);this.items.set(v.item.extId,b),m.add(b)}}else{const _=this.createItem(v);this.roots.add(_),this.items.set(v.item.extId,_),m.add(_)}v.expand===2&&this.busyControllerCount++;break}case 1:{const v=l[1],_=this.items.get(v.extId);if(!_)break;v.expand!==void 0&&(_.expand===2&&this.busyControllerCount--,v.expand===2&&this.busyControllerCount++),(0,e.applyTestItemUpdate)(_,v),m.update(_);break}case 2:{const v=this.items.get(l[1]);if(!v)break;v.parent?this.items.get(v.parent).children.delete(v.item.extId):this.roots.delete(v);const _=[[l[1]]];for(;_.length;)for(const b of _.pop()){const P=this.items.get(b);P&&(_.push(P.children),this.items.delete(b),m.remove(P,P!==v),P.expand===2&&this.busyControllerCount--)}break}case 4:this.retireTest(l[1]);break;case 3:this.updatePendingRoots(l[1]);break}m.complete()}retireTest(u){}updatePendingRoots(u){this.pendingRootCount+=u}createChangeCollector(){return new A}}e.AbstractIncrementalTestCollection=i}),define(me[90],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var g;(function(S){S.Delimiter="\0"})(g=e.TestIdPathParts||(e.TestIdPathParts={}));var R;(function(S){S[S.IsSame=0]="IsSame",S[S.Disconnected=1]="Disconnected",S[S.IsChild=2]="IsChild",S[S.IsParent=3]="IsParent"})(R=e.TestPosition||(e.TestPosition={}));class k{constructor(T,D=T.length){if(this.path=T,this.viewEnd=D,T.length===0||D<1)throw new Error("cannot create test with empty path")}static fromExtHostTestItem(T,D,y=T.parent){if(T.id===D)return new k([D]);let A=[T.id];for(let i=y;i&&i.id!==D;i=i.parent)A.push(i.id);return A.push(D),new k(A.reverse())}static fromString(T){return new k(T.split("\0"))}static join(T,D){return new k([...T.path,D])}static joinToString(T,D){return T.toString()+"\0"+D}static compare(T,D){return T===D?0:D.startsWith(T+"\0")?2:T.startsWith(D+"\0")?3:1}get parentId(){return this.viewEnd>1?new k(this.path,this.viewEnd-1):this}get localId(){return this.path[this.viewEnd-1]}get controllerId(){return this.path[0]}get isRoot(){return this.viewEnd===1}*idsFromRoot(){let T=this.path[0];yield T;for(let D=1;D<this.viewEnd;D++)T+="\0",T+=this.path[D],yield T}compare(T){if(typeof T=="string")return k.compare(this.toString(),T);for(let D=0;D<T.viewEnd&&D<this.viewEnd;D++)if(T.path[D]!==this.path[D])return 1;return T.viewEnd>this.viewEnd?2:T.viewEnd<this.viewEnd?3:0}toJSON(){return this.toString()}toString(){if(!this.stringifed){this.stringifed=this.path[0];for(let T=1;T<this.viewEnd;T++)this.stringifed+="\0",this.stringifed+=this.path[T]}return this.stringifed}}e.TestId=k}),define(me[214],ge([0,1,9,38,14,25,11,77,177]),function(J,e,g,R,k,S,T,D,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class A{constructor(C,u,m){this._contributedVariables=new Map,this._context=C,this._labelService=u,m&&(this._envVariablesPromise=m.then(l=>this.prepareEnv(l)))}prepareEnv(C){if(T.isWindows){const u=Object.create(null);return Object.keys(C).forEach(m=>{u[m.toLowerCase()]=C[m]}),u}return C}resolveWithEnvironment(C,u,m){return this.recursiveResolve(this.prepareEnv(C),u?u.uri:void 0,m)}async resolveAsync(C,u){return this.recursiveResolve(await this._envVariablesPromise,C?C.uri:void 0,u)}async resolveAnyBase(C,u,m,l){const v=S.deepClone(u);return T.isWindows&&v.windows?Object.keys(v.windows).forEach(_=>v[_]=v.windows[_]):T.isMacintosh&&v.osx?Object.keys(v.osx).forEach(_=>v[_]=v.osx[_]):T.isLinux&&v.linux&&Object.keys(v.linux).forEach(_=>v[_]=v.linux[_]),delete v.windows,delete v.osx,delete v.linux,this.recursiveResolve(await this._envVariablesPromise,C?C.uri:void 0,v,m,l)}async resolveAnyAsync(C,u,m){return this.resolveAnyBase(C,u,m)}async resolveAnyMap(C,u,m){const l=new Map;return{newConfig:await this.resolveAnyBase(C,u,m,l),resolvedVariables:l}}resolveWithInteractionReplace(C,u,m,l){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(C,u,m,l){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(C,u){if(this._contributedVariables.has(C))throw new Error("Variable "+C+" is contributed twice.");this._contributedVariables.set(C,u)}recursiveResolve(C,u,m,l,v){if(k.isString(m))return this.resolveString(C,u,m,l,v);if(k.isArray(m))return m.map(_=>this.recursiveResolve(C,u,_,l,v));if(k.isObject(m)){let _=Object.create(null);return Object.keys(m).forEach(b=>{const P=this.resolveString(C,u,b,l,v);_[P]=this.recursiveResolve(C,u,m[b],l,v)}),_}return m}resolveString(C,u,m,l,v){return m.replace(A.VARIABLE_REGEXP,(b,P)=>{if(P.includes(A.VARIABLE_LHS))return b;let c=this.evaluateSingleVariable(C,b,P,u,l);return v&&v.set(P,c),c!==b&&k.isString(c)&&c.match(A.VARIABLE_REGEXP)&&(c=this.resolveString(C,u,c,l,v)),c})}fsPath(C){return this._labelService?this._labelService.getUriLabel(C,{noPrefix:!0}):C.fsPath}evaluateSingleVariable(C,u,m,l,v){let _;const b=m.split(":");b.length>1&&(m=b[0],_=b[1]);const P=()=>{const p=this._context.getFilePath();if(p)return p;throw new Error((0,y.localize)(0,null,u))},c=()=>{const p=P();if(this._context.getWorkspaceFolderPathForFile){const t=this._context.getWorkspaceFolderPathForFile();if(t)return t}throw new Error((0,y.localize)(1,null,u,g.basename(p)))},h=()=>{if(_){const p=this._context.getFolderUri(_);if(p)return p;throw new Error((0,y.localize)(2,null,u,_))}if(l)return l;throw this._context.getWorkspaceFolderCount()>1?new Error((0,y.localize)(3,null,u)):new Error((0,y.localize)(4,null,u))};switch(m){case"env":if(_){if(C){const p=C[T.isWindows?_.toLowerCase():_];if(k.isString(p))return p}return""}throw new Error((0,y.localize)(5,null,u));case"config":if(_){const p=this._context.getConfigurationValue(l,_);if(k.isUndefinedOrNull(p))throw new Error((0,y.localize)(6,null,u,_));if(k.isObject(p))throw new Error((0,y.localize)(7,null,u,_));return p}throw new Error((0,y.localize)(8,null,u));case"command":return this.resolveFromMap(u,_,v,"command");case"input":return this.resolveFromMap(u,_,v,"input");default:switch(m){case"workspaceRoot":case"workspaceFolder":return(0,D.normalizeDriveLetter)(this.fsPath(h()));case"cwd":return l||_?(0,D.normalizeDriveLetter)(this.fsPath(h())):R.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return g.basename(this.fsPath(h()));case"lineNumber":const p=this._context.getLineNumber();if(p)return p;throw new Error((0,y.localize)(9,null,u));case"selectedText":const t=this._context.getSelectedText();if(t)return t;throw new Error((0,y.localize)(10,null,u));case"file":return P();case"fileWorkspaceFolder":return c();case"relativeFile":return l||_?g.relative(this.fsPath(h()),P()):P();case"relativeFileDirname":const r=g.dirname(P());if(l||_){const d=g.relative(this.fsPath(h()),r);return d.length===0?".":d}return r;case"fileDirname":return g.dirname(P());case"fileExtname":return g.extname(P());case"fileBasename":return g.basename(P());case"fileBasenameNoExtension":const s=g.basename(P());return s.slice(0,s.length-g.extname(s).length);case"fileDirnameBasename":return g.basename(g.dirname(P()));case"execPath":const n=this._context.getExecPath();return n||u;case"execInstallFolder":const a=this._context.getAppRoot();return a||u;case"pathSeparator":return g.sep;default:try{const d=_?`${m}:${_}`:m;return this.resolveFromMap(u,d,v,void 0)}catch(d){return u}}}}resolveFromMap(C,u,m,l){if(u&&m){const v=l===void 0?m[u]:m[l+":"+u];if(typeof v=="string")return v;throw new Error((0,y.localize)(11,null,C))}return C}}e.AbstractVariableResolverService=A,A.VARIABLE_LHS="${",A.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(me[127],ge([0,1,4,207]),function(J,e,g,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupChangeKind=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,g.createDecorator)("editorGroupsService");var k;(function(v){v[v.UP=0]="UP",v[v.DOWN=1]="DOWN",v[v.LEFT=2]="LEFT",v[v.RIGHT=3]="RIGHT"})(k=e.GroupDirection||(e.GroupDirection={}));var S;(function(v){v[v.HORIZONTAL=0]="HORIZONTAL",v[v.VERTICAL=1]="VERTICAL"})(S=e.GroupOrientation||(e.GroupOrientation={}));var T;(function(v){v[v.FIRST=0]="FIRST",v[v.LAST=1]="LAST",v[v.NEXT=2]="NEXT",v[v.PREVIOUS=3]="PREVIOUS"})(T=e.GroupLocation||(e.GroupLocation={}));var D;(function(v){v[v.MINIMIZE_OTHERS=0]="MINIMIZE_OTHERS",v[v.EVEN=1]="EVEN",v[v.TOGGLE=2]="TOGGLE"})(D=e.GroupsArrangement||(e.GroupsArrangement={}));var y;(function(v){v[v.COPY_EDITORS=0]="COPY_EDITORS",v[v.MOVE_EDITORS=1]="MOVE_EDITORS"})(y=e.MergeGroupMode||(e.MergeGroupMode={}));function A(v){const _=v;return(0,R.isEditorInput)(_?.editor)&&(0,R.isEditorInput)(_?.replacement)}e.isEditorReplacement=A;var i;(function(v){v[v.CREATION_TIME=0]="CREATION_TIME",v[v.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",v[v.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(i=e.GroupsOrder||(e.GroupsOrder={}));var C;(function(v){v[v.GROUP_ACTIVE=0]="GROUP_ACTIVE",v[v.GROUP_INDEX=1]="GROUP_INDEX",v[v.EDITOR_OPEN=2]="EDITOR_OPEN",v[v.EDITOR_CLOSE=3]="EDITOR_CLOSE",v[v.EDITOR_MOVE=4]="EDITOR_MOVE",v[v.EDITOR_ACTIVE=5]="EDITOR_ACTIVE",v[v.EDITOR_LABEL=6]="EDITOR_LABEL",v[v.EDITOR_CAPABILITIES=7]="EDITOR_CAPABILITIES",v[v.EDITOR_PIN=8]="EDITOR_PIN",v[v.EDITOR_STICKY=9]="EDITOR_STICKY",v[v.EDITOR_DIRTY=10]="EDITOR_DIRTY"})(C=e.GroupChangeKind||(e.GroupChangeKind={}));var u;(function(v){v[v.NEW_EDITOR=1]="NEW_EDITOR",v[v.MOVE_EDITOR=2]="MOVE_EDITOR",v[v.COPY_EDITOR=3]="COPY_EDITOR"})(u=e.OpenEditorContext||(e.OpenEditorContext={}));function m(v){const _=v;return!!_&&typeof _.id=="number"&&Array.isArray(_.editors)}e.isEditorGroup=m;function l(v){return v.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=l}),define(me[215],ge([0,1,4,127]),function(J,e,g,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,g.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function k(S){const T=S;return typeof S=="number"||(0,R.isEditorGroup)(T)}e.isPreferredGroup=k}),define(me[17],ge([0,1,20,99,290,59,25,14,2,41,81,178,117,87,89,90,215,7]),function(J,e,g,R,k,S,T,D,y,A,i,C,u,m,l,v,_,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookStatusBarItem=e.NotebookDecorationRenderOptions=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.Position=e.TokenType=e.Range=e.Selection=void 0;var P;(function(Se){function Pe(Q){const{selectionStartLineNumber:Oe,selectionStartColumn:Fe,positionLineNumber:tt,positionColumn:Ke}=Q,ut=new b.Position(Oe-1,Fe-1),St=new b.Position(tt-1,Ke-1);return new b.Selection(ut,St)}Se.to=Pe;function te(Q){const{anchor:Oe,active:Fe}=Q;return{selectionStartLineNumber:Oe.line+1,selectionStartColumn:Oe.character+1,positionLineNumber:Fe.line+1,positionColumn:Fe.character+1}}Se.from=te})(P=e.Selection||(e.Selection={}));var c;(function(Se){function Pe(Q){if(!Q)return;const{start:Oe,end:Fe}=Q;return{startLineNumber:Oe.line+1,startColumn:Oe.character+1,endLineNumber:Fe.line+1,endColumn:Fe.character+1}}Se.from=Pe;function te(Q){if(!Q)return;const{startLineNumber:Oe,startColumn:Fe,endLineNumber:tt,endColumn:Ke}=Q;return new b.Range(Oe-1,Fe-1,tt-1,Ke-1)}Se.to=te})(c=e.Range||(e.Range={}));var h;(function(Se){function Pe(te){switch(te){case 1:return b.StandardTokenType.Comment;case 0:return b.StandardTokenType.Other;case 4:return b.StandardTokenType.RegEx;case 2:return b.StandardTokenType.String}}Se.to=Pe})(h=e.TokenType||(e.TokenType={}));var p;(function(Se){function Pe(Q){return new b.Position(Q.lineNumber-1,Q.column-1)}Se.to=Pe;function te(Q){return{lineNumber:Q.line+1,column:Q.character+1}}Se.from=te})(p=e.Position||(e.Position={}));var t;(function(Se){function Pe(Q){switch(Q){case b.DiagnosticTag.Unnecessary:return 1;case b.DiagnosticTag.Deprecated:return 2}}Se.from=Pe;function te(Q){switch(Q){case 1:return b.DiagnosticTag.Unnecessary;case 2:return b.DiagnosticTag.Deprecated;default:return}}Se.to=te})(t=e.DiagnosticTag||(e.DiagnosticTag={}));var r;(function(Se){function Pe(Q){let Oe;return Q.code&&((0,D.isString)(Q.code)||(0,D.isNumber)(Q.code)?Oe=String(Q.code):Oe={value:String(Q.code.value),target:Q.code.target}),{...c.from(Q.range),message:Q.message,source:Q.source,code:Oe,severity:n.from(Q.severity),relatedInformation:Q.relatedInformation&&Q.relatedInformation.map(s.from),tags:Array.isArray(Q.tags)?(0,g.coalesce)(Q.tags.map(t.from)):void 0}}Se.from=Pe;function te(Q){const Oe=new b.Diagnostic(c.to(Q),Q.message,n.to(Q.severity));return Oe.source=Q.source,Oe.code=(0,D.isString)(Q.code)?Q.code:Q.code?.value,Oe.relatedInformation=Q.relatedInformation&&Q.relatedInformation.map(s.to),Oe.tags=Q.tags&&(0,g.coalesce)(Q.tags.map(t.to)),Oe}Se.to=te})(r=e.Diagnostic||(e.Diagnostic={}));var s;(function(Se){function Pe(Q){return{...c.from(Q.location.range),message:Q.message,resource:Q.location.uri}}Se.from=Pe;function te(Q){return new b.DiagnosticRelatedInformation(new b.Location(Q.resource,c.to(Q)),Q.message)}Se.to=te})(s=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var n;(function(Se){function Pe(Q){switch(Q){case b.DiagnosticSeverity.Error:return u.MarkerSeverity.Error;case b.DiagnosticSeverity.Warning:return u.MarkerSeverity.Warning;case b.DiagnosticSeverity.Information:return u.MarkerSeverity.Info;case b.DiagnosticSeverity.Hint:return u.MarkerSeverity.Hint}return u.MarkerSeverity.Error}Se.from=Pe;function te(Q){switch(Q){case u.MarkerSeverity.Info:return b.DiagnosticSeverity.Information;case u.MarkerSeverity.Warning:return b.DiagnosticSeverity.Warning;case u.MarkerSeverity.Error:return b.DiagnosticSeverity.Error;case u.MarkerSeverity.Hint:return b.DiagnosticSeverity.Hint;default:return b.DiagnosticSeverity.Error}}Se.to=te})(n=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var a;(function(Se){function Pe(Q){return typeof Q=="number"&&Q>=b.ViewColumn.One?Q-1:Q===b.ViewColumn.Beside?_.SIDE_GROUP:_.ACTIVE_GROUP}Se.from=Pe;function te(Q){if(typeof Q=="number"&&Q>=0)return Q+1;throw new Error("invalid 'EditorGroupColumn'")}Se.to=te})(a=e.ViewColumn||(e.ViewColumn={}));function d(Se){return typeof Se.range!="undefined"}function f(Se){return Se.length===0?!0:!!d(Se[0])}e.isDecorationOptionsArr=f;var w;(function(Se){function Pe(Ke){return Ke.map(Se.from)}Se.fromMany=Pe;function te(Ke){return Ke&&typeof Ke=="object"&&typeof Ke.language=="string"&&typeof Ke.value=="string"}function Q(Ke){let ut;if(te(Ke)){const{language:ft,value:dt}=Ke;ut={value:"```"+ft+`
`+dt+"\n```\n"}}else b.MarkdownString.isMarkdownString(Ke)?ut={value:Ke.value,isTrusted:Ke.isTrusted,supportThemeIcons:Ke.supportThemeIcons}:typeof Ke=="string"?ut={value:Ke}:ut={value:""};const St=Object.create(null);ut.uris=St;const kt=ft=>{try{let dt=y.URI.parse(ft,!0);dt=dt.with({query:Oe(dt.query,St)}),St[ft]=dt}catch(dt){}return""},Dt=new k.Renderer;return Dt.link=kt,Dt.image=ft=>kt(R.parseHrefAndDimensions(ft).href),k(ut.value,{renderer:Dt}),ut}Se.from=Q;function Oe(Ke,ut){if(!Ke)return Ke;let St;try{St=(0,S.parse)(Ke)}catch(Dt){}if(!St)return Ke;let kt=!1;return St=(0,T.cloneAndChange)(St,Dt=>{if(y.URI.isUri(Dt)){const ft=`__uri_${Math.random().toString(16).slice(2,8)}`;return ut[ft]=Dt,kt=!0,ft}else return}),kt?JSON.stringify(St):Ke}function Fe(Ke){const ut=new b.MarkdownString(Ke.value,Ke.supportThemeIcons);return ut.isTrusted=Ke.isTrusted,ut}Se.to=Fe;function tt(Ke){if(!!Ke)return typeof Ke=="string"?Ke:Se.from(Ke)}Se.fromStrict=tt})(w=e.MarkdownString||(e.MarkdownString={}));function E(Se){return f(Se)?Se.map(Pe=>({range:c.from(Pe.range),hoverMessage:Array.isArray(Pe.hoverMessage)?w.fromMany(Pe.hoverMessage):Pe.hoverMessage?w.from(Pe.hoverMessage):void 0,renderOptions:Pe.renderOptions})):Se.map(Pe=>({range:c.from(Pe)}))}e.fromRangeOrRangeWithMessage=E;function o(Se){return typeof Se=="undefined"?Se:typeof Se=="string"?y.URI.file(Se):Se}e.pathOrURIToURI=o;var I;(function(Se){function Pe(te){return typeof te=="undefined"?te:{contentText:te.contentText,contentIconPath:te.contentIconPath?o(te.contentIconPath):void 0,border:te.border,borderColor:te.borderColor,fontStyle:te.fontStyle,fontWeight:te.fontWeight,textDecoration:te.textDecoration,color:te.color,backgroundColor:te.backgroundColor,margin:te.margin,width:te.width,height:te.height}}Se.from=Pe})(I=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var L;(function(Se){function Pe(te){return typeof te=="undefined"?te:{backgroundColor:te.backgroundColor,outline:te.outline,outlineColor:te.outlineColor,outlineStyle:te.outlineStyle,outlineWidth:te.outlineWidth,border:te.border,borderColor:te.borderColor,borderRadius:te.borderRadius,borderSpacing:te.borderSpacing,borderStyle:te.borderStyle,borderWidth:te.borderWidth,fontStyle:te.fontStyle,fontWeight:te.fontWeight,textDecoration:te.textDecoration,cursor:te.cursor,color:te.color,opacity:te.opacity,letterSpacing:te.letterSpacing,gutterIconPath:te.gutterIconPath?o(te.gutterIconPath):void 0,gutterIconSize:te.gutterIconSize,overviewRulerColor:te.overviewRulerColor,before:te.before?I.from(te.before):void 0,after:te.after?I.from(te.after):void 0}}Se.from=Pe})(L=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var U;(function(Se){function Pe(te){if(typeof te=="undefined")return te;switch(te){case b.DecorationRangeBehavior.OpenOpen:return 0;case b.DecorationRangeBehavior.ClosedClosed:return 1;case b.DecorationRangeBehavior.OpenClosed:return 2;case b.DecorationRangeBehavior.ClosedOpen:return 3}}Se.from=Pe})(U=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var V;(function(Se){function Pe(te){return{isWholeLine:te.isWholeLine,rangeBehavior:te.rangeBehavior?U.from(te.rangeBehavior):void 0,overviewRulerLane:te.overviewRulerLane,light:te.light?L.from(te.light):void 0,dark:te.dark?L.from(te.dark):void 0,backgroundColor:te.backgroundColor,outline:te.outline,outlineColor:te.outlineColor,outlineStyle:te.outlineStyle,outlineWidth:te.outlineWidth,border:te.border,borderColor:te.borderColor,borderRadius:te.borderRadius,borderSpacing:te.borderSpacing,borderStyle:te.borderStyle,borderWidth:te.borderWidth,fontStyle:te.fontStyle,fontWeight:te.fontWeight,textDecoration:te.textDecoration,cursor:te.cursor,color:te.color,opacity:te.opacity,letterSpacing:te.letterSpacing,gutterIconPath:te.gutterIconPath?o(te.gutterIconPath):void 0,gutterIconSize:te.gutterIconSize,overviewRulerColor:te.overviewRulerColor,before:te.before?I.from(te.before):void 0,after:te.after?I.from(te.after):void 0}}Se.from=Pe})(V=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var ee;(function(Se){function Pe(Q){return{text:Q.newText,eol:Q.newEol&&fe.from(Q.newEol),range:c.from(Q.range)}}Se.from=Pe;function te(Q){const Oe=new b.TextEdit(c.to(Q.range),Q.text);return Oe.newEol=typeof Q.eol=="undefined"?void 0:fe.to(Q.eol),Oe}Se.to=te})(ee=e.TextEdit||(e.TextEdit={}));var K;(function(Se){function Pe(Q,Oe,Fe){const tt={edits:[]};if(Q instanceof b.WorkspaceEdit)for(let Ke of Q._allEntries())if(Ke._type===1)tt.edits.push({_type:1,oldUri:Ke.from,newUri:Ke.to,options:Ke.options,metadata:Ke.metadata});else if(Ke._type===2){const ut=Oe?.getDocument(Ke.uri);tt.edits.push({_type:2,resource:Ke.uri,edit:ee.from(Ke.edit),modelVersionId:ut?.version,metadata:Ke.metadata})}else Ke._type===3?tt.edits.push({_type:3,metadata:Ke.metadata,resource:Ke.uri,edit:Ke.edit,notebookMetadata:Ke.notebookMetadata,notebookVersionId:Fe?.getNotebookDocument(Ke.uri,!0)?.apiNotebook.version}):Ke._type===5&&tt.edits.push({_type:3,metadata:Ke.metadata,resource:Ke.uri,notebookVersionId:Fe?.getNotebookDocument(Ke.uri,!0)?.apiNotebook.version,edit:{editType:1,index:Ke.index,count:Ke.count,cells:Ke.cells.map(j.from)}});return tt}Se.from=Pe;function te(Q){const Oe=new b.WorkspaceEdit;for(const Fe of Q.edits)Fe.edit?Oe.replace(y.URI.revive(Fe.resource),c.to(Fe.edit.range),Fe.edit.text):Oe.renameFile(y.URI.revive(Fe.oldUri),y.URI.revive(Fe.newUri),Fe.options);return Oe}Se.to=te})(K=e.WorkspaceEdit||(e.WorkspaceEdit={}));var N;(function(Se){const Pe=Object.create(null);Pe[b.SymbolKind.File]=0,Pe[b.SymbolKind.Module]=1,Pe[b.SymbolKind.Namespace]=2,Pe[b.SymbolKind.Package]=3,Pe[b.SymbolKind.Class]=4,Pe[b.SymbolKind.Method]=5,Pe[b.SymbolKind.Property]=6,Pe[b.SymbolKind.Field]=7,Pe[b.SymbolKind.Constructor]=8,Pe[b.SymbolKind.Enum]=9,Pe[b.SymbolKind.Interface]=10,Pe[b.SymbolKind.Function]=11,Pe[b.SymbolKind.Variable]=12,Pe[b.SymbolKind.Constant]=13,Pe[b.SymbolKind.String]=14,Pe[b.SymbolKind.Number]=15,Pe[b.SymbolKind.Boolean]=16,Pe[b.SymbolKind.Array]=17,Pe[b.SymbolKind.Object]=18,Pe[b.SymbolKind.Key]=19,Pe[b.SymbolKind.Null]=20,Pe[b.SymbolKind.EnumMember]=21,Pe[b.SymbolKind.Struct]=22,Pe[b.SymbolKind.Event]=23,Pe[b.SymbolKind.Operator]=24,Pe[b.SymbolKind.TypeParameter]=25;function te(Oe){return typeof Pe[Oe]=="number"?Pe[Oe]:6}Se.from=te;function Q(Oe){for(const Fe in Pe)if(Pe[Fe]===Oe)return Number(Fe);return b.SymbolKind.Property}Se.to=Q})(N=e.SymbolKind||(e.SymbolKind={}));var x;(function(Se){function Pe(Q){switch(Q){case b.SymbolTag.Deprecated:return 1}}Se.from=Pe;function te(Q){switch(Q){case 1:return b.SymbolTag.Deprecated}}Se.to=te})(x=e.SymbolTag||(e.SymbolTag={}));var F;(function(Se){function Pe(Q){return{name:Q.name,kind:N.from(Q.kind),tags:Q.tags&&Q.tags.map(x.from),containerName:Q.containerName,location:B.from(Q.location)}}Se.from=Pe;function te(Q){const Oe=new b.SymbolInformation(Q.name,N.to(Q.kind),Q.containerName,B.to(Q.location));return Oe.tags=Q.tags&&Q.tags.map(x.to),Oe}Se.to=te})(F=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var z;(function(Se){function Pe(Q){const Oe={name:Q.name||"!!MISSING: name!!",detail:Q.detail,range:c.from(Q.range),selectionRange:c.from(Q.selectionRange),kind:N.from(Q.kind),tags:Q.tags?.map(x.from)??[]};return Q.children&&(Oe.children=Q.children.map(Pe)),Oe}Se.from=Pe;function te(Q){const Oe=new b.DocumentSymbol(Q.name,Q.detail,N.to(Q.kind),c.to(Q.range),c.to(Q.selectionRange));return(0,g.isNonEmptyArray)(Q.tags)&&(Oe.tags=Q.tags.map(x.to)),Q.children&&(Oe.children=Q.children.map(te)),Oe}Se.to=te})(z=e.DocumentSymbol||(e.DocumentSymbol={}));var M;(function(Se){function Pe(Q){const Oe=new b.CallHierarchyItem(N.to(Q.kind),Q.name,Q.detail||"",y.URI.revive(Q.uri),c.to(Q.range),c.to(Q.selectionRange));return Oe._sessionId=Q._sessionId,Oe._itemId=Q._itemId,Oe}Se.to=Pe;function te(Q,Oe,Fe){if(Oe=Oe??Q._sessionId,Fe=Fe??Q._itemId,Oe===void 0||Fe===void 0)throw new Error("invalid item");return{_sessionId:Oe,_itemId:Fe,name:Q.name,detail:Q.detail,kind:N.from(Q.kind),uri:Q.uri,range:c.from(Q.range),selectionRange:c.from(Q.selectionRange),tags:Q.tags?.map(x.from)}}Se.from=te})(M=e.CallHierarchyItem||(e.CallHierarchyItem={}));var O;(function(Se){function Pe(te){return new b.CallHierarchyIncomingCall(M.to(te.from),te.fromRanges.map(Q=>c.to(Q)))}Se.to=Pe})(O=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var q;(function(Se){function Pe(te){return new b.CallHierarchyOutgoingCall(M.to(te.to),te.fromRanges.map(Q=>c.to(Q)))}Se.to=Pe})(q=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var B;(function(Se){function Pe(Q){return{range:Q.range&&c.from(Q.range),uri:Q.uri}}Se.from=Pe;function te(Q){return new b.Location(y.URI.revive(Q.uri),c.to(Q.range))}Se.to=te})(B=e.location||(e.location={}));var G;(function(Se){function Pe(Q){const Oe=Q,Fe=Q;return{originSelectionRange:Oe.originSelectionRange?c.from(Oe.originSelectionRange):void 0,uri:Oe.targetUri?Oe.targetUri:Fe.uri,range:c.from(Oe.targetRange?Oe.targetRange:Fe.range),targetSelectionRange:Oe.targetSelectionRange?c.from(Oe.targetSelectionRange):void 0}}Se.from=Pe;function te(Q){return{targetUri:y.URI.revive(Q.uri),targetRange:c.to(Q.range),targetSelectionRange:Q.targetSelectionRange?c.to(Q.targetSelectionRange):void 0,originSelectionRange:Q.originSelectionRange?c.to(Q.originSelectionRange):void 0}}Se.to=te})(G=e.DefinitionLink||(e.DefinitionLink={}));var ie;(function(Se){function Pe(Q){return{range:c.from(Q.range),contents:w.fromMany(Q.contents)}}Se.from=Pe;function te(Q){return new b.Hover(Q.contents.map(w.to),c.to(Q.range))}Se.to=te})(ie=e.Hover||(e.Hover={}));var he;(function(Se){function Pe(Q){return{range:c.from(Q.range),expression:Q.expression}}Se.from=Pe;function te(Q){return new b.EvaluatableExpression(c.to(Q.range),Q.expression)}Se.to=te})(he=e.EvaluatableExpression||(e.EvaluatableExpression={}));var ye;(function(Se){function Pe(Q){if(Q instanceof b.InlineValueText)return{type:"text",range:c.from(Q.range),text:Q.text};if(Q instanceof b.InlineValueVariableLookup)return{type:"variable",range:c.from(Q.range),variableName:Q.variableName,caseSensitiveLookup:Q.caseSensitiveLookup};if(Q instanceof b.InlineValueEvaluatableExpression)return{type:"expression",range:c.from(Q.range),expression:Q.expression};throw new Error("Unknown 'InlineValue' type")}Se.from=Pe;function te(Q){switch(Q.type){case"text":return{range:c.to(Q.range),text:Q.text};case"variable":return{range:c.to(Q.range),variableName:Q.variableName,caseSensitiveLookup:Q.caseSensitiveLookup};case"expression":return{range:c.to(Q.range),expression:Q.expression}}}Se.to=te})(ye=e.InlineValue||(e.InlineValue={}));var Ie;(function(Se){function Pe(Q){return{frameId:Q.frameId,stoppedLocation:c.from(Q.stoppedLocation)}}Se.from=Pe;function te(Q){return new b.InlineValueContext(Q.frameId,c.to(Q.stoppedLocation))}Se.to=te})(Ie=e.InlineValueContext||(e.InlineValueContext={}));var Le;(function(Se){function Pe(Q){return{range:c.from(Q.range),kind:Q.kind}}Se.from=Pe;function te(Q){return new b.DocumentHighlight(c.to(Q.range),Q.kind)}Se.to=te})(Le=e.DocumentHighlight||(e.DocumentHighlight={}));var qe;(function(Se){function Pe(te){switch(te){case 1:return b.CompletionTriggerKind.TriggerCharacter;case 2:return b.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return b.CompletionTriggerKind.Invoke}}Se.to=Pe})(qe=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var We;(function(Se){function Pe(te){return{triggerKind:qe.to(te.triggerKind),triggerCharacter:te.triggerCharacter}}Se.to=Pe})(We=e.CompletionContext||(e.CompletionContext={}));var je;(function(Se){function Pe(Q){switch(Q){case b.CompletionItemTag.Deprecated:return 1}}Se.from=Pe;function te(Q){switch(Q){case 1:return b.CompletionItemTag.Deprecated}}Se.to=te})(je=e.CompletionItemTag||(e.CompletionItemTag={}));var W;(function(Se){const Pe=new Map([[b.CompletionItemKind.Method,0],[b.CompletionItemKind.Function,1],[b.CompletionItemKind.Constructor,2],[b.CompletionItemKind.Field,3],[b.CompletionItemKind.Variable,4],[b.CompletionItemKind.Class,5],[b.CompletionItemKind.Interface,7],[b.CompletionItemKind.Struct,6],[b.CompletionItemKind.Module,8],[b.CompletionItemKind.Property,9],[b.CompletionItemKind.Unit,12],[b.CompletionItemKind.Value,13],[b.CompletionItemKind.Constant,14],[b.CompletionItemKind.Enum,15],[b.CompletionItemKind.EnumMember,16],[b.CompletionItemKind.Keyword,17],[b.CompletionItemKind.Snippet,27],[b.CompletionItemKind.Text,18],[b.CompletionItemKind.Color,19],[b.CompletionItemKind.File,20],[b.CompletionItemKind.Reference,21],[b.CompletionItemKind.Folder,23],[b.CompletionItemKind.Event,10],[b.CompletionItemKind.Operator,11],[b.CompletionItemKind.TypeParameter,24],[b.CompletionItemKind.Issue,26],[b.CompletionItemKind.User,25]]);function te(Fe){return Pe.get(Fe)??9}Se.from=te;const Q=new Map([[0,b.CompletionItemKind.Method],[1,b.CompletionItemKind.Function],[2,b.CompletionItemKind.Constructor],[3,b.CompletionItemKind.Field],[4,b.CompletionItemKind.Variable],[5,b.CompletionItemKind.Class],[7,b.CompletionItemKind.Interface],[6,b.CompletionItemKind.Struct],[8,b.CompletionItemKind.Module],[9,b.CompletionItemKind.Property],[12,b.CompletionItemKind.Unit],[13,b.CompletionItemKind.Value],[14,b.CompletionItemKind.Constant],[15,b.CompletionItemKind.Enum],[16,b.CompletionItemKind.EnumMember],[17,b.CompletionItemKind.Keyword],[27,b.CompletionItemKind.Snippet],[18,b.CompletionItemKind.Text],[19,b.CompletionItemKind.Color],[20,b.CompletionItemKind.File],[21,b.CompletionItemKind.Reference],[23,b.CompletionItemKind.Folder],[10,b.CompletionItemKind.Event],[11,b.CompletionItemKind.Operator],[24,b.CompletionItemKind.TypeParameter],[25,b.CompletionItemKind.User],[26,b.CompletionItemKind.Issue]]);function Oe(Fe){return Q.get(Fe)??b.CompletionItemKind.Property}Se.to=Oe})(W=e.CompletionItemKind||(e.CompletionItemKind={}));var Z;(function(Se){function Pe(te,Q){const Oe=new b.CompletionItem(te.label);return Oe.insertText=te.insertText,Oe.kind=W.to(te.kind),Oe.tags=te.tags?.map(je.to),Oe.detail=te.detail,Oe.documentation=R.isMarkdownString(te.documentation)?w.to(te.documentation):te.documentation,Oe.sortText=te.sortText,Oe.filterText=te.filterText,Oe.preselect=te.preselect,Oe.commitCharacters=te.commitCharacters,A.Range.isIRange(te.range)?Oe.range=c.to(te.range):typeof te.range=="object"&&(Oe.range={inserting:c.to(te.range.insert),replacing:c.to(te.range.replace)}),Oe.keepWhitespace=typeof te.insertTextRules=="undefined"?!1:Boolean(te.insertTextRules&1),typeof te.insertTextRules!="undefined"&&te.insertTextRules&4?Oe.insertText=new b.SnippetString(te.insertText):(Oe.insertText=te.insertText,Oe.textEdit=Oe.range instanceof b.Range?new b.TextEdit(Oe.range,Oe.insertText):void 0),te.additionalTextEdits&&te.additionalTextEdits.length>0&&(Oe.additionalTextEdits=te.additionalTextEdits.map(Fe=>ee.to(Fe))),Oe.command=Q&&te.command?Q.fromInternal(te.command):void 0,Oe}Se.to=Pe})(Z=e.CompletionItem||(e.CompletionItem={}));var ne;(function(Se){function Pe(Q){return{label:Q.label,documentation:Q.documentation?w.fromStrict(Q.documentation):void 0}}Se.from=Pe;function te(Q){return{label:Q.label,documentation:R.isMarkdownString(Q.documentation)?w.to(Q.documentation):Q.documentation}}Se.to=te})(ne=e.ParameterInformation||(e.ParameterInformation={}));var le;(function(Se){function Pe(Q){return{label:Q.label,documentation:Q.documentation?w.fromStrict(Q.documentation):void 0,parameters:Array.isArray(Q.parameters)?Q.parameters.map(ne.from):[],activeParameter:Q.activeParameter}}Se.from=Pe;function te(Q){return{label:Q.label,documentation:R.isMarkdownString(Q.documentation)?w.to(Q.documentation):Q.documentation,parameters:Array.isArray(Q.parameters)?Q.parameters.map(ne.to):[],activeParameter:Q.activeParameter}}Se.to=te})(le=e.SignatureInformation||(e.SignatureInformation={}));var Y;(function(Se){function Pe(Q){return{activeSignature:Q.activeSignature,activeParameter:Q.activeParameter,signatures:Array.isArray(Q.signatures)?Q.signatures.map(le.from):[]}}Se.from=Pe;function te(Q){return{activeSignature:Q.activeSignature,activeParameter:Q.activeParameter,signatures:Array.isArray(Q.signatures)?Q.signatures.map(le.to):[]}}Se.to=te})(Y=e.SignatureHelp||(e.SignatureHelp={}));var ae;(function(Se){function Pe(Q){return{text:Q.text,position:p.from(Q.position),kind:ve.from(Q.kind??b.InlayHintKind.Other),whitespaceBefore:Q.whitespaceBefore,whitespaceAfter:Q.whitespaceAfter}}Se.from=Pe;function te(Q){const Oe=new b.InlayHint(Q.text,p.to(Q.position),ve.to(Q.kind));return Oe.whitespaceAfter=Q.whitespaceAfter,Oe.whitespaceBefore=Q.whitespaceBefore,Oe}Se.to=te})(ae=e.InlayHint||(e.InlayHint={}));var ve;(function(Se){function Pe(Q){return Q}Se.from=Pe;function te(Q){return Q}Se.to=te})(ve=e.InlayHintKind||(e.InlayHintKind={}));var Me;(function(Se){function Pe(Q){return{range:c.from(Q.range),url:Q.target,tooltip:Q.tooltip}}Se.from=Pe;function te(Q){let Oe;if(Q.url)try{Oe=typeof Q.url=="string"?y.URI.parse(Q.url,!0):y.URI.revive(Q.url)}catch(Fe){}return new b.DocumentLink(c.to(Q.range),Oe)}Se.to=te})(Me=e.DocumentLink||(e.DocumentLink={}));var ze;(function(Se){function Pe(Q){const Oe=new b.ColorPresentation(Q.label);return Q.textEdit&&(Oe.textEdit=ee.to(Q.textEdit)),Q.additionalTextEdits&&(Oe.additionalTextEdits=Q.additionalTextEdits.map(Fe=>ee.to(Fe))),Oe}Se.to=Pe;function te(Q){return{label:Q.label,textEdit:Q.textEdit?ee.from(Q.textEdit):void 0,additionalTextEdits:Q.additionalTextEdits?Q.additionalTextEdits.map(Oe=>ee.from(Oe)):void 0}}Se.from=te})(ze=e.ColorPresentation||(e.ColorPresentation={}));var Ee;(function(Se){function Pe(Q){return new b.Color(Q[0],Q[1],Q[2],Q[3])}Se.to=Pe;function te(Q){return[Q.red,Q.green,Q.blue,Q.alpha]}Se.from=te})(Ee=e.Color||(e.Color={}));var Ye;(function(Se){function Pe(Q){return{range:c.from(Q.range)}}Se.from=Pe;function te(Q){return new b.SelectionRange(c.to(Q.range))}Se.to=te})(Ye=e.SelectionRange||(e.SelectionRange={}));var X;(function(Se){function Pe(te){switch(te){case 2:return b.TextDocumentSaveReason.AfterDelay;case 1:return b.TextDocumentSaveReason.Manual;case 3:case 4:return b.TextDocumentSaveReason.FocusOut}}Se.to=Pe})(X=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var se;(function(Se){function Pe(Q){switch(Q){case b.TextEditorLineNumbersStyle.Off:return 0;case b.TextEditorLineNumbersStyle.Relative:return 2;case b.TextEditorLineNumbersStyle.On:default:return 1}}Se.from=Pe;function te(Q){switch(Q){case 0:return b.TextEditorLineNumbersStyle.Off;case 2:return b.TextEditorLineNumbersStyle.Relative;case 1:default:return b.TextEditorLineNumbersStyle.On}}Se.to=te})(se=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var fe;(function(Se){function Pe(Q){if(Q===b.EndOfLine.CRLF)return 1;if(Q===b.EndOfLine.LF)return 0}Se.from=Pe;function te(Q){if(Q===1)return b.EndOfLine.CRLF;if(Q===0)return b.EndOfLine.LF}Se.to=te})(fe=e.EndOfLine||(e.EndOfLine={}));var xe;(function(Se){function Pe(te){if(typeof te=="object")return te.viewId;switch(te){case b.ProgressLocation.SourceControl:return 3;case b.ProgressLocation.Window:return 10;case b.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Se.from=Pe})(xe=e.ProgressLocation||(e.ProgressLocation={}));var Be;(function(Se){function Pe(te){const Q={start:te.start+1,end:te.end+1};return te.kind&&(Q.kind=et.from(te.kind)),Q}Se.from=Pe})(Be=e.FoldingRange||(e.FoldingRange={}));var et;(function(Se){function Pe(te){if(te)switch(te){case b.FoldingRangeKind.Comment:return i.FoldingRangeKind.Comment;case b.FoldingRangeKind.Imports:return i.FoldingRangeKind.Imports;case b.FoldingRangeKind.Region:return i.FoldingRangeKind.Region}}Se.from=Pe})(et=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Ce;(function(Se){function Pe(te){if(te)return{pinned:typeof te.preview=="boolean"?!te.preview:void 0,inactive:te.background,preserveFocus:te.preserveFocus,selection:typeof te.selection=="object"?c.from(te.selection):void 0,override:typeof te.override=="boolean"?C.EditorResolution.DISABLED:void 0}}Se.from=Pe})(Ce=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var De;(function(Se){function Pe(Q){return Q instanceof b.RelativePattern||typeof Q=="string"?Q:te(Q)?new b.RelativePattern(Q.base,Q.pattern):Q}Se.from=Pe;function te(Q){const Oe=Q;return Oe&&typeof Oe.base=="string"&&typeof Oe.pattern=="string"}})(De=e.GlobPattern||(e.GlobPattern={}));var Te;(function(Se){function Pe(te){if(te){if(Array.isArray(te))return te.map(Pe);if(typeof te=="string")return te;{const Q=te;return{language:Q.language,scheme:Q.scheme,pattern:typeof Q.pattern=="undefined"?void 0:De.from(Q.pattern),exclusive:Q.exclusive}}}else return}Se.from=Pe})(Te=e.LanguageSelector||(e.LanguageSelector={}));var ce;(function(Se){function Pe(Q){return{start:Q.start,end:Q.end}}Se.from=Pe;function te(Q){return new b.NotebookRange(Q.start,Q.end)}Se.to=te})(ce=e.NotebookRange||(e.NotebookRange={}));var ue;(function(Se){function Pe(Q){return{timing:typeof Q.runStartTime=="number"&&typeof Q.runEndTime=="number"?{startTime:Q.runStartTime,endTime:Q.runEndTime}:void 0,executionOrder:Q.executionOrder,success:Q.lastRunSuccess}}Se.to=Pe;function te(Q){return{lastRunSuccess:Q.success,runStartTime:Q.timing?.startTime,runEndTime:Q.timing?.endTime,executionOrder:Q.executionOrder}}Se.from=te})(ue=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var pe;(function(Se){function Pe(Q){switch(Q){case b.NotebookCellKind.Markup:return l.CellKind.Markup;case b.NotebookCellKind.Code:default:return l.CellKind.Code}}Se.from=Pe;function te(Q){switch(Q){case l.CellKind.Markup:return b.NotebookCellKind.Markup;case l.CellKind.Code:default:return b.NotebookCellKind.Code}}Se.to=te})(pe=e.NotebookCellKind||(e.NotebookCellKind={}));var be;(function(Se){function Pe(Q){const Oe={metadata:Q.metadata??Object.create(null),cells:[]};for(let Fe of Q.cells)b.NotebookCellData.validate(Fe),Oe.cells.push(j.from(Fe));return Oe}Se.from=Pe;function te(Q){const Oe=new b.NotebookData(Q.cells.map(j.to));return(0,D.isEmptyObject)(Q.metadata)||(Oe.metadata=Q.metadata),Oe}Se.to=te})(be=e.NotebookData||(e.NotebookData={}));var j;(function(Se){function Pe(Q){return{cellKind:pe.from(Q.kind),language:Q.languageId,mime:Q.mime,source:Q.value,metadata:Q.metadata,internalMetadata:ue.from(Q.executionSummary??{}),outputs:Q.outputs?Q.outputs.map(_e.from):[]}}Se.from=Pe;function te(Q){return new b.NotebookCellData(pe.to(Q.cellKind),Q.source,Q.language,Q.mime,Q.outputs?Q.outputs.map(_e.to):void 0,Q.metadata,Q.internalMetadata?ue.to(Q.internalMetadata):void 0)}Se.to=te})(j=e.NotebookCellData||(e.NotebookCellData={}));var we;(function(Se){function Pe(Q){return{mime:Q.mime,valueBytes:Array.from(Q.data)}}Se.from=Pe;function te(Q){return new b.NotebookCellOutputItem(new Uint8Array(Q.valueBytes),Q.mime)}Se.to=te})(we=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var _e;(function(Se){function Pe(Q){return{outputId:Q.id,items:Q.items.map(we.from),metadata:Q.metadata}}Se.from=Pe;function te(Q){const Oe=Q.items.map(we.to);return new b.NotebookCellOutput(Oe,Q.outputId,Q.metadata)}Se.to=te})(_e=e.NotebookCellOutput||(e.NotebookCellOutput={}));var Ae;(function(Se){function Pe(Fe){if(Fe!=null){if(Fe instanceof b.RelativePattern||typeof Fe=="string")return Fe;if(Oe(Fe))return new b.RelativePattern(Fe.base,Fe.pattern);if(Q(Fe))return{include:De.from(Fe.include)||void 0,exclude:De.from(Fe.exclude)||void 0}}}Se.from=Pe;function te(Fe){return typeof Fe=="string"?Fe:Oe(Fe)?{base:Fe.base,pattern:Fe.pattern}:{include:Fe.include,exclude:Fe.exclude}}Se.to=te;function Q(Fe){const tt=Fe,Ke=De.from(tt.include);if(!(Ke&&Ke instanceof b.RelativePattern||typeof Ke=="string"))return!1;const ut=De.from(tt.exclude);return!!(ut&&ut instanceof b.RelativePattern||typeof ut=="string")}function Oe(Fe){const tt=Fe;return tt&&typeof tt.base=="string"&&typeof tt.pattern=="string"}})(Ae=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var Ue;(function(Se){function Pe(te){return{backgroundColor:te.backgroundColor,borderColor:te.borderColor,top:te.top?I.from(te.top):void 0}}Se.from=Pe})(Ue=e.NotebookDecorationRenderOptions||(e.NotebookDecorationRenderOptions={}));var Ge;(function(Se){function Pe(te,Q,Oe){const Fe=typeof te.command=="string"?{title:"",command:te.command}:te.command;return{alignment:te.alignment===b.NotebookCellStatusBarAlignment.Left?1:2,command:Q.toInternal(Fe,Oe),text:te.text,tooltip:te.tooltip,accessibilityInformation:te.accessibilityInformation,priority:te.priority}}Se.from=Pe})(Ge=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var Ze;(function(Se){function Pe(te){return{transientOutputs:te?.transientOutputs??!1,transientCellMetadata:te?.transientCellMetadata??{},transientDocumentMetadata:te?.transientDocumentMetadata??{}}}Se.from=Pe})(Ze=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var Qe;(function(Se){function Pe(Q){return{uri:Q.uri,provides:Q.provides}}Se.from=Pe;function te(Q){return new b.NotebookRendererScript(y.URI.revive(Q.uri),Q.provides)}Se.to=te})(Qe=e.NotebookRendererScript||(e.NotebookRendererScript={}));var Je;(function(Se){function Pe(Q){return{message:w.fromStrict(Q.message)||"",severity:b.TestMessageSeverity.Error,expectedOutput:Q.expectedOutput,actualOutput:Q.actualOutput,location:Q.location?B.from(Q.location):void 0}}Se.from=Pe;function te(Q){const Oe=new b.TestMessage(typeof Q.message=="string"?Q.message:w.to(Q.message));return Oe.actualOutput=Q.actualOutput,Oe.expectedOutput=Q.expectedOutput,Oe}Se.to=te})(Je=e.TestMessage||(e.TestMessage={}));var ct;(function(Se){function Pe(Fe){return{extId:v.TestId.fromExtHostTestItem(Fe,(0,m.getPrivateApiFor)(Fe).controllerId).toString(),label:Fe.label,uri:Fe.uri,range:c.from(Fe.range)||null,description:Fe.description||null,error:Fe.error&&w.fromStrict(Fe.error)||null}}Se.from=Pe;function te(Fe){return{id:v.TestId.fromString(Fe.extId).localId,label:Fe.label,uri:y.URI.revive(Fe.uri),range:c.to(Fe.range||void 0),invalidateResults:()=>{},canResolveChildren:!1,busy:!1,description:Fe.description||void 0}}Se.toPlain=te;function Q(Fe){const tt=v.TestId.fromString(Fe.extId),Ke=new m.TestItemImpl(tt.controllerId,tt.localId,Fe.label,y.URI.revive(Fe.uri));return Ke.range=c.to(Fe.range||void 0),Ke.description=Fe.description||void 0,Ke}function Oe(Fe){let tt;for(const Ke of Fe.tests){const ut=Q(Ke.item);(0,m.getPrivateApiFor)(ut).parent=tt,tt=ut}return tt}Se.toItemFromContext=Oe})(ct=e.TestItem||(e.TestItem={}));var mt;(function(Se){const Pe=(Q,Oe)=>{const Fe={...ct.toPlain(Q.item),parent:void 0,taskStates:Q.tasks.map(tt=>({state:tt.state,duration:tt.duration,messages:tt.messages.map(Je.to)})),children:Q.children.map(tt=>Oe.get(tt)).filter(D.isDefined).map(tt=>Pe(tt,Oe))};for(const tt of Fe.children)tt.parent=Fe;return Fe};function te(Q){const Oe=[],Fe=new Map;for(const tt of Q.items)Fe.set(tt.item.extId,tt),Q.request.targets.some(Ke=>Ke.controllerId===tt.controllerId&&Ke.testIds.includes(tt.item.extId))&&Oe.push(tt);return{completedAt:Q.completedAt,results:Oe.map(tt=>Pe(tt,Fe))}}Se.to=te})(mt=e.TestResults||(e.TestResults={}));var bt;(function(Se){function Pe(Fe){return{covered:Fe.covered,total:Fe.covered}}function te(Fe){return"line"in Fe?p.from(Fe):c.from(Fe)}function Q(Fe){return"branches"in Fe?{count:Fe.executionCount,location:te(Fe.location),type:1,branches:Fe.branches.length?Fe.branches.map(tt=>({count:tt.executionCount,location:tt.location&&te(tt.location)})):void 0}:{type:0,count:Fe.executionCount,location:te(Fe.location)}}Se.fromDetailed=Q;function Oe(Fe){return{uri:Fe.uri,statement:Pe(Fe.statementCoverage),branch:Fe.branchCoverage&&Pe(Fe.branchCoverage),function:Fe.functionCoverage&&Pe(Fe.functionCoverage),details:Fe.detailedCoverage?.map(Q)}}Se.fromFile=Oe})(bt=e.TestCoverage||(e.TestCoverage={}));var ot;(function(Se){function Pe(te){switch(te){case 1:return b.CodeActionTriggerKind.Invoke;case 2:return b.CodeActionTriggerKind.Automatic}}Se.to=Pe})(ot=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));var at;(function(Se){function Pe(Q){const Oe=new b.TypeHierarchyItem(N.to(Q.kind),Q.name,Q.detail||"",y.URI.revive(Q.uri),c.to(Q.range),c.to(Q.selectionRange));return Oe._sessionId=Q._sessionId,Oe._itemId=Q._itemId,Oe}Se.to=Pe;function te(Q,Oe,Fe){if(Oe=Oe??Q._sessionId,Fe=Fe??Q._itemId,Oe===void 0||Fe===void 0)throw new Error("invalid item");return{_sessionId:Oe,_itemId:Fe,kind:N.from(Q.kind),name:Q.name,detail:Q.detail??"",uri:Q.uri,range:c.from(Q.range),selectionRange:c.from(Q.selectionRange),tags:Q.tags?.map(x.from)}}Se.from=te})(at=e.TypeHierarchyItem||(e.TypeHierarchyItem={}))}),define(me[216],ge([0,1,2,15,7,17,95]),function(J,e,g,R,k,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class D{constructor(A,i,C,u={timeout:1500,errors:3}){this._logService=A,this._documents=i,this._mainThreadBulkEdits=C,this._thresholds=u,this._callbacks=new T.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(A){return(i,C,u)=>{const l={dispose:this._callbacks.push([i,C,A])};return Array.isArray(u)&&u.push(l),l}}async $participateInSave(A,i){const C=g.URI.revive(A);let u=!1;const m=setTimeout(()=>u=!0,this._thresholds.timeout),l=[];try{for(let v of[...this._callbacks]){if(u)break;const _=this._documents.getDocument(C),b=await this._deliverEventAsyncAndBlameBadListeners(v,{document:_,reason:S.TextDocumentSaveReason.to(i)});l.push(b)}}finally{clearTimeout(m)}return l}_deliverEventAsyncAndBlameBadListeners([A,i,C],u){const m=this._badListeners.get(A);return typeof m=="number"&&m>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(C,A,i,u).then(()=>!0,l=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${C.identifier.value}' threw ERROR`),this._logService.error(l),!(l instanceof Error)||l.message!=="concurrent_edits"){const v=this._badListeners.get(A);this._badListeners.set(A,v?v+1:1),typeof v=="number"&&v>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${C.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(A,i,C,u){const m=[],l=Date.now(),{document:v,reason:_}=u,{version:b}=v,P=Object.freeze({document:v,reason:_,waitUntil(c){if(Object.isFrozen(m))throw(0,R.illegalState)("waitUntil can not be called async");m.push(Promise.resolve(c))}});try{i.apply(C,[P])}catch(c){return Promise.reject(c)}return Object.freeze(m),new Promise((c,h)=>{const p=setTimeout(()=>h(new Error("timeout")),this._thresholds.timeout);return Promise.all(m).then(t=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${A.identifier.value}' finished after ${Date.now()-l}ms`),clearTimeout(p),c(t)}).catch(t=>{clearTimeout(p),h(t)})}).then(c=>{const h={edits:[]};for(const p of c)if(Array.isArray(p)&&p.every(t=>t instanceof k.TextEdit))for(const{newText:t,newEol:r,range:s}of p)h.edits.push({_type:2,resource:v.uri,edit:{range:s&&S.Range.from(s),text:t,eol:r&&S.EndOfLine.from(r)}});if(h.edits.length!==0)return b===v.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(h):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=D}),define(me[217],ge([0,1,3,30,2,17,7]),function(J,e,g,R,k,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class D{constructor(i,C,u,m,l){this._onDidCreate=new g.Emitter,this._onDidChange=new g.Emitter,this._onDidDelete=new g.Emitter,this._config=0,u&&(this._config+=1),m&&(this._config+=2),l&&(this._config+=4);const v=(0,R.parse)(C),_=i(b=>{if(!u)for(let P of b.created){const c=k.URI.revive(P);v(c.fsPath)&&this._onDidCreate.fire(c)}if(!m)for(let P of b.changed){const c=k.URI.revive(P);v(c.fsPath)&&this._onDidChange.fire(c)}if(!l)for(let P of b.deleted){const c=k.URI.revive(P);v(c.fsPath)&&this._onDidDelete.fire(c)}});this._disposable=T.Disposable.from(this._onDidCreate,this._onDidChange,this._onDidDelete,_)}get ignoreCreateEvents(){return Boolean(this._config&1)}get ignoreChangeEvents(){return Boolean(this._config&2)}get ignoreDeleteEvents(){return Boolean(this._config&4)}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class y{constructor(i,C,u){this._logService=C,this._extHostDocumentsAndEditors=u,this._onFileSystemEvent=new g.Emitter,this._onDidRenameFile=new g.Emitter,this._onDidCreateFile=new g.Emitter,this._onDidDeleteFile=new g.Emitter,this._onWillRenameFile=new g.AsyncEmitter,this._onWillCreateFile=new g.AsyncEmitter,this._onWillDeleteFile=new g.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(i,C,u,m){return new D(this._onFileSystemEvent.event,i,C,u,m)}$onFileEvent(i){this._onFileSystemEvent.fire(i)}$onDidRunFileOperation(i,C){switch(i){case 2:this._onDidRenameFile.fire(Object.freeze({files:C.map(u=>({oldUri:k.URI.revive(u.source),newUri:k.URI.revive(u.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:C.map(u=>k.URI.revive(u.target))}));break;case 0:this._onDidCreateFile.fire(Object.freeze({files:C.map(u=>k.URI.revive(u.target))}));break;default:}}getOnWillRenameFileEvent(i){return this._createWillExecuteEvent(i,this._onWillRenameFile)}getOnWillCreateFileEvent(i){return this._createWillExecuteEvent(i,this._onWillCreateFile)}getOnWillDeleteFileEvent(i){return this._createWillExecuteEvent(i,this._onWillDeleteFile)}_createWillExecuteEvent(i,C){return(u,m,l)=>{const v=function(b){u.call(m,b)};return v.extension=i,C.event(v,void 0,l)}}async $onWillRunFileOperation(i,C,u,m){switch(i){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:C.map(l=>({oldUri:k.URI.revive(l.source),newUri:k.URI.revive(l.target)}))},u,m);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:C.map(l=>k.URI.revive(l.target))},u,m);case 0:return await this._fireWillEvent(this._onWillCreateFile,{files:C.map(l=>k.URI.revive(l.target))},u,m)}}async _fireWillEvent(i,C,u,m){const l=new Set,v=[];if(await i.fireAsync(C,m,async(b,P)=>{const c=Date.now(),h=await Promise.resolve(b);h instanceof T.WorkspaceEdit&&(v.push(h),l.add(P.extension.displayName??P.extension.identifier.value)),Date.now()-c>u&&this._logService.warn("SLOW file-participant",P.extension.identifier)}),m.isCancellationRequested||v.length===0)return;const _={edits:[]};for(let b of v){let{edits:P}=S.WorkspaceEdit.from(b,this._extHostDocumentsAndEditors);_.edits=_.edits.concat(P)}return{edit:_,extensionNames:Array.from(l)}}}e.ExtHostFileSystemEventService=y}),define(me[218],ge([0,1,10,25,2,17,7,89]),function(J,e,g,R,k,S,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class y{constructor(u,m,l,v){this.start=u,this.deletedCount=m,this.deletedItems=l,this.items=v}static asApiEvents(u){return u.map(m=>({start:m.start,deletedCount:m.deletedCount,deletedItems:m.deletedItems,items:m.items.map(l=>l.apiCell)}))}}class A{constructor(u,m,l){this.notebook=u,this._extHostDocument=m,this._cellData=l,this.handle=l.handle,this.uri=k.URI.revive(l.uri),this.cellKind=l.cellKind,this._outputs=l.outputs.map(S.NotebookCellOutput.to),this._internalMetadata=l.internalMetadata??{},this._metadata=Object.freeze(l.metadata??{}),this._previousResult=Object.freeze(S.NotebookCellExecutionSummary.to(l.internalMetadata??{}))}static asModelAddData(u,m){return{EOL:m.eol,lines:m.source,modeId:m.language,uri:m.uri,isDirty:!1,versionId:1,notebook:u}}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._apiCell){const u=this,m=this._extHostDocument.getDocument(this.uri);if(!m)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);this._apiCell=Object.freeze({get index(){return u.notebook.getCellIndex(u)},notebook:u.notebook.apiNotebook,kind:S.NotebookCellKind.to(this._cellData.cellKind),document:m.document,get mime(){return u._mime},set mime(l){u._mime=l},get outputs(){return u._outputs.slice(0)},get metadata(){return u._metadata},get executionSummary(){return u._previousResult}})}return this._apiCell}setOutputs(u){this._outputs=u.map(S.NotebookCellOutput.to)}setOutputItems(u,m,l){const v=l.map(S.NotebookCellOutputItem.to),_=this._outputs.find(b=>b.id===u);_&&(m||(_.items.length=0),_.items.push(...v))}setMetadata(u){this._metadata=Object.freeze(u)}setInternalMetadata(u){this._internalMetadata=u,this._previousResult=Object.freeze(S.NotebookCellExecutionSummary.to(u))}setMime(u){}}e.ExtHostCell=A;class i{constructor(u,m,l,v,_,b){this._proxy=u,this._textDocumentsAndEditors=m,this._textDocuments=l,this._emitter=v,this.uri=_,this.handle=i._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1,this._notebookType=b.viewType,this._metadata=Object.freeze(b.metadata??Object.create(null)),this._spliceNotebookCells([[0,0,b.cells]],!0),this._versionId=b.versionId}dispose(){this._disposed=!0}get apiNotebook(){if(!this._notebook){const u=this;this._notebook={get uri(){return u.uri},get version(){return u._versionId},get notebookType(){return u._notebookType},get isDirty(){return u._isDirty},get isUntitled(){return u.uri.scheme===g.Schemas.untitled},get isClosed(){return u._disposed},get metadata(){return u._metadata},get cellCount(){return u._cells.length},cellAt(m){return m=u._validateIndex(m),u._cells[m].apiCell},getCells(m){return(m?u._getCells(m):u._cells).map(v=>v.apiCell)},save(){return u._save()}}}return this._notebook}updateBackup(u){this._backup?.delete(),this._backup=u}disposeBackup(){this._backup?.delete(),this._backup=void 0}acceptDocumentPropertiesChanged(u){u.metadata&&(this._metadata=Object.freeze({...this._metadata,...u.metadata}))}acceptDirty(u){this._isDirty=u}acceptModelChanged(u,m){this._versionId=u.versionId,this._isDirty=m;for(const l of u.rawEvents)l.kind===D.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(l.changes,!1):l.kind===D.NotebookCellsChangeType.Move?this._moveCell(l.index,l.newIdx):l.kind===D.NotebookCellsChangeType.Output?this._setCellOutputs(l.index,l.outputs):l.kind===D.NotebookCellsChangeType.OutputItem?this._setCellOutputItems(l.index,l.outputId,l.append,l.outputItems):l.kind===D.NotebookCellsChangeType.ChangeLanguage?this._changeCellLanguage(l.index,l.language):l.kind===D.NotebookCellsChangeType.ChangeCellMime?this._changeCellMime(l.index,l.mime):l.kind===D.NotebookCellsChangeType.ChangeCellMetadata?this._changeCellMetadata(l.index,l.metadata):l.kind===D.NotebookCellsChangeType.ChangeCellInternalMetadata&&this._changeCellInternalMetadata(l.index,l.internalMetadata)}_validateIndex(u){return u=u|0,u<0?0:u>=this._cells.length?this._cells.length-1:u}_validateRange(u){let m=u.start|0,l=u.end|0;return m<0&&(m=0),l>this._cells.length&&(l=this._cells.length),u.with({start:m,end:l})}_getCells(u){u=this._validateRange(u);const m=[];for(let l=u.start;l<u.end;l++)m.push(this._cells[l]);return m}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveNotebook(this.uri)}_spliceNotebookCells(u,m){if(this._disposed)return;const l=[],v=[],_=[];u.reverse().forEach(b=>{const c=b[2].map(t=>{const r=new A(this,this._textDocumentsAndEditors,t);return m||v.push(A.asModelAddData(this.apiNotebook,t)),r}),h=new y(b[0],b[1],[],c),p=this._cells.splice(b[0],b[1],...c);for(const t of p)_.push(t.uri),h.deletedItems.push(t.apiCell);l.push(h)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:v,removedDocuments:_}),m||this._emitter.emitModelChange((0,R.deepFreeze)({document:this.apiNotebook,changes:y.asApiEvents(l)}))}_moveCell(u,m){const l=this._cells.splice(u,1);this._cells.splice(m,0,...l);const v=[new y(u,1,l.map(_=>_.apiCell),[]),new y(m,0,[],l)];this._emitter.emitModelChange((0,R.deepFreeze)({document:this.apiNotebook,changes:y.asApiEvents(v)}))}_setCellOutputs(u,m){const l=this._cells[u];l.setOutputs(m),this._emitter.emitCellOutputsChange((0,R.deepFreeze)({document:this.apiNotebook,cells:[l.apiCell]}))}_setCellOutputItems(u,m,l,v){const _=this._cells[u];_.setOutputItems(m,l,v),this._emitter.emitCellOutputsChange((0,R.deepFreeze)({document:this.apiNotebook,cells:[_.apiCell]}))}_changeCellLanguage(u,m){const l=this._cells[u];l.apiCell.document.languageId!==m&&this._textDocuments.$acceptModelModeChanged(l.uri,m)}_changeCellMime(u,m){const l=this._cells[u];l.apiCell.mime=m}_changeCellMetadata(u,m){const l=this._cells[u],v=l.apiCell.metadata;l.setMetadata(m);const _=l.apiCell.metadata;(0,R.equals)(v,_)||this._emitter.emitCellMetadataChange((0,R.deepFreeze)({document:this.apiNotebook,cell:l.apiCell}))}_changeCellInternalMetadata(u,m){const l=this._cells[u],v=l.internalMetadata;if(l.setInternalMetadata(m),v.runState!==m.runState){const _=m.runState??T.NotebookCellExecutionState.Idle;this._emitter.emitCellExecutionStateChange((0,R.deepFreeze)({document:this.apiNotebook,cell:l.apiCell,state:_}))}}getCellFromApiCell(u){return this._cells.find(m=>m.apiCell===u)}getCellFromIndex(u){return this._cells[u]}getCell(u){return this._cells.find(m=>m.handle===u)}getCellIndex(u){return this._cells.indexOf(u)}}e.ExtHostNotebookDocument=i,i._handlePool=0}),define(me[128],ge([0,1,7,17,15]),function(J,e,g,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class S{constructor(y){this._finalized=!1,this._collectedEdits=[],this._documentVersionId=y}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,cellEdits:this._collectedEdits}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replaceMetadata(y){this._throwIfFinalized(),this._collectedEdits.push({editType:5,metadata:y})}replaceCellMetadata(y,A){this._throwIfFinalized(),this._collectedEdits.push({editType:8,index:y,metadata:A})}replaceCells(y,A,i){this._throwIfFinalized(),!(y===A&&i.length===0)&&this._collectedEdits.push({editType:1,index:y,count:A-y,cells:i.map(R.NotebookCellData.from)})}}class T{constructor(y,A,i,C,u,m){this.id=y,this._proxy=A,this.notebookData=i,this._selections=[],this._visibleRanges=[],this._visible=!1,this._hasDecorationsForKey=new Set,this._selections=u,this._visibleRanges=C,this._viewColumn=m}get apiEditor(){if(!this._editor){const y=this;this._editor={get document(){return y.notebookData.apiNotebook},get selections(){return y._selections},set selections(A){if(!Array.isArray(A)||!A.every(g.NotebookRange.isNotebookRange))throw(0,k.illegalArgument)("selections");y._selections=A,y._trySetSelections(A)},get visibleRanges(){return y._visibleRanges},revealRange(A,i){y._proxy.$tryRevealRange(y.id,R.NotebookRange.from(A),i??g.NotebookEditorRevealType.Default)},get viewColumn(){return y._viewColumn},edit(A){const i=new S(this.document.version);return A(i),y._applyEdit(i.finalize())},setDecorations(A,i){return y.setDecorations(A,i)}},T.apiEditorsToExtHost.set(this._editor,this)}return this._editor}get visible(){return this._visible}_acceptVisibility(y){this._visible=y}_acceptVisibleRanges(y){this._visibleRanges=y}_acceptSelections(y){this._selections=y}_trySetSelections(y){this._proxy.$trySetSelections(this.id,y.map(R.NotebookRange.from))}_acceptViewColumn(y){this._viewColumn=y}_applyEdit(y){if(y.cellEdits.length===0)return Promise.resolve(!0);const A=[];let i=-1;for(let C=0;C<y.cellEdits.length;C++){if(i<0){A.push(y.cellEdits[C]),i++;continue}const m=A[i],l=y.cellEdits[C];if(m.editType===1&&l.editType===1&&m.index===l.index){m.cells.push(...y.cellEdits[C].cells),m.count+=y.cellEdits[C].count;continue}A.push(y.cellEdits[C]),i++}return this._proxy.$tryApplyEdits(this.id,y.documentVersionId,A)}setDecorations(y,A){if(!(A.isEmpty&&!this._hasDecorationsForKey.has(y.key)))return A.isEmpty?this._hasDecorationsForKey.delete(y.key):this._hasDecorationsForKey.add(y.key),this._proxy.$trySetDecorations(this.id,R.NotebookRange.from(A),y.key)}}e.ExtHostNotebookEditor=T,T.apiEditorsToExtHost=new WeakMap}),define(me[219],ge([0,1,17,118,165,21,56]),function(J,e,g,R,k,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class D{constructor(C){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=C}withProgress(C,u,m){const l=this._handles++,{title:v,location:_,cancellable:b}=u,P={label:(0,k.localize)(0,null,C.displayName||C.name),id:C.identifier.value};return this._proxy.$startProgress(l,{location:g.ProgressLocation.from(_),title:v,source:P,cancellable:b},C),this._withProgress(l,m,!!b)}_withProgress(C,u,m){let l;m&&(l=new S.CancellationTokenSource,this._mapHandleToCancellationSource.set(C,l));const v=b=>{this._proxy.$progressEnd(b),this._mapHandleToCancellationSource.delete(b),l&&l.dispose()};let _;try{_=u(new A(this._proxy,C),m&&l?l.token:S.CancellationToken.None)}catch(b){throw v(C),b}return _.then(b=>v(C),b=>v(C)),_}$acceptProgressCanceled(C){const u=this._mapHandleToCancellationSource.get(C);u&&(u.cancel(),this._mapHandleToCancellationSource.delete(C))}}e.ExtHostProgress=D;function y(i,C){return i.message=C.message,typeof C.increment=="number"&&(typeof i.increment=="number"?i.increment+=C.increment:i.increment=C.increment),i}class A extends R.Progress{constructor(C,u){super(m=>this.throttledReport(m));this._proxy=C,this._handle=u}throttledReport(C){this._proxy.$progressReport(this._handle,C)}}Ve([(0,T.throttle)(100,(i,C)=>y(i,C),()=>Object.create(null))],A.prototype,"throttledReport",null)}),define(me[129],ge([0,1,54,15,73,17,7]),function(J,e,g,R,k,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorEdit=e.TextEditorDecorationType=void 0;class D{constructor(u,m,l){const v=D._Keys.nextId();u.$registerTextEditorDecorationType(m.identifier,v,S.DecorationRenderOptions.from(l)),this.value=Object.freeze({key:v,dispose(){u.$removeTextEditorDecorationType(v)}})}}e.TextEditorDecorationType=D,D._Keys=new k.IdGenerator("TextEditorDecorationType");class y{constructor(u,m){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=u,this._documentVersionId=u.version,this._undoStopBefore=m.undoStopBefore,this._undoStopAfter=m.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(u,m){this._throwIfFinalized();let l=null;if(u instanceof T.Position)l=new T.Range(u,u);else if(u instanceof T.Range)l=u;else throw new Error("Unrecognized location");this._pushEdit(l,m,!1)}insert(u,m){this._throwIfFinalized(),this._pushEdit(new T.Range(u,u),m,!0)}delete(u){this._throwIfFinalized();let m=null;if(u instanceof T.Range)m=u;else throw new Error("Unrecognized location");this._pushEdit(m,null,!0)}_pushEdit(u,m,l){const v=this._document.validateRange(u);this._collectedEdits.push({range:v,text:m,forceMoveMarkers:l})}setEndOfLine(u){if(this._throwIfFinalized(),u!==T.EndOfLine.LF&&u!==T.EndOfLine.CRLF)throw(0,R.illegalArgument)("endOfLine");this._setEndOfLine=u}}e.TextEditorEdit=y;class A{constructor(u,m,l,v){this._proxy=u,this._id=m,this._accept(l),this._logService=v;const _=this;this.value={get tabSize(){return _._tabSize},set tabSize(b){_._setTabSize(b)},get insertSpaces(){return _._insertSpaces},set insertSpaces(b){_._setInsertSpaces(b)},get cursorStyle(){return _._cursorStyle},set cursorStyle(b){_._setCursorStyle(b)},get lineNumbers(){return _._lineNumbers},set lineNumbers(b){_._setLineNumbers(b)}}}_accept(u){this._tabSize=u.tabSize,this._insertSpaces=u.insertSpaces,this._cursorStyle=u.cursorStyle,this._lineNumbers=S.TextEditorLineNumbersStyle.to(u.lineNumbers)}_validateTabSize(u){if(u==="auto")return"auto";if(typeof u=="number"){const m=Math.floor(u);return m>0?m:null}if(typeof u=="string"){const m=parseInt(u,10);return isNaN(m)?null:m>0?m:null}return null}_setTabSize(u){const m=this._validateTabSize(u);if(m!==null){if(typeof m=="number"){if(this._tabSize===m)return;this._tabSize=m}this._warnOnError(this._proxy.$trySetOptions(this._id,{tabSize:m}))}}_validateInsertSpaces(u){return u==="auto"?"auto":u==="false"?!1:Boolean(u)}_setInsertSpaces(u){const m=this._validateInsertSpaces(u);if(typeof m=="boolean"){if(this._insertSpaces===m)return;this._insertSpaces=m}this._warnOnError(this._proxy.$trySetOptions(this._id,{insertSpaces:m}))}_setCursorStyle(u){this._cursorStyle!==u&&(this._cursorStyle=u,this._warnOnError(this._proxy.$trySetOptions(this._id,{cursorStyle:u})))}_setLineNumbers(u){this._lineNumbers!==u&&(this._lineNumbers=u,this._warnOnError(this._proxy.$trySetOptions(this._id,{lineNumbers:S.TextEditorLineNumbersStyle.from(u)})))}assign(u){const m={};let l=!1;if(typeof u.tabSize!="undefined"){const v=this._validateTabSize(u.tabSize);v==="auto"?(l=!0,m.tabSize=v):typeof v=="number"&&this._tabSize!==v&&(this._tabSize=v,l=!0,m.tabSize=v)}if(typeof u.insertSpaces!="undefined"){const v=this._validateInsertSpaces(u.insertSpaces);v==="auto"?(l=!0,m.insertSpaces=v):this._insertSpaces!==v&&(this._insertSpaces=v,l=!0,m.insertSpaces=v)}typeof u.cursorStyle!="undefined"&&this._cursorStyle!==u.cursorStyle&&(this._cursorStyle=u.cursorStyle,l=!0,m.cursorStyle=u.cursorStyle),typeof u.lineNumbers!="undefined"&&this._lineNumbers!==u.lineNumbers&&(this._lineNumbers=u.lineNumbers,l=!0,m.lineNumbers=S.TextEditorLineNumbersStyle.from(u.lineNumbers)),l&&this._warnOnError(this._proxy.$trySetOptions(this._id,m))}_warnOnError(u){u.catch(m=>this._logService.warn(m))}}e.ExtHostTextEditorOptions=A;class i{constructor(u,m,l,v,_,b,P,c){this.id=u,this._proxy=m,this._logService=l,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=_,this._options=new A(this._proxy,this.id,b,l),this._visibleRanges=P,this._viewColumn=c;const h=this;this.value=Object.freeze({get document(){return v.getValue()},set document(p){throw(0,R.readonly)("document")},get selection(){return h._selections&&h._selections[0]},set selection(p){if(!(p instanceof T.Selection))throw(0,R.illegalArgument)("selection");h._selections=[p],h._trySetSelection()},get selections(){return h._selections},set selections(p){if(!Array.isArray(p)||p.some(t=>!(t instanceof T.Selection)))throw(0,R.illegalArgument)("selections");h._selections=p,h._trySetSelection()},get visibleRanges(){return h._visibleRanges},set visibleRanges(p){throw(0,R.readonly)("visibleRanges")},get options(){return h._options.value},set options(p){h._disposed||h._options.assign(p)},get viewColumn(){return h._viewColumn},set viewColumn(p){throw(0,R.readonly)("viewColumn")},edit(p,t={undoStopBefore:!0,undoStopAfter:!0}){if(h._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const r=new y(v.getValue(),t);return p(r),h._applyEdit(r)},insertSnippet(p,t,r={undoStopBefore:!0,undoStopAfter:!0}){if(h._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let s;if(!t||Array.isArray(t)&&t.length===0)s=h._selections.map(n=>S.Range.from(n));else if(t instanceof T.Position){const{lineNumber:n,column:a}=S.Position.from(t);s=[{startLineNumber:n,startColumn:a,endLineNumber:n,endColumn:a}]}else if(t instanceof T.Range)s=[S.Range.from(t)];else{s=[];for(const n of t)if(n instanceof T.Range)s.push(S.Range.from(n));else{const{lineNumber:a,column:d}=S.Position.from(n);s.push({startLineNumber:a,startColumn:d,endLineNumber:a,endColumn:d})}}return m.$tryInsertSnippet(u,p.value,s,r)},setDecorations(p,t){const r=t.length===0;r&&!h._hasDecorationsForKey.has(p.key)||(r?h._hasDecorationsForKey.delete(p.key):h._hasDecorationsForKey.add(p.key),h._runOnProxy(()=>{if(S.isDecorationOptionsArr(t))return m.$trySetDecorations(u,p.key,S.fromRangeOrRangeWithMessage(t));{const s=new Array(4*t.length);for(let n=0,a=t.length;n<a;n++){const d=t[n];s[4*n]=d.start.line+1,s[4*n+1]=d.start.character+1,s[4*n+2]=d.end.line+1,s[4*n+3]=d.end.character+1}return m.$trySetDecorationsFast(u,p.key,s)}}))},revealRange(p,t){h._runOnProxy(()=>m.$tryRevealRange(u,S.Range.from(p),t||T.TextEditorRevealType.Default))},show(p){m.$tryShowEditor(u,S.ViewColumn.from(p))},hide(){m.$tryHideEditor(u)}})}dispose(){(0,g.ok)(!this._disposed),this._disposed=!0}_acceptOptions(u){(0,g.ok)(!this._disposed),this._options._accept(u)}_acceptVisibleRanges(u){(0,g.ok)(!this._disposed),this._visibleRanges=u}_acceptViewColumn(u){(0,g.ok)(!this._disposed),this._viewColumn=u}_acceptSelections(u){(0,g.ok)(!this._disposed),this._selections=u}async _trySetSelection(){const u=this._selections.map(S.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,u)),this.value}_applyEdit(u){const m=u.finalize();if(m.edits.length===0&&!m.setEndOfLine)return Promise.resolve(!0);const l=m.edits.map(_=>_.range);l.sort((_,b)=>_.end.line===b.end.line?_.end.character===b.end.character?_.start.line===b.start.line?_.start.character-b.start.character:_.start.line-b.start.line:_.end.character-b.end.character:_.end.line-b.end.line);for(let _=0,b=l.length-1;_<b;_++){const P=l[_].end;if(l[_+1].start.isBefore(P))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const v=m.edits.map(_=>({range:S.Range.from(_.range),text:_.text,forceMoveMarkers:_.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,m.documentVersionId,v,{setEndOfLine:typeof m.setEndOfLine=="number"?S.EndOfLine.from(m.setEndOfLine):void 0,undoStopBefore:m.undoStopBefore,undoStopAfter:m.undoStopAfter})}_runOnProxy(u){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):u().then(()=>this,m=>(m instanceof Error&&m.name==="DISPOSED"||this._logService.warn(m),null))}}e.ExtHostTextEditor=i}),define(me[220],ge([0,1,168,23,2,3,6,208,16,7,14,20,17,21,205]),function(J,e,g,R,k,S,T,D,y,A,i,C,u,m,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function v(P,c){if((0,i.isString)(P))return{label:P};if(P&&typeof P=="object"&&typeof P.label=="string"){let h;return Array.isArray(P.highlights)&&(h=P.highlights.filter(p=>p.length===2&&typeof p[0]=="number"&&typeof p[1]=="number"),h=h.length?h:void 0),{label:P.label,highlights:h}}}class _{constructor(c,h,p){this._proxy=c,this.commands=h,this.logService=p,this.treeViews=new Map;function t(r){return r&&r.$treeViewId&&r.$treeItemHandle}h.registerArgumentProcessor({processArgument:r=>t(r)?this.convertArgument(r):Array.isArray(r)&&r.length>0?r.map(s=>t(s)?this.convertArgument(s):s):r})}registerTreeDataProvider(c,h,p){const t=this.createTreeView(c,{treeDataProvider:h},p);return{dispose:()=>t.dispose()}}createTreeView(c,h,p){if(!h||!h.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const t=h.dragAndDropController!==void 0,r=this._proxy.$registerTreeViewDataProvider(c,{showCollapseAll:!!h.showCollapseAll,canSelectMany:!!h.canSelectMany,canDragAndDrop:t}),s=this.createExtHostTreeView(c,h,p);return{get onDidCollapseElement(){return s.onDidCollapseElement},get onDidExpandElement(){return s.onDidExpandElement},get selection(){return s.selectedElements},get onDidChangeSelection(){return s.onDidChangeSelection},get visible(){return s.visible},get onDidChangeVisibility(){return s.onDidChangeVisibility},get message(){return s.message},set message(n){s.message=n},get title(){return s.title},set title(n){s.title=n},get description(){return s.description},set description(n){s.description=n},reveal:(n,a)=>s.reveal(n,a),dispose:async()=>{await r,this.treeViews.delete(c),s.dispose()}}}$getChildren(c,h){const p=this.treeViews.get(c);return p?p.getChildren(h):Promise.reject(new Error((0,g.localize)(0,null,c)))}async $onDrop(c,h,p){const t=this.treeViews.get(c);if(!t)return Promise.reject(new Error((0,g.localize)(1,null,c)));const r=l.TreeDataTransferConverter.toITreeDataTransfer(h);if(r.items.has(D.TREE_ITEM_DATA_TRANSFER_TYPE)){const n=JSON.parse(await r.items.get(D.TREE_ITEM_DATA_TRANSFER_TYPE).asString()).map(a=>t.getExtensionElement(a)).filter(a=>!!a);n.length>0?r.items.set(D.TREE_ITEM_DATA_TRANSFER_TYPE,{asString:async()=>JSON.stringify(n)}):r.items.delete(D.TREE_ITEM_DATA_TRANSFER_TYPE)}return t.onDrop(r,p)}async $hasResolve(c){const h=this.treeViews.get(c);if(!h)throw new Error((0,g.localize)(2,null,c));return h.hasResolve}$resolve(c,h,p){const t=this.treeViews.get(c);if(!t)throw new Error((0,g.localize)(3,null,c));return t.resolveTreeItem(h,p)}$setExpanded(c,h,p){const t=this.treeViews.get(c);if(!t)throw new Error((0,g.localize)(4,null,c));t.setExpanded(h,p)}$setSelection(c,h){const p=this.treeViews.get(c);if(!p)throw new Error((0,g.localize)(5,null,c));p.setSelection(h)}$setVisible(c,h){const p=this.treeViews.get(c);if(!p)throw new Error((0,g.localize)(6,null,c));p.setVisible(h)}createExtHostTreeView(c,h,p){const t=new b(c,h,this._proxy,this.commands.converter,this.logService,p);return this.treeViews.set(c,t),t}convertArgument(c){const h=this.treeViews.get(c.$treeViewId);return h?h.getExtensionElement(c.$treeItemHandle):null}}e.ExtHostTreeViews=_;class b extends T.Disposable{constructor(c,h,p,t,r,s){super();if(this.viewId=c,this.proxy=p,this.commands=t,this.logService=r,this.extension=s,this.roots=null,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._onDidExpandElement=this._register(new S.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new S.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new S.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new S.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeData=this._register(new S.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new m.CancellationTokenSource,s.contributes&&s.contributes.views)for(const d in s.contributes.views)for(const f of s.contributes.views[d])f.id===c&&(this._title=f.name);this.dataProvider=h.treeDataProvider,this.dndController=h.dragAndDropController,this.dataProvider.onDidChangeTreeData2?this._register(this.dataProvider.onDidChangeTreeData2(d=>this._onDidChangeData.fire({message:!1,element:d}))):this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(d=>this._onDidChangeData.fire({message:!1,element:d})));let n,a;this._register(S.Event.debounce(this._onDidChangeData.event,(d,f)=>(d||(d={message:!1,elements:[]}),f.element!==!1&&(n||(n=new Promise(w=>a=w),this.refreshPromise=this.refreshPromise.then(()=>n)),Array.isArray(f.element)?d.elements.push(...f.element):d.elements.push(f.element)),f.message&&(d.message=!0),d),200,!0)(({message:d,elements:f})=>{f.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const w=a;return n=null,this.refresh(f).then(()=>w())})),d&&this.proxy.$setMessage(this.viewId,this._message)}))}get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(c=>this.getExtensionElement(c)).filter(c=>!(0,i.isUndefinedOrNull)(c))}getChildren(c){const h=c?this.getExtensionElement(c):void 0;if(c&&!h)return this.logService.error(`No tree item with id '${c}' found.`),Promise.resolve([]);const p=this.getChildrenNodes(c);return(p?Promise.resolve(p):this.fetchChildrenNodes(h)).then(t=>t.map(r=>r.item))}getExtensionElement(c){return this.elements.get(c)}reveal(c,h){h=h||{select:!0,focus:!1};const p=(0,i.isUndefinedOrNull)(h.select)?!0:h.select,t=(0,i.isUndefinedOrNull)(h.focus)?!1:h.focus,r=(0,i.isUndefinedOrNull)(h.expand)?!1:h.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):c?this.refreshPromise.then(()=>this.resolveUnknownParentChain(c)).then(s=>this.resolveTreeNode(c,s[s.length-1]).then(n=>this.proxy.$reveal(this.viewId,{item:n.item,parentChain:s.map(a=>a.item)},{select:p,focus:t,expand:r})),s=>this.logService.error(s)):this.proxy.$reveal(this.viewId,void 0,{select:p,focus:t,expand:r})}get message(){return this._message}set message(c){this._message=c,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(c){this._title=c,this.proxy.$setTitle(this.viewId,c,this._description)}get description(){return this._description}set description(c){this._description=c,this.proxy.$setTitle(this.viewId,this._title,c)}setExpanded(c,h){const p=this.getExtensionElement(c);p&&(h?this._onDidExpandElement.fire(Object.freeze({element:p})):this._onDidCollapseElement.fire(Object.freeze({element:p})))}setSelection(c){(0,C.equals)(this._selectedHandles,c)||(this._selectedHandles=c,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setVisible(c){c!==this._visible&&(this._visible=c,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}async onDrop(c,h){const p=this.getExtensionElement(h);if(!!p)return(0,y.asPromise)(()=>this.dndController?.onDrop(c,p))}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(c,h){if(!this.dataProvider.resolveTreeItem)return;const p=this.elements.get(c);if(p){const t=this.nodes.get(p);if(t){const r=await this.dataProvider.resolveTreeItem(t.extensionItem,p,h)??t.extensionItem;return t.item.tooltip=this.getTooltip(r.tooltip),t.item.command=this.getCommand(t.disposableStore,r.command),t.item}}}resolveUnknownParentChain(c){return this.resolveParent(c).then(h=>h?this.resolveUnknownParentChain(h).then(p=>this.resolveTreeNode(h,p[p.length-1]).then(t=>(p.push(t),p))):Promise.resolve([]))}resolveParent(c){const h=this.nodes.get(c);return h?Promise.resolve(h.parent?this.elements.get(h.parent.item.handle):void 0):(0,y.asPromise)(()=>this.dataProvider.getParent(c))}resolveTreeNode(c,h){const p=this.nodes.get(c);return p?Promise.resolve(p):(0,y.asPromise)(()=>this.dataProvider.getTreeItem(c)).then(t=>this.createHandle(c,t,h,!0)).then(t=>this.getChildren(h?h.item.handle:void 0).then(()=>{const r=this.getExtensionElement(t);if(r){const s=this.nodes.get(r);if(s)return Promise.resolve(s)}throw new Error(`Cannot resolve tree item for element ${t}`)}))}getChildrenNodes(c){if(c){let h;if(typeof c=="string"){const p=this.getExtensionElement(c);h=p?this.nodes.get(p):void 0}else h=c;return h&&h.children||null}return this.roots}async fetchChildrenNodes(c){this.clearChildren(c);const h=new m.CancellationTokenSource(this._refreshCancellationSource.token);try{const p=c?this.nodes.get(c):void 0,t=await this.dataProvider.getChildren(c);if(h.token.isCancellationRequested)return[];const r=await Promise.all((0,C.coalesce)(t||[]).map(async s=>{const n=await this.dataProvider.getTreeItem(s);return n&&!h.token.isCancellationRequested?this.createAndRegisterTreeNode(s,n,p):null}));return h.token.isCancellationRequested?[]:(0,C.coalesce)(r)}finally{h.dispose()}}refresh(c){if(c.some(p=>!p))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new m.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const p=this.getHandlesToRefresh(c);if(p.length)return this.refreshHandles(p)}return Promise.resolve(void 0)}getHandlesToRefresh(c){const h=new Set,p=c.map(r=>this.nodes.get(r));for(const r of p)if(r&&!h.has(r.item.handle)){let s=r;for(;s&&s.parent&&p.findIndex(n=>s&&s.parent&&n&&n.item.handle===s.parent.item.handle)===-1;){const n=this.elements.get(s.parent.item.handle);s=n?this.nodes.get(n):void 0}s&&!s.parent&&h.add(r.item.handle)}const t=[];return h.forEach(r=>{const s=this.elements.get(r);if(s){const n=this.nodes.get(s);n&&(!n.parent||!h.has(n.parent.item.handle))&&t.push(r)}}),t}refreshHandles(c){const h={};return Promise.all(c.map(p=>this.refreshNode(p).then(t=>{t&&(h[p]=t.item)}))).then(()=>Object.keys(h).length?this.proxy.$refresh(this.viewId,h):void 0)}refreshNode(c){const h=this.getExtensionElement(c);if(h){const p=this.nodes.get(h);if(p)return this.clearChildren(h),(0,y.asPromise)(()=>this.dataProvider.getTreeItem(h)).then(t=>{if(t){const r=this.createTreeNode(h,t,p.parent);return this.updateNodeCache(h,r,p,p.parent),p.dispose(),r}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(c,h,p){const t=this.createTreeNode(c,h,p);if(h.id&&this.elements.has(t.item.handle))throw new Error((0,g.localize)(7,null,h.id));return this.addNodeToCache(c,t),this.addNodeToParentCache(t,p),t}getTooltip(c){return A.MarkdownString.isMarkdownString(c)?u.MarkdownString.from(c):c}getCommand(c,h){return h?this.commands.toInternal(h,c):void 0}createTreeNode(c,h,p){const t=new T.DisposableStore,r=this.createHandle(c,h,p),s=this.getLightIconPath(h);return{item:{handle:r,parentHandle:p?p.item.handle:void 0,label:v(h.label,this.extension),description:h.description,resourceUri:h.resourceUri,tooltip:this.getTooltip(h.tooltip),command:this.getCommand(t,h.command),contextValue:h.contextValue,icon:s,iconDark:this.getDarkIconPath(h)||s,themeIcon:this.getThemeIcon(h),collapsibleState:(0,i.isUndefinedOrNull)(h.collapsibleState)?A.TreeItemCollapsibleState.None:h.collapsibleState,accessibilityInformation:h.accessibilityInformation},extensionItem:h,parent:p,children:void 0,disposableStore:t,dispose(){t.dispose()}}}getThemeIcon(c){return c.iconPath instanceof A.ThemeIcon?c.iconPath:void 0}createHandle(c,{id:h,label:p,resourceUri:t},r,s){if(h)return`${b.ID_HANDLE_PREFIX}/${h}`;const n=v(p,this.extension),a=r?r.item.handle:b.LABEL_HANDLE_PREFIX;let d=n?n.label:t?(0,R.basename)(t):"";d=d.indexOf("/")!==-1?d.replace("/","//"):d;const f=this.nodes.has(c)?this.nodes.get(c).item.handle:void 0,w=this.getChildrenNodes(r)||[];let E,o=0;do{if(E=`${a}/${o}:${d}`,s||!this.elements.has(E)||f===E)break;o++}while(o<=w.length);return E}getLightIconPath(c){if(c.iconPath&&!(c.iconPath instanceof A.ThemeIcon))return typeof c.iconPath=="string"||k.URI.isUri(c.iconPath)?this.getIconPath(c.iconPath):this.getIconPath(c.iconPath.light)}getDarkIconPath(c){if(c.iconPath&&!(c.iconPath instanceof A.ThemeIcon)&&c.iconPath.dark)return this.getIconPath(c.iconPath.dark)}getIconPath(c){return k.URI.isUri(c)?c:k.URI.file(c)}addNodeToCache(c,h){this.elements.set(h.item.handle,c),this.nodes.set(c,h)}updateNodeCache(c,h,p,t){this.elements.delete(h.item.handle),this.nodes.delete(c),h.item.handle!==p.item.handle&&this.elements.delete(p.item.handle),this.addNodeToCache(c,h);const r=this.getChildrenNodes(t)||[],s=r.filter(n=>n.item.handle===p.item.handle)[0];s&&r.splice(r.indexOf(s),1,h)}addNodeToParentCache(c,h){h?(h.children||(h.children=[]),h.children.push(c)):(this.roots||(this.roots=[]),this.roots.push(c))}clearChildren(c){if(c){const h=this.nodes.get(c);if(h){if(h.children)for(const p of h.children){const t=this.elements.get(p.item.handle);t&&this.clear(t)}h.children=void 0}}else this.clearAll()}clear(c){const h=this.nodes.get(c);if(h){if(h.children)for(const p of h.children){const t=this.elements.get(p.item.handle);t&&this.clear(t)}this.nodes.delete(c),this.elements.delete(h.item.handle),h.dispose()}}clearAll(){this.roots=null,this.elements.clear(),this.nodes.forEach(c=>c.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll()}}b.LABEL_HANDLE_PREFIX="0",b.ID_HANDLE_PREFIX="1"}),define(me[221],ge([0,1,16,3,6,14,87,17,126,90]),function(J,e,g,R,k,S,T,D,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SingleUseTestCollection=void 0;class i extends k.Disposable{constructor(u){super();this.controllerId=u,this.debounceSendDiff=this._register(new g.RunOnceScheduler(()=>this.flushDiff(),200)),this.diffOpEmitter=this._register(new R.Emitter),this.root=new T.TestItemRootImpl(this.controllerId,this.controllerId),this.tree=new Map,this.diff=[],this.onDidGenerateDiff=this.diffOpEmitter.event,this.root.canResolveChildren=!0,this.upsertItem(this.root,void 0)}set resolveHandler(u){this._resolveHandler=u;for(const m of this.tree.values())this.updateExpandability(m)}collectDiff(){const u=this.diff;return this.diff=[],u}pushDiff(u){const m=this.diff[this.diff.length-1];if(m&&u[0]===1){if(m[0]===1&&m[1].extId===u[1].extId){(0,y.applyTestItemUpdate)(m[1],u[1]);return}if(m[0]===0&&m[1].item.extId===u[1].extId){(0,y.applyTestItemUpdate)(m[1],u[1]);return}}this.diff.push(u),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(u,m){const l=this.tree.get(u);if(!!l){if((l.expandLevels===void 0||m>l.expandLevels)&&(l.expandLevels=m),l.expand===1){const v=this.resolveChildren(l);return v.isOpen()?this.expandChildren(l,m-1):v.wait().then(()=>this.expandChildren(l,m-1))}else if(l.expand===3)return l.resolveBarrier?.isOpen()===!1?l.resolveBarrier.wait().then(()=>this.expandChildren(l,m-1)):this.expandChildren(l,m-1)}}dispose(){for(const u of this.tree.values())(0,T.getPrivateApiFor)(u.actual).listener=void 0;this.tree.clear(),this.diff=[],super.dispose()}onTestItemEvent(u,m){switch(m.op){case 2:this.pushDiff([4,u.fullId.toString()]);break;case 1:this.removeItem(A.TestId.joinToString(u.fullId,m.id));break;case 0:this.upsertItem(m.item,u);break;case 4:for(const b of m.ops)this.onTestItemEvent(u,b);break;case 3:const{key:l,value:v}=m,_=u.fullId.toString();switch(l){case"canResolveChildren":this.updateExpandability(u);break;case"range":this.pushDiff([1,{extId:_,item:{range:D.Range.from(v)}}]);break;case"error":this.pushDiff([1,{extId:_,item:{error:D.MarkdownString.fromStrict(v)||null}}]);break;default:this.pushDiff([1,{extId:_,item:{[l]:v??null}}]);break}break;default:(0,S.assertNever)(m)}}upsertItem(u,m){if(!(u instanceof T.TestItemImpl))throw new Error(`TestItems provided to the VS Code API must extend \`vscode.TestItem\`, but ${u.id} did not`);const l=A.TestId.fromExtHostTestItem(u,this.root.id,m?.actual),v=(0,T.getPrivateApiFor)(u);v.parent&&v.parent!==m?.actual&&v.parent.children.delete(u.id);let _=this.tree.get(l.toString());if(!_){_={fullId:l,actual:u,parent:m?l.parentId:null,expandLevels:m?.expandLevels?m.expandLevels-1:void 0,expand:0},this.tree.set(_.fullId.toString(),_),this.setItemParent(u,m),this.pushDiff([0,{parent:_.parent&&_.parent.toString(),controllerId:this.controllerId,expand:_.expand,item:D.TestItem.from(u)}]),this.connectItemAndChildren(u,_,m);return}if(_.actual===u){this.connectItem(u,_,m);return}const b=_.actual.children,P=_.actual,c=(0,T.diffTestItems)(P,u);(0,T.getPrivateApiFor)(P).listener=void 0,_.actual=u,_.expand=0;for(const[h,p]of c)this.onTestItemEvent(_,{op:3,key:h,value:p});this.connectItemAndChildren(u,_,m);for(const h of b)u.children.get(h.id)||this.removeItem(A.TestId.joinToString(l,h.id))}setItemParent(u,m){(0,T.getPrivateApiFor)(u).parent=m&&m.actual!==this.root?m.actual:void 0}connectItem(u,m,l){this.setItemParent(u,l);const v=(0,T.getPrivateApiFor)(u);v.parent=l?.actual,v.listener=_=>this.onTestItemEvent(m,_),this.updateExpandability(m)}connectItemAndChildren(u,m,l){this.connectItem(u,m,l);for(const v of u.children)this.upsertItem(v,m)}updateExpandability(u){let m;this._resolveHandler?u.resolveBarrier?m=u.resolveBarrier.isOpen()?3:2:m=u.actual.canResolveChildren?1:0:m=0,m!==u.expand&&(u.expand=m,this.pushDiff([1,{extId:u.fullId.toString(),expand:m}]),m===1&&u.expandLevels!==void 0&&this.resolveChildren(u))}expandChildren(u,m){if(m<0)return;const l=[];for(const v of u.actual.children){const _=this.expand(A.TestId.joinToString(u.fullId,v.id),m);(0,g.isThenable)(_)&&l.push(_)}if(l.length)return Promise.all(l).then(()=>{})}resolveChildren(u){if(u.resolveBarrier)return u.resolveBarrier;if(!this._resolveHandler){const _=new g.Barrier;return _.open(),_}u.expand=2,this.pushExpandStateUpdate(u);const m=u.resolveBarrier=new g.Barrier,l=_=>{console.error(`Unhandled error in resolveHandler of test controller "${this.controllerId}"`),u.actual!==this.root&&(u.actual.error=_.stack||_.message||String(_))};let v;try{v=this._resolveHandler(u.actual===this.root?void 0:u.actual)}catch(_){l(_)}return(0,g.isThenable)(v)?v.catch(l).then(()=>{m.open(),this.updateExpandability(u)}):(m.open(),this.updateExpandability(u)),u.resolveBarrier}pushExpandStateUpdate(u){this.pushDiff([1,{extId:u.fullId.toString(),expand:u.expand}])}removeItem(u){const m=this.tree.get(u);if(!m)throw new Error("attempting to remove non-existent child");this.pushDiff([2,u]);const l=[m];for(;l.length;){const v=l.pop();if(!!v){(0,T.getPrivateApiFor)(v.actual).listener=void 0,this.tree.delete(v.fullId.toString());for(const _ of v.actual.children)l.push(this.tree.get(A.TestId.joinToString(v.fullId,_.id)))}}}flushDiff(){const u=this.collectDiff();u.length&&this.diffOpEmitter.fire(u)}}e.SingleUseTestCollection=i}),define(me[222],ge([0,1,4,183]),function(J,e,g,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,g.refineServiceDecorator)(R.IEnvironmentService)}),define(me[223],ge([0,1,26,3,9]),function(J,e,g,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class S{constructor(i){this.removedDueToLooping=i}}e.DeltaExtensionsResult=S;class T{constructor(i){this._onDidChange=new R.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=i,this._initialize()}_initialize(){this._extensionDescriptions.sort(y),this._extensionsMap=new Map,this._extensionsArr=[],this._activationMap=new Map;for(const i of this._extensionDescriptions){if(this._extensionsMap.has(g.ExtensionIdentifier.toKey(i.identifier))){console.error("Extension `"+i.identifier.value+"` is already registered");continue}if(this._extensionsMap.set(g.ExtensionIdentifier.toKey(i.identifier),i),this._extensionsArr.push(i),Array.isArray(i.activationEvents))for(let C of i.activationEvents)C==="onUri"&&(C=`onUri:${g.ExtensionIdentifier.toKey(i.identifier)}`),this._activationMap.has(C)||this._activationMap.set(C,[]),this._activationMap.get(C).push(i)}}keepOnly(i){const C=new Set;i.forEach(u=>C.add(g.ExtensionIdentifier.toKey(u))),this._extensionDescriptions=this._extensionDescriptions.filter(u=>C.has(g.ExtensionIdentifier.toKey(u.identifier))),this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(i,C){i.length>0&&(this._extensionDescriptions=this._extensionDescriptions.concat(i));const u=T._findLoopingExtensions(this._extensionDescriptions);if(C=C.concat(u.map(m=>m.identifier)),C.length>0){const m=new Set;C.forEach(l=>m.add(g.ExtensionIdentifier.toKey(l))),this._extensionDescriptions=this._extensionDescriptions.filter(l=>!m.has(g.ExtensionIdentifier.toKey(l.identifier)))}return this._initialize(),this._onDidChange.fire(void 0),new S(u)}static _findLoopingExtensions(i){const C=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(_){this._nodesSet.has(_)||(this._nodesSet.add(_),this._nodesArr.push(_))}addArc(_,b){this.addNode(_),this.addNode(b),this._arcs.has(_)?this._arcs.get(_).push(b):this._arcs.set(_,[b])}getArcs(_){return this._arcs.has(_)?this._arcs.get(_):[]}hasOnlyGoodArcs(_,b){const P=C.getArcs(_);for(let c=0;c<P.length;c++)if(!b.has(P[c]))return!1;return!0}getNodes(){return this._nodesArr}};let u=new Map;for(let _ of i){const b=g.ExtensionIdentifier.toKey(_.identifier);if(u.set(b,_),_.extensionDependencies)for(let P of _.extensionDependencies){const c=g.ExtensionIdentifier.toKey(P);C.addArc(b,c)}}let m=new Set;C.getNodes().filter(_=>C.getArcs(_).length===0).forEach(_=>m.add(_));let l=C.getNodes().filter(_=>!m.has(_)),v;do{v=!1;for(let _=0;_<l.length;_++){const b=l[_];C.hasOnlyGoodArcs(b,m)&&(l.splice(_,1),_--,m.add(b),v=!0)}}while(v);return l.map(_=>u.get(_))}containsActivationEvent(i){return this._activationMap.has(i)}containsExtension(i){return this._extensionsMap.has(g.ExtensionIdentifier.toKey(i))}getExtensionDescriptionsForActivationEvent(i){const C=this._activationMap.get(i);return C?C.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(i){const C=this._extensionsMap.get(g.ExtensionIdentifier.toKey(i));return C||void 0}}e.ExtensionDescriptionRegistry=T;var D;(function(A){A[A.Builtin=0]="Builtin",A[A.User=1]="User",A[A.Dev=2]="Dev"})(D||(D={}));function y(A,i){const C=A.isBuiltin?0:A.isUnderDevelopment?2:1,u=i.isBuiltin?0:i.isUnderDevelopment?2:1;if(C!==u)return C-u;const m=k.posix.basename(A.extensionLocation.path),l=k.posix.basename(i.extensionLocation.path);return m<l?-1:m>l?1:0}}),define(me[224],ge([0,1,24]),function(J,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=void 0;var R;(function(D){D[D.VersionMismatch=55]="VersionMismatch",D[D.UnexpectedError=81]="UnexpectedError"})(R=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var k;(function(D){D[D.Initialized=0]="Initialized",D[D.Ready=1]="Ready",D[D.Terminate=2]="Terminate"})(k=e.MessageType||(e.MessageType={}));function S(D){const y=g.VSBuffer.alloc(1);switch(D){case 0:y.writeUInt8(1,0);break;case 1:y.writeUInt8(2,0);break;case 2:y.writeUInt8(3,0);break}return y}e.createMessageOfType=S;function T(D,y){if(D.byteLength!==1)return!1;switch(D.readUInt8(0)){case 1:return y===0;case 2:return y===1;case 3:return y===2;default:return!1}}e.isMessageOfType=T}),define(me[35],ge([0,1,3,2,4,26,185]),function(J,e,g,R,k,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.throwProposedApiError=e.checkProposedApiEnabled=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.ExtensionHostKind=e.MissingExtensionDependency=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new S.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",enableProposedApi:!1,engines:{vscode:""},extensionLocation:R.URI.parse("void:location"),isBuiltin:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,k.createDecorator)("extensionService");class D{constructor(P){this.dependency=P}}e.MissingExtensionDependency=D;var y;(function(b){b[b.LocalProcess=0]="LocalProcess",b[b.LocalWebWorker=1]="LocalWebWorker",b[b.Remote=2]="Remote"})(y=e.ExtensionHostKind||(e.ExtensionHostKind={}));class A{constructor(P,c,h,p){this.codeLoadingTime=P,this.activateCallTime=c,this.activateResolvedTime=h,this.activationReason=p}}e.ActivationTimes=A;class i{constructor(P,c){this.description=P,this.value=c}}e.ExtensionPointContribution=i,e.ExtensionHostLogFileName="exthost";var C;(function(b){b[b.Normal=0]="Normal",b[b.Immediate=1]="Immediate"})(C=e.ActivationKind||(e.ActivationKind={}));function u(b){b.enableProposedApi||m(b)}e.checkProposedApiEnabled=u;function m(b){throw new Error(`[${b.identifier.value}]: Proposed API is only available when running out of dev or with the following command line switch: --enable-proposed-api ${b.identifier.value}`)}e.throwProposedApiError=m;function l(b){return{type:b.isBuiltin?0:1,isBuiltin:b.isBuiltin||b.isUserBuiltin,identifier:{id:(0,T.getGalleryExtensionId)(b.publisher,b.name),uuid:b.uuid},manifest:b,location:b.extensionLocation}}e.toExtension=l;function v(b,P){return{identifier:new S.ExtensionIdentifier(b.identifier.id),isBuiltin:b.type===0,isUserBuiltin:b.type===1&&b.isBuiltin,isUnderDevelopment:!!P,extensionLocation:b.location,...b.manifest,uuid:b.identifier.uuid}}e.toExtensionDescription=v;class _{constructor(){this.onDidRegisterExtensions=g.Event.None,this.onDidChangeExtensionsStatus=g.Event.None,this.onDidChangeExtensions=g.Event.None,this.onWillActivateByEvent=g.Event.None,this.onDidChangeResponsiveChange=g.Event.None}activateByEvent(P){return Promise.resolve(void 0)}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtensions(){return Promise.resolve([])}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(P){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(P){return Promise.resolve(0)}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(P){}canAddExtension(){return!1}canRemoveExtension(){return!1}_activateById(P,c){return Promise.resolve()}_onWillActivateExtension(P){}_onDidActivateExtension(P,c,h,p,t){}_onDidActivateExtensionError(P,c){}_onExtensionRuntimeError(P,c){}_onExtensionHostExit(P){}}e.NullExtensionService=_}),define(me[225],ge([0,1,26,35,12]),function(J,e,g,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.FailedExtension=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;const S=Promise.resolve(void 0);class T{constructor(l,v,_,b){this.startup=l,this.codeLoadingTime=v,this.activateCallTime=_,this.activateResolvedTime=b}}e.ExtensionActivationTimes=T,T.NONE=new T(!1,-1,-1,-1);class D{constructor(l){this._startup=l,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(l,v){return l===-1||v===-1?-1:v-l}build(){return new T(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=D;class y{constructor(l,v,_,b,P,c){this.activationFailed=l,this.activationFailedError=v,this.activationTimes=_,this.module=b,this.exports=P,this.subscriptions=c}}e.ActivatedExtension=y;class A extends y{constructor(l){super(!1,null,l,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=A;class i extends y{constructor(){super(!1,null,T.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=i;class C extends y{constructor(l){super(!0,l,T.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.FailedExtension=C;let u=class{constructor(l,v,_,b,P){this._logService=P,this._registry=l,this._resolvedExtensionsSet=new Set,v.forEach(c=>this._resolvedExtensionsSet.add(g.ExtensionIdentifier.toKey(c))),this._hostExtensionsMap=new Map,_.forEach(c=>this._hostExtensionsMap.set(g.ExtensionIdentifier.toKey(c),c)),this._host=b,this._activatingExtensions=new Map,this._activatedExtensions=new Map,this._alreadyActivatedEvents=Object.create(null)}isActivated(l){const v=g.ExtensionIdentifier.toKey(l);return this._activatedExtensions.has(v)}getActivatedExtension(l){const v=g.ExtensionIdentifier.toKey(l),_=this._activatedExtensions.get(v);if(!_)throw new Error("Extension `"+l.value+"` is not known or not activated");return _}activateByEvent(l,v){if(this._alreadyActivatedEvents[l])return S;const _=this._registry.getExtensionDescriptionsForActivationEvent(l);return this._activateExtensions(_.map(b=>({id:b.identifier,reason:{startup:v,extensionId:b.identifier,activationEvent:l}}))).then(()=>{this._alreadyActivatedEvents[l]=!0})}activateById(l,v){const _=this._registry.getExtensionDescription(l);if(!_)throw new Error("Extension `"+l+"` is not known");return this._activateExtensions([{id:_.identifier,reason:v}])}_handleActivateRequest(l,v,_){if(this._hostExtensionsMap.has(g.ExtensionIdentifier.toKey(l.id))){v[g.ExtensionIdentifier.toKey(l.id)]=l;return}const b=this._registry.getExtensionDescription(l.id);if(!b){const h=new Error(`Cannot activate unknown extension '${l.id.value}'`);this._host.onExtensionActivationError(l.id,h,new R.MissingExtensionDependency(l.id.value)),this._activatedExtensions.set(g.ExtensionIdentifier.toKey(l.id),new C(h));return}const P=typeof b.extensionDependencies=="undefined"?[]:b.extensionDependencies;let c=!0;for(let h=0,p=P.length;h<p;h++){const t=P[h];if(this._resolvedExtensionsSet.has(g.ExtensionIdentifier.toKey(t)))continue;const r=this._activatedExtensions.get(g.ExtensionIdentifier.toKey(t));if(r&&!r.activationFailed)continue;if(r&&r.activationFailed){const d=b.displayName||b.identifier.value,f=this._registry.getExtensionDescription(t),w=f&&f.displayName||t,E=new Error(`Cannot activate the '${d}' extension because its dependency '${w}' failed to activate`);E.detail=r.activationFailedError,this._host.onExtensionActivationError(b.identifier,E,null),this._activatedExtensions.set(g.ExtensionIdentifier.toKey(b.identifier),new C(E));return}if(this._hostExtensionsMap.has(g.ExtensionIdentifier.toKey(t))){c=!1,v[g.ExtensionIdentifier.toKey(t)]={id:this._hostExtensionsMap.get(g.ExtensionIdentifier.toKey(t)),reason:l.reason};continue}const s=this._registry.getExtensionDescription(t);if(s){c=!1,v[g.ExtensionIdentifier.toKey(t)]={id:s.identifier,reason:l.reason};continue}const n=b.displayName||b.identifier.value,a=new Error(`Cannot activate the '${n}' extension because it depends on unknown extension '${t}'`);this._host.onExtensionActivationError(b.identifier,a,new R.MissingExtensionDependency(t)),this._activatedExtensions.set(g.ExtensionIdentifier.toKey(b.identifier),new C(a));return}c?v[g.ExtensionIdentifier.toKey(b.identifier)]=l:_.push(l)}_activateExtensions(l){if(l.length===0||(l=l.filter(P=>!this._activatedExtensions.has(g.ExtensionIdentifier.toKey(P.id))),l.length===0))return Promise.resolve(void 0);const v=Object.create(null),_=[];for(let P=0,c=l.length;P<c;P++)this._handleActivateRequest(l[P],v,_);for(let P=0,c=_.length;P<c;P++){const h=g.ExtensionIdentifier.toKey(_[P].id);v[h]&&delete v[h]}const b=Object.keys(v).map(P=>v[P]);return _.length===0?Promise.all(b.map(P=>this._activateExtension(P.id,P.reason))).then(P=>{}):this._activateExtensions(b).then(P=>this._activateExtensions(_))}_activateExtension(l,v){const _=g.ExtensionIdentifier.toKey(l);if(this._activatedExtensions.has(_))return Promise.resolve(void 0);const b=this._activatingExtensions.get(_);if(b)return b;const P=this._host.actualActivateExtension(l,v).then(void 0,c=>{const h=new Error;return c&&c.name&&(h.name=c.name),c&&c.message?h.message=`Activating extension '${l.value}' failed: ${c.message}.`:h.message=`Activating extension '${l.value}' failed: ${c}.`,c&&c.stack&&(h.stack=c.stack),this._host.onExtensionActivationError(l,h,null),this._logService.error(`Activating extension ${l.value} failed due to an error:`),this._logService.error(c),new C(c)}).then(c=>{this._activatedExtensions.set(_,c),this._activatingExtensions.delete(_)});return this._activatingExtensions.set(_,P),P}};u=Ve([$e(4,k.ILogService)],u),e.ExtensionsActivator=u}),define(me[226],ge([0,1,12,35,27,10,116]),function(J,e,g,R,k,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let D=class extends g.LogService{constructor(A){if(A.logFile.scheme!==S.Schemas.file)throw new Error("Only file-logging supported");super(new T.SpdLogLogger(R.ExtensionHostLogFileName,A.logFile.fsPath,!0,A.logLevel))}$setLevel(A){this.setLevel(A)}};D=Ve([$e(0,k.IExtHostInitDataService)],D),e.ExtHostLogService=D}),define(me[227],ge([0,1,15]),function(J,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LazyPromise=void 0;class R{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((S,T)=>{this._actualOk=S,this._actualErr=T,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(S){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=S,this._actual&&this._actualOk(S))}resolveErr(S){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=S,this._actual?this._actualErr(S):(0,g.onUnexpectedError)(S))}then(S,T){return this._ensureActual().then(S,T)}catch(S){return this._ensureActual().then(void 0,S)}finally(S){return this._ensureActual().finally(S)}}e.LazyPromise=R}),define(me[130],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getStringIdentifierForProxy=e.createExtHostContextProxyIdentifier=e.createMainContextProxyIdentifier=e.ProxyIdentifier=void 0;class g{constructor(y,A){this._proxyIdentifierBrand=void 0,this.isMain=y,this.sid=A,this.nid=++g.count}}e.ProxyIdentifier=g,g.count=0;const R=[];function k(D){const y=new g(!0,D);return R[y.nid]=y,y}e.createMainContextProxyIdentifier=k;function S(D){const y=new g(!1,D);return R[y.nid]=y,y}e.createExtHostContextProxyIdentifier=S;function T(D){return R[D].sid}e.getStringIdentifierForProxy=T}),define(me[5],ge([0,1,59,2,130]),function(J,e,g,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.reviveWorkspaceEditDto=e.WorkspaceEditType=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.ObjectIdentifier=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TextEditorRevealType=e.UIKind=void 0;var S;(function(c){c[c.Desktop=1]="Desktop",c[c.Web=2]="Web"})(S=e.UIKind||(e.UIKind={}));var T;(function(c){c[c.Default=0]="Default",c[c.InCenter=1]="InCenter",c[c.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",c[c.AtTop=3]="AtTop"})(T=e.TextEditorRevealType||(e.TextEditorRevealType={}));var D;(function(c){c[c.Editable=0]="Editable",c[c.SupportsHotExit=1]="SupportsHotExit"})(D=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var y;(function(c){c[c.Int8Array=1]="Int8Array",c[c.Uint8Array=2]="Uint8Array",c[c.Uint8ClampedArray=3]="Uint8ClampedArray",c[c.Int16Array=4]="Int16Array",c[c.Uint16Array=5]="Uint16Array",c[c.Int32Array=6]="Int32Array",c[c.Uint32Array=7]="Uint32Array",c[c.Float32Array=8]="Float32Array",c[c.Float64Array=9]="Float64Array",c[c.BigInt64Array=10]="BigInt64Array",c[c.BigUint64Array=11]="BigUint64Array"})(y=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var A;(function(c){c[c.Text=1]="Text",c[c.Error=2]="Error",c[c.Rich=3]="Rich"})(A=e.CellOutputKind||(e.CellOutputKind={}));var i;(function(c){c[c.Default=0]="Default",c[c.InCenter=1]="InCenter",c[c.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",c[c.AtTop=3]="AtTop"})(i=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var C;(function(c){c[c.None=0]="None",c[c.Process=1]="Process",c[c.Output=2]="Output"})(C=e.CandidatePortSource||(e.CandidatePortSource={}));var u;(function(c){c.name="$ident";function h(t,r){return Object.defineProperty(t,c.name,{value:r,enumerable:!0}),t}c.mixin=h;function p(t){return t[c.name]}c.of=p})(u=e.ObjectIdentifier||(e.ObjectIdentifier={}));class m{static mixin(h){return h._id=m._n++,h}}e.IdObject=m,m._n=0;var l;(function(c){c.label="a",c.kind="b",c.detail="c",c.documentation="d",c.sortText="e",c.filterText="f",c.preselect="g",c.insertText="h",c.insertTextRules="i",c.range="j",c.commitCharacters="k",c.additionalTextEdits="l",c.command="m",c.kindModifier="n"})(l=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var v;(function(c){c.defaultRanges="a",c.completions="b",c.isIncomplete="c",c.duration="d"})(v=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var _;(function(c){c[c.File=1]="File",c[c.Text=2]="Text",c[c.Cell=3]="Cell"})(_=e.WorkspaceEditType||(e.WorkspaceEditType={}));function b(c){if(c&&c.edits)for(const h of c.edits)typeof h.resource=="object"?h.resource=R.URI.revive(h.resource):(h.newUri=R.URI.revive(h.newUri),h.oldUri=R.URI.revive(h.oldUri)),h.metadata&&h.metadata.iconPath&&(h.metadata=(0,g.revive)(h.metadata));return c}e.reviveWorkspaceEditDto=b;var P;(function(c){c[c.Workspace=0]="Workspace",c[c.TextDocument=1]="TextDocument"})(P=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,k.createMainContextProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,k.createMainContextProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,k.createMainContextProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,k.createMainContextProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,k.createMainContextProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,k.createMainContextProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,k.createMainContextProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,k.createMainContextProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,k.createMainContextProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,k.createMainContextProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,k.createMainContextProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,k.createMainContextProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,k.createMainContextProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,k.createMainContextProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,k.createMainContextProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,k.createMainContextProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,k.createMainContextProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,k.createMainContextProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,k.createMainContextProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,k.createMainContextProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,k.createMainContextProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,k.createMainContextProxyIdentifier)("MainThreadLanguages"),MainThreadLog:(0,k.createMainContextProxyIdentifier)("MainThread"),MainThreadMessageService:(0,k.createMainContextProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,k.createMainContextProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,k.createMainContextProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,k.createMainContextProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,k.createMainContextProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,k.createMainContextProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,k.createMainContextProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,k.createMainContextProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,k.createMainContextProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,k.createMainContextProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,k.createMainContextProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,k.createMainContextProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,k.createMainContextProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,k.createMainContextProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,k.createMainContextProxyIdentifier)("MainThreadUriOpeners"),MainThreadWorkspace:(0,k.createMainContextProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,k.createMainContextProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,k.createMainContextProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,k.createMainContextProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,k.createMainContextProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,k.createMainContextProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,k.createMainContextProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,k.createMainContextProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,k.createMainContextProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,k.createMainContextProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,k.createMainContextProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,k.createMainContextProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,k.createMainContextProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,k.createMainContextProxyIdentifier)("MainThreadInteractive"),MainThreadTheming:(0,k.createMainContextProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,k.createMainContextProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,k.createMainContextProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,k.createMainContextProxyIdentifier)("MainThreadTesting")},e.ExtHostContext={ExtHostCommands:(0,k.createExtHostContextProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,k.createExtHostContextProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,k.createExtHostContextProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,k.createExtHostContextProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,k.createExtHostContextProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,k.createExtHostContextProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,k.createExtHostContextProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,k.createExtHostContextProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,k.createExtHostContextProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,k.createExtHostContextProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,k.createExtHostContextProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,k.createExtHostContextProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,k.createExtHostContextProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,k.createExtHostContextProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguageFeatures:(0,k.createExtHostContextProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,k.createExtHostContextProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,k.createExtHostContextProxyIdentifier)("ExtHostExtensionService"),ExtHostLogService:(0,k.createExtHostContextProxyIdentifier)("ExtHostLogService"),ExtHostTerminalService:(0,k.createExtHostContextProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,k.createExtHostContextProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,k.createExtHostContextProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,k.createExtHostContextProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,k.createExtHostContextProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,k.createExtHostContextProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,k.createExtHostContextProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,k.createExtHostContextProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,k.createExtHostContextProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,k.createExtHostContextProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,k.createExtHostContextProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,k.createExtHostContextProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,k.createMainContextProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,k.createMainContextProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,k.createMainContextProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,k.createMainContextProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,k.createExtHostContextProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,k.createExtHostContextProxyIdentifier)("ExtHostUriOpeners"),ExtHostOutputService:(0,k.createMainContextProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,k.createMainContextProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,k.createMainContextProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,k.createMainContextProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,k.createMainContextProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,k.createMainContextProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,k.createMainContextProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostInteractive:(0,k.createMainContextProxyIdentifier)("ExtHostInteractive"),ExtHostTheming:(0,k.createMainContextProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,k.createMainContextProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,k.createMainContextProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,k.createMainContextProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,k.createMainContextProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,k.createMainContextProxyIdentifier)("ExtHostTelemetry")}}),define(me[91],ge([0,1,5,3,4]),function(J,e,g,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class S{constructor(D){this._onDidChangePassword=new R.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=D.getProxy(g.MainContext.MainThreadSecretState)}async $onDidChangePassword(D){this._onDidChangePassword.fire(D)}get(D,y){return this._proxy.$getPassword(D,y)}store(D,y,A){return this._proxy.$setPassword(D,y,A)}delete(D,y){return this._proxy.$deletePassword(D,y)}}e.ExtHostSecretState=S,e.IExtHostSecretState=(0,k.createDecorator)("IExtHostSecretState")}),define(me[64],ge([0,1,4,12,5,13]),function(J,e,g,R,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,g.createDecorator)("IExtHostApiDeprecationService");let T=class{constructor(y,A){this._extHostLogService=A,this._reportedUsages=new Set,this._telemetryShape=y.getProxy(k.MainContext.MainThreadTelemetry)}report(y,A,i){const C=this.getUsageKey(y,A);this._reportedUsages.has(C)||(this._reportedUsages.add(C),A.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${y}' is deprecated. ${i}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:A.identifier.value,apiId:y}))}getUsageKey(y,A){return`${y}-${A.identifier.value}`}};T=Ve([$e(0,S.IExtHostRpcService),$e(1,R.ILogService)],T),e.ExtHostApiDeprecationService=T,e.NullApiDeprecationService=Object.freeze(new class{report(D,y,A){}})}),define(me[228],ge([0,1,3,5,7,26]),function(J,e,g,R,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class T{constructor(y){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeSessions=new g.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._inFlightRequests=new Map,this._proxy=y.getProxy(R.MainContext.MainThreadAuthentication)}$setProviders(y){return this._providers=y,Promise.resolve()}async getSession(y,A,i,C={}){const u=S.ExtensionIdentifier.toKey(y.identifier),m=this._inFlightRequests.get(u)||[],l=[...i].sort().join(" ");let v=m.find(_=>_.scopes===l);if(v)return v.result;{const _=this._getSession(y,u,A,i,C);v={scopes:l,result:_},m.push(v),this._inFlightRequests.set(u,m);try{await _}finally{const b=m.findIndex(P=>P.scopes===l);b>-1&&(m.splice(b),this._inFlightRequests.set(u,m))}return _}}async _getSession(y,A,i,C,u={}){await this._proxy.$ensureProvider(i);const m=y.displayName||y.name;return this._proxy.$getSession(i,C,A,m,u)}async removeSession(y,A){const i=this._authenticationProviders.get(y);return i?i.provider.removeSession(A):this._proxy.$removeSession(y,A)}registerAuthenticationProvider(y,A,i,C){if(this._authenticationProviders.get(y))throw new Error(`An authentication provider with id '${y}' is already registered.`);this._authenticationProviders.set(y,{label:A,provider:i,options:C??{supportsMultipleAccounts:!1}}),this._providers.find(m=>m.id===y)||this._providers.push({id:y,label:A});const u=i.onDidChangeSessions(m=>{this._proxy.$sendDidChangeSessions(y,{added:m.added??[],changed:m.changed??[],removed:m.removed??[]})});return this._proxy.$registerAuthenticationProvider(y,A,C?.supportsMultipleAccounts??!1),new k.Disposable(()=>{u.dispose(),this._authenticationProviders.delete(y);const m=this._providers.findIndex(l=>l.id===y);m>-1&&this._providers.splice(m),this._proxy.$unregisterAuthenticationProvider(y)})}$createSession(y,A){const i=this._authenticationProviders.get(y);if(i)return Promise.resolve(i.provider.createSession(A));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$removeSession(y,A){const i=this._authenticationProviders.get(y);if(i)return Promise.resolve(i.provider.removeSession(A));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$getSessions(y,A){const i=this._authenticationProviders.get(y);if(i)return Promise.resolve(i.provider.getSessions(A));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$onDidChangeAuthenticationSessions(y,A){return this._onDidChangeSessions.fire({provider:{id:y,label:A}}),Promise.resolve()}}e.ExtHostAuthentication=T}),define(me[229],ge([0,1,5,13,17]),function(J,e,g,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let S=class{constructor(D,y){this._extHostDocumentsAndEditors=y,this._proxy=D.getProxy(g.MainContext.MainThreadBulkEdits)}applyWorkspaceEdit(D){const y=k.WorkspaceEdit.from(D,this._extHostDocumentsAndEditors);return this._proxy.$tryApplyWorkspaceEdit(y)}};S=Ve([$e(0,R.IExtHostRpcService)],S),e.ExtHostBulkEdits=S}),define(me[230],ge([0,1,5]),function(J,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class R{constructor(S){const T=S.getProxy(g.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return T.$readText()},writeText(D){return T.$writeText(D)}})}}e.ExtHostClipboard=R}),define(me[44],ge([0,1,14,7,17,25,5,20,12,59,41,50,2,6,4,13]),function(J,e,g,R,k,S,T,D,y,A,i,C,u,m,l,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let _=class{constructor(t,r){this._commands=new Map,this._apiCommands=new Map,this._proxy=t.getProxy(T.MainContext.MainThreadCommands),this._logService=r,this.converter=new b(this,s=>{const n=this._apiCommands.get(s);return n?.result===c.Void?n:void 0},r),this._argumentProcessors=[{processArgument(s){return(0,A.revive)(s)}},{processArgument(s){return(0,S.cloneAndChange)(s,function(n){if(i.Range.isIRange(n))return k.Range.to(n);if(C.Position.isIPosition(n))return k.Position.to(n);if(i.Range.isIRange(n.range)&&u.URI.isUri(n.uri))return k.location.to(n);if(!Array.isArray(n))return n})}}]}registerArgumentProcessor(t){this._argumentProcessors.push(t)}registerApiCommand(t){const r=this.registerCommand(!1,t.id,async(...s)=>{const n=t.args.map((d,f)=>{if(!d.validate(s[f]))throw new Error(`Invalid argument '${d.name}' when running '${t.id}', received: ${s[f]}`);return d.convert(s[f])}),a=await this.executeCommand(t.internalId,...n);return t.result.convert(a,s,this.converter)},void 0,{description:t.description,args:t.args,returns:t.result.description});return this._apiCommands.set(t.id,t),new R.Disposable(()=>{r.dispose(),this._apiCommands.delete(t.id)})}registerCommand(t,r,s,n,a){if(this._logService.trace("ExtHostCommands#registerCommand",r),!r.trim().length)throw new Error("invalid id");if(this._commands.has(r))throw new Error(`command '${r}' already exists`);return this._commands.set(r,{callback:s,thisArg:n,description:a}),t&&this._proxy.$registerCommand(r),new R.Disposable(()=>{this._commands.delete(r)&&t&&this._proxy.$unregisterCommand(r)})}executeCommand(t,...r){return this._logService.trace("ExtHostCommands#executeCommand",t),this._doExecuteCommand(t,r,!0)}async _doExecuteCommand(t,r,s){if(this._commands.has(t))return this._executeContributedCommand(t,r);{const n=(0,S.cloneAndChange)(r,function(a){if(a instanceof R.Position)return k.Position.from(a);if(a instanceof R.Range)return k.Range.from(a);if(a instanceof R.Location)return k.location.from(a);if(R.NotebookRange.isNotebookRange(a))return k.NotebookRange.from(a);if(!Array.isArray(a))return a});try{const a=await this._proxy.$executeCommand(t,n,s);return(0,A.revive)(a)}catch(a){if(a instanceof Error&&a.message==="$executeCommand:retry")return this._doExecuteCommand(t,r,!1);throw a}}}async _executeContributedCommand(t,r){const s=this._commands.get(t);if(!s)throw new Error("Unknown command");let{callback:n,thisArg:a,description:d}=s;if(d)for(let f=0;f<d.args.length;f++)try{(0,g.validateConstraint)(r[f],d.args[f].constraint)}catch(w){throw new Error(`Running the contributed command: '${t}' failed. Illegal argument '${d.args[f].name}' - ${d.args[f].description}`)}try{return await n.apply(a,r)}catch(f){if(t===this.converter.delegatingCommandId){const w=this.converter.getActualCommand(...r);w&&(t=w.command)}throw this._logService.error(f,t),new Error(`Running the contributed command: '${t}' failed.`)}}$executeContributedCommand(t,...r){return this._logService.trace("ExtHostCommands#$executeContributedCommand",t),this._commands.has(t)?(r=r.map(s=>this._argumentProcessors.reduce((n,a)=>a.processArgument(n),s)),this._executeContributedCommand(t,r)):Promise.reject(new Error(`Contributed command '${t}' does not exist.`))}getCommands(t=!1){return this._logService.trace("ExtHostCommands#getCommands",t),this._proxy.$getCommands().then(r=>(t&&(r=r.filter(s=>s[0]!=="_")),r))}$getContributedCommandHandlerDescriptions(){const t=Object.create(null);for(let[r,s]of this._commands){let{description:n}=s;n&&(t[r]=n)}return Promise.resolve(t)}};_=Ve([$e(0,v.IExtHostRpcService),$e(1,y.ILogService)],_),e.ExtHostCommands=_,e.IExtHostCommands=(0,l.createDecorator)("IExtHostCommands");class b{constructor(t,r,s){this._commands=t,this._lookupApiCommand=r,this._logService=s,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(t,r){if(!t)return;const s={$ident:void 0,id:t.command,title:t.title,tooltip:t.tooltip};if(!t.command)return s;const n=this._lookupApiCommand(t.command);if(n)s.id=n.internalId,s.arguments=n.args.map((a,d)=>a.convert(t.arguments&&t.arguments[d]));else if((0,D.isNonEmptyArray)(t.arguments)){const a=++this._cachIdPool;this._cache.set(a,t),r.add((0,m.toDisposable)(()=>{this._cache.delete(a),this._logService.trace("CommandsConverter#DISPOSE",a)})),s.$ident=a,s.id=this.delegatingCommandId,s.arguments=[a],this._logService.trace("CommandsConverter#CREATE",t.command,a)}return s}fromInternal(t){const r=T.ObjectIdentifier.of(t);return typeof r=="number"?this._cache.get(r):{command:t.id,title:t.title,arguments:t.arguments}}getActualCommand(...t){return this._cache.get(t[0])}_executeConvertedCommand(...t){const r=this.getActualCommand(...t);return this._logService.trace("CommandsConverter#EXECUTE",t[0],r?r.command:"MISSING"),r?this._commands.executeCommand(r.command,...r.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=b;class P{constructor(t,r,s,n){this.name=t,this.description=r,this.validate=s,this.convert=n}optional(){return new P(this.name,`(optional) ${this.description}`,t=>t==null||this.validate(t),t=>t===void 0?void 0:t===null?null:this.convert(t))}with(t,r){return new P(t??this.name,r??this.description,this.validate,this.convert)}}e.ApiCommandArgument=P,P.Uri=new P("uri","Uri of a text document",p=>u.URI.isUri(p),p=>p),P.Position=new P("position","A position in a text document",p=>R.Position.isPosition(p),k.Position.from),P.Range=new P("range","A range in a text document",p=>R.Range.isRange(p),k.Range.from),P.Selection=new P("selection","A selection in a text document",p=>R.Selection.isSelection(p),k.Selection.from),P.Number=new P("number","",p=>typeof p=="number",p=>p),P.String=new P("string","",p=>typeof p=="string",p=>p),P.CallHierarchyItem=new P("item","A call hierarchy item",p=>p instanceof R.CallHierarchyItem,k.CallHierarchyItem.from),P.TypeHierarchyItem=new P("item","A type hierarchy item",p=>p instanceof R.TypeHierarchyItem,k.TypeHierarchyItem.from);class c{constructor(t,r){this.description=t,this.convert=r}}e.ApiCommandResult=c,c.Void=new c("no result",p=>p);class h{constructor(t,r,s,n,a){this.id=t,this.internalId=r,this.description=s,this.args=n,this.result=a}}e.ApiCommand=h}),define(me[231],ge([0,1,17,7,81,44,20,111]),function(J,e,g,R,k,S,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const y=[new S.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",i(g.DocumentHighlight.to))),new S.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[S.ApiCommandArgument.Uri],new S.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(u,m)=>{if((0,T.isFalsyOrEmpty)(u))return;class l extends R.SymbolInformation{static to(_){const b=new l(_.name,g.SymbolKind.to(_.kind),_.containerName||"",new R.Location(m[0],g.Range.to(_.range)));return b.detail=_.detail,b.range=b.location.range,b.selectionRange=g.Range.to(_.selectionRange),b.children=_.children?_.children.map(l.to):[],b}}return u.map(l.to)})),new S.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[S.ApiCommandArgument.Uri,new S.ApiCommandArgument("options","Formatting options",u=>!0,u=>u)],new S.ApiCommandResult("A promise that resolves to an array of TextEdits.",i(g.TextEdit.to))),new S.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Range,new S.ApiCommandArgument("options","Formatting options",u=>!0,u=>u)],new S.ApiCommandResult("A promise that resolves to an array of TextEdits.",i(g.TextEdit.to))),new S.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position,new S.ApiCommandArgument("ch","Trigger character",u=>typeof u=="string",u=>u),new S.ApiCommandArgument("options","Formatting options",u=>!0,u=>u)],new S.ApiCommandResult("A promise that resolves to an array of TextEdits.",i(g.TextEdit.to))),new S.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",C)),new S.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",C)),new S.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",C)),new S.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",C)),new S.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to an array of Location-instances.",i(g.location.to))),new S.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to an array of Hover-instances.",i(g.Hover.to))),new S.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[S.ApiCommandArgument.Uri,new S.ApiCommandArgument("position","A position in a text document",u=>Array.isArray(u)&&u.every(m=>R.Position.isPosition(m)),u=>u.map(g.Position.from))],new S.ApiCommandResult("A promise that resolves to an array of ranges.",u=>u.map(m=>{let l;for(const v of m.reverse())l=new R.SelectionRange(g.Range.to(v),l);return l}))),new S.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[S.ApiCommandArgument.String.with("query","Search string")],new S.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",u=>{const m=[];if(Array.isArray(u))for(let l of u)m.push(...l[1].map(g.WorkspaceSymbol.to));return m})),new S.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A CallHierarchyItem or undefined",u=>u.map(g.CallHierarchyItem.to))),new S.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[S.ApiCommandArgument.CallHierarchyItem],new S.ApiCommandResult("A CallHierarchyItem or undefined",u=>u.map(g.CallHierarchyIncomingCall.to))),new S.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[S.ApiCommandArgument.CallHierarchyItem],new S.ApiCommandResult("A CallHierarchyItem or undefined",u=>u.map(g.CallHierarchyOutgoingCall.to))),new S.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position,S.ApiCommandArgument.String.with("newName","The new symbol name")],new S.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",u=>{if(!!u){if(u.rejectReason)throw new Error(u.rejectReason);return g.WorkspaceEdit.to(u)}})),new S.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new S.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",u=>u.map(g.DocumentLink.to))),new S.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[S.ApiCommandArgument.Uri],new S.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",u=>{if(!!u)return new R.SemanticTokensLegend(u.tokenTypes,u.tokenModifiers)})),new S.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[S.ApiCommandArgument.Uri],new S.ApiCommandResult("A promise that resolves to SemanticTokens.",u=>{if(!u)return;const m=(0,D.decodeSemanticTokensDto)(u);if(m.type==="full")return new R.SemanticTokens(m.data,void 0)})),new S.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[S.ApiCommandArgument.Uri],new S.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",u=>{if(!!u)return new R.SemanticTokensLegend(u.tokenTypes,u.tokenModifiers)})),new S.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Range],new S.ApiCommandResult("A promise that resolves to SemanticTokens.",u=>{if(!u)return;const m=(0,D.decodeSemanticTokensDto)(u);if(m.type==="full")return new R.SemanticTokens(m.data,void 0)})),new S.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position,S.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),S.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new S.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(u,m,l)=>{if(!u)return new R.CompletionList([]);const v=u.suggestions.map(_=>g.CompletionItem.to(_,l));return new R.CompletionList(v,u.incomplete)})),new S.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position,S.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new S.ApiCommandResult("A promise that resolves to SignatureHelp.",u=>{if(u)return g.SignatureHelp.to(u)})),new S.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new S.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(u,m,l)=>i(v=>new R.CodeLens(g.Range.to(v.range),v.command&&l.fromInternal(v.command)))(u))),new S.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[S.ApiCommandArgument.Uri,new S.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",u=>R.Range.isRange(u),u=>R.Selection.isSelection(u)?g.Selection.from(u):g.Range.from(u)),S.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),S.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new S.ApiCommandResult("A promise that resolves to an array of Command-instances.",(u,m,l)=>i(v=>{if(v._isSynthetic){if(!v.command)throw new Error("Synthetic code actions must have a command");return l.fromInternal(v.command)}else{const _=new R.CodeAction(v.title,v.kind?new R.CodeActionKind(v.kind):void 0);return v.edit&&(_.edit=g.WorkspaceEdit.to(v.edit)),v.command&&(_.command=l.fromInternal(v.command)),_.isPreferred=v.isPreferred,_}})(u))),new S.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[S.ApiCommandArgument.Uri],new S.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",u=>u?u.map(m=>new R.ColorInformation(g.Range.to(m.range),g.Color.to(m.color))):[])),new S.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new S.ApiCommandArgument("color","The color to show and insert",u=>u instanceof R.Color,g.Color.from),new S.ApiCommandArgument("context","Context object with uri and range",u=>!0,u=>({uri:u.uri,range:g.Range.from(u.range)}))],new S.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",u=>u?u.map(g.ColorPresentation.to):[])),new S.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Range],new S.ApiCommandResult("A promise that resolves to an array of Inlay objects",u=>u.map(g.InlayHint.to))),new S.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new S.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",i(u=>({viewType:u.viewType,displayName:u.displayName,options:{transientOutputs:u.options.transientOutputs,transientCellMetadata:u.options.transientCellMetadata,transientDocumentMetadata:u.options.transientDocumentMetadata},filenamePattern:u.filenamePattern.map(m=>g.NotebookExclusiveDocumentPattern.to(m))})))),new S.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Range],new S.ApiCommandResult("A promise that resolves to an array of InlineValue objects",u=>u.map(g.InlineValue.to))),new S.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[S.ApiCommandArgument.Uri,new S.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",u=>u===void 0||typeof u=="number"||typeof u=="object",u=>u&&(typeof u=="number"?[u,void 0]:[g.ViewColumn.from(u.viewColumn),g.TextEditorOpenOptions.from(u)])).optional(),S.ApiCommandArgument.String.with("label","").optional()],S.ApiCommandResult.Void),new S.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[S.ApiCommandArgument.Uri.with("resource","Resource to open"),S.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new S.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",u=>u===void 0||typeof u=="number"||typeof u=="object",u=>u&&(typeof u=="number"?[u,void 0]:[g.ViewColumn.from(u.viewColumn),g.TextEditorOpenOptions.from(u)])).optional()],S.ApiCommandResult.Void),new S.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[S.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),S.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),S.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new S.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",u=>u===void 0||typeof u=="object",u=>u&&[g.ViewColumn.from(u.viewColumn),g.TextEditorOpenOptions.from(u)]).optional()],S.ApiCommandResult.Void),new S.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A TypeHierarchyItem or undefined",u=>u.map(g.TypeHierarchyItem.to))),new S.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[S.ApiCommandArgument.TypeHierarchyItem],new S.ApiCommandResult("A TypeHierarchyItem or undefined",u=>u.map(g.TypeHierarchyItem.to))),new S.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[S.ApiCommandArgument.TypeHierarchyItem],new S.ApiCommandResult("A TypeHierarchyItem or undefined",u=>u.map(g.TypeHierarchyItem.to)))];class A{static register(m){y.forEach(m.registerApiCommand,m)}}e.ExtHostApiCommands=A;function i(u){return m=>{if(Array.isArray(m))return m.map(u)}}function C(u){if(!Array.isArray(u))return;const m=[];for(const l of u)k.isLocationLink(l)?m.push(g.DefinitionLink.to(l)):m.push(g.location.to(l));return m}}),define(me[232],ge([0,1,16,56,3,6,2,81,26,17,7,5]),function(J,e,g,R,k,S,T,D,y,A,i,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function u(m,l,v){const _=m.getProxy(C.MainContext.MainThreadComments);class b{constructor(){this._commentControllers=new Map,this._commentControllersByExtension=new Map,l.registerArgumentProcessor({processArgument:n=>{if(n&&n.$mid===6){const a=this._commentControllers.get(n.handle);return a||n}else if(n&&n.$mid===7){const a=this._commentControllers.get(n.commentControlHandle);if(!a)return n;const d=a.getCommentThread(n.commentThreadHandle);return d||n}else if(n&&n.$mid===8){const a=this._commentControllers.get(n.thread.commentControlHandle);if(!a)return n;const d=a.getCommentThread(n.thread.commentThreadHandle);return d?{thread:d,text:n.text}:n}else if(n&&n.$mid===9){const a=this._commentControllers.get(n.thread.commentControlHandle);if(!a)return n;const d=a.getCommentThread(n.thread.commentThreadHandle);if(!d)return n;let f=n.commentUniqueId,w=d.getCommentByUniqueId(f);return w||n}else if(n&&n.$mid===10){const a=this._commentControllers.get(n.thread.commentControlHandle);if(!a)return n;const d=a.getCommentThread(n.thread.commentThreadHandle);if(!d)return n;let f=n.text,w=n.commentUniqueId,E=d.getCommentByUniqueId(w);return E?(E.body=f,E):n}return n}})}createCommentController(n,a,d){const f=b.handlePool++,w=new c(n,f,a,d);this._commentControllers.set(w.handle,w);const E=this._commentControllersByExtension.get(y.ExtensionIdentifier.toKey(n.identifier))||[];return E.push(w),this._commentControllersByExtension.set(y.ExtensionIdentifier.toKey(n.identifier),E),w.value}$createCommentThreadTemplate(n,a,d){const f=this._commentControllers.get(n);!f||f.$createCommentThreadTemplate(a,d)}async $updateCommentThreadTemplate(n,a,d){const f=this._commentControllers.get(n);!f||f.$updateCommentThreadTemplate(a,d)}$deleteCommentThread(n,a){const d=this._commentControllers.get(n);d&&d.$deleteCommentThread(a)}$provideCommentingRanges(n,a,d){const f=this._commentControllers.get(n);if(!f||!f.commentingRangeProvider)return Promise.resolve(void 0);const w=v.getDocument(T.URI.revive(a));return(0,g.asPromise)(()=>f.commentingRangeProvider.provideCommentingRanges(w,d)).then(E=>E?E.map(o=>A.Range.from(o)):void 0)}$toggleReaction(n,a,d,f,w){const E=this._commentControllers.get(n);return!E||!E.reactionHandler?Promise.resolve(void 0):(0,g.asPromise)(()=>{const o=E.getCommentThread(a);if(o){const I=o.getCommentByUniqueId(f.uniqueIdInThread);if(E!==void 0&&I&&E.reactionHandler)return E.reactionHandler(I,t(w))}return Promise.resolve(void 0)})}dispose(){}}b.handlePool=0;class P{constructor(n,a,d,f,w,E,o){this._commentControllerHandle=a,this._id=d,this._uri=f,this._range=w,this._comments=E,this.handle=P._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new k.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new S.MutableDisposable,this._acceptInputDisposables.value=new S.DisposableStore,this._id===void 0&&(this._id=`${n}.${this.handle}`),_.$createCommentThread(a,this.handle,this._id,this._uri,A.Range.from(this._range),o),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=E,this._localDisposables.push({dispose:()=>{_.$deleteCommentThread(a,this.handle)}});const I=this;this.value={get uri(){return I.uri},get range(){return I.range},set range(L){I.range=L},get comments(){return I.comments},set comments(L){I.comments=L},get collapsibleState(){return I.collapsibleState},set collapsibleState(L){I.collapsibleState=L},get canReply(){return I.canReply},set canReply(L){I.canReply=L},get contextValue(){return I.contextValue},set contextValue(L){I.contextValue=L},get label(){return I.label},set label(L){I.label=L},dispose:()=>{I.dispose()}}}set threadId(n){this._id=n}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(n){n.isEqual(this._range)||(this._range=n,this.modifications.range=n,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(n){this._canReply!==n&&(this._canReply=n,this.modifications.canReply=n,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(n){this._label=n,this.modifications.label=n,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(n){this._contextValue=n,this.modifications.contextValue=n,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(n){this._comments=n,this.modifications.comments=n,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(n){this._collapseState=n,this.modifications.collapsibleState=n,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}eventuallyUpdateCommentThread(){if(this._isDiposed)return;this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new S.DisposableStore);const n=d=>Object.prototype.hasOwnProperty.call(this.modifications,d),a={};n("range")&&(a.range=A.Range.from(this._range)),n("label")&&(a.label=this.label),n("contextValue")&&(a.contextValue=this.contextValue),n("comments")&&(a.comments=this._comments.map(d=>h(this,d,this._commentsMap))),n("collapsibleState")&&(a.collapseState=r(this._collapseState)),n("canReply")&&(a.canReply=this.canReply),this.modifications={},_.$updateCommentThread(this._commentControllerHandle,this.handle,this._id,this._uri,a)}getCommentByUniqueId(n){for(let a of this._commentsMap){let d=a[0],f=a[1];if(n===f)return d}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(n=>n.dispose())}}P._handlePool=0,Ve([(0,R.debounce)(100)],P.prototype,"eventuallyUpdateCommentThread",null);class c{constructor(n,a,d,f){this._extension=n,this._handle=a,this._id=d,this._label=f,this._threads=new Map,_.$registerCommentController(this.handle,d,f);const w=this;this.value=Object.freeze({id:w.id,label:w.label,get options(){return w.options},set options(E){w.options=E},get commentingRangeProvider(){return w.commentingRangeProvider},set commentingRangeProvider(E){w.commentingRangeProvider=E},get reactionHandler(){return w.reactionHandler},set reactionHandler(E){w.reactionHandler=E},createCommentThread(E,o,I){return w.createCommentThread(E,o,I).value},dispose:()=>{w.dispose()}}),this._localDisposables=[],this._localDisposables.push({dispose:()=>{_.$unregisterCommentController(this.handle)}})}get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get reactionHandler(){return this._reactionHandler}set reactionHandler(n){this._reactionHandler=n,_.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!n})}get options(){return this._options}set options(n){this._options=n,_.$updateCommentControllerFeatures(this.handle,{options:this._options})}createCommentThread(n,a,d,f){if(typeof n=="string"){const w=new P(this.id,this.handle,n,a,d,f,this._extension.identifier);return this._threads.set(w.handle,w),w}else{const w=new P(this.id,this.handle,void 0,n,a,d,this._extension.identifier);return this._threads.set(w.handle,w),w}}$createCommentThreadTemplate(n,a){const d=new P(this.id,this.handle,void 0,T.URI.revive(n),A.Range.to(a),[],this._extension.identifier);return d.collapsibleState=D.CommentThreadCollapsibleState.Expanded,this._threads.set(d.handle,d),d}$updateCommentThreadTemplate(n,a){let d=this._threads.get(n);d&&(d.range=A.Range.to(a))}$deleteCommentThread(n){let a=this._threads.get(n);a&&a.dispose(),this._threads.delete(n)}getCommentThread(n){return this._threads.get(n)}dispose(){this._threads.forEach(n=>{n.dispose()}),this._localDisposables.forEach(n=>n.dispose())}}function h(s,n,a){let d=a.get(n);d||(d=++s.commentHandle,a.set(n,d));const f=n.author&&n.author.iconPath?n.author.iconPath.toString():void 0;return{mode:n.mode,contextValue:n.contextValue,uniqueIdInThread:d,body:A.MarkdownString.from(n.body),userName:n.author.name,userIconPath:f,label:n.label,commentReactions:n.reactions?n.reactions.map(w=>p(w)):void 0}}function p(s){return{label:s.label,iconPath:s.iconPath?A.pathOrURIToURI(s.iconPath):void 0,count:s.count,hasReacted:s.authorHasReacted}}function t(s){return{label:s.label||"",count:s.count||0,iconPath:s.iconPath?T.URI.revive(s.iconPath):"",authorHasReacted:s.hasReacted||!1}}function r(s){if(s!==void 0)switch(s){case i.CommentThreadCollapsibleState.Expanded:return D.CommentThreadCollapsibleState.Expanded;case i.CommentThreadCollapsibleState.Collapsed:return D.CommentThreadCollapsibleState.Collapsed}return D.CommentThreadCollapsibleState.Collapsed}return new b}e.createExtHostComments=u}),define(me[131],ge([0,1,2,5,7,4,13,12,20,8,9]),function(J,e,g,R,k,S,T,D,y,A,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let C=class wn{constructor(m,l){this._logService=l,this._provider=new Map,this._proxy=m.getProxy(R.MainContext.MainThreadDecorations)}registerFileDecorationProvider(m,l){const v=wn._handlePool++;this._provider.set(v,{provider:m,extensionId:l}),this._proxy.$registerDecorationProvider(v,l.value);const _=m.onDidChangeFileDecorations&&m.onDidChangeFileDecorations(b=>{if(!b){this._proxy.$onDidChange(v,null);return}let P=(0,y.asArray)(b);if(P.length<=wn._maxEventSize){this._proxy.$onDidChange(v,P);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",l.value,P.length);const c=P.map(t=>({uri:t,rank:(0,A.count)(t.path,"/")})),h=(0,y.groupBy)(c,(t,r)=>t.rank-r.rank||(0,A.compare)(t.uri.path,r.uri.path));let p=[];e:for(let t of h){let r;for(let s of t){let n=(0,i.dirname)(s.uri.path);if(r!==n&&(r=n,p.push(s.uri)>=wn._maxEventSize))break e}}this._proxy.$onDidChange(v,p)});return new k.Disposable(()=>{_?.dispose(),this._proxy.$unregisterDecorationProvider(v),this._provider.delete(v)})}async $provideDecorations(m,l,v){if(!this._provider.has(m))return Object.create(null);const _=Object.create(null),{provider:b,extensionId:P}=this._provider.get(m);return await Promise.all(l.map(async c=>{try{const{uri:h,id:p}=c,t=await Promise.resolve(b.provideFileDecoration(g.URI.revive(h),v));if(!t)return;try{k.FileDecoration.validate(t),_[p]=[t.propagate,t.tooltip,t.badge,t.color]}catch(r){this._logService.warn(`INVALID decoration from extension '${P.value}': ${r}`)}}catch(h){this._logService.error(h)}})),_}};C._handlePool=0,C._maxEventSize=250,C=Ve([$e(0,T.IExtHostRpcService),$e(1,D.ILogService)],C),e.ExtHostDecorations=C,e.IExtHostDecorations=(0,S.createDecorator)("IExtHostDecorations")}),define(me[233],ge([0,1,163,117,2,5,7,17,3,12,22]),function(J,e,g,R,k,S,T,D,y,A,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class C{constructor(l,v,_,b,P){this._name=l,this._owner=v,this._maxDiagnosticsPerFile=_,this._proxy=b,this._onDidChangeDiagnostics=P,this._isDisposed=!1,this._data=new i.ResourceMap}dispose(){this._isDisposed||(this._onDidChangeDiagnostics.fire([...this._data.keys()]),this._proxy&&this._proxy.$clear(this._owner),this._data=void 0,this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(l,v){if(!l){this.clear();return}this._checkDisposed();let _=[];if(k.URI.isUri(l)){if(!v){this.delete(l);return}this._data.set(l,v.slice()),_=[l]}else if(Array.isArray(l)){_=[];let P;l=[...l].sort(C._compareIndexedTuplesByUri);for(const c of l){const[h,p]=c;if((!P||h.toString()!==P.toString())&&(P&&this._data.get(P).length===0&&this._data.delete(P),P=h,_.push(h),this._data.set(h,[])),p){const t=this._data.get(h);t&&t.push(...p)}else{const t=this._data.get(h);t&&(t.length=0)}}}if(this._onDidChangeDiagnostics.fire(_),!this._proxy)return;const b=[];for(let P of _){let c=[];const h=this._data.get(P);if(h)if(h.length>this._maxDiagnosticsPerFile){c=[];const p=[T.DiagnosticSeverity.Error,T.DiagnosticSeverity.Warning,T.DiagnosticSeverity.Information,T.DiagnosticSeverity.Hint];e:for(let t=0;t<4;t++)for(let r of h)if(r.severity===p[t]&&c.push(D.Diagnostic.from(r))===this._maxDiagnosticsPerFile)break e;c.push({severity:R.MarkerSeverity.Info,message:(0,g.localize)(0,null,h.length-this._maxDiagnosticsPerFile),startLineNumber:c[c.length-1].startLineNumber,startColumn:c[c.length-1].startColumn,endLineNumber:c[c.length-1].endLineNumber,endColumn:c[c.length-1].endColumn})}else c=h.map(p=>D.Diagnostic.from(p));b.push([P,c])}this._proxy.$changeMany(this._owner,b)}delete(l){this._checkDisposed(),this._onDidChangeDiagnostics.fire([l]),this._data.delete(l),this._proxy&&this._proxy.$changeMany(this._owner,[[l,void 0]])}clear(){this._checkDisposed(),this._onDidChangeDiagnostics.fire([...this._data.keys()]),this._data.clear(),this._proxy&&this._proxy.$clear(this._owner)}forEach(l,v){this._checkDisposed();for(let _ of this._data.keys())l.apply(v,[_,this.get(_),this])}get(l){this._checkDisposed();const v=this._data.get(l);return Array.isArray(v)?Object.freeze(v.slice(0)):[]}has(l){return this._checkDisposed(),Array.isArray(this._data.get(l))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(l,v){return l[0].toString()<v[0].toString()?-1:l[0].toString()>v[0].toString()?1:0}}e.DiagnosticCollection=C;let u=class Qt{constructor(l,v){this._logService=v,this._collections=new Map,this._onDidChangeDiagnostics=new y.DebounceEmitter({merge:_=>_.flat(),delay:50}),this.onDidChangeDiagnostics=y.Event.map(this._onDidChangeDiagnostics.event,Qt._mapper),this._proxy=l.getProxy(S.MainContext.MainThreadDiagnostics)}static _mapper(l){const v=new i.ResourceMap;for(const _ of l)v.set(_,_);return{uris:Object.freeze(Array.from(v.values()))}}createDiagnosticCollection(l,v){const{_collections:_,_proxy:b,_onDidChangeDiagnostics:P,_logService:c}=this,h=new class{$changeMany(r,s){b.$changeMany(r,s),c.trace("[DiagnosticCollection] change many (extension, owner, uris)",l.value,r,s.length===0?"CLEARING":s)}$clear(r){b.$clear(r),c.trace("[DiagnosticCollection] remove all (extension, owner)",l.value,r)}dispose(){b.dispose()}};let p;if(!v)v="_generated_diagnostic_collection_name_#"+Qt._idPool++,p=v;else if(!_.has(v))p=v;else{this._logService.warn(`DiagnosticCollection with name '${v}' does already exist.`);do p=v+Qt._idPool++;while(_.has(p))}return new class extends C{constructor(){super(v,p,Qt._maxDiagnosticsPerFile,h,P);_.set(p,this)}dispose(){super.dispose(),_.delete(p)}}}getDiagnostics(l){if(l)return this._getDiagnostics(l);{const v=new Map,_=[];for(const b of this._collections.values())b.forEach((P,c)=>{let h=v.get(P.toString());typeof h=="undefined"&&(h=_.length,v.set(P.toString(),h),_.push([P,[]])),_[h][1]=_[h][1].concat(...c)});return _}}_getDiagnostics(l){let v=[];for(let _ of this._collections.values())_.has(l)&&(v=v.concat(_.get(l)));return v}$acceptMarkersChange(l){if(!this._mirrorCollection){const v="_generated_mirror",_=new C(v,v,Qt._maxDiagnosticsPerFile,void 0,this._onDidChangeDiagnostics);this._collections.set(v,_),this._mirrorCollection=_}for(const[v,_]of l)this._mirrorCollection.set(k.URI.revive(v),_.map(D.Diagnostic.to))}};u._idPool=0,u._maxDiagnosticsPerFile=1e3,u=Ve([$e(1,A.ILogService)],u),e.ExtHostDiagnostics=u}),define(me[234],ge([0,1,2,5]),function(J,e,g,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class k{constructor(T){this._proxy=T.getProxy(R.MainContext.MainThreadDialogs)}showOpenDialog(T){return this._proxy.$showOpenDialog(T).then(D=>D?D.map(y=>g.URI.revive(y)):void 0)}showSaveDialog(T){return this._proxy.$showSaveDialog(T).then(D=>D?g.URI.revive(D):void 0)}}e.ExtHostDialogs=k}),define(me[235],ge([0,1,15,2,7,5,10,21,8]),function(J,e,g,R,k,S,T,D,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class A{constructor(C,u,m){this._documentsAndEditors=u,this._logService=m,this._documentContentProviders=new Map,this._proxy=C.getProxy(S.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(C,u){if(Object.keys(T.Schemas).indexOf(C)>=0)throw new Error(`scheme '${C}' already registered`);const m=A._handlePool++;this._documentContentProviders.set(m,u),this._proxy.$registerTextContentProvider(m,C);let l;return typeof u.onDidChange=="function"&&(l=u.onDidChange(v=>{if(v.scheme!==C){this._logService.warn(`Provider for scheme '${C}' is firing event for schema '${v.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(v)&&this.$provideTextDocumentContent(m,v).then(_=>{if(!_&&typeof _!="string")return;const b=this._documentsAndEditors.getDocument(v);if(!b)return;const P=(0,y.splitLines)(_);if(!b.equalLines(P))return this._proxy.$onVirtualDocumentChange(v,_)},g.onUnexpectedError)})),new k.Disposable(()=>{this._documentContentProviders.delete(m)&&this._proxy.$unregisterTextContentProvider(m),l&&(l.dispose(),l=void 0)})}$provideTextDocumentContent(C,u){const m=this._documentContentProviders.get(C);return m?Promise.resolve(m.provideTextDocumentContent(R.URI.revive(u),D.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${u.scheme}`))}}e.ExtHostDocumentContentProvider=A,A._handlePool=0}),define(me[236],ge([0,1,3,6,2,5,123,17,14,25,7]),function(J,e,g,R,k,S,T,D,y,A,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class C{constructor(m,l){this._onDidAddDocument=new g.Emitter,this._onDidRemoveDocument=new g.Emitter,this._onDidChangeDocument=new g.Emitter,this._onDidSaveDocument=new g.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new R.DisposableStore,this._documentLoader=new Map,this._proxy=m.getProxy(S.MainContext.MainThreadDocuments),this._documentsAndEditors=l,this._documentsAndEditors.onDidRemoveDocuments(v=>{for(const _ of v)this._onDidRemoveDocument.fire(_.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(v=>{for(const _ of v)this._onDidAddDocument.fire(_.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(m){if(!m)return;const l=this._documentsAndEditors.getDocument(m);if(l)return l}getDocument(m){const l=this.getDocumentData(m);if(!l?.document)throw new Error(`Unable to retrieve document from URI '${m}'`);return l.document}ensureDocumentData(m){const l=this._documentsAndEditors.getDocument(m);if(l)return Promise.resolve(l);let v=this._documentLoader.get(m.toString());return v||(v=this._proxy.$tryOpenDocument(m).then(_=>{this._documentLoader.delete(m.toString());const b=k.URI.revive(_);return(0,y.assertIsDefined)(this._documentsAndEditors.getDocument(b))},_=>(this._documentLoader.delete(m.toString()),Promise.reject(_))),this._documentLoader.set(m.toString(),v)),v}createDocumentData(m){return this._proxy.$tryCreateDocument(m).then(l=>k.URI.revive(l))}$acceptModelModeChanged(m,l){const v=k.URI.revive(m),_=this._documentsAndEditors.getDocument(v);if(!_)throw new Error("unknown document");this._onDidRemoveDocument.fire(_.document),_._acceptLanguageId(l),this._onDidAddDocument.fire(_.document)}$acceptModelSaved(m){const l=k.URI.revive(m),v=this._documentsAndEditors.getDocument(l);if(!v)throw new Error("unknown document");this.$acceptDirtyStateChanged(m,!1),this._onDidSaveDocument.fire(v.document)}$acceptDirtyStateChanged(m,l){const v=k.URI.revive(m),_=this._documentsAndEditors.getDocument(v);if(!_)throw new Error("unknown document");_._acceptIsDirty(l),this._onDidChangeDocument.fire({document:_.document,contentChanges:[],reason:void 0})}$acceptModelChanged(m,l,v){const _=k.URI.revive(m),b=this._documentsAndEditors.getDocument(_);if(!b)throw new Error("unknown document");b._acceptIsDirty(v),b.onEvents(l);let P;l.isUndoing?P=i.TextDocumentChangeReason.Undo:l.isRedoing&&(P=i.TextDocumentChangeReason.Redo),this._onDidChangeDocument.fire((0,A.deepFreeze)({document:b.document,contentChanges:l.changes.map(c=>({range:D.Range.to(c.range),rangeOffset:c.rangeOffset,rangeLength:c.rangeLength,text:c.text})),reason:P}))}setWordDefinitionFor(m,l){(0,T.setWordDefinitionFor)(m,l)}}e.ExtHostDocuments=C}),define(me[45],ge([0,1,54,3,6,2,4,5,123,13,129,17,12,22,10,74,139]),function(J,e,g,R,k,S,T,D,y,A,i,C,u,m,l,v,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class b{constructor(h){this.value=h,this._count=0}ref(){this._count++}unref(){return--this._count==0}}let P=class{constructor(h,p){this._extHostRpc=h,this._logService=p,this._activeEditorId=null,this._editors=new Map,this._documents=new m.ResourceMap,this._onDidAddDocuments=new R.Emitter,this._onDidRemoveDocuments=new R.Emitter,this._onDidChangeVisibleTextEditors=new R.Emitter,this._onDidChangeActiveTextEditor=new R.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(h){this.acceptDocumentsAndEditorsDelta(h)}acceptDocumentsAndEditorsDelta(h){const p=[],t=[],r=[];if(h.removedDocuments)for(const s of h.removedDocuments){const n=S.URI.revive(s),a=this._documents.get(n);a?.unref()&&(this._documents.delete(n),p.push(a.value))}if(h.addedDocuments)for(const s of h.addedDocuments){const n=S.URI.revive(s.uri);let a=this._documents.get(n);if(a&&n.scheme!==l.Schemas.vscodeNotebookCell&&n.scheme!==l.Schemas.vscodeInteractiveInput)throw new Error(`document '${n} already exists!'`);a||(a=new b(new y.ExtHostDocumentData(this._extHostRpc.getProxy(D.MainContext.MainThreadDocuments),n,s.lines,s.EOL,s.versionId,s.modeId,s.isDirty,s.notebook)),this._documents.set(n,a),t.push(a.value)),a.ref()}if(h.removedEditors)for(const s of h.removedEditors){const n=this._editors.get(s);this._editors.delete(s),n&&r.push(n)}if(h.addedEditors)for(const s of h.addedEditors){const n=S.URI.revive(s.documentUri);g.ok(this._documents.has(n),`document '${n}' does not exist`),g.ok(!this._editors.has(s.id),`editor '${s.id}' already exists!`);const a=this._documents.get(n).value,d=new i.ExtHostTextEditor(s.id,this._extHostRpc.getProxy(D.MainContext.MainThreadTextEditors),this._logService,new _.Lazy(()=>a.document),s.selections.map(C.Selection.to),s.options,s.visibleRanges.map(f=>C.Range.to(f)),typeof s.editorPosition=="number"?C.ViewColumn.to(s.editorPosition):void 0);this._editors.set(s.id,d)}h.newActiveEditor!==void 0&&(g.ok(h.newActiveEditor===null||this._editors.has(h.newActiveEditor),`active editor '${h.newActiveEditor}' does not exist`),this._activeEditorId=h.newActiveEditor),(0,k.dispose)(p),(0,k.dispose)(r),h.removedDocuments&&this._onDidRemoveDocuments.fire(p),h.addedDocuments&&this._onDidAddDocuments.fire(t),(h.removedEditors||h.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(s=>s.value)),h.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(h){return this._documents.get(h)?.value}allDocuments(){return v.Iterable.map(this._documents.values(),h=>h.value)}getEditor(h){return this._editors.get(h)}activeEditor(h){if(!this._activeEditorId)return;const p=this._editors.get(this._activeEditorId);return h?p:p?.value}allEditors(){return[...this._editors.values()]}};P=Ve([$e(0,A.IExtHostRpcService),$e(1,u.ILogService)],P),e.ExtHostDocumentsAndEditors=P,e.IExtHostDocumentsAndEditors=(0,T.createDecorator)("IExtHostDocumentsAndEditors")}),define(me[237],ge([0,1,2,5,6,7,17,147,8,24]),function(J,e,g,R,k,S,T,D,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class i{constructor(){this._schemes=[]}add(m){this._stateMachine=void 0,this._schemes.push(m)}delete(m){const l=this._schemes.indexOf(m);l>=0&&(this._schemes.splice(l,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const m=this._schemes.sort(),l=[];let v,_,b=14,P=14;for(const c of m){let h=v?(0,y.commonPrefixLength)(v,c):0;for(h===0?_=1:_=P;h<c.length;h++)h+1===c.length?(b=P,P=9):P+=1,l.push([_,c.toUpperCase().charCodeAt(h),P]),l.push([_,c.toLowerCase().charCodeAt(h),P]),_=P;v=c,P=b}l.push([9,58,10]),l.push([10,47,12]),this._stateMachine=new D.StateMachine(l)}}provideDocumentLinks(m){this._initStateMachine();const l=[],v=D.LinkComputer.computeLinks({getLineContent(_){return m.lineAt(_-1).text},getLineCount(){return m.lineCount}},this._stateMachine);for(const _ of v){const b=T.DocumentLink.to(_);b.target&&l.push(b)}return l}}class C{constructor(m,l){this._extHostLanguageFeatures=l,this._linkProvider=new i,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._enableProposedApi=new Map,this._handlePool=0,this._proxy=m.getProxy(R.MainContext.MainThreadFileSystem)}dispose(){this._linkProviderRegistration?.dispose()}_registerLinkProviderIfNotYetRegistered(){this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(void 0,"*",this._linkProvider))}registerFileSystemProvider(m,l,v,_={},b){if(this._registeredSchemes.has(l))throw new Error(`a provider for the scheme '${l}' is already registered`);this._registerLinkProviderIfNotYetRegistered();const P=this._handlePool++;this._linkProvider.add(l),this._registeredSchemes.add(l),this._fsProvider.set(P,v),this._enableProposedApi.set(P,b??!1);let c=2;_.isCaseSensitive&&(c+=1024),_.isReadonly&&(c+=2048),typeof v.copy=="function"&&(c+=8),typeof v.open=="function"&&typeof v.close=="function"&&typeof v.read=="function"&&typeof v.write=="function"&&(c+=4),this._proxy.$registerFileSystemProvider(P,l,c).catch(p=>{console.error(`FAILED to register filesystem provider of ${m.value}-extension for the scheme ${l}`),console.error(p)});const h=v.onDidChangeFile(p=>{const t=[];for(const r of p){let{uri:s,type:n}=r;if(s.scheme!==l)continue;let a;switch(n){case S.FileChangeType.Changed:a=0;break;case S.FileChangeType.Created:a=1;break;case S.FileChangeType.Deleted:a=2;break;default:throw new Error("Unknown FileChangeType")}t.push({resource:s,type:a})}this._proxy.$onFileSystemChange(P,t)});return(0,k.toDisposable)(()=>{h.dispose(),this._linkProvider.delete(l),this._registeredSchemes.delete(l),this._fsProvider.delete(P),this._enableProposedApi.delete(P),this._proxy.$unregisterProvider(P)})}static _asIStat(m,l){const{type:v,ctime:_,mtime:b,size:P,permissions:c}=m;return l?{type:v,ctime:_,mtime:b,size:P,permissions:c}:{type:v,ctime:_,mtime:b,size:P}}$stat(m,l){return Promise.resolve(this._getFsProvider(m).stat(g.URI.revive(l))).then(v=>C._asIStat(v,this._enableProposedApi.get(m)??!1))}$readdir(m,l){return Promise.resolve(this._getFsProvider(m).readDirectory(g.URI.revive(l)))}$readFile(m,l){return Promise.resolve(this._getFsProvider(m).readFile(g.URI.revive(l))).then(v=>A.VSBuffer.wrap(v))}$writeFile(m,l,v,_){return Promise.resolve(this._getFsProvider(m).writeFile(g.URI.revive(l),v.buffer,_))}$delete(m,l,v){return Promise.resolve(this._getFsProvider(m).delete(g.URI.revive(l),v))}$rename(m,l,v,_){return Promise.resolve(this._getFsProvider(m).rename(g.URI.revive(l),g.URI.revive(v),_))}$copy(m,l,v,_){const b=this._getFsProvider(m);if(!b.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(b.copy(g.URI.revive(l),g.URI.revive(v),_))}$mkdir(m,l){return Promise.resolve(this._getFsProvider(m).createDirectory(g.URI.revive(l)))}$watch(m,l,v,_){const b=this._getFsProvider(m).watch(g.URI.revive(v),_);this._watches.set(l,b)}$unwatch(m,l){const v=this._watches.get(l);v&&(v.dispose(),this._watches.delete(l))}$open(m,l,v){const _=this._getFsProvider(m);if(!_.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(_.open(g.URI.revive(l),v))}$close(m,l){const v=this._getFsProvider(m);if(!v.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(v.close(l))}$read(m,l,v,_){const b=this._getFsProvider(m);if(!b.read)throw new Error('FileSystemProvider does not implement "read"');const P=A.VSBuffer.alloc(_);return Promise.resolve(b.read(l,v,P.buffer,0,_)).then(c=>P.slice(0,c))}$write(m,l,v,_){const b=this._getFsProvider(m);if(!b.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(b.write(l,v,_.buffer,0,_.byteLength))}_getFsProvider(m){const l=this._fsProvider.get(m);if(!l){const v=new Error;throw v.name="ENOPRO",v.message="no provider",v}return l}}e.ExtHostFileSystem=C}),define(me[92],ge([0,1,5,42,7,24,4,13,62]),function(J,e,g,R,k,S,T,D,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let A=class Ut{constructor(C,u){const m=C.getProxy(g.MainContext.MainThreadFileSystem);this.value=Object.freeze({stat(l){return m.$stat(l).catch(Ut._handleError)},readDirectory(l){return m.$readdir(l).catch(Ut._handleError)},createDirectory(l){return m.$mkdir(l).catch(Ut._handleError)},async readFile(l){return m.$readFile(l).then(v=>v.buffer).catch(Ut._handleError)},writeFile(l,v){return m.$writeFile(l,S.VSBuffer.wrap(v)).catch(Ut._handleError)},delete(l,v){return m.$delete(l,{recursive:!1,useTrash:!1,...v}).catch(Ut._handleError)},rename(l,v,_){return m.$rename(l,v,{overwrite:!1,..._}).catch(Ut._handleError)},copy(l,v,_){return m.$copy(l,v,{overwrite:!1,..._}).catch(Ut._handleError)},isWritableFileSystem(l){const v=u.getCapabilities(l);if(typeof v=="number")return!(v&2048)}})}static _handleError(C){if(!(C instanceof Error))throw new k.FileSystemError(String(C));if(C.name==="ENOPRO")throw k.FileSystemError.Unavailable(C.message);switch(C.name){case R.FileSystemProviderErrorCode.FileExists:throw k.FileSystemError.FileExists(C.message);case R.FileSystemProviderErrorCode.FileNotFound:throw k.FileSystemError.FileNotFound(C.message);case R.FileSystemProviderErrorCode.FileNotADirectory:throw k.FileSystemError.FileNotADirectory(C.message);case R.FileSystemProviderErrorCode.FileIsADirectory:throw k.FileSystemError.FileIsADirectory(C.message);case R.FileSystemProviderErrorCode.NoPermissions:throw k.FileSystemError.NoPermissions(C.message);case R.FileSystemProviderErrorCode.Unavailable:throw k.FileSystemError.Unavailable(C.message);default:throw new k.FileSystemError(C.message,C.name)}}};A=Ve([$e(0,D.IExtHostRpcService),$e(1,y.IExtHostFileSystemInfo)],A),e.ExtHostConsumerFileSystem=A,e.IExtHostConsumerFileSystem=(0,T.createDecorator)("IExtHostConsumerFileSystem")}),define(me[238],ge([0,1,2,44]),function(J,e,g,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class k{constructor(T,D,y,A){this._extHostNotebooks=D,this._textDocumentsAndEditors=y,this._commands=A;const i=new R.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new R.ApiCommandArgument("showOptions","Show Options",C=>!0,C=>C),new R.ApiCommandArgument("resource","Interactive resource Uri",C=>!0,C=>C),new R.ApiCommandArgument("controllerId","Notebook controller Id",C=>!0,C=>C),new R.ApiCommandArgument("title","Interactive editor title",C=>!0,C=>C)],new R.ApiCommandResult("Notebook and input URI",C=>{if(C.notebookEditorId!==void 0){const u=this._extHostNotebooks.getEditorById(C.notebookEditorId);return{notebookUri:g.URI.revive(C.notebookUri),inputUri:g.URI.revive(C.inputUri),notebookEditor:u.apiEditor}}return{notebookUri:g.URI.revive(C.notebookUri),inputUri:g.URI.revive(C.inputUri)}}));this._commands.registerApiCommand(i)}$willAddInteractiveDocument(T,D,y,A){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:D,lines:[""],modeId:y,uri:T,isDirty:!1,versionId:1,notebook:this._extHostNotebooks.getNotebookDocument(g.URI.revive(A))?.apiNotebook}]})}$willRemoveInteractiveDocument(T,D){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({removedDocuments:[T]})}}e.ExtHostInteractive=k}),define(me[239],ge([0,1,6,5]),function(J,e,g,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class k{constructor(T){this._handlePool=0,this._proxy=T.getProxy(R.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(T){const D=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(D,T),(0,g.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(D)})}}e.ExtHostLabelService=k}),define(me[240],ge([0,1,2,25,17,7,5,8,41,20,14,144,6,111,73,86,46,15,3]),function(J,e,g,R,k,S,T,D,y,A,i,C,u,m,l,v,_,b,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=e.InlineCompletionController=e.DocumentRangeSemanticTokensAdapter=e.DocumentSemanticTokensAdapter=void 0;class c{constructor(W,Z){this._documents=W,this._provider=Z}async provideDocumentSymbols(W,Z){const ne=this._documents.getDocument(W),le=await this._provider.provideDocumentSymbols(ne,Z);if(!(0,A.isFalsyOrEmpty)(le))return le[0]instanceof S.DocumentSymbol?le.map(k.DocumentSymbol.from):c._asDocumentSymbolTree(le)}static _asDocumentSymbolTree(W){W=W.slice(0).sort((le,Y)=>{let ae=le.location.range.start.compareTo(Y.location.range.start);return ae===0&&(ae=Y.location.range.end.compareTo(le.location.range.end)),ae});const Z=[],ne=[];for(const le of W){const Y={name:le.name||"!!MISSING: name!!",kind:k.SymbolKind.from(le.kind),tags:le.tags?.map(k.SymbolTag.from)||[],detail:"",containerName:le.containerName,range:k.Range.from(le.location.range),selectionRange:k.Range.from(le.location.range),children:[]};for(;;){if(ne.length===0){ne.push(Y),Z.push(Y);break}const ae=ne[ne.length-1];if(y.Range.containsRange(ae.range,Y.range)&&!y.Range.equalsRange(ae.range,Y.range)){ae.children&&ae.children.push(Y),ne.push(Y);break}ne.pop()}}return Z}}class h{constructor(W,Z,ne){this._documents=W,this._commands=Z,this._provider=ne,this._cache=new v.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(W,Z){const ne=this._documents.getDocument(W),le=await this._provider.provideCodeLenses(ne,Z);if(!le||Z.isCancellationRequested)return;const Y=this._cache.add(le),ae=new u.DisposableStore;this._disposables.set(Y,ae);const ve={cacheId:Y,lenses:[]};for(let Me=0;Me<le.length;Me++)ve.lenses.push({cacheId:[Y,Me],range:k.Range.from(le[Me].range),command:this._commands.toInternal(le[Me].command,ae)});return ve}async resolveCodeLens(W,Z){const ne=W.cacheId&&this._cache.get(...W.cacheId);if(!ne)return;let le;if(typeof this._provider.resolveCodeLens!="function"||ne.isResolved?le=ne:le=await this._provider.resolveCodeLens(ne,Z),le||(le=ne),Z.isCancellationRequested)return;const Y=W.cacheId&&this._disposables.get(W.cacheId[0]);if(!!Y)return W.command=this._commands.toInternal(le.command??h._badCmd,Y),W}releaseCodeLenses(W){this._disposables.get(W)?.dispose(),this._disposables.delete(W),this._cache.delete(W)}}h._badCmd={command:"missing",title:"!!MISSING: command!!"};function p(je){return Array.isArray(je)?je.map(k.DefinitionLink.from):je?[k.DefinitionLink.from(je)]:[]}class t{constructor(W,Z){this._documents=W,this._provider=Z}async provideDefinition(W,Z,ne){const le=this._documents.getDocument(W),Y=k.Position.to(Z),ae=await this._provider.provideDefinition(le,Y,ne);return p(ae)}}class r{constructor(W,Z){this._documents=W,this._provider=Z}async provideDeclaration(W,Z,ne){const le=this._documents.getDocument(W),Y=k.Position.to(Z),ae=await this._provider.provideDeclaration(le,Y,ne);return p(ae)}}class s{constructor(W,Z){this._documents=W,this._provider=Z}async provideImplementation(W,Z,ne){const le=this._documents.getDocument(W),Y=k.Position.to(Z),ae=await this._provider.provideImplementation(le,Y,ne);return p(ae)}}class n{constructor(W,Z){this._documents=W,this._provider=Z}async provideTypeDefinition(W,Z,ne){const le=this._documents.getDocument(W),Y=k.Position.to(Z),ae=await this._provider.provideTypeDefinition(le,Y,ne);return p(ae)}}class a{constructor(W,Z){this._documents=W,this._provider=Z}async provideHover(W,Z,ne){const le=this._documents.getDocument(W),Y=k.Position.to(Z),ae=await this._provider.provideHover(le,Y,ne);if(!(!ae||(0,A.isFalsyOrEmpty)(ae.contents)))return ae.range||(ae.range=le.getWordRangeAtPosition(Y)),ae.range||(ae.range=new S.Range(Y,Y)),k.Hover.from(ae)}}class d{constructor(W,Z){this._documents=W,this._provider=Z}async provideEvaluatableExpression(W,Z,ne){const le=this._documents.getDocument(W),Y=k.Position.to(Z),ae=await this._provider.provideEvaluatableExpression(le,Y,ne);if(ae)return k.EvaluatableExpression.from(ae)}}class f{constructor(W,Z){this._documents=W,this._provider=Z}async provideInlineValues(W,Z,ne,le){const Y=this._documents.getDocument(W),ae=await this._provider.provideInlineValues(Y,k.Range.to(Z),k.InlineValueContext.to(ne),le);if(Array.isArray(ae))return ae.map(ve=>k.InlineValue.from(ve))}}class w{constructor(W,Z){this._documents=W,this._provider=Z}async provideDocumentHighlights(W,Z,ne){const le=this._documents.getDocument(W),Y=k.Position.to(Z),ae=await this._provider.provideDocumentHighlights(le,Y,ne);if(Array.isArray(ae))return ae.map(k.DocumentHighlight.from)}}class E{constructor(W,Z){this._documents=W,this._provider=Z}async provideLinkedEditingRanges(W,Z,ne){const le=this._documents.getDocument(W),Y=k.Position.to(Z),ae=await this._provider.provideLinkedEditingRanges(le,Y,ne);if(ae&&Array.isArray(ae.ranges))return{ranges:(0,A.coalesce)(ae.ranges.map(k.Range.from)),wordPattern:ae.wordPattern}}}class o{constructor(W,Z){this._documents=W,this._provider=Z}async provideReferences(W,Z,ne,le){const Y=this._documents.getDocument(W),ae=k.Position.to(Z),ve=await this._provider.provideReferences(Y,ae,ne,le);if(Array.isArray(ve))return ve.map(k.location.from)}}class I{constructor(W,Z,ne,le,Y,ae,ve){this._documents=W,this._commands=Z,this._diagnostics=ne,this._provider=le,this._logService=Y,this._extension=ae,this._apiDeprecation=ve,this._cache=new v.Cache("CodeAction"),this._disposables=new Map}async provideCodeActions(W,Z,ne,le){const Y=this._documents.getDocument(W),ae=C.Selection.isISelection(Z)?k.Selection.to(Z):k.Range.to(Z),ve=[];for(const se of this._diagnostics.getDiagnostics(W))if(ae.intersection(se.range)&&ve.push(se)>I._maxCodeActionsPerFile)break;const Me={diagnostics:ve,only:ne.only?new S.CodeActionKind(ne.only):void 0,triggerKind:k.CodeActionTriggerKind.to(ne.trigger)},ze=await this._provider.provideCodeActions(Y,ae,Me,le);if(!(0,A.isNonEmptyArray)(ze)||le.isCancellationRequested)return;const Ee=this._cache.add(ze),Ye=new u.DisposableStore;this._disposables.set(Ee,Ye);const X=[];for(let se=0;se<ze.length;se++){const fe=ze[se];!fe||(I._isCommand(fe)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),X.push({_isSynthetic:!0,title:fe.title,command:this._commands.toInternal(fe,Ye)})):(Me.only&&(fe.kind?Me.only.contains(fe.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Me.only.value} 'requested but returned code action is of kind '${fe.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Me.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),X.push({cacheId:[Ee,se],title:fe.title,command:fe.command&&this._commands.toInternal(fe.command,Ye),diagnostics:fe.diagnostics&&fe.diagnostics.map(k.Diagnostic.from),edit:fe.edit&&k.WorkspaceEdit.from(fe.edit),kind:fe.kind&&fe.kind.value,isPreferred:fe.isPreferred,disabled:fe.disabled?.reason})))}return{cacheId:Ee,actions:X}}async resolveCodeAction(W,Z){const[ne,le]=W,Y=this._cache.get(ne,le);if(!Y||I._isCommand(Y)||!this._provider.resolveCodeAction)return;const ae=await this._provider.resolveCodeAction(Y,Z)??Y;return ae?.edit?k.WorkspaceEdit.from(ae.edit):void 0}releaseCodeActions(W){this._disposables.get(W)?.dispose(),this._disposables.delete(W),this._cache.delete(W)}static _isCommand(W){return typeof W.command=="string"&&typeof W.title=="string"}}I._maxCodeActionsPerFile=1e3;class L{constructor(W,Z){this._documents=W,this._provider=Z}async provideDocumentFormattingEdits(W,Z,ne){const le=this._documents.getDocument(W),Y=await this._provider.provideDocumentFormattingEdits(le,Z,ne);if(Array.isArray(Y))return Y.map(k.TextEdit.from)}}class U{constructor(W,Z){this._documents=W,this._provider=Z}async provideDocumentRangeFormattingEdits(W,Z,ne,le){const Y=this._documents.getDocument(W),ae=k.Range.to(Z),ve=await this._provider.provideDocumentRangeFormattingEdits(Y,ae,ne,le);if(Array.isArray(ve))return ve.map(k.TextEdit.from)}}class V{constructor(W,Z){this._documents=W,this._provider=Z,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(W,Z,ne,le,Y){const ae=this._documents.getDocument(W),ve=k.Position.to(Z),Me=await this._provider.provideOnTypeFormattingEdits(ae,ve,ne,le,Y);if(Array.isArray(Me))return Me.map(k.TextEdit.from)}}class ee{constructor(W,Z){this._provider=W,this._logService=Z,this._symbolCache=new Map,this._resultCache=new Map}async provideWorkspaceSymbols(W,Z){const ne=T.IdObject.mixin({symbols:[]}),le=await this._provider.provideWorkspaceSymbols(W,Z);if((0,A.isNonEmptyArray)(le))for(const Y of le){if(!Y)continue;if(!Y.name){this._logService.warn("INVALID SymbolInformation, lacks name",Y);continue}const ae=T.IdObject.mixin(k.WorkspaceSymbol.from(Y));this._symbolCache.set(ae._id,Y),ne.symbols.push(ae)}return ne.symbols.length>0&&this._resultCache.set(ne._id,[ne.symbols[0]._id,ne.symbols[ne.symbols.length-1]._id]),ne}async resolveWorkspaceSymbol(W,Z){if(typeof this._provider.resolveWorkspaceSymbol!="function")return W;const ne=this._symbolCache.get(W._id);if(ne){const le=await this._provider.resolveWorkspaceSymbol(ne,Z);return le&&(0,R.mixin)(W,k.WorkspaceSymbol.from(le),!0)}}releaseWorkspaceSymbols(W){const Z=this._resultCache.get(W);if(Z){for(let[ne,le]=Z;ne<=le;ne++)this._symbolCache.delete(ne);this._resultCache.delete(W)}}}class K{constructor(W,Z,ne){this._documents=W,this._provider=Z,this._logService=ne}static supportsResolving(W){return typeof W.prepareRename=="function"}async provideRenameEdits(W,Z,ne,le){const Y=this._documents.getDocument(W),ae=k.Position.to(Z);try{const ve=await this._provider.provideRenameEdits(Y,ae,ne,le);return ve?k.WorkspaceEdit.from(ve):void 0}catch(ve){const Me=K._asMessage(ve);return Me?{rejectReason:Me,edits:void 0}:Promise.reject(ve)}}async resolveRenameLocation(W,Z,ne){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const le=this._documents.getDocument(W),Y=k.Position.to(Z);try{const ae=await this._provider.prepareRename(le,Y,ne);let ve,Me;if(S.Range.isRange(ae)?(ve=ae,Me=le.getText(ae)):(0,i.isObject)(ae)&&(ve=ae.range,Me=ae.placeholder),!ve||!Me)return;if(ve.start.line>Y.line||ve.end.line<Y.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:k.Range.from(ve),text:Me}}catch(ae){const ve=K._asMessage(ae);return ve?{rejectReason:ve,range:void 0,text:void 0}:Promise.reject(ae)}}static _asMessage(W){return typeof W=="string"?W:W instanceof Error&&typeof W.message=="string"?W.message:void 0}}class N{constructor(W,Z){this.resultId=W,this.tokens=Z}}class x{constructor(W,Z){this._documents=W,this._provider=Z,this._nextResultId=1,this._previousResults=new Map}async provideDocumentSemanticTokens(W,Z,ne){const le=this._documents.getDocument(W),Y=Z!==0?this._previousResults.get(Z):null;let ae=typeof Y?.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?await this._provider.provideDocumentSemanticTokensEdits(le,Y.resultId,ne):await this._provider.provideDocumentSemanticTokens(le,ne);return Y&&this._previousResults.delete(Z),ae?(ae=x._fixProvidedSemanticTokens(ae),this._send(x._convertToEdits(Y,ae),ae)):null}async releaseDocumentSemanticColoring(W){this._previousResults.delete(W)}static _fixProvidedSemanticTokens(W){return x._isSemanticTokens(W)?x._isCorrectSemanticTokens(W)?W:new S.SemanticTokens(new Uint32Array(W.data),W.resultId):x._isSemanticTokensEdits(W)?x._isCorrectSemanticTokensEdits(W)?W:new S.SemanticTokensEdits(W.edits.map(Z=>new S.SemanticTokensEdit(Z.start,Z.deleteCount,Z.data?new Uint32Array(Z.data):Z.data)),W.resultId):W}static _isSemanticTokens(W){return W&&!!W.data}static _isCorrectSemanticTokens(W){return W.data instanceof Uint32Array}static _isSemanticTokensEdits(W){return W&&Array.isArray(W.edits)}static _isCorrectSemanticTokensEdits(W){for(const Z of W.edits)if(!(Z.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(W,Z){if(!x._isSemanticTokens(Z)||!W||!W.tokens)return Z;const ne=W.tokens,le=ne.length,Y=Z.data,ae=Y.length;let ve=0;const Me=Math.min(le,ae);for(;ve<Me&&ne[ve]===Y[ve];)ve++;if(ve===le&&ve===ae)return new S.SemanticTokensEdits([],Z.resultId);let ze=0;const Ee=Me-ve;for(;ze<Ee&&ne[le-ze-1]===Y[ae-ze-1];)ze++;return new S.SemanticTokensEdits([{start:ve,deleteCount:le-ve-ze,data:Y.subarray(ve,ae-ze)}],Z.resultId)}_send(W,Z){if(x._isSemanticTokens(W)){const ne=this._nextResultId++;return this._previousResults.set(ne,new N(W.resultId,W.data)),(0,m.encodeSemanticTokensDto)({id:ne,type:"full",data:W.data})}if(x._isSemanticTokensEdits(W)){const ne=this._nextResultId++;return x._isSemanticTokens(Z)?this._previousResults.set(ne,new N(Z.resultId,Z.data)):this._previousResults.set(ne,new N(W.resultId)),(0,m.encodeSemanticTokensDto)({id:ne,type:"delta",deltas:(W.edits||[]).map(le=>({start:le.start,deleteCount:le.deleteCount,data:le.data}))})}return null}}e.DocumentSemanticTokensAdapter=x;class F{constructor(W,Z){this._documents=W,this._provider=Z}async provideDocumentRangeSemanticTokens(W,Z,ne){const le=this._documents.getDocument(W),Y=await this._provider.provideDocumentRangeSemanticTokens(le,k.Range.to(Z),ne);return Y?this._send(Y):null}_send(W){return(0,m.encodeSemanticTokensDto)({id:0,type:"full",data:W.data})}}e.DocumentRangeSemanticTokensAdapter=F;class z{constructor(W,Z,ne,le,Y){this._documents=W,this._commands=Z,this._provider=ne,this._apiDeprecation=le,this._extension=Y,this._cache=new v.Cache("CompletionItem"),this._disposables=new Map}static supportsResolving(W){return typeof W.resolveCompletionItem=="function"}async provideCompletionItems(W,Z,ne,le){const Y=this._documents.getDocument(W),ae=k.Position.to(Z),ve=Y.getWordRangeAtPosition(ae)||new S.Range(ae,ae),Me=ve.with({end:ae}),ze=new _.StopWatch(!0),Ee=await this._provider.provideCompletionItems(Y,ae,le,k.CompletionContext.to(ne));if(!Ee||le.isCancellationRequested)return;const Ye=Array.isArray(Ee)?new S.CompletionList(Ee):Ee,X=z.supportsResolving(this._provider)?this._cache.add(Ye.items):this._cache.add([]),se=new u.DisposableStore;this._disposables.set(X,se);const fe=[],xe={x:X,b:fe,a:{replace:k.Range.from(ve),insert:k.Range.from(Me)},c:Ye.isIncomplete||void 0,d:ze.elapsed()};for(let Be=0;Be<Ye.items.length;Be++){const et=Ye.items[Be],Ce=this._convertCompletionItem(et,[X,Be],Me,ve);fe.push(Ce)}return xe}async resolveCompletionItem(W,Z){if(typeof this._provider.resolveCompletionItem!="function")return;const ne=this._cache.get(...W);if(!ne)return;const le=await this._provider.resolveCompletionItem(ne,Z);if(!!le)return this._convertCompletionItem(le,W)}releaseCompletionItems(W){this._disposables.get(W)?.dispose(),this._disposables.delete(W),this._cache.delete(W)}_convertCompletionItem(W,Z,ne,le){const Y=this._disposables.get(Z[0]);if(!Y)throw Error("DisposableStore is missing...");const ae={x:Z,a:W.label,b:W.kind!==void 0?k.CompletionItemKind.from(W.kind):void 0,n:W.tags&&W.tags.map(k.CompletionItemTag.from),c:W.detail,d:typeof W.documentation=="undefined"?void 0:k.MarkdownString.fromStrict(W.documentation),e:W.sortText!==W.label?W.sortText:void 0,f:W.filterText!==W.label?W.filterText:void 0,g:W.preselect||void 0,i:W.keepWhitespace?1:0,k:W.commitCharacters,l:W.additionalTextEdits&&W.additionalTextEdits.map(k.TextEdit.from),m:this._commands.toInternal(W.command,Y)};W.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),ae.h=W.textEdit.newText):typeof W.insertText=="string"?ae.h=W.insertText:W.insertText instanceof S.SnippetString&&(ae.h=W.insertText.value,ae.i|=4);let ve;return W.textEdit?ve=W.textEdit.range:W.range&&(ve=W.range),S.Range.isRange(ve)?ae.j=k.Range.from(ve):ve&&(!ne?.isEqual(ve.inserting)||!le?.isEqual(ve.replacing))&&(ae.j={insert:k.Range.from(ve.inserting),replace:k.Range.from(ve.replacing)}),ae}}class M{constructor(W,Z,ne){this._documents=W,this._provider=Z,this._commands=ne,this._cache=new v.Cache("InlineCompletionItem"),this._disposables=new Map}async provideInlineCompletions(W,Z,ne,le){const Y=this._documents.getDocument(W),ae=k.Position.to(Z),ve=await this._provider.provideInlineCompletionItems(Y,ae,ne,le);if(!ve||le.isCancellationRequested)return;const Me=(0,i.isArray)(ve)?{items:ve}:ve,ze=this._cache.add(Me.items);let Ee;return{pid:ze,items:Me.items.map((Ye,X)=>{let se;return Ye.command&&(Ee||(Ee=new u.DisposableStore,this._disposables.set(ze,Ee)),se=this._commands.toInternal(Ye.command,Ee)),{text:Ye.text,range:Ye.range?k.Range.from(Ye.range):void 0,command:se,idx:X}})}}disposeCompletions(W){this._cache.delete(W);const Z=this._disposables.get(W);Z&&Z.clear(),this._disposables.delete(W)}handleDidShowCompletionItem(W,Z){const ne=this._cache.get(W,Z);ne&&O.get(this._provider).fireOnDidShowCompletionItem({completionItem:ne})}}class O{constructor(){this._onDidShowCompletionItemEmitter=new P.Emitter,this.onDidShowCompletionItem=this._onDidShowCompletionItemEmitter.event}static get(W){let Z=O.map.get(W);return Z||(Z=new O,O.map.set(W,Z)),Z}fireOnDidShowCompletionItem(W){this._onDidShowCompletionItemEmitter.fire(W)}}e.InlineCompletionController=O,O.map=new WeakMap;class q{constructor(W,Z){this._documents=W,this._provider=Z,this._cache=new v.Cache("SignatureHelp")}async provideSignatureHelp(W,Z,ne,le){const Y=this._documents.getDocument(W),ae=k.Position.to(Z),ve=this.reviveContext(ne),Me=await this._provider.provideSignatureHelp(Y,ae,le,ve);if(Me){const ze=this._cache.add([Me]);return{...k.SignatureHelp.from(Me),id:ze}}}reviveContext(W){let Z;if(W.activeSignatureHelp){const ne=k.SignatureHelp.to(W.activeSignatureHelp),le=this._cache.get(W.activeSignatureHelp.id,0);le?(Z=le,Z.activeSignature=ne.activeSignature,Z.activeParameter=ne.activeParameter):Z=ne}return{...W,activeSignatureHelp:Z}}releaseSignatureHelp(W){this._cache.delete(W)}}class B{constructor(W,Z){this._documents=W,this._provider=Z}async provideInlayHints(W,Z,ne){const le=this._documents.getDocument(W),Y=await this._provider.provideInlayHints(le,k.Range.to(Z),ne);return Y?{hints:Y.map(k.InlayHint.from)}:void 0}}class G{constructor(W,Z){this._documents=W,this._provider=Z,this._cache=new v.Cache("DocumentLink")}async provideLinks(W,Z){const ne=this._documents.getDocument(W),le=await this._provider.provideDocumentLinks(ne,Z);if(!(!Array.isArray(le)||le.length===0)&&!Z.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:le.filter(G._validateLink).map(k.DocumentLink.from)};{const Y=this._cache.add(le),ae={links:[],id:Y};for(let ve=0;ve<le.length;ve++){if(!G._validateLink(le[ve]))continue;const Me=k.DocumentLink.from(le[ve]);Me.cacheId=[Y,ve],ae.links.push(Me)}return ae}}}static _validateLink(W){return W.target&&W.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(W,Z){if(typeof this._provider.resolveDocumentLink!="function")return;const ne=this._cache.get(...W);if(!ne)return;const le=await this._provider.resolveDocumentLink(ne,Z);if(!(!le||!G._validateLink(le)))return k.DocumentLink.from(le)}releaseLinks(W){this._cache.delete(W)}}class ie{constructor(W,Z){this._documents=W,this._provider=Z}async provideColors(W,Z){const ne=this._documents.getDocument(W),le=await this._provider.provideDocumentColors(ne,Z);return Array.isArray(le)?le.map(ae=>({color:k.Color.from(ae.color),range:k.Range.from(ae.range)})):[]}async provideColorPresentations(W,Z,ne){const le=this._documents.getDocument(W),Y=k.Range.to(Z.range),ae=k.Color.to(Z.color),ve=await this._provider.provideColorPresentations(ae,{document:le,range:Y},ne);if(!!Array.isArray(ve))return ve.map(k.ColorPresentation.from)}}class he{constructor(W,Z){this._documents=W,this._provider=Z}async provideFoldingRanges(W,Z,ne){const le=this._documents.getDocument(W),Y=await this._provider.provideFoldingRanges(le,Z,ne);if(!!Array.isArray(Y))return Y.map(k.FoldingRange.from)}}class ye{constructor(W,Z,ne){this._documents=W,this._provider=Z,this._logService=ne}async provideSelectionRanges(W,Z,ne){const le=this._documents.getDocument(W),Y=Z.map(k.Position.to),ae=await this._provider.provideSelectionRanges(le,Y,ne);if(!(0,A.isNonEmptyArray)(ae))return[];if(ae.length!==Y.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const ve=[];for(let Me=0;Me<Y.length;Me++){const ze=[];ve.push(ze);let Ee=Y[Me],Ye=ae[Me];for(;;){if(!Ye.range.contains(Ee))throw new Error("INVALID selection range, must contain the previous range");if(ze.push(k.SelectionRange.from(Ye)),!Ye.parent)break;Ee=Ye.range,Ye=Ye.parent}}return ve}}class Ie{constructor(W,Z){this._documents=W,this._provider=Z,this._idPool=new l.IdGenerator(""),this._cache=new Map}async prepareSession(W,Z,ne){const le=this._documents.getDocument(W),Y=k.Position.to(Z),ae=await this._provider.prepareCallHierarchy(le,Y,ne);if(!ae)return;const ve=this._idPool.nextId();return this._cache.set(ve,new Map),Array.isArray(ae)?ae.map(Me=>this._cacheAndConvertItem(ve,Me)):[this._cacheAndConvertItem(ve,ae)]}async provideCallsTo(W,Z,ne){const le=this._itemFromCache(W,Z);if(!le)throw new Error("missing call hierarchy item");const Y=await this._provider.provideCallHierarchyIncomingCalls(le,ne);if(!!Y)return Y.map(ae=>({from:this._cacheAndConvertItem(W,ae.from),fromRanges:ae.fromRanges.map(ve=>k.Range.from(ve))}))}async provideCallsFrom(W,Z,ne){const le=this._itemFromCache(W,Z);if(!le)throw new Error("missing call hierarchy item");const Y=await this._provider.provideCallHierarchyOutgoingCalls(le,ne);if(!!Y)return Y.map(ae=>({to:this._cacheAndConvertItem(W,ae.to),fromRanges:ae.fromRanges.map(ve=>k.Range.from(ve))}))}releaseSession(W){this._cache.delete(W)}_cacheAndConvertItem(W,Z){const ne=this._cache.get(W),le=k.CallHierarchyItem.from(Z,W,ne.size.toString(36));return ne.set(le._itemId,Z),le}_itemFromCache(W,Z){return this._cache.get(W)?.get(Z)}}class Le{constructor(W,Z){this._documents=W,this._provider=Z,this._idPool=new l.IdGenerator(""),this._cache=new Map}async prepareSession(W,Z,ne){const le=this._documents.getDocument(W),Y=k.Position.to(Z),ae=await this._provider.prepareTypeHierarchy(le,Y,ne);if(!ae)return;const ve=this._idPool.nextId();return this._cache.set(ve,new Map),Array.isArray(ae)?ae.map(Me=>this._cacheAndConvertItem(ve,Me)):[this._cacheAndConvertItem(ve,ae)]}async provideSupertypes(W,Z,ne){const le=this._itemFromCache(W,Z);if(!le)throw new Error("missing type hierarchy item");const Y=await this._provider.provideTypeHierarchySupertypes(le,ne);if(!!Y)return Y.map(ae=>this._cacheAndConvertItem(W,ae))}async provideSubtypes(W,Z,ne){const le=this._itemFromCache(W,Z);if(!le)throw new Error("missing type hierarchy item");const Y=await this._provider.provideTypeHierarchySubtypes(le,ne);if(!!Y)return Y.map(ae=>this._cacheAndConvertItem(W,ae))}releaseSession(W){this._cache.delete(W)}_cacheAndConvertItem(W,Z){const ne=this._cache.get(W),le=k.TypeHierarchyItem.from(Z,W,ne.size.toString(36));return ne.set(le._itemId,Z),le}_itemFromCache(W,Z){return this._cache.get(W)?.get(Z)}}class qe{constructor(W,Z){this.adapter=W,this.extension=Z}}class We{constructor(W,Z,ne,le,Y,ae,ve){this._adapter=new Map,this._uriTransformer=Z,this._proxy=W.getProxy(T.MainContext.MainThreadLanguageFeatures),this._documents=ne,this._commands=le,this._diagnostics=Y,this._logService=ae,this._apiDeprecation=ve}_transformDocumentSelector(W){return(0,A.coalesce)((0,A.asArray)(W).map(Z=>this._doTransformDocumentSelector(Z)))}_doTransformDocumentSelector(W){if(typeof W=="string")return{$serialized:!0,language:W};if(W)return{$serialized:!0,language:W.language,scheme:this._transformScheme(W.scheme),pattern:typeof W.pattern=="undefined"?void 0:k.GlobPattern.from(W.pattern),exclusive:W.exclusive}}_transformScheme(W){return this._uriTransformer&&typeof W=="string"?this._uriTransformer.transformOutgoingScheme(W):W}_createDisposable(W){return new S.Disposable(()=>{this._adapter.delete(W),this._proxy.$unregister(W)})}_nextHandle(){return We._handlePool++}_withAdapter(W,Z,ne,le,Y=!1){const ae=this._adapter.get(W);if(!ae)return Promise.resolve(le);if(ae.adapter instanceof Z){let ve;ae.extension&&(ve=Date.now(),this._logService.trace(`[${ae.extension.identifier.value}] INVOKE provider '${Z.name}'`));const Me=ne(ae.adapter,ae.extension),ze=ae.extension;return ze&&Promise.resolve(Me).then(()=>this._logService.trace(`[${ze.identifier.value}] provider DONE after ${Date.now()-ve}ms`),Ee=>{Y&&Ee instanceof b.CancellationError||(this._logService.error(`[${ze.identifier.value}] provider FAILED`),this._logService.error(Ee))}),Me}return Promise.reject(new Error("no adapter found"))}_addNewAdapter(W,Z){const ne=this._nextHandle();return this._adapter.set(ne,new qe(W,Z)),ne}static _extLabel(W){return W.displayName||W.name}registerDocumentSymbolProvider(W,Z,ne,le){const Y=this._addNewAdapter(new c(this._documents,ne),W),ae=le&&le.label||We._extLabel(W);return this._proxy.$registerDocumentSymbolProvider(Y,this._transformDocumentSelector(Z),ae),this._createDisposable(Y)}$provideDocumentSymbols(W,Z,ne){return this._withAdapter(W,c,le=>le.provideDocumentSymbols(g.URI.revive(Z),ne),void 0)}registerCodeLensProvider(W,Z,ne){const le=this._nextHandle(),Y=typeof ne.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(le,new qe(new h(this._documents,this._commands.converter,ne),W)),this._proxy.$registerCodeLensSupport(le,this._transformDocumentSelector(Z),Y);let ae=this._createDisposable(le);if(Y!==void 0){const ve=ne.onDidChangeCodeLenses(Me=>this._proxy.$emitCodeLensEvent(Y));ae=S.Disposable.from(ae,ve)}return ae}$provideCodeLenses(W,Z,ne){return this._withAdapter(W,h,le=>le.provideCodeLenses(g.URI.revive(Z),ne),void 0)}$resolveCodeLens(W,Z,ne){return this._withAdapter(W,h,le=>le.resolveCodeLens(Z,ne),void 0)}$releaseCodeLenses(W,Z){this._withAdapter(W,h,ne=>Promise.resolve(ne.releaseCodeLenses(Z)),void 0)}registerDefinitionProvider(W,Z,ne){const le=this._addNewAdapter(new t(this._documents,ne),W);return this._proxy.$registerDefinitionSupport(le,this._transformDocumentSelector(Z)),this._createDisposable(le)}$provideDefinition(W,Z,ne,le){return this._withAdapter(W,t,Y=>Y.provideDefinition(g.URI.revive(Z),ne,le),[])}registerDeclarationProvider(W,Z,ne){const le=this._addNewAdapter(new r(this._documents,ne),W);return this._proxy.$registerDeclarationSupport(le,this._transformDocumentSelector(Z)),this._createDisposable(le)}$provideDeclaration(W,Z,ne,le){return this._withAdapter(W,r,Y=>Y.provideDeclaration(g.URI.revive(Z),ne,le),[])}registerImplementationProvider(W,Z,ne){const le=this._addNewAdapter(new s(this._documents,ne),W);return this._proxy.$registerImplementationSupport(le,this._transformDocumentSelector(Z)),this._createDisposable(le)}$provideImplementation(W,Z,ne,le){return this._withAdapter(W,s,Y=>Y.provideImplementation(g.URI.revive(Z),ne,le),[])}registerTypeDefinitionProvider(W,Z,ne){const le=this._addNewAdapter(new n(this._documents,ne),W);return this._proxy.$registerTypeDefinitionSupport(le,this._transformDocumentSelector(Z)),this._createDisposable(le)}$provideTypeDefinition(W,Z,ne,le){return this._withAdapter(W,n,Y=>Y.provideTypeDefinition(g.URI.revive(Z),ne,le),[])}registerHoverProvider(W,Z,ne,le){const Y=this._addNewAdapter(new a(this._documents,ne),W);return this._proxy.$registerHoverProvider(Y,this._transformDocumentSelector(Z)),this._createDisposable(Y)}$provideHover(W,Z,ne,le){return this._withAdapter(W,a,Y=>Y.provideHover(g.URI.revive(Z),ne,le),void 0)}registerEvaluatableExpressionProvider(W,Z,ne,le){const Y=this._addNewAdapter(new d(this._documents,ne),W);return this._proxy.$registerEvaluatableExpressionProvider(Y,this._transformDocumentSelector(Z)),this._createDisposable(Y)}$provideEvaluatableExpression(W,Z,ne,le){return this._withAdapter(W,d,Y=>Y.provideEvaluatableExpression(g.URI.revive(Z),ne,le),void 0)}registerInlineValuesProvider(W,Z,ne,le){const Y=typeof ne.onDidChangeInlineValues=="function"?this._nextHandle():void 0,ae=this._addNewAdapter(new f(this._documents,ne),W);this._proxy.$registerInlineValuesProvider(ae,this._transformDocumentSelector(Z),Y);let ve=this._createDisposable(ae);if(Y!==void 0){const Me=ne.onDidChangeInlineValues(ze=>this._proxy.$emitInlineValuesEvent(Y));ve=S.Disposable.from(ve,Me)}return ve}$provideInlineValues(W,Z,ne,le,Y){return this._withAdapter(W,f,ae=>ae.provideInlineValues(g.URI.revive(Z),ne,le,Y),void 0)}registerDocumentHighlightProvider(W,Z,ne){const le=this._addNewAdapter(new w(this._documents,ne),W);return this._proxy.$registerDocumentHighlightProvider(le,this._transformDocumentSelector(Z)),this._createDisposable(le)}$provideDocumentHighlights(W,Z,ne,le){return this._withAdapter(W,w,Y=>Y.provideDocumentHighlights(g.URI.revive(Z),ne,le),void 0)}registerLinkedEditingRangeProvider(W,Z,ne){const le=this._addNewAdapter(new E(this._documents,ne),W);return this._proxy.$registerLinkedEditingRangeProvider(le,this._transformDocumentSelector(Z)),this._createDisposable(le)}$provideLinkedEditingRanges(W,Z,ne,le){return this._withAdapter(W,E,async Y=>{const ae=await Y.provideLinkedEditingRanges(g.URI.revive(Z),ne,le);if(ae)return{ranges:ae.ranges,wordPattern:ae.wordPattern?We._serializeRegExp(ae.wordPattern):void 0}},void 0)}registerReferenceProvider(W,Z,ne){const le=this._addNewAdapter(new o(this._documents,ne),W);return this._proxy.$registerReferenceSupport(le,this._transformDocumentSelector(Z)),this._createDisposable(le)}$provideReferences(W,Z,ne,le,Y){return this._withAdapter(W,o,ae=>ae.provideReferences(g.URI.revive(Z),ne,le,Y),void 0)}registerCodeActionProvider(W,Z,ne,le){const Y=new u.DisposableStore,ae=this._addNewAdapter(new I(this._documents,this._commands.converter,this._diagnostics,ne,this._logService,W,this._apiDeprecation),W);return this._proxy.$registerQuickFixSupport(ae,this._transformDocumentSelector(Z),{providedKinds:le?.providedCodeActionKinds?.map(ve=>ve.value),documentation:le?.documentation?.map(ve=>({kind:ve.kind.value,command:this._commands.converter.toInternal(ve.command,Y)}))},We._extLabel(W),Boolean(ne.resolveCodeAction)),Y.add(this._createDisposable(ae)),Y}$provideCodeActions(W,Z,ne,le,Y){return this._withAdapter(W,I,ae=>ae.provideCodeActions(g.URI.revive(Z),ne,le,Y),void 0)}$resolveCodeAction(W,Z,ne){return this._withAdapter(W,I,le=>le.resolveCodeAction(Z,ne),void 0)}$releaseCodeActions(W,Z){this._withAdapter(W,I,ne=>Promise.resolve(ne.releaseCodeActions(Z)),void 0)}registerDocumentFormattingEditProvider(W,Z,ne){const le=this._addNewAdapter(new L(this._documents,ne),W);return this._proxy.$registerDocumentFormattingSupport(le,this._transformDocumentSelector(Z),W.identifier,W.displayName||W.name),this._createDisposable(le)}$provideDocumentFormattingEdits(W,Z,ne,le){return this._withAdapter(W,L,Y=>Y.provideDocumentFormattingEdits(g.URI.revive(Z),ne,le),void 0)}registerDocumentRangeFormattingEditProvider(W,Z,ne){const le=this._addNewAdapter(new U(this._documents,ne),W);return this._proxy.$registerRangeFormattingSupport(le,this._transformDocumentSelector(Z),W.identifier,W.displayName||W.name),this._createDisposable(le)}$provideDocumentRangeFormattingEdits(W,Z,ne,le,Y){return this._withAdapter(W,U,ae=>ae.provideDocumentRangeFormattingEdits(g.URI.revive(Z),ne,le,Y),void 0)}registerOnTypeFormattingEditProvider(W,Z,ne,le){const Y=this._addNewAdapter(new V(this._documents,ne),W);return this._proxy.$registerOnTypeFormattingSupport(Y,this._transformDocumentSelector(Z),le,W.identifier),this._createDisposable(Y)}$provideOnTypeFormattingEdits(W,Z,ne,le,Y,ae){return this._withAdapter(W,V,ve=>ve.provideOnTypeFormattingEdits(g.URI.revive(Z),ne,le,Y,ae),void 0)}registerWorkspaceSymbolProvider(W,Z){const ne=this._addNewAdapter(new ee(Z,this._logService),W);return this._proxy.$registerNavigateTypeSupport(ne),this._createDisposable(ne)}$provideWorkspaceSymbols(W,Z,ne){return this._withAdapter(W,ee,le=>le.provideWorkspaceSymbols(Z,ne),{symbols:[]})}$resolveWorkspaceSymbol(W,Z,ne){return this._withAdapter(W,ee,le=>le.resolveWorkspaceSymbol(Z,ne),void 0)}$releaseWorkspaceSymbols(W,Z){this._withAdapter(W,ee,ne=>ne.releaseWorkspaceSymbols(Z),void 0)}registerRenameProvider(W,Z,ne){const le=this._addNewAdapter(new K(this._documents,ne,this._logService),W);return this._proxy.$registerRenameSupport(le,this._transformDocumentSelector(Z),K.supportsResolving(ne)),this._createDisposable(le)}$provideRenameEdits(W,Z,ne,le,Y){return this._withAdapter(W,K,ae=>ae.provideRenameEdits(g.URI.revive(Z),ne,le,Y),void 0)}$resolveRenameLocation(W,Z,ne,le){return this._withAdapter(W,K,Y=>Y.resolveRenameLocation(g.URI.revive(Z),ne,le),void 0)}registerDocumentSemanticTokensProvider(W,Z,ne,le){const Y=this._nextHandle(),ae=typeof ne.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._adapter.set(Y,new qe(new x(this._documents,ne),W)),this._proxy.$registerDocumentSemanticTokensProvider(Y,this._transformDocumentSelector(Z),le,ae);let ve=this._createDisposable(Y);if(ae){const Me=ne.onDidChangeSemanticTokens(ze=>this._proxy.$emitDocumentSemanticTokensEvent(ae));ve=S.Disposable.from(ve,Me)}return ve}$provideDocumentSemanticTokens(W,Z,ne,le){return this._withAdapter(W,x,Y=>Y.provideDocumentSemanticTokens(g.URI.revive(Z),ne,le),null,!0)}$releaseDocumentSemanticTokens(W,Z){this._withAdapter(W,x,ne=>ne.releaseDocumentSemanticColoring(Z),void 0)}registerDocumentRangeSemanticTokensProvider(W,Z,ne,le){const Y=this._addNewAdapter(new F(this._documents,ne),W);return this._proxy.$registerDocumentRangeSemanticTokensProvider(Y,this._transformDocumentSelector(Z),le),this._createDisposable(Y)}$provideDocumentRangeSemanticTokens(W,Z,ne,le){return this._withAdapter(W,F,Y=>Y.provideDocumentRangeSemanticTokens(g.URI.revive(Z),ne,le),null,!0)}registerCompletionItemProvider(W,Z,ne,le){const Y=this._addNewAdapter(new z(this._documents,this._commands.converter,ne,this._apiDeprecation,W),W);return this._proxy.$registerSuggestSupport(Y,this._transformDocumentSelector(Z),le,z.supportsResolving(ne),`${W.identifier.value}(${le.join("")})`),this._createDisposable(Y)}$provideCompletionItems(W,Z,ne,le,Y){return this._withAdapter(W,z,ae=>ae.provideCompletionItems(g.URI.revive(Z),ne,le,Y),void 0)}$resolveCompletionItem(W,Z,ne){return this._withAdapter(W,z,le=>le.resolveCompletionItem(Z,ne),void 0)}$releaseCompletionItems(W,Z){this._withAdapter(W,z,ne=>ne.releaseCompletionItems(Z),void 0)}registerInlineCompletionsProvider(W,Z,ne){const le=this._addNewAdapter(new M(this._documents,ne,this._commands.converter),W);return this._proxy.$registerInlineCompletionsSupport(le,this._transformDocumentSelector(Z)),this._createDisposable(le)}$provideInlineCompletions(W,Z,ne,le,Y){return this._withAdapter(W,M,ae=>ae.provideInlineCompletions(g.URI.revive(Z),ne,le,Y),void 0)}$handleInlineCompletionDidShow(W,Z,ne){this._withAdapter(W,M,async le=>{le.handleDidShowCompletionItem(Z,ne)},void 0)}$freeInlineCompletionsList(W,Z){this._withAdapter(W,M,async ne=>{ne.disposeCompletions(Z)},void 0)}registerSignatureHelpProvider(W,Z,ne,le){const Y=Array.isArray(le)?{triggerCharacters:le,retriggerCharacters:[]}:le,ae=this._addNewAdapter(new q(this._documents,ne),W);return this._proxy.$registerSignatureHelpProvider(ae,this._transformDocumentSelector(Z),Y),this._createDisposable(ae)}$provideSignatureHelp(W,Z,ne,le,Y){return this._withAdapter(W,q,ae=>ae.provideSignatureHelp(g.URI.revive(Z),ne,le,Y),void 0)}$releaseSignatureHelp(W,Z){this._withAdapter(W,q,ne=>ne.releaseSignatureHelp(Z),void 0)}registerInlayHintsProvider(W,Z,ne){const le=typeof ne.onDidChangeInlayHints=="function"?this._nextHandle():void 0,Y=this._addNewAdapter(new B(this._documents,ne),W);this._proxy.$registerInlayHintsProvider(Y,this._transformDocumentSelector(Z),le);let ae=this._createDisposable(Y);if(le!==void 0){const ve=ne.onDidChangeInlayHints(Me=>this._proxy.$emitInlayHintsEvent(le));ae=S.Disposable.from(ae,ve)}return ae}$provideInlayHints(W,Z,ne,le){return this._withAdapter(W,B,Y=>Y.provideInlayHints(g.URI.revive(Z),ne,le),void 0)}registerDocumentLinkProvider(W,Z,ne){const le=this._addNewAdapter(new G(this._documents,ne),W);return this._proxy.$registerDocumentLinkProvider(le,this._transformDocumentSelector(Z),typeof ne.resolveDocumentLink=="function"),this._createDisposable(le)}$provideDocumentLinks(W,Z,ne){return this._withAdapter(W,G,le=>le.provideLinks(g.URI.revive(Z),ne),void 0)}$resolveDocumentLink(W,Z,ne){return this._withAdapter(W,G,le=>le.resolveLink(Z,ne),void 0)}$releaseDocumentLinks(W,Z){this._withAdapter(W,G,ne=>ne.releaseLinks(Z),void 0)}registerColorProvider(W,Z,ne){const le=this._addNewAdapter(new ie(this._documents,ne),W);return this._proxy.$registerDocumentColorProvider(le,this._transformDocumentSelector(Z)),this._createDisposable(le)}$provideDocumentColors(W,Z,ne){return this._withAdapter(W,ie,le=>le.provideColors(g.URI.revive(Z),ne),[])}$provideColorPresentations(W,Z,ne,le){return this._withAdapter(W,ie,Y=>Y.provideColorPresentations(g.URI.revive(Z),ne,le),void 0)}registerFoldingRangeProvider(W,Z,ne){const le=this._nextHandle(),Y=typeof ne.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(le,new qe(new he(this._documents,ne),W)),this._proxy.$registerFoldingRangeProvider(le,this._transformDocumentSelector(Z),Y);let ae=this._createDisposable(le);if(Y!==void 0){const ve=ne.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(Y));ae=S.Disposable.from(ae,ve)}return ae}$provideFoldingRanges(W,Z,ne,le){return this._withAdapter(W,he,Y=>Y.provideFoldingRanges(g.URI.revive(Z),ne,le),void 0)}registerSelectionRangeProvider(W,Z,ne){const le=this._addNewAdapter(new ye(this._documents,ne,this._logService),W);return this._proxy.$registerSelectionRangeProvider(le,this._transformDocumentSelector(Z)),this._createDisposable(le)}$provideSelectionRanges(W,Z,ne,le){return this._withAdapter(W,ye,Y=>Y.provideSelectionRanges(g.URI.revive(Z),ne,le),[])}registerCallHierarchyProvider(W,Z,ne){const le=this._addNewAdapter(new Ie(this._documents,ne),W);return this._proxy.$registerCallHierarchyProvider(le,this._transformDocumentSelector(Z)),this._createDisposable(le)}$prepareCallHierarchy(W,Z,ne,le){return this._withAdapter(W,Ie,Y=>Promise.resolve(Y.prepareSession(g.URI.revive(Z),ne,le)),void 0)}$provideCallHierarchyIncomingCalls(W,Z,ne,le){return this._withAdapter(W,Ie,Y=>Y.provideCallsTo(Z,ne,le),void 0)}$provideCallHierarchyOutgoingCalls(W,Z,ne,le){return this._withAdapter(W,Ie,Y=>Y.provideCallsFrom(Z,ne,le),void 0)}$releaseCallHierarchy(W,Z){this._withAdapter(W,Ie,ne=>Promise.resolve(ne.releaseSession(Z)),void 0)}registerTypeHierarchyProvider(W,Z,ne){const le=this._addNewAdapter(new Le(this._documents,ne),W);return this._proxy.$registerTypeHierarchyProvider(le,this._transformDocumentSelector(Z)),this._createDisposable(le)}$prepareTypeHierarchy(W,Z,ne,le){return this._withAdapter(W,Le,Y=>Promise.resolve(Y.prepareSession(g.URI.revive(Z),ne,le)),void 0)}$provideTypeHierarchySupertypes(W,Z,ne,le){return this._withAdapter(W,Le,Y=>Y.provideSupertypes(Z,ne,le),void 0)}$provideTypeHierarchySubtypes(W,Z,ne,le){return this._withAdapter(W,Le,Y=>Y.provideSubtypes(Z,ne,le),void 0)}$releaseTypeHierarchy(W,Z){this._withAdapter(W,Le,ne=>Promise.resolve(ne.releaseSession(Z)),void 0)}static _serializeRegExp(W){return{pattern:W.source,flags:(0,D.regExpFlags)(W)}}static _serializeIndentationRule(W){return{decreaseIndentPattern:We._serializeRegExp(W.decreaseIndentPattern),increaseIndentPattern:We._serializeRegExp(W.increaseIndentPattern),indentNextLinePattern:W.indentNextLinePattern?We._serializeRegExp(W.indentNextLinePattern):void 0,unIndentedLinePattern:W.unIndentedLinePattern?We._serializeRegExp(W.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(W){return{beforeText:We._serializeRegExp(W.beforeText),afterText:W.afterText?We._serializeRegExp(W.afterText):void 0,previousLineText:W.previousLineText?We._serializeRegExp(W.previousLineText):void 0,action:W.action}}static _serializeOnEnterRules(W){return W.map(We._serializeOnEnterRule)}setLanguageConfiguration(W,Z,ne){let{wordPattern:le}=ne;if(le&&(0,D.regExpLeadsToEndlessLoop)(le))throw new Error(`Invalid language configuration: wordPattern '${le}' is not allowed to match the empty string.`);le?this._documents.setWordDefinitionFor(Z,le):this._documents.setWordDefinitionFor(Z,void 0),ne.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",W,"Do not use."),ne.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",W,"Do not use.");const Y=this._nextHandle(),ae={comments:ne.comments,brackets:ne.brackets,wordPattern:ne.wordPattern?We._serializeRegExp(ne.wordPattern):void 0,indentationRules:ne.indentationRules?We._serializeIndentationRule(ne.indentationRules):void 0,onEnterRules:ne.onEnterRules?We._serializeOnEnterRules(ne.onEnterRules):void 0,__electricCharacterSupport:ne.__electricCharacterSupport,__characterPairSupport:ne.__characterPairSupport};return this._proxy.$setLanguageConfiguration(Y,Z,ae),this._createDisposable(Y)}$setWordDefinitions(W){for(const Z of W)this._documents.setWordDefinitionFor(Z.languageId,new RegExp(Z.regexSource,Z.regexFlags))}}e.ExtHostLanguageFeatures=We,We._handlePool=0}),define(me[241],ge([0,1,5,17,7,48,16]),function(J,e,g,R,k,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class D{constructor(A,i){this._handlePool=0,this._proxy=A.getProxy(g.MainContext.MainThreadLanguages),this._documents=i}getLanguages(){return this._proxy.$getLanguages()}async changeLanguage(A,i){await this._proxy.$changeLanguage(A,i);const C=this._documents.getDocumentData(A);if(!C)throw new Error(`document '${A.toString}' NOT found`);return C.document}async tokenAtPosition(A,i){const C=A.version,u=R.Position.from(i),m=await this._proxy.$tokensAtPosition(A.uri,u),l={type:k.StandardTokenType.Other,range:A.getWordRangeAtPosition(i)??new k.Range(i.line,i.character,i.line,i.character)};if(!m)return l;const v={range:R.Range.to(m.range),type:R.TokenType.to(m.type)};return!v.range.contains(i)||C!==A.version?l:v}createLanguageStatusItem(A){const i=this._handlePool++,C=this._proxy,u={selector:A,text:"",detail:"",severity:k.LanguageStatusSeverity.Information};let m;const l=()=>{m?.dispose(),m=(0,T.disposableTimeout)(()=>{this._proxy.$setLanguageStatus(i,{selector:u.selector,text:u.text,message:typeof u.detail=="string"?u.detail:R.MarkdownString.from(u.detail),severity:u.severity===k.LanguageStatusSeverity.Error?S.default.Error:u.severity===k.LanguageStatusSeverity.Warning?S.default.Warning:S.default.Info})},0)},v={get selector(){return u.selector},set selector(_){u.selector=_,l()},get text(){return u.text},set text(_){u.text=_,l()},get detail(){return u.detail},set detail(_){u.detail=_,l()},get severity(){return u.severity},set severity(_){u.severity=_,l()},dispose(){m?.dispose(),C.$removeLanguageStatus(i)}};return l(),v}}e.ExtHostLanguages=D}),define(me[242],ge([0,1,5,12,35]),function(J,e,g,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function S(D){return D&&D.title}let T=class{constructor(y,A){this._logService=A,this._proxy=y.getProxy(g.MainContext.MainThreadMessageService)}showMessage(y,A,i,C,u){const m={extension:y};let l;typeof C=="string"||S(C)?l=[C,...u]:(m.modal=C?.modal,m.useCustom=C?.useCustom,m.detail=C?.detail,l=u),m.useCustom&&(0,k.checkProposedApiEnabled)(y);const v=[];for(let _=0;_<l.length;_++){const b=l[_];if(typeof b=="string")v.push({title:b,handle:_,isCloseAffordance:!1});else if(typeof b=="object"){let{title:P,isCloseAffordance:c}=b;v.push({title:P,isCloseAffordance:!!c,handle:_})}else this._logService.warn("Invalid message item:",b)}return this._proxy.$showMessage(A,i,m,v).then(_=>{if(typeof _=="number")return l[_]})}};T=Ve([$e(1,R.ILogService)],T),e.ExtHostMessageService=T}),define(me[243],ge([0,1,24,3,58,6,22,8,14,2,86,5,17,7,218,128]),function(J,e,g,R,k,S,T,D,y,A,i,C,u,m,l,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class _{constructor(P,c,h,p,t){this._textDocumentsAndEditors=h,this._textDocuments=p,this._extensionStoragePaths=t,this._notebookContentProviders=new Map,this._notebookStatusBarItemProviders=new Map,this._documents=new T.ResourceMap,this._editors=new Map,this._onDidChangeNotebookCells=new R.Emitter,this.onDidChangeNotebookCells=this._onDidChangeNotebookCells.event,this._onDidChangeCellOutputs=new R.Emitter,this.onDidChangeCellOutputs=this._onDidChangeCellOutputs.event,this._onDidChangeCellMetadata=new R.Emitter,this.onDidChangeCellMetadata=this._onDidChangeCellMetadata.event,this._onDidChangeActiveNotebookEditor=new R.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._onDidChangeCellExecutionState=new R.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new R.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new R.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new R.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._statusBarCache=new i.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._backupIdPool=0,this._notebookProxy=P.getProxy(C.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=P.getProxy(C.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=P.getProxy(C.MainContext.MainThreadNotebookEditors),this._commandsConverter=c.converter,c.registerArgumentProcessor({processArgument:r=>{if(r&&r.$mid===12){const s=r.notebookEditor?.notebookUri,n=r.cell.handle,d=this._documents.get(s)?.getCell(n);if(d)return d.apiCell}return r}})}get activeNotebookEditor(){return this._activeNotebookEditor?.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(P=>P.apiEditor)}getEditorById(P){const c=this._editors.get(P);if(!c)throw new Error(`unknown text editor: ${P}. known editors: ${[...this._editors.keys()]} `);return c}getIdByEditor(P){for(const[c,h]of this._editors)if(h.apiEditor===P)return c}get notebookDocuments(){return[...this._documents.values()]}getNotebookDocument(P,c){const h=this._documents.get(P);if(!h&&!c)throw new Error(`NO notebook document for '${P}'`);return h}_getProviderData(P){const c=this._notebookContentProviders.get(P);if(!c)throw new Error(`NO provider for '${P}'`);return c}registerNotebookContentProvider(P,c,h,p,t){if((0,D.isFalsyOrWhitespace)(c))throw new Error("viewType cannot be empty or just whitespace");if(this._notebookContentProviders.has(c))throw new Error(`Notebook provider for '${c}' already registered`);this._notebookContentProviders.set(c,{extension:P,provider:h});let r;return h.onDidChangeNotebookContentOptions&&(r=h.onDidChangeNotebookContentOptions(()=>{const s=u.NotebookDocumentContentOptions.from(h.options);this._notebookProxy.$updateNotebookProviderOptions(c,s)})),this._notebookProxy.$registerNotebookProvider({id:P.identifier,location:P.extensionLocation},c,u.NotebookDocumentContentOptions.from(p),_._convertNotebookRegistrationData(P,t)),new m.Disposable(()=>{r?.dispose(),this._notebookContentProviders.delete(c),this._notebookProxy.$unregisterNotebookProvider(c)})}static _convertNotebookRegistrationData(P,c){if(!c)return;const h=c.filenamePattern.map(p=>u.NotebookExclusiveDocumentPattern.from(p)).filter(p=>p!==void 0);if(c.filenamePattern&&!h){console.warn(`Notebook content provider view options file name pattern is invalid ${c.filenamePattern}`);return}return{extension:P.identifier,providerDisplayName:P.displayName||P.name,displayName:c.displayName,filenamePattern:h,exclusive:c.exclusive||!1}}registerNotebookCellStatusBarItemProvider(P,c,h){const p=_._notebookStatusBarItemProviderHandlePool++,t=typeof h.onDidChangeCellStatusBarItems=="function"?_._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(p,h),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(p,t,c);let r;return t!==void 0&&(r=h.onDidChangeCellStatusBarItems(s=>this._notebookProxy.$emitCellStatusBarEvent(t))),new m.Disposable(()=>{this._notebookStatusBarItemProviders.delete(p),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(p,t),r&&r.dispose()})}async createNotebookDocument(P){const c=await this._notebookDocumentsProxy.$tryCreateNotebook({viewType:P.viewType,content:P.content&&u.NotebookData.from(P.content)});return A.URI.revive(c)}async openNotebookDocument(P){const c=this._documents.get(P);if(c)return c.apiNotebook;const h=await this._notebookDocumentsProxy.$tryOpenNotebook(P),p=this._documents.get(A.URI.revive(h));return(0,y.assertIsDefined)(p?.apiNotebook)}async showNotebookDocument(P,c){A.URI.isUri(P)&&(P=await this.openNotebookDocument(P));let h;typeof c=="object"?h={position:u.ViewColumn.from(c.viewColumn),preserveFocus:c.preserveFocus,selections:c.selections&&c.selections.map(u.NotebookRange.from),pinned:typeof c.preview=="boolean"?!c.preview:void 0}:h={preserveFocus:!1};const p=await this._notebookEditorsProxy.$tryShowNotebookDocument(P.uri,P.notebookType,h),t=p&&this._editors.get(p)?.apiEditor;if(t)return t;throw p?new Error(`Could NOT open editor for "${P.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${P.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(P,c,h,p){const t=this._notebookStatusBarItemProviders.get(P),r=A.URI.revive(c),s=this._documents.get(r);if(!s||!t)return;const n=s.getCellFromIndex(h);if(!n)return;const a=await t.provideCellStatusBarItems(n.apiCell,p);if(!a)return;const d=new S.DisposableStore,f=this._statusBarCache.add([d]),E=(Array.isArray(a)?a:[a]).map(o=>u.NotebookStatusBarItem.from(o,this._commandsConverter,d));return{cacheId:f,items:E}}$releaseNotebookCellStatusBarItems(P){this._statusBarCache.delete(P)}registerNotebookSerializer(P,c,h,p,t){if((0,D.isFalsyOrWhitespace)(c))throw new Error("viewType cannot be empty or just whitespace");const r=this._handlePool++;return this._notebookSerializer.set(r,h),this._notebookProxy.$registerNotebookSerializer(r,{id:P.identifier,location:P.extensionLocation},c,u.NotebookDocumentContentOptions.from(p),_._convertNotebookRegistrationData(P,t)),(0,S.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(r)})}async $dataToNotebook(P,c,h){const p=this._notebookSerializer.get(P);if(!p)throw new Error("NO serializer found");const t=await p.deserializeNotebook(c.buffer,h);return u.NotebookData.from(t)}async $notebookToData(P,c,h){const p=this._notebookSerializer.get(P);if(!p)throw new Error("NO serializer found");const t=await p.serializeNotebook(u.NotebookData.to(c),h);return g.VSBuffer.wrap(t)}async $openNotebook(P,c,h,p,t){const{provider:r}=this._getProviderData(P),s=await r.openNotebook(A.URI.revive(c),{backupId:h,untitledDocumentData:p?.buffer},t);return{metadata:s.metadata??Object.create(null),cells:s.cells.map(u.NotebookCellData.from)}}async $saveNotebook(P,c,h){const p=this.getNotebookDocument(A.URI.revive(c)),{provider:t}=this._getProviderData(P);return await t.saveNotebook(p.apiNotebook,h),!0}async $saveNotebookAs(P,c,h,p){const t=this.getNotebookDocument(A.URI.revive(c)),{provider:r}=this._getProviderData(P);return await r.saveNotebookAs(A.URI.revive(h),t.apiNotebook,p),!0}async $backupNotebook(P,c,h){const p=this.getNotebookDocument(A.URI.revive(c)),t=this._getProviderData(P),r=this._extensionStoragePaths.workspaceValue(t.extension)??this._extensionStoragePaths.globalValue(t.extension),s=String((0,k.hash)([p.uri.toString(),this._backupIdPool++])),n=A.URI.joinPath(r,s),a=await t.provider.backupNotebook(p.apiNotebook,{destination:n},h);return p.updateBackup(a),a.id}_createExtHostEditor(P,c,h){if(this._editors.has(c))throw new Error(`editor with id ALREADY EXSIST: ${c}`);const p=new v.ExtHostNotebookEditor(c,this._notebookEditorsProxy,P,h.visibleRanges.map(u.NotebookRange.to),h.selections.map(u.NotebookRange.to),typeof h.viewColumn=="number"?u.ViewColumn.to(h.viewColumn):void 0);this._editors.set(c,p)}$acceptDocumentAndEditorsDelta(P){if(P.removedDocuments)for(const h of P.removedDocuments){const p=A.URI.revive(h),t=this._documents.get(p);t&&(t.dispose(),this._documents.delete(p),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:t.apiNotebook.getCells().map(r=>r.document.uri)}),this._onDidCloseNotebookDocument.fire(t.apiNotebook));for(const r of this._editors.values())r.notebookData.uri.toString()===p.toString()&&this._editors.delete(r.id)}if(P.addedDocuments){const h=[];for(const p of P.addedDocuments){const t=A.URI.revive(p.uri);if(this._documents.has(t))throw new Error(`adding EXISTING notebook ${t} `);const r=this,s=new l.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,{emitModelChange(n){r._onDidChangeNotebookCells.fire(n)},emitCellOutputsChange(n){r._onDidChangeCellOutputs.fire(n)},emitCellMetadataChange(n){r._onDidChangeCellMetadata.fire(n)},emitCellExecutionStateChange(n){r._onDidChangeCellExecutionState.fire(n)}},t,p);h.push(...p.cells.map(n=>l.ExtHostCell.asModelAddData(s.apiNotebook,n))),this._documents.get(t)?.dispose(),this._documents.set(t,s),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:h}),this._onDidOpenNotebookDocument.fire(s.apiNotebook)}}if(P.addedEditors)for(const h of P.addedEditors){if(this._editors.has(h.id))return;const p=A.URI.revive(h.documentUri),t=this._documents.get(p);t&&this._createExtHostEditor(t,h.id,h)}const c=[];if(P.removedEditors)for(const h of P.removedEditors){const p=this._editors.get(h);p&&(this._editors.delete(h),this._activeNotebookEditor?.id===p.id&&(this._activeNotebookEditor=void 0),c.push(p))}if(P.visibleEditors){this._visibleNotebookEditors=P.visibleEditors.map(p=>this._editors.get(p)).filter(p=>!!p);const h=new Set;this._visibleNotebookEditors.forEach(p=>h.add(p.id));for(const p of this._editors.values()){const t=h.has(p.id);p._acceptVisibility(t)}this._visibleNotebookEditors=[...this._editors.values()].map(p=>p).filter(p=>p.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}P.newActiveEditor===null?this._activeNotebookEditor=void 0:P.newActiveEditor&&(this._activeNotebookEditor=this._editors.get(P.newActiveEditor)),P.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire(this._activeNotebookEditor?.apiEditor)}}e.ExtHostNotebookController=_,_._notebookStatusBarItemProviderHandlePool=0}),define(me[244],ge([0,1,3,73,12,5,13,17]),function(J,e,g,R,k,S,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;class y{constructor(C,u){const m=y._Keys.nextId();C.$registerNotebookEditorDecorationType(m,D.NotebookDecorationRenderOptions.from(u)),this.value={key:m,dispose(){C.$removeNotebookEditorDecorationType(m)}}}}y._Keys=new R.IdGenerator("NotebookEditorDecorationType");let A=class{constructor(C,u,m){this._logService=C,this._extHostRpc=u,this._notebooksAndEditors=m,this._onDidChangeNotebookEditorSelection=new g.Emitter,this._onDidChangeNotebookEditorVisibleRanges=new g.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event}createNotebookEditorDecorationType(C){return new y(this._extHostRpc.getProxy(S.MainContext.MainThreadNotebookEditors),C).value}$acceptEditorPropertiesChanged(C,u){this._logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",C,u);const m=this._notebooksAndEditors.getEditorById(C);u.visibleRanges&&m._acceptVisibleRanges(u.visibleRanges.ranges.map(D.NotebookRange.to)),u.selections&&m._acceptSelections(u.selections.selections.map(D.NotebookRange.to)),u.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:m.apiEditor,visibleRanges:m.apiEditor.visibleRanges}),u.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:m.apiEditor,selections:m.apiEditor.selections}))}$acceptEditorViewColumns(C){for(const u in C)this._notebooksAndEditors.getEditorById(u)._acceptViewColumn(D.ViewColumn.to(C[u]))}};A=Ve([$e(0,k.ILogService),$e(1,T.IExtHostRpcService)],A),e.ExtHostNotebookEditors=A}),define(me[245],ge([0,1,3,6,5,26,2,17,88,22,16,89,21,20,12,7,35]),function(J,e,g,R,k,S,T,D,y,A,i,C,u,m,l,v,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookKernels=void 0;let b=class{constructor(t,r,s,n){this._initData=r,this._extHostNotebook=s,this._logService=n,this._activeExecutions=new A.ResourceMap,this._kernelData=new Map,this._handlePool=0,this._proxy=t.getProxy(k.MainContext.MainThreadNotebookKernels)}createNotebookController(t,r,s,n,a,d){for(let M of this._kernelData.values())if(M.controller.id===r&&S.ExtensionIdentifier.equals(t.identifier,M.extensionId))throw new Error(`notebook controller with id '${r}' ALREADY exist`);const f=this._handlePool++,w=this;this._logService.trace(`NotebookController[${f}], CREATED by ${t.identifier.value}, ${r}`);const E=()=>console.warn(`NO execute handler from notebook controller '${V.id}' of extension: '${t.identifier}'`);let o=!1;const I=new R.DisposableStore,L=new g.Emitter,U=new g.Emitter,V={id:`${t.identifier.value}/${r}`,notebookType:s,extensionId:t.identifier,extensionLocation:t.extensionLocation,label:n||t.identifier.value,preloads:d?d.map(D.NotebookRendererScript.from):[]};let ee=a??E,K;this._proxy.$addKernel(f,V).catch(M=>{console.log(M),o=!0});let N=0;const x=()=>{if(o)return;const M=++N;Promise.resolve().then(()=>{M===N&&this._proxy.$updateKernel(f,V)})},F=new A.ResourceMap,z={get id(){return r},get notebookType(){return V.notebookType},onDidChangeSelectedNotebooks:L.event,get label(){return V.label},set label(M){V.label=M??t.displayName??t.name,x()},get detail(){return V.detail??""},set detail(M){V.detail=M,x()},get description(){return V.description??""},set description(M){V.description=M,x()},get supportedLanguages(){return V.supportedLanguages},set supportedLanguages(M){V.supportedLanguages=M,x()},get supportsExecutionOrder(){return V.supportsExecutionOrder??!1},set supportsExecutionOrder(M){V.supportsExecutionOrder=M,x()},get rendererScripts(){return V.preloads?V.preloads.map(D.NotebookRendererScript.to):[]},get executeHandler(){return ee},set executeHandler(M){ee=M??E},get interruptHandler(){return K},set interruptHandler(M){K=M,V.supportsInterrupt=Boolean(M),x()},createNotebookCellExecution(M){if(o)throw new Error("notebook controller is DISPOSED");if(!F.has(M.notebook.uri))throw w._logService.trace(`NotebookController[${f}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(F.keys()).map(O=>O.toString())),new Error(`notebook controller is NOT associated to notebook: ${M.notebook.uri.toString()}`);return w._createNotebookCellExecution(M)},dispose:()=>{o||(this._logService.trace(`NotebookController[${f}], DISPOSED`),o=!0,this._kernelData.delete(f),I.dispose(),L.dispose(),U.dispose(),this._proxy.$removeKernel(f))},updateNotebookAffinity(M,O){w._proxy.$updateNotebookPriority(f,M.uri,O)},onDidReceiveMessage:U.event,postMessage(M,O){return(0,_.checkProposedApiEnabled)(t),w._proxy.$postMessage(f,O&&w._extHostNotebook.getIdByEditor(O),M)},asWebviewUri(M){return(0,_.checkProposedApiEnabled)(t),(0,y.asWebviewUri)(M,w._initData.remote)}};return this._kernelData.set(f,{extensionId:t.identifier,controller:z,onDidReceiveMessage:U,onDidChangeSelection:L,associatedNotebooks:F}),z}$acceptNotebookAssociation(t,r,s){const n=this._kernelData.get(t);if(n){const a=this._extHostNotebook.getNotebookDocument(T.URI.revive(r));s?n.associatedNotebooks.set(a.uri,!0):n.associatedNotebooks.delete(a.uri),this._logService.trace(`NotebookController[${t}] ASSOCIATE notebook`,a.uri.toString(),s),n.onDidChangeSelection.fire({selected:s,notebook:a.apiNotebook})}}async $executeCells(t,r,s){const n=this._kernelData.get(t);if(!n)return;const a=this._extHostNotebook.getNotebookDocument(T.URI.revive(r)),d=[];for(let f of s){const w=a.getCell(f);w&&d.push(w.apiCell)}try{this._logService.trace(`NotebookController[${t}] EXECUTE cells`,a.uri.toString(),d.length),await n.controller.executeHandler.call(n.controller,d,a.apiNotebook,n.controller)}catch(f){this._logService.error(`NotebookController[${t}] execute cells FAILED`,f),console.error(f)}}async $cancelCells(t,r,s){const n=this._kernelData.get(t);if(!n)return;const a=this._extHostNotebook.getNotebookDocument(T.URI.revive(r));if(n.controller.interruptHandler)await n.controller.interruptHandler.call(n.controller,a.apiNotebook);else for(let d of s){const f=a.getCell(d);f&&this._activeExecutions.get(f.uri)?.cancel()}}$acceptKernelMessageFromRenderer(t,r,s){const n=this._kernelData.get(t);if(!n)return;const a=this._extHostNotebook.getEditorById(r);n.onDidReceiveMessage.fire(Object.freeze({editor:a.apiEditor,message:s}))}_createNotebookCellExecution(t){if(t.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const s=this._extHostNotebook.getNotebookDocument(t.notebook.uri).getCellFromApiCell(t);if(!s)throw new Error("invalid cell");if(this._activeExecutions.has(s.uri))throw new Error(`duplicate execution for ${s.uri}`);const n=new c(s.notebook,s,this._proxy);this._activeExecutions.set(s.uri,n);const a=n.onDidChangeState(()=>{n.state===P.Resolved&&(n.dispose(),a.dispose(),this._activeExecutions.delete(s.uri))});return n.asApiObject()}};b=Ve([$e(3,l.ILogService)],b),e.ExtHostNotebookKernels=b;var P;(function(p){p[p.Init=0]="Init",p[p.Started=1]="Started",p[p.Resolved=2]="Resolved"})(P||(P={}));class c extends R.Disposable{constructor(t,r,s){super();this._document=t,this._cell=r,this._proxy=s,this._onDidChangeState=new g.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=P.Init,this._tokenSource=this._register(new u.CancellationTokenSource),this._collector=new h(10,n=>this.applyEdits(n)),this._executionOrder=r.internalMetadata.executionOrder,this.mixinMetadata({runState:C.NotebookCellExecutionState.Pending,executionOrder:null})}get state(){return this._state}cancel(){this._tokenSource.cancel()}async applyEditSoon(t){await this._collector.addItem(t)}async applyEdits(t){return this._proxy.$applyExecutionEdits(this._document.uri,t)}verifyStateForOutput(){if(this._state===P.Init)throw new Error("Must call start before modifying cell output");if(this._state===P.Resolved)throw new Error("Cannot modify cell output after calling resolve")}mixinMetadata(t){this.applyEdits([{editType:9,handle:this._cell.handle,internalMetadata:t}])}cellIndexToHandle(t){let r=this._cell;if(t&&(r=this._document.getCellFromApiCell(t)),!r)throw new Error("INVALID cell");return r.handle}validateAndConvertOutputs(t){return t.map(r=>{const s=v.NotebookCellOutput.ensureUniqueMimeTypes(r.items,!0);return s===r.items?D.NotebookCellOutput.from(r):D.NotebookCellOutput.from({items:s,id:r.id,metadata:r.metadata})})}async updateOutputs(t,r,s){const n=this.cellIndexToHandle(r),a=this.validateAndConvertOutputs((0,m.asArray)(t));return this.applyEditSoon({editType:2,handle:n,append:s,outputs:a})}async updateOutputItems(t,r,s){return t=v.NotebookCellOutput.ensureUniqueMimeTypes((0,m.asArray)(t),!0),this.applyEditSoon({editType:7,items:t.map(D.NotebookCellOutputItem.from),outputId:r.id,append:s})}asApiObject(){const t=this;return Object.freeze({get token(){return t._tokenSource.token},get cell(){return t._cell.apiCell},get executionOrder(){return t._executionOrder},set executionOrder(s){t._executionOrder=s,t.mixinMetadata({executionOrder:s})},start(s){if(t._state===P.Resolved||t._state===P.Started)throw new Error("Cannot call start again");t._state=P.Started,t._onDidChangeState.fire(),t.mixinMetadata({runState:C.NotebookCellExecutionState.Executing,runStartTime:s??null})},end(s,n){if(t._state===P.Resolved)throw new Error("Cannot call resolve twice");t._state=P.Resolved,t._onDidChangeState.fire(),t.mixinMetadata({runState:null,lastRunSuccess:s??null,runEndTime:n??null})},clearOutput(s){return t.verifyStateForOutput(),t.updateOutputs([],s,!1)},appendOutput(s,n){return t.verifyStateForOutput(),t.updateOutputs(s,n,!0)},replaceOutput(s,n){return t.verifyStateForOutput(),t.updateOutputs(s,n,!1)},appendOutputItems(s,n){return t.verifyStateForOutput(),t.updateOutputItems(s,n,!0)},replaceOutputItems(s,n){return t.verifyStateForOutput(),t.updateOutputItems(s,n,!1)}})}}class h{constructor(t,r){this.delay=t,this.callback=r,this.batch=[]}addItem(t){return this.batch.push(t),this.waitPromise||(this.waitPromise=(0,i.timeout)(this.delay).then(()=>{this.waitPromise=void 0;const r=this.batch;return this.batch=[],this.callback(r)})),this.waitPromise}}}),define(me[246],ge([0,1,3,5,128]),function(J,e,g,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class S{constructor(D,y){this._extHostNotebook=y,this._rendererMessageEmitters=new Map,this.proxy=D.getProxy(R.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(D,y,A){const i=this._extHostNotebook.getEditorById(D);this._rendererMessageEmitters.get(y)?.fire({editor:i.apiEditor,message:A})}createRendererMessaging(D,y){if(!D.contributes?.notebookRenderer?.some(u=>u.id===y))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${y})`);const A=!!D.enableProposedApi,i=new WeakMap;return{onDidReceiveMessage:(u,m,l)=>{const v=A?u:_=>{const b={};i.set(b,_.editor),u({editor:b,message:_.message})};return this.getOrCreateEmitterFor(y).event(v,m,l)},postMessage:(u,m)=>{k.ExtHostNotebookEditor.apiEditorsToExtHost.has(u)&&([u,m]=[m,u]);const l=A?m:i.get(m),v=l&&k.ExtHostNotebookEditor.apiEditorsToExtHost.get(l);return this.proxy.$postMessage(v?.id,y,u)}}}getOrCreateEmitterFor(D){let y=this._rendererMessageEmitters.get(D);return y||(y=new g.Emitter({onLastListenerRemove:()=>{y?.dispose(),this._rendererMessageEmitters.delete(D)}}),this._rendererMessageEmitters.set(D,y),y)}}e.ExtHostNotebookRenderers=S}),define(me[65],ge([0,1,5,3,6,24,4,13]),function(J,e,g,R,k,S,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=e.LazyOutputChannel=e.ExtHostPushOutputChannel=e.AbstractExtHostOutputChannel=void 0;class y extends k.Disposable{constructor(l,v,_,b,P){super();this._onDidAppend=this._register(new R.Emitter),this.onDidAppend=this._onDidAppend.event,this._name=l,this._proxy=P,this._id=P.$register(this.name,v,_,b),this._disposed=!1,this._offset=0}get name(){return this._name}append(l){this.validate(),this._offset+=l?S.VSBuffer.fromString(l).byteLength:0}update(){this._id.then(l=>this._proxy.$update(l))}appendLine(l){this.validate(),this.append(l+`
`)}clear(){this.validate();const l=this._offset;this._id.then(v=>this._proxy.$clear(v,l))}show(l,v){this.validate(),this._id.then(_=>this._proxy.$reveal(_,!!(typeof l=="boolean"?l:v)))}hide(){this.validate(),this._id.then(l=>this._proxy.$close(l))}validate(){if(this._disposed)throw new Error("Channel has been closed")}dispose(){super.dispose(),this._disposed||this._id.then(l=>this._proxy.$dispose(l)).then(()=>this._disposed=!0)}}e.AbstractExtHostOutputChannel=y;class A extends y{constructor(l,v,_){super(l,!1,void 0,v,_)}append(l){super.append(l),this._id.then(v=>this._proxy.$append(v,l)),this._onDidAppend.fire()}}e.ExtHostPushOutputChannel=A;class i extends y{constructor(l,v,_){super(l,!0,v,void 0,_)}append(l){throw new Error("Not supported")}}class C{constructor(l,v){this.name=l,this._channel=v}append(l){this._channel.then(v=>v.append(l))}appendLine(l){this._channel.then(v=>v.appendLine(l))}clear(){this._channel.then(l=>l.clear())}show(l,v){this._channel.then(_=>_.show(l,v))}hide(){this._channel.then(l=>l.hide())}dispose(){this._channel.then(l=>l.dispose())}}e.LazyOutputChannel=C;let u=class{constructor(l){this._proxy=l.getProxy(g.MainContext.MainThreadOutputService)}$setVisibleChannel(l){}createOutputChannel(l,v){if(l=l.trim(),!l)throw new Error("illegal argument `name`. must not be falsy");return new A(l,v.identifier.value,this._proxy)}createOutputChannelFromLogFile(l,v){if(l=l.trim(),!l)throw new Error("illegal argument `name`. must not be falsy");if(!v)throw new Error("illegal argument `file`. must not be falsy");return new i(l,v,this._proxy)}};u=Ve([$e(0,D.IExtHostRpcService)],u),e.ExtHostOutputService=u,e.IExtHostOutputService=(0,T.createDecorator)("IExtHostOutputService")}),define(me[247],ge([0,1,16,21,3,6,5,2,7,15,20,48]),function(J,e,g,R,k,S,T,D,y,A,i,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function u(m,l,v){const _=m.getProxy(T.MainContext.MainThreadQuickOpen);class b{constructor(n,a){this._sessions=new Map,this._instances=0,this._workspace=n,this._commands=a}showQuickPick(n,a,d,f=R.CancellationToken.None){this._onDidSelectItem=void 0;const w=Promise.resolve(n),E=++this._instances,o=_.$show(E,{title:d?.title,placeHolder:d?.placeHolder,matchOnDescription:d?.matchOnDescription,matchOnDetail:d?.matchOnDetail,ignoreFocusLost:d?.ignoreFocusOut,canPickMany:d?.canPickMany},f),I={},L=o.then(()=>I);return Promise.race([L,w]).then(U=>{if(U!==I)return w.then(V=>{const ee=[];for(let K=0;K<V.length;K++){const N=V[K];let x,F,z,M,O;typeof N=="string"?x=N:(x=N.label,F=N.description,z=N.detail,M=N.picked,O=N.alwaysShow),ee.push({label:x,description:F,handle:K,detail:z,picked:M,alwaysShow:O})}return d&&typeof d.onDidSelectItem=="function"&&(this._onDidSelectItem=K=>{d.onDidSelectItem(V[K])}),_.$setItems(E,ee),o.then(K=>{if(typeof K=="number")return V[K];if(Array.isArray(K))return K.map(N=>V[N])})})}).then(void 0,U=>{if(!(0,A.isPromiseCanceledError)(U))return _.$setError(E,U),Promise.reject(U)})}$onItemSelected(n){this._onDidSelectItem&&this._onDidSelectItem(n)}showInput(n,a=R.CancellationToken.None){return this._validateInput=n?n.validateInput:void 0,_.$input(n,typeof this._validateInput=="function",a).then(void 0,d=>{if(!(0,A.isPromiseCanceledError)(d))return Promise.reject(d)})}$validateInput(n){return this._validateInput?(0,g.asPromise)(()=>this._validateInput(n)):Promise.resolve(void 0)}async showWorkspaceFolderPick(n,a=R.CancellationToken.None){const d=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[n]);if(!d)return;const f=await this._workspace.getWorkspaceFolders2();if(!!f)return f.find(w=>w.uri.toString()===d.uri.toString())}createQuickPick(n,a){const d=new t(n,a,()=>this._sessions.delete(d._id));return this._sessions.set(d._id,d),d}createInputBox(n){const a=new r(n,()=>this._sessions.delete(a._id));return this._sessions.set(a._id,a),a}$onDidChangeValue(n,a){const d=this._sessions.get(n);d&&d._fireDidChangeValue(a)}$onDidAccept(n){const a=this._sessions.get(n);a&&a._fireDidAccept()}$onDidChangeActive(n,a){const d=this._sessions.get(n);d instanceof t&&d._fireDidChangeActive(a)}$onDidChangeSelection(n,a){const d=this._sessions.get(n);d instanceof t&&d._fireDidChangeSelection(a)}$onDidTriggerButton(n,a){const d=this._sessions.get(n);d&&d._fireDidTriggerButton(a)}$onDidHide(n){const a=this._sessions.get(n);a&&a._fireDidHide()}}class P{constructor(n,a){this._extensionId=n,this._onDidDispose=a,this._id=t._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new k.Emitter,this._onDidChangeValueEmitter=new k.Emitter,this._onDidTriggerButtonEmitter=new k.Emitter,this._onDidHideEmitter=new k.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(n){this._title=n,this.update({title:n})}get step(){return this._steps}set step(n){this._steps=n,this.update({step:n})}get totalSteps(){return this._totalSteps}set totalSteps(n){this._totalSteps=n,this.update({totalSteps:n})}get enabled(){return this._enabled}set enabled(n){this._enabled=n,this.update({enabled:n})}get busy(){return this._busy}set busy(n){this._busy=n,this.update({busy:n})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(n){this._ignoreFocusOut=n,this.update({ignoreFocusOut:n})}get value(){return this._value}set value(n){this._value=n,this.update({value:n})}get placeholder(){return this._placeholder}set placeholder(n){this._placeholder=n,this.update({placeholder:n})}get buttons(){return this._buttons}set buttons(n){this._buttons=n.slice(),this._handlesToButtons.clear(),n.forEach((a,d)=>{const f=a===y.QuickInputButtons.Back?-1:d;this._handlesToButtons.set(f,a)}),this.update({buttons:n.map((a,d)=>({iconPath:c(a.iconPath),tooltip:a.tooltip,handle:a===y.QuickInputButtons.Back?-1:d}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(n){this._value=n,this._onDidChangeValueEmitter.fire(n)}_fireDidTriggerButton(n){const a=this._handlesToButtons.get(n);a&&this._onDidTriggerButtonEmitter.fire(a)}_fireDidHide(){this._expectingHide&&(this._expectingHide=!1,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,S.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),_.$dispose(this._id))}update(n){if(!this._disposed){for(const a of Object.keys(n)){const d=n[a];this._pendingUpdate[a]=d===void 0?null:d}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){_.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}P._nextId=1;function c(s){if(s instanceof y.ThemeIcon)return{id:s.id};const n=p(s),a=h(s);return{dark:typeof n=="string"?D.URI.file(n):n,light:typeof a=="string"?D.URI.file(a):a}}function h(s){return typeof s=="object"&&"light"in s?s.light:s}function p(s){return typeof s=="object"&&"dark"in s?s.dark:s}class t extends P{constructor(n,a,d){super(n,d);this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._activeItems=[],this._onDidChangeActiveEmitter=new k.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new k.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(n){this._items=n.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),n.forEach((a,d)=>{this._handlesToItems.set(d,a),this._itemsToHandles.set(a,d)}),this.update({items:n.map((a,d)=>({label:a.label,description:a.description,handle:d,detail:a.detail,picked:a.picked,alwaysShow:a.alwaysShow}))})}get canSelectMany(){return this._canSelectMany}set canSelectMany(n){this._canSelectMany=n,this.update({canSelectMany:n})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(n){this._matchOnDescription=n,this.update({matchOnDescription:n})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(n){this._matchOnDetail=n,this.update({matchOnDetail:n})}get sortByLabel(){return this._sortByLabel}set sortByLabel(n){this._sortByLabel=n,this.update({sortByLabel:n})}get activeItems(){return this._activeItems}set activeItems(n){this._activeItems=n.filter(a=>this._itemsToHandles.has(a)),this.update({activeItems:this._activeItems.map(a=>this._itemsToHandles.get(a))})}get selectedItems(){return this._selectedItems}set selectedItems(n){this._selectedItems=n.filter(a=>this._itemsToHandles.has(a)),this.update({selectedItems:this._selectedItems.map(a=>this._itemsToHandles.get(a))})}_fireDidChangeActive(n){const a=(0,i.coalesce)(n.map(d=>this._handlesToItems.get(d)));this._activeItems=a,this._onDidChangeActiveEmitter.fire(a)}_fireDidChangeSelection(n){const a=(0,i.coalesce)(n.map(d=>this._handlesToItems.get(d)));this._selectedItems=a,this._onDidChangeSelectionEmitter.fire(a)}}class r extends P{constructor(n,a){super(n,a);this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(n){this._password=n,this.update({password:n})}get prompt(){return this._prompt}set prompt(n){this._prompt=n,this.update({prompt:n})}get validationMessage(){return this._validationMessage}set validationMessage(n){this._validationMessage=n,this.update({validationMessage:n,severity:n?C.default.Error:C.default.Ignore})}}return new b(l,v)}e.createExtHostQuickOpen=u}),define(me[248],ge([0,1,2,3,56,6,16,5,20,100,12,26,35,85]),function(J,e,g,R,k,S,T,D,y,A,i,C,u,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function l(a){if(a)return typeof a.iconPath=="string"?g.URI.file(a.iconPath):g.URI.isUri(a.iconPath)||m.ThemeIcon.isThemeIcon(a.iconPath)?a.iconPath:void 0}function v(a,d){if(!a.iconPath&&!d.iconPath)return 0;if(a.iconPath){if(!d.iconPath)return 1}else return-1;const f=typeof a.iconPath=="string"?a.iconPath:g.URI.isUri(a.iconPath)?a.iconPath.fsPath:a.iconPath.id,w=typeof d.iconPath=="string"?d.iconPath:g.URI.isUri(d.iconPath)?d.iconPath.fsPath:d.iconPath.id;return(0,A.comparePaths)(f,w)}function _(a,d){let f=0;if(a.strikeThrough!==d.strikeThrough)return a.strikeThrough?1:-1;if(a.faded!==d.faded)return a.faded?1:-1;if(a.tooltip!==d.tooltip)return(a.tooltip||"").localeCompare(d.tooltip||"");if(f=v(a,d),f!==0)return f;if(a.light&&d.light)f=v(a.light,d.light);else{if(a.light)return 1;if(d.light)return-1}if(f!==0)return f;if(a.dark&&d.dark)f=v(a.dark,d.dark);else{if(a.dark)return 1;if(d.dark)return-1}return f}function b(a,d){if(a.command!==d.command)return a.command<d.command?-1:1;if(a.title!==d.title)return a.title<d.title?-1:1;if(a.tooltip!==d.tooltip){if(a.tooltip!==void 0&&d.tooltip!==void 0)return a.tooltip<d.tooltip?-1:1;if(a.tooltip!==void 0)return 1;if(d.tooltip!==void 0)return-1}if(a.arguments===d.arguments)return 0;if(a.arguments)if(d.arguments){if(a.arguments.length!==d.arguments.length)return a.arguments.length-d.arguments.length}else return 1;else return-1;for(let f=0;f<a.arguments.length;f++){const w=a.arguments[f],E=d.arguments[f];if(w!==E)return w<E?-1:1}return 0}function P(a,d){let f=(0,A.comparePaths)(a.resourceUri.fsPath,d.resourceUri.fsPath,!0);if(f!==0)return f;if(a.command&&d.command)f=b(a.command,d.command);else{if(a.command)return 1;if(d.command)return-1}if(f!==0)return f;if(a.decorations&&d.decorations)f=_(a.decorations,d.decorations);else{if(a.decorations)return 1;if(d.decorations)return-1}return f}function c(a,d){for(let f=0;f<a.length;f++)if(a[f]!==d[f])return!1;return!0}function h(a,d){return a.command===d.command&&a.title===d.title&&a.tooltip===d.tooltip&&(a.arguments&&d.arguments?c(a.arguments,d.arguments):a.arguments===d.arguments)}function p(a,d){return(0,y.equals)(a,d,h)}class t{constructor(d,f,w){this._extension=d,this._proxy=f,this._sourceControlHandle=w,this._value="",this._onDidChange=new R.Emitter,this._placeholder="",this._visible=!0}get value(){return this._value}set value(d){this._proxy.$setInputBoxValue(this._sourceControlHandle,d),this.updateValue(d)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(d){this._proxy.$setInputBoxPlaceholder(this._sourceControlHandle,d),this._placeholder=d}get validateInput(){return(0,u.checkProposedApiEnabled)(this._extension),this._validateInput}set validateInput(d){if((0,u.checkProposedApiEnabled)(this._extension),d&&typeof d!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=d,this._proxy.$setValidationProviderIsEnabled(this._sourceControlHandle,!!d)}get visible(){return this._visible}set visible(d){d=!!d,this._visible!==d&&(this._visible=d,this._proxy.$setInputBoxVisibility(this._sourceControlHandle,d))}focus(){(0,u.checkProposedApiEnabled)(this._extension),this._visible||(this.visible=!0),this._proxy.$setInputBoxFocus(this._sourceControlHandle)}showValidationMessage(d,f){(0,u.checkProposedApiEnabled)(this._extension),this._proxy.$showValidationMessage(this._sourceControlHandle,d,f)}$onInputBoxValueChange(d){this.updateValue(d)}updateValue(d){this._value=d,this._onDidChange.fire(d)}}e.ExtHostSCMInputBox=t;class r{constructor(d,f,w,E,o){this._proxy=d,this._commands=f,this._sourceControlHandle=w,this._id=E,this._label=o,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new R.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new R.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=r._handlePool++}get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(d){this._label=d,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,d)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(d){this._hideWhenEmpty=d,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(d){this._resourceStates=[...d],this._onDidUpdateResourceStates.fire()}getResourceState(d){return this._resourceStatesMap.get(d)}$executeResourceCommand(d,f){const w=this._resourceStatesCommandsMap.get(d);return w?(0,T.asPromise)(()=>this._commands.executeCommand(w.command,...w.arguments||[],f)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const d=[...this._resourceStates].sort(P),w=(0,y.sortedDiff)(this._resourceSnapshot,d,P).map(I=>{const L=I.toInsert.map(U=>{const V=this._resourceHandlePool++;this._resourceStatesMap.set(V,U);const ee=U.resourceUri;let K;if(U.command)if(U.command.command==="vscode.open"||U.command.command==="vscode.diff"){const ie=new S.DisposableStore;K=this._commands.converter.toInternal(U.command,ie),this._resourceStatesDisposablesMap.set(V,ie)}else this._resourceStatesCommandsMap.set(V,U.command);const N=l(U.decorations),x=U.decorations&&l(U.decorations.light)||N,F=U.decorations&&l(U.decorations.dark)||N,z=[x,F],M=U.decorations&&U.decorations.tooltip||"",O=U.decorations&&!!U.decorations.strikeThrough,q=U.decorations&&!!U.decorations.faded,B=U.contextValue||"";return{rawResource:[V,ee,z,M,O,q,B,K],handle:V}});return{start:I.start,deleteCount:I.deleteCount,toInsert:L}}),E=w.map(({start:I,deleteCount:L,toInsert:U})=>[I,L,U.map(V=>V.rawResource)]),o=w.reverse();for(const{start:I,deleteCount:L,toInsert:U}of o){const V=U.map(K=>K.handle),ee=this._handlesSnapshot.splice(I,L,...V);for(const K of ee)this._resourceStatesMap.delete(K),this._resourceStatesCommandsMap.delete(K),this._resourceStatesDisposablesMap.get(K)?.dispose(),this._resourceStatesDisposablesMap.delete(K)}return this._resourceSnapshot=d,E}dispose(){this._disposed=!0,this._onDidDispose.fire()}}r._handlePool=0;class s{constructor(d,f,w,E,o,I){this._proxy=f,this._commands=w,this._id=E,this._label=o,this._rootUri=I,this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new S.MutableDisposable,this._acceptInputCommand=void 0,this._statusBarDisposables=new S.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new R.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=s._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,this._inputBox=new t(d,this._proxy,this.handle),this._proxy.$registerSourceControl(this.handle,E,o,I)}get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(d){this._count!==d&&(this._count=d,this._proxy.$updateSourceControl(this.handle,{count:d}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(d){this._quickDiffProvider=d,this._proxy.$updateSourceControl(this.handle,{hasQuickDiffProvider:!!d})}get commitTemplate(){return this._commitTemplate}set commitTemplate(d){d!==this._commitTemplate&&(this._commitTemplate=d,this._proxy.$updateSourceControl(this.handle,{commitTemplate:d}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(d){this._acceptInputDisposables.value=new S.DisposableStore,this._acceptInputCommand=d;const f=this._commands.converter.toInternal(d,this._acceptInputDisposables.value);this._proxy.$updateSourceControl(this.handle,{acceptInputCommand:f})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(d){if(this._statusBarCommands&&d&&p(this._statusBarCommands,d))return;this._statusBarDisposables.value=new S.DisposableStore,this._statusBarCommands=d;const f=(d||[]).map(w=>this._commands.converter.toInternal(w,this._statusBarDisposables.value));this._proxy.$updateSourceControl(this.handle,{statusBarCommands:f})}get selected(){return this._selected}createResourceGroup(d,f){const w=new r(this._proxy,this._commands,this.handle,d,f),E=R.Event.once(w.onDidDispose)(()=>this.createdResourceGroups.delete(w));return this.createdResourceGroups.set(w,E),this.eventuallyAddResourceGroups(),w}eventuallyAddResourceGroups(){const d=[],f=[];for(const[w,E]of this.createdResourceGroups){E.dispose();const o=w.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(w),this.eventuallyUpdateResourceStates()});R.Event.once(w.onDidDispose)(()=>{this.updatedResourceGroups.delete(w),o.dispose(),this._groups.delete(w.handle),this._proxy.$unregisterGroup(this.handle,w.handle)}),d.push([w.handle,w.id,w.label,w.features]);const I=w._takeResourceStateSnapshot();I.length>0&&f.push([w.handle,I]),this._groups.set(w.handle,w)}this._proxy.$registerGroups(this.handle,d,f),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const d=[];this.updatedResourceGroups.forEach(f=>{const w=f._takeResourceStateSnapshot();w.length!==0&&d.push([f.handle,w])}),d.length>0&&this._proxy.$spliceResourceStates(this.handle,d),this.updatedResourceGroups.clear()}getResourceGroup(d){return this._groups.get(d)}setSelectionState(d){this._selected=d,this._onDidChangeSelection.fire(d)}dispose(){this._acceptInputDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(d=>d.dispose()),this._proxy.$unregisterSourceControl(this.handle)}}s._handlePool=0,Ve([(0,k.debounce)(100)],s.prototype,"eventuallyAddResourceGroups",null),Ve([(0,k.debounce)(100)],s.prototype,"eventuallyUpdateResourceStates",null);let n=class xn{constructor(d,f,w){this._commands=f,this.logService=w,this._sourceControls=new Map,this._sourceControlsByExtension=new Map,this._onDidChangeActiveProvider=new R.Emitter,this._proxy=d.getProxy(D.MainContext.MainThreadSCM),this._telemetry=d.getProxy(D.MainContext.MainThreadTelemetry),f.registerArgumentProcessor({processArgument:E=>{if(E&&E.$mid===3){const o=this._sourceControls.get(E.sourceControlHandle);if(!o)return E;const I=o.getResourceGroup(E.groupHandle);return I?I.getResourceState(E.handle):E}else if(E&&E.$mid===4){const o=this._sourceControls.get(E.sourceControlHandle);return o?o.getResourceGroup(E.groupHandle):E}else if(E&&E.$mid===5){const o=this._sourceControls.get(E.handle);return o||E}return E}})}get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}createSourceControl(d,f,w,E){this.logService.trace("ExtHostSCM#createSourceControl",d.identifier.value,f,w,E),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:d.identifier.value});const o=xn._handlePool++,I=new s(d,this._proxy,this._commands,f,w,E);this._sourceControls.set(o,I);const L=this._sourceControlsByExtension.get(C.ExtensionIdentifier.toKey(d.identifier))||[];return L.push(I),this._sourceControlsByExtension.set(C.ExtensionIdentifier.toKey(d.identifier),L),I}getLastInputBox(d){this.logService.trace("ExtHostSCM#getLastInputBox",d.identifier.value);const f=this._sourceControlsByExtension.get(C.ExtensionIdentifier.toKey(d.identifier)),w=f&&f[f.length-1];return w&&w.inputBox}$provideOriginalResource(d,f,w){const E=g.URI.revive(f);this.logService.trace("ExtHostSCM#$provideOriginalResource",d,E.toString());const o=this._sourceControls.get(d);return!o||!o.quickDiffProvider||!o.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,T.asPromise)(()=>o.quickDiffProvider.provideOriginalResource(E,w)).then(I=>I||null)}$onInputBoxValueChange(d,f){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",d);const w=this._sourceControls.get(d);return w&&w.inputBox.$onInputBoxValueChange(f),Promise.resolve(void 0)}$executeResourceCommand(d,f,w,E){this.logService.trace("ExtHostSCM#$executeResourceCommand",d,f,w);const o=this._sourceControls.get(d);if(!o)return Promise.resolve(void 0);const I=o.getResourceGroup(f);return I?I.$executeResourceCommand(w,E):Promise.resolve(void 0)}$validateInput(d,f,w){this.logService.trace("ExtHostSCM#$validateInput",d);const E=this._sourceControls.get(d);return!E||!E.inputBox.validateInput?Promise.resolve(void 0):(0,T.asPromise)(()=>E.inputBox.validateInput(f,w)).then(o=>o?Promise.resolve([o.message,o.type]):Promise.resolve(void 0))}$setSelectedSourceControl(d){return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",d),d!==void 0&&this._sourceControls.get(d)?.setSelectionState(!0),this._selectedSourceControlHandle!==void 0&&this._sourceControls.get(this._selectedSourceControlHandle)?.setSelectionState(!1),this._selectedSourceControlHandle=d,Promise.resolve(void 0)}};n._handlePool=0,n=Ve([$e(2,i.ILogService)],n),e.ExtHostSCM=n});var it=this&&this.__classPrivateFieldSet||function(J,e,g,R,k){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!k:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?k.call(J,g):k?k.value=g:e.set(J,g),g},He=this&&this.__classPrivateFieldGet||function(J,e,g,R){if(g==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!R:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?R:g==="a"?R.call(J):R?R.value:e.get(J)};define(me[249],ge([0,1,7,5,166,6,17]),function(J,e,g,R,k,S,T){"use strict";var D,y;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class A{constructor(m,l,v,_,b=g.StatusBarAlignment.Left,P){D.set(this,void 0),y.set(this,void 0),this._disposed=!1,this._visible=!1,this._text="",this._internalCommandRegistration=new S.DisposableStore,it(this,D,m,"f"),it(this,y,l,"f"),this._entryId=A.ID_GEN++,this._extension=v,this._id=_,this._alignment=b,this._priority=P}get id(){return this._id??this._extension.identifier.value}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get name(){return this._name}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){return this._command?.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(m){this._text=m,this.update()}set name(m){this._name=m,this.update()}set tooltip(m){this._tooltip=m,this.update()}set color(m){this._color=m,this.update()}set backgroundColor(m){m&&!A.ALLOWED_BACKGROUND_COLORS.has(m.id)&&(m=void 0),this._backgroundColor=m,this.update()}set command(m){this._command?.fromApi!==m&&(this._internalCommandRegistration.clear(),typeof m=="string"?this._command={fromApi:m,internal:He(this,y,"f").toInternal({title:"",command:m},this._internalCommandRegistration)}:m?this._command={fromApi:m,internal:He(this,y,"f").toInternal(m,this._internalCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(m){this._accessibilityInformation=m,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,He(this,D,"f").$dispose(this._entryId)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{this._timeoutHandle=void 0;let m;this._extension?this._id?m=`${this._extension.identifier.value}.${this._id}`:m=this._extension.identifier.value:m=this._id;let l;this._name?l=this._name:l=(0,k.localize)(0,null,this._extension.displayName||this._extension.name);let v=this._color;this._backgroundColor&&(v=A.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id));const _=this._tooltip?T.MarkdownString.fromStrict(this._tooltip):void 0;He(this,D,"f").$setEntry(this._entryId,m,l,this._text,_,this._command?.internal,v,this._backgroundColor,this._alignment===g.StatusBarAlignment.Left?0:1,this._priority,this._accessibilityInformation)},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=A,D=new WeakMap,y=new WeakMap,A.ID_GEN=0,A.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new g.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new g.ThemeColor("statusBarItem.warningForeground")]]);class i{constructor(m){this._messages=[],this._item=m.createStatusBarEntry(void 0,"status.extensionMessage",g.StatusBarAlignment.Left,Number.MIN_VALUE),this._item.name=(0,k.localize)(1,null)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(m){const l={message:m};return this._messages.unshift(l),this._update(),new g.Disposable(()=>{const v=this._messages.indexOf(l);v>=0&&(this._messages.splice(v,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class C{constructor(m,l){this._proxy=m.getProxy(R.MainContext.MainThreadStatusBar),this._commands=l,this._statusMessage=new i(this)}createStatusBarEntry(m,l,v,_){return new A(this._proxy,this._commands,m,l,v,_)}setStatusBarMessage(m,l){const v=this._statusMessage.setMessage(m);let _;return typeof l=="number"?_=setTimeout(()=>v.dispose(),l):typeof l!="undefined"&&l.then(()=>v.dispose(),()=>v.dispose()),new g.Disposable(()=>{v.dispose(),clearTimeout(_)})}}e.ExtHostStatusBar=C}),define(me[93],ge([0,1,5,3,4]),function(J,e,g,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class S{constructor(D){this._onDidChangeStorage=new R.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=D.getProxy(g.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(D,y){this._proxy.$registerExtensionStorageKeysToSync(D,y)}getValue(D,y,A){return this._proxy.$getValue(D,y).then(i=>i||A)}setValue(D,y,A){return this._proxy.$setValue(D,y,A)}$acceptValue(D,y,A){this._onDidChangeStorage.fire({shared:D,key:y,value:A})}}e.ExtHostStorage=S,e.IExtHostStorage=(0,k.createDecorator)("IExtHostStorage")}),define(me[66],ge([0,1,4,27,12,92,2]),function(J,e,g,R,k,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,g.createDecorator)("IExtensionStoragePaths");let D=class{constructor(A,i,C){this._logService=i,this._extHostFileSystem=C,this._workspace=A.workspace??void 0,this._environment=A.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(u=>this._value=u)}async _getWorkspaceStorageURI(A){return T.URI.joinPath(this._environment.workspaceStorageHome,A)}async _getOrCreateWorkspaceStoragePath(){if(!this._workspace)return Promise.resolve(void 0);const A=this._workspace.id,i=await this._getWorkspaceStorageURI(A);try{return await this._extHostFileSystem.value.stat(i),this._logService.trace("[ExtHostStorage] storage dir already exists",i),i}catch{}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",i),await this._extHostFileSystem.value.createDirectory(i),await this._extHostFileSystem.value.writeFile(T.URI.joinPath(i,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:T.URI.revive(this._workspace.configuration)?.toString(),name:this._workspace.name},void 0,2))),i}catch(C){this._logService.error("[ExtHostStorage]",C);return}}workspaceValue(A){if(this._value)return T.URI.joinPath(this._value,A.identifier.value)}globalValue(A){return T.URI.joinPath(this._environment.globalStorageHome,A.identifier.value.toLowerCase())}onWillDeactivateAll(){}};D=Ve([$e(0,R.IExtHostInitDataService),$e(1,k.ILogService),$e(2,S.IExtHostConsumerFileSystem)],D),e.ExtensionStoragePaths=D}),define(me[33],ge([0,1,3,5,4,2,13,6,7,167,15,213,21,32,195,85,14]),function(J,e,g,R,k,S,T,D,y,A,i,C,u,m,l,v,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.EnvironmentVariableCollection=e.BaseExtHostTerminalService=e.ExtHostPseudoterminal=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,k.createDecorator)("IExtHostTerminalService");class b{constructor(n,a,d,f){this._proxy=n,this._id=a,this._creationOptions=d,this._name=f,this._disposed=!1,this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(E=>this._pidPromiseComplete=E);const w=this;this.value={get name(){return w._name||""},get processId(){return w._pidPromise},get creationOptions(){return w._creationOptions},get exitStatus(){return w._exitStatus},sendText(E,o=!0){w._checkDisposed(),w._proxy.$sendText(w._id,E,o)},show(E){w._checkDisposed(),w._proxy.$show(w._id,E)},hide(){w._checkDisposed(),w._proxy.$hide(w._id)},dispose(){w._disposed||(w._disposed=!0,w._proxy.$dispose(w._id))},get dimensions(){if(!(w._cols===void 0||w._rows===void 0))return{columns:w._cols,rows:w._rows}}}}async create(n,a){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:n.name,shellPath:(0,_.withNullAsUndefined)(n.shellPath),shellArgs:(0,_.withNullAsUndefined)(n.shellArgs),cwd:(0,_.withNullAsUndefined)(n.cwd),env:(0,_.withNullAsUndefined)(n.env),icon:(0,_.withNullAsUndefined)(r(n.iconPath)),color:v.ThemeColor.isThemeColor(n.color)?n.color.id:void 0,initialText:(0,_.withNullAsUndefined)(n.message),strictEnv:(0,_.withNullAsUndefined)(n.strictEnv),hideFromUser:(0,_.withNullAsUndefined)(n.hideFromUser),isFeatureTerminal:(0,_.withNullAsUndefined)(a?.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:(0,_.withNullAsUndefined)(a?.useShellEnvironment),isSplitTerminal:a?.isSplitTerminal,target:a?.target})}async createExtensionTerminal(n,a,d){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0,icon:d,isSplitTerminal:n,target:a}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(n){this._name=n}setExitCode(n){this._exitStatus=Object.freeze({code:n})}setDimensions(n,a){return n===this._cols&&a===this._rows||n===0||a===0?!1:(this._cols=n,this._rows=a,!0)}_setProcessId(n){this._pidPromiseComplete?(this._pidPromiseComplete(n),this._pidPromiseComplete=void 0):this._pidPromise.then(a=>{a!==n&&(this._pidPromise=Promise.resolve(n))})}}e.ExtHostTerminal=b;class P{constructor(n){this._pty=n,this.id=0,this.shouldPersist=!1,this._onProcessData=new g.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessExit=new g.Emitter,this.onProcessExit=this._onProcessExit.event,this._onProcessReady=new g.Emitter,this._onProcessTitleChanged=new g.Emitter,this.onProcessTitleChanged=this._onProcessTitleChanged.event,this._onProcessOverrideDimensions=new g.Emitter,this._onProcessShellTypeChanged=new g.Emitter,this.onProcessShellTypeChanged=this._onProcessShellTypeChanged.event}get onProcessReady(){return this._onProcessReady.event}get onProcessOverrideDimensions(){return this._onProcessOverrideDimensions.event}async start(){}shutdown(){this._pty.close()}input(n){this._pty.handleInput&&this._pty.handleInput(n)}resize(n,a){this._pty.setDimensions&&this._pty.setDimensions({columns:n,rows:a})}async processBinary(n){}acknowledgeDataEvent(n){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(n){this._pty.onDidWrite(a=>this._onProcessData.fire(a)),this._pty.onDidClose&&this._pty.onDidClose((a=void 0)=>{this._onProcessExit.fire(a===void 0?void 0:a)}),this._pty.onDidOverrideDimensions&&this._pty.onDidOverrideDimensions(a=>this._onProcessOverrideDimensions.fire(a&&{cols:a.columns,rows:a.rows})),this._pty.onDidChangeName&&this._pty.onDidChangeName(a=>this._onProcessTitleChanged.fire(a)),this._pty.open(n||void 0),this._pty.setDimensions&&n&&this._pty.setDimensions(n),this._onProcessReady.fire({pid:-1,cwd:""})}}e.ExtHostPseudoterminal=P;let c=1,h=class extends D.Disposable{constructor(n,a){super();this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._profileProviders=new Map,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new g.Emitter,this._onDidOpenTerminal=new g.Emitter,this._onDidChangeActiveTerminal=new g.Emitter,this._onDidChangeTerminalDimensions=new g.Emitter,this._proxy=a.getProxy(R.MainContext.MainThreadTerminalService),this._bufferer=new l.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new g.Emitter({onFirstListenerAdd:()=>this._proxy.$startSendingDataEvents(),onLastListenerRemove:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(n),this._register({dispose:()=>{for(const[d,f]of this._terminalProcesses)f.shutdown(!0)}})}get activeTerminal(){return this._activeTerminal?.value}get terminals(){return this._terminals.map(n=>n.value)}get onDidCloseTerminal(){return this._onDidCloseTerminal&&this._onDidCloseTerminal.event}get onDidOpenTerminal(){return this._onDidOpenTerminal&&this._onDidOpenTerminal.event}get onDidChangeActiveTerminal(){return this._onDidChangeActiveTerminal&&this._onDidChangeActiveTerminal.event}get onDidChangeTerminalDimensions(){return this._onDidChangeTerminalDimensions&&this._onDidChangeTerminalDimensions.event}get onDidWriteTerminalData(){return this._onDidWriteTerminalData&&this._onDidWriteTerminalData.event}getDefaultShell(n){return(n?this._defaultAutomationProfile:this._defaultProfile)?.path||""}getDefaultShellArgs(n){return(n?this._defaultAutomationProfile:this._defaultProfile)?.args||[]}createExtensionTerminal(n,a){const d=new b(this._proxy,(0,m.generateUuid)(),n,n.name),f=new P(n.pty);return d.createExtensionTerminal(a?.isSplitTerminal,a?.target,r(n.iconPath)).then(w=>{const E=this._setupExtHostProcessListeners(w,f);this._terminalProcessDisposables[w]=E}),this._terminals.push(d),d.value}attachPtyToTerminal(n,a){if(!this._getTerminalById(n))throw new Error(`Cannot resolve terminal with id ${n} for virtual process`);const f=new P(a),w=this._setupExtHostProcessListeners(n,f);this._terminalProcessDisposables[n]=w}async $acceptActiveTerminalChanged(n){const a=this._activeTerminal;if(n===null){this._activeTerminal=void 0,a!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const d=this._getTerminalById(n);d&&(this._activeTerminal=d,a!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(n,a){const d=this._getTerminalById(n);d&&this._onDidWriteTerminalData.fire({terminal:d.value,data:a})}async $acceptTerminalDimensions(n,a,d){const f=this._getTerminalById(n);f&&f.setDimensions(a,d)&&this._onDidChangeTerminalDimensions.fire({terminal:f.value,dimensions:f.value.dimensions})}async $acceptTerminalMaximumDimensions(n,a,d){this._terminalProcesses.get(n)?.resize(a,d)}async $acceptTerminalTitleChange(n,a){const d=this._getTerminalById(n);d&&(d.name=a)}async $acceptTerminalClosed(n,a){const d=this._getTerminalObjectIndexById(this._terminals,n);if(d!==null){const f=this._terminals.splice(d,1)[0];f.setExitCode(a),this._onDidCloseTerminal.fire(f.value)}}$acceptTerminalOpened(n,a,d,f){if(a){const o=this._getTerminalObjectIndexById(this._terminals,a);if(o!==null){this._terminals[o]._id=n,this._onDidOpenTerminal.fire(this.terminals[o]),this._terminals[o].isOpen=!0;return}}const w={name:f.name,shellPath:f.executable,shellArgs:f.args,cwd:typeof f.cwd=="string"?f.cwd:S.URI.revive(f.cwd),env:f.env,hideFromUser:f.hideFromUser},E=new b(this._proxy,n,w,d);this._terminals.push(E),this._onDidOpenTerminal.fire(E.value),E.isOpen=!0}async $acceptTerminalProcessId(n,a){const d=this._getTerminalById(n);d&&d._setProcessId(a)}async $startExtensionTerminal(n,a){const d=this._getTerminalById(n);if(!d)return{message:(0,A.localize)(0,null,n)};d.isOpen||await new Promise(w=>{const E=this.onDidOpenTerminal(async o=>{o===d.value&&(E.dispose(),w())})});const f=this._terminalProcesses.get(n);f?f.startSendingEvents(a):this._extensionTerminalAwaitingStart[n]={initialDimensions:a}}_setupExtHostProcessListeners(n,a){const d=new D.DisposableStore;d.add(a.onProcessReady(w=>this._proxy.$sendProcessReady(n,w.pid,w.cwd))),d.add(a.onProcessTitleChanged(w=>this._proxy.$sendProcessTitle(n,w))),this._bufferer.startBuffering(n,a.onProcessData),d.add(a.onProcessExit(w=>this._onProcessExit(n,w))),a.onProcessOverrideDimensions&&d.add(a.onProcessOverrideDimensions(w=>this._proxy.$sendOverrideDimensions(n,w))),this._terminalProcesses.set(n,a);const f=this._extensionTerminalAwaitingStart[n];return f&&a instanceof P&&(a.startSendingEvents(f.initialDimensions),delete this._extensionTerminalAwaitingStart[n]),d}$acceptProcessAckDataEvent(n,a){this._terminalProcesses.get(n)?.acknowledgeDataEvent(a)}$acceptProcessInput(n,a){this._terminalProcesses.get(n)?.input(a)}$acceptProcessResize(n,a,d){try{this._terminalProcesses.get(n)?.resize(a,d)}catch(f){if(f.code!=="EPIPE"&&f.code!=="ERR_IPC_CHANNEL_CLOSED")throw f}}$acceptProcessShutdown(n,a){this._terminalProcesses.get(n)?.shutdown(a)}$acceptProcessRequestInitialCwd(n){this._terminalProcesses.get(n)?.getInitialCwd().then(a=>this._proxy.$sendProcessInitialCwd(n,a))}$acceptProcessRequestCwd(n){this._terminalProcesses.get(n)?.getCwd().then(a=>this._proxy.$sendProcessCwd(n,a))}$acceptProcessRequestLatency(n){return n}registerLinkProvider(n){return this._linkProviders.add(n),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new y.Disposable(()=>{this._linkProviders.delete(n),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}registerProfileProvider(n,a,d){if(this._profileProviders.has(a))throw new Error(`Terminal profile provider "${a}" already registered`);return this._profileProviders.set(a,d),this._proxy.$registerProfileProvider(a,n.identifier.value),new y.Disposable(()=>{this._profileProviders.delete(a),this._proxy.$unregisterProfileProvider(a)})}async $createContributedProfileTerminal(n,a){const d=new u.CancellationTokenSource().token,f=await this._profileProviders.get(n)?.provideTerminalProfile(d);if(!d.isCancellationRequested){if(!f||!("options"in f))throw new Error(`No terminal profile options provided for id "${n}"`);if("pty"in f.options){this.createExtensionTerminal(f.options,a);return}this.createTerminalFromOptions(f.options,a)}}async $provideLinks(n,a){const d=this._getTerminalById(n);if(!d)return[];this._terminalLinkCache.delete(n);const f=this._terminalLinkCancellationSource.get(n);f&&f.dispose(!0);const w=new u.CancellationTokenSource;this._terminalLinkCancellationSource.set(n,w);const E=[],o={terminal:d.value,line:a},I=[];for(const V of this._linkProviders)I.push(new Promise(async ee=>{w.token.onCancellationRequested(()=>ee({provider:V,links:[]}));const K=await V.provideTerminalLinks(o,w.token)||[];w.token.isCancellationRequested||ee({provider:V,links:K})}));const L=await Promise.all(I);if(w.token.isCancellationRequested)return[];const U=new Map;for(const V of L)V&&V.links.length>0&&E.push(...V.links.map(ee=>{const K={id:c++,startIndex:ee.startIndex,length:ee.length,label:ee.tooltip};return U.set(K.id,{provider:V.provider,link:ee}),K}));return this._terminalLinkCache.set(n,U),E}$activateLink(n,a){const d=this._terminalLinkCache.get(n)?.get(a);!d||d.provider.handleTerminalLink(d.link)}_onProcessExit(n,a){this._bufferer.stopBuffering(n),this._terminalProcesses.delete(n),delete this._extensionTerminalAwaitingStart[n];const d=this._terminalProcessDisposables[n];d&&(d.dispose(),delete this._terminalProcessDisposables[n]),this._proxy.$sendProcessExit(n,a)}_getTerminalById(n){return this._getTerminalObjectById(this._terminals,n)}_getTerminalObjectById(n,a){const d=this._getTerminalObjectIndexById(n,a);return d!==null?n[d]:null}_getTerminalObjectIndexById(n,a){let d=null;return n.some((f,w)=>f._id===a?(d=w,!0):!1),d}getEnvironmentVariableCollection(n){let a=this._environmentVariableCollections.get(n.identifier.value);return a||(a=new p,this._setEnvironmentVariableCollection(n.identifier.value,a)),a}_syncEnvironmentVariableCollection(n,a){const d=(0,C.serializeEnvironmentVariableCollection)(a.map);this._proxy.$setEnvironmentVariableCollection(n,a.persistent,d.length===0?void 0:d)}$initEnvironmentVariableCollections(n){n.forEach(a=>{const d=a[0],f=new p(a[1]);this._setEnvironmentVariableCollection(d,f)})}$acceptDefaultProfile(n,a){this._defaultProfile=n,this._defaultAutomationProfile=a}_setEnvironmentVariableCollection(n,a){this._environmentVariableCollections.set(n,a),a.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(n,a)})}};h=Ve([$e(1,T.IExtHostRpcService)],h),e.BaseExtHostTerminalService=h;class p{constructor(n){this.map=new Map,this._persistent=!0,this._onDidChangeCollection=new g.Emitter,this.map=new Map(n)}get persistent(){return this._persistent}set persistent(n){this._persistent=n,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}get size(){return this.map.size}replace(n,a){this._setIfDiffers(n,{value:a,type:y.EnvironmentVariableMutatorType.Replace})}append(n,a){this._setIfDiffers(n,{value:a,type:y.EnvironmentVariableMutatorType.Append})}prepend(n,a){this._setIfDiffers(n,{value:a,type:y.EnvironmentVariableMutatorType.Prepend})}_setIfDiffers(n,a){const d=this.map.get(n);(!d||d.value!==a.value||d.type!==a.type)&&(this.map.set(n,a),this._onDidChangeCollection.fire())}get(n){return this.map.get(n)}forEach(n,a){this.map.forEach((d,f)=>n.call(a,f,d,this))}delete(n){this.map.delete(n),this._onDidChangeCollection.fire()}clear(){this.map.clear(),this._onDidChangeCollection.fire()}}e.EnvironmentVariableCollection=p;let t=class extends h{constructor(n){super(!1,n)}createTerminal(n,a,d){throw new i.NotSupportedError}createTerminalFromOptions(n,a){throw new i.NotSupportedError}};t=Ve([$e(0,T.IExtHostRpcService)],t),e.WorkerExtHostTerminalService=t;function r(s){if(!(!s||typeof s=="string"))return"id"in s?{id:s.id,color:s.color}:s}});var it=this&&this.__classPrivateFieldSet||function(J,e,g,R,k){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!k:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?k.call(J,g):k?k.value=g:e.set(J,g),g},He=this&&this.__classPrivateFieldGet||function(J,e,g,R){if(g==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!R:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?R:g==="a"?R.call(J):R?R.value:e.get(J)};define(me[250],ge([0,1,24,21,3,72,58,74,6,25,14,32,5,13,87,17,7,221,126,90]),function(J,e,g,R,k,S,T,D,y,A,i,C,u,m,l,v,_,b,P,c){"use strict";var h;Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.MirroredTestCollection=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let p=class{constructor(L,U){this.resultsChangedEmitter=new k.Emitter,this.controllers=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=L.getProxy(u.MainContext.MainThreadTesting),this.observer=new w(this.proxy),this.runTracker=new r(this.proxy),U.registerArgumentProcessor({processArgument:V=>V?.$mid===13?v.TestItem.toItemFromContext(V):V})}createTestController(L,U){if(this.controllers.has(L))throw new Error(`Attempt to insert a duplicate controller with ID "${L}"`);const V=new y.DisposableStore,ee=V.add(new b.SingleUseTestCollection(L));ee.root.label=U;const K=new Map,N=this.proxy,x={items:ee.root.children,get label(){return U},set label(z){U=z,ee.root.label=z,N.$updateControllerLabel(L,U)},get id(){return L},createRunProfile:(z,M,O,q)=>{let B=(0,T.hash)(z);for(;K.has(B);)B++;const G=new E(this.proxy,L,B,z,M,O,q);return K.set(B,G),G},createTestItem(z,M,O){return new l.TestItemImpl(L,z,M,O)},createTestRun:(z,M,O=!0)=>this.runTracker.createTestRun(L,ee,z,M,O),set resolveHandler(z){ee.resolveHandler=z},get resolveHandler(){return ee.resolveHandler},dispose:()=>{V.dispose()}};x.createRunConfiguration=x.createRunProfile,N.$registerTestController(L,U),V.add((0,y.toDisposable)(()=>N.$unregisterTestController(L)));const F={controller:x,collection:ee,profiles:K};return this.controllers.set(L,F),V.add((0,y.toDisposable)(()=>this.controllers.delete(L))),V.add(ee.onDidGenerateDiff(z=>N.$publishDiff(L,z))),x}createTestObserver(){return this.observer.checkout()}async runTests(L,U=R.CancellationToken.None){const V=s(L);if(!V)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const ee=this.controllers.get(V.controllerId);if(!ee)throw new Error("Controller not found");await this.proxy.$runTests({targets:[{testIds:L.include?.map(K=>K.id)??[ee.collection.root.id],profileGroup:o[V.kind],profileId:V.profileId,controllerId:V.controllerId}],exclude:L.exclude?.map(K=>({testId:K.id,controllerId:V.controllerId}))},U)}$provideFileCoverage(L,U,V){return D.Iterable.find(this.runTracker.trackers,ee=>ee.id===L)?.getCoverage(U)?.provideFileCoverage(V)??Promise.resolve([])}$resolveFileCoverage(L,U,V,ee){return D.Iterable.find(this.runTracker.trackers,K=>K.id===L)?.getCoverage(U)?.resolveFileCoverage(V,ee)??Promise.resolve([])}$configureRunProfile(L,U){this.controllers.get(L)?.profiles.get(U)?.configureHandler?.()}$publishTestResults(L){this.results=Object.freeze(L.map(U=>(0,A.deepFreeze)(v.TestResults.to(U))).concat(this.results).sort((U,V)=>V.completedAt-U.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $expandTest({controllerId:L,testId:U},V){const ee=this.controllers.get(L)?.collection;ee&&(await ee.expand(U,V<0?Infinity:V),ee.flushDiff())}$acceptDiff(L){this.observer.applyDiff(L)}async $runControllerTests(L,U){const V=this.controllers.get(L.controllerId);if(!V)return;const{collection:ee,profiles:K}=V,N=K.get(L.profileId);if(!N)return;const x=L.testIds.map(O=>ee.tree.get(O)).filter(i.isDefined),F=L.excludeExtIds.map(O=>V.collection.tree.get(O)).filter(i.isDefined).filter(O=>x.some(q=>q.fullId.compare(O.fullId)===2));if(!x.length)return;const z=new _.TestRunRequest(x.some(O=>O.actual instanceof l.TestItemRootImpl)?void 0:x.map(O=>O.actual),F.map(O=>O.actual),N),M=this.runTracker.prepareForMainThreadTestRun(z,n.fromInternal(L,V.collection),U);try{await N.runHandler(z,U)}finally{M.isRunning&&!U.isCancellationRequested&&await k.Event.toPromise(M.onEnd),this.runTracker.cancelRunById(L.runId)}}$cancelExtensionTestRun(L){L===void 0?this.runTracker.cancelAllRuns():this.runTracker.cancelRunById(L)}};p=Ve([$e(0,m.IExtHostRpcService)],p),e.ExtHostTesting=p;class t extends y.Disposable{constructor(L,U,V){super();this.dto=L,this.proxy=U,this.tasks=new Map,this.sharedTestIds=new Set,this.endEmitter=this._register(new k.Emitter),this.disposed=!1,this.onEnd=this.endEmitter.event,this.cts=this._register(new R.CancellationTokenSource(V)),this._register(this.cts.token.onCancellationRequested(()=>{for(const{run:ee}of this.tasks.values())ee.end()}))}get isRunning(){return this.tasks.size>0}get id(){return this.dto.id}getCoverage(L){return this.tasks.get(L)?.coverage}createRun(L){const U=this.dto.id,V=this.dto.controllerId,ee=(0,C.generateUuid)(),K=new a(this.proxy,U,ee),N=z=>(M,...O)=>{if(x){console.warn(`Setting the state of test "${M.id}" is a no-op after the run ends.`);return}!this.dto.isIncluded(M)||(this.ensureTestIsKnown(M),z(M,...O))};let x=!1;const F={isPersisted:this.dto.isPersisted,token:this.cts.token,name:L,get coverageProvider(){return K.coverageProvider},set coverageProvider(z){K.coverageProvider=z},enqueued:N(z=>{this.proxy.$updateTestStateInRun(U,ee,c.TestId.fromExtHostTestItem(z,V).toString(),1)}),skipped:N(z=>{this.proxy.$updateTestStateInRun(U,ee,c.TestId.fromExtHostTestItem(z,V).toString(),5)}),started:N(z=>{this.proxy.$updateTestStateInRun(U,ee,c.TestId.fromExtHostTestItem(z,V).toString(),2)}),errored:N((z,M,O)=>{this.proxy.$appendTestMessagesInRun(U,ee,c.TestId.fromExtHostTestItem(z,V).toString(),M instanceof Array?M.map(v.TestMessage.from):[v.TestMessage.from(M)]),this.proxy.$updateTestStateInRun(U,ee,c.TestId.fromExtHostTestItem(z,V).toString(),6,O)}),failed:N((z,M,O)=>{this.proxy.$appendTestMessagesInRun(U,ee,c.TestId.fromExtHostTestItem(z,V).toString(),M instanceof Array?M.map(v.TestMessage.from):[v.TestMessage.from(M)]),this.proxy.$updateTestStateInRun(U,ee,c.TestId.fromExtHostTestItem(z,V).toString(),4,O)}),passed:N((z,M)=>{this.proxy.$updateTestStateInRun(U,ee,c.TestId.fromExtHostTestItem(z,this.dto.controllerId).toString(),3,M)}),appendOutput:z=>{x||this.proxy.$appendOutputToRun(U,ee,g.VSBuffer.fromString(z))},end:()=>{x||(x=!0,this.proxy.$finishedTestRunTask(U,ee),this.tasks.delete(ee),this.isRunning||this.dispose())}};return this.tasks.set(ee,{run:F,coverage:K}),this.proxy.$startedTestRunTask(U,{id:ee,name:L,running:!0}),F}dispose(){this.disposed||(this.disposed=!0,this.endEmitter.fire(),this.cts.cancel(),super.dispose())}ensureTestIsKnown(L){if(!(L instanceof l.TestItemImpl))throw new l.InvalidTestItemError(L.id);if(this.sharedTestIds.has(L.id))return;const U=[];for(;U.unshift(v.TestItem.from(L)),!(this.sharedTestIds.has(L.id)||(this.sharedTestIds.add(L.id),!L.parent));)L=L.parent;const V=this.dto.colllection.root;this.sharedTestIds.has(V.id)||(this.sharedTestIds.add(V.id),U.unshift(v.TestItem.from(V))),this.proxy.$addTestsToRun(this.dto.controllerId,this.dto.id,U)}}class r{constructor(L){this.proxy=L,this.tracked=new Map}get trackers(){return this.tracked.values()}prepareForMainThreadTestRun(L,U,V){return this.getTracker(L,U,V)}cancelRunById(L){for(const U of this.tracked.values())if(U.id===L){U.dispose();return}}cancelAllRuns(){for(const L of this.tracked.values())L.dispose()}createTestRun(L,U,V,ee,K){const N=this.tracked.get(V);if(N)return N.createRun(ee);const x=n.fromPublic(L,U,V,K),F=s(V);this.proxy.$startedExtensionTestRun({controllerId:L,profile:F&&{group:o[F.kind],id:F.profileId},exclude:V.exclude?.map(M=>M.id)??[],id:x.id,include:V.include?.map(M=>M.id)??[U.root.id],persist:K});const z=this.getTracker(V,x);return z.onEnd(()=>this.proxy.$finishedExtensionTestRun(x.id)),z.createRun(ee)}getTracker(L,U,V){const ee=new t(U,this.proxy,V);return this.tracked.set(L,ee),ee.onEnd(()=>this.tracked.delete(L)),ee}}e.TestRunCoordinator=r;const s=I=>{if(!!I.profile){if(!(I.profile instanceof E))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return I.profile}};class n{constructor(L,U,V,ee,K,N){this.controllerId=L,this.id=U,this.isPersisted=K,this.colllection=N,this.includePrefix=V.map(x=>x+"\0"),this.excludePrefix=ee.map(x=>x+"\0")}static fromPublic(L,U,V,ee){return new n(L,(0,C.generateUuid)(),V.include?.map(K=>c.TestId.fromExtHostTestItem(K,L).toString())??[L],V.exclude?.map(K=>c.TestId.fromExtHostTestItem(K,L).toString())??[],ee,U)}static fromInternal(L,U){return new n(L.controllerId,L.runId,L.testIds,L.excludeExtIds,!0,U)}isIncluded(L){const U=c.TestId.fromExtHostTestItem(L,this.controllerId).toString()+"\0";for(const V of this.excludePrefix)if(U===V||U.startsWith(V))return!1;for(const V of this.includePrefix)if(U===V||U.startsWith(V))return!0;return!1}}e.TestRunDto=n;class a{constructor(L,U,V){this.proxy=L,this.runId=U,this.taskId=V}set coverageProvider(L){if(this._coverageProvider)throw new Error("The TestCoverageProvider cannot be replaced after being provided");!L||(this._coverageProvider=L,this.proxy.$signalCoverageAvailable(this.runId,this.taskId))}get coverageProvider(){return this._coverageProvider}async provideFileCoverage(L){if(!this._coverageProvider)return[];this.fileCoverage||(this.fileCoverage=(async()=>this._coverageProvider.provideFileCoverage(L))());try{return(await this.fileCoverage)?.map(v.TestCoverage.fromFile)??[]}catch(U){throw this.fileCoverage=void 0,U}}async resolveFileCoverage(L,U){const V=await this.fileCoverage;let ee=V?.[L];return!this._coverageProvider||!V||!ee?[]:(ee.detailedCoverage||(ee=V[L]=await this._coverageProvider.resolveFileCoverage?.(ee,U)??ee),ee.detailedCoverage?.map(v.TestCoverage.fromDetailed)??[])}}class d extends P.IncrementalChangeCollector{constructor(L){super();this.emitter=L,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}add(L){this.added.add(L)}update(L){Object.assign(L.revived,v.TestItem.toPlain(L.item)),this.added.has(L)||this.updated.add(L)}remove(L){if(this.added.has(L)){this.added.delete(L);return}if(this.updated.delete(L),L.parent&&this.alreadyRemoved.has(L.parent)){this.alreadyRemoved.add(L.item.extId);return}this.removed.add(L)}getChangeEvent(){const{added:L,updated:U,removed:V}=this;return{get added(){return[...L].map(ee=>ee.revived)},get updated(){return[...U].map(ee=>ee.revived)},get removed(){return[...V].map(ee=>ee.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class f extends P.AbstractIncrementalTestCollection{constructor(){super(...arguments);this.changeEmitter=new k.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTests(){return super.roots}getMirroredTestDataById(L){return this.items.get(L)}getMirroredTestDataByReference(L){return this.items.get(L.id)}createItem(L,U){return{...L,revived:v.TestItem.toPlain(L.item),depth:U?U.depth+1:0,children:new Set}}createChangeCollector(){return new d(this.changeEmitter)}}e.MirroredTestCollection=f;class w{constructor(L){this.proxy=L}checkout(){this.current||(this.current=this.createObserverData());const L=this.current;return L.observers++,{onDidChangeTest:L.tests.onDidChangeTests,get tests(){return[...L.tests.rootTests].map(U=>U.revived)},dispose:(0,S.once)(()=>{--L.observers==0&&(this.proxy.$unsubscribeFromDiffs(),this.current=void 0)})}}getMirroredTestDataByReference(L){return this.current?.tests.getMirroredTestDataByReference(L)}applyDiff(L){this.current?.tests.apply(L)}createObserverData(){const L=new f;return this.proxy.$subscribeToDiffs(),{observers:0,tests:L}}}class E{constructor(L,U,V,ee,K,N,x=!1){this.controllerId=U,this.profileId=V,this._label=ee,this.kind=K,this.runHandler=N,this._isDefault=x,h.set(this,void 0),it(this,h,L,"f");const F=o[K];if(typeof F!="number")throw new Error(`Unknown TestRunProfile.group ${K}`);He(this,h,"f").$publishTestRunProfile({profileId:V,controllerId:U,label:ee,group:F,isDefault:x,hasConfigurationHandler:!1})}get label(){return this._label}set label(L){L!==this._label&&(this._label=L,He(this,h,"f").$updateTestRunConfig(this.controllerId,this.profileId,{label:L}))}get isDefault(){return this._isDefault}set isDefault(L){L!==this._isDefault&&(this._isDefault=L,He(this,h,"f").$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:L}))}get configureHandler(){return this._configureHandler}set configureHandler(L){L!==this._configureHandler&&(this._configureHandler=L,He(this,h,"f").$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!L}))}dispose(){He(this,h,"f").$removeTestProfile(this.controllerId,this.profileId)}}e.TestRunProfileImpl=E,h=new WeakMap;const o={[_.TestRunProfileKind.Coverage]:8,[_.TestRunProfileKind.Debug]:4,[_.TestRunProfileKind.Run]:2}}),define(me[251],ge([0,1,3,20,5,129,17,7]),function(J,e,g,R,k,S,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class y{constructor(i,C){this._extHostDocumentsAndEditors=C,this._onDidChangeTextEditorSelection=new g.Emitter,this._onDidChangeTextEditorOptions=new g.Emitter,this._onDidChangeTextEditorVisibleRanges=new g.Emitter,this._onDidChangeTextEditorViewColumn=new g.Emitter,this._onDidChangeActiveTextEditor=new g.Emitter,this._onDidChangeVisibleTextEditors=new g.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=i.getProxy(k.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(u=>this._onDidChangeVisibleTextEditors.fire(u)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(u=>this._onDidChangeActiveTextEditor.fire(u))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(i){const C=this._extHostDocumentsAndEditors.allEditors();return i?C:C.map(u=>u.value)}async showTextDocument(i,C,u){let m;typeof C=="number"?m={position:T.ViewColumn.from(C),preserveFocus:u}:typeof C=="object"?m={position:T.ViewColumn.from(C.viewColumn),preserveFocus:C.preserveFocus,selection:typeof C.selection=="object"?T.Range.from(C.selection):void 0,pinned:typeof C.preview=="boolean"?!C.preview:void 0}:m={preserveFocus:!1};const l=await this._proxy.$tryShowTextDocument(i.uri,m),v=l&&this._extHostDocumentsAndEditors.getEditor(l);if(v)return v.value;throw l?new Error(`Could NOT open editor for "${i.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${i.uri.toString()}".`)}createTextEditorDecorationType(i,C){return new S.TextEditorDecorationType(this._proxy,i,C).value}$acceptEditorPropertiesChanged(i,C){const u=this._extHostDocumentsAndEditors.getEditor(i);if(!u)throw new Error("unknown text editor");if(C.options&&u._acceptOptions(C.options),C.selections){const m=C.selections.selections.map(T.Selection.to);u._acceptSelections(m)}if(C.visibleRanges){const m=R.coalesce(C.visibleRanges.map(T.Range.to));u._acceptVisibleRanges(m)}if(C.options&&this._onDidChangeTextEditorOptions.fire({textEditor:u.value,options:{...C.options,lineNumbers:T.TextEditorLineNumbersStyle.to(C.options.lineNumbers)}}),C.selections){const m=D.TextEditorSelectionChangeKind.fromValue(C.selections.source),l=C.selections.selections.map(T.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:u.value,selections:l,kind:m})}if(C.visibleRanges){const m=R.coalesce(C.visibleRanges.map(T.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:u.value,visibleRanges:m})}}$acceptEditorPositionData(i){for(const C in i){const u=this._extHostDocumentsAndEditors.getEditor(C);if(!u)throw new Error("Unknown text editor");const m=T.ViewColumn.to(i[C]);u.value.viewColumn!==m&&(u._acceptViewColumn(m),this._onDidChangeTextEditorViewColumn.fire({textEditor:u.value,viewColumn:m}))}}getDiffInformation(i){return Promise.resolve(this._proxy.$getDiffInformation(i))}}e.ExtHostEditors=y}),define(me[252],ge([0,1,2,4,5,6,7]),function(J,e,g,R,k,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,R.createDecorator)("IExtHostTimeline");class D{constructor(i,C){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=i.getProxy(k.MainContext.MainThreadTimeline),C.registerArgumentProcessor({processArgument:u=>{if(u&&u.$mid===11){const m=u.uri===void 0?void 0:g.URI.revive(u.uri);return this._itemsBySourceAndUriMap.get(u.source)?.get(y(m))?.get(u.handle)}return u}})}async $getTimeline(i,C,u,m,l){return this._providers.get(i)?.provideTimeline(g.URI.revive(C),u,m,l)}registerTimelineProvider(i,C,u,m){const l=new S.DisposableStore,v=this.convertTimelineItem(C.id,m,l).bind(this);let _;C.onDidChange&&(_=C.onDidChange(P=>this._proxy.$emitTimelineChangeEvent({uri:void 0,reset:!0,...P,id:C.id}),this));const b=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore({...C,scheme:i,onDidChange:void 0,async provideTimeline(P,c,h,p){p?.resetCache&&(l.clear(),b.get(C.id)?.clear());const t=await C.provideTimeline(P,c,h);if(t==null)return;const r=v(P,p);return{...t,source:C.id,items:t.items.map(r)}},dispose(){for(const P of b.values())P.get(C.id)?.clear();_?.dispose(),l.dispose()}})}convertTimelineItem(i,C,u){return(m,l)=>{let v;if(l?.cacheResults){let _=this._itemsBySourceAndUriMap.get(i);_===void 0&&(_=new Map,this._itemsBySourceAndUriMap.set(i,_));const b=y(m);v=_.get(b),v===void 0&&(v=new Map,_.set(b,v))}return _=>{const{iconPath:b,...P}=_,c=`${i}|${_.id??_.timestamp}`;v?.set(c,_);let h,p,t;return _.iconPath&&(b instanceof T.ThemeIcon?t={id:b.id,color:b.color}:g.URI.isUri(b)?(h=b,p=b):{light:h,dark:p}=b),{...P,id:P.id??void 0,handle:c,source:i,command:_.command?C.toInternal(_.command,u):void 0,icon:h,iconDark:p,themeIcon:t,accessibilityInformation:_.accessibilityInformation}}}}registerTimelineProviderCore(i){if(this._providers.get(i.id))throw new Error(`Timeline Provider ${i.id} already exists.`);return this._proxy.$registerTimelineProvider({id:i.id,label:i.label,scheme:i.scheme}),this._providers.set(i.id,i),(0,S.toDisposable)(()=>{for(const u of this._itemsBySourceAndUriMap.values())u.get(i.id)?.clear();this._providers.delete(i.id),this._proxy.$unregisterTimelineProvider(i.id),i.dispose()})}}e.ExtHostTimeline=D;function y(A){return A?.toString()}}),define(me[253],ge([0,1,6,10,2,5]),function(J,e,g,R,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class T{constructor(y){this._openers=new Map,this._proxy=y.getProxy(S.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(y,A,i,C){if(this._openers.has(A))throw new Error(`Opener with id '${A}' already registered`);const u=C.schemes.find(m=>!T.supportedSchemes.has(m));if(u)throw new Error(`Scheme '${u}' is not supported. Only http and https are currently supported.`);return this._openers.set(A,i),this._proxy.$registerUriOpener(A,C.schemes,y,C.label),(0,g.toDisposable)(()=>{this._openers.delete(A),this._proxy.$unregisterUriOpener(A)})}async $canOpenUri(y,A,i){const C=this._openers.get(y);if(!C)throw new Error(`Unknown opener with id: ${y}`);const u=k.URI.revive(A);return C.canOpenExternalUri(u,i)}async $openUri(y,A,i){const C=this._openers.get(y);if(!C)throw new Error(`Unknown opener id: '${y}'`);return C.openExternalUri(k.URI.revive(A.resolvedUri),{sourceUri:k.URI.revive(A.sourceUri)},i)}}e.ExtHostUriOpeners=T,T.supportedSchemes=new Set([R.Schemas.http,R.Schemas.https])}),define(me[254],ge([0,1,5,2,6,15,26]),function(J,e,g,R,k,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class D{constructor(A){this.handles=new Set,this.handlers=new Map,this._proxy=A.getProxy(g.MainContext.MainThreadUrls)}registerUriHandler(A,i){if(this.handles.has(T.ExtensionIdentifier.toKey(A)))throw new Error(`Protocol handler already registered for extension ${A}`);const C=D.HandlePool++;return this.handles.add(T.ExtensionIdentifier.toKey(A)),this.handlers.set(C,i),this._proxy.$registerUriHandler(C,A),(0,k.toDisposable)(()=>{this.handles.delete(T.ExtensionIdentifier.toKey(A)),this.handlers.delete(C),this._proxy.$unregisterUriHandler(C)})}$handleExternalUri(A,i){const C=this.handlers.get(A);if(!C)return Promise.resolve(void 0);try{C.handleUri(R.URI.revive(i))}catch(u){(0,S.onUnexpectedError)(u)}return Promise.resolve(void 0)}async createAppUri(A){return R.URI.revive(await this._proxy.$createAppUri(A))}}e.ExtHostUrls=D,D.HandlePool=0});var it=this&&this.__classPrivateFieldSet||function(J,e,g,R,k){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!k:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?k.call(J,g):k?k.value=g:e.set(J,g),g},He=this&&this.__classPrivateFieldGet||function(J,e,g,R){if(g==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!R:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?R:g==="a"?R.call(J):R?R.value:e.get(J)};define(me[67],ge([0,1,3,2,179,204,88,5]),function(J,e,g,R,k,S,T,D){"use strict";var y,A,i,C,u,m,l,v,_,b,P,c;Object.defineProperty(e,"__esModule",{value:!0}),e.reviveOptions=e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class h{constructor(f,w,E,o,I,L,U){y.set(this,void 0),A.set(this,void 0),i.set(this,void 0),C.set(this,void 0),u.set(this,void 0),m.set(this,void 0),l.set(this,""),v.set(this,void 0),_.set(this,!1),b.set(this,!1),P.set(this,!1),this._onMessageEmitter=new g.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,c.set(this,new g.Emitter),this._onDidDispose=He(this,c,"f").event,it(this,y,f,"f"),it(this,A,w,"f"),it(this,v,E,"f"),it(this,C,o,"f"),it(this,u,I,"f"),it(this,m,L,"f"),it(this,P,p(L),"f"),it(this,i,U,"f")}dispose(){it(this,_,!0,"f"),He(this,c,"f").fire(),He(this,c,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(f){return it(this,b,!0,"f"),(0,T.asWebviewUri)(f,He(this,C,"f").remote)}get cspSource(){return T.webviewGenericCspSource}get html(){return this.assertNotDisposed(),He(this,l,"f")}set html(f){this.assertNotDisposed(),He(this,l,"f")!==f&&(it(this,l,f,"f"),!He(this,b,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(f)&&(it(this,b,!0,"f"),He(this,i,"f").report("Webview vscode-resource: uris",He(this,m,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),He(this,A,"f").$setHtml(He(this,y,"f"),f))}get options(){return this.assertNotDisposed(),He(this,v,"f")}set options(f){this.assertNotDisposed(),He(this,A,"f").$setOptions(He(this,y,"f"),s(He(this,m,"f"),He(this,u,"f"),f)),it(this,v,f,"f")}async postMessage(f){if(He(this,_,"f"))return!1;const w=(0,S.serializeWebviewMessage)(f,{serializeBuffersForPostMessage:He(this,P,"f")});return He(this,A,"f").$postMessage(He(this,y,"f"),w.message,...w.buffers)}assertNotDisposed(){if(He(this,_,"f"))throw new Error("Webview is disposed")}}e.ExtHostWebview=h,y=new WeakMap,A=new WeakMap,i=new WeakMap,C=new WeakMap,u=new WeakMap,m=new WeakMap,l=new WeakMap,v=new WeakMap,_=new WeakMap,b=new WeakMap,P=new WeakMap,c=new WeakMap;function p(d){try{const f=(0,k.normalizeVersion)((0,k.parseVersion)(d.engines.vscode));return!!f&&f.majorBase>=1&&f.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=p;class t{constructor(f,w,E,o,I){this.initData=w,this.workspace=E,this._logService=o,this._deprecationService=I,this._webviews=new Map,this._webviewProxy=f.getProxy(D.MainContext.MainThreadWebviews)}$onMessage(f,w,...E){const o=this.getWebview(f);if(o){const{message:I}=(0,S.deserializeWebviewMessage)(w,E);o._onMessageEmitter.fire(I)}}$onMissingCsp(f,w){this._logService.warn(`${w} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(f,w,E){const o=new h(f,this._webviewProxy,n(w),this.initData,this.workspace,E,this._deprecationService);return this._webviews.set(f,o),o._onDidDispose(()=>{this._webviews.delete(f)}),o}deleteWebview(f){this._webviews.delete(f)}getWebview(f){return this._webviews.get(f)}}e.ExtHostWebviews=t;function r(d){return{id:d.identifier,location:d.extensionLocation}}e.toExtensionData=r;function s(d,f,w){return{enableCommandUris:w.enableCommandUris,enableScripts:w.enableScripts,portMapping:w.portMapping,localResourceRoots:w.localResourceRoots||a(d,f)}}e.serializeWebviewOptions=s;function n(d){return{enableCommandUris:d.enableCommandUris,enableScripts:d.enableScripts,portMapping:d.portMapping,localResourceRoots:d.localResourceRoots?.map(f=>R.URI.from(f))}}e.reviveOptions=n;function a(d,f){return[...(f?.getWorkspaceFolders()||[]).map(w=>w.uri),d.extensionLocation]}}),define(me[255],ge([0,1,21,58,6,10,23,2,17,67,86,5,7]),function(J,e,g,R,k,S,T,D,y,A,i,C,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class m{constructor(t,r){this.document=t,this._storagePath=r,this._backupCounter=1,this._edits=new i.Cache("custom documents")}addEdit(t){return this._edits.add([t])}async undo(t,r){await this.getEdit(t).undo(),r||this.disposeBackup()}async redo(t,r){await this.getEdit(t).redo(),r||this.disposeBackup()}disposeEdits(t){for(const r of t)this._edits.delete(r)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const t=h(this.document.uri)+this._backupCounter++;return(0,T.joinPath)(this._storagePath,t)}updateBackup(t){this._backup?.delete(),this._backup=t}disposeBackup(){this._backup?.delete(),this._backup=void 0}getEdit(t){const r=this._edits.get(t,0);if(!r)throw new Error("No edit found");return r}}class l{constructor(){this._documents=new Map}get(t,r){return this._documents.get(this.key(t,r))}add(t,r,s){const n=this.key(t,r.uri);if(this._documents.has(n))throw new Error(`Document already exists for viewType:${t} resource:${r.uri}`);const a=new m(r,s);return this._documents.set(n,a),a}delete(t,r){const s=this.key(t,r.uri);this._documents.delete(s)}key(t,r){return`${t}@@@${r}`}}var v;(function(p){p[p.Text=0]="Text",p[p.Custom=1]="Custom"})(v||(v={}));class _{constructor(){this._providers=new Map}addTextProvider(t,r,s){return this.add(0,t,r,s)}addCustomProvider(t,r,s){return this.add(1,t,r,s)}get(t){return this._providers.get(t)}add(t,r,s,n){if(this._providers.has(r))throw new Error(`Provider for viewType:${r} already registered`);return this._providers.set(r,{type:t,extension:s,provider:n}),new u.Disposable(()=>this._providers.delete(r))}}class b{constructor(t,r,s,n,a){this._extHostDocuments=r,this._extensionStoragePaths=s,this._extHostWebview=n,this._extHostWebviewPanels=a,this._editorProviders=new _,this._documents=new l,this._proxy=t.getProxy(C.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(t,r,s,n){const a=new k.DisposableStore;return P(s)?(a.add(this._editorProviders.addTextProvider(r,t,s)),this._proxy.$registerTextEditorProvider((0,A.toExtensionData)(t),r,n.webviewOptions||{},{supportsMove:!!s.moveCustomTextEditor},(0,A.shouldSerializeBuffersForPostMessage)(t))):(a.add(this._editorProviders.addCustomProvider(r,t,s)),this.supportEditing(s)&&a.add(s.onDidChangeCustomDocument(d=>{const f=this.getCustomDocumentEntry(r,d.document.uri);if(c(d)){const w=f.addEdit(d);this._proxy.$onDidEdit(d.document.uri,r,w,d.label)}else this._proxy.$onContentChange(d.document.uri,r)})),this._proxy.$registerCustomEditorProvider((0,A.toExtensionData)(t),r,n.webviewOptions||{},!!n.supportsMultipleEditorsPerDocument,(0,A.shouldSerializeBuffersForPostMessage)(t))),u.Disposable.from(a,new u.Disposable(()=>{this._proxy.$unregisterEditorProvider(r)}))}async $createCustomDocument(t,r,s,n,a){const d=this._editorProviders.get(r);if(!d)throw new Error(`No provider found for '${r}'`);if(d.type!==1)throw new Error(`Invalid provide type for '${r}'`);const f=D.URI.revive(t),w=await d.provider.openCustomDocument(f,{backupId:s,untitledDocumentData:n?.buffer},a);let E;return this.supportEditing(d.provider)&&this._extensionStoragePaths&&(E=this._extensionStoragePaths.workspaceValue(d.extension)??this._extensionStoragePaths.globalValue(d.extension)),this._documents.add(r,w,E),{editable:this.supportEditing(d.provider)}}async $disposeCustomDocument(t,r){const s=this._editorProviders.get(r);if(!s)throw new Error(`No provider found for '${r}'`);if(s.type!==1)throw new Error(`Invalid provider type for '${r}'`);const n=D.URI.revive(t),{document:a}=this.getCustomDocumentEntry(r,n);this._documents.delete(r,a),a.dispose()}async $resolveWebviewEditor(t,r,s,n,a,d){const f=this._editorProviders.get(s);if(!f)throw new Error(`No provider found for '${s}'`);const w=y.ViewColumn.to(a),E=this._extHostWebview.createNewWebview(r,n.webviewOptions,f.extension),o=this._extHostWebviewPanels.createNewWebviewPanel(r,s,n.title,w,n.panelOptions,E),I=D.URI.revive(t);switch(f.type){case 1:{const{document:L}=this.getCustomDocumentEntry(s,I);return f.provider.resolveCustomEditor(L,o,d)}case 0:{const L=this._extHostDocuments.getDocument(I);return f.provider.resolveCustomTextEditor(L,o,d)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(t,r,s){this.getCustomDocumentEntry(r,t).disposeEdits(s)}async $onMoveCustomEditor(t,r,s){const n=this._editorProviders.get(s);if(!n)throw new Error(`No provider found for '${s}'`);if(!n.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${s}'`);const a=this._extHostWebviewPanels.getWebviewPanel(t);if(!a)throw new Error("No webview found");const d=D.URI.revive(r),f=this._extHostDocuments.getDocument(d);await n.provider.moveCustomTextEditor(f,a,g.CancellationToken.None)}async $undo(t,r,s,n){return this.getCustomDocumentEntry(r,t).undo(s,n)}async $redo(t,r,s,n){return this.getCustomDocumentEntry(r,t).redo(s,n)}async $revert(t,r,s){const n=this.getCustomDocumentEntry(r,t);await this.getCustomEditorProvider(r).revertCustomDocument(n.document,s),n.disposeBackup()}async $onSave(t,r,s){const n=this.getCustomDocumentEntry(r,t);await this.getCustomEditorProvider(r).saveCustomDocument(n.document,s),n.disposeBackup()}async $onSaveAs(t,r,s,n){const a=this.getCustomDocumentEntry(r,t);return this.getCustomEditorProvider(r).saveCustomDocumentAs(a.document,D.URI.revive(s),n)}async $backup(t,r,s){const n=this.getCustomDocumentEntry(r,t),d=await this.getCustomEditorProvider(r).backupCustomDocument(n.document,{destination:n.getNewBackupUri()},s);return n.updateBackup(d),d.id}getCustomDocumentEntry(t,r){const s=this._documents.get(t,D.URI.revive(r));if(!s)throw new Error("No custom document found");return s}getCustomEditorProvider(t){const s=this._editorProviders.get(t)?.provider;if(!s||!this.supportEditing(s))throw new Error("Custom document is not editable");return s}supportEditing(t){return!!t.onDidChangeCustomDocument}}e.ExtHostCustomEditors=b;function P(p){return typeof p.resolveCustomTextEditor=="function"}function c(p){return typeof p.undo=="function"&&typeof p.redo=="function"}function h(p){const t=p.scheme===S.Schemas.file||p.scheme===S.Schemas.untitled?p.fsPath:p.toString();return(0,R.hash)(t)+""}});var it=this&&this.__classPrivateFieldSet||function(J,e,g,R,k){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!k:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?k.call(J,g):k?k.value=g:e.set(J,g),g},He=this&&this.__classPrivateFieldGet||function(J,e,g,R){if(g==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!R:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?R:g==="a"?R.call(J):R?R.value:e.get(J)};define(me[256],ge([0,1,3,6,2,32,17,67,5,7]),function(J,e,g,R,k,S,T,D,y,A){"use strict";var i,C,u,m,l,v,_,b,P,c,h,p,t;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class r extends R.Disposable{constructor(d,f,w,E,o,I,L){super();i.set(this,void 0),C.set(this,void 0),u.set(this,void 0),m.set(this,void 0),l.set(this,void 0),v.set(this,void 0),_.set(this,void 0),b.set(this,void 0),P.set(this,!0),c.set(this,!0),h.set(this,!1),p.set(this,this._register(new g.Emitter)),this.onDidDispose=He(this,p,"f").event,t.set(this,this._register(new g.Emitter)),this.onDidChangeViewState=He(this,t,"f").event,it(this,i,d,"f"),it(this,C,f,"f"),it(this,u,w,"f"),it(this,l,I,"f"),it(this,b,o,"f"),it(this,v,E,"f"),it(this,m,L,"f")}dispose(){He(this,h,"f")||(it(this,h,!0,"f"),He(this,p,"f").fire(),He(this,C,"f").$disposeWebview(He(this,i,"f")),He(this,m,"f").dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),He(this,m,"f")}get viewType(){return this.assertNotDisposed(),He(this,u,"f")}get title(){return this.assertNotDisposed(),He(this,v,"f")}set title(d){this.assertNotDisposed(),He(this,v,"f")!==d&&(it(this,v,d,"f"),He(this,C,"f").$setTitle(He(this,i,"f"),d))}get iconPath(){return this.assertNotDisposed(),He(this,_,"f")}set iconPath(d){this.assertNotDisposed(),He(this,_,"f")!==d&&(it(this,_,d,"f"),He(this,C,"f").$setIconPath(He(this,i,"f"),k.URI.isUri(d)?{light:d,dark:d}:d))}get options(){return He(this,l,"f")}get viewColumn(){if(this.assertNotDisposed(),!(typeof He(this,b,"f")=="number"&&He(this,b,"f")<0))return He(this,b,"f")}get active(){return this.assertNotDisposed(),He(this,c,"f")}get visible(){return this.assertNotDisposed(),He(this,P,"f")}_updateViewState(d){He(this,h,"f")||(this.active!==d.active||this.visible!==d.visible||this.viewColumn!==d.viewColumn)&&(it(this,c,d.active,"f"),it(this,P,d.visible,"f"),it(this,b,d.viewColumn,"f"),He(this,t,"f").fire({webviewPanel:this}))}reveal(d,f){this.assertNotDisposed(),He(this,C,"f").$reveal(He(this,i,"f"),{viewColumn:d?T.ViewColumn.from(d):void 0,preserveFocus:!!f})}assertNotDisposed(){if(He(this,h,"f"))throw new Error("Webview is disposed")}}i=new WeakMap,C=new WeakMap,u=new WeakMap,m=new WeakMap,l=new WeakMap,v=new WeakMap,_=new WeakMap,b=new WeakMap,P=new WeakMap,c=new WeakMap,h=new WeakMap,p=new WeakMap,t=new WeakMap;class s{constructor(d,f,w){this.webviews=f,this.workspace=w,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=d.getProxy(y.MainContext.MainThreadWebviewPanels)}static newHandle(){return(0,S.generateUuid)()}createWebviewPanel(d,f,w,E,o={}){const I=typeof E=="object"?E.viewColumn:E,L={viewColumn:T.ViewColumn.from(I),preserveFocus:typeof E=="object"&&!!E.preserveFocus},U=(0,D.shouldSerializeBuffersForPostMessage)(d),V=s.newHandle();this._proxy.$createWebviewPanel((0,D.toExtensionData)(d),V,f,{title:w,panelOptions:n(o),webviewOptions:(0,D.serializeWebviewOptions)(d,this.workspace,o),serializeBuffersForPostMessage:U},L);const ee=this.webviews.createNewWebview(V,o,d);return this.createNewWebviewPanel(V,f,w,I,o,ee)}$onDidChangeWebviewPanelViewStates(d){const f=Object.keys(d);f.sort((w,E)=>{const o=d[w],I=d[E];return o.active?1:I.active?-1:+o.visible-+I.visible});for(const w of f){const E=this.getWebviewPanel(w);if(!E)continue;const o=d[w];E._updateViewState({active:o.active,visible:o.visible,viewColumn:T.ViewColumn.to(o.position)})}}async $onDidDisposeWebviewPanel(d){this.getWebviewPanel(d)?.dispose(),this._webviewPanels.delete(d),this.webviews.deleteWebview(d)}registerWebviewPanelSerializer(d,f,w){if(this._serializers.has(f))throw new Error(`Serializer for '${f}' already registered`);return this._serializers.set(f,{serializer:w,extension:d}),this._proxy.$registerSerializer(f,{serializeBuffersForPostMessage:(0,D.shouldSerializeBuffersForPostMessage)(d)}),new A.Disposable(()=>{this._serializers.delete(f),this._proxy.$unregisterSerializer(f)})}async $deserializeWebviewPanel(d,f,w,E){const o=this._serializers.get(f);if(!o)throw new Error(`No serializer found for '${f}'`);const{serializer:I,extension:L}=o,U=this.webviews.createNewWebview(d,w.webviewOptions,L),V=this.createNewWebviewPanel(d,f,w.title,E,w.panelOptions,U);await I.deserializeWebviewPanel(V,w.state)}createNewWebviewPanel(d,f,w,E,o,I){const L=new r(d,this._proxy,f,w,E,o,I);return this._webviewPanels.set(d,L),L}getWebviewPanel(d){return this._webviewPanels.get(d)}}e.ExtHostWebviewPanels=s;function n(a){return{enableFindWidget:a.enableFindWidget,retainContextWhenHidden:a.retainContextWhenHidden}}});var it=this&&this.__classPrivateFieldSet||function(J,e,g,R,k){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!k:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?k.call(J,g):k?k.value=g:e.set(J,g),g},He=this&&this.__classPrivateFieldGet||function(J,e,g,R){if(g==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!R:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?R:g==="a"?R.call(J):R?R.value:e.get(J)};define(me[257],ge([0,1,3,6,67,5,7]),function(J,e,g,R,k,S,T){"use strict";var D,y,A,i,C,u,m,l,v,_;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class b extends R.Disposable{constructor(h,p,t,r,s,n){super();D.set(this,void 0),y.set(this,void 0),A.set(this,void 0),i.set(this,void 0),C.set(this,!1),u.set(this,void 0),m.set(this,void 0),l.set(this,void 0),v.set(this,this._register(new g.Emitter)),this.onDidChangeVisibility=He(this,v,"f").event,_.set(this,this._register(new g.Emitter)),this.onDidDispose=He(this,_,"f").event,it(this,A,t,"f"),it(this,m,r,"f"),it(this,D,h,"f"),it(this,y,p,"f"),it(this,i,s,"f"),it(this,u,n,"f")}dispose(){He(this,C,"f")||(it(this,C,!0,"f"),He(this,_,"f").fire(),He(this,i,"f").dispose(),super.dispose())}get title(){return this.assertNotDisposed(),He(this,m,"f")}set title(h){this.assertNotDisposed(),He(this,m,"f")!==h&&(it(this,m,h,"f"),He(this,y,"f").$setWebviewViewTitle(He(this,D,"f"),h))}get description(){return this.assertNotDisposed(),He(this,l,"f")}set description(h){this.assertNotDisposed(),He(this,l,"f")!==h&&(it(this,l,h,"f"),He(this,y,"f").$setWebviewViewDescription(He(this,D,"f"),h))}get visible(){return He(this,u,"f")}get webview(){return He(this,i,"f")}get viewType(){return He(this,A,"f")}_setVisible(h){h===He(this,u,"f")||He(this,C,"f")||(it(this,u,h,"f"),He(this,v,"f").fire())}show(h){this.assertNotDisposed(),He(this,y,"f").$show(He(this,D,"f"),!!h)}assertNotDisposed(){if(He(this,C,"f"))throw new Error("Webview is disposed")}}D=new WeakMap,y=new WeakMap,A=new WeakMap,i=new WeakMap,C=new WeakMap,u=new WeakMap,m=new WeakMap,l=new WeakMap,v=new WeakMap,_=new WeakMap;class P{constructor(h,p){this._extHostWebview=p,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=h.getProxy(S.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(h,p,t,r){if(this._viewProviders.has(p))throw new Error(`View provider for '${p}' already registered`);return this._viewProviders.set(p,{provider:t,extension:h}),this._proxy.$registerWebviewViewProvider((0,k.toExtensionData)(h),p,{retainContextWhenHidden:r?.retainContextWhenHidden,serializeBuffersForPostMessage:!1}),new T.Disposable(()=>{this._viewProviders.delete(p),this._proxy.$unregisterWebviewViewProvider(p)})}async $resolveWebviewView(h,p,t,r,s){const n=this._viewProviders.get(p);if(!n)throw new Error(`No view provider found for '${p}'`);const{provider:a,extension:d}=n,f=this._extHostWebview.createNewWebview(h,{},d),w=new b(h,this._proxy,p,t,f,!0);this._webviewViews.set(h,w),await a.resolveWebviewView(w,{state:r},s)}async $onDidChangeWebviewViewVisibility(h,p){this.getWebviewView(h)._setVisible(p)}async $disposeWebviewView(h){const p=this.getWebviewView(h);this._webviewViews.delete(h),p.dispose(),this._extHostWebview.deleteWebview(h)}getWebviewView(h){const p=this._webviewViews.get(h);if(!p)throw new Error("No webview found");return p}}e.ExtHostWebviewViews=P}),define(me[132],ge([0,1,3,5,2,10,8,4,13]),function(J,e,g,R,k,S,T,D,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let A=class Bn{constructor(C){this._onDidChangeWindowState=new g.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=Bn.InitialState,this._proxy=C.getProxy(R.MainContext.MainThreadWindow),this._proxy.$getWindowVisibility().then(u=>this.$onDidChangeWindowFocus(u))}get state(){return this._state}$onDidChangeWindowFocus(C){C!==this._state.focused&&(this._state={...this._state,focused:C},this._onDidChangeWindowState.fire(this._state))}openUri(C,u){let m;if(typeof C=="string"){m=C;try{C=k.URI.parse(C)}catch(l){return Promise.reject(`Invalid uri - '${C}'`)}}return(0,T.isFalsyOrWhitespace)(C.scheme)?Promise.reject("Invalid scheme - cannot be empty"):C.scheme===S.Schemas.command?Promise.reject(`Invalid scheme '${C.scheme}'`):this._proxy.$openUri(C,m,u)}async asExternalUri(C,u){if((0,T.isFalsyOrWhitespace)(C.scheme))return Promise.reject("Invalid scheme - cannot be empty");const m=await this._proxy.$asExternalUri(C,u);return k.URI.from(m)}};A.InitialState={focused:!0},A=Ve([$e(0,y.IExtHostRpcService)],A),e.ExtHostWindow=A,e.IExtHostWindow=(0,D.createDecorator)("IExtHostWindow")}),define(me[258],ge([0,1,9,78,32,44,6,5,2,13]),function(J,e,g,R,k,S,T,D,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDownloadService=void 0;let i=class extends T.Disposable{constructor(u,m){super();const l=u.getProxy(D.MainContext.MainThreadDownloadService);m.registerCommand(!1,"_workbench.downloadResource",async v=>{const _=y.URI.file((0,g.join)((0,R.tmpdir)(),(0,k.generateUuid)()));return await l.$download(v,_),_})}};i=Ve([$e(0,A.IExtHostRpcService),$e(1,S.IExtHostCommands)],i),e.ExtHostDownloadService=i}),define(me[259],ge([0,1,2,9,151,28,65,27,13,6,12,116,42]),function(J,e,g,R,k,S,T,D,y,A,i,C,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostOutputService2=void 0;class m{constructor(b,P,c){this.name=b,this.file=P,this.appender=c}static async create(b,P){const c=await(0,C.createRotatingLogger)(b,P,30*u.ByteSize.MB,1);return c.clearFormatters(),new m(b,P,c)}append(b){this.appender.critical(b)}flush(){this.appender.flush()}}class l extends T.AbstractExtHostOutputChannel{constructor(b,P,c,h){super(b,!1,g.URI.file(P.file),c,h);this._appender=P}append(b){super.append(b),this._appender.append(b),this._onDidAppend.fire()}update(){this._appender.flush(),super.update()}show(b,P){this._appender.flush(),super.show(b,P)}clear(){this._appender.flush(),super.clear()}}let v=class extends T.ExtHostOutputService{constructor(b,P,c){super(b);this.logService=P,this._namePool=1,this._channels=new Map,this._visibleChannelDisposable=new A.MutableDisposable,this._logsLocation=c.logsLocation}$setVisibleChannel(b){if(b){const P=this._channels.get(b);P&&(this._visibleChannelDisposable.value=P.onDidAppend(()=>P.update()))}}createOutputChannel(b,P){if(b=b.trim(),!b)throw new Error("illegal argument `name`. must not be falsy");const c=this._doCreateOutChannel(b,P);return c.then(h=>h._id.then(p=>this._channels.set(p,h))),new T.LazyOutputChannel(b,c)}async _doCreateOutChannel(b,P){try{const c=(0,R.join)(this._logsLocation.fsPath,`output_logging_${(0,k.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`);await S.SymlinkSupport.existsDirectory(c)||await S.Promises.mkdir(c,{recursive:!0});const p=`${this._namePool++}-${b.replace(/[\\/:\*\?"<>\|]/g,"")}`,t=g.URI.file((0,R.join)(c,`${p}.log`)),r=await m.create(p,t.fsPath);return new l(b,r,P.identifier.value,this._proxy)}catch(c){return this.logService.error(c),new T.ExtHostPushOutputChannel(b,P.identifier.value,this._proxy)}}};v=Ve([$e(0,y.IExtHostRpcService),$e(1,i.ILogService),$e(2,D.IExtHostInitDataService)],v),e.ExtHostOutputService2=v}),define(me[260],ge([0,1,49,291,2,66,6,10,16]),function(J,e,g,R,k,S,T,D,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=void 0;class A extends S.ExtensionStoragePaths{constructor(){super(...arguments);this._workspaceStorageLock=null}async _getWorkspaceStorageURI(p){const t=await super._getWorkspaceStorageURI(p);if(t.scheme!==D.Schemas.file)return t;if(this._environment.skipWorkspaceStorageLock)return this._logService.info(`Skipping acquiring lock for ${t.fsPath}.`),t;const r=t.fsPath;let s=0;do{let n;s===0?n=r:n=/[/\\]$/.test(r)?`${r.substr(0,r.length-1)}-${s}`:`${r}-${s}`,await i(n);const a=R.join(n,"vscode.lock"),d=await l(this._logService,a,!1);if(d)return this._workspaceStorageLock=d,process.on("exit",()=>{d.dispose()}),k.URI.file(n);s++}while(s<10);return t}onWillDeactivateAll(){this._workspaceStorageLock&&this._workspaceStorageLock.setWillRelease(6e3)}}e.ExtensionStoragePaths=A;async function i(h){try{await g.promises.stat(h);return}catch{}try{await g.promises.mkdir(h,{recursive:!0})}catch{}}const C=1e3,u=10*60*1e3;class m extends T.Disposable{constructor(p,t){super();this.logService=p,this.filename=t,this._timer=this._register(new y.IntervalTimer),this._timer.cancelAndSet(async()=>{const r=await v(p,t);(!r||r.pid!==process.pid)&&(p.info(`Lock '${t}': The lock was lost unexpectedly.`),this._timer.cancel());try{await g.promises.utimes(t,new Date,new Date)}catch(s){p.error(s),p.info(`Lock '${t}': Could not update mtime.`)}},C)}dispose(){super.dispose();try{g.unlinkSync(this.filename)}catch(p){}}async setWillRelease(p){this.logService.info(`Lock '${this.filename}': Marking the lockfile as scheduled to be released in ${p} ms.`);try{const t={pid:process.pid,willReleaseAt:Date.now()+p};await g.promises.writeFile(this.filename,JSON.stringify(t),{flag:"w"})}catch(t){this.logService.error(t)}}}async function l(h,p,t){try{const s={pid:process.pid,willReleaseAt:0};await g.promises.writeFile(p,JSON.stringify(s),{flag:"wx"})}catch(s){h.error(s)}const r=await v(h,p);return!r||r.pid!==process.pid?t?(h.info(`Lock '${p}': Could not acquire lock, giving up.`),null):(h.info(`Lock '${p}': Could not acquire lock, checking if the file is stale.`),P(h,p)):(h.info(`Lock '${p}': Lock acquired.`),new m(h,p))}async function v(h,p){let t;try{t=await g.promises.readFile(p)}catch(r){return h.error(r),null}try{return JSON.parse(String(t))}catch(r){return h.error(r),null}}async function _(h,p){let t;try{t=await g.promises.stat(p)}catch(r){return h.error(r),0}return t.mtime.getTime()}function b(h){try{return process.kill(h,0),!0}catch(p){return!1}}async function P(h,p){const t=await v(h,p);if(!t)return h.info(`Lock '${p}': Could not read pid of lock holder.`),c(h,p);if(t.willReleaseAt){let d=t.willReleaseAt-Date.now();if(d<5e3){for(d>0?h.info(`Lock '${p}': The lockfile is scheduled to be released in ${d} ms.`):h.info(`Lock '${p}': The lockfile is scheduled to have been released.`);d>0;){if(await(0,y.timeout)(Math.min(100,d)),await _(h,p)===0)return c(h,p);d=t.willReleaseAt-Date.now()}return c(h,p)}}if(!b(t.pid))return h.info(`Lock '${p}': The pid ${t.pid} appears to be gone.`),c(h,p);const r=await _(h,p),s=Date.now()-r;if(s<=u)return h.info(`Lock '${p}': The lock does not look stale, elapsed: ${s} ms, giving up.`),null;h.info(`Lock '${p}': The lock looks stale, waiting for 2s.`),await(0,y.timeout)(2e3);const n=await _(h,p),a=Date.now()-n;return a<=u?(h.info(`Lock '${p}': The lock does not look stale, elapsed: ${a} ms, giving up.`),null):(h.info(`Lock '${p}': The lock looks stale even after waiting for 2s.`),c(h,p))}async function c(h,p){h.info(`Lock '${p}': Deleting a stale lock.`);try{await g.promises.unlink(p)}catch(t){}return l(h,p,!0)}}),define(me[261],ge([0,1,32,13,33]),function(J,e,g,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTerminalService=void 0;let S=class extends k.BaseExtHostTerminalService{constructor(D){super(!0,D)}createTerminal(D,y,A){return this.createTerminalFromOptions({name:D,shellPath:y,shellArgs:A})}createTerminalFromOptions(D,y){const A=new k.ExtHostTerminal(this._proxy,(0,g.generateUuid)(),D,D.name);return this._terminals.push(A),A.create(D,y),A.value}};S=Ve([$e(0,R.IExtHostRpcService)],S),e.ExtHostTerminalService=S}),define(me[262],ge([0,1,5,13,6,27,2,39,23,28,7,11,52,3,193,75,12]),function(J,e,g,R,k,S,T,D,y,A,i,C,u,m,l,v,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.tryFindRootPorts=e.findPorts=e.getRootProcesses=e.loadConnectionTable=e.parseIpAddress=e.loadListeningPorts=e.getSockets=void 0;class b{constructor(f,w,E){this.remoteAddress=f,this.localAddress=w,this._dispose=E,this._onDispose=new m.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}function P(d){const f=d.trim().split(`
`),w=[];return f.forEach(o=>{const I=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(o);I&&I.length>=3&&w.push({pid:parseInt(I[1],10),socket:parseInt(I[2],10)})}),w.reduce((o,I)=>(o[I.socket]=I,o),{})}e.getSockets=P;function c(...d){const f=[].concat(...d.map(p));return[...new Map(f.filter(w=>w.st==="0A").map(w=>{const E=w.local_address.split(":");return{socket:parseInt(w.inode,10),ip:h(E[0]),port:parseInt(E[1],16)}}).map(w=>[w.ip+":"+w.port,w])).values()]}e.loadListeningPorts=c;function h(d){let f="";if(d.length===8)for(let w=d.length-2;w>=0;w-=2)f+=parseInt(d.substr(w,2),16),w!==0&&(f+=".");else for(let w=d.length-4;w>=0;w-=4)f+=parseInt(d.substr(w,4),16).toString(16),w!==0&&(f+=":");return f}e.parseIpAddress=h;function p(d){const f=d.trim().split(`
`),w=f.shift().trim().split(/\s+/).filter(o=>o!=="rx_queue"&&o!=="tm->when");return f.map(o=>o.trim().split(/\s+/).reduce((I,L,U)=>(I[w[U]||U]=L,I),{}))}e.loadConnectionTable=p;function t(d){return!!d.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||d.indexOf("out/vs/server/main.js")!==-1||d.indexOf("_productName=VSCode")!==-1}function r(d){const f=d.trim().split(`
`),w=[];return f.forEach(E=>{const o=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(E);o&&o.length>=4&&w.push({pid:parseInt(o[1],10),ppid:parseInt(o[2]),cmd:o[3]})}),w}e.getRootProcesses=r;async function s(d,f,w){const E=w.reduce((I,L)=>(I[L.pid]=L,I),{}),o=[];return d.forEach(({socket:I,ip:L,port:U})=>{const V=f[I]?f[I].pid:void 0,ee=V?E[V]?.cmd:void 0;V&&ee&&!t(ee)&&o.push({host:L,port:U,detail:ee,pid:V})}),o}e.findPorts=s;function n(d,f,w){const E=new Map,o=r(f);for(const I of d){const L=w.get(I.port);if(L){E.set(I.port,L);continue}const U=o.find(V=>V.cmd.includes(`${I.port}`));if(U){let V=U,ee;do ee=o.find(K=>K.ppid===V.pid),ee&&(V=ee);while(ee);E.set(I.port,{host:I.ip,port:I.port,pid:V.pid,detail:V.cmd,ppid:V.ppid})}else E.set(I.port,{host:I.ip,port:I.port,ppid:Number.MAX_VALUE})}return E}e.tryFindRootPorts=n;let a=class extends k.Disposable{constructor(f,w,E){super();this.logService=E,this._showCandidatePort=()=>Promise.resolve(!0),this._extensionTunnels=new Map,this._onDidChangeTunnels=new m.Emitter,this.onDidChangeTunnels=this._onDidChangeTunnels.event,this._candidateFindingEnabled=!1,this._foundRootPorts=new Map,this._providerHandleCounter=0,this._portAttributesProviders=new Map,this._proxy=f.getProxy(g.MainContext.MainThreadTunnelService),C.isLinux&&w.remote.isRemote&&w.remote.authority&&this._proxy.$setRemoteTunnelService(process.pid)}async openTunnel(f,w){this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) ${f.identifier.value} called openTunnel API for ${w.remoteAddress.host}:${w.remoteAddress.port}.`);const E=await this._proxy.$openTunnel(w,f.displayName);if(E){const o=new b(E.remoteAddress,E.localAddress,()=>this._proxy.$closeTunnel(E.remoteAddress));return this._register(o),o}}async getTunnels(){return this._proxy.$getTunnels()}calculateDelay(f){return Math.max(f*20,2e3)}nextPortAttributesProviderHandle(){return this._providerHandleCounter++}registerPortsAttributesProvider(f,w){const E=this.nextPortAttributesProviderHandle();return this._portAttributesProviders.set(E,{selector:f,provider:w}),this._proxy.$registerPortsAttributesProvider(f,E),new i.Disposable(()=>{this._portAttributesProviders.delete(E),this._proxy.$unregisterPortsAttributesProvider(E)})}async $providePortAttributes(f,w,E,o,I){const L=[];for(const V of f){const ee=this._portAttributesProviders.get(V);if(!ee)return[];L.push(...await Promise.all(w.map(async K=>ee.provider.providePortAttributes(K,E,o,I))))}const U=L.filter(V=>!!V);return U.length>0?U.map(V=>({autoForwardAction:V.autoForwardAction,port:V.port})):[]}async $registerCandidateFinder(f){if(f&&this._candidateFindingEnabled)return;this._candidateFindingEnabled=f;let w=new v.MovingAverage,E;for(;this._candidateFindingEnabled;){const o=new Date().getTime(),I=(await this.findCandidatePorts()).filter(U=>(0,l.isLocalhost)(U.host)||(0,l.isAllInterfaces)(U.host));this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${I.map(U=>U.port).join(", ")}`);const L=new Date().getTime()-o;w.update(L),(!E||JSON.stringify(E)!==JSON.stringify(I))&&(E=I,await this._proxy.$onFoundNewCandidates(E)),await new Promise(U=>setTimeout(()=>U(),this.calculateDelay(w.value)))}}async setTunnelExtensionFunctions(f){return f?(f.candidatePortSource!==void 0&&this._proxy.$setCandidatePortSource(f.candidatePortSource),f.showCandidatePort&&(this._showCandidatePort=f.showCandidatePort,this._proxy.$setCandidateFilter()),f.tunnelFactory&&(this._forwardPortProvider=f.tunnelFactory,this._proxy.$setTunnelProvider(f.tunnelFeatures??{elevation:!1,public:!1}))):this._forwardPortProvider=void 0,(0,k.toDisposable)(()=>{this._forwardPortProvider=void 0})}async $closeTunnel(f,w){if(this._extensionTunnels.has(f.host)){const E=this._extensionTunnels.get(f.host);E.has(f.port)&&(w&&E.get(f.port).disposeListener.dispose(),await E.get(f.port).tunnel.dispose(),E.delete(f.port))}}async $onDidTunnelsChange(){this._onDidChangeTunnels.fire()}async $forwardPort(f,w){if(this._forwardPortProvider)try{this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const E=this._forwardPortProvider(f,w);if(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),E!==void 0){const o=await E;this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),this._extensionTunnels.has(f.remoteAddress.host)||this._extensionTunnels.set(f.remoteAddress.host,new Map);const I=this._register(o.onDidDispose(()=>(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this._proxy.$closeTunnel(o.remoteAddress))));return this._extensionTunnels.get(f.remoteAddress.host).set(f.remoteAddress.port,{tunnel:o,disposeListener:I}),u.TunnelDto.fromApiTunnel(o)}else this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(E){this.logService.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error")}}async $applyCandidateFilter(f){const w=await Promise.all(f.map(o=>this._showCandidatePort(o.host,o.port,o.detail??""))),E=f.filter((o,I)=>w[I]);return this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${f.map(o=>o.port).join(", ")} to ${E.map(o=>o.port).join(", ")}`),E}async findCandidatePorts(){let f="",w="";try{f=await A.Promises.readFile("/proc/net/tcp","utf8"),w=await A.Promises.readFile("/proc/net/tcp6","utf8")}catch(x){}const E=c(f,w),o=await new Promise(x=>{(0,D.exec)("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(F,z,M)=>{x(z)})}),I=P(o),L=await A.Promises.readdir("/proc"),U=[];for(let x of L)try{const F=Number(x),z=y.joinPath(T.URI.file("/proc"),x);if((await A.Promises.stat(z.fsPath)).isDirectory()&&!isNaN(F)){const O=await A.Promises.readlink(y.joinPath(z,"cwd").fsPath),q=await A.Promises.readFile(y.joinPath(z,"cmdline").fsPath,"utf8");U.push({pid:F,cwd:O,cmd:q})}}catch(F){}const V=[],ee=E.filter(x=>{const F=I[x.socket];return F||V.push(x),F}),K=s(ee,I,U);let N;if(this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${V.length}`),V.length>0){const x=await new Promise(F=>{(0,D.exec)("ps -F -A -l | grep root",(z,M,O)=>{F(M)})});this._foundRootPorts=n(V,x,this._foundRootPorts),N=Array.from(this._foundRootPorts.values()),this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${N.join(", ")}`)}return K.then(x=>N?x.concat(N):x)}};a=Ve([$e(0,R.IExtHostRpcService),$e(1,S.IExtHostInitDataService),$e(2,_.ILogService)],a),e.ExtHostTunnelService=a}),define(me[263],ge([0,1,16,21,15,3,6,103,227,130,24]),function(J,e,g,R,k,S,T,D,y,A,i){"use strict";var C;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=void 0;function u(n,a){try{return JSON.stringify(n,a)}catch(d){return"null"}}function m(n,a){return JSON.stringify(n,a)}function l(n){return n?(a,d)=>d&&d.$mid===1?n.transformOutgoing(d):d:null}var v;(function(n){n[n.LocalSide=0]="LocalSide",n[n.OtherSide=1]="OtherSide"})(v=e.RequestInitiator||(e.RequestInitiator={}));var _;(function(n){n[n.Responsive=0]="Responsive",n[n.Unresponsive=1]="Unresponsive"})(_=e.ResponsiveState||(e.ResponsiveState={}));const b=()=>{},P=Symbol.for("rpcProtocol"),c=Symbol.for("rpcProxy");class h extends T.Disposable{constructor(a,d=null,f=null){super();this[C]=!0,this._onDidChangeResponsiveState=this._register(new S.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=a,this._logger=d,this._uriTransformer=f,this._uriReplacer=l(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let w=0,E=A.ProxyIdentifier.count;w<E;w++)this._locals[w]=null,this._proxies[w]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new g.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(w=>this._receiveOneMessage(w))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(a=>{this._pendingRPCReplies[a].resolveErr(k.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(a){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+h.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(a){this._unresponsiveTime=Date.now()+h.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(a){this._responsiveState!==a&&(this._responsiveState=a,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(a){return this._uriTransformer?(0,D.transformIncomingURIs)(a,this._uriTransformer):a}getProxy(a){const{nid:d,sid:f}=a;return this._proxies[d]||(this._proxies[d]=this._createProxy(d,f)),this._proxies[d]}_createProxy(a,d){let f={get:(w,E)=>(typeof E=="string"&&!w[E]&&E.charCodeAt(0)===36&&(w[E]=(...o)=>this._remoteCall(a,E,o)),E===c?d:w[E])};return new Proxy(Object.create(null),f)}set(a,d){return this._locals[a.nid]=d,d}assertRegistered(a){for(let d=0,f=a.length;d<f;d++){const w=a[d];if(!this._locals[w.nid])throw new Error(`Missing actor ${w.sid} (isMain: ${w.isMain})`)}}_receiveOneMessage(a){if(this._isDisposed)return;const d=a.byteLength,f=p.read(a,0),w=f.readUInt8(),E=f.readUInt32();switch(w){case 1:case 2:{let{rpcId:o,method:I,args:L}=t.deserializeRequestJSONArgs(f);this._uriTransformer&&(L=(0,D.transformIncomingURIs)(L,this._uriTransformer)),this._receiveRequest(d,E,o,I,L,w===2);break}case 3:case 4:{let{rpcId:o,method:I,args:L}=t.deserializeRequestMixedArgs(f);this._uriTransformer&&(L=(0,D.transformIncomingURIs)(L,this._uriTransformer)),this._receiveRequest(d,E,o,I,L,w===4);break}case 5:{this._logger&&this._logger.logIncoming(d,E,0,"ack"),this._onDidReceiveAcknowledge(E);break}case 6:{this._receiveCancel(d,E);break}case 7:{this._receiveReply(d,E,void 0);break}case 9:{let o=t.deserializeReplyOKJSON(f);this._uriTransformer&&(o=(0,D.transformIncomingURIs)(o,this._uriTransformer)),this._receiveReply(d,E,o);break}case 8:{let o=t.deserializeReplyOKVSBuffer(f);this._receiveReply(d,E,o);break}case 10:{let o=t.deserializeReplyErrError(f);this._uriTransformer&&(o=(0,D.transformIncomingURIs)(o,this._uriTransformer)),this._receiveReplyErr(d,E,o);break}case 11:{this._receiveReplyErr(d,E,void 0);break}default:console.error("received unexpected message"),console.error(a)}}_receiveRequest(a,d,f,w,E,o){this._logger&&this._logger.logIncoming(a,d,1,`receiveRequest ${(0,A.getStringIdentifierForProxy)(f)}.${w}(`,E);const I=String(d);let L,U;if(o){const ee=new R.CancellationTokenSource;E.push(ee.token),L=this._invokeHandler(f,w,E),U=()=>ee.cancel()}else L=this._invokeHandler(f,w,E),U=b;this._cancelInvokedHandlers[I]=U;const V=t.serializeAcknowledged(d);this._logger&&this._logger.logOutgoing(V.byteLength,d,1,"ack"),this._protocol.send(V),L.then(ee=>{delete this._cancelInvokedHandlers[I];const K=t.serializeReplyOK(d,ee,this._uriReplacer);this._logger&&this._logger.logOutgoing(K.byteLength,d,1,"reply:",ee),this._protocol.send(K)},ee=>{delete this._cancelInvokedHandlers[I];const K=t.serializeReplyErr(d,ee);this._logger&&this._logger.logOutgoing(K.byteLength,d,1,"replyErr:",ee),this._protocol.send(K)})}_receiveCancel(a,d){this._logger&&this._logger.logIncoming(a,d,1,"receiveCancel");const f=String(d);this._cancelInvokedHandlers[f]&&this._cancelInvokedHandlers[f]()}_receiveReply(a,d,f){this._logger&&this._logger.logIncoming(a,d,0,"receiveReply:",f);const w=String(d);if(!this._pendingRPCReplies.hasOwnProperty(w))return;const E=this._pendingRPCReplies[w];delete this._pendingRPCReplies[w],E.resolveOk(f)}_receiveReplyErr(a,d,f){this._logger&&this._logger.logIncoming(a,d,0,"receiveReplyErr:",f);const w=String(d);if(!this._pendingRPCReplies.hasOwnProperty(w))return;const E=this._pendingRPCReplies[w];delete this._pendingRPCReplies[w];let o;f&&(f.$isError?(o=new Error,o.name=f.name,o.message=f.message,o.stack=f.stack):o=f),E.resolveErr(o)}_invokeHandler(a,d,f){try{return Promise.resolve(this._doInvokeHandler(a,d,f))}catch(w){return Promise.reject(w)}}_doInvokeHandler(a,d,f){const w=this._locals[a];if(!w)throw new Error("Unknown actor "+(0,A.getStringIdentifierForProxy)(a));let E=w[d];if(typeof E!="function")throw new Error("Unknown method "+d+" on actor "+(0,A.getStringIdentifierForProxy)(a));return E.apply(w,f)}_remoteCall(a,d,f){if(this._isDisposed)return Promise.reject(k.canceled());let w=null;if(f.length>0&&R.CancellationToken.isCancellationToken(f[f.length-1])&&(w=f.pop()),w&&w.isCancellationRequested)return Promise.reject(k.canceled());const E=t.serializeRequestArguments(f,this._uriReplacer),o=++this._lastMessageId,I=String(o),L=new y.LazyPromise;w&&w.onCancellationRequested(()=>{const V=t.serializeCancel(o);this._logger&&this._logger.logOutgoing(V.byteLength,o,0,"cancel"),this._protocol.send(t.serializeCancel(o))}),this._pendingRPCReplies[I]=L,this._onWillSendRequest(o);const U=t.serializeRequest(o,a,d,E,!!w);return this._logger&&this._logger.logOutgoing(U.byteLength,o,0,`request: ${(0,A.getStringIdentifierForProxy)(a)}.${d}(`,f),this._protocol.send(U),L}}e.RPCProtocol=h,C=P,h.UNRESPONSIVE_TIME=3*1e3;class p{constructor(a,d){this._buff=a,this._offset=d}static alloc(a,d,f){let w=new p(i.VSBuffer.alloc(f+1+4),0);return w.writeUInt8(a),w.writeUInt32(d),w}static read(a,d){return new p(a,d)}get buffer(){return this._buff}static sizeUInt8(){return 1}writeUInt8(a){this._buff.writeUInt8(a,this._offset),this._offset+=1}readUInt8(){const a=this._buff.readUInt8(this._offset);return this._offset+=1,a}writeUInt32(a){this._buff.writeUInt32BE(a,this._offset),this._offset+=4}readUInt32(){const a=this._buff.readUInt32BE(this._offset);return this._offset+=4,a}static sizeShortString(a){return 1+a.byteLength}writeShortString(a){this._buff.writeUInt8(a.byteLength,this._offset),this._offset+=1,this._buff.set(a,this._offset),this._offset+=a.byteLength}readShortString(){const a=this._buff.readUInt8(this._offset);this._offset+=1;const f=this._buff.slice(this._offset,this._offset+a).toString();return this._offset+=a,f}static sizeLongString(a){return 4+a.byteLength}writeLongString(a){this._buff.writeUInt32BE(a.byteLength,this._offset),this._offset+=4,this._buff.set(a,this._offset),this._offset+=a.byteLength}readLongString(){const a=this._buff.readUInt32BE(this._offset);this._offset+=4;const f=this._buff.slice(this._offset,this._offset+a).toString();return this._offset+=a,f}writeBuffer(a){this._buff.writeUInt32BE(a.byteLength,this._offset),this._offset+=4,this._buff.set(a,this._offset),this._offset+=a.byteLength}static sizeVSBuffer(a){return 4+a.byteLength}writeVSBuffer(a){this._buff.writeUInt32BE(a.byteLength,this._offset),this._offset+=4,this._buff.set(a,this._offset),this._offset+=a.byteLength}readVSBuffer(){const a=this._buff.readUInt32BE(this._offset);this._offset+=4;const d=this._buff.slice(this._offset,this._offset+a);return this._offset+=a,d}static sizeMixedArray(a,d){let f=0;f+=1;for(let w=0,E=a.length;w<E;w++){const o=a[w],I=d[w];switch(f+=1,I){case 1:f+=this.sizeLongString(o);break;case 2:f+=this.sizeVSBuffer(o);break;case 3:break}}return f}writeMixedArray(a,d){this._buff.writeUInt8(a.length,this._offset),this._offset+=1;for(let f=0,w=a.length;f<w;f++){const E=a[f];switch(d[f]){case 1:this.writeUInt8(1),this.writeLongString(E);break;case 2:this.writeUInt8(2),this.writeVSBuffer(E);break;case 3:this.writeUInt8(3);break}}}readMixedArray(){const a=this._buff.readUInt8(this._offset);this._offset+=1;let d=new Array(a);for(let f=0;f<a;f++)switch(this.readUInt8()){case 1:d[f]=this.readLongString();break;case 2:d[f]=this.readVSBuffer();break;case 3:d[f]=void 0;break}return d}}class t{static _arrayContainsBufferOrUndefined(a){for(let d=0,f=a.length;d<f;d++)if(a[d]instanceof i.VSBuffer||typeof a[d]=="undefined")return!0;return!1}static serializeRequestArguments(a,d){if(this._arrayContainsBufferOrUndefined(a)){let f=[],w=[];for(let E=0,o=a.length;E<o;E++){const I=a[E];I instanceof i.VSBuffer?(f[E]=I,w[E]=2):typeof I=="undefined"?(f[E]=i.VSBuffer.alloc(0),w[E]=3):(f[E]=i.VSBuffer.fromString(m(I,d)),w[E]=1)}return{type:"mixed",args:f,argsType:w}}return{type:"simple",args:m(a,d)}}static serializeRequest(a,d,f,w,E){return w.type==="mixed"?this._requestMixedArgs(a,d,f,w.args,w.argsType,E):this._requestJSONArgs(a,d,f,w.args,E)}static _requestJSONArgs(a,d,f,w,E){const o=i.VSBuffer.fromString(f),I=i.VSBuffer.fromString(w);let L=0;L+=p.sizeUInt8(),L+=p.sizeShortString(o),L+=p.sizeLongString(I);let U=p.alloc(E?2:1,a,L);return U.writeUInt8(d),U.writeShortString(o),U.writeLongString(I),U.buffer}static deserializeRequestJSONArgs(a){const d=a.readUInt8(),f=a.readShortString(),w=a.readLongString();return{rpcId:d,method:f,args:JSON.parse(w)}}static _requestMixedArgs(a,d,f,w,E,o){const I=i.VSBuffer.fromString(f);let L=0;L+=p.sizeUInt8(),L+=p.sizeShortString(I),L+=p.sizeMixedArray(w,E);let U=p.alloc(o?4:3,a,L);return U.writeUInt8(d),U.writeShortString(I),U.writeMixedArray(w,E),U.buffer}static deserializeRequestMixedArgs(a){const d=a.readUInt8(),f=a.readShortString(),w=a.readMixedArray(),E=new Array(w.length);for(let o=0,I=w.length;o<I;o++){const L=w[o];typeof L=="string"?E[o]=JSON.parse(L):E[o]=L}return{rpcId:d,method:f,args:E}}static serializeAcknowledged(a){return p.alloc(5,a,0).buffer}static serializeCancel(a){return p.alloc(6,a,0).buffer}static serializeReplyOK(a,d,f){return typeof d=="undefined"?this._serializeReplyOKEmpty(a):d instanceof i.VSBuffer?this._serializeReplyOKVSBuffer(a,d):this._serializeReplyOKJSON(a,u(d,f))}static _serializeReplyOKEmpty(a){return p.alloc(7,a,0).buffer}static _serializeReplyOKVSBuffer(a,d){let f=0;f+=p.sizeVSBuffer(d);let w=p.alloc(8,a,f);return w.writeVSBuffer(d),w.buffer}static deserializeReplyOKVSBuffer(a){return a.readVSBuffer()}static _serializeReplyOKJSON(a,d){const f=i.VSBuffer.fromString(d);let w=0;w+=p.sizeLongString(f);let E=p.alloc(9,a,w);return E.writeLongString(f),E.buffer}static deserializeReplyOKJSON(a){const d=a.readLongString();return JSON.parse(d)}static serializeReplyErr(a,d){return d?this._serializeReplyErrEror(a,d):this._serializeReplyErrEmpty(a)}static _serializeReplyErrEror(a,d){const f=i.VSBuffer.fromString(u(k.transformErrorForSerialization(d),null));let w=0;w+=p.sizeLongString(f);let E=p.alloc(10,a,w);return E.writeLongString(f),E.buffer}static deserializeReplyErrError(a){const d=a.readLongString();return JSON.parse(d)}static _serializeReplyErrEmpty(a){return p.alloc(11,a,0).buffer}}var r;(function(n){n[n.RequestJSONArgs=1]="RequestJSONArgs",n[n.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",n[n.RequestMixedArgs=3]="RequestMixedArgs",n[n.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",n[n.Acknowledged=5]="Acknowledged",n[n.Cancel=6]="Cancel",n[n.ReplyOKEmpty=7]="ReplyOKEmpty",n[n.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",n[n.ReplyOKJSON=9]="ReplyOKJSON",n[n.ReplyErrError=10]="ReplyErrError",n[n.ReplyErrEmpty=11]="ReplyErrEmpty"})(r||(r={}));var s;(function(n){n[n.String=1]="String",n[n.VSBuffer=2]="VSBuffer",n[n.Undefined=3]="Undefined"})(s||(s={}))}),define(me[264],ge([0,1,4]),function(J,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,g.createDecorator)("remoteAgentService")}),define(me[265],ge([0,1,10,9,11,2,4,84,43,222,264]),function(J,e,g,R,k,S,T,D,y,A,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,T.createDecorator)("pathService");let C=class $n{constructor(m,l,v,_){this.localUserHome=m,this.remoteAgentService=l,this.environmentService=v,this.contextService=_,this.resolveOS=(async()=>(await this.remoteAgentService.getEnvironment())?.os||k.OS)(),this.resolveUserHome=(async()=>{const b=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=b?.userHome||m})()}get defaultUriScheme(){return $n.findDefaultUriScheme(this.environmentService,this.contextService)}static findDefaultUriScheme(m,l){if(m.remoteAuthority)return g.Schemas.vscodeRemote;const v=(0,D.getVirtualWorkspaceScheme)(l.getWorkspace());if(v)return v;const _=l.getWorkspace().folders[0];if(_)return _.uri.scheme;const b=l.getWorkspace().configuration;return b?b.scheme:g.Schemas.file}async userHome(m){return m?.preferLocal?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(m=>m===1?R.win32:R.posix)}async fileURI(m){let l="";if(await this.resolveOS===1&&(m=m.replace(/\\/g,"/")),m[0]==="/"&&m[1]==="/"){const _=m.indexOf("/",2);_===-1?(l=m.substring(2),m="/"):(l=m.substring(2,_),m=m.substring(_)||"/")}return S.URI.from({scheme:g.Schemas.file,authority:l,path:m,query:"",fragment:""})}};C=Ve([$e(1,i.IRemoteAgentService),$e(2,A.IWorkbenchEnvironmentService),$e(3,y.IWorkspaceContextService)],C),e.AbstractPathService=C}),define(me[68],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class g{constructor(T,D){this.line=T,this.character=D}isBefore(T){return!1}isBeforeOrEqual(T){return!1}isAfter(T){return!1}isAfterOrEqual(T){return!1}isEqual(T){return!1}compareTo(T){return 0}translate(T,D){return new g(0,0)}with(T){return new g(0,0)}}e.Position=g;class R{constructor(T,D,y,A){this.isEmpty=!1,this.isSingleLine=!1,this.start=new g(T,D),this.end=new g(y,A)}contains(T){return!1}isEqual(T){return!1}intersection(T){}union(T){return new R(0,0,0,0)}with(T){return new R(0,0,0,0)}}e.Range=R;var k;(function(S){S[S.Information=1]="Information",S[S.Warning=2]="Warning"})(k=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(me[31],ge([0,1,20,30,25,29,8,4,9,15,68]),function(J,e,g,R,k,S,T,D,y,A,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return i.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const C="\u27EA ",u=" characters skipped \u27EB",m=(C.length+u.length+5)*2;e.ISearchService=(0,D.createDecorator)("searchService");var l;(function(F){F[F.file=0]="file",F[F.text=1]="text"})(l=e.SearchProviderType||(e.SearchProviderType={}));var v;(function(F){F[F.File=1]="File",F[F.Text=2]="Text"})(v=e.QueryType||(e.QueryType={}));function _(F){return!!F.preview}e.resultIsMatch=_;function b(F){return!!F.resource}e.isFileMatch=b;function P(F){return!!F.message}e.isProgressMessage=P;var c;(function(F){F[F.Normal=0]="Normal",F[F.NewSearchStarted=1]="NewSearchStarted"})(c=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class h{constructor(z){this.resource=z,this.results=[]}}e.FileMatch=h;class p{constructor(z,M,O){this.ranges=M;const q=Array.isArray(M)?M:[M];if(O&&O.matchLines===1&&t(q)){z=(0,T.getNLines)(z,O.matchLines);let B="",G=0,ie=0;const he=Math.floor(O.charsPerLine/5),ye=[];for(const Ie of q){const Le=Math.max(Ie.startColumn-he,0),qe=Ie.startColumn+O.charsPerLine;if(Le>ie+he+m){const We=C+(Le-ie)+u;B+=We+z.slice(Le,qe),G+=Le-(ie+We.length)}else B+=z.slice(ie,qe);ye.push(new s(0,Ie.startColumn-G,Ie.endColumn-G)),ie=qe}this.preview={text:B,matches:Array.isArray(this.ranges)?ye:ye[0]}}else{const B=Array.isArray(M)?M[0].startLineNumber:M.startLineNumber;this.preview={text:z,matches:(0,g.mapArrayOrNot)(M,G=>new r(G.startLineNumber-B,G.startColumn,G.endLineNumber-B,G.endColumn))}}}}e.TextSearchMatch=p;function t(F){const z=F[0].startLineNumber;for(const M of F)if(M.startLineNumber!==z||M.endLineNumber!==z)return!1;return!0}class r{constructor(z,M,O,q){this.startLineNumber=z,this.startColumn=M,this.endLineNumber=O,this.endColumn=q}}e.SearchRange=r;class s extends r{constructor(z,M,O){super(z,M,z,O)}}e.OneLineRange=s;var n;(function(F){F.Default="default",F.FileNames="fileNames",F.Type="type",F.Modified="modified",F.CountDescending="countDescending",F.CountAscending="countAscending"})(n=e.SearchSortOrder||(e.SearchSortOrder={}));function a(F,z=!0){const M=F&&F.files&&F.files.exclude,O=z&&F&&F.search&&F.search.exclude;if(!M&&!O)return;if(!M||!O)return M||O;let q=Object.create(null);return q=k.mixin(q,k.deepClone(M)),q=k.mixin(q,k.deepClone(O),!0),q}e.getExcludes=a;function d(F,z){return F.excludePattern&&R.match(F.excludePattern,z)?!1:F.includePattern||F.usingSearchPaths?F.includePattern&&R.match(F.includePattern,z)?!0:F.usingSearchPaths?!!F.folderQueries&&F.folderQueries.some(M=>{const O=M.folder.fsPath;if(S.isEqualOrParent(z,O)){const q=y.relative(O,z);return!M.includePattern||!!R.match(M.includePattern,q)}else return!1}):!1:!0}e.pathIncludedInQuery=d;var f;(function(F){F[F.unknownEncoding=1]="unknownEncoding",F[F.regexParseError=2]="regexParseError",F[F.globParseError=3]="globParseError",F[F.invalidLiteral=4]="invalidLiteral",F[F.rgProcessError=5]="rgProcessError",F[F.other=6]="other",F[F.canceled=7]="canceled"})(f=e.SearchErrorCode||(e.SearchErrorCode={}));class w extends Error{constructor(z,M){super(z);this.code=M}}e.SearchError=w;function E(F){const z=F.message;if((0,A.isPromiseCanceledError)(F))return new w(z,f.canceled);try{const M=JSON.parse(z);return new w(M.message,M.code)}catch(M){return new w(z,f.other)}}e.deserializeSearchError=E;function o(F){const z={message:F.message,code:F.code};return new Error(JSON.stringify(z))}e.serializeSearchError=o;function I(F){return F.type==="error"?!0:F.type==="success"}e.isSerializedSearchComplete=I;function L(F){return F.type==="success"}e.isSerializedSearchSuccess=L;function U(F){return!!F.path}e.isSerializedFileMatch=U;function V(F,z){const M=F.searchPath?F.searchPath:F.relativePath;return(0,T.fuzzyContains)(M,z)}e.isFilePatternMatch=V;class ee{constructor(z){this.path=z,this.results=[]}addMatch(z){this.results.push(z)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=ee;function K(F,z){const M={...F||{},...z||{}};return Object.keys(M).filter(O=>{const q=M[O];return typeof q=="boolean"&&q})}e.resolvePatternsForProvider=K;class N{constructor(z,M){this._parsedIncludeExpression=null,this._excludeExpression={...z.excludePattern||{},...M.excludePattern||{}},this._parsedExcludeExpression=R.parse(this._excludeExpression);let O=z.includePattern;M.includePattern&&(O?O={...O,...M.includePattern}:O=M.includePattern),O&&(this._parsedIncludeExpression=R.parse(O))}includedInQuerySync(z,M,O){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(z,M,O)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(z,M,O))}includedInQuery(z,M,O){return Promise.resolve(this._parsedExcludeExpression(z,M,O)).then(B=>!!B).then(B=>B?!1:this._parsedIncludeExpression?Promise.resolve(this._parsedIncludeExpression(z,M,O)).then(G=>!!G):Promise.resolve(!0)).then(B=>B)}hasSiblingExcludeClauses(){return x(this._excludeExpression)}}e.QueryGlobTester=N;function x(F){for(const z in F)if(typeof F[z]!="boolean")return!0;return!1}}),define(me[36],ge([0,1,20,16,21,3,22,10,75,23,8,14,2,169,4,12,189,43,62,27,13,7,31,5]),function(J,e,g,R,k,S,T,D,y,A,i,C,u,m,l,v,_,b,P,c,h,p,t,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function s(I,L,U){return new A.ExtUri(V=>f(V,U)).isEqual(I,L)}function n(I,L,U){return s(I.uri,L.uri,U)?0:(0,i.compare)(I.uri.toString(),L.uri.toString())}function a(I,L,U){return I.index!==L.index?I.index<L.index?-1:1:s(I.uri,L.uri,U)?(0,i.compare)(I.name,L.name):(0,i.compare)(I.uri.toString(),L.uri.toString())}function d(I,L,U,V){const ee=I.slice(0).sort((N,x)=>U(N,x,V)),K=L.slice(0).sort((N,x)=>U(N,x,V));return(0,g.delta)(ee,K,(N,x)=>U(N,x,V))}function f(I,L){const U=L.getCapabilities(I.scheme);return!(U&&U&1024)}class w extends b.Workspace{constructor(L,U,V,ee,K,N){super(L,V.map(x=>new b.WorkspaceFolder(x)),ee,N);this._name=U,this._isUntitled=K,this._workspaceFolders=[],this._structure=T.TernarySearchTree.forUris(N),V.forEach(x=>{this._workspaceFolders.push(x),this._structure.set(x.uri,x)})}static toExtHostWorkspace(L,U,V,ee){if(!L)return{workspace:null,added:[],removed:[]};const{id:K,name:N,folders:x,configuration:F,isUntitled:z}=L,M=[],O=U;U?x.forEach((ie,he)=>{const ye=u.URI.revive(ie.uri),Ie=w._findFolder(V||U,ye,ee);Ie?(Ie.name=ie.name,Ie.index=ie.index,M.push(Ie)):M.push({uri:ye,name:ie.name,index:he})}):M.push(...x.map(({uri:ie,name:he,index:ye})=>({uri:u.URI.revive(ie),name:he,index:ye}))),M.sort((ie,he)=>ie.index<he.index?-1:1);const q=new w(K,N,M,F?u.URI.revive(F):null,!!z,ie=>f(ie,ee)),{added:B,removed:G}=d(O?O.workspaceFolders:[],q.workspaceFolders,n,ee);return{workspace:q,added:B,removed:G}}static _findFolder(L,U,V){for(let ee=0;ee<L.folders.length;ee++){const K=L.workspaceFolders[ee];if(s(K.uri,U,V))return K}}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(L,U){return U&&this._structure.get(L)&&(L=(0,A.dirname)(L)),this._structure.findSubstr(L)}resolveWorkspaceFolder(L){return this._structure.get(L)}}let E=class{constructor(L,U,V,ee){this._onDidChangeWorkspace=new S.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new S.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._logService=ee,this._extHostFileSystemInfo=V,this._requestIdProvider=new y.Counter,this._barrier=new R.Barrier,this._proxy=L.getProxy(r.MainContext.MainThreadWorkspace),this._messageService=L.getProxy(r.MainContext.MainThreadMessageService);const K=U.workspace;this._confirmedWorkspace=K?new w(K.id,K.name,[],K.configuration?u.URI.revive(K.configuration):null,!!K.isUntitled,N=>f(N,V)):void 0}$initializeWorkspace(L,U){this._trusted=U,this.$acceptWorkspaceData(L),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?u.URI.from({scheme:D.Schemas.untitled,path:(0,A.basename)((0,A.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(L,U,V,...ee){const K=[];if(Array.isArray(ee)&&ee.forEach(M=>{u.URI.isUri(M.uri)&&!K.some(O=>s(O.uri,M.uri,this._extHostFileSystemInfo))&&K.push({uri:M.uri,name:M.name||(0,A.basenameOrAuthority)(M.uri)})}),this._unconfirmedWorkspace||[U,V].some(M=>typeof M!="number"||M<0)||V===0&&K.length===0)return!1;const N=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(U+V>N.length)return!1;const x=N.slice(0);x.splice(U,V,...K.map(M=>({uri:M.uri,name:M.name||(0,A.basenameOrAuthority)(M.uri),index:void 0})));for(let M=0;M<x.length;M++){const O=x[M];if(x.some((q,B)=>B!==M&&s(O.uri,q.uri,this._extHostFileSystemInfo)))return!1}x.forEach((M,O)=>M.index=O);const{added:F,removed:z}=d(N,x,a,this._extHostFileSystemInfo);if(F.length===0&&z.length===0)return!1;if(this._proxy){const M=L.displayName||L.name;this._proxy.$updateWorkspaceFolders(M,U,V,K).then(void 0,O=>{this._unconfirmedWorkspace=void 0,this._messageService.$showMessage(_.Severity.Error,(0,m.localize)(0,null,M,O.toString()),{extension:L},[])})}return this.trySetWorkspaceFolders(x),!0}getWorkspaceFolder(L,U){if(!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(L,U)}async getWorkspaceFolder2(L,U){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(L,U)}async resolveWorkspaceFolder(L){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(L)}getPath(){if(!this._actualWorkspace)return;const{folders:L}=this._actualWorkspace;if(L.length!==0)return L[0].uri.fsPath}getRelativePath(L,U){let V,ee="";if(typeof L=="string"?(V=u.URI.file(L),ee=L):typeof L!="undefined"&&(V=L,ee=L.fsPath),!V)return ee;const K=this.getWorkspaceFolder(V,!0);if(!K)return ee;typeof U=="undefined"&&this._actualWorkspace&&(U=this._actualWorkspace.folders.length>1);let N=(0,A.relativePath)(K.uri,V);return U&&K.name&&(N=`${K.name}/${N}`),N}trySetWorkspaceFolders(L){this._actualWorkspace&&(this._unconfirmedWorkspace=w.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:L,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(L){const{workspace:U,added:V,removed:ee}=w.toExtHostWorkspace(L,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=U||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:V,removed:ee}))}findFiles(L,U,V,ee,K=k.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${ee.value}, entryPoint: findFiles`);let N;if(U===null?N=!1:U&&(typeof U=="string"?N=U:N=U.pattern),K&&K.isCancellationRequested)return Promise.resolve([]);const{includePattern:x,folder:F}=o(L);return this._proxy.$startFileSearch((0,C.withUndefinedAsNull)(x),(0,C.withUndefinedAsNull)(F),(0,C.withUndefinedAsNull)(N),(0,C.withUndefinedAsNull)(V),K).then(z=>Array.isArray(z)?z.map(M=>u.URI.revive(M)):[])}async findTextInFiles(L,U,V,ee,K=k.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${ee.value}, entryPoint: findTextInFiles`);const N=this._requestIdProvider.getNext(),x=typeof U.previewOptions=="undefined"?{matchLines:100,charsPerLine:1e4}:U.previewOptions,{includePattern:F,folder:z}=o(U.include),M=typeof U.exclude=="string"?U.exclude:U.exclude?U.exclude.pattern:void 0,O={ignoreSymlinks:typeof U.followSymlinks=="boolean"?!U.followSymlinks:void 0,disregardIgnoreFiles:typeof U.useIgnoreFiles=="boolean"?!U.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof U.useGlobalIgnoreFiles=="boolean"?!U.useGlobalIgnoreFiles:void 0,disregardExcludeSettings:typeof U.useDefaultExcludes=="boolean"?!U.useDefaultExcludes:!0,fileEncoding:U.encoding,maxResults:U.maxResults,previewOptions:x,afterContext:U.afterContext,beforeContext:U.beforeContext,includePattern:F,excludePattern:M},q=!1;if(this._activeSearchCallbacks[N]=B=>{if(q)return;const G=u.URI.revive(B.resource);B.results.forEach(ie=>{(0,t.resultIsMatch)(ie)?V({uri:G,preview:{text:ie.preview.text,matches:(0,g.mapArrayOrNot)(ie.preview.matches,he=>new p.Range(he.startLineNumber,he.startColumn,he.endLineNumber,he.endColumn))},ranges:(0,g.mapArrayOrNot)(ie.ranges,he=>new p.Range(he.startLineNumber,he.startColumn,he.endLineNumber,he.endColumn))}):V({uri:G,text:ie.text,lineNumber:ie.lineNumber})})},K.isCancellationRequested)return{};try{const B=await this._proxy.$startTextSearch(L,(0,C.withUndefinedAsNull)(z),O,N,K);return delete this._activeSearchCallbacks[N],B||{}}catch(B){throw delete this._activeSearchCallbacks[N],B}}$handleTextSearchResult(L,U){this._activeSearchCallbacks[U]&&this._activeSearchCallbacks[U](L)}saveAll(L){return this._proxy.$saveAll(L)}resolveProxy(L){return this._proxy.$resolveProxy(L)}get trusted(){return this._trusted}requestWorkspaceTrust(L){return this._proxy.$requestWorkspaceTrust(L)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}};E=Ve([$e(0,h.IExtHostRpcService),$e(1,c.IExtHostInitDataService),$e(2,P.IExtHostFileSystemInfo),$e(3,v.ILogService)],E),e.ExtHostWorkspace=E,e.IExtHostWorkspace=(0,l.createDecorator)("IExtHostWorkspace");function o(I){let L,U;return I&&(typeof I=="string"?L=I:(L=I.pattern,U=I.baseFolder||u.URI.file(I.base))),{includePattern:L,folder:U}}}),define(me[37],ge([0,1,25,3,36,5,7,192,83,14,16,4,13,12,2]),function(J,e,g,R,k,S,T,D,y,A,i,C,u,m,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function v(r,s){if(s){const n=s.split(".");let a=r;for(let d=0;a&&d<n.length;d++)a=a[n[d]];return a}}function _(r){return r instanceof l.URI}function b(r){return r&&r.uri instanceof l.URI&&r.languageId&&typeof r.languageId=="string"}function P(r){return r&&!r.uri&&r.languageId&&typeof r.languageId=="string"}function c(r){return r&&r.uri instanceof l.URI&&(!r.name||typeof r.name=="string")&&(!r.index||typeof r.index=="number")}function h(r){if(_(r))return{resource:r};if(b(r))return{resource:r.uri,overrideIdentifier:r.languageId};if(P(r))return{overrideIdentifier:r.languageId};if(c(r))return{resource:r.uri};if(r===null)return{resource:null}}let p=class{constructor(s,n,a){this._proxy=s.getProxy(S.MainContext.MainThreadConfiguration),this._extHostWorkspace=n,this._logService=a,this._barrier=new i.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(s=>this._actual)}$initializeConfiguration(s){this._actual=new t(this._proxy,this._extHostWorkspace,s,this._logService),this._barrier.open()}$acceptConfigurationChanged(s,n){this.getConfigProvider().then(a=>a.$acceptConfigurationChanged(s,n))}};p=Ve([$e(0,u.IExtHostRpcService),$e(1,k.IExtHostWorkspace),$e(2,m.ILogService)],p),e.ExtHostConfiguration=p;class t{constructor(s,n,a,d){this._onDidChangeConfiguration=new R.Emitter,this._proxy=s,this._logService=d,this._extHostWorkspace=n,this._configuration=D.Configuration.parse(a),this._configurationScopes=this._toMap(a.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(s,n){const a={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=D.Configuration.parse(s),this._configurationScopes=this._toMap(s.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(n,a))}getConfiguration(s,n,a){const d=h(n)||{},f=this._toReadonlyValue(s?v(this._configuration.getValue(void 0,d,this._extHostWorkspace.workspace),s):this._configuration.getValue(void 0,d,this._extHostWorkspace.workspace));s&&this._validateConfigurationAccess(s,d,a?.identifier);function w(o){if(o==null)return null;if(typeof o=="boolean")return o?1:4;switch(o){case T.ConfigurationTarget.Global:return 1;case T.ConfigurationTarget.Workspace:return 4;case T.ConfigurationTarget.WorkspaceFolder:return 5}}const E={has(o){return typeof v(f,o)!="undefined"},get:(o,I)=>{this._validateConfigurationAccess(s?`${s}.${o}`:o,d,a?.identifier);let L=v(f,o);if(typeof L=="undefined")L=I;else{let U;const V=(ee,K)=>{let N;const x=()=>{U=U||(0,g.deepClone)(f),N=N||v(U,K)};return(0,A.isObject)(ee)?new Proxy(ee,{get:(F,z)=>{if(typeof z=="string"&&z.toLowerCase()==="tojson")return x(),()=>N;if(U)return N=N||v(U,K),N[z];const M=F[z];return typeof z=="string"?V(M,`${K}.${z}`):M},set:(F,z,M)=>(x(),N&&(N[z]=M),!0),deleteProperty:(F,z)=>(x(),N&&delete N[z],!0),defineProperty:(F,z,M)=>(x(),N&&Object.defineProperty(N,z,M),!0)}):ee};L=V(L,o)}return L},update:(o,I,L,U)=>{o=s?`${s}.${o}`:o;const V=w(L);return I!==void 0?this._proxy.$updateConfigurationOption(V,o,I,d,U):this._proxy.$removeConfigurationOption(V,o,d,U)},inspect:o=>{o=s?`${s}.${o}`:o;const I=(0,g.deepClone)(this._configuration.inspect(o,d,this._extHostWorkspace.workspace));if(I)return{key:o,defaultValue:I.default?.value,globalValue:I.user?.value,workspaceValue:I.workspace?.value,workspaceFolderValue:I.workspaceFolder?.value,defaultLanguageValue:I.default?.override,globalLanguageValue:I.user?.override,workspaceLanguageValue:I.workspace?.override,workspaceFolderLanguageValue:I.workspaceFolder?.override,languageIds:I.overrideIdentifiers}}};return typeof f=="object"&&(0,g.mixin)(E,f,!1),Object.freeze(E)}_toReadonlyValue(s){const n=a=>(0,A.isObject)(a)?new Proxy(a,{get:(d,f)=>n(d[f]),set:(d,f,w)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(f)}' of object`)},deleteProperty:(d,f)=>{throw new Error(`TypeError: Cannot delete read only property '${String(f)}' of object`)},defineProperty:(d,f)=>{throw new Error(`TypeError: Cannot define property '${String(f)}' for a readonly object`)},setPrototypeOf:d=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):a;return n(s)}_validateConfigurationAccess(s,n,a){const d=y.OVERRIDE_PROPERTY_PATTERN.test(s)?4:this._configurationScopes.get(s),f=a?`[${a.value}] `:"";if(d===4){typeof n?.resource=="undefined"&&this._logService.warn(`${f}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${s}', provide the URI of a resource or 'null' for any resource.`);return}if(d===3){n?.resource&&this._logService.warn(`${f}Accessing a window scoped configuration for a resource is not expected. To associate '${s}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(s,n){const a=new D.ConfigurationChangeEvent(s,n,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(d,f)=>a.affectsConfiguration(d,h(f))})}_toMap(s){return s.reduce((n,a)=>(n.set(a[0],a[1]),n),new Map)}}e.ExtHostConfigProvider=t,e.IExtHostConfiguration=(0,C.createDecorator)("IExtHostConfiguration")});var it=this&&this.__classPrivateFieldSet||function(J,e,g,R,k){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!k:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?k.call(J,g):k?k.value=g:e.set(J,g),g},He=this&&this.__classPrivateFieldGet||function(J,e,g,R){if(g==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!R:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?R:g==="a"?R.call(J):R?R.value:e.get(J)};define(me[69],ge([0,1,2,16,3,5,25,7,36,45,37,21,33,13,27,4,10,11,12,64,212,15]),function(J,e,g,R,k,S,T,D,y,A,i,C,u,m,l,v,_,b,P,c,h,p){"use strict";var t;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskExecutionDTO=e.TaskFilterDTO=e.TaskDTO=e.TaskGroupDTO=e.TaskHandleDTO=e.CustomExecutionDTO=e.ShellExecutionDTO=e.ShellExecutionOptionsDTO=e.ProcessExecutionDTO=e.ProcessExecutionOptionsDTO=e.TaskPresentationOptionsDTO=e.TaskDefinitionDTO=void 0;var r;(function(N){function x(z){if(z!=null)return z}N.from=x;function F(z){if(z!=null)return z}N.to=F})(r=e.TaskDefinitionDTO||(e.TaskDefinitionDTO={}));var s;(function(N){function x(z){if(z!=null)return z}N.from=x;function F(z){if(z!=null)return z}N.to=F})(s=e.TaskPresentationOptionsDTO||(e.TaskPresentationOptionsDTO={}));var n;(function(N){function x(z){if(z!=null)return z}N.from=x;function F(z){if(z!=null)return z}N.to=F})(n=e.ProcessExecutionOptionsDTO||(e.ProcessExecutionOptionsDTO={}));var a;(function(N){function x(M){if(M){const O=M;return O&&!!O.process}else return!1}N.is=x;function F(M){if(M==null)return;const O={process:M.process,args:M.args};return M.options&&(O.options=n.from(M.options)),O}N.from=F;function z(M){if(M!=null)return new D.ProcessExecution(M.process,M.args,M.options)}N.to=z})(a=e.ProcessExecutionDTO||(e.ProcessExecutionDTO={}));var d;(function(N){function x(z){if(z!=null)return z}N.from=x;function F(z){if(z!=null)return z}N.to=F})(d=e.ShellExecutionOptionsDTO||(e.ShellExecutionOptionsDTO={}));var f;(function(N){function x(M){if(M){const O=M;return O&&(!!O.commandLine||!!O.command)}else return!1}N.is=x;function F(M){if(M==null)return;const O={};return M.commandLine!==void 0?O.commandLine=M.commandLine:(O.command=M.command,O.args=M.args),M.options&&(O.options=d.from(M.options)),O}N.from=F;function z(M){if(!(M==null||M.command===void 0&&M.commandLine===void 0))return M.commandLine?new D.ShellExecution(M.commandLine,M.options):new D.ShellExecution(M.command,M.args?M.args:[],M.options)}N.to=z})(f=e.ShellExecutionDTO||(e.ShellExecutionDTO={}));var w;(function(N){function x(M){if(M){let O=M;return O&&O.customExecution==="customExecution"}else return!1}N.is=x;function F(M){return{customExecution:"customExecution"}}N.from=F;function z(M,O){return O.get(M)}N.to=z})(w=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var E;(function(N){function x(F,z){let M;return F.scope!==void 0&&typeof F.scope!="number"?M=F.scope.uri:F.scope!==void 0&&typeof F.scope=="number"&&(F.scope===D.TaskScope.Workspace&&z&&z.workspaceFile?M=z.workspaceFile:M=h.USER_TASKS_GROUP_KEY),{id:F._id,workspaceFolder:M}}N.from=x})(E=e.TaskHandleDTO||(e.TaskHandleDTO={}));var o;(function(N){function x(F){if(F!=null)return{_id:F.id,isDefault:F.isDefault}}N.from=x})(o=e.TaskGroupDTO||(e.TaskGroupDTO={}));var I;(function(N){function x(M,O){if(M==null)return[];const q=[];for(let B of M){const G=F(B,O);G&&q.push(G)}return q}N.fromMany=x;function F(M,O){if(M==null)return;let q;M.execution instanceof D.ProcessExecution?q=a.from(M.execution):M.execution instanceof D.ShellExecution?q=f.from(M.execution):M.execution&&M.execution instanceof D.CustomExecution&&(q=w.from(M.execution));const B=r.from(M.definition);let G;return M.scope?typeof M.scope=="number"?G=M.scope:G=M.scope.uri:G=D.TaskScope.Workspace,!B||!G?void 0:{_id:M._id,definition:B,name:M.name,source:{extensionId:O.identifier.value,label:M.source,scope:G},execution:q,isBackground:M.isBackground,group:o.from(M.group),presentationOptions:s.from(M.presentationOptions),problemMatchers:M.problemMatchers,hasDefinedMatchers:M.hasDefinedMatchers,runOptions:M.runOptions?M.runOptions:{reevaluateOnRerun:!0},detail:M.detail}}N.from=F;async function z(M,O,q){if(M==null)return;let B;a.is(M.execution)?B=a.to(M.execution):f.is(M.execution)?B=f.to(M.execution):w.is(M.execution)&&(B=w.to(M._id,q));const G=r.to(M.definition);let ie;if(M.source&&(M.source.scope!==void 0?typeof M.source.scope=="number"?ie=M.source.scope:ie=await O.resolveWorkspaceFolder(g.URI.revive(M.source.scope)):ie=D.TaskScope.Workspace),!G||!ie)return;const he=new D.Task(G,ie,M.name,M.source.label,B,M.problemMatchers);return M.isBackground!==void 0&&(he.isBackground=M.isBackground),M.group!==void 0&&(he.group=D.TaskGroup.from(M.group._id),he.group&&(he.group=T.deepClone(he.group),M.group.isDefault&&(he.group.isDefault=M.group.isDefault))),M.presentationOptions&&(he.presentationOptions=s.to(M.presentationOptions)),M._id&&(he._id=M._id),M.detail&&(he.detail=M.detail),he}N.to=z})(I=e.TaskDTO||(e.TaskDTO={}));var L;(function(N){function x(z){return z}N.from=x;function F(z){if(!!z)return Object.assign(Object.create(null),z)}N.to=F})(L=e.TaskFilterDTO||(e.TaskFilterDTO={}));class U{constructor(x,F,z){this._id=F,this._task=z,t.set(this,void 0),it(this,t,x,"f")}get task(){return this._task}terminate(){He(this,t,"f").terminateTask(this)}fireDidStartProcess(x){}fireDidEndProcess(x){}}t=new WeakMap;var V;(function(N){function x(F){return{id:F._id,task:void 0}}N.from=x})(V=e.TaskExecutionDTO||(e.TaskExecutionDTO={}));let ee=class{constructor(x,F,z,M,O,q,B,G){this._onDidExecuteTask=new k.Emitter,this._onDidTerminateTask=new k.Emitter,this._onDidTaskProcessStarted=new k.Emitter,this._onDidTaskProcessEnded=new k.Emitter,this._proxy=x.getProxy(S.MainContext.MainThreadTask),this._workspaceProvider=z,this._editorService=M,this._configurationService=O,this._terminalService=q,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=B,this._deprecationService=G,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(x,F,z){if(!z)return new D.Disposable(()=>{});const M=this.nextHandle();return this._handlers.set(M,{type:F,provider:z,extension:x}),this._proxy.$registerTaskProvider(M,F),new D.Disposable(()=>{this._handlers.delete(M),this._proxy.$unregisterTaskProvider(M)})}registerTaskSystem(x,F){this._proxy.$registerTaskSystem(x,F)}fetchTasks(x){return this._proxy.$fetchTasks(L.from(x)).then(async F=>{const z=[];for(let M of F){const O=await I.to(M,this._workspaceProvider,this._providedCustomExecutions2);O&&z.push(O)}return z})}get taskExecutions(){const x=[];return this._taskExecutions.forEach(F=>x.push(F)),x}terminateTask(x){if(!(x instanceof U))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(x._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(x,F,z){const M=this._providedCustomExecutions2.get(x.id);if(M){if(this._activeCustomExecutions2.get(x.id)!==void 0)throw new Error("We should not be trying to start the same custom task executions twice.");this._activeCustomExecutions2.set(x.id,M),this._terminalService.attachPtyToTerminal(F,await M.callback(z))}this._lastStartedTask=x.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(x)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(x){const F=await this.getTaskExecution(x);this._taskExecutionPromises.delete(x.id),this._taskExecutions.delete(x.id),this.customExecutionComplete(x),this._onDidTerminateTask.fire({execution:F})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(x){const F=await this.getTaskExecution(x.id);this._onDidTaskProcessStarted.fire({execution:F,processId:x.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(x){const F=await this.getTaskExecution(x.id);this._onDidTaskProcessEnded.fire({execution:F,exitCode:x.exitCode})}$provideTasks(x,F){const z=this._handlers.get(x);if(!z)return Promise.reject(new Error("no handler found"));const M=[],O=(0,R.asPromise)(()=>z.provider.provideTasks(C.CancellationToken.None)).then(q=>this.provideTasksInternal(F,M,z,q));return new Promise(q=>{O.then(B=>{Promise.all(M).then(()=>{q(B)})})})}async $resolveTask(x,F){const z=this._handlers.get(x);if(!z)return Promise.reject(new Error("no handler found"));if(F.definition.type!==z.type)throw new Error(`Unexpected: Task of type [${F.definition.type}] cannot be resolved by provider of type [${z.type}].`);const M=await I.to(F,this._workspaceProvider,this._providedCustomExecutions2);if(!M)throw new Error("Unexpected: Task cannot be resolved.");const O=await z.provider.resolveTask(M,C.CancellationToken.None);if(!O)return;this.checkDeprecation(O,z);const q=I.from(O,z.extension);if(!q)throw new Error("Unexpected: Task cannot be resolved.");if(O.definition!==M.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return w.is(q.execution)&&await this.addCustomExecution(q,O,!0),await this.resolveTaskInternal(q)}nextHandle(){return this._handleCounter++}async addCustomExecution(x,F,z){const M=await this._proxy.$createTaskId(x);!z&&!this._providedCustomExecutions2.has(M)&&this._notProvidedCustomExecutions.add(M),this._providedCustomExecutions2.set(M,F.execution)}async getTaskExecution(x,F){if(typeof x=="string"){const O=this._taskExecutionPromises.get(x);if(!O)throw new Error("Unexpected: The specified task is missing an execution");return O}let z=this._taskExecutionPromises.get(x.id);if(z)return z;const M=new Promise(async(O,q)=>{const B=F||await I.to(x.task,this._workspaceProvider,this._providedCustomExecutions2);B?O(new U(this,x.id,B)):q("Unexpected: Task does not exist.")});return this._taskExecutionPromises.set(x.id,M),M.then(O=>(this._taskExecutions.set(x.id,O),O),O=>Promise.reject(O))}checkDeprecation(x,F){x._deprecated&&this._deprecationService.report("Task.constructor",F.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(x){this._activeCustomExecutions2.get(x.id)&&this._activeCustomExecutions2.delete(x.id),this._notProvidedCustomExecutions.has(x.id)&&this._lastStartedTask!==x.id&&(this._providedCustomExecutions2.delete(x.id),this._notProvidedCustomExecutions.delete(x.id));let z=this._notProvidedCustomExecutions.values(),M=z.next();for(;!M.done;)!this._activeCustomExecutions2.has(M.value)&&this._lastStartedTask!==M.value&&(this._providedCustomExecutions2.delete(M.value),this._notProvidedCustomExecutions.delete(M.value)),M=z.next()}};ee=Ve([$e(0,m.IExtHostRpcService),$e(1,l.IExtHostInitDataService),$e(2,y.IExtHostWorkspace),$e(3,A.IExtHostDocumentsAndEditors),$e(4,i.IExtHostConfiguration),$e(5,u.IExtHostTerminalService),$e(6,P.ILogService),$e(7,c.IExtHostApiDeprecationService)],ee),e.ExtHostTaskBase=ee;let K=class extends ee{constructor(x,F,z,M,O,q,B,G){super(x,F,z,M,O,q,B,G);this.registerTaskSystem(_.Schemas.vscodeRemote,{scheme:_.Schemas.vscodeRemote,authority:"",platform:b.PlatformToString(0)})}async executeTask(x,F){if(!F.execution)throw new Error("Tasks to execute must include an execution");const z=I.from(F,x);if(z===void 0)throw new Error("Task is not valid");if(w.is(z.execution))await this.addCustomExecution(z,F,!1);else throw new p.NotSupportedError;const M=await this.getTaskExecution(await this._proxy.$getTaskExecution(z),F);return this._proxy.$executeTask(z).catch(O=>{throw new Error(O)}),M}provideTasksInternal(x,F,z,M){const O=[];if(M)for(let q of M){this.checkDeprecation(q,z),(!q.definition||!x[q.definition.type])&&this._logService.warn(`The task [${q.source}, ${q.name}] uses an undefined task type. The task will be ignored in the future.`);const B=I.from(q,z.extension);B&&w.is(B.execution)?(O.push(B),F.push(this.addCustomExecution(B,q,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:O,extension:z.extension}}async resolveTaskInternal(x){if(w.is(x.execution))return x;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(x,F){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(x,F,z){}};K=Ve([$e(0,m.IExtHostRpcService),$e(1,l.IExtHostInitDataService),$e(2,y.IExtHostWorkspace),$e(3,A.IExtHostDocumentsAndEditors),$e(4,i.IExtHostConfiguration),$e(5,u.IExtHostTerminalService),$e(6,P.ILogService),$e(7,c.IExtHostApiDeprecationService)],K),e.WorkerExtHostTask=K,e.IExtHostTask=(0,v.createDecorator)("IExtHostTask")}),define(me[266],ge([0,1,20,55,30,77,22,10,9,23,8,14,2,145,175,120,43,127,265,31]),function(J,e,g,R,k,S,T,D,y,A,i,C,u,m,l,v,_,b,P,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let h=class{constructor(w,E,o,I){this.configurationService=w,this.workspaceContextService=E,this.editorGroupsService=o,this.pathService=I}text(w,E,o={}){w=this.getContentPattern(w,o);const I=this.configurationService.getValue(),L=E&&E.some(V=>!this.configurationService.getValue({resource:V}).search.useRipgrep);return{...this.commonQuery(E?.map(_.toWorkspaceFolder),o),type:2,contentPattern:w,previewOptions:o.previewOptions,maxFileSize:o.maxFileSize,usePCRE2:I.search.usePCRE2||L||!1,beforeContext:o.beforeContext,afterContext:o.afterContext,userDisabledExcludesAndIgnoreFiles:o.disregardExcludeSettings&&o.disregardIgnoreFiles}}getContentPattern(w,E){const o=this.configurationService.getValue();w.isRegExp&&(w.pattern=w.pattern.replace(/\r?\n/g,"\\n"));const I={...w,wordSeparators:o.editor.wordSeparators};return this.isCaseSensitive(w,E)&&(I.isCaseSensitive=!0),this.isMultiline(w)&&(I.isMultiline=!0),I}file(w,E={}){return{...this.commonQuery(w,E),type:1,filePattern:E.filePattern?E.filePattern.trim():E.filePattern,exists:E.exists,sortByScore:E.sortByScore,cacheKey:E.cacheKey}}handleIncludeExclude(w,E){return w?(w=Array.isArray(w)?w.map(n):n(w),E?this.parseSearchPaths(w):{pattern:t(...Array.isArray(w)?w:[w])}):{}}commonQuery(w=[],E={}){const o=this.handleIncludeExclude(E.includePattern,E.expandPatterns),I=this.handleIncludeExclude(E.excludePattern,E.expandPatterns),L=w.length>1,U=(o.searchPaths&&o.searchPaths.length?o.searchPaths.map(K=>this.getFolderQueryForSearchPath(K,E,I)):w.map(K=>this.getFolderQueryForRoot(K,E,I,L))).filter(K=>!!K),V={_reason:E._reason,folderQueries:U,usingSearchPaths:!!(o.searchPaths&&o.searchPaths.length),extraFileResources:E.extraFileResources,excludePattern:I.pattern,includePattern:o.pattern,onlyOpenEditors:E.onlyOpenEditors,maxResults:E.maxResults};if(E.onlyOpenEditors){const N=g.coalesce(g.flatten(this.editorGroupsService.groups.map(F=>F.editors.map(z=>z.resource)))).filter(F=>(0,c.pathIncludedInQuery)(V,F.fsPath)),x=this.commonQueryFromFileList(N);return{...V,...x}}const ee=E.extraFileResources&&E.extraFileResources.filter(K=>(0,c.pathIncludedInQuery)(V,K.fsPath));return V.extraFileResources=ee&&ee.length?ee:void 0,V}commonQueryFromFileList(w){const E=[],o=new T.ResourceMap,I={};let L=!1;return w.forEach(U=>{if(U.scheme===D.Schemas.walkThrough)return;if((0,A.isAbsolutePath)(U)){const ee=this.workspaceContextService.getWorkspaceFolder(U)?.uri??U.with({path:y.dirname(U.fsPath)});let K=o.get(ee);K||(L=!0,K={folder:ee,includePattern:{}},E.push(K),o.set(ee,K));const N=y.relative(ee.fsPath,U.fsPath);(0,C.assertIsDefined)(K.includePattern)[N.replace(/\\/g,"/")]=!0}else U.fsPath&&(L=!0,I[U.fsPath]=!0)}),{folderQueries:E,includePattern:I,usingSearchPaths:!0,excludePattern:L?void 0:{"**/*":!0}}}isCaseSensitive(w,E){if(E.isSmartCase){if(w.isRegExp){if(i.containsUppercaseCharacter(w.pattern,!0))return!0}else if(i.containsUppercaseCharacter(w.pattern))return!0}return!!w.isCaseSensitive}isMultiline(w){return w.isMultiline||w.isRegExp&&(0,m.isMultilineRegexSource)(w.pattern)||w.pattern.indexOf(`
`)>=0?!0:!!w.isMultiline}parseSearchPaths(w){const E=x=>y.isAbsolute(x)||/^\.\.?([\/\\]|$)/.test(x),I=(Array.isArray(w)?w:r(w)).map(x=>{const F=this.pathService.resolvedUserHome;return F?(0,S.untildify)(x,F.scheme===D.Schemas.file?F.fsPath:F.path):x}),L=R.groupBy(I,x=>E(x)?"searchPaths":"exprSegments"),U=(L.exprSegments||[]).map(x=>i.rtrim(x,"/")).map(x=>i.rtrim(x,"\\")).map(x=>(x[0]==="."&&(x="*"+x),s(x))),V={},ee=this.expandSearchPathPatterns(L.searchPaths||[]);ee&&ee.length&&(V.searchPaths=ee);const K=g.flatten(U),N=t(...K);return N&&(V.pattern=N),V}getExcludesForFolder(w,E){return E.disregardExcludeSettings?void 0:(0,c.getExcludes)(w,!E.disregardSearchExcludeSettings)}expandSearchPathPatterns(w){if(!w||!w.length)return[];const E=g.flatten(w.map(I=>{let{pathPortion:L,globPortion:U}=p(I);U&&(U=a(U));const V=this.expandOneSearchPath(L);return g.flatten(V.map(ee=>this.resolveOneSearchPathPattern(ee,U)))})),o=new Map;return E.forEach(I=>{const L=I.searchPath.toString(),U=o.get(L);U?I.pattern&&(U.pattern=U.pattern||{},U.pattern[I.pattern]=!0):o.set(L,{searchPath:I.searchPath,pattern:I.pattern?t(I.pattern):void 0})}),Array.from(o.values())}expandOneSearchPath(w){if(y.isAbsolute(w)){const E=this.workspaceContextService.getWorkspace().folders;return E[0]&&E[0].uri.scheme!==D.Schemas.file?[{searchPath:E[0].uri.with({path:w})}]:[{searchPath:u.URI.file(y.normalize(w))}]}if(this.workspaceContextService.getWorkbenchState()===2){const E=this.workspaceContextService.getWorkspace().folders[0].uri;if(w=n(w),w.startsWith("../")||w===".."){const I=y.posix.resolve(E.path,w);return[{searchPath:E.with({path:I})}]}const o=a(w);return[{searchPath:E,pattern:o}]}else{if(w==="./"||w===".\\")return[];{const E=w.replace(/^\.[\/\\]/,""),I=this.workspaceContextService.getWorkspace().folders.map(L=>{const U=E.match(new RegExp(`^${i.escapeRegExpCharacters(L.name)}(?:/(.*)|$)`));return U?{match:U,folder:L}:null}).filter(C.isDefined);if(I.length)return I.map(L=>{const U=L.match[1];return{searchPath:L.folder.uri,pattern:U&&a(U)}});{const L=w.match(/\.[\/\\](.+)[\/\\]?/),U=L?L[1]:w,V=l.localize(0,null,U);throw new Error(V)}}}}resolveOneSearchPathPattern(w,E){const o=w.pattern&&E?`${w.pattern}/${E}`:w.pattern||E,I=[{searchPath:w.searchPath,pattern:o}];return o&&!o.endsWith("**")&&I.push({searchPath:w.searchPath,pattern:o+"/**"}),I}getFolderQueryForSearchPath(w,E,o){const I=this.getFolderQueryForRoot((0,_.toWorkspaceFolder)(w.searchPath),E,o,!1);return I?{...I,includePattern:w.pattern}:null}getFolderQueryForRoot(w,E,o,I){let L;const U=u.URI.isUri(w)?w:w.uri;if(o.searchPaths){const x=o.searchPaths.filter(F=>(0,A.isEqual)(F.searchPath,U))[0];if(x&&!x.pattern)return null;x&&(L=x.pattern)}const V=this.configurationService.getValue({resource:U}),K={...this.getExcludesForFolder(V,E)||{},...L||{}},N=u.URI.isUri(w)?(0,A.basename)(w):w.name;return{folder:U,folderName:I?N:void 0,excludePattern:Object.keys(K).length>0?K:void 0,fileEncoding:V.files&&V.files.encoding,disregardIgnoreFiles:typeof E.disregardIgnoreFiles=="boolean"?E.disregardIgnoreFiles:!V.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof E.disregardGlobalIgnoreFiles=="boolean"?E.disregardGlobalIgnoreFiles:!V.search.useGlobalIgnoreFiles,ignoreSymlinks:typeof E.ignoreSymlinks=="boolean"?E.ignoreSymlinks:!V.search.followSymlinks}}};h=Ve([$e(0,v.IConfigurationService),$e(1,_.IWorkspaceContextService),$e(2,b.IEditorGroupsService),$e(3,P.IPathService)],h),e.QueryBuilder=h;function p(f){const w=f.match(/[\*\{\}\(\)\[\]\?]/);if(w){const E=w.index,o=f.substr(0,E).match(/[/|\\][^/\\]*$/);if(o){let I=f.substr(0,o.index);return I.match(/[/\\]/)||(I+="/"),{pathPortion:I,globPortion:f.substr((o.index||0)+1)}}}return{pathPortion:f}}function t(...f){return f.length?f.reduce((w,E)=>(w[E]=!0,w),Object.create(null)):void 0}function r(f){return k.splitGlobAware(f,",").map(w=>w.trim()).filter(w=>!!w.length)}function s(f){return[`**/${f}/**`,`**/${f}`].map(E=>E.replace(/\*\*\/\*\*/g,"**"))}function n(f){return f.replace(/\\/g,"/")}function a(f){return n(f).replace(/^\.\//,"").replace(/\/+$/g,"")}function d(f,w){f=g.distinct(f,I=>I.toString());const E=[],o=w.getWorkspace();return f&&f.forEach(I=>{let L;if(w.getWorkbenchState()===2)L=(0,A.relativePath)(o.folders[0].uri,I),L&&L!=="."&&(L="./"+L);else{const U=w.getWorkspaceFolder(I);if(U){const V=U.name;if(o.folders.filter(K=>K.name===V).length===1){const K=(0,A.relativePath)(U.uri,I);K===""?L=`./${U.name}`:L=`./${U.name}/${K}`}else L=I.fsPath}}L&&E.push(L)}),E}e.resolveResourcesForSearchIncludes=d}),define(me[267],ge([0,1,23,2,21,15,4,266,31,43]),function(J,e,g,R,k,S,T,D,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const i=7e3;function C(v,_){const b=_.activationEvents;if(!b)return Promise.resolve(void 0);const P=[],c=[];for(const n of b)if(/^workspaceContains:/.test(n)){const a=n.substr("workspaceContains:".length);a.indexOf("*")>=0||a.indexOf("?")>=0||v.forceUsingSearch?c.push(a):P.push(a)}if(P.length===0&&c.length===0)return Promise.resolve(void 0);let h;const p=new Promise((n,a)=>{h=n}),t=n=>h({activationEvent:n}),r=Promise.all(P.map(n=>u(v,n,t))).then(()=>{}),s=m(v,_.identifier,c,t);return Promise.all([r,s]).then(()=>{h(void 0)}),p}e.checkActivateWorkspaceContainsExtension=C;async function u(v,_,b){for(const P of v.folders)if(await v.exists(g.joinPath(R.URI.revive(P),_))){b(`workspaceContains:${_}`);return}}async function m(v,_,b,P){if(b.length===0)return Promise.resolve(void 0);const c=new k.CancellationTokenSource,h=v.checkExists(v.folders,b,c.token),p=setTimeout(async()=>{c.cancel(),P(`workspaceContainsTimeout:${b.join(",")}`)},i);let t=!1;try{t=await h}catch(r){S.isPromiseCanceledError(r)||S.onUnexpectedError(r)}c.dispose(),clearTimeout(p),t&&P(`workspaceContains:${b.join(",")}`)}function l(v,_,b,P){const c=v.get(T.IInstantiationService),h=v.get(y.ISearchService),t=c.createInstance(D.QueryBuilder).file(_.map(r=>(0,A.toWorkspaceFolder)(R.URI.revive(r))),{_reason:"checkExists",includePattern:b,exists:!0});return h.fileSearch(t,P).then(r=>!!r.limitHit,r=>S.isPromiseCanceledError(r)?!1:Promise.reject(r))}e.checkGlobFileExists=l});var it=this&&this.__classPrivateFieldSet||function(J,e,g,R,k){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!k:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?k.call(J,g):k?k.value=g:e.set(J,g),g},He=this&&this.__classPrivateFieldGet||function(J,e,g,R){if(g==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!R:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?R:g==="a"?R.call(J):R?R.value:e.get(J)};define(me[40],ge([0,1,164,9,70,23,16,6,22,2,12,5,37,225,93,36,35,223,15,26,24,199,7,121,4,27,66,13,82,52,33,3,267,91,201]),function(J,e,g,R,k,S,T,D,y,A,i,C,u,m,l,v,_,b,P,c,h,p,t,r,s,n,a,d,f,w,E,o,I,L,U){"use strict";var V,ee,K;Object.defineProperty(e,"__esModule",{value:!0}),e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,s.createDecorator)("IHostUtils");let N=class Wn extends D.Disposable{constructor(M,O,q,B,G,ie,he,ye,Ie,Le){super();this._onDidChangeRemoteConnectionData=this._register(new o.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._hostUtils=O,this._extHostContext=q,this._initData=he,this._extHostWorkspace=B,this._extHostConfiguration=G,this._logService=ie,this._extHostTunnelService=Ie,this._extHostTerminalService=Le,this._disposables=new D.DisposableStore,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(C.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(C.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(C.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new T.Barrier,this._readyToStartExtensionHost=new T.Barrier,this._readyToRunExtensions=new T.Barrier,this._eagerExtensionsActivated=new T.Barrier,this._registry=new b.ExtensionDescriptionRegistry(this._initData.extensions),this._storage=new l.ExtHostStorage(this._extHostContext),this._secretState=new L.ExtHostSecretState(this._extHostContext),this._storagePath=ye,this._instaService=M.createChild(new f.ServiceCollection([l.IExtHostStorage,this._storage],[L.IExtHostSecretState,this._secretState]));const qe=new Set;this._initData.hostExtensions.forEach(We=>qe.add(c.ExtensionIdentifier.toKey(We))),this._activator=new m.ExtensionsActivator(this._registry,this._initData.resolvedExtensions,this._initData.hostExtensions,{onExtensionActivationError:(We,je,W)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(We,P.transformErrorForSerialization(je),W)},actualActivateExtension:async(We,je)=>{if(qe.has(c.ExtensionIdentifier.toKey(We)))return await this._mainThreadExtensionsProxy.$activateExtension(We,je),new m.HostExtension;const W=this._registry.getExtensionDescription(We);return this._activateExtension(W,je)}},this._logService),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),k.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(M){P.onUnexpectedError(M)}}async deactivateAll(){this._storagePath.onWillDeactivateAll();let M=[];try{M=this._registry.getAllExtensionDescriptions().map(G=>G.identifier).filter(G=>this.isActivated(G)).map(G=>this._deactivate(G))}catch(O){}await Promise.all(M)}isActivated(M){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(M):!1}_activateByEvent(M,O){return this._activator.activateByEvent(M,O)}_activateById(M,O){return this._activator.activateById(M,O)}activateByIdWithErrors(M,O){return this._activateById(M,O).then(()=>{const q=this._activator.getActivatedExtension(M);if(q.activationFailed)return Promise.reject(q.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(M=>this._registry)}getExtensionExports(M){return this._readyToRunExtensions.isOpen()?this._activator.getActivatedExtension(M).exports:null}getExtensionPathIndex(){if(!this._extensionPathIndex){const M=y.TernarySearchTree.forPaths(),O=this._registry.getAllExtensionDescriptions().map(q=>{if(!!this._getEntryPoint(q))return this._hostUtils.realpath(q.extensionLocation.fsPath).then(B=>M.set(A.URI.file(B).fsPath,q))});this._extensionPathIndex=Promise.all(O).then(()=>M)}return this._extensionPathIndex}_deactivate(M){let O=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(M))return O;const q=this._activator.getActivatedExtension(M);if(!q)return O;try{typeof q.module.deactivate=="function"&&(O=Promise.resolve(q.module.deactivate()).then(void 0,B=>(this._logService.error(B),Promise.resolve(void 0))))}catch(B){this._logService.error(B)}try{(0,D.dispose)(q.subscriptions)}catch(B){this._logService.error(B)}return O}async _activateExtension(M,O){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(M.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(M.identifier),this._doActivateExtension(M,O).then(q=>{const B=q.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(M.identifier,B.codeLoadingTime,B.activateCallTime,B.activateResolvedTime,O),this._logExtensionActivationTimes(M,O,"success",B),q},q=>{throw this._logExtensionActivationTimes(M,O,"failure"),q})}_logExtensionActivationTimes(M,O,q,B){const G=x(M,O);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",{...G,...B||{},outcome:q})}_doActivateExtension(M,O){const q=x(M,O);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",q);const B=this._getEntryPoint(M);if(!B)return Promise.resolve(new m.EmptyExtension(m.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${M.identifier.value} ${JSON.stringify(O)}`),this._logService.flush();const G=new m.ExtensionActivationTimesBuilder(O.startup);return Promise.all([this._loadCommonJSModule(M.identifier,(0,S.joinPath)(M.extensionLocation,B),G),this._loadExtensionContext(M)]).then(ie=>(k.mark(`code/extHost/willActivateExtension/${M.identifier.value}`),Wn._callActivate(this._logService,M.identifier,ie[0],ie[1],G))).then(ie=>(k.mark(`code/extHost/didActivateExtension/${M.identifier.value}`),ie))}_loadExtensionContext(M){const O=new p.ExtensionGlobalMemento(M,this._storage),q=new p.ExtensionMemento(M.identifier.value,!1,this._storage),B=new U.ExtensionSecrets(M,this._secretState),G=M.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?t.ExtensionMode.Test:t.ExtensionMode.Development:t.ExtensionMode.Production,ie=this._initData.remote.isRemote?t.ExtensionKind.Workspace:t.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${M.identifier.value}`),Promise.all([O.whenReady,q.whenReady,this._storagePath.whenReady]).then(()=>{const he=this;let ye;return Object.freeze({globalState:O,workspaceState:q,secrets:B,subscriptions:[],get extensionUri(){return M.extensionLocation},get extensionPath(){return M.extensionLocation.fsPath},asAbsolutePath(Ie){return R.join(M.extensionLocation.fsPath,Ie)},get storagePath(){return he._storagePath.workspaceValue(M)?.fsPath},get globalStoragePath(){return he._storagePath.globalValue(M).fsPath},get logPath(){return R.join(he._initData.logsLocation.fsPath,M.identifier.value)},get logUri(){return A.URI.joinPath(he._initData.logsLocation,M.identifier.value)},get storageUri(){return he._storagePath.workspaceValue(M)},get globalStorageUri(){return he._storagePath.globalValue(M)},get extensionMode(){return G},get extension(){return ye===void 0&&(ye=new F(he,M.identifier,M,ie)),ye},get extensionRuntime(){return(0,_.checkProposedApiEnabled)(M),he.extensionRuntime},get environmentVariableCollection(){return he._extHostTerminalService.getEnvironmentVariableCollection(M)}})})}static _callActivate(M,O,q,B,G){return q=q||{activate:void 0,deactivate:void 0},this._callActivateOptional(M,O,q,B,G).then(ie=>new m.ActivatedExtension(!1,null,G.build(),q,ie,B.subscriptions))}static _callActivateOptional(M,O,q,B,G){if(typeof q.activate=="function")try{G.activateCallStart(),M.trace(`ExtensionService#_callActivateOptional ${O.value}`);const ie=typeof global=="object"?global:self,he=q.activate.apply(ie,[B]);return G.activateCallStop(),G.activateResolveStart(),Promise.resolve(he).then(ye=>(G.activateResolveStop(),ye))}catch(ie){return Promise.reject(ie)}else return Promise.resolve(q)}_activateOneStartupFinished(M,O){this._activateById(M.identifier,{startup:!1,extensionId:M.identifier,activationEvent:O}).then(void 0,q=>{this._logService.error(q)})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(k.getMarks());for(const M of this._registry.getAllExtensionDescriptions())if(M.activationEvents)for(const O of M.activationEvents)O==="onStartupFinished"&&this._activateOneStartupFinished(M,O)}_handleEagerExtensions(){const M=this._activateByEvent("*",!0).then(void 0,G=>{this._logService.error(G)});this._disposables.add(this._extHostWorkspace.onDidChangeWorkspace(G=>this._handleWorkspaceContainsEagerExtensions(G.added)));const O=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],q=this._handleWorkspaceContainsEagerExtensions(O),B=Promise.all([M,q]).then(()=>{});return Promise.race([B,(0,T.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),B}_handleWorkspaceContainsEagerExtensions(M){return M.length===0?Promise.resolve(void 0):Promise.all(this._registry.getAllExtensionDescriptions().map(O=>this._handleWorkspaceContainsEagerExtension(M,O))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(M,O){if(this.isActivated(O.identifier))return;const q=!this._initData.remote.isRemote&&!!this._initData.remote.authority,B={folders:M.map(ie=>ie.uri),forceUsingSearch:q,exists:ie=>this._hostUtils.exists(ie.fsPath),checkExists:(ie,he,ye)=>this._mainThreadWorkspaceProxy.$checkExists(ie,he,ye)},G=await(0,I.checkActivateWorkspaceContainsExtension)(B,O);if(!!G)return this._activateById(O.identifier,{startup:!0,extensionId:O.identifier,activationEvent:G.activationEvent}).then(void 0,ie=>this._logService.error(ie))}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return await this._doHandleExtensionTests()}catch(M){throw console.error(M),M}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:M,extensionTestsLocationURI:O}=this._initData.environment;if(!M||!O)throw new Error(g.localize(0,null));const q=await this._loadCommonJSModule(null,O,new m.ExtensionActivationTimesBuilder(!1));if(!q||typeof q.run!="function")throw new Error(g.localize(1,null,O.toString()));return new Promise((B,G)=>{const ie=(Ie,Le)=>{Ie?G(Ie):B(typeof Le=="number"&&Le>0?1:0)},he=(0,S.originalFSPath)(O),ye=q.run(he,ie);ye&&ye.then&&ye.then(()=>{B(0)}).catch(Ie=>{G(Ie.toString())})})}async $extensionTestsExit(M){this._logService.info(`extension host terminating: test runner requested exit with code ${M}`),this._logService.info(`exiting with code ${M}`),this._logService.flush(),this._hostUtils.exit(M)}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("eager extensions activated")})}registerRemoteAuthorityResolver(M,O){return this._resolvers[M]=O,(0,D.toDisposable)(()=>{delete this._resolvers[M]})}async _activateAndGetResolver(M){const O=M.indexOf("+");if(O===-1)throw new Error("Not an authority that can be resolved!");const q=M.substr(0,O);return await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${q}`,!1),{authorityPrefix:q,resolver:this._resolvers[q]}}async $resolveAuthority(M,O){const{authorityPrefix:q,resolver:B}=await this._activateAndGetResolver(M);if(!B)return{type:"error",error:{code:r.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${q}.`,detail:void 0}};try{this._disposables.add(await this._extHostTunnelService.setTunnelExtensionFunctions(B)),k.mark(`code/extHost/willResolveAuthority/${q}`);const G=await B.resolve(M,{resolveAttempt:O});k.mark(`code/extHost/didResolveAuthorityOK/${q}`);const ie={authority:M,host:G.host,port:G.port,connectionToken:G.connectionToken},he={extensionHostEnv:G.extensionHostEnv,isTrusted:G.isTrusted};return{type:"ok",value:{authority:ie,options:he,tunnelInformation:{environmentTunnels:G.environmentTunnels}}}}catch(G){if(k.mark(`code/extHost/didResolveAuthorityError/${q}`),G instanceof t.RemoteAuthorityResolverError)return{type:"error",error:{code:G._code,message:G._message,detail:G._detail}};throw G}}async $getCanonicalURI(M,O){const{authorityPrefix:q,resolver:B}=await this._activateAndGetResolver(M);if(!B)throw new Error(`Cannot get canonical URI because no remote extension is installed to resolve ${q}`);const G=A.URI.revive(O);if(typeof B.getCanonicalURI=="undefined")return G;const ie=await(0,T.asPromise)(()=>B.getCanonicalURI(G));return ie||G}$startExtensionHost(M){return this._registry.keepOnly(M),this._startExtensionHost()}$activateByEvent(M,O){return O===1?this._activateByEvent(M,!1):this._readyToRunExtensions.wait().then(q=>this._activateByEvent(M,!1))}async $activate(M,O){return await this._readyToRunExtensions.wait(),this._registry.getExtensionDescription(M)?(await this._activateById(M,O),!0):!1}async $deltaExtensions(M,O){M.forEach(B=>B.extensionLocation=A.URI.revive(B.extensionLocation));const q=await this.getExtensionPathIndex();return await Promise.all(O.map(async B=>{const G=this._registry.getExtensionDescription(B);if(!G)return;const ie=await this._hostUtils.realpath(G.extensionLocation.fsPath);q.delete(A.URI.file(ie).fsPath)})),await Promise.all(M.map(async B=>{const G=await this._hostUtils.realpath(B.extensionLocation.fsPath);q.set(A.URI.file(G).fsPath,B)})),this._registry.deltaExtensions(M,O),Promise.resolve(void 0)}async $test_latency(M){return M}async $test_up(M){return M.byteLength}async $test_down(M){let O=h.VSBuffer.alloc(M),q=Math.random()%256;for(let B=0;B<M;B++)O.writeUInt8(q,B);return O}async $updateRemoteConnectionData(M){this._remoteConnectionData=M,this._onDidChangeRemoteConnectionData.fire()}};N=Ve([$e(0,s.IInstantiationService),$e(1,e.IHostUtils),$e(2,d.IExtHostRpcService),$e(3,v.IExtHostWorkspace),$e(4,u.IExtHostConfiguration),$e(5,i.ILogService),$e(6,n.IExtHostInitDataService),$e(7,a.IExtensionStoragePaths),$e(8,w.IExtHostTunnelService),$e(9,E.IExtHostTerminalService)],N),e.AbstractExtHostExtensionService=N;function x(z,M){return{id:z.identifier.value,name:z.name,extensionVersion:z.version,publisherDisplayName:z.publisher,activationEvents:z.activationEvents?z.activationEvents.join(","):null,isBuiltin:z.isBuiltin,reason:M.activationEvent,reasonId:M.extensionId.value}}e.IExtHostExtensionService=(0,s.createDecorator)("IExtHostExtensionService");class F{constructor(M,O,q,B){V.set(this,void 0),ee.set(this,void 0),K.set(this,void 0),it(this,V,M,"f"),it(this,ee,O,"f"),it(this,K,q.identifier,"f"),this.id=q.identifier.value,this.extensionUri=q.extensionLocation,this.extensionPath=R.normalize((0,S.originalFSPath)(q.extensionLocation)),this.packageJSON=q,this.extensionKind=B}get isActive(){return He(this,V,"f").isActivated(He(this,K,"f"))}get exports(){if(this.packageJSON.api!=="none")return He(this,V,"f").getExtensionExports(He(this,K,"f"))}activate(){return He(this,V,"f").activateByIdWithErrors(He(this,K,"f"),{startup:!1,extensionId:He(this,ee,"f"),activationEvent:"api"}).then(()=>this.exports)}}e.Extension=F,V=new WeakMap,ee=new WeakMap,K=new WeakMap}),define(me[53],ge([0,1,9,2,3,16,5,7,124,36,40,45,214,37,209,13,4,14,38,51]),function(J,e,g,R,k,S,T,D,y,A,i,C,u,m,l,v,_,b,P,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostVariableResolverService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,_.createDecorator)("IExtHostDebugService");let h=class{constructor(f,w,E,o,I,L){this._workspaceService=w,this._extensionService=E,this._editorsService=o,this._configurationService=I,this._editorTabs=L,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new k.Emitter,this._onDidTerminateDebugSession=new k.Emitter,this._onDidChangeActiveDebugSession=new k.Emitter,this._onDidReceiveDebugSessionCustomEvent=new k.Emitter,this._debugServiceProxy=f.getProxy(T.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new k.Emitter({onFirstListenerAdd:()=>{this.startBreakpoints()}}),this._activeDebugConsole=new t(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then(U=>{U.onDidChange(V=>{this.registerAllDebugTypes(U)}),this.registerAllDebugTypes(U)})}get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}asDebugSourceUri(f,w){const E=f;if(typeof E.sourceReference=="number"&&E.sourceReference>0){let o=`debug:${encodeURIComponent(E.path||"")}`,I="?";return w&&(o+=`${I}session=${encodeURIComponent(w.id)}`,I="&"),o+=`${I}ref=${E.sourceReference}`,R.URI.parse(o)}else{if(E.path)return R.URI.file(E.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(f){const w=[];for(const E of f.getAllExtensionDescriptions())if(E.contributes){const o=E.contributes.debuggers;if(o&&o.length>0)for(const I of o)(0,l.isDebuggerMainContribution)(I)&&w.push(I.type)}this._debugServiceProxy.$registerDebugTypes(w)}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const f=[];return this._breakpoints.forEach(w=>f.push(w)),f}addBreakpoints(f){this.startBreakpoints();const w=f.filter(I=>{const L=I.id;return this._breakpoints.has(L)?!1:(this._breakpoints.set(L,I),!0)});this.fireBreakpointChanges(w,[],[]);const E=[],o=new Map;for(const I of w)if(I instanceof D.SourceBreakpoint){let L=o.get(I.location.uri.toString());L||(L={type:"sourceMulti",uri:I.location.uri,lines:[]},o.set(I.location.uri.toString(),L),E.push(L)),L.lines.push({id:I.id,enabled:I.enabled,condition:I.condition,hitCondition:I.hitCondition,logMessage:I.logMessage,line:I.location.range.start.line,character:I.location.range.start.character})}else I instanceof D.FunctionBreakpoint&&E.push({type:"function",id:I.id,enabled:I.enabled,hitCondition:I.hitCondition,logMessage:I.logMessage,condition:I.condition,functionName:I.functionName});return this._debugServiceProxy.$registerBreakpoints(E)}removeBreakpoints(f){this.startBreakpoints();const w=f.filter(L=>this._breakpoints.delete(L.id));this.fireBreakpointChanges([],w,[]);const E=w.filter(L=>L instanceof D.SourceBreakpoint).map(L=>L.id),o=w.filter(L=>L instanceof D.FunctionBreakpoint).map(L=>L.id),I=w.filter(L=>L instanceof D.DataBreakpoint).map(L=>L.id);return this._debugServiceProxy.$unregisterBreakpoints(E,o,I)}startDebugging(f,w,E){return this._debugServiceProxy.$startDebugging(f?f.uri:void 0,w,{parentSessionID:E.parentSession?E.parentSession.id:void 0,lifecycleManagedByParent:E.lifecycleManagedByParent,repl:E.consoleMode===D.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:E.noDebug,compact:E.compact,debugUI:E.debugUI})}stopDebugging(f){return this._debugServiceProxy.$stopDebugging(f?f.id:void 0)}registerDebugConfigurationProvider(f,w,E){if(!w)return new D.Disposable(()=>{});const o=this._configProviderHandleCounter++;return this._configProviders.push({type:f,handle:o,provider:w}),this._debugServiceProxy.$registerDebugConfigurationProvider(f,E,!!w.provideDebugConfigurations,!!w.resolveDebugConfiguration,!!w.resolveDebugConfigurationWithSubstitutedVariables,o),new D.Disposable(()=>{this._configProviders=this._configProviders.filter(I=>I.provider!==w),this._debugServiceProxy.$unregisterDebugConfigurationProvider(o)})}registerDebugAdapterDescriptorFactory(f,w,E){if(!E)return new D.Disposable(()=>{});if(!this.definesDebugType(f,w))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${w}' debugger.`);if(this.getAdapterDescriptorFactoryByType(w))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const o=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:w,handle:o,factory:E}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(w,o),new D.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(I=>I.factory!==E),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(o)})}registerDebugAdapterTrackerFactory(f,w){if(!w)return new D.Disposable(()=>{});const E=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:f,handle:E,factory:w}),new D.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(o=>o.factory!==w)})}async $runInTerminal(f,w){return Promise.resolve(void 0)}async $substituteVariables(f,w){if(!this._variableResolver){const[I,L]=await Promise.all([this._workspaceService.getWorkspaceFolders2(),this._configurationService.getConfigProvider()]);this._variableResolver=this.createVariableResolver(I||[],this._editorsService,L)}let E;const o=await this.getFolder(f);return o&&(E={uri:o.uri,name:o.name,index:o.index,toResource:()=>{throw new Error("Not implemented")}}),this._variableResolver.resolveAnyAsync(E,w)}createDebugAdapter(f,w){if(f.type==="implementation")return new n(f.implementation)}createSignService(){}async $startDASession(f,w){const E=this,o=await this.getSession(w);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(o.type),o).then(I=>{if(!I)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${o.type}' (extension might have failed to activate)`);const L=this.convertToDto(I),U=this.createDebugAdapter(L,o);if(!U)throw new Error(`Couldn't create a debug adapter for type '${o.type}'.`);const V=U;return this._debugAdapters.set(f,V),this.getDebugAdapterTrackers(o).then(ee=>(ee&&this._debugAdaptersTrackers.set(f,ee),V.onMessage(async K=>{if(K.type==="request"&&K.command==="handshake"){const N=K,x={type:"response",seq:0,command:N.command,request_seq:N.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const F=await this._signService.sign(N.arguments.value);x.body={signature:F},V.sendResponse(x)}else throw new Error("no signer")}catch(F){x.success=!1,x.message=F.message,V.sendResponse(x)}}else ee&&ee.onDidSendMessage&&ee.onDidSendMessage(K),K=(0,l.convertToVSCPaths)(K,!0),E._debugServiceProxy.$acceptDAMessage(f,K)}),V.onError(K=>{ee&&ee.onError&&ee.onError(K),this._debugServiceProxy.$acceptDAError(f,K.name,K.message,K.stack)}),V.onExit(K=>{ee&&ee.onExit&&ee.onExit((0,b.withNullAsUndefined)(K),void 0),this._debugServiceProxy.$acceptDAExit(f,(0,b.withNullAsUndefined)(K),void 0)}),ee&&ee.onWillStartSession&&ee.onWillStartSession(),V.startSession()))})}$sendDAMessage(f,w){w=(0,l.convertToDAPaths)(w,!1);const E=this._debugAdaptersTrackers.get(f);E&&E.onWillReceiveMessage&&E.onWillReceiveMessage(w);const o=this._debugAdapters.get(f);o&&o.sendMessage(w)}$stopDASession(f){const w=this._debugAdaptersTrackers.get(f);this._debugAdaptersTrackers.delete(f),w&&w.onWillStopSession&&w.onWillStopSession();const E=this._debugAdapters.get(f);return this._debugAdapters.delete(f),E?E.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(f){const w=[],E=[],o=[];if(f.added)for(const I of f.added){const L=I.id;if(L&&!this._breakpoints.has(L)){let U;if(I.type==="function")U=new D.FunctionBreakpoint(I.functionName,I.enabled,I.condition,I.hitCondition,I.logMessage);else if(I.type==="data")U=new D.DataBreakpoint(I.label,I.dataId,I.canPersist,I.enabled,I.hitCondition,I.condition,I.logMessage);else{const V=R.URI.revive(I.uri);U=new D.SourceBreakpoint(new D.Location(V,new D.Position(I.line,I.character)),I.enabled,I.condition,I.hitCondition,I.logMessage)}U._id=L,this._breakpoints.set(L,U),w.push(U)}}if(f.removed)for(const I of f.removed){const L=this._breakpoints.get(I);L&&(this._breakpoints.delete(I),E.push(L))}if(f.changed){for(const I of f.changed)if(I.id){const L=this._breakpoints.get(I.id);if(L){if(L instanceof D.FunctionBreakpoint&&I.type==="function"){const U=L;U.enabled=I.enabled,U.condition=I.condition,U.hitCondition=I.hitCondition,U.logMessage=I.logMessage,U.functionName=I.functionName}else if(L instanceof D.SourceBreakpoint&&I.type==="source"){const U=L;U.enabled=I.enabled,U.condition=I.condition,U.hitCondition=I.hitCondition,U.logMessage=I.logMessage,U.location=new D.Location(R.URI.revive(I.uri),new D.Position(I.line,I.character))}o.push(L)}}}this.fireBreakpointChanges(w,E,o)}$provideDebugConfigurations(f,w,E){return(0,S.asPromise)(async()=>{const o=this.getConfigProviderByHandle(f);if(!o)throw new Error("no DebugConfigurationProvider found");if(!o.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const I=await this.getFolder(w);return o.provideDebugConfigurations(I,E)}).then(o=>{if(!o)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return o})}$resolveDebugConfiguration(f,w,E,o){return(0,S.asPromise)(async()=>{const I=this.getConfigProviderByHandle(f);if(!I)throw new Error("no DebugConfigurationProvider found");if(!I.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const L=await this.getFolder(w);return I.resolveDebugConfiguration(L,E,o)})}$resolveDebugConfigurationWithSubstitutedVariables(f,w,E,o){return(0,S.asPromise)(async()=>{const I=this.getConfigProviderByHandle(f);if(!I)throw new Error("no DebugConfigurationProvider found");if(!I.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const L=await this.getFolder(w);return I.resolveDebugConfigurationWithSubstitutedVariables(L,E,o)})}async $provideDebugAdapter(f,w){const E=this.getAdapterDescriptorFactoryByHandle(f);if(!E)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const o=await this.getSession(w);return this.getAdapterDescriptor(E,o).then(I=>{if(!I)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${o.type}'`);return this.convertToDto(I)})}async $acceptDebugSessionStarted(f){const w=await this.getSession(f);this._onDidStartDebugSession.fire(w)}async $acceptDebugSessionTerminated(f){const w=await this.getSession(f);w&&(this._onDidTerminateDebugSession.fire(w),this._debugSessions.delete(w.id))}async $acceptDebugSessionActiveChanged(f){this._activeDebugSession=f?await this.getSession(f):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(f,w){const E=await this.getSession(f);E&&E._acceptNameChanged(w)}async $acceptDebugSessionCustomEvent(f,w){const o={session:await this.getSession(f),event:w.event,body:w.body};this._onDidReceiveDebugSessionCustomEvent.fire(o)}convertToDto(f){if(f instanceof D.DebugAdapterExecutable)return{type:"executable",command:f.command,args:f.args,options:f.options};if(f instanceof D.DebugAdapterServer)return{type:"server",port:f.port,host:f.host};if(f instanceof D.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:f.path};if(f instanceof D.DebugAdapterInlineImplementation)return{type:"implementation",implementation:f.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(f){const w=this._adapterFactories.filter(E=>E.type===f);if(w.length>0)return w[0].factory}getAdapterDescriptorFactoryByHandle(f){const w=this._adapterFactories.filter(E=>E.handle===f);if(w.length>0)return w[0].factory}getConfigProviderByHandle(f){const w=this._configProviders.filter(E=>E.handle===f);if(w.length>0)return w[0].provider}definesDebugType(f,w){if(f.contributes){const E=f.contributes.debuggers;if(E&&E.length>0){for(const o of E)if(o.label&&o.type&&o.type===w)return!0}}return!1}getDebugAdapterTrackers(f){const E=f.configuration.type,o=this._trackerFactories.filter(I=>I.type===E||I.type==="*").map(I=>(0,S.asPromise)(()=>I.factory.createDebugAdapterTracker(f)).then(L=>L,L=>null));return Promise.race([Promise.all(o).then(I=>{const L=I.filter(U=>!!U);if(L.length>0)return new s(L)}),new Promise((I,L)=>{const U=setTimeout(()=>{clearTimeout(U),L(new Error("timeout"))},1e3)})]).catch(I=>{})}async getAdapterDescriptor(f,w){const E=w.configuration.debugServer;if(typeof E=="number")return Promise.resolve(new D.DebugAdapterServer(E));if(f){const I=await this._extensionService.getExtensionRegistry();return(0,S.asPromise)(()=>f.createDebugAdapterDescriptor(w,this.daExecutableFromPackage(w,I))).then(L=>{if(L)return L})}const o=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(w,o))}daExecutableFromPackage(f,w){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(f,w,E){(f.length>0||w.length>0||E.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:f,removed:w,changed:E}))}async getSession(f){if(f)if(typeof f=="string"){const w=this._debugSessions.get(f);if(w)return w}else{let w=this._debugSessions.get(f.id);if(!w){const E=await this.getFolder(f.folderUri),o=f.parent?this._debugSessions.get(f.parent):void 0;w=new p(this._debugServiceProxy,f.id,f.type,f.name,E,f.configuration,o),this._debugSessions.set(w.id,w),this._debugServiceProxy.$sessionCached(w.id)}return w}throw new Error("cannot find session")}getFolder(f){if(f){const w=R.URI.revive(f);return this._workspaceService.resolveWorkspaceFolder(w)}return Promise.resolve(void 0)}};h=Ve([$e(0,v.IExtHostRpcService),$e(1,A.IExtHostWorkspace),$e(2,i.IExtHostExtensionService),$e(3,C.IExtHostDocumentsAndEditors),$e(4,m.IExtHostConfiguration),$e(5,c.IExtHostEditorTabs)],h),e.ExtHostDebugServiceBase=h;class p{constructor(f,w,E,o,I,L,U){this._debugServiceProxy=f,this._id=w,this._type=E,this._name=o,this._workspaceFolder=I,this._configuration=L,this._parentSession=U}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(f){this._name=f,this._debugServiceProxy.$setDebugSessionName(this._id,f)}get parentSession(){return this._parentSession}_acceptNameChanged(f){this._name=f}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(f,w){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,f,w)}getDebugProtocolBreakpoint(f){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,f.id)}}e.ExtHostDebugSession=p;class t{constructor(f){this.value=Object.freeze({append(w){f.$appendDebugConsole(w)},appendLine(w){this.append(w+`
`)}})}}e.ExtHostDebugConsole=t;class r extends u.AbstractVariableResolverService{constructor(f,w,E,o,I){function L(){if(w){const U=w.activeEditor();if(U)return U.document.uri;const V=o.tabs.filter(ee=>ee.isActive);if(V.length>0)return V[0].resource}}super({getFolderUri:U=>{const V=f.filter(ee=>ee.name===U);if(V&&V.length>0)return V[0].uri},getWorkspaceFolderCount:()=>f.length,getConfigurationValue:(U,V)=>E.getConfiguration(void 0,U).get(V),getAppRoot:()=>P.cwd(),getExecPath:()=>P.env.VSCODE_EXEC_PATH,getFilePath:()=>{const U=L();if(U)return g.normalize(U.fsPath)},getWorkspaceFolderPathForFile:()=>{if(I){const U=L();if(U){const V=I.getWorkspaceFolder(U);if(V)return g.normalize(V.uri.fsPath)}}},getSelectedText:()=>{if(w){const U=w.activeEditor();if(U&&!U.selection.isEmpty)return U.document.getText(U.selection)}},getLineNumber:()=>{if(w){const U=w.activeEditor();if(U)return String(U.selection.end.line+1)}}},void 0,Promise.resolve(P.env))}}e.ExtHostVariableResolverService=r;class s{constructor(f){this.trackers=f}onWillStartSession(){this.trackers.forEach(f=>f.onWillStartSession?f.onWillStartSession():void 0)}onWillReceiveMessage(f){this.trackers.forEach(w=>w.onWillReceiveMessage?w.onWillReceiveMessage(f):void 0)}onDidSendMessage(f){this.trackers.forEach(w=>w.onDidSendMessage?w.onDidSendMessage(f):void 0)}onWillStopSession(){this.trackers.forEach(f=>f.onWillStopSession?f.onWillStopSession():void 0)}onError(f){this.trackers.forEach(w=>w.onError?w.onError(f):void 0)}onExit(f,w){this.trackers.forEach(E=>E.onExit?E.onExit(f,w):void 0)}}class n extends y.AbstractDebugAdapter{constructor(f){super();this.implementation=f,f.onDidSendMessage(w=>{this.acceptMessage(w)})}startSession(){return Promise.resolve(void 0)}sendMessage(f){this.implementation.handleMessage(f)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let a=class extends h{constructor(f,w,E,o,I,L){super(f,w,E,o,I,L)}createVariableResolver(f,w,E){return new r(f,w,E,this._editorTabs)}};a=Ve([$e(0,v.IExtHostRpcService),$e(1,A.IExtHostWorkspace),$e(2,i.IExtHostExtensionService),$e(3,C.IExtHostDocumentsAndEditors),$e(4,m.IExtHostConfiguration),$e(5,c.IExtHostEditorTabs)],a),e.WorkerExtHostDebugService=a}),define(me[268],ge([0,1,70,2,5,37,35,26,13,27,4,40,38,12]),function(J,e,g,R,k,S,T,D,y,A,i,C,u,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let l=class{constructor(c,h,p,t,r,s,n){this._apiFactory=c,this._extensionRegistry=h,this._instaService=p,this._extHostConfiguration=t,this._extHostExtensionService=r,this._initData=s,this._logService=n,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),g.mark("code/extHost/willWaitForConfig");const c=await this._extHostConfiguration.getConfigProvider();g.mark("code/extHost/didWaitForConfig");const h=await this._extHostExtensionService.getExtensionPathIndex();this.register(new v(this._apiFactory,h,this._extensionRegistry,c,this._logService)),this.register(this._instaService.createInstance(_)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(b,h,this._initData.environment.appUriScheme))}register(c){if(Array.isArray(c.nodeModuleName))for(let h of c.nodeModuleName)this._factories.set(h,c);else this._factories.set(c.nodeModuleName,c);typeof c.alternativeModuleName=="function"&&this._alternatives.push(h=>c.alternativeModuleName(h))}};l=Ve([$e(2,i.IInstantiationService),$e(3,S.IExtHostConfiguration),$e(4,C.IExtHostExtensionService),$e(5,A.IExtHostInitDataService),$e(6,m.ILogService)],l),e.RequireInterceptor=l;class v{constructor(c,h,p,t,r){this._apiFactory=c,this._extensionPaths=h,this._extensionRegistry=p,this._configProvider=t,this._logService=r,this.nodeModuleName="vscode",this._extApiImpl=new Map}load(c,h){const p=this._extensionPaths.findSubstr(h.fsPath);if(p){let t=this._extApiImpl.get(D.ExtensionIdentifier.toKey(p.identifier));return t||(t=this._apiFactory(p,this._extensionRegistry,this._configProvider),this._extApiImpl.set(D.ExtensionIdentifier.toKey(p.identifier),t)),t}if(!this._defaultApiImpl){let t="";this._extensionPaths.forEach((r,s)=>t+=`	${s} -> ${r.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${h.fsPath}. These are the extension path mappings: 
${t}`),this._defaultApiImpl=this._apiFactory(T.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let _=class{constructor(c,h){this.nodeModuleName="keytar";const{environment:p}=h,t=c.getProxy(k.MainContext.MainThreadKeytar);if(p.appRoot){let r=p.appRoot.fsPath;u.platform==="win32"&&(r=r.replace(/\\/g,"/")),r[r.length-1]==="/"&&(r=r.substr(0,r.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${r}/node_modules.asar/keytar`),this.alternativeNames.add(`${r}/node_modules/keytar`)}this._impl={getPassword:(r,s)=>t.$getPassword(r,s),setPassword:(r,s,n)=>t.$setPassword(r,s,n),deletePassword:(r,s)=>t.$deletePassword(r,s),findPassword:r=>t.$findPassword(r),findCredentials(r){return t.$findCredentials(r)}}}load(c,h){return this._impl}alternativeModuleName(c){const h=c.length;if(h<=7||!this.alternativeNames)return;const p=h-7;if((c.charAt(p)==="/"||c.charAt(p)==="\\")&&c.endsWith("keytar")&&(c=c.replace(/\\/g,"/"),this.alternativeNames.has(c)))return"keytar"}};_=Ve([$e(0,y.IExtHostRpcService),$e(1,A.IExtHostInitDataService)],_);let b=class{constructor(c,h,p){this._extensionPaths=c,this._appUriScheme=h,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=p.getProxy(k.MainContext.MainThreadTelemetry);const t=p.getProxy(k.MainContext.MainThreadWindow);this._impl=(r,s)=>{const n=R.URI.parse(r);return s?this.callOriginal(r,s):n.scheme==="http"||n.scheme==="https"?t.$openUri(n,r,{allowTunneling:!0}):n.scheme==="mailto"||n.scheme===this._appUriScheme?t.$openUri(n,r,{}):this.callOriginal(r,s)}}load(c,h,p){const t=this._extensionPaths.findSubstr(h.fsPath);return t&&(this._extensionId=t.identifier.value,this.sendShimmingTelemetry()),this._original=p(c),this._impl}callOriginal(c,h){return this.sendNoForwardTelemetry(),this._original(c,h)}sendShimmingTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};b=Ve([$e(2,y.IExtHostRpcService)],b)}),define(me[269],ge([0,1,170,11,7,210,36,40,45,37,33,13,53,194,16,211,51]),function(J,e,g,R,k,S,T,D,y,A,i,C,u,m,l,v,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDebugService=void 0;let b=class extends u.ExtHostDebugServiceBase{constructor(h,p,t,r,s,n,a){super(h,p,t,r,s,a);this._terminalService=n,this._integratedTerminalInstances=new P}createDebugAdapter(h,p){switch(h.type){case"server":return new S.SocketDebugAdapter(h);case"pipeServer":return new S.NamedPipeDebugAdapter(h);case"executable":return new S.ExecutableDebugAdapter(h,p.type)}return super.createDebugAdapter(h,p)}daExecutableFromPackage(h,p){const t=S.ExecutableDebugAdapter.platformAdapterExecutable(p.getAllExtensionDescriptions(),h.type);if(t)return new k.DebugAdapterExecutable(t.command,t.args,t.options)}createSignService(){return new m.SignService}async $runInTerminal(h,p){if(h.kind==="integrated"){this._terminalDisposedListener||(this._terminalDisposedListener=this._terminalService.onDidCloseTerminal(L=>{this._integratedTerminalInstances.onTerminalClosed(L)}));const t=await this._configurationService.getConfigProvider(),r=this._terminalService.getDefaultShell(!0),s=this._terminalService.getDefaultShellArgs(!0),n=h.title||g.localize(0,null),a=JSON.stringify({shell:r,shellArgs:s});let d=await this._integratedTerminalInstances.checkout(a,n),f,w=!1;if(d)f=h.cwd;else{const L={shellPath:r,shellArgs:s,cwd:h.cwd,name:n,iconPath:new k.ThemeIcon("debug")};w=!0,d=this._terminalService.createTerminalFromOptions(L,{isFeatureTerminal:!0,useShellEnvironment:!0}),this._integratedTerminalInstances.insert(d,a)}d.show(!0);const E=await d.processId;w?await new Promise(L=>setTimeout(L,1e3)):t.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(r.indexOf("powershell")>=0||r.indexOf("pwsh")>=0||r.indexOf("cmd.exe")>=0?d.sendText("cls"):r.indexOf("bash")>=0?d.sendText("clear"):R.isWindows?d.sendText("cls"):d.sendText("clear"));const o=(0,v.prepareCommand)(r,h.args,f,h.env);d.sendText(o);const I=this.onDidTerminateDebugSession(L=>{L.id===p&&(this._integratedTerminalInstances.free(d),I.dispose())});return E}else if(h.kind==="external")return(0,v.runInExternalTerminal)(h,await this._configurationService.getConfigProvider());return super.$runInTerminal(h,p)}createVariableResolver(h,p,t){return new u.ExtHostVariableResolverService(h,p,t,this._editorTabs,this._workspaceService)}};b=Ve([$e(0,C.IExtHostRpcService),$e(1,T.IExtHostWorkspace),$e(2,D.IExtHostExtensionService),$e(3,y.IExtHostDocumentsAndEditors),$e(4,A.IExtHostConfiguration),$e(5,i.IExtHostTerminalService),$e(6,_.IExtHostEditorTabs)],b),e.ExtHostDebugService=b;class P{constructor(){this._terminalInstances=new Map}async checkout(h,p){const r=[...this._terminalInstances.entries()].map(([s,n])=>(0,l.createCancelablePromise)(async a=>{if(s.name!==p||n.lastUsedAt!==-1&&await(0,v.hasChildProcesses)(await s.processId))return null;const d=Date.now();return n.lastUsedAt+P.minUseDelay>d||a.isCancellationRequested||n.config!==h?null:(n.lastUsedAt=d,s)}));return await(0,l.firstParallel)(r,s=>!!s)}insert(h,p){this._terminalInstances.set(h,{lastUsedAt:Date.now(),config:p})}free(h){const p=this._terminalInstances.get(h);p&&(p.lastUsedAt=-1)}onTerminalClosed(h){this._terminalInstances.delete(h)}}P.minUseDelay=1e3}),define(me[270],ge([0,1,9,2,113,36,53,45,37,43,33,13,27,69,10,12,64,51,23,78]),function(J,e,g,R,k,S,T,D,y,A,i,C,u,m,l,v,_,b,P,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTask=void 0;let h=class extends m.ExtHostTaskBase{constructor(t,r,s,n,a,d,f,w,E){super(t,r,s,n,a,d,f,w);this.workspaceService=s,this.editorTabs=E,r.remote.isRemote&&r.remote.authority?this.registerTaskSystem(l.Schemas.vscodeRemote,{scheme:l.Schemas.vscodeRemote,authority:r.remote.authority,platform:process.platform}):this.registerTaskSystem(l.Schemas.file,{scheme:l.Schemas.file,authority:"",platform:process.platform}),this._proxy.$registerSupportedExecutions(!0,!0,!0)}async executeTask(t,r){const s=r;if(!r.execution&&s._id===void 0)throw new Error("Tasks to execute must include an execution");if(s._id!==void 0){const n=m.TaskHandleDTO.from(s,this.workspaceService),a=await this._proxy.$getTaskExecution(n);if(a.task===void 0)throw new Error("Task from execution DTO is undefined");const d=await this.getTaskExecution(a,r);return this._proxy.$executeTask(n).catch(()=>{}),d}else{const n=m.TaskDTO.from(r,t);if(n===void 0)return Promise.reject(new Error("Task is not valid"));m.CustomExecutionDTO.is(n.execution)&&await this.addCustomExecution(n,r,!1);const a=await this.getTaskExecution(await this._proxy.$getTaskExecution(n),r);return this._proxy.$executeTask(n).catch(()=>{}),a}}provideTasksInternal(t,r,s,n){const a=[];if(n)for(let d of n){this.checkDeprecation(d,s),(!d.definition||!t[d.definition.type])&&this._logService.warn(`The task [${d.source}, ${d.name}] uses an undefined task type. The task will be ignored in the future.`);const f=m.TaskDTO.from(d,s.extension);f&&(a.push(f),m.CustomExecutionDTO.is(f.execution)&&r.push(this.addCustomExecution(f,d,!0)))}return{tasks:a,extension:s.extension}}async resolveTaskInternal(t){return t}async getVariableResolver(t){if(this._variableResolver===void 0){const r=await this._configurationService.getConfigProvider();this._variableResolver=new T.ExtHostVariableResolverService(t,this._editorService,r,this.editorTabs,this.workspaceService)}return this._variableResolver}async getAFolder(t){let r=t&&t.length>0?t[0]:void 0;if(!r){const s=R.URI.file((0,c.homedir)());r=new A.WorkspaceFolder({uri:s,name:P.basename(s),index:0})}return{uri:r.uri,name:r.name,index:r.index,toResource:()=>{throw new Error("Not implemented")}}}async $resolveVariables(t,r){const s=R.URI.revive(t),n={process:void 0,variables:Object.create(null)},a=await this._workspaceProvider.resolveWorkspaceFolder(s),d=await this._workspaceProvider.getWorkspaceFolders2()??[],f=await this.getVariableResolver(d),w=a?{uri:a.uri,name:a.name,index:a.index,toResource:()=>{throw new Error("Not implemented")}}:await this.getAFolder(d);for(let E of r.variables)n.variables[E]=await f.resolveAsync(w,E);if(r.process!==void 0){let E;if(r.process.path!==void 0){E=r.process.path.split(g.delimiter);for(let o=0;o<E.length;o++)E[o]=await f.resolveAsync(w,E[o])}n.process=await k.win32.findExecutable(await f.resolveAsync(w,r.process.name),r.process.cwd!==void 0?await f.resolveAsync(w,r.process.cwd):void 0,E)}return n}async $jsonTasksSupported(){return!0}async $findExecutable(t,r,s){return k.win32.findExecutable(t,r,s)}};h=Ve([$e(0,C.IExtHostRpcService),$e(1,u.IExtHostInitDataService),$e(2,S.IExtHostWorkspace),$e(3,D.IExtHostDocumentsAndEditors),$e(4,y.IExtHostConfiguration),$e(5,i.IExtHostTerminalService),$e(6,v.ILogService),$e(7,_.IExtHostApiDeprecationService),$e(8,b.IExtHostEditorTabs)],h),e.ExtHostTask=h}),define(me[271],ge([0,1,16,15,70,6,2,5,263,12,80,82,27,188,13,63,40,33]),function(J,e,g,R,k,S,T,D,y,A,i,C,u,m,l,v,_,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class P{constructor(h,p,t,r){this._disposables=new S.DisposableStore,this._isTerminating=!1,this._hostUtils=t,this._rpcProtocol=new y.RPCProtocol(h,null,r),p=P._transform(p,this._rpcProtocol);const s=new C.ServiceCollection(...(0,i.getSingletonServiceDescriptors)());s.set(u.IExtHostInitDataService,{_serviceBrand:void 0,...p}),s.set(l.IExtHostRpcService,new l.ExtHostRpcService(this._rpcProtocol)),s.set(v.IURITransformerService,new v.URITransformerService(r)),s.set(_.IHostUtils,t);const n=new m.InstantiationService(s,!0),a=n.invokeFunction(E=>E.get(b.IExtHostTerminalService));this._disposables.add(a),this._logService=n.invokeFunction(E=>E.get(A.ILogService)),k.mark("code/extHost/didCreateServices"),this._logService.info("extension host started"),this._logService.trace("initData",p),this._extensionService=n.invokeFunction(E=>E.get(_.IExtHostExtensionService)),this._extensionService.initialize(),Error.stackTraceLimit=100;const d=new WeakMap;this._extensionService.getExtensionPathIndex().then(E=>{Error.prepareStackTrace=(o,I)=>{let L="",U,V;for(const ee of I)L+=`
	at ${ee.toString()}`,V=ee.getFileName(),!U&&V&&(U=E.findSubstr(V));return d.set(o,U),`${o.name||"Error"}: ${o.message||""}${L}`}});const f=this._rpcProtocol.getProxy(D.MainContext.MainThreadExtensionService),w=this._rpcProtocol.getProxy(D.MainContext.MainThreadErrors);R.setUnexpectedErrorHandler(E=>{const o=R.transformErrorForSerialization(E),I=d.get(E);I?f.$onExtensionRuntimeError(I.identifier,o):w.$onUnexpectedError(o)})}terminate(h){if(this._isTerminating)return;this._isTerminating=!0,this._logService.info(`extension host terminating: ${h}`),this._logService.flush(),this._disposables.dispose(),R.setUnexpectedErrorHandler(t=>{this._logService.error(t)}),this._rpcProtocol.dispose();const p=this._extensionService.deactivateAll();setTimeout(()=>{Promise.race([(0,g.timeout)(4e3),p]).finally(()=>{this._logService.info("exiting with code 0"),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(0)})},1e3)}static _transform(h,p){h.extensions.forEach(r=>r.extensionLocation=T.URI.revive(p.transformIncomingURIs(r.extensionLocation))),h.environment.appRoot=T.URI.revive(p.transformIncomingURIs(h.environment.appRoot));const t=h.environment.extensionDevelopmentLocationURI;return t&&(h.environment.extensionDevelopmentLocationURI=t.map(r=>T.URI.revive(p.transformIncomingURIs(r)))),h.environment.extensionTestsLocationURI=T.URI.revive(p.transformIncomingURIs(h.environment.extensionTestsLocationURI)),h.environment.globalStorageHome=T.URI.revive(p.transformIncomingURIs(h.environment.globalStorageHome)),h.environment.workspaceStorageHome=T.URI.revive(p.transformIncomingURIs(h.environment.workspaceStorageHome)),h.logsLocation=T.URI.revive(p.transformIncomingURIs(h.logsLocation)),h.logFile=T.URI.revive(p.transformIncomingURIs(h.logFile)),h.workspace=p.transformIncomingURIs(h.workspace),h}}e.ExtensionHostMain=P}),define(me[272],ge([0,1,9,21,60,30,23,46,31]),function(J,e,g,R,k,S,T,D,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class A{constructor(u,m,l){this.config=u,this.provider=m,this.sessionToken=l,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=u.filePattern,this.includePattern=u.includePattern&&S.parse(u.includePattern),this.maxResults=u.maxResults||void 0,this.exists=u.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=u.excludePattern&&S.parse(u.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(u=>u.cancel()),this.activeCancellationTokens=new Set}search(u){const m=this.config.folderQueries||[];return new Promise((l,v)=>{const _=b=>{this.resultCount++,u(b)};if(this.isCanceled)return l({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(b=>{const P=b.toString(),c=g.basename(P);this.globalExcludePattern&&this.globalExcludePattern(P,c)||this.matchFile(_,{base:b,basename:c})}),Promise.all(m.map(b=>this.searchInFolder(b,_))).then(b=>{l({limitHit:this.isLimitHit,stats:b[0]||void 0})},b=>{v(new Error((0,k.toErrorMessage)(b)))})})}async searchInFolder(u,m){const l=new R.CancellationTokenSource,v=this.getSearchOptionsForFolder(u),_=this.initDirectoryTree(),b=new y.QueryGlobTester(this.config,u),P=!b.hasSiblingExcludeClauses();let c;try{this.activeCancellationTokens.add(l),c=D.StopWatch.create();const h=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},v,l.token),p=c.elapsed(),t=D.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(h&&h.forEach(r=>{const s=g.posix.relative(u.folder.path,r.path);if(P){const n=g.basename(r.path);this.matchFile(m,{base:u.folder,relativePath:s,basename:n});return}this.addDirectoryEntries(_,u.folder,s,m)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(_,b,m),{providerTime:p,postProcessTime:t.elapsed()})}finally{l.dispose(),this.activeCancellationTokens.delete(l)}}getSearchOptionsForFolder(u){const m=(0,y.resolvePatternsForProvider)(this.config.includePattern,u.includePattern),l=(0,y.resolvePatternsForProvider)(this.config.excludePattern,u.excludePattern);return{folder:u.folder,excludes:l,includes:m,useIgnoreFiles:!u.disregardIgnoreFiles,useGlobalIgnoreFiles:!u.disregardGlobalIgnoreFiles,followSymlinks:!u.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const u={rootEntries:[],pathToEntries:Object.create(null)};return u.pathToEntries["."]=u.rootEntries,u}addDirectoryEntries({pathToEntries:u},m,l,v){if(l===this.filePattern){const b=g.basename(this.filePattern);this.matchFile(v,{base:m,relativePath:this.filePattern,basename:b})}function _(b){const P=g.basename(b),c=g.dirname(b);let h=u[c];h||(h=u[c]=[],_(c)),h.push({base:m,relativePath:b,basename:P})}_(l)}matchDirectoryTree({rootEntries:u,pathToEntries:m},l,v){const _=this,b=this.filePattern;function P(c){const h=S.hasSiblingFn(()=>c.map(p=>p.basename));for(let p=0,t=c.length;p<t;p++){const r=c[p],{relativePath:s,basename:n}=r;if(!l.includedInQuerySync(s,n,b!==n?h:void 0))continue;const a=m[s];if(a)P(a);else{if(s===b)continue;_.matchFile(v,r)}if(_.isLimitHit)break}}P(u)}matchFile(u,m){(!this.includePattern||m.relativePath&&this.includePattern(m.relativePath,m.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||u(m))}}class i{constructor(){this.sessions=new Map}fileSearch(u,m,l,v){const _=this.getSessionTokenSource(u.cacheKey),b=new A(u,m,_&&_.token);let P=0;const c=h=>{P+=h.length,l(h.map(p=>this.rawMatchToSearchItem(p)))};return this.doSearch(b,i.BATCH_SIZE,c,v).then(h=>({limitHit:h.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:P,detailStats:h.stats}}))}clearCache(u){const m=this.getSessionTokenSource(u);m&&m.cancel()}getSessionTokenSource(u){if(!!u)return this.sessions.has(u)||this.sessions.set(u,new R.CancellationTokenSource),this.sessions.get(u)}rawMatchToSearchItem(u){return u.relativePath?{resource:T.joinPath(u.base,u.relativePath)}:{resource:u.base}}doSearch(u,m,l,v){v.onCancellationRequested(()=>{u.cancel()});const _=P=>{P&&(b.push(P),m>0&&b.length>=m&&(l(b),b=[]))};let b=[];return u.search(_).then(P=>(b.length&&l(b),P),P=>(b.length&&l(b),Promise.reject(P)))}}e.FileSearchManager=i,i.BATCH_SIZE=512}),define(me[133],ge([0,1,9,20,21,60,23,30,2,31,10,14]),function(J,e,g,R,k,S,T,D,y,A,i,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class u{constructor(c,h,p){this.query=c,this.provider=h,this.fileUtils=p,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(c,h){const p=this.query.folderQueries||[],t=new k.CancellationTokenSource;return h.onCancellationRequested(()=>t.cancel()),new Promise((r,s)=>{this.collector=new l(c);let n=!1;const a=(d,f)=>{if(!n&&!this.isLimitHit){const w=this.resultSize(d);_(d)&&typeof this.query.maxResults=="number"&&this.resultCount+w>this.query.maxResults&&(this.isLimitHit=!0,n=!0,t.cancel(),d=this.trimResultToSize(d,this.query.maxResults-this.resultCount));const E=this.resultSize(d);this.resultCount+=E,(E>0||!_(d))&&this.collector.add(d,f)}};Promise.all(p.map((d,f)=>this.searchInFolder(d,w=>a(w,f),t.token))).then(d=>{t.dispose(),this.collector.flush();const f=d.some(w=>!!w&&!!w.limitHit);r({limitHit:this.isLimitHit||f,messages:(0,R.flatten)(d.map(w=>w?.message?(0,C.isArray)(w.message)?w.message:[w.message]:[])),stats:{type:"textSearchProvider"}})},d=>{t.dispose();const f=(0,S.toErrorMessage)(d);s(new Error(f))})})}resultSize(c){return _(c)?Array.isArray(c.ranges)?c.ranges.length:1:0}trimResultToSize(c,h){const p=Array.isArray(c.ranges)?c.ranges:[c.ranges],t=Array.isArray(c.preview.matches)?c.preview.matches:[c.preview.matches];return{ranges:p.slice(0,h),preview:{matches:t.slice(0,h),text:c.preview.text},uri:c.uri}}async searchInFolder(c,h,p){const t=new A.QueryGlobTester(this.query,c),r=[],s={report:d=>{if(!this.validateProviderResult(d))return;const f=c.folder.scheme===i.Schemas.file?D.hasSiblingPromiseFn(()=>this.fileUtils.readdir(T.dirname(d.uri))):void 0,w=T.relativePath(c.folder,d.uri);w&&r.push(t.includedInQuery(w,g.basename(w),f).then(E=>{E&&h(d)}))}},n=this.getSearchOptionsForFolder(c),a=await this.provider.provideTextSearchResults(m(this.query.contentPattern),n,s,p);return await Promise.all(r),a}validateProviderResult(c){if(_(c)){if(Array.isArray(c.ranges)){if(!Array.isArray(c.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(c.preview.matches.length!==c.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(c.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(c){const h=(0,A.resolvePatternsForProvider)(this.query.includePattern,c.includePattern),p=(0,A.resolvePatternsForProvider)(this.query.excludePattern,c.excludePattern),t={folder:y.URI.from(c.folder),excludes:p,includes:h,useIgnoreFiles:!c.disregardIgnoreFiles,useGlobalIgnoreFiles:!c.disregardGlobalIgnoreFiles,followSymlinks:!c.ignoreSymlinks,encoding:c.fileEncoding&&this.fileUtils.toCanonicalName(c.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return t.usePCRE2=this.query.usePCRE2,t}}e.TextSearchManager=u;function m(P){return{isCaseSensitive:P.isCaseSensitive||!1,isRegExp:P.isRegExp||!1,isWordMatch:P.isWordMatch||!1,isMultiline:P.isMultiline||!1,pattern:P.pattern}}class l{constructor(c){this._onResult=c,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new b(512,h=>this.sendItems(h))}add(c,h){this._currentFileMatch&&(this._currentFolderIdx!==h||!T.isEqual(this._currentUri,c.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=h,this._currentFileMatch={resource:c.uri,results:[]}),this._currentFileMatch.results.push(v(c))}pushToCollector(){const c=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,c)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(c){this._onResult(c)}}e.TextSearchResultsCollector=l;function v(P){return _(P)?{preview:{matches:(0,R.mapArrayOrNot)(P.preview.matches,c=>({startLineNumber:c.start.line,startColumn:c.start.character,endLineNumber:c.end.line,endColumn:c.end.character})),text:P.preview.text},ranges:(0,R.mapArrayOrNot)(P.ranges,c=>({startLineNumber:c.start.line,startColumn:c.start.character,endLineNumber:c.end.line,endColumn:c.end.character}))}:{text:P.text,lineNumber:P.lineNumber}}function _(P){return!!P.preview}e.extensionResultIsMatch=_;class b{constructor(c,h){this.maxBatchSize=c,this.cb=h,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(c,h){!c||this.addItemToBatch(c,h)}addItems(c,h){!c||this.addItemsToBatch(c,h)}addItemToBatch(c,h){this.batch.push(c),this.batchSize+=h,this.onUpdate()}addItemsToBatch(c,h){this.batch=this.batch.concat(c),this.batchSize+=h,this.onUpdate()}onUpdate(){this.totalNumberCompleted<b.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},b.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=b,b.TIMEOUT=4e3,b.START_BATCH_AFTER_COUNT=50}),define(me[71],ge([0,1,6,5,4,272,13,63,12,2,133]),function(J,e,g,R,k,S,T,D,y,A,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,k.createDecorator)("IExtHostSearch");let C=class{constructor(v,_,b){this.extHostRpc=v,this._uriTransformer=_,this._logService=b,this._proxy=this.extHostRpc.getProxy(R.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new S.FileSearchManager}_transformScheme(v){return this._uriTransformer.transformOutgoingScheme(v)}registerTextSearchProvider(v,_){if(this._textSearchUsedSchemes.has(v))throw new Error(`a text search provider for the scheme '${v}' is already registered`);this._textSearchUsedSchemes.add(v);const b=this._handlePool++;return this._textSearchProvider.set(b,_),this._proxy.$registerTextSearchProvider(b,this._transformScheme(v)),(0,g.toDisposable)(()=>{this._textSearchUsedSchemes.delete(v),this._textSearchProvider.delete(b),this._proxy.$unregisterProvider(b)})}registerFileSearchProvider(v,_){if(this._fileSearchUsedSchemes.has(v))throw new Error(`a file search provider for the scheme '${v}' is already registered`);this._fileSearchUsedSchemes.add(v);const b=this._handlePool++;return this._fileSearchProvider.set(b,_),this._proxy.$registerFileSearchProvider(b,this._transformScheme(v)),(0,g.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(v),this._fileSearchProvider.delete(b),this._proxy.$unregisterProvider(b)})}$provideFileSearchResults(v,_,b,P){const c=u(b),h=this._fileSearchProvider.get(v);if(h)return this._fileSearchManager.fileSearch(c,h,p=>{this._proxy.$handleFileMatch(v,_,p.map(t=>t.resource))},P);throw new Error("unknown provider: "+v)}$clearCache(v){return this._fileSearchManager.clearCache(v),Promise.resolve(void 0)}$provideTextSearchResults(v,_,b,P){const c=this._textSearchProvider.get(v);if(!c||!c.provideTextSearchResults)throw new Error(`Unknown provider ${v}`);const h=u(b);return this.createTextSearchManager(h,c).search(t=>this._proxy.$handleTextMatch(v,_,t),P)}createTextSearchManager(v,_){return new i.TextSearchManager(v,_,{readdir:b=>Promise.resolve([]),toCanonicalName:b=>b})}};C=Ve([$e(0,T.IExtHostRpcService),$e(1,D.IURITransformerService),$e(2,y.ILogService)],C),e.ExtHostSearch=C;function u(l){return{...l,folderQueries:l.folderQueries&&l.folderQueries.map(m),extraFileResources:l.extraFileResources&&l.extraFileResources.map(v=>A.URI.revive(v))}}e.reviveQuery=u;function m(l){return{...l,folder:A.URI.revive(l.folder)}}}),define(me[273],ge([0,1,21,15,3,48,2,114,109,146,79,42,5,231,230,44,232,37,233,234,235,216,236,45,40,237,217,240,241,242,65,219,247,248,249,93,33,251,220,17,7,254,67,132,36,35,55,206,239,84,131,69,53,71,12,63,13,27,243,203,52,64,228,252,202,66,92,257,255,256,229,62,250,253,91,51,122,245,68,246,10,190,244,200,238]),function(J,e,g,R,k,S,T,D,y,A,i,C,u,m,l,v,_,b,P,c,h,p,t,r,s,n,a,d,f,w,E,o,I,L,U,V,ee,K,N,x,F,z,M,O,q,B,G,ie,he,ye,Ie,Le,qe,We,je,W,Z,ne,le,Y,ae,ve,Me,ze,Ee,Ye,X,se,fe,xe,Be,et,Ce,De,Te,ce,ue,pe,be,j,we,_e,Ae,Ue,Ge){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function Ze(Qe){const Je=Qe.get(ne.IExtHostInitDataService),ct=Qe.get(et.IExtHostFileSystemInfo),mt=Qe.get(X.IExtHostConsumerFileSystem),bt=Qe.get(s.IExtHostExtensionService),ot=Qe.get(q.IExtHostWorkspace),at=Qe.get(ue.IExtHostTelemetry),Se=Qe.get(b.IExtHostConfiguration),Pe=Qe.get(W.IURITransformerService),te=Qe.get(Z.IExtHostRpcService),Q=Qe.get(V.IExtHostStorage),Oe=Qe.get(Ye.IExtensionStoragePaths),Fe=Qe.get(je.ILogService),tt=Qe.get(ae.IExtHostTunnelService),Ke=Qe.get(ve.IExtHostApiDeprecationService),ut=Qe.get(O.IExtHostWindow),St=Qe.get(Te.IExtHostSecretState),kt=Qe.get(ce.IExtHostEditorTabs);te.set(u.ExtHostContext.ExtHostFileSystemInfo,ct),te.set(u.ExtHostContext.ExtHostLogService,Fe),te.set(u.ExtHostContext.ExtHostWorkspace,ot),te.set(u.ExtHostContext.ExtHostConfiguration,Se),te.set(u.ExtHostContext.ExtHostExtensionService,bt),te.set(u.ExtHostContext.ExtHostStorage,Q),te.set(u.ExtHostContext.ExtHostTunnelService,tt),te.set(u.ExtHostContext.ExtHostWindow,ut),te.set(u.ExtHostContext.ExtHostSecretState,St),te.set(u.ExtHostContext.ExtHostTelemetry,at),te.set(u.ExtHostContext.ExtHostEditorTabs,kt);const Dt=te.set(u.ExtHostContext.ExtHostDecorations,Qe.get(Ie.IExtHostDecorations)),ft=te.set(u.ExtHostContext.ExtHostDocumentsAndEditors,Qe.get(r.IExtHostDocumentsAndEditors)),dt=te.set(u.ExtHostContext.ExtHostCommands,Qe.get(v.IExtHostCommands)),vt=te.set(u.ExtHostContext.ExtHostTerminalService,Qe.get(ee.IExtHostTerminalService)),Et=te.set(u.ExtHostContext.ExtHostDebugService,Qe.get(qe.IExtHostDebugService)),Tt=te.set(u.ExtHostContext.ExtHostSearch,Qe.get(We.IExtHostSearch)),It=te.set(u.ExtHostContext.ExtHostTask,Qe.get(Le.IExtHostTask)),bn=te.set(u.ExtHostContext.ExtHostOutputService,Qe.get(E.IExtHostOutputService)),Vt=te.set(u.ExtHostContext.ExtHostUrls,new z.ExtHostUrls(te)),_t=te.set(u.ExtHostContext.ExtHostDocuments,new t.ExtHostDocuments(te,ft)),Xt=te.set(u.ExtHostContext.ExtHostDocumentContentProviders,new h.ExtHostDocumentContentProvider(te,ft,Fe)),Yt=te.set(u.ExtHostContext.ExtHostDocumentSaveParticipant,new p.ExtHostDocumentSaveParticipant(Fe,_t,te.getProxy(u.MainContext.MainThreadBulkEdits))),gt=te.set(u.ExtHostContext.ExtHostNotebook,new le.ExtHostNotebookController(te,dt,ft,_t,Oe)),jt=te.set(u.ExtHostContext.ExtHostNotebookDocuments,new Ue.ExtHostNotebookDocuments(Fe,gt)),Wt=te.set(u.ExtHostContext.ExtHostNotebookEditors,new Ae.ExtHostNotebookEditors(Fe,te,gt)),Jt=te.set(u.ExtHostContext.ExtHostNotebookKernels,new pe.ExtHostNotebookKernels(te,Je,gt,Fe)),Zt=te.set(u.ExtHostContext.ExtHostNotebookRenderers,new j.ExtHostNotebookRenderers(te,gt)),Pt=te.set(u.ExtHostContext.ExtHostEditors,new K.ExtHostEditors(te,ft)),dn=te.set(u.ExtHostContext.ExtHostTreeViews,new N.ExtHostTreeViews(te.getProxy(u.MainContext.MainThreadTreeViews),dt,Fe)),en=te.set(u.ExtHostContext.ExtHostEditorInsets,new ie.ExtHostEditorInsets(te.getProxy(u.MainContext.MainThreadEditorInsets),Pt,Je)),xt=te.set(u.ExtHostContext.ExtHostDiagnostics,new P.ExtHostDiagnostics(te,Fe)),ht=te.set(u.ExtHostContext.ExtHostLanguageFeatures,new d.ExtHostLanguageFeatures(te,Pe,_t,dt,xt,Fe,Ke)),tn=te.set(u.ExtHostContext.ExtHostFileSystem,new n.ExtHostFileSystem(te,ht)),Mt=te.set(u.ExtHostContext.ExtHostFileSystemEventService,new a.ExtHostFileSystemEventService(te,Fe,ft)),Ot=te.set(u.ExtHostContext.ExtHostQuickOpen,(0,I.createExtHostQuickOpen)(te,ot,dt)),qt=te.set(u.ExtHostContext.ExtHostSCM,new L.ExtHostSCM(te,dt,Fe)),En=te.set(u.ExtHostContext.ExtHostComments,(0,_.createExtHostComments)(te,dt,_t)),hn=te.set(u.ExtHostContext.ExtHostProgress,new o.ExtHostProgress(te.getProxy(u.MainContext.MainThreadProgress))),_n=te.set(u.ExtHostContext.ExtHosLabelService,new he.ExtHostLabelService(te)),fn=te.set(u.ExtHostContext.ExtHostTheming,new Y.ExtHostTheming(te)),nn=te.set(u.ExtHostContext.ExtHostAuthentication,new Me.ExtHostAuthentication(te)),rn=te.set(u.ExtHostContext.ExtHostTimeline,new ze.ExtHostTimeline(te,dt)),Ht=te.set(u.ExtHostContext.ExtHostWebviews,new M.ExtHostWebviews(te,{remote:Je.remote},ot,Fe,Ke)),sn=te.set(u.ExtHostContext.ExtHostWebviewPanels,new xe.ExtHostWebviewPanels(te,Ht,ot)),Sn=te.set(u.ExtHostContext.ExtHostCustomEditors,new fe.ExtHostCustomEditors(te,_t,Oe,Ht,sn)),yn=te.set(u.ExtHostContext.ExtHostWebviewViews,new se.ExtHostWebviewViews(te,Ht)),zt=te.set(u.ExtHostContext.ExtHostTesting,new Ce.ExtHostTesting(te,dt)),Gt=te.set(u.ExtHostContext.ExtHostUriOpeners,new De.ExtHostUriOpeners(te));te.set(u.ExtHostContext.ExtHostInteractive,new Ge.ExtHostInteractive(te,gt,ft,dt));const Dn=(0,G.values)(u.ExtHostContext);te.assertRegistered(Dn);const Cn=new Be.ExtHostBulkEdits(te,ft),on=new l.ExtHostClipboard(te),an=new w.ExtHostMessageService(te,Fe),Bt=new c.ExtHostDialogs(te),Lt=new U.ExtHostStatusBar(te,dt.converter),Kt=new f.ExtHostLanguages(te,_t);return m.ExtHostApiCommands.register(dt),function(Ne,$t,mn){const pt=function(){let re=!Ne.isUnderDevelopment;function de(Re){re||(Fe.info(`Extension '${Ne.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),re=!0)}return function Re(st){if(Array.isArray(st))st.forEach(Re);else if(typeof st=="string")de(st);else{const wt=st;typeof wt.scheme=="undefined"&&de(st),!Ne.enableProposedApi&&typeof wt.exclusive=="boolean"&&(0,B.throwProposedApiError)(Ne)}return st}}(),kn={getSession(re,de,Re){return Re?.forceRecreate&&(0,B.checkProposedApiEnabled)(Ne),nn.getSession(Ne,re,de,Re)},get onDidChangeSessions(){return nn.onDidChangeSessions},registerAuthenticationProvider(re,de,Re,st){return nn.registerAuthenticationProvider(re,de,Re,st)}},In={registerCommand(re,de,Re){return dt.registerCommand(!0,re,de,Re)},registerTextEditorCommand(re,de,Re){return dt.registerCommand(!0,re,(...st)=>{const wt=Pt.getActiveTextEditor();if(!wt){Fe.warn("Cannot execute "+re+" because there is no active text editor.");return}return wt.edit(Ct=>{de.apply(Re,[wt,Ct,...st])}).then(Ct=>{Ct||Fe.warn("Edits from command "+re+" were not applied.")},Ct=>{Fe.warn("An error occurred while running command "+re,Ct)})})},registerDiffInformationCommand:(re,de,Re)=>((0,B.checkProposedApiEnabled)(Ne),dt.registerCommand(!0,re,async(...st)=>{const wt=ft.activeEditor(!0);if(!wt){Fe.warn("Cannot execute "+re+" because there is no active text editor.");return}const Ct=await Pt.getDiffInformation(wt.id);de.apply(Re,[Ct,...st])})),executeCommand(re,...de){return dt.executeCommand(re,...de)},getCommands(re=!1){return dt.getCommands(re)}},gn={get machineId(){return Je.telemetryInfo.machineId},get sessionId(){return Je.telemetryInfo.sessionId},get language(){return Je.environment.appLanguage},get appName(){return Je.environment.appName},get appRoot(){return Je.environment.appRoot?.fsPath??""},get uriScheme(){return Je.environment.appUriScheme},get clipboard(){return on.value},get shell(){return vt.getDefaultShell(!1)},get isTelemetryEnabled(){return at.getTelemetryEnabled()},get onDidChangeTelemetryEnabled(){return at.onDidChangeTelemetryEnabled},get isNewAppInstall(){const re=Date.now()-new Date(Je.telemetryInfo.firstSessionDate).getTime();return isNaN(re)?!1:re<1e3*60*60*24},openExternal(re,de){return ut.openUri(re,{allowTunneling:!!Je.remote.authority,allowContributedOpeners:de?.allowContributedOpeners})},async asExternalUri(re){if(re.scheme===Je.environment.appUriScheme)return Vt.createAppUri(re);try{return await ut.asExternalUri(re,{allowTunneling:!!Je.remote.authority})}catch(de){if((0,_e.matchesScheme)(re,we.Schemas.http)||(0,_e.matchesScheme)(re,we.Schemas.https))return re;throw de}},get remoteName(){return(0,ye.getRemoteName)(Je.remote.authority)},get uiKind(){return Je.uiKind}};Je.environment.extensionTestsLocationURI||Object.freeze(gn);const pn=Je.remote.isRemote?F.ExtensionKind.Workspace:F.ExtensionKind.UI,Pn={createTestController(re,de){return zt.createTestController(re,de)},createTestObserver(){return(0,B.checkProposedApiEnabled)(Ne),zt.createTestObserver()},runTests(re){return(0,B.checkProposedApiEnabled)(Ne),zt.runTests(re)},get onDidChangeTestResults(){return(0,B.checkProposedApiEnabled)(Ne),zt.onResultsChanged},get testResults(){return(0,B.checkProposedApiEnabled)(Ne),zt.results}},ln={getExtension(re){const de=$t.getExtensionDescription(re);if(de)return new s.Extension(bt,Ne.identifier,de,pn)},get all(){return $t.getAllExtensionDescriptions().map(re=>new s.Extension(bt,Ne.identifier,re,pn))},get onDidChange(){return $t.onDidChange}},An={createDiagnosticCollection(re){return xt.createDiagnosticCollection(Ne.identifier,re)},get onDidChangeDiagnostics(){return xt.onDidChangeDiagnostics},getDiagnostics:re=>xt.getDiagnostics(re),getLanguages(){return Kt.getLanguages()},setTextDocumentLanguage(re,de){return Kt.changeLanguage(re.uri,de)},match(re,de){return(0,i.score)(x.LanguageSelector.from(re),de.uri,de.languageId,!0)},registerCodeActionsProvider(re,de,Re){return ht.registerCodeActionProvider(Ne,pt(re),de,Re)},registerCodeLensProvider(re,de){return ht.registerCodeLensProvider(Ne,pt(re),de)},registerDefinitionProvider(re,de){return ht.registerDefinitionProvider(Ne,pt(re),de)},registerDeclarationProvider(re,de){return ht.registerDeclarationProvider(Ne,pt(re),de)},registerImplementationProvider(re,de){return ht.registerImplementationProvider(Ne,pt(re),de)},registerTypeDefinitionProvider(re,de){return ht.registerTypeDefinitionProvider(Ne,pt(re),de)},registerHoverProvider(re,de){return ht.registerHoverProvider(Ne,pt(re),de,Ne.identifier)},registerEvaluatableExpressionProvider(re,de){return ht.registerEvaluatableExpressionProvider(Ne,pt(re),de,Ne.identifier)},registerInlineValuesProvider(re,de){return ht.registerInlineValuesProvider(Ne,pt(re),de,Ne.identifier)},registerDocumentHighlightProvider(re,de){return ht.registerDocumentHighlightProvider(Ne,pt(re),de)},registerLinkedEditingRangeProvider(re,de){return ht.registerLinkedEditingRangeProvider(Ne,pt(re),de)},registerReferenceProvider(re,de){return ht.registerReferenceProvider(Ne,pt(re),de)},registerRenameProvider(re,de){return ht.registerRenameProvider(Ne,pt(re),de)},registerDocumentSymbolProvider(re,de,Re){return ht.registerDocumentSymbolProvider(Ne,pt(re),de,Re)},registerWorkspaceSymbolProvider(re){return ht.registerWorkspaceSymbolProvider(Ne,re)},registerDocumentFormattingEditProvider(re,de){return ht.registerDocumentFormattingEditProvider(Ne,pt(re),de)},registerDocumentRangeFormattingEditProvider(re,de){return ht.registerDocumentRangeFormattingEditProvider(Ne,pt(re),de)},registerOnTypeFormattingEditProvider(re,de,Re,...st){return ht.registerOnTypeFormattingEditProvider(Ne,pt(re),de,[Re].concat(st))},registerDocumentSemanticTokensProvider(re,de,Re){return ht.registerDocumentSemanticTokensProvider(Ne,pt(re),de,Re)},registerDocumentRangeSemanticTokensProvider(re,de,Re){return ht.registerDocumentRangeSemanticTokensProvider(Ne,pt(re),de,Re)},registerSignatureHelpProvider(re,de,Re,...st){return typeof Re=="object"?ht.registerSignatureHelpProvider(Ne,pt(re),de,Re):ht.registerSignatureHelpProvider(Ne,pt(re),de,typeof Re=="undefined"?[]:[Re,...st])},registerCompletionItemProvider(re,de,...Re){return ht.registerCompletionItemProvider(Ne,pt(re),de,Re)},registerInlineCompletionItemProvider(re,de){return(0,B.checkProposedApiEnabled)(Ne),ht.registerInlineCompletionsProvider(Ne,pt(re),de)},registerDocumentLinkProvider(re,de){return ht.registerDocumentLinkProvider(Ne,pt(re),de)},registerColorProvider(re,de){return ht.registerColorProvider(Ne,pt(re),de)},registerFoldingRangeProvider(re,de){return ht.registerFoldingRangeProvider(Ne,pt(re),de)},registerSelectionRangeProvider(re,de){return ht.registerSelectionRangeProvider(Ne,re,de)},registerCallHierarchyProvider(re,de){return ht.registerCallHierarchyProvider(Ne,re,de)},setLanguageConfiguration:(re,de)=>ht.setLanguageConfiguration(Ne,re,de),getTokenInformationAtPosition(re,de){return(0,B.checkProposedApiEnabled)(Ne),Kt.tokenAtPosition(re,de)},registerInlayHintsProvider(re,de){return(0,B.checkProposedApiEnabled)(Ne),ht.registerInlayHintsProvider(Ne,re,de)},registerTypeHierarchyProvider(re,de){return(0,B.checkProposedApiEnabled)(Ne),ht.registerTypeHierarchyProvider(Ne,re,de)},createLanguageStatusItem(re){return(0,B.checkProposedApiEnabled)(Ne),Kt.createLanguageStatusItem(re)}},Tn={get activeTextEditor(){return Pt.getActiveTextEditor()},get visibleTextEditors(){return Pt.getVisibleTextEditors()},get activeTerminal(){return vt.activeTerminal},get terminals(){return vt.terminals},async showTextDocument(re,de,Re){const st=await(T.URI.isUri(re)?Promise.resolve(vn.openTextDocument(re)):Promise.resolve(re));return Pt.showTextDocument(st,de,Re)},createTextEditorDecorationType(re){return Pt.createTextEditorDecorationType(Ne,re)},onDidChangeActiveTextEditor(re,de,Re){return Pt.onDidChangeActiveTextEditor(re,de,Re)},onDidChangeVisibleTextEditors(re,de,Re){return Pt.onDidChangeVisibleTextEditors(re,de,Re)},onDidChangeTextEditorSelection(re,de,Re){return Pt.onDidChangeTextEditorSelection(re,de,Re)},onDidChangeTextEditorOptions(re,de,Re){return Pt.onDidChangeTextEditorOptions(re,de,Re)},onDidChangeTextEditorVisibleRanges(re,de,Re){return Pt.onDidChangeTextEditorVisibleRanges(re,de,Re)},onDidChangeTextEditorViewColumn(re,de,Re){return Pt.onDidChangeTextEditorViewColumn(re,de,Re)},onDidCloseTerminal(re,de,Re){return vt.onDidCloseTerminal(re,de,Re)},onDidOpenTerminal(re,de,Re){return vt.onDidOpenTerminal(re,de,Re)},onDidChangeActiveTerminal(re,de,Re){return vt.onDidChangeActiveTerminal(re,de,Re)},onDidChangeTerminalDimensions(re,de,Re){return(0,B.checkProposedApiEnabled)(Ne),vt.onDidChangeTerminalDimensions(re,de,Re)},onDidWriteTerminalData(re,de,Re){return(0,B.checkProposedApiEnabled)(Ne),vt.onDidWriteTerminalData(re,de,Re)},get state(){return ut.state},onDidChangeWindowState(re,de,Re){return ut.onDidChangeWindowState(re,de,Re)},showInformationMessage(re,...de){return an.showMessage(Ne,S.default.Info,re,de[0],de.slice(1))},showWarningMessage(re,...de){return an.showMessage(Ne,S.default.Warning,re,de[0],de.slice(1))},showErrorMessage(re,...de){return an.showMessage(Ne,S.default.Error,re,de[0],de.slice(1))},showQuickPick(re,de,Re){return Ot.showQuickPick(re,!!Ne.enableProposedApi,de,Re)},showWorkspaceFolderPick(re){return Ot.showWorkspaceFolderPick(re)},showInputBox(re,de){return Ot.showInput(re,de)},showOpenDialog(re){return Bt.showOpenDialog(re)},showSaveDialog(re){return Bt.showSaveDialog(re)},createStatusBarItem(re,de,Re){let st,wt,Ct;return typeof re=="string"?(st=re,wt=de,Ct=Re):(wt=re,Ct=de),Lt.createStatusBarEntry(Ne,st,wt,Ct)},setStatusBarMessage(re,de){return Lt.setStatusBarMessage(re,de)},withScmProgress(re){return Ke.report("window.withScmProgress",Ne,"Use 'withProgress' instead."),hn.withProgress(Ne,{location:F.ProgressLocation.SourceControl},(de,Re)=>re({report(st){}}))},withProgress(re,de){return hn.withProgress(Ne,re,de)},createOutputChannel(re){return bn.createOutputChannel(re,Ne)},createWebviewPanel(re,de,Re,st){return sn.createWebviewPanel(Ne,re,de,Re,st)},createWebviewTextEditorInset(re,de,Re,st){return(0,B.checkProposedApiEnabled)(Ne),en.createWebviewEditorInset(re,de,Re,st,Ne)},createTerminal(re,de,Re){return typeof re=="object"?(re.color&&(0,B.checkProposedApiEnabled)(Ne),"pty"in re?vt.createExtensionTerminal(re):vt.createTerminalFromOptions(re)):vt.createTerminal(re,de,Re)},registerTerminalLinkProvider(re){return vt.registerLinkProvider(re)},registerTerminalProfileProvider(re,de){return vt.registerProfileProvider(Ne,re,de)},registerTreeDataProvider(re,de){return dn.registerTreeDataProvider(re,de,Ne)},createTreeView(re,de){return dn.createTreeView(re,de,Ne)},registerWebviewPanelSerializer:(re,de)=>sn.registerWebviewPanelSerializer(Ne,re,de),registerCustomEditorProvider:(re,de,Re={})=>Sn.registerCustomEditorProvider(Ne,re,de,Re),registerFileDecorationProvider(re){return Dt.registerFileDecorationProvider(re,Ne.identifier)},registerUriHandler(re){return Vt.registerUriHandler(Ne.identifier,re)},createQuickPick(){return Ot.createQuickPick(Ne.identifier,!!Ne.enableProposedApi)},createInputBox(){return Ot.createInputBox(Ne.identifier)},get activeColorTheme(){return fn.activeColorTheme},onDidChangeActiveColorTheme(re,de,Re){return fn.onDidChangeActiveColorTheme(re,de,Re)},registerWebviewViewProvider(re,de,Re){return yn.registerWebviewViewProvider(Ne,re,de,Re?.webviewOptions)},get activeNotebookEditor(){return(0,B.checkProposedApiEnabled)(Ne),gt.activeNotebookEditor},onDidChangeActiveNotebookEditor(re,de,Re){return(0,B.checkProposedApiEnabled)(Ne),gt.onDidChangeActiveNotebookEditor(re,de,Re)},get visibleNotebookEditors(){return(0,B.checkProposedApiEnabled)(Ne),gt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return(0,B.checkProposedApiEnabled)(Ne),gt.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(re,de,Re){return(0,B.checkProposedApiEnabled)(Ne),Wt.onDidChangeNotebookEditorSelection(re,de,Re)},onDidChangeNotebookEditorVisibleRanges(re,de,Re){return(0,B.checkProposedApiEnabled)(Ne),Wt.onDidChangeNotebookEditorVisibleRanges(re,de,Re)},showNotebookDocument(re,de){return(0,B.checkProposedApiEnabled)(Ne),gt.showNotebookDocument(re,de)},registerExternalUriOpener(re,de,Re){return(0,B.checkProposedApiEnabled)(Ne),Gt.registerExternalUriOpener(Ne.identifier,re,de,Re)},get openEditors(){return(0,B.checkProposedApiEnabled)(Ne),kt.tabs},get onDidChangeOpenEditors(){return(0,B.checkProposedApiEnabled)(Ne),kt.onDidChangeTabs},getInlineCompletionItemController(re){return(0,B.checkProposedApiEnabled)(Ne),d.InlineCompletionController.get(re)}},vn={get rootPath(){return Ke.report("workspace.rootPath",Ne,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),ot.getPath()},set rootPath(re){throw R.readonly()},getWorkspaceFolder(re){return ot.getWorkspaceFolder(re)},get workspaceFolders(){return ot.getWorkspaceFolders()},get name(){return ot.name},set name(re){throw R.readonly()},get workspaceFile(){return ot.workspaceFile},set workspaceFile(re){throw R.readonly()},updateWorkspaceFolders:(re,de,...Re)=>ot.updateWorkspaceFolders(Ne,re,de||0,...Re),onDidChangeWorkspaceFolders:function(re,de,Re){return ot.onDidChangeWorkspace(re,de,Re)},asRelativePath:(re,de)=>ot.getRelativePath(re,de),findFiles:(re,de,Re,st)=>ot.findFiles(x.GlobPattern.from(re),x.GlobPattern.from(de),Re,Ne.identifier,st),findTextInFiles:(re,de,Re,st)=>{let wt,Ct;return typeof de=="object"?(wt=de,Ct=Re):(wt={},Ct=de,st=Re),ot.findTextInFiles(re,wt||{},Ct,Ne.identifier,st)},saveAll:re=>ot.saveAll(re),applyEdit(re){return Cn.applyWorkspaceEdit(re)},createFileSystemWatcher:(re,de,Re,st)=>Mt.createFileSystemWatcher(x.GlobPattern.from(re),de,Re,st),get textDocuments(){return _t.getAllDocumentData().map(re=>re.document)},set textDocuments(re){throw R.readonly()},openTextDocument(re){let de;const Re=re;if(typeof re=="string")de=Promise.resolve(T.URI.file(re));else if(T.URI.isUri(re))de=Promise.resolve(re);else if(!Re||typeof Re=="object")de=_t.createDocumentData(Re);else throw new Error("illegal argument - uriOrFileNameOrOptions");return de.then(st=>_t.ensureDocumentData(st).then(wt=>wt.document))},onDidOpenTextDocument:(re,de,Re)=>_t.onDidAddDocument(re,de,Re),onDidCloseTextDocument:(re,de,Re)=>_t.onDidRemoveDocument(re,de,Re),onDidChangeTextDocument:(re,de,Re)=>_t.onDidChangeDocument(re,de,Re),onDidSaveTextDocument:(re,de,Re)=>_t.onDidSaveDocument(re,de,Re),onWillSaveTextDocument:(re,de,Re)=>Yt.getOnWillSaveTextDocumentEvent(Ne)(re,de,Re),get notebookDocuments(){return gt.notebookDocuments.map(re=>re.apiNotebook)},async openNotebookDocument(re,de){let Re;if(T.URI.isUri(re))Re=re,await gt.openNotebookDocument(re);else if(typeof re=="string")Re=T.URI.revive(await gt.createNotebookDocument({viewType:re,content:de}));else throw new Error("Invalid arguments");return gt.getNotebookDocument(Re).apiNotebook},get onDidOpenNotebookDocument(){return gt.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return gt.onDidCloseNotebookDocument},registerNotebookSerializer(re,de,Re,st){return gt.registerNotebookSerializer(Ne,re,de,Re,Ne.enableProposedApi?st:void 0)},registerNotebookContentProvider:(re,de,Re,st)=>((0,B.checkProposedApiEnabled)(Ne),gt.registerNotebookContentProvider(Ne,re,de,Re,Ne.enableProposedApi?st:void 0)),onDidChangeConfiguration:(re,de,Re)=>mn.onDidChangeConfiguration(re,de,Re),getConfiguration(re,de){return de=arguments.length===1?void 0:de,mn.getConfiguration(re,de,Ne)},registerTextDocumentContentProvider(re,de){return Xt.registerTextDocumentContentProvider(re,de)},registerTaskProvider:(re,de)=>(Ke.report("window.registerTaskProvider",Ne,"Use the corresponding function on the 'tasks' namespace instead"),It.registerTaskProvider(Ne,re,de)),registerFileSystemProvider(re,de,Re){return tn.registerFileSystemProvider(Ne.identifier,re,de,Re,Ne.enableProposedApi)},get fs(){return mt.value},registerFileSearchProvider:(re,de)=>((0,B.checkProposedApiEnabled)(Ne),Tt.registerFileSearchProvider(re,de)),registerTextSearchProvider:(re,de)=>((0,B.checkProposedApiEnabled)(Ne),Tt.registerTextSearchProvider(re,de)),registerRemoteAuthorityResolver:(re,de)=>((0,B.checkProposedApiEnabled)(Ne),bt.registerRemoteAuthorityResolver(re,de)),registerResourceLabelFormatter:re=>((0,B.checkProposedApiEnabled)(Ne),_n.$registerResourceLabelFormatter(re)),onDidCreateFiles:(re,de,Re)=>Mt.onDidCreateFile(re,de,Re),onDidDeleteFiles:(re,de,Re)=>Mt.onDidDeleteFile(re,de,Re),onDidRenameFiles:(re,de,Re)=>Mt.onDidRenameFile(re,de,Re),onWillCreateFiles:(re,de,Re)=>Mt.getOnWillCreateFileEvent(Ne)(re,de,Re),onWillDeleteFiles:(re,de,Re)=>Mt.getOnWillDeleteFileEvent(Ne)(re,de,Re),onWillRenameFiles:(re,de,Re)=>Mt.getOnWillRenameFileEvent(Ne)(re,de,Re),openTunnel:re=>((0,B.checkProposedApiEnabled)(Ne),tt.openTunnel(Ne,re).then(de=>{if(!de)throw new Error("cannot open tunnel");return de})),get tunnels(){return(0,B.checkProposedApiEnabled)(Ne),tt.getTunnels()},onDidChangeTunnels:(re,de,Re)=>((0,B.checkProposedApiEnabled)(Ne),tt.onDidChangeTunnels(re,de,Re)),registerPortAttributesProvider:(re,de)=>((0,B.checkProposedApiEnabled)(Ne),tt.registerPortsAttributesProvider(re,de)),registerTimelineProvider:(re,de)=>((0,B.checkProposedApiEnabled)(Ne),rn.registerTimelineProvider(re,de,Ne.identifier,dt.converter)),get isTrusted(){return ot.trusted},requestWorkspaceTrust:re=>((0,B.checkProposedApiEnabled)(Ne),ot.requestWorkspaceTrust(re)),onDidGrantWorkspaceTrust:(re,de,Re)=>ot.onDidGrantWorkspaceTrust(re,de,Re)},Rn={get inputBox(){return Ke.report("scm.inputBox",Ne,"Use 'SourceControl.inputBox' instead"),qt.getLastInputBox(Ne)},createSourceControl(re,de,Re){return qt.createSourceControl(Ne,re,de,Re)}},Ln={createCommentController(re,de){return En.createCommentController(Ne,re,de)}},Fn={get activeDebugSession(){return Et.activeDebugSession},get activeDebugConsole(){return Et.activeDebugConsole},get breakpoints(){return Et.breakpoints},onDidStartDebugSession(re,de,Re){return Et.onDidStartDebugSession(re,de,Re)},onDidTerminateDebugSession(re,de,Re){return Et.onDidTerminateDebugSession(re,de,Re)},onDidChangeActiveDebugSession(re,de,Re){return Et.onDidChangeActiveDebugSession(re,de,Re)},onDidReceiveDebugSessionCustomEvent(re,de,Re){return Et.onDidReceiveDebugSessionCustomEvent(re,de,Re)},onDidChangeBreakpoints(re,de,Re){return Et.onDidChangeBreakpoints(re,de,Re)},registerDebugConfigurationProvider(re,de,Re){return Et.registerDebugConfigurationProvider(re,de,Re||F.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(re,de){return Et.registerDebugAdapterDescriptorFactory(Ne,re,de)},registerDebugAdapterTrackerFactory(re,de){return Et.registerDebugAdapterTrackerFactory(re,de)},startDebugging(re,de,Re){return!Re||typeof Re=="object"&&"configuration"in Re?Et.startDebugging(re,de,{parentSession:Re}):Et.startDebugging(re,de,Re||{})},stopDebugging(re){return Et.stopDebugging(re)},addBreakpoints(re){return Et.addBreakpoints(re)},removeBreakpoints(re){return Et.removeBreakpoints(re)},asDebugSourceUri(re,de){return Et.asDebugSourceUri(re,de)}},Mn={registerTaskProvider:(re,de)=>It.registerTaskProvider(Ne,re,de),fetchTasks:re=>It.fetchTasks(re),executeTask:re=>It.executeTask(Ne,re),get taskExecutions(){return It.taskExecutions},onDidStartTask:(re,de,Re)=>It.onDidStartTask(re,de,Re),onDidEndTask:(re,de,Re)=>It.onDidEndTask(re,de,Re),onDidStartTaskProcess:(re,de,Re)=>It.onDidStartTaskProcess(re,de,Re),onDidEndTaskProcess:(re,de,Re)=>It.onDidEndTaskProcess(re,de,Re)},On={createNotebookController(re,de,Re,st,wt){return Jt.createNotebookController(Ne,re,de,Re,st,Ne.enableProposedApi?wt:void 0)},registerNotebookCellStatusBarItemProvider:(re,de)=>gt.registerNotebookCellStatusBarItemProvider(Ne,re,de),get onDidSaveNotebookDocument(){return(0,B.checkProposedApiEnabled)(Ne),jt.onDidSaveNotebookDocument},createNotebookEditorDecorationType(re){return(0,B.checkProposedApiEnabled)(Ne),Wt.createNotebookEditorDecorationType(re)},createRendererMessaging(re){return Zt.createRendererMessaging(Ne,re)},onDidChangeNotebookDocumentMetadata(re,de,Re){return(0,B.checkProposedApiEnabled)(Ne),jt.onDidChangeNotebookDocumentMetadata(re,de,Re)},onDidChangeNotebookCells(re,de,Re){return(0,B.checkProposedApiEnabled)(Ne),gt.onDidChangeNotebookCells(re,de,Re)},onDidChangeNotebookCellExecutionState(re,de,Re){return(0,B.checkProposedApiEnabled)(Ne),gt.onDidChangeNotebookCellExecutionState(re,de,Re)},onDidChangeCellOutputs(re,de,Re){return(0,B.checkProposedApiEnabled)(Ne),gt.onDidChangeCellOutputs(re,de,Re)},onDidChangeCellMetadata(re,de,Re){return(0,B.checkProposedApiEnabled)(Ne),gt.onDidChangeCellMetadata(re,de,Re)},createConcatTextDocument(re,de){return(0,B.checkProposedApiEnabled)(Ne),new Ee.ExtHostNotebookConcatDocument(gt,_t,re,de)}};return{version:Je.version,authentication:kn,commands:In,comments:Ln,debug:Fn,env:gn,extensions:ln,languages:An,notebooks:On,scm:Rn,tasks:Mn,tests:Pn,window:Tn,workspace:vn,Breakpoint:F.Breakpoint,CallHierarchyIncomingCall:F.CallHierarchyIncomingCall,CallHierarchyItem:F.CallHierarchyItem,CallHierarchyOutgoingCall:F.CallHierarchyOutgoingCall,CancellationError:R.CancellationError,CancellationTokenSource:g.CancellationTokenSource,CandidatePortSource:u.CandidatePortSource,CodeAction:F.CodeAction,CodeActionKind:F.CodeActionKind,CodeActionTriggerKind:F.CodeActionTriggerKind,CodeLens:F.CodeLens,Color:F.Color,ColorInformation:F.ColorInformation,ColorPresentation:F.ColorPresentation,ColorThemeKind:F.ColorThemeKind,CommentMode:F.CommentMode,CommentThreadCollapsibleState:F.CommentThreadCollapsibleState,CompletionItem:F.CompletionItem,CompletionItemKind:F.CompletionItemKind,CompletionItemTag:F.CompletionItemTag,CompletionList:F.CompletionList,CompletionTriggerKind:F.CompletionTriggerKind,ConfigurationTarget:F.ConfigurationTarget,CustomExecution:F.CustomExecution,DebugAdapterExecutable:F.DebugAdapterExecutable,DebugAdapterInlineImplementation:F.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:F.DebugAdapterNamedPipeServer,DebugAdapterServer:F.DebugAdapterServer,DebugConfigurationProviderTriggerKind:F.DebugConfigurationProviderTriggerKind,DebugConsoleMode:F.DebugConsoleMode,DecorationRangeBehavior:F.DecorationRangeBehavior,Diagnostic:F.Diagnostic,DiagnosticRelatedInformation:F.DiagnosticRelatedInformation,DiagnosticSeverity:F.DiagnosticSeverity,DiagnosticTag:F.DiagnosticTag,Disposable:F.Disposable,DocumentHighlight:F.DocumentHighlight,DocumentHighlightKind:F.DocumentHighlightKind,DocumentLink:F.DocumentLink,DocumentSymbol:F.DocumentSymbol,EndOfLine:F.EndOfLine,EnvironmentVariableMutatorType:F.EnvironmentVariableMutatorType,EvaluatableExpression:F.EvaluatableExpression,InlineValueText:F.InlineValueText,InlineValueVariableLookup:F.InlineValueVariableLookup,InlineValueEvaluatableExpression:F.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:F.InlineCompletionTriggerKind,EventEmitter:k.Emitter,ExtensionKind:F.ExtensionKind,ExtensionMode:F.ExtensionMode,ExternalUriOpenerPriority:F.ExternalUriOpenerPriority,FileChangeType:F.FileChangeType,FileDecoration:F.FileDecoration,FileSystemError:F.FileSystemError,FileType:C.FileType,FilePermission:C.FilePermission,FoldingRange:F.FoldingRange,FoldingRangeKind:F.FoldingRangeKind,FunctionBreakpoint:F.FunctionBreakpoint,InlineCompletionItem:F.InlineSuggestion,InlineCompletionList:F.InlineSuggestions,Hover:F.Hover,IndentAction:A.IndentAction,Location:F.Location,MarkdownString:F.MarkdownString,OverviewRulerLane:y.OverviewRulerLane,ParameterInformation:F.ParameterInformation,PortAutoForwardAction:F.PortAutoForwardAction,Position:F.Position,ProcessExecution:F.ProcessExecution,ProgressLocation:F.ProgressLocation,QuickInputButtons:F.QuickInputButtons,Range:F.Range,RelativePattern:F.RelativePattern,Selection:F.Selection,SelectionRange:F.SelectionRange,SemanticTokens:F.SemanticTokens,SemanticTokensBuilder:F.SemanticTokensBuilder,SemanticTokensEdit:F.SemanticTokensEdit,SemanticTokensEdits:F.SemanticTokensEdits,SemanticTokensLegend:F.SemanticTokensLegend,ShellExecution:F.ShellExecution,ShellQuoting:F.ShellQuoting,SignatureHelp:F.SignatureHelp,SignatureHelpTriggerKind:F.SignatureHelpTriggerKind,SignatureInformation:F.SignatureInformation,SnippetString:F.SnippetString,SourceBreakpoint:F.SourceBreakpoint,StandardTokenType:F.StandardTokenType,StatusBarAlignment:F.StatusBarAlignment,SymbolInformation:F.SymbolInformation,SymbolKind:F.SymbolKind,SymbolTag:F.SymbolTag,Task:F.Task,Task2:F.Task,TaskGroup:F.TaskGroup,TaskGroup2:F.TaskGroup,TaskPanelKind:F.TaskPanelKind,TaskRevealKind:F.TaskRevealKind,TaskScope:F.TaskScope,TerminalLink:F.TerminalLink,TerminalProfile:F.TerminalProfile,TextDocumentSaveReason:F.TextDocumentSaveReason,TextEdit:F.TextEdit,TextEditorCursorStyle:D.TextEditorCursorStyle,TextEditorLineNumbersStyle:F.TextEditorLineNumbersStyle,TextEditorRevealType:F.TextEditorRevealType,TextEditorSelectionChangeKind:F.TextEditorSelectionChangeKind,TextDocumentChangeReason:F.TextDocumentChangeReason,ThemeColor:F.ThemeColor,ThemeIcon:F.ThemeIcon,TreeItem:F.TreeItem,TreeItemCollapsibleState:F.TreeItemCollapsibleState,TypeHierarchyItem:F.TypeHierarchyItem,UIKind:u.UIKind,Uri:T.URI,ViewColumn:F.ViewColumn,WorkspaceEdit:F.WorkspaceEdit,InlayHint:F.InlayHint,InlayHintKind:F.InlayHintKind,RemoteAuthorityResolverError:F.RemoteAuthorityResolverError,ResolvedAuthority:F.ResolvedAuthority,SourceControlInputBoxValidationType:F.SourceControlInputBoxValidationType,ExtensionRuntime:F.ExtensionRuntime,TimelineItem:F.TimelineItem,NotebookRange:F.NotebookRange,NotebookCellKind:F.NotebookCellKind,NotebookCellExecutionState:F.NotebookCellExecutionState,NotebookCellData:F.NotebookCellData,NotebookData:F.NotebookData,NotebookRendererScript:F.NotebookRendererScript,NotebookCellStatusBarAlignment:F.NotebookCellStatusBarAlignment,NotebookEditorRevealType:F.NotebookEditorRevealType,NotebookCellOutput:F.NotebookCellOutput,NotebookCellOutputItem:F.NotebookCellOutputItem,NotebookCellStatusBarItem:F.NotebookCellStatusBarItem,NotebookControllerAffinity:F.NotebookControllerAffinity,PortAttributes:F.PortAttributes,LinkedEditingRanges:F.LinkedEditingRanges,TestResultState:F.TestResultState,TestRunRequest:F.TestRunRequest,TestMessage:F.TestMessage,TestRunProfileKind:F.TestRunProfileKind,TextSearchCompleteMessageType:be.TextSearchCompleteMessageType,TestMessageSeverity:F.TestMessageSeverity,CoveredCount:F.CoveredCount,FileCoverage:F.FileCoverage,StatementCoverage:F.StatementCoverage,BranchCoverage:F.BranchCoverage,FunctionCoverage:F.FunctionCoverage,WorkspaceTrustState:F.WorkspaceTrustState,LanguageStatusSeverity:F.LanguageStatusSeverity}}}e.createApiFactoryAndRegisterActors=Ze}),define(me[274],ge([0,1,80,65,36,131,37,44,45,33,69,53,71,93,52,64,132,92,62,91,122,51]),function(J,e,g,R,k,S,T,D,y,A,i,C,u,m,l,v,_,b,P,c,h,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,g.registerSingleton)(v.IExtHostApiDeprecationService,v.ExtHostApiDeprecationService),(0,g.registerSingleton)(D.IExtHostCommands,D.ExtHostCommands),(0,g.registerSingleton)(T.IExtHostConfiguration,T.ExtHostConfiguration),(0,g.registerSingleton)(b.IExtHostConsumerFileSystem,b.ExtHostConsumerFileSystem),(0,g.registerSingleton)(C.IExtHostDebugService,C.WorkerExtHostDebugService),(0,g.registerSingleton)(S.IExtHostDecorations,S.ExtHostDecorations),(0,g.registerSingleton)(y.IExtHostDocumentsAndEditors,y.ExtHostDocumentsAndEditors),(0,g.registerSingleton)(P.IExtHostFileSystemInfo,P.ExtHostFileSystemInfo),(0,g.registerSingleton)(R.IExtHostOutputService,R.ExtHostOutputService),(0,g.registerSingleton)(u.IExtHostSearch,u.ExtHostSearch),(0,g.registerSingleton)(m.IExtHostStorage,m.ExtHostStorage),(0,g.registerSingleton)(i.IExtHostTask,i.WorkerExtHostTask),(0,g.registerSingleton)(A.IExtHostTerminalService,A.WorkerExtHostTerminalService),(0,g.registerSingleton)(l.IExtHostTunnelService,l.ExtHostTunnelService),(0,g.registerSingleton)(_.IExtHostWindow,_.ExtHostWindow),(0,g.registerSingleton)(k.IExtHostWorkspace,k.ExtHostWorkspace),(0,g.registerSingleton)(c.IExtHostSecretState,c.ExtHostSecretState),(0,g.registerSingleton)(h.IExtHostTelemetry,h.ExtHostTelemetry),(0,g.registerSingleton)(p.IExtHostEditorTabs,p.ExtHostEditorTabs)}),define(me[94],ge([0,1,20,12,31,68]),function(J,e,g,R,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutputChannel=e.createTextSearchResult=e.anchorGlob=void 0;function T(C){return C.startsWith("**")||C.startsWith("/")?C:`/${C}`}e.anchorGlob=T;function D(C,u,m,l){const v=(0,g.mapArrayOrNot)(m,y),_=new k.TextSearchMatch(u,v,l),b=_.preview.matches;return{ranges:(0,g.mapArrayOrNot)(v,A),uri:C,preview:{text:_.preview.text,matches:(0,g.mapArrayOrNot)(b,A)}}}e.createTextSearchResult=D;function y(C){return new k.SearchRange(C.start.line,C.start.character,C.end.line,C.end.character)}function A(C){return new S.Range(C.startLineNumber,C.startColumn,C.endLineNumber,C.endColumn)}let i=class{constructor(u,m){this.prefix=u,this.logService=m}appendLine(u){this.logService.debug(`${this.prefix}#search`,u)}};i=Ve([$e(1,R.ILogService)],i),e.OutputChannel=i}),define(me[275],ge([0,1,96,24]),function(J,e,g,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SUPPORTED_ENCODINGS=e.detectEncodingFromBuffer=e.toCanonicalName=e.detectEncodingByBOMFromBuffer=e.toNodeEncoding=e.encodingExists=e.toEncodeReadable=e.toDecodeStream=e.UTF8_BOM=e.UTF16le_BOM=e.UTF16be_BOM=e.isUTFEncoding=e.UTF16le=e.UTF16be=e.UTF8_with_bom=e.UTF8=void 0,e.UTF8="utf8",e.UTF8_with_bom="utf8bom",e.UTF16be="utf16be",e.UTF16le="utf16le";function k(t){return[e.UTF8,e.UTF8_with_bom,e.UTF16be,e.UTF16le].some(r=>r===t)}e.isUTFEncoding=k,e.UTF16be_BOM=[254,255],e.UTF16le_BOM=[255,254],e.UTF8_BOM=[239,187,191];const S=512,T=512,D=512*8,y=512*128;class A{constructor(r){this.iconvLiteDecoder=r}static async create(r){let s;if(r!==e.UTF8)s=(await new Promise((a,d)=>{J(["iconv-lite-umd"],a,d)})).getDecoder(m(r));else{const n=new TextDecoder;s={write(a){return n.decode(a,{stream:!0})},end(){return n.decode()}}}return new A(s)}write(r){return this.iconvLiteDecoder.write(r)}end(){return this.iconvLiteDecoder.end()}}function i(t,r){const s=r.minBytesRequiredForDetection??r.guessEncoding?D:T;return new Promise((n,a)=>{const d=(0,g.newWriteableStream)(I=>I.join("")),f=[];let w=0,E;const o=async()=>{try{const I=await p({buffer:R.VSBuffer.concat(f),bytesRead:w},r.guessEncoding);I.encoding=await r.overwriteEncoding(I.encoding),E=await A.create(I.encoding);const L=E.write(R.VSBuffer.concat(f).buffer);d.write(L),f.length=0,w=0,n({stream:d,detected:I})}catch(I){a(I)}};(0,g.listenStream)(t,{onData:async I=>{E?d.write(E.write(I.buffer)):(f.push(I),w+=I.byteLength,w>=s&&(t.pause(),await o(),setTimeout(()=>t.resume())))},onError:I=>d.error(I),onEnd:async()=>{E||await o(),d.end(E?.end())}})})}e.toDecodeStream=i;async function C(t,r,s){const a=(await new Promise((w,E)=>{J(["iconv-lite-umd"],w,E)})).getEncoder(m(r),s);let d=!1,f=!1;return{read(){if(f)return null;const w=t.read();if(typeof w!="string"){if(f=!0,!d&&s?.addBOM)switch(r){case e.UTF8:case e.UTF8_with_bom:return R.VSBuffer.wrap(Uint8Array.from(e.UTF8_BOM));case e.UTF16be:return R.VSBuffer.wrap(Uint8Array.from(e.UTF16be_BOM));case e.UTF16le:return R.VSBuffer.wrap(Uint8Array.from(e.UTF16le_BOM))}const E=a.end();return E&&E.length>0?(d=!0,R.VSBuffer.wrap(E)):null}return d=!0,R.VSBuffer.wrap(a.write(w))}}}e.toEncodeReadable=C;async function u(t){return(await new Promise((s,n)=>{J(["iconv-lite-umd"],s,n)})).encodingExists(m(t))}e.encodingExists=u;function m(t){return t===e.UTF8_with_bom||t===null?e.UTF8:t}e.toNodeEncoding=m;function l(t,r){if(!t||r<e.UTF16be_BOM.length)return null;const s=t.readUInt8(0),n=t.readUInt8(1);if(s===e.UTF16be_BOM[0]&&n===e.UTF16be_BOM[1])return e.UTF16be;if(s===e.UTF16le_BOM[0]&&n===e.UTF16le_BOM[1])return e.UTF16le;if(r<e.UTF8_BOM.length)return null;const a=t.readUInt8(2);return s===e.UTF8_BOM[0]&&n===e.UTF8_BOM[1]&&a===e.UTF8_BOM[2]?e.UTF8_with_bom:null}e.detectEncodingByBOMFromBuffer=l;const v=["ascii","utf-16","utf-32"];async function _(t){const r=await new Promise((f,w)=>{J(["jschardet"],f,w)}),s=t.slice(0,y),n=c(s.buffer),a=r.detect(n);if(!a||!a.encoding)return null;const d=a.encoding.toLowerCase();return 0<=v.indexOf(d)?null:P(a.encoding)}const b={ibm866:"cp866",big5:"cp950"};function P(t){const r=t.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return b[r]||r}function c(t){let r="";for(let s=0;s<t.length;s++)r+=String.fromCharCode(t[s]);return r}function h(t){switch(t){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:const r=t.match(/windows(\d+)/);return r?"windows-"+r[1]:t}}e.toCanonicalName=h;function p({buffer:t,bytesRead:r},s){let n=l(t,r),a=!1;if(n!==e.UTF16be&&n!==e.UTF16le&&t){let d=!0,f=!0,w=!1;for(let E=0;E<r&&E<S;E++){const o=E%2==1,I=t.readUInt8(E)===0;if(I&&(w=!0),d&&(o&&!I||!o&&I)&&(d=!1),f&&(o&&I||!o&&!I)&&(f=!1),I&&!d&&!f)break}w&&(d?n=e.UTF16le:f?n=e.UTF16be:a=!0)}return s&&!a&&!n&&t?_(t.slice(0,r)).then(d=>({seemsBinary:!1,encoding:d})):{seemsBinary:a,encoding:n}}e.detectEncodingFromBuffer=p,e.SUPPORTED_ENCODINGS={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}}}),define(me[134],ge([0,1,275,28,133]),function(J,e,g,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeTextSearchManager=void 0;class S extends k.TextSearchManager{constructor(D,y,A=R){super(D,y,{readdir:i=>A.Promises.readdir(i.fsPath),toCanonicalName:i=>(0,g.toCanonicalName)(i)})}}e.NativeTextSearchManager=S}),define(me[276],ge([0,1,277,292,293,2,294]),function(J,e,g,R,k,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connectProxyResolver=void 0;function D(C,u,m,l,v,_){const b=_.environment.useHostProxy,P=typeof b=="boolean"?b:!_.remote.isRemote,c=(0,T.createProxyResolver)({resolveProxy:p=>C.resolveProxy(p),getHttpProxySetting:()=>u.getConfiguration("http").get("proxy"),log:(p,t,...r)=>{switch(p){case T.LogLevel.Trace:l.trace(t,...r);break;case T.LogLevel.Debug:l.debug(t,...r);break;case T.LogLevel.Info:l.info(t,...r);break;case T.LogLevel.Warning:l.warn(t,...r);break;case T.LogLevel.Error:l.error(t,...r);break;case T.LogLevel.Critical:l.critical(t,...r);break;case T.LogLevel.Off:break;default:s(p,t,r);break}function s(n,a,...d){l.error("Unknown log level",n),l.error(a,...d)}},getLogLevel:()=>l.getLevel(),proxyResolveTelemetry:p=>{v.$publicLog2("resolveProxy",p)},useHostProxy:P,env:process.env}),h=y(u,c);return i(m,h)}e.connectProxyResolver=D;function y(C,u){const m={config:C.getConfiguration("http").get("proxySupport")||"off"};C.onDidChangeConfiguration(v=>{m.config=C.getConfiguration("http").get("proxySupport")||"off"});const l={config:!!C.getConfiguration("http").get("systemCertificates")};return C.onDidChangeConfiguration(v=>{l.config=!!C.getConfiguration("http").get("systemCertificates")}),{http:{off:Object.assign({},g,(0,T.createHttpPatch)(g,u,{config:"off"},l,!0)),on:Object.assign({},g,(0,T.createHttpPatch)(g,u,{config:"on"},l,!0)),override:Object.assign({},g,(0,T.createHttpPatch)(g,u,{config:"override"},l,!0)),onRequest:Object.assign({},g,(0,T.createHttpPatch)(g,u,m,l,!0)),default:Object.assign(g,(0,T.createHttpPatch)(g,u,m,l,!1))},https:{off:Object.assign({},R,(0,T.createHttpPatch)(R,u,{config:"off"},l,!0)),on:Object.assign({},R,(0,T.createHttpPatch)(R,u,{config:"on"},l,!0)),override:Object.assign({},R,(0,T.createHttpPatch)(R,u,{config:"override"},l,!0)),onRequest:Object.assign({},R,(0,T.createHttpPatch)(R,u,m,l,!0)),default:Object.assign(R,(0,T.createHttpPatch)(R,u,m,l,!1))},tls:Object.assign(k,(0,T.createTlsPatch)(k))}}const A=new Map;function i(C,u){return C.getExtensionPathIndex().then(m=>{const l=J.__$__nodeRequire("module"),v=l._load;l._load=function(b,P,c){if(b==="tls")return u.tls;if(b!=="http"&&b!=="https")return v.apply(this,arguments);const h=u[b],p=m.findSubstr(S.URI.file(P.filename).fsPath);let t=A.get(p);if(t||A.set(p,t={}),!t[b]){let r=h.default;p&&p.enableProposedApi&&(r=h[p.proxySupport]||h.onRequest),t[b]={...r}}return t[b]}})}}),define(me[278],ge([0,1,39,9,76,29,11,8,94,279]),function(J,e,g,R,k,S,T,D,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixDriveC=e.getAbsoluteGlob=e.foldersToIncludeGlobs=e.foldersToRgExcludeGlobs=e.spawnRipgrepCmd=void 0;const i=A.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function C(c,h,p,t){const r=u(c,h,p,t),s=h.folder.fsPath;return{cmd:g.spawn(i,r.args,{cwd:s}),rgDiskPath:i,siblingClauses:r.siblingClauses,rgArgs:r,cwd:s}}e.spawnRipgrepCmd=C;function u(c,h,p,t){const r=["--files","--hidden","--case-sensitive"];l([h],p,!1).forEach(n=>{const a=(0,y.anchorGlob)(n);if(r.push("-g",a),T.isMacintosh){const d=(0,k.normalizeNFD)(a);d!==a&&r.push("-g",d)}});const s=m([h],t,void 0,!1);return s.globArgs.forEach(n=>{const a=`!${(0,y.anchorGlob)(n)}`;if(r.push("-g",a),T.isMacintosh){const d=(0,k.normalizeNFD)(a);d!==a&&r.push("-g",d)}}),h.disregardIgnoreFiles!==!1?r.push("--no-ignore"):r.push("--no-ignore-parent"),h.ignoreSymlinks||r.push("--follow"),c.exists&&r.push("--quiet"),r.push("--no-config"),h.disregardGlobalIgnoreFiles&&r.push("--no-ignore-global"),{args:r,siblingClauses:s.siblingClauses}}function m(c,h,p,t=!0){const r=[];let s={};return c.forEach(n=>{const a=Object.assign({},n.excludePattern||{},h||{}),d=v(a,t?n.folder.fsPath:void 0,p);r.push(...d.globArgs),d.siblingClauses&&(s=Object.assign(s,d.siblingClauses))}),{globArgs:r,siblingClauses:s}}e.foldersToRgExcludeGlobs=m;function l(c,h,p=!0){const t=[];return c.forEach(r=>{const s=Object.assign({},h||{},r.includePattern||{}),n=v(s,p?r.folder.fsPath:void 0);t.push(...n.globArgs)}),t}e.foldersToIncludeGlobs=l;function v(c,h,p){const t=[],r={};return Object.keys(c).forEach(s=>{if(p&&p.has(s)||!s)return;const n=c[s];s=b(h?_(h,s):s),s.startsWith("\\\\")?s="\\\\"+s.substr(2).replace(/\\/g,"/"):s=s.replace(/\\/g,"/"),typeof n=="boolean"&&n?(s.startsWith("\\\\")&&(s+="**"),t.push(P(s))):n&&n.when&&(r[s]=n)}),{globArgs:t,siblingClauses:r}}function _(c,h){return R.isAbsolute(h)?h:R.join(c,h)}e.getAbsoluteGlob=_;function b(c){return c=D.rtrim(c,"\\"),D.rtrim(c,"/")}function P(c){return S.getRoot(c).toLowerCase()==="c:/"?c.replace(/^c:[/\\]/i,"/"):c}e.fixDriveC=P}),define(me[280],ge([0,1,39,49,9,104,20,60,30,76,29,11,46,8,14,28,31,278,101]),function(J,e,g,R,k,S,T,D,y,A,i,C,u,m,l,v,_,b,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.rgErrorMsgForDisplay=e.Engine=e.FileWalker=void 0;const c=new Set;process.on("exit",()=>{c.forEach(s=>s())});class h{constructor(n){this.normalizedFilePatternLowercase=null,this.maxFilesize=null,this.isCanceled=!1,this.fileWalkSW=null,this.cmdSW=null,this.cmdResultCount=0,this.config=n,this.filePattern=n.filePattern||"",this.includePattern=n.includePattern&&y.parse(n.includePattern),this.maxResults=n.maxResults||null,this.exists=!!n.exists,this.walkedPaths=Object.create(null),this.resultCount=0,this.isLimitHit=!1,this.directoriesWalked=0,this.filesWalked=0,this.errors=[],this.filePattern&&(this.normalizedFilePatternLowercase=(0,P.prepareQuery)(this.filePattern).normalizedLowercase),this.globalExcludePattern=n.excludePattern&&y.parse(n.excludePattern),this.folderExcludePatterns=new Map,n.folderQueries.forEach(a=>{const d=Object.assign({},a.excludePattern||{},this.config.excludePattern||{}),f=a.folder.fsPath;n.folderQueries.map(w=>w.folder.fsPath).filter(w=>w!==f).forEach(w=>{(0,i.isEqualOrParent)(w,f)&&(d[k.relative(f,w)]=!0)}),this.folderExcludePatterns.set(f,new t(d,f))})}cancel(){this.isCanceled=!0}walk(n,a,d,f,w){if(this.fileWalkSW=u.StopWatch.create(!1),this.isCanceled)return w(null,this.isLimitHit);a.forEach(E=>{const o=k.basename(E.fsPath);this.globalExcludePattern&&this.globalExcludePattern(E.fsPath,o)||this.matchFile(d,{relativePath:E.fsPath,searchPath:void 0})}),this.cmdSW=u.StopWatch.create(!1),this.parallel(n,(E,o)=>{this.call(this.cmdTraversal,this,E,d,f,I=>{if(I){const L=(0,D.toErrorMessage)(I);console.error(L),this.errors.push(L),o(I,void 0)}else o(null,void 0)})},(E,o)=>{this.fileWalkSW.stop();const I=E?T.coalesce(E)[0]:null;w(I,this.isLimitHit)})}parallel(n,a,d){const f=new Array(n.length),w=new Array(n.length);let E=!1,o=0;if(n.length===0)return d(null,[]);n.forEach((I,L)=>{a(I,(U,V)=>{if(U?(E=!0,f[L]=null,w[L]=U):(f[L]=V,w[L]=null),++o===n.length)return d(E?w:null,f)})})}call(n,a,...d){try{n.apply(a,d)}catch(f){d[d.length-1](f)}}cmdTraversal(n,a,d,f){const w=n.folder.fsPath,E=C.isMacintosh;let o;const I=()=>o&&o.kill();c.add(I);let L=F=>{c.delete(I),L=()=>{},f(F)},U="";const V=this.initDirectoryTree();let ee;const K=(0,b.spawnRipgrepCmd)(this.config,n,this.config.includePattern,this.folderExcludePatterns.get(n.folder.fsPath).expression);o=K.cmd,ee=!Object.keys(K.siblingClauses).length;const N=K.rgArgs.args.map(F=>F.match(/^-/)?F:`'${F}'`).join(" ");let x=`${K.rgDiskPath} ${N}
 - cwd: ${K.cwd}`;K.rgArgs.siblingClauses&&(x+=`
 - Sibling clauses: ${JSON.stringify(K.rgArgs.siblingClauses)}`),d({message:x}),this.cmdResultCount=0,this.collectStdout(o,"utf8",d,(F,z,M)=>{if(F){L(F);return}if(this.isLimitHit){L();return}const q=(U+(E?A.normalizeNFC(z||""):z)).split(`
`);if(M){const B=q.length;q[B-1]=q[B-1].trim(),q[B-1]||q.pop()}else U=q.pop()||"";if(q.length&&q[0].indexOf(`
`)!==-1){L(new Error("Splitting up files failed"));return}if(this.cmdResultCount+=q.length,ee){for(const B of q)if(this.matchFile(a,{base:w,relativePath:B,searchPath:this.getSearchPath(n,B)}),this.isLimitHit){I();break}(M||this.isLimitHit)&&L();return}this.addDirectoryEntries(n,V,w,q,a),M&&(this.matchDirectoryTree(V,w,a),L())})}spawnFindCmd(n){const a=this.folderExcludePatterns.get(n.folder.fsPath),d=a.getBasenameTerms(),f=a.getPathTerms(),w=["-L","."];if(d.length||f.length){w.push("-not","(","(");for(const E of d)w.push("-name",E),w.push("-o");for(const E of f)w.push("-path",E),w.push("-o");w.pop(),w.push(")","-prune",")")}return w.push("-type","f"),g.spawn("find",w,{cwd:n.folder.fsPath})}readStdout(n,a,d){let f="";this.collectStdout(n,a,()=>{},(w,E,o)=>{if(w){d(w);return}f+=E,o&&d(null,f)})}collectStdout(n,a,d,f){let w=(I,L,U)=>{(I||U)&&(w=()=>{},this.cmdSW&&this.cmdSW.stop()),f(I,L,U)},E=!1;n.stdout?(this.forwardData(n.stdout,a,w),n.stdout.once("data",()=>E=!0)):d({message:"stdout is null"});let o;n.stderr?o=this.collectData(n.stderr):d({message:"stderr is null"}),n.on("error",I=>{w(I)}),n.on("close",I=>{let L;!E&&(L=this.decodeData(o,a))&&r(L)?w(new Error(`command failed with error code ${I}: ${this.decodeData(o,a)}`)):(this.exists&&I===0&&(this.isLimitHit=!0),w(null,"",!0))})}forwardData(n,a,d){const f=new S.StringDecoder(a);return n.on("data",w=>{d(null,f.write(w))}),f}collectData(n){const a=[];return n.on("data",d=>{a.push(d)}),a}decodeData(n,a){const d=new S.StringDecoder(a);return n.map(f=>d.write(f)).join("")}initDirectoryTree(){const n={rootEntries:[],pathToEntries:Object.create(null)};return n.pathToEntries["."]=n.rootEntries,n}addDirectoryEntries(n,{pathToEntries:a},d,f,w){f.indexOf(this.filePattern)!==-1&&this.matchFile(w,{base:d,relativePath:this.filePattern,searchPath:this.getSearchPath(n,this.filePattern)});const E=o=>{const I=k.basename(o),L=k.dirname(o);let U=a[L];U||(U=a[L]=[],E(L)),U.push({base:d,relativePath:o,basename:I,searchPath:this.getSearchPath(n,o)})};f.forEach(E)}matchDirectoryTree({rootEntries:n,pathToEntries:a},d,f){const w=this,E=this.folderExcludePatterns.get(d),o=this.filePattern;function I(L){w.directoriesWalked++;const U=y.hasSiblingFn(()=>L.map(V=>V.basename));for(let V=0,ee=L.length;V<ee;V++){const K=L[V],{relativePath:N,basename:x}=K;if(E.test(N,x,o!==x?U:void 0))continue;const F=a[N];if(F)I(F);else{if(w.filesWalked++,N===o)continue;w.matchFile(f,K)}if(w.isLimitHit)break}}I(n)}getStats(){return{cmdTime:this.cmdSW.elapsed(),fileWalkTime:this.fileWalkSW.elapsed(),directoriesWalked:this.directoriesWalked,filesWalked:this.filesWalked,cmdResultCount:this.cmdResultCount}}doWalk(n,a,d,f,w){const E=n.folder,o=y.hasSiblingFn(()=>d);this.parallel(d,(I,L)=>{if(this.isCanceled||this.isLimitHit)return L(null);const U=a?[a,I].join(k.sep):I;if(this.folderExcludePatterns.get(n.folder.fsPath).test(U,I,this.config.filePattern!==I?o:void 0))return L(null);const V=[E.fsPath,U].join(k.sep);R.lstat(V,(ee,K)=>{if(ee||this.isCanceled||this.isLimitHit)return L(null);this.statLinkIfNeeded(V,K,(N,x)=>N||this.isCanceled||this.isLimitHit?L(null):x.isDirectory()?(this.directoriesWalked++,this.realPathIfNeeded(V,K,(F,z)=>F||this.isCanceled||this.isLimitHit||(z=z||"",this.walkedPaths[z])?L(null):(this.walkedPaths[z]=!0,v.Promises.readdir(V).then(M=>{if(this.isCanceled||this.isLimitHit)return L(null);this.doWalk(n,U,M,f,O=>L(O||null))},M=>{L(null)})))):(this.filesWalked++,U===this.filePattern||this.maxFilesize&&l.isNumber(x.size)&&x.size>this.maxFilesize||this.matchFile(f,{base:E.fsPath,relativePath:U,searchPath:this.getSearchPath(n,U)}),L(null,void 0)))})},I=>{const L=I&&T.coalesce(I);return w(L&&L.length>0?L[0]:void 0)})}matchFile(n,a){this.isFileMatch(a)&&(!this.includePattern||this.includePattern(a.relativePath,k.basename(a.relativePath)))&&(this.resultCount++,(this.exists||this.maxResults&&this.resultCount>this.maxResults)&&(this.isLimitHit=!0),this.isLimitHit||n(a))}isFileMatch(n){if(this.filePattern){if(this.filePattern==="*")return!0;if(this.normalizedFilePatternLowercase)return(0,_.isFilePatternMatch)(n,this.normalizedFilePatternLowercase)}return!0}statLinkIfNeeded(n,a,d){return a.isSymbolicLink()?R.stat(n,d):d(null,a)}realPathIfNeeded(n,a,d){return a.isSymbolicLink()?R.realpath(n,(f,w)=>f?d(f):d(null,w)):d(null,n)}getSearchPath(n,a){return n.folderName?k.join(n.folderName,a):a}}e.FileWalker=h;class p{constructor(n){this.folderQueries=n.folderQueries,this.extraFiles=n.extraFileResources||[],this.walker=new h(n)}search(n,a,d){this.walker.walk(this.folderQueries,this.extraFiles,n,a,(f,w)=>{d(f,{limitHit:w,stats:this.walker.getStats(),messages:[]})})}cancel(){this.walker.cancel()}}e.Engine=p;class t{constructor(n,a){this.expression=n,this.root=a,this.init(n)}init(n){let a,d;Object.keys(n).filter(f=>n[f]).forEach(f=>{k.isAbsolute(f)?(a=a||y.getEmptyExpression(),a[f]=n[f]):(d=d||y.getEmptyExpression(),d[f]=n[f])}),this.absoluteParsedExpr=a&&y.parse(a,{trimForExclusions:!0}),this.relativeParsedExpr=d&&y.parse(d,{trimForExclusions:!0})}test(n,a,d){return this.relativeParsedExpr&&this.relativeParsedExpr(n,a,d)||this.absoluteParsedExpr&&this.absoluteParsedExpr(k.join(this.root,n),a,d)}getBasenameTerms(){const n=[];return this.absoluteParsedExpr&&n.push(...y.getBasenameTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&n.push(...y.getBasenameTerms(this.relativeParsedExpr)),n}getPathTerms(){const n=[];return this.absoluteParsedExpr&&n.push(...y.getPathTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&n.push(...y.getPathTerms(this.relativeParsedExpr)),n}}function r(s){const n=s.trim().split(`
`),a=n[0].trim();if(a.startsWith("Error parsing regex"))return a;if(a.startsWith("regex parse error"))return m.uppercaseFirstLetter(n[n.length-1].trim());if(a.startsWith("error parsing glob")||a.startsWith("unsupported encoding"))return a.charAt(0).toUpperCase()+a.substr(1);if(a==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(a.startsWith("Literal "))return a}e.rgErrorMsgForDisplay=r}),define(me[135],ge([0,1,39,295,104,20,55,30,9,8,2,31,68,296,279,94]),function(J,e,g,R,k,S,T,D,y,A,i,C,u,m,l,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixNewline=e.fixRegexNewline=e.unicodeEscapesToPCRE2=e.spreadGlobComponents=e.RipgrepParser=e.buildRegexParseError=e.rgErrorMsgForDisplay=e.RipgrepTextSearchEngine=void 0;const _=l.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class b{constructor(E){this.outputChannel=E}provideTextSearchResults(E,o,I,L){return this.outputChannel.appendLine(`provideTextSearchResults ${E.pattern}, ${JSON.stringify({...o,folder:o.folder.toString()})}`),new Promise((U,V)=>{L.onCancellationRequested(()=>O());const ee=r(E,o),K=o.folder.fsPath,N=ee.map(he=>he.match(/^-/)?he:`'${he}'`).join(" ");this.outputChannel.appendLine(`${_} ${N}
 - cwd: ${K}`);let x=g.spawn(_,ee,{cwd:K});x.on("error",he=>{console.error(he),this.outputChannel.appendLine("Error: "+(he&&he.message)),V((0,C.serializeSearchError)(new C.SearchError(he&&he.message,C.SearchErrorCode.rgProcessError)))});let F=!1;const z=new h(o.maxResults,K,o.previewOptions);z.on("result",he=>{F=!0,B="",I.report(he)});let M=!1;const O=()=>{M=!0,x&&x.kill(),z&&z.cancel()};let q=!1;z.on("hitLimit",()=>{q=!0,O()});let B="";x.stdout.on("data",he=>{z.handleData(he),F||(B+=he)});let G=!1;x.stdout.once("data",()=>G=!0);let ie="";x.stderr.on("data",he=>{const ye=he.toString();this.outputChannel.appendLine(ye),ie+=ye}),x.on("close",()=>{if(this.outputChannel.appendLine(G?"Got data from stdout":"No data from stdout"),this.outputChannel.appendLine(F?"Got result from parser":"No result from parser"),B&&this.outputChannel.appendLine(`Got data without result: ${B}`),this.outputChannel.appendLine(""),M)U({limitHit:q});else{z.flush(),x=null;let he;ie&&!G&&(he=P(ie))?V((0,C.serializeSearchError)(new C.SearchError(he.message,he.code))):U({limitHit:q})}})})}}e.RipgrepTextSearchEngine=b;function P(w){const E=w.split(`
`),o=E[0].trim();if(E.some(L=>L.startsWith("regex parse error")))return new C.SearchError(c(E),C.SearchErrorCode.regexParseError);const I=o.match(/grep config error: unknown encoding: (.*)/);if(I)return new C.SearchError(`Unknown encoding: ${I[1]}`,C.SearchErrorCode.unknownEncoding);if(o.startsWith("error parsing glob"))return new C.SearchError(o.charAt(0).toUpperCase()+o.substr(1),C.SearchErrorCode.globParseError);if(o.startsWith("the literal"))return new C.SearchError(o.charAt(0).toUpperCase()+o.substr(1),C.SearchErrorCode.invalidLiteral);if(o.startsWith("PCRE2: error compiling pattern"))return new C.SearchError(o,C.SearchErrorCode.regexParseError)}e.rgErrorMsgForDisplay=P;function c(w){const E=["Regex parse error"],o=w.filter(I=>I.startsWith("PCRE2:"));if(o.length>=1){const I=o[0].replace("PCRE2:","");if(I.indexOf(":")!==-1&&I.split(":").length>=2){const L=I.split(":")[1];E.push(":"+L)}}return E.join("")}e.buildRegexParseError=c;class h extends R.EventEmitter{constructor(E,o,I){super();this.maxResults=E,this.rootFolder=o,this.previewOptions=I,this.remainder="",this.isDone=!1,this.hitLimit=!1,this.numResults=0,this.stringDecoder=new k.StringDecoder}cancel(){this.isDone=!0}flush(){this.handleDecodedData(this.stringDecoder.end())}on(E,o){return super.on(E,o),this}handleData(E){if(this.isDone)return;const o=typeof E=="string"?E:this.stringDecoder.write(E);this.handleDecodedData(o)}handleDecodedData(E){let o=E.indexOf(`
`);const I=this.remainder+E;if(o>=0)o+=this.remainder.length;else{this.remainder=I;return}let L=0;for(;o>=0;)this.handleLine(I.substring(L,o).trim()),L=o+1,o=I.indexOf(`
`,L);this.remainder=I.substring(L)}handleLine(E){if(this.isDone||!E)return;let o;try{o=JSON.parse(E)}catch(I){throw new Error(`malformed line from rg: ${E}`)}if(o.type==="match"){const I=p(o.data.path),L=i.URI.file(y.join(this.rootFolder,I)),U=this.createTextSearchMatch(o.data,L);this.onResult(U),this.hitLimit&&(this.cancel(),this.emit("hitLimit"))}else if(o.type==="context"){const I=p(o.data.path),L=i.URI.file(y.join(this.rootFolder,I));this.createTextSearchContext(o.data,L).forEach(V=>this.onResult(V))}}createTextSearchMatch(E,o){const I=E.line_number-1,L=p(E.lines),U=Buffer.from(L);let V=0,ee=0,K=I;E.submatches.length===0&&E.submatches.push(L.length?{start:0,end:1,match:{text:L[0]}}:{start:0,end:0,match:{text:""}});const N=(0,S.coalesce)(E.submatches.map((x,F)=>{if(this.hitLimit)return null;this.numResults++,this.numResults>=this.maxResults&&(this.hitLimit=!0);const z=p(x.match),M=U.slice(V,x.start).toString().length,O=ee+M,q=t(z),B=K,G=q.numLines+B,ie=q.numLines>0?q.lastLineLength:q.lastLineLength+O;return V=x.end,ee=ie,K=G,new u.Range(B,O,G,ie)}));return(0,v.createTextSearchResult)(o,L,N,this.previewOptions)}createTextSearchContext(E,o){const I=p(E.lines),L=E.line_number;return I.replace(/\r?\n$/,"").split(`
`).map((U,V)=>({text:U,uri:o,lineNumber:L+V}))}onResult(E){this.emit("result",E)}}e.RipgrepParser=h;function p(w){return w.bytes?Buffer.from(w.bytes,"base64").toString():w.text}function t(w){const E=/\n/g;let o=0,I=-1,L;for(;L=E.exec(w);)o++,I=L.index;const U=I>=0?w.length-I-1:w.length;return{numLines:o,lastLineLength:U}}function r(w,E){const o=["--hidden"];o.push(w.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:I,otherIncludes:L}=(0,T.groupBy)(E.includes,V=>V.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(L&&L.length){const V=new Set;L.forEach(ee=>{V.add(ee)}),o.push("-g","!*"),V.forEach(ee=>{s(ee).map(v.anchorGlob).forEach(K=>{o.push("-g",K)})})}I&&I.length&&I.forEach(V=>{o.push("-g",V)}),E.excludes.map(v.anchorGlob).forEach(V=>o.push("-g",`!${V}`)),E.maxFileSize&&o.push("--max-filesize",E.maxFileSize+""),E.useIgnoreFiles?o.push("--no-ignore-parent"):o.push("--no-ignore"),E.followSymlinks&&o.push("--follow"),E.encoding&&E.encoding!=="utf8"&&o.push("--encoding",E.encoding),w.pattern==="--"&&(w.isRegExp=!0,w.pattern="\\-\\-"),w.isMultiline&&!w.isRegExp&&(w.pattern=(0,A.escapeRegExpCharacters)(w.pattern),w.isRegExp=!0),E.usePCRE2&&o.push("--pcre2"),o.push("--crlf"),w.isRegExp&&(w.pattern=n(w.pattern),o.push("--auto-hybrid-regex"));let U;if(w.isWordMatch){const ee=(0,A.createRegExp)(w.pattern,!!w.isRegExp,{wholeWord:w.isWordMatch}).source.replace(/\\\//g,"/");o.push("--regexp",ee)}else if(w.isRegExp){let V=d(w.pattern);V=f(V),o.push("--regexp",V)}else U=w.pattern,o.push("--fixed-strings");return o.push("--no-config"),E.useGlobalIgnoreFiles||o.push("--no-ignore-global"),o.push("--json"),w.isMultiline&&o.push("--multiline"),E.beforeContext&&o.push("--before-context",E.beforeContext+""),E.afterContext&&o.push("--after-context",E.afterContext+""),o.push("--"),U&&o.push(U),o.push("."),o}function s(w){const E=(0,D.splitGlobAware)(w,"/");return E.map((o,I)=>E.slice(0,I+1).join("/"))}e.spreadGlobComponents=s;function n(w){const E=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;w.match(E);)w=w.replace(E,"$1\\x{$2}");const o=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;w.match(o);)w=w.replace(o,"$1\\x{$2}");return w}e.unicodeEscapesToPCRE2=n;const a=w=>w.type==="Assertion"&&w.kind==="lookbehind";function d(w){let E;try{E=new m.RegExpParser().parsePattern(w)}catch{return w}let o="",I=0;const L=(ee,K,N)=>{o+=w.slice(I,ee)+N,I=K},U=[];return new m.RegExpVisitor({onCharacterEnter(ee){if(ee.raw!=="\\n")return;const K=U[0];if(!K)L(ee.start,ee.end,"\\r?\\n");else if(!U.some(a))if(K.type==="CharacterClass")if(K.negate){const N=w.slice(K.start+2,ee.start)+w.slice(ee.end,K.end-1);L(K.start,K.end,"(?!\\r?\\n"+(N?`|[${N}]`:"")+")")}else{const N=w.slice(K.start+1,ee.start)+w.slice(ee.end,K.end-1);L(K.start,K.end,N===""?"\\r?\\n":`(?:[${N}]|\\r?\\n)`)}else K.type==="Quantifier"&&L(ee.start,ee.end,"(?:\\r?\\n)")},onQuantifierEnter(ee){U.unshift(ee)},onQuantifierLeave(){U.shift()},onCharacterClassRangeEnter(ee){U.unshift(ee)},onCharacterClassRangeLeave(){U.shift()},onCharacterClassEnter(ee){U.unshift(ee)},onCharacterClassLeave(){U.shift()},onAssertionEnter(ee){a(ee)&&U.push(ee)},onAssertionLeave(ee){U[0]===ee&&U.shift()}}).visit(E),o+=w.slice(I),o}e.fixRegexNewline=d;function f(w){return w.replace(/\n/g,"\\r?\\n")}e.fixNewline=f}),define(me[281],ge([0,1,21,135,118,10]),function(J,e,g,R,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RipgrepSearchProvider=void 0;class T{constructor(A){this.outputChannel=A,this.inProgress=new Set,process.once("exit",()=>this.dispose())}provideTextSearchResults(A,i,C,u){const m=new R.RipgrepTextSearchEngine(this.outputChannel);if(i.folder.scheme===S.Schemas.userData){const l={...i,folder:i.folder.with({scheme:S.Schemas.file})},v=new k.Progress(_=>C.report({..._,uri:_.uri.with({scheme:i.folder.scheme})}));return this.withToken(u,_=>m.provideTextSearchResults(A,l,v,_))}else return this.withToken(u,l=>m.provideTextSearchResults(A,i,C,l))}async withToken(A,i){const C=D(A);this.inProgress.add(C);const u=await i(C.token);return this.inProgress.delete(C),u}dispose(){this.inProgress.forEach(A=>A.cancel())}}e.RipgrepSearchProvider=T;function D(y){const A=new g.CancellationTokenSource;return y.onCancellationRequested(()=>A.cancel()),A}}),define(me[282],ge([0,1,28,135,134]),function(J,e,g,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchEngineAdapter=void 0;class S{constructor(y){this.query=y}search(y,A,i){if((!this.query.folderQueries||!this.query.folderQueries.length)&&(!this.query.extraFileResources||!this.query.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"}});const C={appendLine(m){i({message:m})}},u=new k.NativeTextSearchManager(this.query,new R.RipgrepTextSearchEngine(C),g);return new Promise((m,l)=>u.search(v=>{A(v.map(T))},y).then(v=>m({limitHit:v.limitHit,type:"success"}),l))}}e.TextSearchEngineAdapter=S;function T(D){return{path:D.resource&&D.resource.fsPath,results:D.results,numMatches:(D.results||[]).reduce((y,A)=>{if(A.ranges){const i=A;return y+(Array.isArray(i.ranges)?i.ranges.length:1)}else return y+1},0)}}}),define(me[283],ge([0,1,49,297,20,16,15,3,101,9,46,2,42,31,280,282]),function(J,e,g,R,k,S,T,D,y,A,i,C,u,m,l,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SearchService=void 0,R.gracefulify(g);class _{constructor(){this.caches=Object.create(null)}fileSearch(t){let r;const s=c(t),n=new D.Emitter({onFirstListenerDidAdd:()=>{r=(0,S.createCancelablePromise)(a=>this.doFileSearchWithEngine(l.Engine,s,d=>n.fire(d),a)),r.then(a=>n.fire(a),a=>n.fire({type:"error",error:{message:a.message,stack:a.stack}}))},onLastListenerRemove:()=>{r.cancel()}});return n.event}textSearch(t){let r;const s=c(t),n=new D.Emitter({onFirstListenerDidAdd:()=>{r=(0,S.createCancelablePromise)(a=>this.ripgrepTextSearch(s,d=>n.fire(d),a)),r.then(a=>n.fire(a),a=>n.fire({type:"error",error:{message:a.message,stack:a.stack}}))},onLastListenerRemove:()=>{r.cancel()}});return n.event}ripgrepTextSearch(t,r,s){return t.maxFileSize=(0,u.getPlatformLimits)(process.arch==="ia32"?0:1).maxFileSize,new v.TextSearchEngineAdapter(t).search(s,r,r)}doFileSearch(t,r,s){return this.doFileSearchWithEngine(l.Engine,t,r,s)}doFileSearchWithEngine(t,r,s,n,a=_.BATCH_SIZE){let d=0;const f=E=>{Array.isArray(E)?(d+=E.length,s(E.map(o=>this.rawMatchToSearchItem(o)))):E.relativePath?(d++,s(this.rawMatchToSearchItem(E))):s(E)};if(r.sortByScore){let E=this.trySortedSearchFromCache(r,f,n);if(!E){const o=r.maxResults?Object.assign({},r,{maxResults:null}):r,I=new t(o);E=this.doSortedSearch(I,r,s,f,n)}return new Promise((o,I)=>{E.then(([L,U])=>{const V=U.map(ee=>this.rawMatchToSearchItem(ee));this.sendProgress(V,s,a),o(L)},I)})}const w=new t(r);return this.doSearch(w,f,a,n).then(E=>({limitHit:E.limitHit,type:"success",stats:{detailStats:E.stats,type:"searchProcess",fromCache:!1,resultCount:d,sortingTime:void 0}}))}rawMatchToSearchItem(t){return{path:t.base?(0,A.join)(t.base,t.relativePath):t.relativePath}}doSortedSearch(t,r,s,n,a){const d=new D.Emitter;let f=(0,S.createCancelablePromise)(E=>{let o=[];const I=L=>{Array.isArray(L)?o=L:(n(L),d.fire(L))};return this.doSearch(t,I,-1,E).then(L=>[L,o])}),w;if(r.cacheKey){w=this.getOrCreateCache(r.cacheKey);const E={promise:f,event:d.event,resolved:!1};w.resultsToSearchCache[r.filePattern||""]=E,f.then(()=>{E.resolved=!0},o=>{delete w.resultsToSearchCache[r.filePattern||""]}),f=this.preventCancellation(f)}return f.then(([E,o])=>{const I=w?w.scorerCache:Object.create(null),L=(typeof r.maxResults!="number"||r.maxResults>0)&&i.StopWatch.create(!1);return this.sortResults(r,o,I,a).then(U=>{const V=L?L.elapsed():-1;return[{type:"success",stats:{detailStats:E.stats,sortingTime:V,fromCache:!1,type:"searchProcess",workspaceFolderCount:r.folderQueries.length,resultCount:U.length},messages:E.messages,limitHit:E.limitHit||typeof r.maxResults=="number"&&o.length>r.maxResults},U]})})}getOrCreateCache(t){const r=this.caches[t];return r||(this.caches[t]=new b)}trySortedSearchFromCache(t,r,s){const n=t.cacheKey&&this.caches[t.cacheKey];if(!n)return;const a=this.getResultsFromCache(n,t.filePattern||"",r,s);if(a)return a.then(([d,f,w])=>{const E=i.StopWatch.create(!1);return this.sortResults(t,f,n.scorerCache,s).then(o=>{const I=E.elapsed(),L={fromCache:!0,detailStats:w,type:"searchProcess",resultCount:f.length,sortingTime:I};return[{type:"success",limitHit:d.limitHit||typeof t.maxResults=="number"&&f.length>t.maxResults,stats:L},o]})})}sortResults(t,r,s,n){const a=(0,y.prepareQuery)(t.filePattern||""),d=(w,E)=>(0,y.compareItemsByFuzzyScore)(w,E,a,!0,P,s),f=typeof t.maxResults=="number"?t.maxResults:Number.MAX_VALUE;return k.topAsync(r,d,f,1e4,n)}sendProgress(t,r,s){if(s&&s>0)for(let n=0;n<t.length;n+=s)r(t.slice(n,n+s));else r(t)}getResultsFromCache(t,r,s,n){const a=i.StopWatch.create(!1),d=r.indexOf(A.sep)>=0;let f;for(const I in t.resultsToSearchCache)if(r.startsWith(I)){if(d&&I.indexOf(A.sep)<0&&I!=="")continue;const L=t.resultsToSearchCache[I];f={promise:this.preventCancellation(L.promise),event:L.event,resolved:L.resolved};break}if(!f)return null;const w=a.elapsed(),E=i.StopWatch.create(!1),o=f.event(s);return n&&n.onCancellationRequested(()=>{o.dispose()}),f.promise.then(([I,L])=>{if(n&&n.isCancellationRequested)throw(0,T.canceled)();const U=[],V=(0,y.prepareQuery)(r).normalizedLowercase;for(const ee of L)!(0,m.isFilePatternMatch)(ee,V)||U.push(ee);return[I,U,{cacheWasResolved:f.resolved,cacheLookupTime:w,cacheFilterTime:E.elapsed(),cacheEntryCount:L.length}]})}doSearch(t,r,s,n){return new Promise((a,d)=>{let f=[];n&&n.onCancellationRequested(()=>t.cancel()),t.search(w=>{w&&(s?(f.push(w),s>0&&f.length>=s&&(r(f),f=[])):r(w))},w=>{r(w)},(w,E)=>{f.length&&r(f),w?d(w):a(E)})})}clearCache(t){return delete this.caches[t],Promise.resolve(void 0)}preventCancellation(t){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(r,s){return t.then(r,s)}catch(r){return this.then(void 0,r)}finally(r){return t.finally(r)}}}}e.SearchService=_,_.BATCH_SIZE=512;class b{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const P=new class{getItemLabel(p){return(0,A.basename)(p.relativePath)}getItemDescription(p){return(0,A.dirname)(p.relativePath)}getItemPath(p){return p.relativePath}};function c(p){return{...p,folderQueries:p.folderQueries&&p.folderQueries.map(h),extraFileResources:p.extraFileResources&&p.extraFileResources.map(t=>C.URI.revive(t))}}function h(p){return{...p,folder:C.URI.revive(p.folder)}}}),define(me[284],ge([0,1,6,2,28,12,31,283,281,94,13,63,27,71,10,134]),function(J,e,g,R,k,S,T,D,y,A,i,C,u,m,l,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtHostSearch=void 0;let _=class extends m.ExtHostSearch{constructor(P,c,h,p){super(P,h,p);this._pfs=k,this._internalFileSearchHandle=-1,this._internalFileSearchProvider=null;const t=new A.OutputChannel("RipgrepSearchUD",this._logService);this.registerTextSearchProvider(l.Schemas.userData,new y.RipgrepSearchProvider(t)),c.remote.isRemote&&c.remote.authority&&this._registerEHSearchProviders()}_registerEHSearchProviders(){const P=new A.OutputChannel("RipgrepSearchEH",this._logService);this.registerTextSearchProvider(l.Schemas.file,new y.RipgrepSearchProvider(P)),this.registerInternalFileSearchProvider(l.Schemas.file,new D.SearchService)}registerInternalFileSearchProvider(P,c){const h=this._handlePool++;return this._internalFileSearchProvider=c,this._internalFileSearchHandle=h,this._proxy.$registerFileSearchProvider(h,this._transformScheme(P)),(0,g.toDisposable)(()=>{this._internalFileSearchProvider=null,this._proxy.$unregisterProvider(h)})}$provideFileSearchResults(P,c,h,p){const t=(0,m.reviveQuery)(h);return P===this._internalFileSearchHandle?this.doInternalFileSearch(P,c,t,p):super.$provideFileSearchResults(P,c,h,p)}doInternalFileSearch(P,c,h,p){const t=r=>{if((0,T.isSerializedFileMatch)(r)&&(r=[r]),Array.isArray(r)){this._proxy.$handleFileMatch(P,c,r.map(s=>R.URI.file(s.path)));return}r.message&&this._logService.debug("ExtHostSearch",r.message)};if(!this._internalFileSearchProvider)throw new Error("No internal file search handler");return this._internalFileSearchProvider.doFileSearch(h,t,p)}$clearCache(P){return this._internalFileSearchProvider&&this._internalFileSearchProvider.clearCache(P),super.$clearCache(P)}createTextSearchManager(P,c){return new v.NativeTextSearchManager(P,c)}};_=Ve([$e(0,i.IExtHostRpcService),$e(1,u.IExtHostInitDataService),$e(2,C.IURITransformerService),$e(3,S.ILogService)],_),e.NativeExtHostSearch=_}),define(me[136],ge([0,1,298,125,299,3,106,9,78,32,6,24,107,15,11]),function(J,e,g,R,k,S,T,D,y,A,i,C,u,m,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class v{constructor(f){this.socket=f,this._errorListener=w=>{if(w){if(w.code==="EPIPE")return;(0,m.onUnexpectedError)(w)}},this.socket.on("error",this._errorListener)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(f){const w=E=>f(C.VSBuffer.wrap(E));return this.socket.on("data",w),{dispose:()=>this.socket.off("data",w)}}onClose(f){const w=E=>{f({type:0,hadError:E,error:void 0})};return this.socket.on("close",w),{dispose:()=>this.socket.off("close",w)}}onEnd(f){return this.socket.on("end",f),{dispose:()=>this.socket.off("end",f)}}write(f){if(!this.socket.destroyed)try{this.socket.write(f.buffer,w=>{if(w){if(w.code==="EPIPE")return;(0,m.onUnexpectedError)(w)}})}catch(w){if(w.code==="EPIPE")return;(0,m.onUnexpectedError)(w)}}end(){this.socket.end()}drain(){return new Promise((f,w)=>{if(this.socket.bufferSize===0){f();return}const E=()=>{this.socket.off("close",E),this.socket.off("end",E),this.socket.off("error",E),this.socket.off("timeout",E),this.socket.off("drain",E),f()};this.socket.on("close",E),this.socket.on("end",E),this.socket.on("error",E),this.socket.on("timeout",E),this.socket.on("drain",E)})}}e.NodeSocket=v;var _;(function(d){d[d.MinHeaderByteSize=2]="MinHeaderByteSize"})(_||(_={}));var b;(function(d){d[d.PeekHeader=1]="PeekHeader",d[d.ReadHeader=2]="ReadHeader",d[d.ReadBody=3]="ReadBody",d[d.Fin=4]="Fin"})(b||(b={}));class P extends i.Disposable{constructor(f,w,E,o){super();this._onDidZlibFlush=this._register(new S.Emitter),this._recordedInflateBytes=[],this._pendingInflateData=[],this._pendingDeflateData=[],this._onData=this._register(new S.Emitter),this._onClose=this._register(new S.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,mask:0},this.socket=f,this._totalIncomingWireBytes=0,this._totalIncomingDataBytes=0,this._totalOutgoingWireBytes=0,this._totalOutgoingDataBytes=0,this.permessageDeflate=w,this._recordInflateBytes=o,w?(this._zlibInflate=k.createInflateRaw({windowBits:15}),this._zlibInflate.on("error",I=>{console.error(I),(0,m.onUnexpectedError)(I),this._onClose.fire({type:0,hadError:!0,error:I})}),this._zlibInflate.on("data",I=>{this._pendingInflateData.push(I)}),E&&(this._zlibInflate.write(E.buffer),this._zlibInflate.flush(()=>{this._pendingInflateData.length=0})),this._zlibDeflate=k.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",I=>{console.error(I),(0,m.onUnexpectedError)(I),this._onClose.fire({type:0,hadError:!0,error:I})}),this._zlibDeflate.on("data",I=>{this._pendingDeflateData.push(I)})):(this._zlibInflate=null,this._zlibDeflate=null),this._zlibDeflateFlushWaitingCount=0,this._incomingData=new u.ChunkStream,this._register(this.socket.onData(I=>this._acceptChunk(I))),this._register(this.socket.onClose(I=>this._onClose.fire(I)))}get totalIncomingWireBytes(){return this._totalIncomingWireBytes}get totalIncomingDataBytes(){return this._totalIncomingDataBytes}get totalOutgoingWireBytes(){return this._totalOutgoingWireBytes}get totalOutgoingDataBytes(){return this._totalOutgoingDataBytes}get recordedInflateBytes(){return this._recordInflateBytes?C.VSBuffer.wrap(Buffer.concat(this._recordedInflateBytes)):C.VSBuffer.alloc(0)}dispose(){this._zlibDeflateFlushWaitingCount>0?this._register(this._onDidZlibFlush.event(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(f){return this._onData.event(f)}onClose(f){return this._onClose.event(f)}onEnd(f){return this.socket.onEnd(f)}write(f){this._totalOutgoingDataBytes+=f.byteLength,this._zlibDeflate?(this._zlibDeflate.write(f.buffer),this._zlibDeflateFlushWaitingCount++,this._zlibDeflate.flush(2,()=>{this._zlibDeflateFlushWaitingCount--;let w=Buffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,w=w.slice(0,w.length-4),this._isEnded||this._write(C.VSBuffer.wrap(w),!0),this._zlibDeflateFlushWaitingCount===0&&this._onDidZlibFlush.fire()})):this._write(f,!1)}_write(f,w){let E=2;f.byteLength<126?E+=0:f.byteLength<2**16?E+=2:E+=8;const o=C.VSBuffer.alloc(E);if(w?o.writeUInt8(194,0):o.writeUInt8(130,0),f.byteLength<126)o.writeUInt8(f.byteLength,1);else if(f.byteLength<2**16){o.writeUInt8(126,1);let I=1;o.writeUInt8(f.byteLength>>>8&255,++I),o.writeUInt8(f.byteLength>>>0&255,++I)}else{o.writeUInt8(127,1);let I=1;o.writeUInt8(0,++I),o.writeUInt8(0,++I),o.writeUInt8(0,++I),o.writeUInt8(0,++I),o.writeUInt8(f.byteLength>>>24&255,++I),o.writeUInt8(f.byteLength>>>16&255,++I),o.writeUInt8(f.byteLength>>>8&255,++I),o.writeUInt8(f.byteLength>>>0&255,++I)}this._totalOutgoingWireBytes+=o.byteLength+f.byteLength,this.socket.write(C.VSBuffer.concat([o,f]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(f){if(f.byteLength!==0){for(this._totalIncomingWireBytes+=f.byteLength,this._incomingData.acceptChunk(f);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const w=this._incomingData.peek(this._state.readLen),o=(w.readUInt8(0)&128)>>>7,I=w.readUInt8(1),L=(I&128)>>>7,U=I&127;this._state.state=2,this._state.readLen=2+(L?4:0)+(U===126?2:0)+(U===127?8:0),this._state.fin=o,this._state.mask=0}else if(this._state.state===2){const w=this._incomingData.read(this._state.readLen),E=w.readUInt8(1),o=(E&128)>>>7;let I=E&127,L=1;I===126?I=w.readUInt8(++L)*2**8+w.readUInt8(++L):I===127&&(I=w.readUInt8(++L)*0+w.readUInt8(++L)*0+w.readUInt8(++L)*0+w.readUInt8(++L)*0+w.readUInt8(++L)*2**24+w.readUInt8(++L)*2**16+w.readUInt8(++L)*2**8+w.readUInt8(++L));let U=0;o&&(U=w.readUInt8(++L)*2**24+w.readUInt8(++L)*2**16+w.readUInt8(++L)*2**8+w.readUInt8(++L)),this._state.state=3,this._state.readLen=I,this._state.mask=U}else if(this._state.state===3){const w=this._incomingData.read(this._state.readLen);c(w,this._state.mask),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._zlibInflate?(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from(w.buffer)),this._zlibInflate.write(w.buffer),this._state.fin&&(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from([0,0,255,255])),this._zlibInflate.write(Buffer.from([0,0,255,255]))),this._zlibInflate.flush(()=>{const E=Buffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,this._totalIncomingDataBytes+=E.length,this._onData.fire(C.VSBuffer.wrap(E))})):(this._totalIncomingDataBytes+=w.byteLength,this._onData.fire(w))}}}async drain(){this._zlibDeflateFlushWaitingCount>0&&await S.Event.toPromise(this._onDidZlibFlush.event),await this.socket.drain()}}e.WebSocketNodeSocket=P;function c(d,f){if(f===0)return;let w=d.byteLength>>>2;for(let V=0;V<w;V++){const ee=d.readUInt32BE(V*4);d.writeUInt32BE(ee^f,V*4)}let E=w*4,o=d.byteLength-E;const I=f>>>24&255,L=f>>>16&255,U=f>>>8&255;o>=1&&d.writeUInt8(d.readUInt8(E)^I,E),o>=2&&d.writeUInt8(d.readUInt8(E+1)^L,E+1),o>=3&&d.writeUInt8(d.readUInt8(E+2)^U,E+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const h={[2]:107,[1]:103};function p(){const d=(0,A.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${d}-sock`;let f;return e.XDG_RUNTIME_DIR?f=(0,D.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${d}.sock`):f=(0,D.join)((0,y.tmpdir)(),`vscode-ipc-${d}.sock`),r(f),f}e.createRandomIPCHandle=p;function t(d,f,w){const E=(0,g.createHash)("md5").update(d).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${E}-${w}-${f}-sock`;let o;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?o=(0,D.join)(e.XDG_RUNTIME_DIR,`vscode-${E.substr(0,8)}-${w}-${f}.sock`):o=(0,D.join)(d,`${w}-${f}.sock`),r(o),o}e.createStaticIPCHandle=t;function r(d){const f=h[l.platform];typeof f=="number"&&d.length>=f&&console.warn(`WARNING: IPC handle "${d}" is longer than ${f} chars, try a shorter --user-data-dir`)}class s extends T.IPCServer{constructor(f){super(s.toClientConnectionEvent(f));this.server=f}static toClientConnectionEvent(f){const w=S.Event.fromNodeEventEmitter(f,"connection");return S.Event.map(w,E=>({protocol:new u.Protocol(new v(E)),onDidClientDisconnect:S.Event.once(S.Event.fromNodeEventEmitter(E,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=s;function n(d){return new Promise((f,w)=>{const E=(0,R.createServer)();E.on("error",w),E.listen(d,()=>{E.removeListener("error",w),f(new s(E))})})}e.serve=n;function a(d,f){return new Promise((w,E)=>{const o=(0,R.createConnection)(d,()=>{o.removeListener("error",E),w(u.Client.fromSocket(new v(o),f))});o.once("error",E)})}e.connect=a}),define(me[285],ge([0,1,136,277,49,44,2,198,12]),function(J,e,g,R,k,S,T,D,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CLIServer=e.CLIServerBase=void 0;class A{constructor(u,m,l){this._commands=u,this.logService=m,this._ipcHandlePath=l,this._server=R.createServer((v,_)=>this.onRequest(v,_)),this.setup().catch(v=>(m.error(v),""))}get ipcHandlePath(){return this._ipcHandlePath}async setup(){try{this._server.listen(this.ipcHandlePath),this._server.on("error",u=>this.logService.error(u))}catch(u){this.logService.error("Could not start open from terminal server.")}return this._ipcHandlePath}onRequest(u,m){const l=[];u.setEncoding("utf8"),u.on("data",v=>l.push(v)),u.on("end",()=>{const v=JSON.parse(l.join(""));switch(v.type){case"open":this.open(v,m);break;case"openExternal":this.openExternal(v,m);break;case"status":this.getStatus(v,m);break;case"extensionManagement":this.manageExtensions(v,m).catch(this.logService.error);break;default:m.writeHead(404),m.write(`Unknown message type: ${v.type}`,_=>{_&&this.logService.error(_)}),m.end();break}})}open(u,m){let{fileURIs:l,folderURIs:v,forceNewWindow:_,diffMode:b,addMode:P,forceReuseWindow:c,gotoLineMode:h,waitMarkerFilePath:p}=u;const t=[];if(Array.isArray(v))for(const r of v)try{t.push({folderUri:T.URI.parse(r)})}catch(s){}if(Array.isArray(l))for(const r of l)try{(0,D.hasWorkspaceFileExtension)(r)?t.push({workspaceUri:T.URI.parse(r)}):t.push({fileUri:T.URI.parse(r)})}catch(s){}if(t.length){const r=p?T.URI.file(p):void 0,n={forceNewWindow:_,diffMode:b,addMode:P,gotoLineMode:h,forceReuseWindow:c,preferNewWindow:!c&&!r&&!P,waitMarkerFileURI:r};this._commands.executeCommand("_remoteCLI.windowOpen",t,n)}m.writeHead(200),m.end()}async openExternal(u,m){for(const l of u.uris){const v=T.URI.parse(l),_=v.scheme==="file"?v:l;await this._commands.executeCommand("_remoteCLI.openExternal",_)}m.writeHead(200),m.end()}async manageExtensions(u,m){try{const l=b=>b?.map(P=>/\.vsix$/i.test(P)?T.URI.parse(P):P),v={list:u.list,install:l(u.install),uninstall:l(u.uninstall),force:u.force},_=await this._commands.executeCommand("_remoteCLI.manageExtensions",v);m.writeHead(200),m.write(_)}catch(l){m.writeHead(500),m.write(String(l),v=>{v&&this.logService.error(v)})}m.end()}async getStatus(u,m){try{const l=await this._commands.executeCommand("_remoteCLI.getSystemStatus");m.writeHead(200),m.write(l),m.end()}catch(l){m.writeHead(500),m.write(String(l),v=>{v&&this.logService.error(v)}),m.end()}}dispose(){this._server.close(),this._ipcHandlePath&&process.platform!=="win32"&&k.existsSync(this._ipcHandlePath)&&k.unlinkSync(this._ipcHandlePath)}}e.CLIServerBase=A;let i=class extends A{constructor(u,m){super(u,m,(0,g.createRandomIPCHandle)())}};i=Ve([$e(0,S.IExtHostCommands),$e(1,y.ILogService)],i),e.CLIServer=i}),define(me[286],ge([0,1,70,273,268,5,276,40,258,2,10,7,285,105]),function(J,e,g,R,k,S,T,D,y,A,i,C,u,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class l extends k.RequireInterceptor{_installInterceptor(){const b=this,P=J.__$__nodeRequire("module"),c=P._load;P._load=function(p,t,r){for(let s of b._alternatives){let n=s(p);if(n){p=n;break}}return b._factories.has(p)?b._factories.get(p).load(p,A.URI.file((0,m.realpathSync)(t.filename)),s=>c.apply(this,[s,t,r])):c.apply(this,arguments)}}}class v extends D.AbstractExtHostExtensionService{constructor(){super(...arguments);this.extensionRuntime=C.ExtensionRuntime.Node}async _beforeAlmostReadyToRunExtensions(){const b=this._instaService.invokeFunction(R.createApiFactoryAndRegisterActors);if(this._instaService.createInstance(y.ExtHostDownloadService),this._initData.remote.isRemote&&this._initData.remote.authority){const t=this._instaService.createInstance(u.CLIServer);process.env.VSCODE_IPC_HOOK_CLI=t.ipcHandlePath}await this._instaService.createInstance(l,b,this._registry).install(),g.mark("code/extHost/didInitAPI");const c=await this._extHostConfiguration.getConfigProvider();await(0,T.connectProxyResolver)(this._extHostWorkspace,c,this,this._logService,this._mainThreadTelemetryProxy,this._initData),g.mark("code/extHost/didInitProxyResolver");const h=process.send,p=this._extHostContext.getProxy(S.MainContext.MainThreadConsole);process.send=(...t)=>t.length===0||!t[0]||t[0].type!=="__$console"?h.apply(process,t):(p.$logExtensionHostMessage(t[0]),!1)}_getEntryPoint(b){return b.main}_loadCommonJSModule(b,P,c){if(P.scheme!==i.Schemas.file)throw new Error(`Cannot load URI: '${P}', must be of file-scheme`);let h=null;c.codeLoadingStart(),this._logService.info(`ExtensionService#loadCommonJSModule ${P.toString(!0)}`),this._logService.flush();try{b&&g.mark(`code/extHost/willLoadExtensionCode/${b.value}`),h=J.__$__nodeRequire(P.fsPath)}catch(p){return Promise.reject(p)}finally{b&&g.mark(`code/extHost/didLoadExtensionCode/${b.value}`),c.codeLoadingStop()}return Promise.resolve(h)}async $setRemoteEnvironment(b){if(!!this._initData.remote.isRemote)for(const P in b){const c=b[P];c===null?delete process.env[P]:process.env[P]=c}}}e.ExtHostExtensionService=v}),define(me[287],ge([0,1,80,259,261,270,269,284,286,226,262,53,40,65,71,69,33,52,12,66,260]),function(J,e,g,R,k,S,T,D,y,A,i,C,u,m,l,v,_,b,P,c,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,g.registerSingleton)(u.IExtHostExtensionService,y.ExtHostExtensionService),(0,g.registerSingleton)(P.ILogService,A.ExtHostLogService),(0,g.registerSingleton)(c.IExtensionStoragePaths,h.ExtensionStoragePaths),(0,g.registerSingleton)(C.IExtHostDebugService,T.ExtHostDebugService),(0,g.registerSingleton)(m.IExtHostOutputService,R.ExtHostOutputService2),(0,g.registerSingleton)(l.IExtHostSearch,D.NativeExtHostSearch),(0,g.registerSingleton)(v.IExtHostTask,S.ExtHostTask),(0,g.registerSingleton)(_.IExtHostTerminalService,k.ExtHostTerminalService),(0,g.registerSingleton)(b.IExtHostTunnelService,i.ExtHostTunnelService)}),define(me[288],ge([0,1,125,300,70,15,107,136,191,224,271,24,103,28,105,16,114,274,287]),function(J,e,g,R,k,S,T,D,y,A,i,C,u,m,l,v,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.startExtensionHostProcess=void 0,function(){for(let a=0;a<process.execArgv.length;a++)process.execArgv[a]==="--inspect-port=0"&&(process.execArgv.splice(a,1),a--)}();const b=R(process.argv.slice(2),{string:["uriTransformerPath","useHostProxy"],boolean:["skipWorkspaceStorageLock"]});(function(){const n=J.__$__nodeRequire("module"),a=n._load;n._load=function(d){if(d==="natives")throw new Error('Either the extension or a NPM dependency is using the "natives" node module which is unsupported as it can cause a crash of the extension host. Click [here](https://go.microsoft.com/fwlink/?linkid=871887) to find out more');return a.apply(this,arguments)}})();const P=process.exit.bind(process);function c(n){process.exit=function(a){if(n)P(a);else{const d=new Error("An extension called process.exit() and this was prevented.");console.warn(d.stack)}},process.crash=function(){const a=new Error("An extension called process.crash() and this was prevented.");console.warn(a.stack)}}let h=function(n){P()};function p(){if(process.env.VSCODE_EXTHOST_WILL_SEND_SOCKET)return new Promise((n,a)=>{let d=null,f=setTimeout(()=>{h("VSCODE_EXTHOST_IPC_SOCKET timeout")},6e4);const w=108e5,E=3e5,o=new v.RunOnceScheduler(()=>h("renderer disconnected for too long (1)"),w),I=new v.RunOnceScheduler(()=>h("renderer disconnected for too long (2)"),E);process.on("message",(U,V)=>{if(U&&U.type==="VSCODE_EXTHOST_IPC_SOCKET"){const ee=C.VSBuffer.wrap(Buffer.from(U.initialDataChunk,"base64"));let K;if(U.skipWebSocketFrames)K=new D.NodeSocket(V);else{const N=C.VSBuffer.wrap(Buffer.from(U.inflateBytes,"base64"));K=new D.WebSocketNodeSocket(new D.NodeSocket(V),U.permessageDeflate,N,!1)}d?(o.cancel(),I.cancel(),d.beginAcceptReconnection(K,ee),d.endAcceptReconnection()):(clearTimeout(f),d=new T.PersistentProtocol(K,ee),d.onDidDispose(()=>h("renderer disconnected")),n(d),d.onSocketClose(()=>{o.schedule()}))}if(U&&U.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(I.isScheduled())return;o.isScheduled()&&I.schedule()}});const L={type:"VSCODE_EXTHOST_IPC_READY"};process.send&&process.send(L)});{const n=process.env.VSCODE_IPC_HOOK_EXTHOST;return new Promise((a,d)=>{const f=g.createConnection(n,()=>{f.removeListener("error",d),a(new T.PersistentProtocol(new D.NodeSocket(f)))});f.once("error",d),f.on("close",()=>{h("renderer closed the socket")})})}}async function t(){const n=await p();return new class{constructor(){this._onMessage=new T.BufferedEmitter,this.onMessage=this._onMessage.event,this._terminating=!1,n.onMessage(a=>{(0,A.isMessageOfType)(a,2)?(this._terminating=!0,h("received terminate message from renderer")):this._onMessage.fire(a)})}send(a){this._terminating||n.send(a)}drain(){return n.drain()}}}function r(n){return new Promise(a=>{const d=n.onMessage(f=>{d.dispose();const w=JSON.parse(f.toString()),E=w.commit,o=y.default.commit;E&&o&&E!==o&&P(55);const I=[];process.on("unhandledRejection",(V,ee)=>{I.push(ee),setTimeout(()=>{const K=I.indexOf(ee);K>=0&&ee.catch(N=>{I.splice(K,1),(0,S.isPromiseCanceledError)(N)||(console.warn(`rejected promise not handled within 1 second: ${N}`),N&&N.stack&&console.warn(`stack trace: ${N.stack}`),(0,S.onUnexpectedError)(V))})},1e3)}),process.on("rejectionHandled",V=>{const ee=I.indexOf(V);ee>=0&&I.splice(ee,1)}),process.on("uncaughtException",function(V){(0,S.onUnexpectedError)(V)});let L=0;setInterval(function(){try{process.kill(w.parentPid,0),L=0}catch(V){V&&V.code==="EPERM"?(L++,L>=3&&h(`parent process ${w.parentPid} does not exist anymore (3 x EPERM): ${V.message} (code: ${V.code}) (errno: ${V.errno})`)):h(`parent process ${w.parentPid} does not exist anymore: ${V.message} (code: ${V.code}) (errno: ${V.errno})`)}},1e3);let U;try{U=J.__$__nodeRequire("native-watchdog"),U.start(w.parentPid)}catch(V){(0,S.onUnexpectedError)(V)}n.send((0,A.createMessageOfType)(0)),a({protocol:n,initData:w})});n.send((0,A.createMessageOfType)(1))})}async function s(){k.mark("code/extHost/willConnectToRenderer");const n=await t();k.mark("code/extHost/didConnectToRenderer");const a=await r(n);k.mark("code/extHost/didWaitForInitData");const{initData:d}=a;c(!!d.environment.extensionTestsLocationURI),d.environment.useHostProxy=b.useHostProxy!==void 0?b.useHostProxy!=="false":void 0,d.environment.skipWorkspaceStorageLock=(0,_.boolean)(b.skipWorkspaceStorageLock,!1);const f=new class{exit(I){P(I)}exists(I){return m.Promises.exists(I)}realpath(I){return(0,l.realpath)(I)}};let w=null;if(d.remote.authority&&b.uriTransformerPath)try{const I=J.__$__nodeRequire(b.uriTransformerPath)(d.remote.authority);w=new u.URITransformer(I)}catch(o){console.error(o)}const E=new i.ExtensionHostMain(a.protocol,d,f,w);h=o=>E.terminate(o)}e.startExtensionHostProcess=s}),define(me[301],ge([0,1,288]),function(J,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,g.startExtensionHostProcess)().catch(R=>console.log(R))})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/0f22f2d343e33b03e8033d1083513072f58ece21/core/vs/workbench/services/extensions/node/extensionHostProcess.js.map
